#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 2830
#define SYMBOL_COUNT 144
#define ALIAS_COUNT 5
#define TOKEN_COUNT 90
#define EXTERNAL_TOKEN_COUNT 12
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  sym_heredoc_start = 1,
  sym__simple_heredoc_body = 2,
  sym__heredoc_body_beginning = 3,
  sym__heredoc_body_middle = 4,
  sym__heredoc_body_end = 5,
  sym_file_descriptor = 6,
  sym__empty_value = 7,
  sym__concat = 8,
  sym_variable_name = 9,
  anon_sym_for = 10,
  anon_sym_in = 11,
  anon_sym_while = 12,
  anon_sym_do = 13,
  anon_sym_done = 14,
  anon_sym_if = 15,
  anon_sym_then = 16,
  anon_sym_fi = 17,
  anon_sym_elif = 18,
  anon_sym_else = 19,
  anon_sym_case = 20,
  anon_sym_esac = 21,
  anon_sym_PIPE = 22,
  anon_sym_RPAREN = 23,
  anon_sym_SEMI_SEMI = 24,
  anon_sym_function = 25,
  anon_sym_LPAREN = 26,
  anon_sym_LBRACE = 27,
  anon_sym_RBRACE = 28,
  anon_sym_PIPE_AMP = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE_PIPE = 31,
  anon_sym_BANG = 32,
  anon_sym_LBRACK = 33,
  anon_sym_RBRACK = 34,
  anon_sym_LBRACK_LBRACK = 35,
  anon_sym_RBRACK_RBRACK = 36,
  anon_sym_declare = 37,
  anon_sym_typeset = 38,
  anon_sym_export = 39,
  anon_sym_readonly = 40,
  anon_sym_local = 41,
  anon_sym_unset = 42,
  anon_sym_unsetenv = 43,
  anon_sym_EQ_TILDE = 44,
  anon_sym_EQ_EQ = 45,
  anon_sym_EQ = 46,
  anon_sym_PLUS_EQ = 47,
  anon_sym_LT = 48,
  anon_sym_GT = 49,
  anon_sym_GT_GT = 50,
  anon_sym_AMP_GT = 51,
  anon_sym_AMP_GT_GT = 52,
  anon_sym_LT_AMP = 53,
  anon_sym_GT_AMP = 54,
  anon_sym_LT_LT = 55,
  anon_sym_LT_LT_DASH = 56,
  anon_sym_LT_LT_LT = 57,
  anon_sym_BANG_EQ = 58,
  sym__special_characters = 59,
  anon_sym_DQUOTE = 60,
  anon_sym_DOLLAR = 61,
  sym__string_content = 62,
  sym_raw_string = 63,
  anon_sym_POUND = 64,
  anon_sym_DOLLAR_LBRACE = 65,
  aux_sym_SLASH = 66,
  anon_sym_COLON = 67,
  anon_sym_COLON_QMARK = 68,
  anon_sym_COLON_DASH = 69,
  anon_sym_PERCENT = 70,
  anon_sym_DASH = 71,
  anon_sym_DOLLAR_LPAREN = 72,
  anon_sym_BQUOTE = 73,
  anon_sym_LT_LPAREN = 74,
  anon_sym_GT_LPAREN = 75,
  sym_comment = 76,
  aux_sym_SLASH_BSLASHw_PLUS_SLASH = 77,
  anon_sym_STAR = 78,
  anon_sym_AT = 79,
  anon_sym_QMARK = 80,
  anon_sym_0 = 81,
  anon_sym__ = 82,
  sym_word = 83,
  sym_test_operator = 84,
  sym_regex = 85,
  sym_regex_without_right_brace = 86,
  anon_sym_SEMI = 87,
  anon_sym_LF = 88,
  anon_sym_AMP = 89,
  sym_program = 90,
  sym__terminated_statement = 91,
  sym_for_statement = 92,
  sym_while_statement = 93,
  sym_do_group = 94,
  sym_if_statement = 95,
  sym_elif_clause = 96,
  sym_else_clause = 97,
  sym_case_statement = 98,
  sym_case_item = 99,
  sym_last_case_item = 100,
  sym_function_definition = 101,
  sym_compound_statement = 102,
  sym_subshell = 103,
  sym_pipeline = 104,
  sym_list = 105,
  sym_negated_command = 106,
  sym_test_command = 107,
  sym_declaration_command = 108,
  sym_unset_command = 109,
  sym_command = 110,
  sym_command_name = 111,
  sym_variable_assignment = 112,
  sym_subscript = 113,
  sym_file_redirect = 114,
  sym_heredoc_redirect = 115,
  sym_heredoc_body = 116,
  sym_herestring_redirect = 117,
  sym__expression = 118,
  sym_binary_expression = 119,
  sym_unary_expression = 120,
  sym_parenthesized_expression = 121,
  sym_concatenation = 122,
  sym_string = 123,
  sym_array = 124,
  sym_simple_expansion = 125,
  sym_string_expansion = 126,
  sym_expansion = 127,
  sym_command_substitution = 128,
  sym_process_substitution = 129,
  aux_sym_program_repeat1 = 130,
  aux_sym_for_statement_repeat1 = 131,
  aux_sym_while_statement_repeat1 = 132,
  aux_sym_if_statement_repeat1 = 133,
  aux_sym_case_statement_repeat1 = 134,
  aux_sym_case_item_repeat1 = 135,
  aux_sym_declaration_command_repeat1 = 136,
  aux_sym_unset_command_repeat1 = 137,
  aux_sym_command_repeat1 = 138,
  aux_sym_command_repeat2 = 139,
  aux_sym_heredoc_body_repeat1 = 140,
  aux_sym_concatenation_repeat1 = 141,
  aux_sym_string_repeat1 = 142,
  aux_sym_expansion_repeat1 = 143,
  alias_sym_case_item = 144,
  alias_sym_regex = 145,
  alias_sym_special_variable_name = 146,
  alias_sym_variable_name = 147,
  alias_sym_word = 148,
};

static const char *ts_symbol_names[] = {
  [sym_heredoc_start] = "heredoc_start",
  [sym__simple_heredoc_body] = "_simple_heredoc_body",
  [sym__heredoc_body_beginning] = "_heredoc_body_beginning",
  [sym__heredoc_body_middle] = "_heredoc_body_middle",
  [sym__heredoc_body_end] = "_heredoc_body_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_BANG] = "!",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_declare] = "declare",
  [anon_sym_typeset] = "typeset",
  [anon_sym_export] = "export",
  [anon_sym_readonly] = "readonly",
  [anon_sym_local] = "local",
  [anon_sym_unset] = "unset",
  [anon_sym_unsetenv] = "unsetenv",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_LT_LT_LT] = "<<<",
  [anon_sym_BANG_EQ] = "!=",
  [sym__special_characters] = "_special_characters",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DOLLAR] = "$",
  [sym__string_content] = "_string_content",
  [sym_raw_string] = "raw_string",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [aux_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DASH] = "-",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_comment] = "comment",
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = "/\\w+/",
  [anon_sym_STAR] = "*",
  [anon_sym_AT] = "@",
  [anon_sym_QMARK] = "?",
  [anon_sym_0] = "0",
  [anon_sym__] = "_",
  [sym_word] = "word",
  [sym_test_operator] = "test_operator",
  [sym_regex] = "regex",
  [sym_regex_without_right_brace] = "regex_without_right_brace",
  [anon_sym_SEMI] = ";",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_last_case_item] = "last_case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_negated_command] = "negated_command",
  [sym_test_command] = "test_command",
  [sym_declaration_command] = "declaration_command",
  [sym_unset_command] = "unset_command",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_variable_assignment] = "variable_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc_body] = "heredoc_body",
  [sym_herestring_redirect] = "herestring_redirect",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_string_expansion] = "string_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_while_statement_repeat1] = "while_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_declaration_command_repeat1] = "declaration_command_repeat1",
  [aux_sym_unset_command_repeat1] = "unset_command_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_expansion_repeat1] = "expansion_repeat1",
  [alias_sym_case_item] = "case_item",
  [alias_sym_regex] = "regex",
  [alias_sym_special_variable_name] = "special_variable_name",
  [alias_sym_variable_name] = "variable_name",
  [alias_sym_word] = "word",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym_heredoc_start] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_heredoc_body] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsetenv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym__special_characters] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [sym_test_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_without_right_brace] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_last_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_command] = {
    .visible = true,
    .named = true,
  },
  [sym_test_command] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_command] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_herestring_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_string_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_while_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_regex] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_word] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[23][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_word,
  },
  [2] = {
    [0] = alias_sym_variable_name,
  },
  [3] = {
    [1] = alias_sym_word,
  },
  [4] = {
    [1] = alias_sym_special_variable_name,
  },
  [5] = {
    [1] = alias_sym_variable_name,
  },
  [6] = {
    [2] = alias_sym_word,
  },
  [7] = {
    [2] = alias_sym_special_variable_name,
  },
  [8] = {
    [2] = alias_sym_variable_name,
  },
  [9] = {
    [3] = alias_sym_word,
  },
  [10] = {
    [1] = alias_sym_special_variable_name,
    [3] = alias_sym_regex,
  },
  [11] = {
    [1] = alias_sym_variable_name,
    [3] = alias_sym_regex,
  },
  [12] = {
    [3] = alias_sym_regex,
  },
  [13] = {
    [1] = alias_sym_word,
    [4] = alias_sym_case_item,
  },
  [14] = {
    [4] = alias_sym_case_item,
  },
  [15] = {
    [4] = alias_sym_word,
  },
  [16] = {
    [2] = alias_sym_special_variable_name,
    [4] = alias_sym_regex,
  },
  [17] = {
    [2] = alias_sym_variable_name,
    [4] = alias_sym_regex,
  },
  [18] = {
    [4] = alias_sym_regex,
  },
  [19] = {
    [1] = alias_sym_word,
    [5] = alias_sym_case_item,
  },
  [20] = {
    [5] = alias_sym_case_item,
  },
  [21] = {
    [1] = alias_sym_word,
    [6] = alias_sym_case_item,
  },
  [22] = {
    [6] = alias_sym_case_item,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(6);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(10);
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(17);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == '*')
        ADVANCE(19);
      if (lookahead == '+')
        ADVANCE(20);
      if (lookahead == '-')
        ADVANCE(22);
      if (lookahead == '/')
        ADVANCE(23);
      if (lookahead == '0')
        ADVANCE(24);
      if (lookahead == ':')
        ADVANCE(25);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(36);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '?')
        ADVANCE(43);
      if (lookahead == '@')
        ADVANCE(44);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        ADVANCE(47);
      if (lookahead == ']')
        ADVANCE(48);
      if (lookahead == '_')
        ADVANCE(49);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(51);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(55);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      ADVANCE(4);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 3:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == '{')
        ADVANCE(9);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '>')
        ADVANCE(13);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 15:
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead != 0)
        ADVANCE(15);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(aux_sym_SLASH);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(26);
      if (lookahead == '?')
        ADVANCE(27);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '?' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(29);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(31);
      if (lookahead == '(')
        ADVANCE(32);
      if (lookahead == '<')
        ADVANCE(33);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(35);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(37);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead == '~')
        ADVANCE(38);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(4);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '(')
        ADVANCE(41);
      if (lookahead == '>')
        ADVANCE(42);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(46);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 47:
      if (lookahead == '\n')
        SKIP(0);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(53);
      if (lookahead == '|')
        ADVANCE(54);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 56:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(58);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(56);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(57);
      END_STATE();
    case 58:
      if (lookahead == '>')
        ADVANCE(13);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(31);
      if (lookahead == '(')
        ADVANCE(32);
      END_STATE();
    case 60:
      if (lookahead == '\n')
        SKIP(56);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym__special_characters);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '}')
        ADVANCE(61);
      END_STATE();
    case 62:
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '+')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(65);
      if (lookahead == '[')
        ADVANCE(66);
      if (lookahead == '\\')
        SKIP(67);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(62);
      END_STATE();
    case 63:
      if (lookahead == '=')
        ADVANCE(64);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 67:
      if (lookahead == '\n')
        SKIP(62);
      END_STATE();
    case 68:
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '&')
        ADVANCE(69);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(70);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(68);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(71);
      END_STATE();
    case 69:
      if (lookahead == '&')
        ADVANCE(12);
      END_STATE();
    case 70:
      if (lookahead == '\n')
        SKIP(68);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(71);
      END_STATE();
    case 72:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(58);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(73);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(72);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 73:
      if (lookahead == '\n')
        SKIP(72);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 74:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(58);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        ADVANCE(75);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(74);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 75:
      if (lookahead == '\n')
        SKIP(74);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 76:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(17);
      if (lookahead == '-')
        ADVANCE(77);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(81);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(76);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(3);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(78);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '`' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(78);
      END_STATE();
    case 79:
      if (lookahead == '(')
        ADVANCE(32);
      END_STATE();
    case 80:
      if (lookahead == '(')
        ADVANCE(41);
      END_STATE();
    case 81:
      if (lookahead == '\n')
        SKIP(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 82:
      if (lookahead == '\n')
        ADVANCE(83);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(85);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(4);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(12);
      END_STATE();
    case 85:
      if (lookahead == '\n')
        SKIP(82);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 87:
      if (lookahead == '\n')
        ADVANCE(83);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(88);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(87);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(4);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '=')
        ADVANCE(37);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead == '~')
        ADVANCE(38);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(4);
      END_STATE();
    case 89:
      if (lookahead == '\n')
        SKIP(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 90:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(91);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '\\')
        ADVANCE(95);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(96);
      if (lookahead != 0)
        ADVANCE(92);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(92);
      if (lookahead == '\\')
        ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(91);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\\')
        ADVANCE(93);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(92);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(92);
      if (lookahead == '\\')
        ADVANCE(93);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(92);
      if (lookahead != 0)
        ADVANCE(92);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(92);
      if (lookahead == '\\')
        ADVANCE(94);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(91);
      if (lookahead != 0)
        ADVANCE(91);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(96);
      if (lookahead == '\\')
        ADVANCE(93);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(92);
      if (lookahead != 0)
        ADVANCE(92);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(91);
      if (lookahead == '\\')
        ADVANCE(95);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(96);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(92);
      END_STATE();
    case 97:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(6);
      if (lookahead == '$')
        ADVANCE(98);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == '?')
        ADVANCE(102);
      if (lookahead == '@')
        ADVANCE(103);
      if (lookahead == '\\')
        SKIP(104);
      if (lookahead == '_')
        ADVANCE(105);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(97);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(71);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(71);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 104:
      if (lookahead == '\n')
        SKIP(97);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(71);
      END_STATE();
    case 106:
      if (lookahead == '\n')
        ADVANCE(83);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(88);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(107);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(106);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(4);
      END_STATE();
    case 107:
      if (lookahead == '\n')
        SKIP(106);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 108:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '\\')
        SKIP(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(108);
      END_STATE();
    case 109:
      if (lookahead == '\n')
        SKIP(108);
      END_STATE();
    case 110:
      if (lookahead == '\n')
        ADVANCE(83);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(111);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(110);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(4);
      END_STATE();
    case 111:
      if (lookahead == '\n')
        SKIP(110);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 112:
      if (lookahead == '\n')
        ADVANCE(83);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(88);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(113);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(112);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(4);
      END_STATE();
    case 113:
      if (lookahead == '\n')
        SKIP(112);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 114:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(115);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(114);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 115:
      if (lookahead == '\n')
        SKIP(114);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 116:
      if (lookahead == '\n')
        ADVANCE(83);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(117);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(118);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(116);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 118:
      if (lookahead == '\n')
        SKIP(116);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 119:
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '(')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(120);
      if (lookahead == '{')
        ADVANCE(51);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(119);
      END_STATE();
    case 120:
      if (lookahead == '\n')
        SKIP(119);
      END_STATE();
    case 121:
      if (lookahead == '\n')
        ADVANCE(83);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(122);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(4);
      END_STATE();
    case 122:
      if (lookahead == '\n')
        SKIP(121);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 123:
      if (lookahead == '\n')
        ADVANCE(83);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(17);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(88);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(124);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(123);
      if (lookahead != 0)
        ADVANCE(4);
      END_STATE();
    case 124:
      if (lookahead == '\n')
        SKIP(123);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 125:
      if (lookahead == '\n')
        ADVANCE(83);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(126);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(125);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(4);
      END_STATE();
    case 126:
      if (lookahead == '\n')
        SKIP(125);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 127:
      if (lookahead == '\n')
        ADVANCE(83);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '\\')
        ADVANCE(128);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(127);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 128:
      if (lookahead == '\n')
        SKIP(127);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 129:
      if (lookahead == '!')
        ADVANCE(130);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '&')
        ADVANCE(69);
      if (lookahead == '-')
        ADVANCE(132);
      if (lookahead == '<')
        ADVANCE(134);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(139);
      if (lookahead == ']')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(129);
      END_STATE();
    case 130:
      if (lookahead == '=')
        ADVANCE(131);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 132:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(133);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(136);
      if (lookahead == '~')
        ADVANCE(137);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 139:
      if (lookahead == '\n')
        SKIP(129);
      END_STATE();
    case 140:
      if (lookahead == '|')
        ADVANCE(54);
      END_STATE();
    case 141:
      if (lookahead == '!')
        ADVANCE(130);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '&')
        ADVANCE(69);
      if (lookahead == '-')
        ADVANCE(132);
      if (lookahead == '<')
        ADVANCE(134);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(142);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(141);
      END_STATE();
    case 142:
      if (lookahead == '\n')
        SKIP(141);
      END_STATE();
    case 143:
      if (lookahead == ']')
        ADVANCE(144);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 145:
      if (lookahead == '#')
        ADVANCE(6);
      if (lookahead == '$')
        ADVANCE(98);
      if (lookahead == '*')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '0')
        ADVANCE(146);
      if (lookahead == '?')
        ADVANCE(102);
      if (lookahead == '@')
        ADVANCE(103);
      if (lookahead == '\\')
        ADVANCE(148);
      if (lookahead == '_')
        ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(149);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(147);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(92);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(147);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(147);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(149);
      if (lookahead == '\\')
        ADVANCE(93);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(92);
      if (lookahead != 0)
        ADVANCE(92);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '0')
        ADVANCE(146);
      if (lookahead == '?')
        ADVANCE(102);
      if (lookahead == '@')
        ADVANCE(103);
      if (lookahead == '\\')
        ADVANCE(148);
      if (lookahead == '_')
        ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(149);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(147);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(92);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(147);
      END_STATE();
    case 151:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(6);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '-')
        ADVANCE(22);
      if (lookahead == '/')
        ADVANCE(23);
      if (lookahead == ':')
        ADVANCE(25);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '=')
        ADVANCE(152);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(153);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '}')
        ADVANCE(55);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(151);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\\')
        ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 153:
      if (lookahead == '\n')
        SKIP(151);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 154:
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(98);
      if (lookahead == '*')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == '?')
        ADVANCE(102);
      if (lookahead == '@')
        ADVANCE(103);
      if (lookahead == '\\')
        SKIP(155);
      if (lookahead == '_')
        ADVANCE(105);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(154);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(71);
      END_STATE();
    case 155:
      if (lookahead == '\n')
        SKIP(154);
      END_STATE();
    case 156:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(69);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(157);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(156);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(4);
      END_STATE();
    case 157:
      if (lookahead == '\n')
        SKIP(156);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 158:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(88);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(160);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(158);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>'))
        ADVANCE(4);
      END_STATE();
    case 159:
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '>')
        ADVANCE(13);
      END_STATE();
    case 160:
      if (lookahead == '\n')
        SKIP(158);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 161:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(17);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(88);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(162);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(161);
      if (lookahead != 0 &&
          (lookahead < ';' || lookahead > '>'))
        ADVANCE(4);
      END_STATE();
    case 162:
      if (lookahead == '\n')
        SKIP(161);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 163:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(164);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(163);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(4);
      END_STATE();
    case 164:
      if (lookahead == '\n')
        SKIP(163);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 165:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(69);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(166);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(165);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(86);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(4);
      END_STATE();
    case 166:
      if (lookahead == '\n')
        SKIP(165);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 167:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(88);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(168);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(167);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>'))
        ADVANCE(4);
      END_STATE();
    case 168:
      if (lookahead == '\n')
        SKIP(167);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 169:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(88);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(170);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(169);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>'))
        ADVANCE(4);
      END_STATE();
    case 170:
      if (lookahead == '\n')
        SKIP(169);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 171:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(172);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(171);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(4);
      END_STATE();
    case 172:
      if (lookahead == '\n')
        SKIP(171);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 173:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(58);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(174);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        ADVANCE(175);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      if ((lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 174:
      if (lookahead == ';')
        ADVANCE(29);
      END_STATE();
    case 175:
      if (lookahead == '\n')
        SKIP(173);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 176:
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(177);
      if (lookahead == '\\')
        SKIP(178);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(176);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{')
        ADVANCE(9);
      END_STATE();
    case 178:
      if (lookahead == '\n')
        SKIP(176);
      END_STATE();
    case 179:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(180);
      if (lookahead == '$')
        ADVANCE(182);
      if (lookahead == '\'')
        ADVANCE(187);
      if (lookahead == '<')
        ADVANCE(190);
      if (lookahead == '>')
        ADVANCE(192);
      if (lookahead == '[')
        ADVANCE(194);
      if (lookahead == '\\')
        ADVANCE(195);
      if (lookahead == ']')
        ADVANCE(194);
      if (lookahead == '`')
        ADVANCE(198);
      if (lookahead == '{')
        ADVANCE(194);
      if (lookahead == '}')
        ADVANCE(194);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(179);
      if (('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '|')
        ADVANCE(185);
      if (lookahead != 0)
        ADVANCE(197);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(181);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(180);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(181);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(180);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(180);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(183);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead == '{')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(185);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(185);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(185);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(185);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(185);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\'')
        ADVANCE(188);
      if (lookahead == '\\')
        ADVANCE(189);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(15);
      if (lookahead != 0)
        ADVANCE(187);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_raw_string);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(185);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\n')
        ADVANCE(15);
      if (lookahead == '\'')
        ADVANCE(188);
      if (lookahead == '\\')
        ADVANCE(189);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(187);
      if (lookahead != 0)
        ADVANCE(187);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '(')
        ADVANCE(191);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(185);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(185);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '(')
        ADVANCE(193);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(185);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(185);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '[')
        ADVANCE(194);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead == ']')
        ADVANCE(194);
      if (lookahead == '{')
        ADVANCE(194);
      if (lookahead == '}')
        ADVANCE(194);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(185);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(197);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(195);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(185);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(197);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(195);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(197);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(185);
      END_STATE();
    case 199:
      if (lookahead == '\n')
        ADVANCE(83);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(200);
      if (lookahead == '>')
        ADVANCE(201);
      if (lookahead == '\\')
        SKIP(202);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(33);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '>')
        ADVANCE(42);
      END_STATE();
    case 202:
      if (lookahead == '\n')
        SKIP(199);
      END_STATE();
    case 203:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(204);
      if (lookahead == ']')
        ADVANCE(48);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 204:
      if (lookahead == '\n')
        SKIP(203);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 205:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(58);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        ADVANCE(206);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '}')
        ADVANCE(55);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(205);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 206:
      if (lookahead == '\n')
        SKIP(205);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 207:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(58);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(17);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        ADVANCE(208);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(207);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 208:
      if (lookahead == '\n')
        SKIP(207);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 209:
      if (lookahead == '\n')
        ADVANCE(83);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(200);
      if (lookahead == '>')
        ADVANCE(201);
      if (lookahead == '\\')
        SKIP(210);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(209);
      END_STATE();
    case 210:
      if (lookahead == '\n')
        SKIP(209);
      END_STATE();
    case 211:
      if (lookahead == '!')
        ADVANCE(130);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '&')
        ADVANCE(69);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(132);
      if (lookahead == '<')
        ADVANCE(134);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(212);
      if (lookahead == '|')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(211);
      END_STATE();
    case 212:
      if (lookahead == '\n')
        SKIP(211);
      END_STATE();
    case 213:
      if (lookahead == '!')
        ADVANCE(214);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(180);
      if (lookahead == '$')
        ADVANCE(182);
      if (lookahead == '\'')
        ADVANCE(187);
      if (lookahead == '(')
        ADVANCE(215);
      if (lookahead == '-')
        ADVANCE(216);
      if (lookahead == '<')
        ADVANCE(190);
      if (lookahead == '>')
        ADVANCE(192);
      if (lookahead == '[')
        ADVANCE(194);
      if (lookahead == '\\')
        ADVANCE(195);
      if (lookahead == ']')
        ADVANCE(194);
      if (lookahead == '`')
        ADVANCE(198);
      if (lookahead == '{')
        ADVANCE(194);
      if (lookahead == '}')
        ADVANCE(194);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(213);
      if (('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '|')
        ADVANCE(185);
      if (lookahead != 0)
        ADVANCE(197);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(195);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(197);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(185);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(195);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(185);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(197);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(217);
      END_STATE();
    case 218:
      if (lookahead == '!')
        ADVANCE(130);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '&')
        ADVANCE(69);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(132);
      if (lookahead == '<')
        ADVANCE(134);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(219);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(220);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(218);
      END_STATE();
    case 219:
      if (lookahead == '\n')
        SKIP(218);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(54);
      END_STATE();
    case 221:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(222);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '}')
        ADVANCE(55);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 222:
      if (lookahead == '\n')
        SKIP(221);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 223:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(6);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == '-')
        ADVANCE(22);
      if (lookahead == ':')
        ADVANCE(25);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '=')
        ADVANCE(152);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(224);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '}')
        ADVANCE(55);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 224:
      if (lookahead == '\n')
        SKIP(223);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 225:
      if (lookahead == '#')
        ADVANCE(226);
      if (lookahead == '\\')
        ADVANCE(228);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(225);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '}')
        ADVANCE(229);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(227);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '}')
        ADVANCE(226);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(227);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '}')
        ADVANCE(226);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(226);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(228);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '}')
        ADVANCE(229);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(229);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(228);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '}')
        ADVANCE(229);
      END_STATE();
    case 230:
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(200);
      if (lookahead == '>')
        ADVANCE(201);
      if (lookahead == '\\')
        SKIP(231);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(230);
      END_STATE();
    case 231:
      if (lookahead == '\n')
        SKIP(230);
      END_STATE();
    case 232:
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '<')
        ADVANCE(200);
      if (lookahead == '>')
        ADVANCE(201);
      if (lookahead == '\\')
        SKIP(233);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(232);
      END_STATE();
    case 233:
      if (lookahead == '\n')
        SKIP(232);
      END_STATE();
    case 234:
      if (lookahead == '\n')
        ADVANCE(83);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(200);
      if (lookahead == '>')
        ADVANCE(201);
      if (lookahead == '\\')
        ADVANCE(235);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(234);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 235:
      if (lookahead == '\n')
        SKIP(234);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 236:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '$')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(61);
      if (lookahead == '\\')
        ADVANCE(237);
      if (lookahead == ']')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '{')
        ADVANCE(61);
      if (lookahead == '}')
        ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(236);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 237:
      if (lookahead == '\n')
        SKIP(236);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 238:
      if (lookahead == '!')
        ADVANCE(130);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '&')
        ADVANCE(69);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(132);
      if (lookahead == '<')
        ADVANCE(134);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(239);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(238);
      END_STATE();
    case 239:
      if (lookahead == '\n')
        SKIP(238);
      END_STATE();
    case 240:
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(200);
      if (lookahead == '>')
        ADVANCE(201);
      if (lookahead == '\\')
        SKIP(241);
      if (lookahead == '`')
        ADVANCE(50);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      END_STATE();
    case 241:
      if (lookahead == '\n')
        SKIP(240);
      END_STATE();
    case 242:
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == ')')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(243);
      if (lookahead == '|')
        ADVANCE(244);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(242);
      END_STATE();
    case 243:
      if (lookahead == '\n')
        SKIP(242);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 245:
      if (lookahead == '\n')
        ADVANCE(83);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '\\')
        ADVANCE(246);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(245);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 246:
      if (lookahead == '\n')
        SKIP(245);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    case 247:
      if (lookahead == '\n')
        ADVANCE(83);
      if (lookahead == '#')
        ADVANCE(57);
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(200);
      if (lookahead == '>')
        ADVANCE(201);
      if (lookahead == '\\')
        ADVANCE(248);
      if (lookahead == '|')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(4);
      END_STATE();
    case 248:
      if (lookahead == '\n')
        SKIP(247);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(4);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'c')
        ADVANCE(1);
      if (lookahead == 'd')
        ADVANCE(5);
      if (lookahead == 'e')
        ADVANCE(15);
      if (lookahead == 'f')
        ADVANCE(29);
      if (lookahead == 'i')
        ADVANCE(40);
      if (lookahead == 'l')
        ADVANCE(43);
      if (lookahead == 'r')
        ADVANCE(48);
      if (lookahead == 't')
        ADVANCE(56);
      if (lookahead == 'u')
        ADVANCE(66);
      if (lookahead == 'w')
        ADVANCE(74);
      END_STATE();
    case 1:
      if (lookahead == 'a')
        ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == 's')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 'e')
        ADVANCE(4);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 5:
      if (lookahead == 'e')
        ADVANCE(6);
      if (lookahead == 'o')
        ADVANCE(12);
      END_STATE();
    case 6:
      if (lookahead == 'c')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 'l')
        ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == 'a')
        ADVANCE(9);
      END_STATE();
    case 9:
      if (lookahead == 'r')
        ADVANCE(10);
      END_STATE();
    case 10:
      if (lookahead == 'e')
        ADVANCE(11);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'n')
        ADVANCE(13);
      END_STATE();
    case 13:
      if (lookahead == 'e')
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_done);
      END_STATE();
    case 15:
      if (lookahead == 'l')
        ADVANCE(16);
      if (lookahead == 's')
        ADVANCE(21);
      if (lookahead == 'x')
        ADVANCE(24);
      END_STATE();
    case 16:
      if (lookahead == 'i')
        ADVANCE(17);
      if (lookahead == 's')
        ADVANCE(19);
      END_STATE();
    case 17:
      if (lookahead == 'f')
        ADVANCE(18);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 19:
      if (lookahead == 'e')
        ADVANCE(20);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 21:
      if (lookahead == 'a')
        ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == 'c')
        ADVANCE(23);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 24:
      if (lookahead == 'p')
        ADVANCE(25);
      END_STATE();
    case 25:
      if (lookahead == 'o')
        ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == 'r')
        ADVANCE(27);
      END_STATE();
    case 27:
      if (lookahead == 't')
        ADVANCE(28);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 29:
      if (lookahead == 'i')
        ADVANCE(30);
      if (lookahead == 'o')
        ADVANCE(31);
      if (lookahead == 'u')
        ADVANCE(33);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 31:
      if (lookahead == 'r')
        ADVANCE(32);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 33:
      if (lookahead == 'n')
        ADVANCE(34);
      END_STATE();
    case 34:
      if (lookahead == 'c')
        ADVANCE(35);
      END_STATE();
    case 35:
      if (lookahead == 't')
        ADVANCE(36);
      END_STATE();
    case 36:
      if (lookahead == 'i')
        ADVANCE(37);
      END_STATE();
    case 37:
      if (lookahead == 'o')
        ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == 'n')
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 40:
      if (lookahead == 'f')
        ADVANCE(41);
      if (lookahead == 'n')
        ADVANCE(42);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 43:
      if (lookahead == 'o')
        ADVANCE(44);
      END_STATE();
    case 44:
      if (lookahead == 'c')
        ADVANCE(45);
      END_STATE();
    case 45:
      if (lookahead == 'a')
        ADVANCE(46);
      END_STATE();
    case 46:
      if (lookahead == 'l')
        ADVANCE(47);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 48:
      if (lookahead == 'e')
        ADVANCE(49);
      END_STATE();
    case 49:
      if (lookahead == 'a')
        ADVANCE(50);
      END_STATE();
    case 50:
      if (lookahead == 'd')
        ADVANCE(51);
      END_STATE();
    case 51:
      if (lookahead == 'o')
        ADVANCE(52);
      END_STATE();
    case 52:
      if (lookahead == 'n')
        ADVANCE(53);
      END_STATE();
    case 53:
      if (lookahead == 'l')
        ADVANCE(54);
      END_STATE();
    case 54:
      if (lookahead == 'y')
        ADVANCE(55);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 56:
      if (lookahead == 'h')
        ADVANCE(57);
      if (lookahead == 'y')
        ADVANCE(60);
      END_STATE();
    case 57:
      if (lookahead == 'e')
        ADVANCE(58);
      END_STATE();
    case 58:
      if (lookahead == 'n')
        ADVANCE(59);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 60:
      if (lookahead == 'p')
        ADVANCE(61);
      END_STATE();
    case 61:
      if (lookahead == 'e')
        ADVANCE(62);
      END_STATE();
    case 62:
      if (lookahead == 's')
        ADVANCE(63);
      END_STATE();
    case 63:
      if (lookahead == 'e')
        ADVANCE(64);
      END_STATE();
    case 64:
      if (lookahead == 't')
        ADVANCE(65);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_typeset);
      END_STATE();
    case 66:
      if (lookahead == 'n')
        ADVANCE(67);
      END_STATE();
    case 67:
      if (lookahead == 's')
        ADVANCE(68);
      END_STATE();
    case 68:
      if (lookahead == 'e')
        ADVANCE(69);
      END_STATE();
    case 69:
      if (lookahead == 't')
        ADVANCE(70);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == 'e')
        ADVANCE(71);
      END_STATE();
    case 71:
      if (lookahead == 'n')
        ADVANCE(72);
      END_STATE();
    case 72:
      if (lookahead == 'v')
        ADVANCE(73);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_unsetenv);
      END_STATE();
    case 74:
      if (lookahead == 'h')
        ADVANCE(75);
      END_STATE();
    case 75:
      if (lookahead == 'i')
        ADVANCE(76);
      END_STATE();
    case 76:
      if (lookahead == 'l')
        ADVANCE(77);
      END_STATE();
    case 77:
      if (lookahead == 'e')
        ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 56, .external_lex_state = 2},
  [2] = {.lex_state = 56},
  [3] = {.lex_state = 62},
  [4] = {.lex_state = 68},
  [5] = {.lex_state = 56, .external_lex_state = 2},
  [6] = {.lex_state = 56, .external_lex_state = 2},
  [7] = {.lex_state = 72},
  [8] = {.lex_state = 72},
  [9] = {.lex_state = 56, .external_lex_state = 2},
  [10] = {.lex_state = 74, .external_lex_state = 2},
  [11] = {.lex_state = 76},
  [12] = {.lex_state = 76},
  [13] = {.lex_state = 82, .external_lex_state = 3},
  [14] = {.lex_state = 82, .external_lex_state = 4},
  [15] = {.lex_state = 72},
  [16] = {.lex_state = 87, .external_lex_state = 5},
  [17] = {.lex_state = 90},
  [18] = {.lex_state = 97},
  [19] = {.lex_state = 87, .external_lex_state = 5},
  [20] = {.lex_state = 97, .external_lex_state = 6},
  [21] = {.lex_state = 56, .external_lex_state = 2},
  [22] = {.lex_state = 56, .external_lex_state = 2},
  [23] = {.lex_state = 56, .external_lex_state = 2},
  [24] = {.lex_state = 106, .external_lex_state = 5},
  [25] = {.lex_state = 108},
  [26] = {.lex_state = 82, .external_lex_state = 4},
  [27] = {.lex_state = 87, .external_lex_state = 7},
  [28] = {.lex_state = 110, .external_lex_state = 8},
  [29] = {.lex_state = 62},
  [30] = {.lex_state = 72, .external_lex_state = 2},
  [31] = {.lex_state = 112, .external_lex_state = 7},
  [32] = {.lex_state = 56, .external_lex_state = 2},
  [33] = {.lex_state = 72, .external_lex_state = 2},
  [34] = {.lex_state = 72},
  [35] = {.lex_state = 72},
  [36] = {.lex_state = 114, .external_lex_state = 9},
  [37] = {.lex_state = 116, .external_lex_state = 4},
  [38] = {.lex_state = 72},
  [39] = {.lex_state = 82, .external_lex_state = 4},
  [40] = {.lex_state = 110, .external_lex_state = 8},
  [41] = {.lex_state = 72},
  [42] = {.lex_state = 116, .external_lex_state = 10},
  [43] = {.lex_state = 90},
  [44] = {.lex_state = 97},
  [45] = {.lex_state = 116, .external_lex_state = 10},
  [46] = {.lex_state = 97, .external_lex_state = 6},
  [47] = {.lex_state = 56, .external_lex_state = 2},
  [48] = {.lex_state = 56, .external_lex_state = 2},
  [49] = {.lex_state = 56, .external_lex_state = 2},
  [50] = {.lex_state = 116, .external_lex_state = 4},
  [51] = {.lex_state = 119},
  [52] = {.lex_state = 62},
  [53] = {.lex_state = 56, .external_lex_state = 2},
  [54] = {.lex_state = 72},
  [55] = {.lex_state = 74, .external_lex_state = 2},
  [56] = {.lex_state = 76},
  [57] = {.lex_state = 76},
  [58] = {.lex_state = 121, .external_lex_state = 3},
  [59] = {.lex_state = 121, .external_lex_state = 4},
  [60] = {.lex_state = 112, .external_lex_state = 5},
  [61] = {.lex_state = 112, .external_lex_state = 5},
  [62] = {.lex_state = 123, .external_lex_state = 5},
  [63] = {.lex_state = 121, .external_lex_state = 4},
  [64] = {.lex_state = 112, .external_lex_state = 7},
  [65] = {.lex_state = 125, .external_lex_state = 8},
  [66] = {.lex_state = 62},
  [67] = {.lex_state = 56, .external_lex_state = 2},
  [68] = {.lex_state = 72, .external_lex_state = 2},
  [69] = {.lex_state = 62},
  [70] = {.lex_state = 127, .external_lex_state = 4},
  [71] = {.lex_state = 62},
  [72] = {.lex_state = 76},
  [73] = {.lex_state = 76},
  [74] = {.lex_state = 129, .external_lex_state = 11},
  [75] = {.lex_state = 90},
  [76] = {.lex_state = 97},
  [77] = {.lex_state = 129, .external_lex_state = 11},
  [78] = {.lex_state = 97, .external_lex_state = 6},
  [79] = {.lex_state = 56, .external_lex_state = 2},
  [80] = {.lex_state = 56, .external_lex_state = 2},
  [81] = {.lex_state = 56, .external_lex_state = 2},
  [82] = {.lex_state = 129, .external_lex_state = 12},
  [83] = {.lex_state = 76},
  [84] = {.lex_state = 76},
  [85] = {.lex_state = 141, .external_lex_state = 13},
  [86] = {.lex_state = 90},
  [87] = {.lex_state = 97},
  [88] = {.lex_state = 141, .external_lex_state = 13},
  [89] = {.lex_state = 97, .external_lex_state = 6},
  [90] = {.lex_state = 56, .external_lex_state = 2},
  [91] = {.lex_state = 56, .external_lex_state = 2},
  [92] = {.lex_state = 56, .external_lex_state = 2},
  [93] = {.lex_state = 141},
  [94] = {.lex_state = 62},
  [95] = {.lex_state = 82, .external_lex_state = 14},
  [96] = {.lex_state = 90},
  [97] = {.lex_state = 97},
  [98] = {.lex_state = 82, .external_lex_state = 14},
  [99] = {.lex_state = 97, .external_lex_state = 6},
  [100] = {.lex_state = 56, .external_lex_state = 2},
  [101] = {.lex_state = 56, .external_lex_state = 2},
  [102] = {.lex_state = 56, .external_lex_state = 2},
  [103] = {.lex_state = 121, .external_lex_state = 3},
  [104] = {.lex_state = 62},
  [105] = {.lex_state = 82, .external_lex_state = 3},
  [106] = {.lex_state = 82, .external_lex_state = 10},
  [107] = {.lex_state = 90},
  [108] = {.lex_state = 97},
  [109] = {.lex_state = 82, .external_lex_state = 10},
  [110] = {.lex_state = 97, .external_lex_state = 6},
  [111] = {.lex_state = 56, .external_lex_state = 2},
  [112] = {.lex_state = 56, .external_lex_state = 2},
  [113] = {.lex_state = 56, .external_lex_state = 2},
  [114] = {.lex_state = 121, .external_lex_state = 4},
  [115] = {.lex_state = 82, .external_lex_state = 4},
  [116] = {.lex_state = 72, .external_lex_state = 15},
  [117] = {.lex_state = 90},
  [118] = {.lex_state = 97},
  [119] = {.lex_state = 72, .external_lex_state = 15},
  [120] = {.lex_state = 97, .external_lex_state = 6},
  [121] = {.lex_state = 56, .external_lex_state = 2},
  [122] = {.lex_state = 56, .external_lex_state = 2},
  [123] = {.lex_state = 56, .external_lex_state = 2},
  [124] = {.lex_state = 72, .external_lex_state = 2},
  [125] = {.lex_state = 72},
  [126] = {.lex_state = 87, .external_lex_state = 5},
  [127] = {.lex_state = 112, .external_lex_state = 5},
  [128] = {.lex_state = 145},
  [129] = {.lex_state = 90, .external_lex_state = 13},
  [130] = {.lex_state = 97, .external_lex_state = 6},
  [131] = {.lex_state = 56, .external_lex_state = 2},
  [132] = {.lex_state = 56, .external_lex_state = 2},
  [133] = {.lex_state = 90},
  [134] = {.lex_state = 112, .external_lex_state = 5},
  [135] = {.lex_state = 112, .external_lex_state = 5},
  [136] = {.lex_state = 112, .external_lex_state = 5},
  [137] = {.lex_state = 62},
  [138] = {.lex_state = 151, .external_lex_state = 16},
  [139] = {.lex_state = 154, .external_lex_state = 6},
  [140] = {.lex_state = 151, .external_lex_state = 16},
  [141] = {.lex_state = 151, .external_lex_state = 16},
  [142] = {.lex_state = 62},
  [143] = {.lex_state = 68},
  [144] = {.lex_state = 56, .external_lex_state = 2},
  [145] = {.lex_state = 56, .external_lex_state = 2},
  [146] = {.lex_state = 72},
  [147] = {.lex_state = 72},
  [148] = {.lex_state = 56, .external_lex_state = 2},
  [149] = {.lex_state = 74, .external_lex_state = 2},
  [150] = {.lex_state = 76},
  [151] = {.lex_state = 76},
  [152] = {.lex_state = 156, .external_lex_state = 6},
  [153] = {.lex_state = 156},
  [154] = {.lex_state = 158, .external_lex_state = 17},
  [155] = {.lex_state = 90},
  [156] = {.lex_state = 97},
  [157] = {.lex_state = 158, .external_lex_state = 17},
  [158] = {.lex_state = 97, .external_lex_state = 6},
  [159] = {.lex_state = 56, .external_lex_state = 2},
  [160] = {.lex_state = 56, .external_lex_state = 2},
  [161] = {.lex_state = 56, .external_lex_state = 2},
  [162] = {.lex_state = 161, .external_lex_state = 17},
  [163] = {.lex_state = 68},
  [164] = {.lex_state = 158, .external_lex_state = 18},
  [165] = {.lex_state = 163, .external_lex_state = 2},
  [166] = {.lex_state = 62},
  [167] = {.lex_state = 158, .external_lex_state = 18},
  [168] = {.lex_state = 72, .external_lex_state = 2},
  [169] = {.lex_state = 62},
  [170] = {.lex_state = 56, .external_lex_state = 2},
  [171] = {.lex_state = 72},
  [172] = {.lex_state = 74, .external_lex_state = 2},
  [173] = {.lex_state = 76},
  [174] = {.lex_state = 76},
  [175] = {.lex_state = 165, .external_lex_state = 6},
  [176] = {.lex_state = 156},
  [177] = {.lex_state = 167, .external_lex_state = 17},
  [178] = {.lex_state = 167, .external_lex_state = 17},
  [179] = {.lex_state = 169, .external_lex_state = 17},
  [180] = {.lex_state = 68},
  [181] = {.lex_state = 167, .external_lex_state = 18},
  [182] = {.lex_state = 171, .external_lex_state = 2},
  [183] = {.lex_state = 62},
  [184] = {.lex_state = 72, .external_lex_state = 2},
  [185] = {.lex_state = 68},
  [186] = {.lex_state = 163, .external_lex_state = 2},
  [187] = {.lex_state = 68},
  [188] = {.lex_state = 56, .external_lex_state = 2},
  [189] = {.lex_state = 173, .external_lex_state = 2},
  [190] = {.lex_state = 56, .external_lex_state = 2},
  [191] = {.lex_state = 127, .external_lex_state = 4},
  [192] = {.lex_state = 176, .external_lex_state = 19},
  [193] = {.lex_state = 56},
  [194] = {.lex_state = 179},
  [195] = {.lex_state = 72},
  [196] = {.lex_state = 56, .external_lex_state = 20},
  [197] = {.lex_state = 72},
  [198] = {.lex_state = 87, .external_lex_state = 5},
  [199] = {.lex_state = 87, .external_lex_state = 5},
  [200] = {.lex_state = 127, .external_lex_state = 4},
  [201] = {.lex_state = 199, .external_lex_state = 7},
  [202] = {.lex_state = 87, .external_lex_state = 7},
  [203] = {.lex_state = 56, .external_lex_state = 2},
  [204] = {.lex_state = 87, .external_lex_state = 7},
  [205] = {.lex_state = 72, .external_lex_state = 2},
  [206] = {.lex_state = 72, .external_lex_state = 15},
  [207] = {.lex_state = 72, .external_lex_state = 15},
  [208] = {.lex_state = 72, .external_lex_state = 2},
  [209] = {.lex_state = 203, .external_lex_state = 11},
  [210] = {.lex_state = 203, .external_lex_state = 11},
  [211] = {.lex_state = 203, .external_lex_state = 11},
  [212] = {.lex_state = 125, .external_lex_state = 8},
  [213] = {.lex_state = 163},
  [214] = {.lex_state = 110, .external_lex_state = 21},
  [215] = {.lex_state = 90},
  [216] = {.lex_state = 97},
  [217] = {.lex_state = 110, .external_lex_state = 21},
  [218] = {.lex_state = 97, .external_lex_state = 6},
  [219] = {.lex_state = 56, .external_lex_state = 2},
  [220] = {.lex_state = 56, .external_lex_state = 2},
  [221] = {.lex_state = 56, .external_lex_state = 2},
  [222] = {.lex_state = 72},
  [223] = {.lex_state = 72},
  [224] = {.lex_state = 56, .external_lex_state = 2},
  [225] = {.lex_state = 199, .external_lex_state = 7},
  [226] = {.lex_state = 72},
  [227] = {.lex_state = 56, .external_lex_state = 2},
  [228] = {.lex_state = 72},
  [229] = {.lex_state = 116, .external_lex_state = 4},
  [230] = {.lex_state = 72},
  [231] = {.lex_state = 116, .external_lex_state = 10},
  [232] = {.lex_state = 116, .external_lex_state = 10},
  [233] = {.lex_state = 90},
  [234] = {.lex_state = 116, .external_lex_state = 10},
  [235] = {.lex_state = 116, .external_lex_state = 10},
  [236] = {.lex_state = 116, .external_lex_state = 10},
  [237] = {.lex_state = 116, .external_lex_state = 4},
  [238] = {.lex_state = 72},
  [239] = {.lex_state = 62},
  [240] = {.lex_state = 151, .external_lex_state = 16},
  [241] = {.lex_state = 154, .external_lex_state = 6},
  [242] = {.lex_state = 151, .external_lex_state = 16},
  [243] = {.lex_state = 151, .external_lex_state = 16},
  [244] = {.lex_state = 68},
  [245] = {.lex_state = 163, .external_lex_state = 2},
  [246] = {.lex_state = 68},
  [247] = {.lex_state = 171, .external_lex_state = 2},
  [248] = {.lex_state = 68},
  [249] = {.lex_state = 163, .external_lex_state = 2},
  [250] = {.lex_state = 68},
  [251] = {.lex_state = 205, .external_lex_state = 22},
  [252] = {.lex_state = 110, .external_lex_state = 23},
  [253] = {.lex_state = 114, .external_lex_state = 9},
  [254] = {.lex_state = 72},
  [255] = {.lex_state = 119},
  [256] = {.lex_state = 129, .external_lex_state = 12},
  [257] = {.lex_state = 141},
  [258] = {.lex_state = 62},
  [259] = {.lex_state = 121, .external_lex_state = 14},
  [260] = {.lex_state = 121, .external_lex_state = 14},
  [261] = {.lex_state = 62},
  [262] = {.lex_state = 121, .external_lex_state = 3},
  [263] = {.lex_state = 121, .external_lex_state = 10},
  [264] = {.lex_state = 121, .external_lex_state = 10},
  [265] = {.lex_state = 121, .external_lex_state = 4},
  [266] = {.lex_state = 112, .external_lex_state = 5},
  [267] = {.lex_state = 68},
  [268] = {.lex_state = 56, .external_lex_state = 2},
  [269] = {.lex_state = 127, .external_lex_state = 4},
  [270] = {.lex_state = 207, .external_lex_state = 2},
  [271] = {.lex_state = 56, .external_lex_state = 2},
  [272] = {.lex_state = 56},
  [273] = {.lex_state = 179},
  [274] = {.lex_state = 72},
  [275] = {.lex_state = 72},
  [276] = {.lex_state = 112, .external_lex_state = 5},
  [277] = {.lex_state = 112, .external_lex_state = 5},
  [278] = {.lex_state = 209, .external_lex_state = 7},
  [279] = {.lex_state = 112, .external_lex_state = 7},
  [280] = {.lex_state = 121, .external_lex_state = 4},
  [281] = {.lex_state = 125, .external_lex_state = 8},
  [282] = {.lex_state = 56, .external_lex_state = 2},
  [283] = {.lex_state = 112, .external_lex_state = 7},
  [284] = {.lex_state = 114, .external_lex_state = 9},
  [285] = {.lex_state = 76},
  [286] = {.lex_state = 211, .external_lex_state = 13},
  [287] = {.lex_state = 211, .external_lex_state = 13},
  [288] = {.lex_state = 211},
  [289] = {.lex_state = 129, .external_lex_state = 12},
  [290] = {.lex_state = 72},
  [291] = {.lex_state = 129, .external_lex_state = 11},
  [292] = {.lex_state = 129, .external_lex_state = 11},
  [293] = {.lex_state = 90},
  [294] = {.lex_state = 129, .external_lex_state = 11},
  [295] = {.lex_state = 129, .external_lex_state = 11},
  [296] = {.lex_state = 129, .external_lex_state = 11},
  [297] = {.lex_state = 62},
  [298] = {.lex_state = 151, .external_lex_state = 16},
  [299] = {.lex_state = 154, .external_lex_state = 6},
  [300] = {.lex_state = 151, .external_lex_state = 16},
  [301] = {.lex_state = 151, .external_lex_state = 16},
  [302] = {.lex_state = 68},
  [303] = {.lex_state = 163, .external_lex_state = 2},
  [304] = {.lex_state = 68},
  [305] = {.lex_state = 171, .external_lex_state = 2},
  [306] = {.lex_state = 68},
  [307] = {.lex_state = 163, .external_lex_state = 2},
  [308] = {.lex_state = 76},
  [309] = {.lex_state = 199, .external_lex_state = 23},
  [310] = {.lex_state = 213},
  [311] = {.lex_state = 211},
  [312] = {.lex_state = 141},
  [313] = {.lex_state = 72},
  [314] = {.lex_state = 141, .external_lex_state = 13},
  [315] = {.lex_state = 218, .external_lex_state = 13},
  [316] = {.lex_state = 90},
  [317] = {.lex_state = 218, .external_lex_state = 13},
  [318] = {.lex_state = 218, .external_lex_state = 13},
  [319] = {.lex_state = 218, .external_lex_state = 13},
  [320] = {.lex_state = 62},
  [321] = {.lex_state = 151, .external_lex_state = 16},
  [322] = {.lex_state = 154, .external_lex_state = 6},
  [323] = {.lex_state = 151, .external_lex_state = 16},
  [324] = {.lex_state = 151, .external_lex_state = 16},
  [325] = {.lex_state = 68},
  [326] = {.lex_state = 163, .external_lex_state = 2},
  [327] = {.lex_state = 68},
  [328] = {.lex_state = 171, .external_lex_state = 2},
  [329] = {.lex_state = 68},
  [330] = {.lex_state = 163, .external_lex_state = 2},
  [331] = {.lex_state = 76},
  [332] = {.lex_state = 213},
  [333] = {.lex_state = 114, .external_lex_state = 9},
  [334] = {.lex_state = 72},
  [335] = {.lex_state = 82, .external_lex_state = 14},
  [336] = {.lex_state = 121, .external_lex_state = 14},
  [337] = {.lex_state = 90},
  [338] = {.lex_state = 121, .external_lex_state = 14},
  [339] = {.lex_state = 121, .external_lex_state = 14},
  [340] = {.lex_state = 121, .external_lex_state = 14},
  [341] = {.lex_state = 62},
  [342] = {.lex_state = 151, .external_lex_state = 16},
  [343] = {.lex_state = 154, .external_lex_state = 6},
  [344] = {.lex_state = 151, .external_lex_state = 16},
  [345] = {.lex_state = 151, .external_lex_state = 16},
  [346] = {.lex_state = 68},
  [347] = {.lex_state = 163, .external_lex_state = 2},
  [348] = {.lex_state = 68},
  [349] = {.lex_state = 171, .external_lex_state = 2},
  [350] = {.lex_state = 68},
  [351] = {.lex_state = 163, .external_lex_state = 2},
  [352] = {.lex_state = 82, .external_lex_state = 3},
  [353] = {.lex_state = 72},
  [354] = {.lex_state = 82, .external_lex_state = 10},
  [355] = {.lex_state = 121, .external_lex_state = 10},
  [356] = {.lex_state = 90},
  [357] = {.lex_state = 121, .external_lex_state = 10},
  [358] = {.lex_state = 121, .external_lex_state = 10},
  [359] = {.lex_state = 121, .external_lex_state = 10},
  [360] = {.lex_state = 62},
  [361] = {.lex_state = 151, .external_lex_state = 16},
  [362] = {.lex_state = 154, .external_lex_state = 6},
  [363] = {.lex_state = 151, .external_lex_state = 16},
  [364] = {.lex_state = 151, .external_lex_state = 16},
  [365] = {.lex_state = 68},
  [366] = {.lex_state = 163, .external_lex_state = 2},
  [367] = {.lex_state = 68},
  [368] = {.lex_state = 171, .external_lex_state = 2},
  [369] = {.lex_state = 68},
  [370] = {.lex_state = 163, .external_lex_state = 2},
  [371] = {.lex_state = 82, .external_lex_state = 4},
  [372] = {.lex_state = 72},
  [373] = {.lex_state = 72, .external_lex_state = 15},
  [374] = {.lex_state = 163, .external_lex_state = 15},
  [375] = {.lex_state = 90},
  [376] = {.lex_state = 163, .external_lex_state = 15},
  [377] = {.lex_state = 163, .external_lex_state = 15},
  [378] = {.lex_state = 163, .external_lex_state = 15},
  [379] = {.lex_state = 62},
  [380] = {.lex_state = 151, .external_lex_state = 16},
  [381] = {.lex_state = 154, .external_lex_state = 6},
  [382] = {.lex_state = 151, .external_lex_state = 16},
  [383] = {.lex_state = 151, .external_lex_state = 16},
  [384] = {.lex_state = 68},
  [385] = {.lex_state = 163, .external_lex_state = 2},
  [386] = {.lex_state = 68},
  [387] = {.lex_state = 171, .external_lex_state = 2},
  [388] = {.lex_state = 68},
  [389] = {.lex_state = 163, .external_lex_state = 2},
  [390] = {.lex_state = 112, .external_lex_state = 5},
  [391] = {.lex_state = 87, .external_lex_state = 5},
  [392] = {.lex_state = 90, .external_lex_state = 13},
  [393] = {.lex_state = 90, .external_lex_state = 13},
  [394] = {.lex_state = 90, .external_lex_state = 13},
  [395] = {.lex_state = 90},
  [396] = {.lex_state = 62},
  [397] = {.lex_state = 151, .external_lex_state = 16},
  [398] = {.lex_state = 154, .external_lex_state = 6},
  [399] = {.lex_state = 151, .external_lex_state = 16},
  [400] = {.lex_state = 151, .external_lex_state = 16},
  [401] = {.lex_state = 68},
  [402] = {.lex_state = 163, .external_lex_state = 2},
  [403] = {.lex_state = 68},
  [404] = {.lex_state = 171, .external_lex_state = 2},
  [405] = {.lex_state = 112, .external_lex_state = 5},
  [406] = {.lex_state = 90},
  [407] = {.lex_state = 72},
  [408] = {.lex_state = 221, .external_lex_state = 16},
  [409] = {.lex_state = 112, .external_lex_state = 5},
  [410] = {.lex_state = 223, .external_lex_state = 24},
  [411] = {.lex_state = 90},
  [412] = {.lex_state = 97},
  [413] = {.lex_state = 223, .external_lex_state = 24},
  [414] = {.lex_state = 97, .external_lex_state = 6},
  [415] = {.lex_state = 225},
  [416] = {.lex_state = 56, .external_lex_state = 2},
  [417] = {.lex_state = 56, .external_lex_state = 2},
  [418] = {.lex_state = 56, .external_lex_state = 2},
  [419] = {.lex_state = 223, .external_lex_state = 16},
  [420] = {.lex_state = 62},
  [421] = {.lex_state = 151, .external_lex_state = 16},
  [422] = {.lex_state = 151, .external_lex_state = 16},
  [423] = {.lex_state = 151, .external_lex_state = 16},
  [424] = {.lex_state = 112, .external_lex_state = 5},
  [425] = {.lex_state = 225},
  [426] = {.lex_state = 223, .external_lex_state = 16},
  [427] = {.lex_state = 112, .external_lex_state = 5},
  [428] = {.lex_state = 225},
  [429] = {.lex_state = 223, .external_lex_state = 16},
  [430] = {.lex_state = 114, .external_lex_state = 9},
  [431] = {.lex_state = 116, .external_lex_state = 4},
  [432] = {.lex_state = 72},
  [433] = {.lex_state = 72},
  [434] = {.lex_state = 116, .external_lex_state = 10},
  [435] = {.lex_state = 116, .external_lex_state = 10},
  [436] = {.lex_state = 116, .external_lex_state = 4},
  [437] = {.lex_state = 119},
  [438] = {.lex_state = 121, .external_lex_state = 4},
  [439] = {.lex_state = 125, .external_lex_state = 8},
  [440] = {.lex_state = 56, .external_lex_state = 2},
  [441] = {.lex_state = 68},
  [442] = {.lex_state = 129, .external_lex_state = 12},
  [443] = {.lex_state = 141},
  [444] = {.lex_state = 62},
  [445] = {.lex_state = 156, .external_lex_state = 25},
  [446] = {.lex_state = 90},
  [447] = {.lex_state = 97},
  [448] = {.lex_state = 156, .external_lex_state = 25},
  [449] = {.lex_state = 97, .external_lex_state = 6},
  [450] = {.lex_state = 56, .external_lex_state = 2},
  [451] = {.lex_state = 56, .external_lex_state = 2},
  [452] = {.lex_state = 56, .external_lex_state = 2},
  [453] = {.lex_state = 156, .external_lex_state = 6},
  [454] = {.lex_state = 62},
  [455] = {.lex_state = 156, .external_lex_state = 6},
  [456] = {.lex_state = 156, .external_lex_state = 13},
  [457] = {.lex_state = 90},
  [458] = {.lex_state = 97},
  [459] = {.lex_state = 156, .external_lex_state = 13},
  [460] = {.lex_state = 97, .external_lex_state = 6},
  [461] = {.lex_state = 56, .external_lex_state = 2},
  [462] = {.lex_state = 56, .external_lex_state = 2},
  [463] = {.lex_state = 56, .external_lex_state = 2},
  [464] = {.lex_state = 156},
  [465] = {.lex_state = 156},
  [466] = {.lex_state = 72},
  [467] = {.lex_state = 158, .external_lex_state = 17},
  [468] = {.lex_state = 158, .external_lex_state = 17},
  [469] = {.lex_state = 90},
  [470] = {.lex_state = 158, .external_lex_state = 17},
  [471] = {.lex_state = 158, .external_lex_state = 17},
  [472] = {.lex_state = 158, .external_lex_state = 17},
  [473] = {.lex_state = 62},
  [474] = {.lex_state = 151, .external_lex_state = 16},
  [475] = {.lex_state = 154, .external_lex_state = 6},
  [476] = {.lex_state = 151, .external_lex_state = 16},
  [477] = {.lex_state = 151, .external_lex_state = 16},
  [478] = {.lex_state = 68},
  [479] = {.lex_state = 163, .external_lex_state = 2},
  [480] = {.lex_state = 68},
  [481] = {.lex_state = 171, .external_lex_state = 2},
  [482] = {.lex_state = 68},
  [483] = {.lex_state = 163, .external_lex_state = 2},
  [484] = {.lex_state = 68},
  [485] = {.lex_state = 56, .external_lex_state = 2},
  [486] = {.lex_state = 112, .external_lex_state = 5},
  [487] = {.lex_state = 56, .external_lex_state = 2},
  [488] = {.lex_state = 68},
  [489] = {.lex_state = 176, .external_lex_state = 19},
  [490] = {.lex_state = 56},
  [491] = {.lex_state = 179},
  [492] = {.lex_state = 72},
  [493] = {.lex_state = 56, .external_lex_state = 20},
  [494] = {.lex_state = 72},
  [495] = {.lex_state = 158, .external_lex_state = 17},
  [496] = {.lex_state = 158, .external_lex_state = 17},
  [497] = {.lex_state = 68},
  [498] = {.lex_state = 230, .external_lex_state = 18},
  [499] = {.lex_state = 158, .external_lex_state = 18},
  [500] = {.lex_state = 158, .external_lex_state = 18},
  [501] = {.lex_state = 114, .external_lex_state = 9},
  [502] = {.lex_state = 72},
  [503] = {.lex_state = 119},
  [504] = {.lex_state = 129, .external_lex_state = 12},
  [505] = {.lex_state = 141},
  [506] = {.lex_state = 62},
  [507] = {.lex_state = 165, .external_lex_state = 25},
  [508] = {.lex_state = 165, .external_lex_state = 25},
  [509] = {.lex_state = 62},
  [510] = {.lex_state = 165, .external_lex_state = 6},
  [511] = {.lex_state = 165, .external_lex_state = 13},
  [512] = {.lex_state = 165, .external_lex_state = 13},
  [513] = {.lex_state = 156},
  [514] = {.lex_state = 167, .external_lex_state = 17},
  [515] = {.lex_state = 68},
  [516] = {.lex_state = 56, .external_lex_state = 2},
  [517] = {.lex_state = 56, .external_lex_state = 2},
  [518] = {.lex_state = 56},
  [519] = {.lex_state = 179},
  [520] = {.lex_state = 72},
  [521] = {.lex_state = 72},
  [522] = {.lex_state = 167, .external_lex_state = 17},
  [523] = {.lex_state = 167, .external_lex_state = 17},
  [524] = {.lex_state = 232, .external_lex_state = 18},
  [525] = {.lex_state = 167, .external_lex_state = 18},
  [526] = {.lex_state = 167, .external_lex_state = 18},
  [527] = {.lex_state = 112, .external_lex_state = 5},
  [528] = {.lex_state = 119},
  [529] = {.lex_state = 127, .external_lex_state = 4},
  [530] = {.lex_state = 125, .external_lex_state = 8},
  [531] = {.lex_state = 82, .external_lex_state = 4},
  [532] = {.lex_state = 110, .external_lex_state = 8},
  [533] = {.lex_state = 127, .external_lex_state = 4},
  [534] = {.lex_state = 97},
  [535] = {.lex_state = 97, .external_lex_state = 6},
  [536] = {.lex_state = 176, .external_lex_state = 19},
  [537] = {.lex_state = 72},
  [538] = {.lex_state = 87, .external_lex_state = 5},
  [539] = {.lex_state = 87, .external_lex_state = 5},
  [540] = {.lex_state = 112, .external_lex_state = 7},
  [541] = {.lex_state = 199, .external_lex_state = 5},
  [542] = {.lex_state = 199, .external_lex_state = 5},
  [543] = {.lex_state = 234, .external_lex_state = 7},
  [544] = {.lex_state = 234, .external_lex_state = 7},
  [545] = {.lex_state = 199, .external_lex_state = 5},
  [546] = {.lex_state = 199, .external_lex_state = 5},
  [547] = {.lex_state = 234, .external_lex_state = 7},
  [548] = {.lex_state = 127, .external_lex_state = 4},
  [549] = {.lex_state = 199, .external_lex_state = 7},
  [550] = {.lex_state = 199, .external_lex_state = 7},
  [551] = {.lex_state = 87, .external_lex_state = 7},
  [552] = {.lex_state = 87, .external_lex_state = 7},
  [553] = {.lex_state = 203, .external_lex_state = 12},
  [554] = {.lex_state = 62, .external_lex_state = 13},
  [555] = {.lex_state = 203, .external_lex_state = 11},
  [556] = {.lex_state = 203, .external_lex_state = 12},
  [557] = {.lex_state = 62, .external_lex_state = 13},
  [558] = {.lex_state = 129, .external_lex_state = 12},
  [559] = {.lex_state = 125, .external_lex_state = 8},
  [560] = {.lex_state = 236, .external_lex_state = 13},
  [561] = {.lex_state = 90},
  [562] = {.lex_state = 97},
  [563] = {.lex_state = 236, .external_lex_state = 13},
  [564] = {.lex_state = 97, .external_lex_state = 6},
  [565] = {.lex_state = 56, .external_lex_state = 2},
  [566] = {.lex_state = 56, .external_lex_state = 2},
  [567] = {.lex_state = 56, .external_lex_state = 2},
  [568] = {.lex_state = 163},
  [569] = {.lex_state = 72},
  [570] = {.lex_state = 110, .external_lex_state = 21},
  [571] = {.lex_state = 125, .external_lex_state = 21},
  [572] = {.lex_state = 90},
  [573] = {.lex_state = 125, .external_lex_state = 21},
  [574] = {.lex_state = 125, .external_lex_state = 21},
  [575] = {.lex_state = 125, .external_lex_state = 21},
  [576] = {.lex_state = 62},
  [577] = {.lex_state = 151, .external_lex_state = 16},
  [578] = {.lex_state = 154, .external_lex_state = 6},
  [579] = {.lex_state = 151, .external_lex_state = 16},
  [580] = {.lex_state = 151, .external_lex_state = 16},
  [581] = {.lex_state = 68},
  [582] = {.lex_state = 163, .external_lex_state = 2},
  [583] = {.lex_state = 68},
  [584] = {.lex_state = 171, .external_lex_state = 2},
  [585] = {.lex_state = 68},
  [586] = {.lex_state = 163, .external_lex_state = 2},
  [587] = {.lex_state = 116, .external_lex_state = 10},
  [588] = {.lex_state = 116, .external_lex_state = 10},
  [589] = {.lex_state = 116, .external_lex_state = 4},
  [590] = {.lex_state = 56, .external_lex_state = 2},
  [591] = {.lex_state = 127, .external_lex_state = 4},
  [592] = {.lex_state = 234, .external_lex_state = 7},
  [593] = {.lex_state = 56, .external_lex_state = 2},
  [594] = {.lex_state = 127, .external_lex_state = 4},
  [595] = {.lex_state = 199, .external_lex_state = 7},
  [596] = {.lex_state = 127, .external_lex_state = 4},
  [597] = {.lex_state = 56, .external_lex_state = 2},
  [598] = {.lex_state = 56, .external_lex_state = 2},
  [599] = {.lex_state = 72},
  [600] = {.lex_state = 72},
  [601] = {.lex_state = 56, .external_lex_state = 2},
  [602] = {.lex_state = 72},
  [603] = {.lex_state = 116, .external_lex_state = 10},
  [604] = {.lex_state = 72},
  [605] = {.lex_state = 116, .external_lex_state = 4},
  [606] = {.lex_state = 116, .external_lex_state = 10},
  [607] = {.lex_state = 116, .external_lex_state = 10},
  [608] = {.lex_state = 72},
  [609] = {.lex_state = 116, .external_lex_state = 4},
  [610] = {.lex_state = 221, .external_lex_state = 16},
  [611] = {.lex_state = 116, .external_lex_state = 10},
  [612] = {.lex_state = 225},
  [613] = {.lex_state = 223, .external_lex_state = 16},
  [614] = {.lex_state = 62},
  [615] = {.lex_state = 151, .external_lex_state = 16},
  [616] = {.lex_state = 151, .external_lex_state = 16},
  [617] = {.lex_state = 151, .external_lex_state = 16},
  [618] = {.lex_state = 116, .external_lex_state = 10},
  [619] = {.lex_state = 225},
  [620] = {.lex_state = 223, .external_lex_state = 16},
  [621] = {.lex_state = 116, .external_lex_state = 10},
  [622] = {.lex_state = 225},
  [623] = {.lex_state = 223, .external_lex_state = 16},
  [624] = {.lex_state = 116, .external_lex_state = 10},
  [625] = {.lex_state = 116, .external_lex_state = 10},
  [626] = {.lex_state = 119},
  [627] = {.lex_state = 125, .external_lex_state = 23},
  [628] = {.lex_state = 82, .external_lex_state = 4},
  [629] = {.lex_state = 110, .external_lex_state = 8},
  [630] = {.lex_state = 205, .external_lex_state = 22},
  [631] = {.lex_state = 56},
  [632] = {.lex_state = 72},
  [633] = {.lex_state = 127, .external_lex_state = 4},
  [634] = {.lex_state = 125, .external_lex_state = 21},
  [635] = {.lex_state = 125, .external_lex_state = 21},
  [636] = {.lex_state = 209, .external_lex_state = 7},
  [637] = {.lex_state = 68},
  [638] = {.lex_state = 125, .external_lex_state = 23},
  [639] = {.lex_state = 209, .external_lex_state = 23},
  [640] = {.lex_state = 114, .external_lex_state = 9},
  [641] = {.lex_state = 121, .external_lex_state = 14},
  [642] = {.lex_state = 121, .external_lex_state = 3},
  [643] = {.lex_state = 121, .external_lex_state = 10},
  [644] = {.lex_state = 121, .external_lex_state = 4},
  [645] = {.lex_state = 112, .external_lex_state = 5},
  [646] = {.lex_state = 119},
  [647] = {.lex_state = 127, .external_lex_state = 4},
  [648] = {.lex_state = 121, .external_lex_state = 4},
  [649] = {.lex_state = 125, .external_lex_state = 8},
  [650] = {.lex_state = 72},
  [651] = {.lex_state = 112, .external_lex_state = 5},
  [652] = {.lex_state = 112, .external_lex_state = 5},
  [653] = {.lex_state = 209, .external_lex_state = 5},
  [654] = {.lex_state = 209, .external_lex_state = 5},
  [655] = {.lex_state = 209, .external_lex_state = 5},
  [656] = {.lex_state = 209, .external_lex_state = 5},
  [657] = {.lex_state = 209, .external_lex_state = 7},
  [658] = {.lex_state = 209, .external_lex_state = 7},
  [659] = {.lex_state = 112, .external_lex_state = 7},
  [660] = {.lex_state = 207, .external_lex_state = 2},
  [661] = {.lex_state = 112, .external_lex_state = 7},
  [662] = {.lex_state = 163, .external_lex_state = 2},
  [663] = {.lex_state = 163},
  [664] = {.lex_state = 72, .external_lex_state = 15},
  [665] = {.lex_state = 72, .external_lex_state = 15},
  [666] = {.lex_state = 211},
  [667] = {.lex_state = 211, .external_lex_state = 13},
  [668] = {.lex_state = 129, .external_lex_state = 12},
  [669] = {.lex_state = 76},
  [670] = {.lex_state = 213},
  [671] = {.lex_state = 129, .external_lex_state = 11},
  [672] = {.lex_state = 129, .external_lex_state = 11},
  [673] = {.lex_state = 129, .external_lex_state = 11},
  [674] = {.lex_state = 221, .external_lex_state = 16},
  [675] = {.lex_state = 129, .external_lex_state = 11},
  [676] = {.lex_state = 225},
  [677] = {.lex_state = 223, .external_lex_state = 16},
  [678] = {.lex_state = 62},
  [679] = {.lex_state = 151, .external_lex_state = 16},
  [680] = {.lex_state = 151, .external_lex_state = 16},
  [681] = {.lex_state = 151, .external_lex_state = 16},
  [682] = {.lex_state = 129, .external_lex_state = 11},
  [683] = {.lex_state = 225},
  [684] = {.lex_state = 223, .external_lex_state = 16},
  [685] = {.lex_state = 129, .external_lex_state = 11},
  [686] = {.lex_state = 225},
  [687] = {.lex_state = 223, .external_lex_state = 16},
  [688] = {.lex_state = 129, .external_lex_state = 11},
  [689] = {.lex_state = 129, .external_lex_state = 11},
  [690] = {.lex_state = 129, .external_lex_state = 12},
  [691] = {.lex_state = 56},
  [692] = {.lex_state = 72},
  [693] = {.lex_state = 56, .external_lex_state = 20},
  [694] = {.lex_state = 72},
  [695] = {.lex_state = 199, .external_lex_state = 23},
  [696] = {.lex_state = 129, .external_lex_state = 12},
  [697] = {.lex_state = 238},
  [698] = {.lex_state = 218, .external_lex_state = 13},
  [699] = {.lex_state = 141, .external_lex_state = 13},
  [700] = {.lex_state = 218, .external_lex_state = 13},
  [701] = {.lex_state = 221, .external_lex_state = 16},
  [702] = {.lex_state = 218, .external_lex_state = 13},
  [703] = {.lex_state = 225},
  [704] = {.lex_state = 223, .external_lex_state = 16},
  [705] = {.lex_state = 62},
  [706] = {.lex_state = 151, .external_lex_state = 16},
  [707] = {.lex_state = 151, .external_lex_state = 16},
  [708] = {.lex_state = 151, .external_lex_state = 16},
  [709] = {.lex_state = 218, .external_lex_state = 13},
  [710] = {.lex_state = 225},
  [711] = {.lex_state = 223, .external_lex_state = 16},
  [712] = {.lex_state = 218, .external_lex_state = 13},
  [713] = {.lex_state = 225},
  [714] = {.lex_state = 223, .external_lex_state = 16},
  [715] = {.lex_state = 218, .external_lex_state = 13},
  [716] = {.lex_state = 218, .external_lex_state = 13},
  [717] = {.lex_state = 238},
  [718] = {.lex_state = 238},
  [719] = {.lex_state = 121, .external_lex_state = 3},
  [720] = {.lex_state = 163},
  [721] = {.lex_state = 82, .external_lex_state = 14},
  [722] = {.lex_state = 82, .external_lex_state = 14},
  [723] = {.lex_state = 121, .external_lex_state = 14},
  [724] = {.lex_state = 82, .external_lex_state = 14},
  [725] = {.lex_state = 121, .external_lex_state = 14},
  [726] = {.lex_state = 221, .external_lex_state = 16},
  [727] = {.lex_state = 121, .external_lex_state = 14},
  [728] = {.lex_state = 225},
  [729] = {.lex_state = 223, .external_lex_state = 16},
  [730] = {.lex_state = 62},
  [731] = {.lex_state = 151, .external_lex_state = 16},
  [732] = {.lex_state = 151, .external_lex_state = 16},
  [733] = {.lex_state = 151, .external_lex_state = 16},
  [734] = {.lex_state = 121, .external_lex_state = 14},
  [735] = {.lex_state = 225},
  [736] = {.lex_state = 223, .external_lex_state = 16},
  [737] = {.lex_state = 121, .external_lex_state = 14},
  [738] = {.lex_state = 225},
  [739] = {.lex_state = 223, .external_lex_state = 16},
  [740] = {.lex_state = 121, .external_lex_state = 14},
  [741] = {.lex_state = 121, .external_lex_state = 14},
  [742] = {.lex_state = 121, .external_lex_state = 10},
  [743] = {.lex_state = 82, .external_lex_state = 10},
  [744] = {.lex_state = 121, .external_lex_state = 10},
  [745] = {.lex_state = 221, .external_lex_state = 16},
  [746] = {.lex_state = 121, .external_lex_state = 10},
  [747] = {.lex_state = 225},
  [748] = {.lex_state = 223, .external_lex_state = 16},
  [749] = {.lex_state = 62},
  [750] = {.lex_state = 151, .external_lex_state = 16},
  [751] = {.lex_state = 151, .external_lex_state = 16},
  [752] = {.lex_state = 151, .external_lex_state = 16},
  [753] = {.lex_state = 121, .external_lex_state = 10},
  [754] = {.lex_state = 225},
  [755] = {.lex_state = 223, .external_lex_state = 16},
  [756] = {.lex_state = 121, .external_lex_state = 10},
  [757] = {.lex_state = 225},
  [758] = {.lex_state = 223, .external_lex_state = 16},
  [759] = {.lex_state = 121, .external_lex_state = 10},
  [760] = {.lex_state = 121, .external_lex_state = 10},
  [761] = {.lex_state = 163, .external_lex_state = 15},
  [762] = {.lex_state = 72, .external_lex_state = 15},
  [763] = {.lex_state = 163, .external_lex_state = 15},
  [764] = {.lex_state = 221, .external_lex_state = 16},
  [765] = {.lex_state = 163, .external_lex_state = 15},
  [766] = {.lex_state = 225},
  [767] = {.lex_state = 223, .external_lex_state = 16},
  [768] = {.lex_state = 62},
  [769] = {.lex_state = 151, .external_lex_state = 16},
  [770] = {.lex_state = 151, .external_lex_state = 16},
  [771] = {.lex_state = 151, .external_lex_state = 16},
  [772] = {.lex_state = 163, .external_lex_state = 15},
  [773] = {.lex_state = 225},
  [774] = {.lex_state = 223, .external_lex_state = 16},
  [775] = {.lex_state = 163, .external_lex_state = 15},
  [776] = {.lex_state = 225},
  [777] = {.lex_state = 223, .external_lex_state = 16},
  [778] = {.lex_state = 163, .external_lex_state = 15},
  [779] = {.lex_state = 163, .external_lex_state = 15},
  [780] = {.lex_state = 90},
  [781] = {.lex_state = 221, .external_lex_state = 16},
  [782] = {.lex_state = 90, .external_lex_state = 13},
  [783] = {.lex_state = 225},
  [784] = {.lex_state = 223, .external_lex_state = 16},
  [785] = {.lex_state = 62},
  [786] = {.lex_state = 151, .external_lex_state = 16},
  [787] = {.lex_state = 151, .external_lex_state = 16},
  [788] = {.lex_state = 151, .external_lex_state = 16},
  [789] = {.lex_state = 90, .external_lex_state = 13},
  [790] = {.lex_state = 225},
  [791] = {.lex_state = 223, .external_lex_state = 16},
  [792] = {.lex_state = 90, .external_lex_state = 13},
  [793] = {.lex_state = 225},
  [794] = {.lex_state = 223, .external_lex_state = 16},
  [795] = {.lex_state = 90, .external_lex_state = 13},
  [796] = {.lex_state = 203, .external_lex_state = 11},
  [797] = {.lex_state = 203, .external_lex_state = 11},
  [798] = {.lex_state = 203, .external_lex_state = 11},
  [799] = {.lex_state = 112, .external_lex_state = 5},
  [800] = {.lex_state = 205, .external_lex_state = 24},
  [801] = {.lex_state = 90},
  [802] = {.lex_state = 97},
  [803] = {.lex_state = 205, .external_lex_state = 24},
  [804] = {.lex_state = 97, .external_lex_state = 6},
  [805] = {.lex_state = 56, .external_lex_state = 2},
  [806] = {.lex_state = 56, .external_lex_state = 2},
  [807] = {.lex_state = 56, .external_lex_state = 2},
  [808] = {.lex_state = 205, .external_lex_state = 16},
  [809] = {.lex_state = 72},
  [810] = {.lex_state = 223, .external_lex_state = 24},
  [811] = {.lex_state = 223, .external_lex_state = 24},
  [812] = {.lex_state = 90},
  [813] = {.lex_state = 223, .external_lex_state = 24},
  [814] = {.lex_state = 223, .external_lex_state = 24},
  [815] = {.lex_state = 223, .external_lex_state = 24},
  [816] = {.lex_state = 62},
  [817] = {.lex_state = 151, .external_lex_state = 16},
  [818] = {.lex_state = 154, .external_lex_state = 6},
  [819] = {.lex_state = 151, .external_lex_state = 16},
  [820] = {.lex_state = 151, .external_lex_state = 16},
  [821] = {.lex_state = 223, .external_lex_state = 16},
  [822] = {.lex_state = 68},
  [823] = {.lex_state = 163, .external_lex_state = 2},
  [824] = {.lex_state = 68},
  [825] = {.lex_state = 171, .external_lex_state = 2},
  [826] = {.lex_state = 68},
  [827] = {.lex_state = 163, .external_lex_state = 2},
  [828] = {.lex_state = 112, .external_lex_state = 5},
  [829] = {.lex_state = 223, .external_lex_state = 16},
  [830] = {.lex_state = 221, .external_lex_state = 16},
  [831] = {.lex_state = 112, .external_lex_state = 5},
  [832] = {.lex_state = 225},
  [833] = {.lex_state = 223, .external_lex_state = 16},
  [834] = {.lex_state = 112, .external_lex_state = 5},
  [835] = {.lex_state = 225},
  [836] = {.lex_state = 223, .external_lex_state = 16},
  [837] = {.lex_state = 225},
  [838] = {.lex_state = 223, .external_lex_state = 16},
  [839] = {.lex_state = 223, .external_lex_state = 16},
  [840] = {.lex_state = 112, .external_lex_state = 5},
  [841] = {.lex_state = 223, .external_lex_state = 16},
  [842] = {.lex_state = 163, .external_lex_state = 15},
  [843] = {.lex_state = 163, .external_lex_state = 15},
  [844] = {.lex_state = 72},
  [845] = {.lex_state = 72},
  [846] = {.lex_state = 56, .external_lex_state = 2},
  [847] = {.lex_state = 230, .external_lex_state = 18},
  [848] = {.lex_state = 56, .external_lex_state = 2},
  [849] = {.lex_state = 116, .external_lex_state = 4},
  [850] = {.lex_state = 72},
  [851] = {.lex_state = 116, .external_lex_state = 4},
  [852] = {.lex_state = 72},
  [853] = {.lex_state = 68},
  [854] = {.lex_state = 205, .external_lex_state = 22},
  [855] = {.lex_state = 163, .external_lex_state = 26},
  [856] = {.lex_state = 68},
  [857] = {.lex_state = 207, .external_lex_state = 2},
  [858] = {.lex_state = 121, .external_lex_state = 4},
  [859] = {.lex_state = 125, .external_lex_state = 8},
  [860] = {.lex_state = 230, .external_lex_state = 26},
  [861] = {.lex_state = 114, .external_lex_state = 9},
  [862] = {.lex_state = 72},
  [863] = {.lex_state = 156, .external_lex_state = 25},
  [864] = {.lex_state = 156, .external_lex_state = 25},
  [865] = {.lex_state = 90},
  [866] = {.lex_state = 156, .external_lex_state = 25},
  [867] = {.lex_state = 156, .external_lex_state = 25},
  [868] = {.lex_state = 156, .external_lex_state = 25},
  [869] = {.lex_state = 62},
  [870] = {.lex_state = 151, .external_lex_state = 16},
  [871] = {.lex_state = 154, .external_lex_state = 6},
  [872] = {.lex_state = 151, .external_lex_state = 16},
  [873] = {.lex_state = 151, .external_lex_state = 16},
  [874] = {.lex_state = 68},
  [875] = {.lex_state = 163, .external_lex_state = 2},
  [876] = {.lex_state = 68},
  [877] = {.lex_state = 171, .external_lex_state = 2},
  [878] = {.lex_state = 68},
  [879] = {.lex_state = 163, .external_lex_state = 2},
  [880] = {.lex_state = 156, .external_lex_state = 6},
  [881] = {.lex_state = 72},
  [882] = {.lex_state = 156, .external_lex_state = 13},
  [883] = {.lex_state = 156, .external_lex_state = 13},
  [884] = {.lex_state = 90},
  [885] = {.lex_state = 156, .external_lex_state = 13},
  [886] = {.lex_state = 156, .external_lex_state = 13},
  [887] = {.lex_state = 156, .external_lex_state = 13},
  [888] = {.lex_state = 62},
  [889] = {.lex_state = 151, .external_lex_state = 16},
  [890] = {.lex_state = 154, .external_lex_state = 6},
  [891] = {.lex_state = 151, .external_lex_state = 16},
  [892] = {.lex_state = 151, .external_lex_state = 16},
  [893] = {.lex_state = 68},
  [894] = {.lex_state = 163, .external_lex_state = 2},
  [895] = {.lex_state = 68},
  [896] = {.lex_state = 171, .external_lex_state = 2},
  [897] = {.lex_state = 68},
  [898] = {.lex_state = 163, .external_lex_state = 2},
  [899] = {.lex_state = 156},
  [900] = {.lex_state = 158, .external_lex_state = 17},
  [901] = {.lex_state = 158, .external_lex_state = 17},
  [902] = {.lex_state = 158, .external_lex_state = 17},
  [903] = {.lex_state = 221, .external_lex_state = 16},
  [904] = {.lex_state = 158, .external_lex_state = 17},
  [905] = {.lex_state = 225},
  [906] = {.lex_state = 223, .external_lex_state = 16},
  [907] = {.lex_state = 62},
  [908] = {.lex_state = 151, .external_lex_state = 16},
  [909] = {.lex_state = 151, .external_lex_state = 16},
  [910] = {.lex_state = 151, .external_lex_state = 16},
  [911] = {.lex_state = 158, .external_lex_state = 17},
  [912] = {.lex_state = 225},
  [913] = {.lex_state = 223, .external_lex_state = 16},
  [914] = {.lex_state = 158, .external_lex_state = 17},
  [915] = {.lex_state = 225},
  [916] = {.lex_state = 223, .external_lex_state = 16},
  [917] = {.lex_state = 158, .external_lex_state = 17},
  [918] = {.lex_state = 158, .external_lex_state = 17},
  [919] = {.lex_state = 119},
  [920] = {.lex_state = 68},
  [921] = {.lex_state = 163, .external_lex_state = 2},
  [922] = {.lex_state = 68},
  [923] = {.lex_state = 163, .external_lex_state = 2},
  [924] = {.lex_state = 68},
  [925] = {.lex_state = 176, .external_lex_state = 19},
  [926] = {.lex_state = 72},
  [927] = {.lex_state = 158, .external_lex_state = 17},
  [928] = {.lex_state = 158, .external_lex_state = 17},
  [929] = {.lex_state = 158, .external_lex_state = 18},
  [930] = {.lex_state = 230, .external_lex_state = 17},
  [931] = {.lex_state = 230, .external_lex_state = 17},
  [932] = {.lex_state = 240, .external_lex_state = 18},
  [933] = {.lex_state = 240, .external_lex_state = 18},
  [934] = {.lex_state = 230, .external_lex_state = 17},
  [935] = {.lex_state = 230, .external_lex_state = 17},
  [936] = {.lex_state = 240, .external_lex_state = 18},
  [937] = {.lex_state = 68},
  [938] = {.lex_state = 230, .external_lex_state = 18},
  [939] = {.lex_state = 230, .external_lex_state = 18},
  [940] = {.lex_state = 158, .external_lex_state = 18},
  [941] = {.lex_state = 158, .external_lex_state = 18},
  [942] = {.lex_state = 171, .external_lex_state = 15},
  [943] = {.lex_state = 171, .external_lex_state = 15},
  [944] = {.lex_state = 232, .external_lex_state = 18},
  [945] = {.lex_state = 68},
  [946] = {.lex_state = 163, .external_lex_state = 26},
  [947] = {.lex_state = 232, .external_lex_state = 26},
  [948] = {.lex_state = 114, .external_lex_state = 9},
  [949] = {.lex_state = 165, .external_lex_state = 25},
  [950] = {.lex_state = 165, .external_lex_state = 6},
  [951] = {.lex_state = 165, .external_lex_state = 13},
  [952] = {.lex_state = 156},
  [953] = {.lex_state = 167, .external_lex_state = 17},
  [954] = {.lex_state = 119},
  [955] = {.lex_state = 171, .external_lex_state = 2},
  [956] = {.lex_state = 68},
  [957] = {.lex_state = 171, .external_lex_state = 2},
  [958] = {.lex_state = 72},
  [959] = {.lex_state = 167, .external_lex_state = 17},
  [960] = {.lex_state = 167, .external_lex_state = 17},
  [961] = {.lex_state = 232, .external_lex_state = 17},
  [962] = {.lex_state = 232, .external_lex_state = 17},
  [963] = {.lex_state = 232, .external_lex_state = 17},
  [964] = {.lex_state = 232, .external_lex_state = 17},
  [965] = {.lex_state = 232, .external_lex_state = 18},
  [966] = {.lex_state = 232, .external_lex_state = 18},
  [967] = {.lex_state = 167, .external_lex_state = 18},
  [968] = {.lex_state = 167, .external_lex_state = 18},
  [969] = {.lex_state = 110, .external_lex_state = 23},
  [970] = {.lex_state = 176, .external_lex_state = 19},
  [971] = {.lex_state = 176, .external_lex_state = 19},
  [972] = {.lex_state = 62},
  [973] = {.lex_state = 151, .external_lex_state = 16},
  [974] = {.lex_state = 154, .external_lex_state = 6},
  [975] = {.lex_state = 151, .external_lex_state = 16},
  [976] = {.lex_state = 151, .external_lex_state = 16},
  [977] = {.lex_state = 127, .external_lex_state = 4},
  [978] = {.lex_state = 176, .external_lex_state = 19},
  [979] = {.lex_state = 199, .external_lex_state = 5},
  [980] = {.lex_state = 199, .external_lex_state = 5},
  [981] = {.lex_state = 234, .external_lex_state = 7},
  [982] = {.lex_state = 199, .external_lex_state = 5},
  [983] = {.lex_state = 127, .external_lex_state = 4},
  [984] = {.lex_state = 199, .external_lex_state = 7},
  [985] = {.lex_state = 62, .external_lex_state = 13},
  [986] = {.lex_state = 62},
  [987] = {.lex_state = 203, .external_lex_state = 11},
  [988] = {.lex_state = 62, .external_lex_state = 13},
  [989] = {.lex_state = 62},
  [990] = {.lex_state = 72},
  [991] = {.lex_state = 236, .external_lex_state = 13},
  [992] = {.lex_state = 236, .external_lex_state = 13},
  [993] = {.lex_state = 90},
  [994] = {.lex_state = 236, .external_lex_state = 13},
  [995] = {.lex_state = 236, .external_lex_state = 13},
  [996] = {.lex_state = 236, .external_lex_state = 13},
  [997] = {.lex_state = 62},
  [998] = {.lex_state = 151, .external_lex_state = 16},
  [999] = {.lex_state = 154, .external_lex_state = 6},
  [1000] = {.lex_state = 151, .external_lex_state = 16},
  [1001] = {.lex_state = 151, .external_lex_state = 16},
  [1002] = {.lex_state = 68},
  [1003] = {.lex_state = 163, .external_lex_state = 2},
  [1004] = {.lex_state = 68},
  [1005] = {.lex_state = 171, .external_lex_state = 2},
  [1006] = {.lex_state = 68},
  [1007] = {.lex_state = 163, .external_lex_state = 2},
  [1008] = {.lex_state = 125, .external_lex_state = 8},
  [1009] = {.lex_state = 163},
  [1010] = {.lex_state = 125, .external_lex_state = 21},
  [1011] = {.lex_state = 110, .external_lex_state = 21},
  [1012] = {.lex_state = 125, .external_lex_state = 21},
  [1013] = {.lex_state = 221, .external_lex_state = 16},
  [1014] = {.lex_state = 125, .external_lex_state = 21},
  [1015] = {.lex_state = 225},
  [1016] = {.lex_state = 223, .external_lex_state = 16},
  [1017] = {.lex_state = 62},
  [1018] = {.lex_state = 151, .external_lex_state = 16},
  [1019] = {.lex_state = 151, .external_lex_state = 16},
  [1020] = {.lex_state = 151, .external_lex_state = 16},
  [1021] = {.lex_state = 125, .external_lex_state = 21},
  [1022] = {.lex_state = 225},
  [1023] = {.lex_state = 223, .external_lex_state = 16},
  [1024] = {.lex_state = 125, .external_lex_state = 21},
  [1025] = {.lex_state = 225},
  [1026] = {.lex_state = 223, .external_lex_state = 16},
  [1027] = {.lex_state = 125, .external_lex_state = 21},
  [1028] = {.lex_state = 125, .external_lex_state = 21},
  [1029] = {.lex_state = 116, .external_lex_state = 10},
  [1030] = {.lex_state = 72},
  [1031] = {.lex_state = 116, .external_lex_state = 4},
  [1032] = {.lex_state = 127, .external_lex_state = 4},
  [1033] = {.lex_state = 56, .external_lex_state = 2},
  [1034] = {.lex_state = 234, .external_lex_state = 7},
  [1035] = {.lex_state = 56, .external_lex_state = 2},
  [1036] = {.lex_state = 127, .external_lex_state = 4},
  [1037] = {.lex_state = 72},
  [1038] = {.lex_state = 56, .external_lex_state = 2},
  [1039] = {.lex_state = 127, .external_lex_state = 4},
  [1040] = {.lex_state = 72},
  [1041] = {.lex_state = 56, .external_lex_state = 2},
  [1042] = {.lex_state = 72},
  [1043] = {.lex_state = 72},
  [1044] = {.lex_state = 127, .external_lex_state = 4},
  [1045] = {.lex_state = 242, .external_lex_state = 13},
  [1046] = {.lex_state = 242, .external_lex_state = 13},
  [1047] = {.lex_state = 72},
  [1048] = {.lex_state = 242},
  [1049] = {.lex_state = 72},
  [1050] = {.lex_state = 72},
  [1051] = {.lex_state = 127, .external_lex_state = 4},
  [1052] = {.lex_state = 72},
  [1053] = {.lex_state = 72},
  [1054] = {.lex_state = 72},
  [1055] = {.lex_state = 116, .external_lex_state = 10},
  [1056] = {.lex_state = 205, .external_lex_state = 24},
  [1057] = {.lex_state = 205, .external_lex_state = 24},
  [1058] = {.lex_state = 205, .external_lex_state = 16},
  [1059] = {.lex_state = 223, .external_lex_state = 16},
  [1060] = {.lex_state = 116, .external_lex_state = 10},
  [1061] = {.lex_state = 221, .external_lex_state = 16},
  [1062] = {.lex_state = 116, .external_lex_state = 10},
  [1063] = {.lex_state = 225},
  [1064] = {.lex_state = 223, .external_lex_state = 16},
  [1065] = {.lex_state = 116, .external_lex_state = 10},
  [1066] = {.lex_state = 225},
  [1067] = {.lex_state = 223, .external_lex_state = 16},
  [1068] = {.lex_state = 225},
  [1069] = {.lex_state = 223, .external_lex_state = 16},
  [1070] = {.lex_state = 223, .external_lex_state = 16},
  [1071] = {.lex_state = 116, .external_lex_state = 10},
  [1072] = {.lex_state = 223, .external_lex_state = 16},
  [1073] = {.lex_state = 110, .external_lex_state = 23},
  [1074] = {.lex_state = 205, .external_lex_state = 22},
  [1075] = {.lex_state = 125, .external_lex_state = 23},
  [1076] = {.lex_state = 205, .external_lex_state = 22},
  [1077] = {.lex_state = 72},
  [1078] = {.lex_state = 245, .external_lex_state = 10},
  [1079] = {.lex_state = 245, .external_lex_state = 10},
  [1080] = {.lex_state = 127, .external_lex_state = 4},
  [1081] = {.lex_state = 125, .external_lex_state = 21},
  [1082] = {.lex_state = 209, .external_lex_state = 7},
  [1083] = {.lex_state = 119},
  [1084] = {.lex_state = 56},
  [1085] = {.lex_state = 72},
  [1086] = {.lex_state = 56},
  [1087] = {.lex_state = 72},
  [1088] = {.lex_state = 72},
  [1089] = {.lex_state = 209, .external_lex_state = 23},
  [1090] = {.lex_state = 121, .external_lex_state = 14},
  [1091] = {.lex_state = 121, .external_lex_state = 14},
  [1092] = {.lex_state = 121, .external_lex_state = 14},
  [1093] = {.lex_state = 121, .external_lex_state = 10},
  [1094] = {.lex_state = 125, .external_lex_state = 23},
  [1095] = {.lex_state = 209, .external_lex_state = 5},
  [1096] = {.lex_state = 209, .external_lex_state = 5},
  [1097] = {.lex_state = 209, .external_lex_state = 5},
  [1098] = {.lex_state = 127, .external_lex_state = 4},
  [1099] = {.lex_state = 209, .external_lex_state = 7},
  [1100] = {.lex_state = 163, .external_lex_state = 2},
  [1101] = {.lex_state = 163},
  [1102] = {.lex_state = 211, .external_lex_state = 13},
  [1103] = {.lex_state = 129, .external_lex_state = 11},
  [1104] = {.lex_state = 205, .external_lex_state = 24},
  [1105] = {.lex_state = 205, .external_lex_state = 24},
  [1106] = {.lex_state = 205, .external_lex_state = 16},
  [1107] = {.lex_state = 223, .external_lex_state = 16},
  [1108] = {.lex_state = 129, .external_lex_state = 11},
  [1109] = {.lex_state = 221, .external_lex_state = 16},
  [1110] = {.lex_state = 129, .external_lex_state = 11},
  [1111] = {.lex_state = 225},
  [1112] = {.lex_state = 223, .external_lex_state = 16},
  [1113] = {.lex_state = 129, .external_lex_state = 11},
  [1114] = {.lex_state = 225},
  [1115] = {.lex_state = 223, .external_lex_state = 16},
  [1116] = {.lex_state = 225},
  [1117] = {.lex_state = 223, .external_lex_state = 16},
  [1118] = {.lex_state = 223, .external_lex_state = 16},
  [1119] = {.lex_state = 129, .external_lex_state = 11},
  [1120] = {.lex_state = 223, .external_lex_state = 16},
  [1121] = {.lex_state = 72},
  [1122] = {.lex_state = 199, .external_lex_state = 27},
  [1123] = {.lex_state = 90},
  [1124] = {.lex_state = 97},
  [1125] = {.lex_state = 199, .external_lex_state = 27},
  [1126] = {.lex_state = 97, .external_lex_state = 6},
  [1127] = {.lex_state = 56, .external_lex_state = 2},
  [1128] = {.lex_state = 56, .external_lex_state = 2},
  [1129] = {.lex_state = 56, .external_lex_state = 2},
  [1130] = {.lex_state = 234, .external_lex_state = 23},
  [1131] = {.lex_state = 234, .external_lex_state = 23},
  [1132] = {.lex_state = 199, .external_lex_state = 27},
  [1133] = {.lex_state = 199, .external_lex_state = 27},
  [1134] = {.lex_state = 234, .external_lex_state = 23},
  [1135] = {.lex_state = 199, .external_lex_state = 23},
  [1136] = {.lex_state = 218, .external_lex_state = 13},
  [1137] = {.lex_state = 205, .external_lex_state = 24},
  [1138] = {.lex_state = 205, .external_lex_state = 24},
  [1139] = {.lex_state = 205, .external_lex_state = 16},
  [1140] = {.lex_state = 223, .external_lex_state = 16},
  [1141] = {.lex_state = 218, .external_lex_state = 13},
  [1142] = {.lex_state = 221, .external_lex_state = 16},
  [1143] = {.lex_state = 218, .external_lex_state = 13},
  [1144] = {.lex_state = 225},
  [1145] = {.lex_state = 223, .external_lex_state = 16},
  [1146] = {.lex_state = 218, .external_lex_state = 13},
  [1147] = {.lex_state = 225},
  [1148] = {.lex_state = 223, .external_lex_state = 16},
  [1149] = {.lex_state = 225},
  [1150] = {.lex_state = 223, .external_lex_state = 16},
  [1151] = {.lex_state = 223, .external_lex_state = 16},
  [1152] = {.lex_state = 218, .external_lex_state = 13},
  [1153] = {.lex_state = 223, .external_lex_state = 16},
  [1154] = {.lex_state = 121, .external_lex_state = 3},
  [1155] = {.lex_state = 163},
  [1156] = {.lex_state = 121, .external_lex_state = 14},
  [1157] = {.lex_state = 205, .external_lex_state = 24},
  [1158] = {.lex_state = 205, .external_lex_state = 24},
  [1159] = {.lex_state = 205, .external_lex_state = 16},
  [1160] = {.lex_state = 223, .external_lex_state = 16},
  [1161] = {.lex_state = 121, .external_lex_state = 14},
  [1162] = {.lex_state = 221, .external_lex_state = 16},
  [1163] = {.lex_state = 121, .external_lex_state = 14},
  [1164] = {.lex_state = 225},
  [1165] = {.lex_state = 223, .external_lex_state = 16},
  [1166] = {.lex_state = 121, .external_lex_state = 14},
  [1167] = {.lex_state = 225},
  [1168] = {.lex_state = 223, .external_lex_state = 16},
  [1169] = {.lex_state = 225},
  [1170] = {.lex_state = 223, .external_lex_state = 16},
  [1171] = {.lex_state = 223, .external_lex_state = 16},
  [1172] = {.lex_state = 121, .external_lex_state = 14},
  [1173] = {.lex_state = 223, .external_lex_state = 16},
  [1174] = {.lex_state = 121, .external_lex_state = 10},
  [1175] = {.lex_state = 205, .external_lex_state = 24},
  [1176] = {.lex_state = 205, .external_lex_state = 24},
  [1177] = {.lex_state = 205, .external_lex_state = 16},
  [1178] = {.lex_state = 223, .external_lex_state = 16},
  [1179] = {.lex_state = 121, .external_lex_state = 10},
  [1180] = {.lex_state = 221, .external_lex_state = 16},
  [1181] = {.lex_state = 121, .external_lex_state = 10},
  [1182] = {.lex_state = 225},
  [1183] = {.lex_state = 223, .external_lex_state = 16},
  [1184] = {.lex_state = 121, .external_lex_state = 10},
  [1185] = {.lex_state = 225},
  [1186] = {.lex_state = 223, .external_lex_state = 16},
  [1187] = {.lex_state = 225},
  [1188] = {.lex_state = 223, .external_lex_state = 16},
  [1189] = {.lex_state = 223, .external_lex_state = 16},
  [1190] = {.lex_state = 121, .external_lex_state = 10},
  [1191] = {.lex_state = 223, .external_lex_state = 16},
  [1192] = {.lex_state = 163, .external_lex_state = 15},
  [1193] = {.lex_state = 205, .external_lex_state = 24},
  [1194] = {.lex_state = 205, .external_lex_state = 24},
  [1195] = {.lex_state = 205, .external_lex_state = 16},
  [1196] = {.lex_state = 223, .external_lex_state = 16},
  [1197] = {.lex_state = 163, .external_lex_state = 15},
  [1198] = {.lex_state = 221, .external_lex_state = 16},
  [1199] = {.lex_state = 163, .external_lex_state = 15},
  [1200] = {.lex_state = 225},
  [1201] = {.lex_state = 223, .external_lex_state = 16},
  [1202] = {.lex_state = 163, .external_lex_state = 15},
  [1203] = {.lex_state = 225},
  [1204] = {.lex_state = 223, .external_lex_state = 16},
  [1205] = {.lex_state = 225},
  [1206] = {.lex_state = 223, .external_lex_state = 16},
  [1207] = {.lex_state = 223, .external_lex_state = 16},
  [1208] = {.lex_state = 163, .external_lex_state = 15},
  [1209] = {.lex_state = 223, .external_lex_state = 16},
  [1210] = {.lex_state = 90, .external_lex_state = 13},
  [1211] = {.lex_state = 205, .external_lex_state = 24},
  [1212] = {.lex_state = 205, .external_lex_state = 24},
  [1213] = {.lex_state = 205, .external_lex_state = 16},
  [1214] = {.lex_state = 223, .external_lex_state = 16},
  [1215] = {.lex_state = 90, .external_lex_state = 13},
  [1216] = {.lex_state = 221, .external_lex_state = 16},
  [1217] = {.lex_state = 90, .external_lex_state = 13},
  [1218] = {.lex_state = 225},
  [1219] = {.lex_state = 223, .external_lex_state = 16},
  [1220] = {.lex_state = 90, .external_lex_state = 13},
  [1221] = {.lex_state = 225},
  [1222] = {.lex_state = 223, .external_lex_state = 16},
  [1223] = {.lex_state = 225},
  [1224] = {.lex_state = 223, .external_lex_state = 16},
  [1225] = {.lex_state = 223, .external_lex_state = 16},
  [1226] = {.lex_state = 90, .external_lex_state = 13},
  [1227] = {.lex_state = 223, .external_lex_state = 16},
  [1228] = {.lex_state = 203, .external_lex_state = 12},
  [1229] = {.lex_state = 151, .external_lex_state = 24},
  [1230] = {.lex_state = 203, .external_lex_state = 12},
  [1231] = {.lex_state = 151, .external_lex_state = 24},
  [1232] = {.lex_state = 129, .external_lex_state = 12},
  [1233] = {.lex_state = 72},
  [1234] = {.lex_state = 112, .external_lex_state = 5},
  [1235] = {.lex_state = 205, .external_lex_state = 24},
  [1236] = {.lex_state = 205, .external_lex_state = 24},
  [1237] = {.lex_state = 90},
  [1238] = {.lex_state = 205, .external_lex_state = 24},
  [1239] = {.lex_state = 205, .external_lex_state = 24},
  [1240] = {.lex_state = 205, .external_lex_state = 24},
  [1241] = {.lex_state = 112, .external_lex_state = 5},
  [1242] = {.lex_state = 62},
  [1243] = {.lex_state = 151, .external_lex_state = 16},
  [1244] = {.lex_state = 154, .external_lex_state = 6},
  [1245] = {.lex_state = 151, .external_lex_state = 16},
  [1246] = {.lex_state = 151, .external_lex_state = 16},
  [1247] = {.lex_state = 68},
  [1248] = {.lex_state = 163, .external_lex_state = 2},
  [1249] = {.lex_state = 68},
  [1250] = {.lex_state = 171, .external_lex_state = 2},
  [1251] = {.lex_state = 68},
  [1252] = {.lex_state = 163, .external_lex_state = 2},
  [1253] = {.lex_state = 223, .external_lex_state = 24},
  [1254] = {.lex_state = 223, .external_lex_state = 24},
  [1255] = {.lex_state = 223, .external_lex_state = 24},
  [1256] = {.lex_state = 221, .external_lex_state = 16},
  [1257] = {.lex_state = 223, .external_lex_state = 24},
  [1258] = {.lex_state = 225},
  [1259] = {.lex_state = 223, .external_lex_state = 16},
  [1260] = {.lex_state = 62},
  [1261] = {.lex_state = 151, .external_lex_state = 16},
  [1262] = {.lex_state = 151, .external_lex_state = 16},
  [1263] = {.lex_state = 151, .external_lex_state = 16},
  [1264] = {.lex_state = 223, .external_lex_state = 24},
  [1265] = {.lex_state = 225},
  [1266] = {.lex_state = 223, .external_lex_state = 16},
  [1267] = {.lex_state = 223, .external_lex_state = 24},
  [1268] = {.lex_state = 225},
  [1269] = {.lex_state = 223, .external_lex_state = 16},
  [1270] = {.lex_state = 112, .external_lex_state = 5},
  [1271] = {.lex_state = 223, .external_lex_state = 16},
  [1272] = {.lex_state = 223, .external_lex_state = 24},
  [1273] = {.lex_state = 223, .external_lex_state = 24},
  [1274] = {.lex_state = 205, .external_lex_state = 24},
  [1275] = {.lex_state = 205, .external_lex_state = 24},
  [1276] = {.lex_state = 205, .external_lex_state = 16},
  [1277] = {.lex_state = 223, .external_lex_state = 16},
  [1278] = {.lex_state = 112, .external_lex_state = 5},
  [1279] = {.lex_state = 223, .external_lex_state = 16},
  [1280] = {.lex_state = 112, .external_lex_state = 5},
  [1281] = {.lex_state = 223, .external_lex_state = 16},
  [1282] = {.lex_state = 112, .external_lex_state = 5},
  [1283] = {.lex_state = 223, .external_lex_state = 16},
  [1284] = {.lex_state = 112, .external_lex_state = 5},
  [1285] = {.lex_state = 223, .external_lex_state = 16},
  [1286] = {.lex_state = 163, .external_lex_state = 15},
  [1287] = {.lex_state = 116, .external_lex_state = 4},
  [1288] = {.lex_state = 56, .external_lex_state = 2},
  [1289] = {.lex_state = 68},
  [1290] = {.lex_state = 240, .external_lex_state = 18},
  [1291] = {.lex_state = 56, .external_lex_state = 2},
  [1292] = {.lex_state = 68},
  [1293] = {.lex_state = 230, .external_lex_state = 18},
  [1294] = {.lex_state = 68},
  [1295] = {.lex_state = 72},
  [1296] = {.lex_state = 56, .external_lex_state = 2},
  [1297] = {.lex_state = 72},
  [1298] = {.lex_state = 72},
  [1299] = {.lex_state = 116, .external_lex_state = 4},
  [1300] = {.lex_state = 72},
  [1301] = {.lex_state = 116, .external_lex_state = 4},
  [1302] = {.lex_state = 119},
  [1303] = {.lex_state = 163, .external_lex_state = 26},
  [1304] = {.lex_state = 205, .external_lex_state = 22},
  [1305] = {.lex_state = 56},
  [1306] = {.lex_state = 72},
  [1307] = {.lex_state = 68},
  [1308] = {.lex_state = 68},
  [1309] = {.lex_state = 207, .external_lex_state = 2},
  [1310] = {.lex_state = 56},
  [1311] = {.lex_state = 72},
  [1312] = {.lex_state = 56, .external_lex_state = 20},
  [1313] = {.lex_state = 72},
  [1314] = {.lex_state = 230, .external_lex_state = 26},
  [1315] = {.lex_state = 156, .external_lex_state = 6},
  [1316] = {.lex_state = 163},
  [1317] = {.lex_state = 156, .external_lex_state = 25},
  [1318] = {.lex_state = 156, .external_lex_state = 25},
  [1319] = {.lex_state = 156, .external_lex_state = 25},
  [1320] = {.lex_state = 156, .external_lex_state = 25},
  [1321] = {.lex_state = 156, .external_lex_state = 25},
  [1322] = {.lex_state = 221, .external_lex_state = 16},
  [1323] = {.lex_state = 156, .external_lex_state = 25},
  [1324] = {.lex_state = 225},
  [1325] = {.lex_state = 223, .external_lex_state = 16},
  [1326] = {.lex_state = 62},
  [1327] = {.lex_state = 151, .external_lex_state = 16},
  [1328] = {.lex_state = 151, .external_lex_state = 16},
  [1329] = {.lex_state = 151, .external_lex_state = 16},
  [1330] = {.lex_state = 156, .external_lex_state = 25},
  [1331] = {.lex_state = 225},
  [1332] = {.lex_state = 223, .external_lex_state = 16},
  [1333] = {.lex_state = 156, .external_lex_state = 25},
  [1334] = {.lex_state = 225},
  [1335] = {.lex_state = 223, .external_lex_state = 16},
  [1336] = {.lex_state = 156, .external_lex_state = 25},
  [1337] = {.lex_state = 156, .external_lex_state = 25},
  [1338] = {.lex_state = 156, .external_lex_state = 13},
  [1339] = {.lex_state = 156, .external_lex_state = 13},
  [1340] = {.lex_state = 156, .external_lex_state = 13},
  [1341] = {.lex_state = 221, .external_lex_state = 16},
  [1342] = {.lex_state = 156, .external_lex_state = 13},
  [1343] = {.lex_state = 225},
  [1344] = {.lex_state = 223, .external_lex_state = 16},
  [1345] = {.lex_state = 62},
  [1346] = {.lex_state = 151, .external_lex_state = 16},
  [1347] = {.lex_state = 151, .external_lex_state = 16},
  [1348] = {.lex_state = 151, .external_lex_state = 16},
  [1349] = {.lex_state = 156, .external_lex_state = 13},
  [1350] = {.lex_state = 225},
  [1351] = {.lex_state = 223, .external_lex_state = 16},
  [1352] = {.lex_state = 156, .external_lex_state = 13},
  [1353] = {.lex_state = 225},
  [1354] = {.lex_state = 223, .external_lex_state = 16},
  [1355] = {.lex_state = 156, .external_lex_state = 13},
  [1356] = {.lex_state = 156, .external_lex_state = 13},
  [1357] = {.lex_state = 158, .external_lex_state = 17},
  [1358] = {.lex_state = 205, .external_lex_state = 24},
  [1359] = {.lex_state = 205, .external_lex_state = 24},
  [1360] = {.lex_state = 205, .external_lex_state = 16},
  [1361] = {.lex_state = 223, .external_lex_state = 16},
  [1362] = {.lex_state = 158, .external_lex_state = 17},
  [1363] = {.lex_state = 221, .external_lex_state = 16},
  [1364] = {.lex_state = 158, .external_lex_state = 17},
  [1365] = {.lex_state = 225},
  [1366] = {.lex_state = 223, .external_lex_state = 16},
  [1367] = {.lex_state = 158, .external_lex_state = 17},
  [1368] = {.lex_state = 225},
  [1369] = {.lex_state = 223, .external_lex_state = 16},
  [1370] = {.lex_state = 225},
  [1371] = {.lex_state = 223, .external_lex_state = 16},
  [1372] = {.lex_state = 223, .external_lex_state = 16},
  [1373] = {.lex_state = 158, .external_lex_state = 17},
  [1374] = {.lex_state = 223, .external_lex_state = 16},
  [1375] = {.lex_state = 163, .external_lex_state = 26},
  [1376] = {.lex_state = 68},
  [1377] = {.lex_state = 230, .external_lex_state = 17},
  [1378] = {.lex_state = 230, .external_lex_state = 17},
  [1379] = {.lex_state = 240, .external_lex_state = 18},
  [1380] = {.lex_state = 230, .external_lex_state = 17},
  [1381] = {.lex_state = 68},
  [1382] = {.lex_state = 230, .external_lex_state = 18},
  [1383] = {.lex_state = 171, .external_lex_state = 15},
  [1384] = {.lex_state = 232, .external_lex_state = 18},
  [1385] = {.lex_state = 119},
  [1386] = {.lex_state = 56},
  [1387] = {.lex_state = 72},
  [1388] = {.lex_state = 56},
  [1389] = {.lex_state = 72},
  [1390] = {.lex_state = 72},
  [1391] = {.lex_state = 232, .external_lex_state = 26},
  [1392] = {.lex_state = 165, .external_lex_state = 25},
  [1393] = {.lex_state = 165, .external_lex_state = 25},
  [1394] = {.lex_state = 165, .external_lex_state = 25},
  [1395] = {.lex_state = 165, .external_lex_state = 13},
  [1396] = {.lex_state = 163, .external_lex_state = 26},
  [1397] = {.lex_state = 232, .external_lex_state = 17},
  [1398] = {.lex_state = 232, .external_lex_state = 17},
  [1399] = {.lex_state = 232, .external_lex_state = 17},
  [1400] = {.lex_state = 232, .external_lex_state = 18},
  [1401] = {.lex_state = 127, .external_lex_state = 4},
  [1402] = {.lex_state = 221, .external_lex_state = 16},
  [1403] = {.lex_state = 176, .external_lex_state = 19},
  [1404] = {.lex_state = 225},
  [1405] = {.lex_state = 223, .external_lex_state = 16},
  [1406] = {.lex_state = 62},
  [1407] = {.lex_state = 151, .external_lex_state = 16},
  [1408] = {.lex_state = 151, .external_lex_state = 16},
  [1409] = {.lex_state = 151, .external_lex_state = 16},
  [1410] = {.lex_state = 176, .external_lex_state = 19},
  [1411] = {.lex_state = 225},
  [1412] = {.lex_state = 223, .external_lex_state = 16},
  [1413] = {.lex_state = 176, .external_lex_state = 19},
  [1414] = {.lex_state = 225},
  [1415] = {.lex_state = 223, .external_lex_state = 16},
  [1416] = {.lex_state = 199, .external_lex_state = 5},
  [1417] = {.lex_state = 127, .external_lex_state = 4},
  [1418] = {.lex_state = 62},
  [1419] = {.lex_state = 62},
  [1420] = {.lex_state = 236, .external_lex_state = 13},
  [1421] = {.lex_state = 236, .external_lex_state = 13},
  [1422] = {.lex_state = 236, .external_lex_state = 13},
  [1423] = {.lex_state = 221, .external_lex_state = 16},
  [1424] = {.lex_state = 236, .external_lex_state = 13},
  [1425] = {.lex_state = 225},
  [1426] = {.lex_state = 223, .external_lex_state = 16},
  [1427] = {.lex_state = 62},
  [1428] = {.lex_state = 151, .external_lex_state = 16},
  [1429] = {.lex_state = 151, .external_lex_state = 16},
  [1430] = {.lex_state = 151, .external_lex_state = 16},
  [1431] = {.lex_state = 236, .external_lex_state = 13},
  [1432] = {.lex_state = 225},
  [1433] = {.lex_state = 223, .external_lex_state = 16},
  [1434] = {.lex_state = 236, .external_lex_state = 13},
  [1435] = {.lex_state = 225},
  [1436] = {.lex_state = 223, .external_lex_state = 16},
  [1437] = {.lex_state = 236, .external_lex_state = 13},
  [1438] = {.lex_state = 236, .external_lex_state = 13},
  [1439] = {.lex_state = 125, .external_lex_state = 21},
  [1440] = {.lex_state = 205, .external_lex_state = 24},
  [1441] = {.lex_state = 205, .external_lex_state = 24},
  [1442] = {.lex_state = 205, .external_lex_state = 16},
  [1443] = {.lex_state = 223, .external_lex_state = 16},
  [1444] = {.lex_state = 125, .external_lex_state = 21},
  [1445] = {.lex_state = 221, .external_lex_state = 16},
  [1446] = {.lex_state = 125, .external_lex_state = 21},
  [1447] = {.lex_state = 225},
  [1448] = {.lex_state = 223, .external_lex_state = 16},
  [1449] = {.lex_state = 125, .external_lex_state = 21},
  [1450] = {.lex_state = 225},
  [1451] = {.lex_state = 223, .external_lex_state = 16},
  [1452] = {.lex_state = 225},
  [1453] = {.lex_state = 223, .external_lex_state = 16},
  [1454] = {.lex_state = 223, .external_lex_state = 16},
  [1455] = {.lex_state = 125, .external_lex_state = 21},
  [1456] = {.lex_state = 223, .external_lex_state = 16},
  [1457] = {.lex_state = 116, .external_lex_state = 10},
  [1458] = {.lex_state = 127, .external_lex_state = 4},
  [1459] = {.lex_state = 127, .external_lex_state = 4},
  [1460] = {.lex_state = 56, .external_lex_state = 2},
  [1461] = {.lex_state = 56, .external_lex_state = 2},
  [1462] = {.lex_state = 127, .external_lex_state = 4},
  [1463] = {.lex_state = 72},
  [1464] = {.lex_state = 72},
  [1465] = {.lex_state = 173, .external_lex_state = 2},
  [1466] = {.lex_state = 242},
  [1467] = {.lex_state = 242, .external_lex_state = 13},
  [1468] = {.lex_state = 173, .external_lex_state = 2},
  [1469] = {.lex_state = 242},
  [1470] = {.lex_state = 127, .external_lex_state = 4},
  [1471] = {.lex_state = 72},
  [1472] = {.lex_state = 72},
  [1473] = {.lex_state = 127, .external_lex_state = 4},
  [1474] = {.lex_state = 72},
  [1475] = {.lex_state = 127, .external_lex_state = 4},
  [1476] = {.lex_state = 72},
  [1477] = {.lex_state = 127, .external_lex_state = 4},
  [1478] = {.lex_state = 72},
  [1479] = {.lex_state = 116, .external_lex_state = 10},
  [1480] = {.lex_state = 116, .external_lex_state = 10},
  [1481] = {.lex_state = 116, .external_lex_state = 10},
  [1482] = {.lex_state = 223, .external_lex_state = 16},
  [1483] = {.lex_state = 205, .external_lex_state = 24},
  [1484] = {.lex_state = 205, .external_lex_state = 24},
  [1485] = {.lex_state = 205, .external_lex_state = 16},
  [1486] = {.lex_state = 223, .external_lex_state = 16},
  [1487] = {.lex_state = 116, .external_lex_state = 10},
  [1488] = {.lex_state = 223, .external_lex_state = 16},
  [1489] = {.lex_state = 116, .external_lex_state = 10},
  [1490] = {.lex_state = 223, .external_lex_state = 16},
  [1491] = {.lex_state = 116, .external_lex_state = 10},
  [1492] = {.lex_state = 223, .external_lex_state = 16},
  [1493] = {.lex_state = 116, .external_lex_state = 10},
  [1494] = {.lex_state = 223, .external_lex_state = 16},
  [1495] = {.lex_state = 127, .external_lex_state = 4},
  [1496] = {.lex_state = 245, .external_lex_state = 10},
  [1497] = {.lex_state = 245, .external_lex_state = 10},
  [1498] = {.lex_state = 127, .external_lex_state = 4},
  [1499] = {.lex_state = 245, .external_lex_state = 10},
  [1500] = {.lex_state = 125, .external_lex_state = 21},
  [1501] = {.lex_state = 125, .external_lex_state = 23},
  [1502] = {.lex_state = 72},
  [1503] = {.lex_state = 127, .external_lex_state = 10},
  [1504] = {.lex_state = 127, .external_lex_state = 10},
  [1505] = {.lex_state = 72},
  [1506] = {.lex_state = 209, .external_lex_state = 27},
  [1507] = {.lex_state = 209, .external_lex_state = 27},
  [1508] = {.lex_state = 209, .external_lex_state = 27},
  [1509] = {.lex_state = 209, .external_lex_state = 27},
  [1510] = {.lex_state = 209, .external_lex_state = 23},
  [1511] = {.lex_state = 209, .external_lex_state = 5},
  [1512] = {.lex_state = 163, .external_lex_state = 2},
  [1513] = {.lex_state = 129, .external_lex_state = 11},
  [1514] = {.lex_state = 129, .external_lex_state = 11},
  [1515] = {.lex_state = 129, .external_lex_state = 11},
  [1516] = {.lex_state = 223, .external_lex_state = 16},
  [1517] = {.lex_state = 205, .external_lex_state = 24},
  [1518] = {.lex_state = 205, .external_lex_state = 24},
  [1519] = {.lex_state = 205, .external_lex_state = 16},
  [1520] = {.lex_state = 223, .external_lex_state = 16},
  [1521] = {.lex_state = 129, .external_lex_state = 11},
  [1522] = {.lex_state = 223, .external_lex_state = 16},
  [1523] = {.lex_state = 129, .external_lex_state = 11},
  [1524] = {.lex_state = 223, .external_lex_state = 16},
  [1525] = {.lex_state = 129, .external_lex_state = 11},
  [1526] = {.lex_state = 223, .external_lex_state = 16},
  [1527] = {.lex_state = 129, .external_lex_state = 11},
  [1528] = {.lex_state = 223, .external_lex_state = 16},
  [1529] = {.lex_state = 199, .external_lex_state = 27},
  [1530] = {.lex_state = 199, .external_lex_state = 27},
  [1531] = {.lex_state = 234, .external_lex_state = 23},
  [1532] = {.lex_state = 72},
  [1533] = {.lex_state = 199, .external_lex_state = 27},
  [1534] = {.lex_state = 234, .external_lex_state = 27},
  [1535] = {.lex_state = 90},
  [1536] = {.lex_state = 234, .external_lex_state = 27},
  [1537] = {.lex_state = 234, .external_lex_state = 27},
  [1538] = {.lex_state = 234, .external_lex_state = 27},
  [1539] = {.lex_state = 62},
  [1540] = {.lex_state = 151, .external_lex_state = 16},
  [1541] = {.lex_state = 154, .external_lex_state = 6},
  [1542] = {.lex_state = 151, .external_lex_state = 16},
  [1543] = {.lex_state = 151, .external_lex_state = 16},
  [1544] = {.lex_state = 68},
  [1545] = {.lex_state = 163, .external_lex_state = 2},
  [1546] = {.lex_state = 68},
  [1547] = {.lex_state = 171, .external_lex_state = 2},
  [1548] = {.lex_state = 68},
  [1549] = {.lex_state = 163, .external_lex_state = 2},
  [1550] = {.lex_state = 218, .external_lex_state = 13},
  [1551] = {.lex_state = 218, .external_lex_state = 13},
  [1552] = {.lex_state = 218, .external_lex_state = 13},
  [1553] = {.lex_state = 223, .external_lex_state = 16},
  [1554] = {.lex_state = 205, .external_lex_state = 24},
  [1555] = {.lex_state = 205, .external_lex_state = 24},
  [1556] = {.lex_state = 205, .external_lex_state = 16},
  [1557] = {.lex_state = 223, .external_lex_state = 16},
  [1558] = {.lex_state = 218, .external_lex_state = 13},
  [1559] = {.lex_state = 223, .external_lex_state = 16},
  [1560] = {.lex_state = 218, .external_lex_state = 13},
  [1561] = {.lex_state = 223, .external_lex_state = 16},
  [1562] = {.lex_state = 218, .external_lex_state = 13},
  [1563] = {.lex_state = 223, .external_lex_state = 16},
  [1564] = {.lex_state = 218, .external_lex_state = 13},
  [1565] = {.lex_state = 223, .external_lex_state = 16},
  [1566] = {.lex_state = 121, .external_lex_state = 3},
  [1567] = {.lex_state = 121, .external_lex_state = 14},
  [1568] = {.lex_state = 121, .external_lex_state = 14},
  [1569] = {.lex_state = 121, .external_lex_state = 14},
  [1570] = {.lex_state = 223, .external_lex_state = 16},
  [1571] = {.lex_state = 205, .external_lex_state = 24},
  [1572] = {.lex_state = 205, .external_lex_state = 24},
  [1573] = {.lex_state = 205, .external_lex_state = 16},
  [1574] = {.lex_state = 223, .external_lex_state = 16},
  [1575] = {.lex_state = 121, .external_lex_state = 14},
  [1576] = {.lex_state = 223, .external_lex_state = 16},
  [1577] = {.lex_state = 121, .external_lex_state = 14},
  [1578] = {.lex_state = 223, .external_lex_state = 16},
  [1579] = {.lex_state = 121, .external_lex_state = 14},
  [1580] = {.lex_state = 223, .external_lex_state = 16},
  [1581] = {.lex_state = 121, .external_lex_state = 14},
  [1582] = {.lex_state = 223, .external_lex_state = 16},
  [1583] = {.lex_state = 121, .external_lex_state = 10},
  [1584] = {.lex_state = 121, .external_lex_state = 10},
  [1585] = {.lex_state = 121, .external_lex_state = 10},
  [1586] = {.lex_state = 223, .external_lex_state = 16},
  [1587] = {.lex_state = 205, .external_lex_state = 24},
  [1588] = {.lex_state = 205, .external_lex_state = 24},
  [1589] = {.lex_state = 205, .external_lex_state = 16},
  [1590] = {.lex_state = 223, .external_lex_state = 16},
  [1591] = {.lex_state = 121, .external_lex_state = 10},
  [1592] = {.lex_state = 223, .external_lex_state = 16},
  [1593] = {.lex_state = 121, .external_lex_state = 10},
  [1594] = {.lex_state = 223, .external_lex_state = 16},
  [1595] = {.lex_state = 121, .external_lex_state = 10},
  [1596] = {.lex_state = 223, .external_lex_state = 16},
  [1597] = {.lex_state = 121, .external_lex_state = 10},
  [1598] = {.lex_state = 223, .external_lex_state = 16},
  [1599] = {.lex_state = 163, .external_lex_state = 15},
  [1600] = {.lex_state = 163, .external_lex_state = 15},
  [1601] = {.lex_state = 163, .external_lex_state = 15},
  [1602] = {.lex_state = 223, .external_lex_state = 16},
  [1603] = {.lex_state = 205, .external_lex_state = 24},
  [1604] = {.lex_state = 205, .external_lex_state = 24},
  [1605] = {.lex_state = 205, .external_lex_state = 16},
  [1606] = {.lex_state = 223, .external_lex_state = 16},
  [1607] = {.lex_state = 163, .external_lex_state = 15},
  [1608] = {.lex_state = 223, .external_lex_state = 16},
  [1609] = {.lex_state = 163, .external_lex_state = 15},
  [1610] = {.lex_state = 223, .external_lex_state = 16},
  [1611] = {.lex_state = 163, .external_lex_state = 15},
  [1612] = {.lex_state = 223, .external_lex_state = 16},
  [1613] = {.lex_state = 163, .external_lex_state = 15},
  [1614] = {.lex_state = 223, .external_lex_state = 16},
  [1615] = {.lex_state = 90, .external_lex_state = 13},
  [1616] = {.lex_state = 90, .external_lex_state = 13},
  [1617] = {.lex_state = 90, .external_lex_state = 13},
  [1618] = {.lex_state = 223, .external_lex_state = 16},
  [1619] = {.lex_state = 205, .external_lex_state = 24},
  [1620] = {.lex_state = 205, .external_lex_state = 24},
  [1621] = {.lex_state = 205, .external_lex_state = 16},
  [1622] = {.lex_state = 223, .external_lex_state = 16},
  [1623] = {.lex_state = 90, .external_lex_state = 13},
  [1624] = {.lex_state = 223, .external_lex_state = 16},
  [1625] = {.lex_state = 90, .external_lex_state = 13},
  [1626] = {.lex_state = 223, .external_lex_state = 16},
  [1627] = {.lex_state = 90, .external_lex_state = 13},
  [1628] = {.lex_state = 223, .external_lex_state = 16},
  [1629] = {.lex_state = 90, .external_lex_state = 13},
  [1630] = {.lex_state = 223, .external_lex_state = 16},
  [1631] = {.lex_state = 151, .external_lex_state = 24},
  [1632] = {.lex_state = 151, .external_lex_state = 16},
  [1633] = {.lex_state = 151, .external_lex_state = 24},
  [1634] = {.lex_state = 151, .external_lex_state = 16},
  [1635] = {.lex_state = 205, .external_lex_state = 24},
  [1636] = {.lex_state = 205, .external_lex_state = 24},
  [1637] = {.lex_state = 205, .external_lex_state = 24},
  [1638] = {.lex_state = 221, .external_lex_state = 16},
  [1639] = {.lex_state = 205, .external_lex_state = 24},
  [1640] = {.lex_state = 225},
  [1641] = {.lex_state = 223, .external_lex_state = 16},
  [1642] = {.lex_state = 62},
  [1643] = {.lex_state = 151, .external_lex_state = 16},
  [1644] = {.lex_state = 151, .external_lex_state = 16},
  [1645] = {.lex_state = 151, .external_lex_state = 16},
  [1646] = {.lex_state = 205, .external_lex_state = 24},
  [1647] = {.lex_state = 225},
  [1648] = {.lex_state = 223, .external_lex_state = 16},
  [1649] = {.lex_state = 205, .external_lex_state = 24},
  [1650] = {.lex_state = 225},
  [1651] = {.lex_state = 223, .external_lex_state = 16},
  [1652] = {.lex_state = 205, .external_lex_state = 24},
  [1653] = {.lex_state = 205, .external_lex_state = 24},
  [1654] = {.lex_state = 223, .external_lex_state = 24},
  [1655] = {.lex_state = 205, .external_lex_state = 24},
  [1656] = {.lex_state = 205, .external_lex_state = 24},
  [1657] = {.lex_state = 205, .external_lex_state = 16},
  [1658] = {.lex_state = 223, .external_lex_state = 16},
  [1659] = {.lex_state = 223, .external_lex_state = 24},
  [1660] = {.lex_state = 221, .external_lex_state = 16},
  [1661] = {.lex_state = 223, .external_lex_state = 24},
  [1662] = {.lex_state = 225},
  [1663] = {.lex_state = 223, .external_lex_state = 16},
  [1664] = {.lex_state = 223, .external_lex_state = 24},
  [1665] = {.lex_state = 225},
  [1666] = {.lex_state = 223, .external_lex_state = 16},
  [1667] = {.lex_state = 225},
  [1668] = {.lex_state = 223, .external_lex_state = 16},
  [1669] = {.lex_state = 223, .external_lex_state = 16},
  [1670] = {.lex_state = 223, .external_lex_state = 24},
  [1671] = {.lex_state = 223, .external_lex_state = 16},
  [1672] = {.lex_state = 112, .external_lex_state = 5},
  [1673] = {.lex_state = 112, .external_lex_state = 5},
  [1674] = {.lex_state = 112, .external_lex_state = 5},
  [1675] = {.lex_state = 112, .external_lex_state = 5},
  [1676] = {.lex_state = 223, .external_lex_state = 16},
  [1677] = {.lex_state = 112, .external_lex_state = 5},
  [1678] = {.lex_state = 223, .external_lex_state = 16},
  [1679] = {.lex_state = 112, .external_lex_state = 5},
  [1680] = {.lex_state = 223, .external_lex_state = 16},
  [1681] = {.lex_state = 112, .external_lex_state = 5},
  [1682] = {.lex_state = 112, .external_lex_state = 5},
  [1683] = {.lex_state = 163, .external_lex_state = 15},
  [1684] = {.lex_state = 72},
  [1685] = {.lex_state = 68},
  [1686] = {.lex_state = 56, .external_lex_state = 2},
  [1687] = {.lex_state = 240, .external_lex_state = 18},
  [1688] = {.lex_state = 68},
  [1689] = {.lex_state = 68},
  [1690] = {.lex_state = 72},
  [1691] = {.lex_state = 72},
  [1692] = {.lex_state = 68},
  [1693] = {.lex_state = 72},
  [1694] = {.lex_state = 72},
  [1695] = {.lex_state = 72},
  [1696] = {.lex_state = 68},
  [1697] = {.lex_state = 72},
  [1698] = {.lex_state = 72},
  [1699] = {.lex_state = 72},
  [1700] = {.lex_state = 163, .external_lex_state = 26},
  [1701] = {.lex_state = 163, .external_lex_state = 26},
  [1702] = {.lex_state = 72},
  [1703] = {.lex_state = 163, .external_lex_state = 13},
  [1704] = {.lex_state = 163, .external_lex_state = 13},
  [1705] = {.lex_state = 68},
  [1706] = {.lex_state = 68},
  [1707] = {.lex_state = 72},
  [1708] = {.lex_state = 230, .external_lex_state = 28},
  [1709] = {.lex_state = 90},
  [1710] = {.lex_state = 97},
  [1711] = {.lex_state = 230, .external_lex_state = 28},
  [1712] = {.lex_state = 97, .external_lex_state = 6},
  [1713] = {.lex_state = 56, .external_lex_state = 2},
  [1714] = {.lex_state = 56, .external_lex_state = 2},
  [1715] = {.lex_state = 56, .external_lex_state = 2},
  [1716] = {.lex_state = 240, .external_lex_state = 26},
  [1717] = {.lex_state = 240, .external_lex_state = 26},
  [1718] = {.lex_state = 230, .external_lex_state = 28},
  [1719] = {.lex_state = 230, .external_lex_state = 28},
  [1720] = {.lex_state = 240, .external_lex_state = 26},
  [1721] = {.lex_state = 230, .external_lex_state = 26},
  [1722] = {.lex_state = 156, .external_lex_state = 6},
  [1723] = {.lex_state = 163},
  [1724] = {.lex_state = 156, .external_lex_state = 25},
  [1725] = {.lex_state = 205, .external_lex_state = 24},
  [1726] = {.lex_state = 205, .external_lex_state = 24},
  [1727] = {.lex_state = 205, .external_lex_state = 16},
  [1728] = {.lex_state = 223, .external_lex_state = 16},
  [1729] = {.lex_state = 156, .external_lex_state = 25},
  [1730] = {.lex_state = 221, .external_lex_state = 16},
  [1731] = {.lex_state = 156, .external_lex_state = 25},
  [1732] = {.lex_state = 225},
  [1733] = {.lex_state = 223, .external_lex_state = 16},
  [1734] = {.lex_state = 156, .external_lex_state = 25},
  [1735] = {.lex_state = 225},
  [1736] = {.lex_state = 223, .external_lex_state = 16},
  [1737] = {.lex_state = 225},
  [1738] = {.lex_state = 223, .external_lex_state = 16},
  [1739] = {.lex_state = 223, .external_lex_state = 16},
  [1740] = {.lex_state = 156, .external_lex_state = 25},
  [1741] = {.lex_state = 223, .external_lex_state = 16},
  [1742] = {.lex_state = 156, .external_lex_state = 13},
  [1743] = {.lex_state = 205, .external_lex_state = 24},
  [1744] = {.lex_state = 205, .external_lex_state = 24},
  [1745] = {.lex_state = 205, .external_lex_state = 16},
  [1746] = {.lex_state = 223, .external_lex_state = 16},
  [1747] = {.lex_state = 156, .external_lex_state = 13},
  [1748] = {.lex_state = 221, .external_lex_state = 16},
  [1749] = {.lex_state = 156, .external_lex_state = 13},
  [1750] = {.lex_state = 225},
  [1751] = {.lex_state = 223, .external_lex_state = 16},
  [1752] = {.lex_state = 156, .external_lex_state = 13},
  [1753] = {.lex_state = 225},
  [1754] = {.lex_state = 223, .external_lex_state = 16},
  [1755] = {.lex_state = 225},
  [1756] = {.lex_state = 223, .external_lex_state = 16},
  [1757] = {.lex_state = 223, .external_lex_state = 16},
  [1758] = {.lex_state = 156, .external_lex_state = 13},
  [1759] = {.lex_state = 223, .external_lex_state = 16},
  [1760] = {.lex_state = 158, .external_lex_state = 17},
  [1761] = {.lex_state = 158, .external_lex_state = 17},
  [1762] = {.lex_state = 158, .external_lex_state = 17},
  [1763] = {.lex_state = 223, .external_lex_state = 16},
  [1764] = {.lex_state = 205, .external_lex_state = 24},
  [1765] = {.lex_state = 205, .external_lex_state = 24},
  [1766] = {.lex_state = 205, .external_lex_state = 16},
  [1767] = {.lex_state = 223, .external_lex_state = 16},
  [1768] = {.lex_state = 158, .external_lex_state = 17},
  [1769] = {.lex_state = 223, .external_lex_state = 16},
  [1770] = {.lex_state = 158, .external_lex_state = 17},
  [1771] = {.lex_state = 223, .external_lex_state = 16},
  [1772] = {.lex_state = 158, .external_lex_state = 17},
  [1773] = {.lex_state = 223, .external_lex_state = 16},
  [1774] = {.lex_state = 158, .external_lex_state = 17},
  [1775] = {.lex_state = 223, .external_lex_state = 16},
  [1776] = {.lex_state = 68},
  [1777] = {.lex_state = 230, .external_lex_state = 17},
  [1778] = {.lex_state = 68},
  [1779] = {.lex_state = 171, .external_lex_state = 15},
  [1780] = {.lex_state = 163, .external_lex_state = 26},
  [1781] = {.lex_state = 72},
  [1782] = {.lex_state = 171, .external_lex_state = 13},
  [1783] = {.lex_state = 171, .external_lex_state = 13},
  [1784] = {.lex_state = 72},
  [1785] = {.lex_state = 232, .external_lex_state = 28},
  [1786] = {.lex_state = 232, .external_lex_state = 28},
  [1787] = {.lex_state = 232, .external_lex_state = 28},
  [1788] = {.lex_state = 232, .external_lex_state = 28},
  [1789] = {.lex_state = 232, .external_lex_state = 26},
  [1790] = {.lex_state = 232, .external_lex_state = 17},
  [1791] = {.lex_state = 176, .external_lex_state = 19},
  [1792] = {.lex_state = 205, .external_lex_state = 24},
  [1793] = {.lex_state = 205, .external_lex_state = 24},
  [1794] = {.lex_state = 205, .external_lex_state = 16},
  [1795] = {.lex_state = 223, .external_lex_state = 16},
  [1796] = {.lex_state = 176, .external_lex_state = 19},
  [1797] = {.lex_state = 221, .external_lex_state = 16},
  [1798] = {.lex_state = 176, .external_lex_state = 19},
  [1799] = {.lex_state = 225},
  [1800] = {.lex_state = 223, .external_lex_state = 16},
  [1801] = {.lex_state = 176, .external_lex_state = 19},
  [1802] = {.lex_state = 225},
  [1803] = {.lex_state = 223, .external_lex_state = 16},
  [1804] = {.lex_state = 225},
  [1805] = {.lex_state = 223, .external_lex_state = 16},
  [1806] = {.lex_state = 223, .external_lex_state = 16},
  [1807] = {.lex_state = 176, .external_lex_state = 19},
  [1808] = {.lex_state = 223, .external_lex_state = 16},
  [1809] = {.lex_state = 236, .external_lex_state = 13},
  [1810] = {.lex_state = 205, .external_lex_state = 24},
  [1811] = {.lex_state = 205, .external_lex_state = 24},
  [1812] = {.lex_state = 205, .external_lex_state = 16},
  [1813] = {.lex_state = 223, .external_lex_state = 16},
  [1814] = {.lex_state = 236, .external_lex_state = 13},
  [1815] = {.lex_state = 221, .external_lex_state = 16},
  [1816] = {.lex_state = 236, .external_lex_state = 13},
  [1817] = {.lex_state = 225},
  [1818] = {.lex_state = 223, .external_lex_state = 16},
  [1819] = {.lex_state = 236, .external_lex_state = 13},
  [1820] = {.lex_state = 225},
  [1821] = {.lex_state = 223, .external_lex_state = 16},
  [1822] = {.lex_state = 225},
  [1823] = {.lex_state = 223, .external_lex_state = 16},
  [1824] = {.lex_state = 223, .external_lex_state = 16},
  [1825] = {.lex_state = 236, .external_lex_state = 13},
  [1826] = {.lex_state = 223, .external_lex_state = 16},
  [1827] = {.lex_state = 125, .external_lex_state = 21},
  [1828] = {.lex_state = 125, .external_lex_state = 21},
  [1829] = {.lex_state = 125, .external_lex_state = 21},
  [1830] = {.lex_state = 223, .external_lex_state = 16},
  [1831] = {.lex_state = 205, .external_lex_state = 24},
  [1832] = {.lex_state = 205, .external_lex_state = 24},
  [1833] = {.lex_state = 205, .external_lex_state = 16},
  [1834] = {.lex_state = 223, .external_lex_state = 16},
  [1835] = {.lex_state = 125, .external_lex_state = 21},
  [1836] = {.lex_state = 223, .external_lex_state = 16},
  [1837] = {.lex_state = 125, .external_lex_state = 21},
  [1838] = {.lex_state = 223, .external_lex_state = 16},
  [1839] = {.lex_state = 125, .external_lex_state = 21},
  [1840] = {.lex_state = 223, .external_lex_state = 16},
  [1841] = {.lex_state = 125, .external_lex_state = 21},
  [1842] = {.lex_state = 223, .external_lex_state = 16},
  [1843] = {.lex_state = 56, .external_lex_state = 2},
  [1844] = {.lex_state = 127, .external_lex_state = 4},
  [1845] = {.lex_state = 242, .external_lex_state = 13},
  [1846] = {.lex_state = 242, .external_lex_state = 13},
  [1847] = {.lex_state = 242},
  [1848] = {.lex_state = 62},
  [1849] = {.lex_state = 56, .external_lex_state = 2},
  [1850] = {.lex_state = 72},
  [1851] = {.lex_state = 72},
  [1852] = {.lex_state = 74, .external_lex_state = 2},
  [1853] = {.lex_state = 76},
  [1854] = {.lex_state = 76},
  [1855] = {.lex_state = 82, .external_lex_state = 3},
  [1856] = {.lex_state = 82, .external_lex_state = 4},
  [1857] = {.lex_state = 87, .external_lex_state = 5},
  [1858] = {.lex_state = 87, .external_lex_state = 5},
  [1859] = {.lex_state = 106, .external_lex_state = 5},
  [1860] = {.lex_state = 127, .external_lex_state = 4},
  [1861] = {.lex_state = 87, .external_lex_state = 7},
  [1862] = {.lex_state = 110, .external_lex_state = 8},
  [1863] = {.lex_state = 62},
  [1864] = {.lex_state = 173, .external_lex_state = 2},
  [1865] = {.lex_state = 72, .external_lex_state = 2},
  [1866] = {.lex_state = 173, .external_lex_state = 2},
  [1867] = {.lex_state = 242},
  [1868] = {.lex_state = 242, .external_lex_state = 13},
  [1869] = {.lex_state = 72},
  [1870] = {.lex_state = 127, .external_lex_state = 4},
  [1871] = {.lex_state = 110, .external_lex_state = 8},
  [1872] = {.lex_state = 173, .external_lex_state = 2},
  [1873] = {.lex_state = 173, .external_lex_state = 2},
  [1874] = {.lex_state = 127, .external_lex_state = 4},
  [1875] = {.lex_state = 242, .external_lex_state = 13},
  [1876] = {.lex_state = 242, .external_lex_state = 13},
  [1877] = {.lex_state = 242},
  [1878] = {.lex_state = 72},
  [1879] = {.lex_state = 127, .external_lex_state = 4},
  [1880] = {.lex_state = 72},
  [1881] = {.lex_state = 116, .external_lex_state = 10},
  [1882] = {.lex_state = 116, .external_lex_state = 10},
  [1883] = {.lex_state = 116, .external_lex_state = 10},
  [1884] = {.lex_state = 116, .external_lex_state = 10},
  [1885] = {.lex_state = 223, .external_lex_state = 16},
  [1886] = {.lex_state = 116, .external_lex_state = 10},
  [1887] = {.lex_state = 223, .external_lex_state = 16},
  [1888] = {.lex_state = 116, .external_lex_state = 10},
  [1889] = {.lex_state = 223, .external_lex_state = 16},
  [1890] = {.lex_state = 116, .external_lex_state = 10},
  [1891] = {.lex_state = 116, .external_lex_state = 10},
  [1892] = {.lex_state = 245, .external_lex_state = 10},
  [1893] = {.lex_state = 127, .external_lex_state = 10},
  [1894] = {.lex_state = 127, .external_lex_state = 10},
  [1895] = {.lex_state = 127, .external_lex_state = 10},
  [1896] = {.lex_state = 209, .external_lex_state = 27},
  [1897] = {.lex_state = 209, .external_lex_state = 27},
  [1898] = {.lex_state = 209, .external_lex_state = 27},
  [1899] = {.lex_state = 129, .external_lex_state = 11},
  [1900] = {.lex_state = 129, .external_lex_state = 11},
  [1901] = {.lex_state = 129, .external_lex_state = 11},
  [1902] = {.lex_state = 129, .external_lex_state = 11},
  [1903] = {.lex_state = 223, .external_lex_state = 16},
  [1904] = {.lex_state = 129, .external_lex_state = 11},
  [1905] = {.lex_state = 223, .external_lex_state = 16},
  [1906] = {.lex_state = 129, .external_lex_state = 11},
  [1907] = {.lex_state = 223, .external_lex_state = 16},
  [1908] = {.lex_state = 129, .external_lex_state = 11},
  [1909] = {.lex_state = 129, .external_lex_state = 11},
  [1910] = {.lex_state = 234, .external_lex_state = 27},
  [1911] = {.lex_state = 199, .external_lex_state = 27},
  [1912] = {.lex_state = 234, .external_lex_state = 27},
  [1913] = {.lex_state = 221, .external_lex_state = 16},
  [1914] = {.lex_state = 234, .external_lex_state = 27},
  [1915] = {.lex_state = 225},
  [1916] = {.lex_state = 223, .external_lex_state = 16},
  [1917] = {.lex_state = 62},
  [1918] = {.lex_state = 151, .external_lex_state = 16},
  [1919] = {.lex_state = 151, .external_lex_state = 16},
  [1920] = {.lex_state = 151, .external_lex_state = 16},
  [1921] = {.lex_state = 234, .external_lex_state = 27},
  [1922] = {.lex_state = 225},
  [1923] = {.lex_state = 223, .external_lex_state = 16},
  [1924] = {.lex_state = 234, .external_lex_state = 27},
  [1925] = {.lex_state = 225},
  [1926] = {.lex_state = 223, .external_lex_state = 16},
  [1927] = {.lex_state = 234, .external_lex_state = 27},
  [1928] = {.lex_state = 234, .external_lex_state = 27},
  [1929] = {.lex_state = 218, .external_lex_state = 13},
  [1930] = {.lex_state = 218, .external_lex_state = 13},
  [1931] = {.lex_state = 218, .external_lex_state = 13},
  [1932] = {.lex_state = 218, .external_lex_state = 13},
  [1933] = {.lex_state = 223, .external_lex_state = 16},
  [1934] = {.lex_state = 218, .external_lex_state = 13},
  [1935] = {.lex_state = 223, .external_lex_state = 16},
  [1936] = {.lex_state = 218, .external_lex_state = 13},
  [1937] = {.lex_state = 223, .external_lex_state = 16},
  [1938] = {.lex_state = 218, .external_lex_state = 13},
  [1939] = {.lex_state = 218, .external_lex_state = 13},
  [1940] = {.lex_state = 121, .external_lex_state = 14},
  [1941] = {.lex_state = 121, .external_lex_state = 14},
  [1942] = {.lex_state = 121, .external_lex_state = 14},
  [1943] = {.lex_state = 121, .external_lex_state = 14},
  [1944] = {.lex_state = 223, .external_lex_state = 16},
  [1945] = {.lex_state = 121, .external_lex_state = 14},
  [1946] = {.lex_state = 223, .external_lex_state = 16},
  [1947] = {.lex_state = 121, .external_lex_state = 14},
  [1948] = {.lex_state = 223, .external_lex_state = 16},
  [1949] = {.lex_state = 121, .external_lex_state = 14},
  [1950] = {.lex_state = 121, .external_lex_state = 14},
  [1951] = {.lex_state = 121, .external_lex_state = 10},
  [1952] = {.lex_state = 121, .external_lex_state = 10},
  [1953] = {.lex_state = 121, .external_lex_state = 10},
  [1954] = {.lex_state = 121, .external_lex_state = 10},
  [1955] = {.lex_state = 223, .external_lex_state = 16},
  [1956] = {.lex_state = 121, .external_lex_state = 10},
  [1957] = {.lex_state = 223, .external_lex_state = 16},
  [1958] = {.lex_state = 121, .external_lex_state = 10},
  [1959] = {.lex_state = 223, .external_lex_state = 16},
  [1960] = {.lex_state = 121, .external_lex_state = 10},
  [1961] = {.lex_state = 121, .external_lex_state = 10},
  [1962] = {.lex_state = 163, .external_lex_state = 15},
  [1963] = {.lex_state = 163, .external_lex_state = 15},
  [1964] = {.lex_state = 163, .external_lex_state = 15},
  [1965] = {.lex_state = 163, .external_lex_state = 15},
  [1966] = {.lex_state = 223, .external_lex_state = 16},
  [1967] = {.lex_state = 163, .external_lex_state = 15},
  [1968] = {.lex_state = 223, .external_lex_state = 16},
  [1969] = {.lex_state = 163, .external_lex_state = 15},
  [1970] = {.lex_state = 223, .external_lex_state = 16},
  [1971] = {.lex_state = 163, .external_lex_state = 15},
  [1972] = {.lex_state = 163, .external_lex_state = 15},
  [1973] = {.lex_state = 90, .external_lex_state = 13},
  [1974] = {.lex_state = 90, .external_lex_state = 13},
  [1975] = {.lex_state = 90, .external_lex_state = 13},
  [1976] = {.lex_state = 90, .external_lex_state = 13},
  [1977] = {.lex_state = 223, .external_lex_state = 16},
  [1978] = {.lex_state = 90, .external_lex_state = 13},
  [1979] = {.lex_state = 223, .external_lex_state = 16},
  [1980] = {.lex_state = 90, .external_lex_state = 13},
  [1981] = {.lex_state = 223, .external_lex_state = 16},
  [1982] = {.lex_state = 90, .external_lex_state = 13},
  [1983] = {.lex_state = 90, .external_lex_state = 13},
  [1984] = {.lex_state = 151, .external_lex_state = 16},
  [1985] = {.lex_state = 151, .external_lex_state = 16},
  [1986] = {.lex_state = 205, .external_lex_state = 24},
  [1987] = {.lex_state = 205, .external_lex_state = 24},
  [1988] = {.lex_state = 205, .external_lex_state = 24},
  [1989] = {.lex_state = 205, .external_lex_state = 16},
  [1990] = {.lex_state = 223, .external_lex_state = 16},
  [1991] = {.lex_state = 205, .external_lex_state = 24},
  [1992] = {.lex_state = 221, .external_lex_state = 16},
  [1993] = {.lex_state = 205, .external_lex_state = 24},
  [1994] = {.lex_state = 225},
  [1995] = {.lex_state = 223, .external_lex_state = 16},
  [1996] = {.lex_state = 205, .external_lex_state = 24},
  [1997] = {.lex_state = 225},
  [1998] = {.lex_state = 223, .external_lex_state = 16},
  [1999] = {.lex_state = 225},
  [2000] = {.lex_state = 223, .external_lex_state = 16},
  [2001] = {.lex_state = 223, .external_lex_state = 16},
  [2002] = {.lex_state = 205, .external_lex_state = 24},
  [2003] = {.lex_state = 223, .external_lex_state = 16},
  [2004] = {.lex_state = 223, .external_lex_state = 24},
  [2005] = {.lex_state = 223, .external_lex_state = 24},
  [2006] = {.lex_state = 223, .external_lex_state = 24},
  [2007] = {.lex_state = 223, .external_lex_state = 16},
  [2008] = {.lex_state = 205, .external_lex_state = 24},
  [2009] = {.lex_state = 205, .external_lex_state = 24},
  [2010] = {.lex_state = 205, .external_lex_state = 16},
  [2011] = {.lex_state = 223, .external_lex_state = 16},
  [2012] = {.lex_state = 223, .external_lex_state = 24},
  [2013] = {.lex_state = 223, .external_lex_state = 16},
  [2014] = {.lex_state = 223, .external_lex_state = 24},
  [2015] = {.lex_state = 223, .external_lex_state = 16},
  [2016] = {.lex_state = 223, .external_lex_state = 24},
  [2017] = {.lex_state = 223, .external_lex_state = 16},
  [2018] = {.lex_state = 223, .external_lex_state = 24},
  [2019] = {.lex_state = 223, .external_lex_state = 16},
  [2020] = {.lex_state = 112, .external_lex_state = 5},
  [2021] = {.lex_state = 112, .external_lex_state = 5},
  [2022] = {.lex_state = 112, .external_lex_state = 5},
  [2023] = {.lex_state = 68},
  [2024] = {.lex_state = 68},
  [2025] = {.lex_state = 68},
  [2026] = {.lex_state = 72},
  [2027] = {.lex_state = 68},
  [2028] = {.lex_state = 72},
  [2029] = {.lex_state = 68},
  [2030] = {.lex_state = 72},
  [2031] = {.lex_state = 68},
  [2032] = {.lex_state = 72},
  [2033] = {.lex_state = 68},
  [2034] = {.lex_state = 72},
  [2035] = {.lex_state = 68},
  [2036] = {.lex_state = 163, .external_lex_state = 13},
  [2037] = {.lex_state = 163, .external_lex_state = 13},
  [2038] = {.lex_state = 68},
  [2039] = {.lex_state = 163, .external_lex_state = 13},
  [2040] = {.lex_state = 230, .external_lex_state = 28},
  [2041] = {.lex_state = 230, .external_lex_state = 28},
  [2042] = {.lex_state = 240, .external_lex_state = 26},
  [2043] = {.lex_state = 72},
  [2044] = {.lex_state = 230, .external_lex_state = 28},
  [2045] = {.lex_state = 240, .external_lex_state = 28},
  [2046] = {.lex_state = 90},
  [2047] = {.lex_state = 240, .external_lex_state = 28},
  [2048] = {.lex_state = 240, .external_lex_state = 28},
  [2049] = {.lex_state = 240, .external_lex_state = 28},
  [2050] = {.lex_state = 62},
  [2051] = {.lex_state = 151, .external_lex_state = 16},
  [2052] = {.lex_state = 154, .external_lex_state = 6},
  [2053] = {.lex_state = 151, .external_lex_state = 16},
  [2054] = {.lex_state = 151, .external_lex_state = 16},
  [2055] = {.lex_state = 68},
  [2056] = {.lex_state = 163, .external_lex_state = 2},
  [2057] = {.lex_state = 68},
  [2058] = {.lex_state = 171, .external_lex_state = 2},
  [2059] = {.lex_state = 68},
  [2060] = {.lex_state = 163, .external_lex_state = 2},
  [2061] = {.lex_state = 156, .external_lex_state = 6},
  [2062] = {.lex_state = 156, .external_lex_state = 25},
  [2063] = {.lex_state = 156, .external_lex_state = 25},
  [2064] = {.lex_state = 156, .external_lex_state = 25},
  [2065] = {.lex_state = 223, .external_lex_state = 16},
  [2066] = {.lex_state = 205, .external_lex_state = 24},
  [2067] = {.lex_state = 205, .external_lex_state = 24},
  [2068] = {.lex_state = 205, .external_lex_state = 16},
  [2069] = {.lex_state = 223, .external_lex_state = 16},
  [2070] = {.lex_state = 156, .external_lex_state = 25},
  [2071] = {.lex_state = 223, .external_lex_state = 16},
  [2072] = {.lex_state = 156, .external_lex_state = 25},
  [2073] = {.lex_state = 223, .external_lex_state = 16},
  [2074] = {.lex_state = 156, .external_lex_state = 25},
  [2075] = {.lex_state = 223, .external_lex_state = 16},
  [2076] = {.lex_state = 156, .external_lex_state = 25},
  [2077] = {.lex_state = 223, .external_lex_state = 16},
  [2078] = {.lex_state = 156, .external_lex_state = 13},
  [2079] = {.lex_state = 156, .external_lex_state = 13},
  [2080] = {.lex_state = 156, .external_lex_state = 13},
  [2081] = {.lex_state = 223, .external_lex_state = 16},
  [2082] = {.lex_state = 205, .external_lex_state = 24},
  [2083] = {.lex_state = 205, .external_lex_state = 24},
  [2084] = {.lex_state = 205, .external_lex_state = 16},
  [2085] = {.lex_state = 223, .external_lex_state = 16},
  [2086] = {.lex_state = 156, .external_lex_state = 13},
  [2087] = {.lex_state = 223, .external_lex_state = 16},
  [2088] = {.lex_state = 156, .external_lex_state = 13},
  [2089] = {.lex_state = 223, .external_lex_state = 16},
  [2090] = {.lex_state = 156, .external_lex_state = 13},
  [2091] = {.lex_state = 223, .external_lex_state = 16},
  [2092] = {.lex_state = 156, .external_lex_state = 13},
  [2093] = {.lex_state = 223, .external_lex_state = 16},
  [2094] = {.lex_state = 158, .external_lex_state = 17},
  [2095] = {.lex_state = 158, .external_lex_state = 17},
  [2096] = {.lex_state = 158, .external_lex_state = 17},
  [2097] = {.lex_state = 158, .external_lex_state = 17},
  [2098] = {.lex_state = 223, .external_lex_state = 16},
  [2099] = {.lex_state = 158, .external_lex_state = 17},
  [2100] = {.lex_state = 223, .external_lex_state = 16},
  [2101] = {.lex_state = 158, .external_lex_state = 17},
  [2102] = {.lex_state = 223, .external_lex_state = 16},
  [2103] = {.lex_state = 158, .external_lex_state = 17},
  [2104] = {.lex_state = 158, .external_lex_state = 17},
  [2105] = {.lex_state = 171, .external_lex_state = 13},
  [2106] = {.lex_state = 171, .external_lex_state = 13},
  [2107] = {.lex_state = 171, .external_lex_state = 13},
  [2108] = {.lex_state = 232, .external_lex_state = 28},
  [2109] = {.lex_state = 232, .external_lex_state = 28},
  [2110] = {.lex_state = 232, .external_lex_state = 28},
  [2111] = {.lex_state = 176, .external_lex_state = 19},
  [2112] = {.lex_state = 176, .external_lex_state = 19},
  [2113] = {.lex_state = 176, .external_lex_state = 19},
  [2114] = {.lex_state = 223, .external_lex_state = 16},
  [2115] = {.lex_state = 205, .external_lex_state = 24},
  [2116] = {.lex_state = 205, .external_lex_state = 24},
  [2117] = {.lex_state = 205, .external_lex_state = 16},
  [2118] = {.lex_state = 223, .external_lex_state = 16},
  [2119] = {.lex_state = 176, .external_lex_state = 19},
  [2120] = {.lex_state = 223, .external_lex_state = 16},
  [2121] = {.lex_state = 176, .external_lex_state = 19},
  [2122] = {.lex_state = 223, .external_lex_state = 16},
  [2123] = {.lex_state = 176, .external_lex_state = 19},
  [2124] = {.lex_state = 223, .external_lex_state = 16},
  [2125] = {.lex_state = 176, .external_lex_state = 19},
  [2126] = {.lex_state = 223, .external_lex_state = 16},
  [2127] = {.lex_state = 236, .external_lex_state = 13},
  [2128] = {.lex_state = 236, .external_lex_state = 13},
  [2129] = {.lex_state = 236, .external_lex_state = 13},
  [2130] = {.lex_state = 223, .external_lex_state = 16},
  [2131] = {.lex_state = 205, .external_lex_state = 24},
  [2132] = {.lex_state = 205, .external_lex_state = 24},
  [2133] = {.lex_state = 205, .external_lex_state = 16},
  [2134] = {.lex_state = 223, .external_lex_state = 16},
  [2135] = {.lex_state = 236, .external_lex_state = 13},
  [2136] = {.lex_state = 223, .external_lex_state = 16},
  [2137] = {.lex_state = 236, .external_lex_state = 13},
  [2138] = {.lex_state = 223, .external_lex_state = 16},
  [2139] = {.lex_state = 236, .external_lex_state = 13},
  [2140] = {.lex_state = 223, .external_lex_state = 16},
  [2141] = {.lex_state = 236, .external_lex_state = 13},
  [2142] = {.lex_state = 223, .external_lex_state = 16},
  [2143] = {.lex_state = 125, .external_lex_state = 21},
  [2144] = {.lex_state = 125, .external_lex_state = 21},
  [2145] = {.lex_state = 125, .external_lex_state = 21},
  [2146] = {.lex_state = 125, .external_lex_state = 21},
  [2147] = {.lex_state = 223, .external_lex_state = 16},
  [2148] = {.lex_state = 125, .external_lex_state = 21},
  [2149] = {.lex_state = 223, .external_lex_state = 16},
  [2150] = {.lex_state = 125, .external_lex_state = 21},
  [2151] = {.lex_state = 223, .external_lex_state = 16},
  [2152] = {.lex_state = 125, .external_lex_state = 21},
  [2153] = {.lex_state = 125, .external_lex_state = 21},
  [2154] = {.lex_state = 114, .external_lex_state = 9},
  [2155] = {.lex_state = 72},
  [2156] = {.lex_state = 119},
  [2157] = {.lex_state = 129, .external_lex_state = 12},
  [2158] = {.lex_state = 141},
  [2159] = {.lex_state = 62},
  [2160] = {.lex_state = 82, .external_lex_state = 14},
  [2161] = {.lex_state = 90},
  [2162] = {.lex_state = 97},
  [2163] = {.lex_state = 82, .external_lex_state = 14},
  [2164] = {.lex_state = 97, .external_lex_state = 6},
  [2165] = {.lex_state = 56, .external_lex_state = 2},
  [2166] = {.lex_state = 56, .external_lex_state = 2},
  [2167] = {.lex_state = 56, .external_lex_state = 2},
  [2168] = {.lex_state = 82, .external_lex_state = 3},
  [2169] = {.lex_state = 62},
  [2170] = {.lex_state = 82, .external_lex_state = 3},
  [2171] = {.lex_state = 82, .external_lex_state = 10},
  [2172] = {.lex_state = 90},
  [2173] = {.lex_state = 97},
  [2174] = {.lex_state = 82, .external_lex_state = 10},
  [2175] = {.lex_state = 97, .external_lex_state = 6},
  [2176] = {.lex_state = 56, .external_lex_state = 2},
  [2177] = {.lex_state = 56, .external_lex_state = 2},
  [2178] = {.lex_state = 56, .external_lex_state = 2},
  [2179] = {.lex_state = 82, .external_lex_state = 4},
  [2180] = {.lex_state = 82, .external_lex_state = 4},
  [2181] = {.lex_state = 87, .external_lex_state = 5},
  [2182] = {.lex_state = 68},
  [2183] = {.lex_state = 56, .external_lex_state = 2},
  [2184] = {.lex_state = 173, .external_lex_state = 2},
  [2185] = {.lex_state = 56, .external_lex_state = 2},
  [2186] = {.lex_state = 56},
  [2187] = {.lex_state = 179},
  [2188] = {.lex_state = 72},
  [2189] = {.lex_state = 72},
  [2190] = {.lex_state = 87, .external_lex_state = 5},
  [2191] = {.lex_state = 87, .external_lex_state = 5},
  [2192] = {.lex_state = 247, .external_lex_state = 7},
  [2193] = {.lex_state = 87, .external_lex_state = 7},
  [2194] = {.lex_state = 72},
  [2195] = {.lex_state = 127, .external_lex_state = 4},
  [2196] = {.lex_state = 110, .external_lex_state = 8},
  [2197] = {.lex_state = 173, .external_lex_state = 2},
  [2198] = {.lex_state = 87, .external_lex_state = 7},
  [2199] = {.lex_state = 173, .external_lex_state = 2},
  [2200] = {.lex_state = 173, .external_lex_state = 2},
  [2201] = {.lex_state = 72},
  [2202] = {.lex_state = 127, .external_lex_state = 4},
  [2203] = {.lex_state = 110, .external_lex_state = 8},
  [2204] = {.lex_state = 173, .external_lex_state = 2},
  [2205] = {.lex_state = 173, .external_lex_state = 2},
  [2206] = {.lex_state = 242},
  [2207] = {.lex_state = 173, .external_lex_state = 2},
  [2208] = {.lex_state = 242},
  [2209] = {.lex_state = 127, .external_lex_state = 4},
  [2210] = {.lex_state = 127, .external_lex_state = 4},
  [2211] = {.lex_state = 116, .external_lex_state = 10},
  [2212] = {.lex_state = 116, .external_lex_state = 10},
  [2213] = {.lex_state = 116, .external_lex_state = 10},
  [2214] = {.lex_state = 127, .external_lex_state = 10},
  [2215] = {.lex_state = 209, .external_lex_state = 27},
  [2216] = {.lex_state = 129, .external_lex_state = 11},
  [2217] = {.lex_state = 129, .external_lex_state = 11},
  [2218] = {.lex_state = 129, .external_lex_state = 11},
  [2219] = {.lex_state = 234, .external_lex_state = 27},
  [2220] = {.lex_state = 205, .external_lex_state = 24},
  [2221] = {.lex_state = 205, .external_lex_state = 24},
  [2222] = {.lex_state = 205, .external_lex_state = 16},
  [2223] = {.lex_state = 223, .external_lex_state = 16},
  [2224] = {.lex_state = 234, .external_lex_state = 27},
  [2225] = {.lex_state = 221, .external_lex_state = 16},
  [2226] = {.lex_state = 234, .external_lex_state = 27},
  [2227] = {.lex_state = 225},
  [2228] = {.lex_state = 223, .external_lex_state = 16},
  [2229] = {.lex_state = 234, .external_lex_state = 27},
  [2230] = {.lex_state = 225},
  [2231] = {.lex_state = 223, .external_lex_state = 16},
  [2232] = {.lex_state = 225},
  [2233] = {.lex_state = 223, .external_lex_state = 16},
  [2234] = {.lex_state = 223, .external_lex_state = 16},
  [2235] = {.lex_state = 234, .external_lex_state = 27},
  [2236] = {.lex_state = 223, .external_lex_state = 16},
  [2237] = {.lex_state = 218, .external_lex_state = 13},
  [2238] = {.lex_state = 218, .external_lex_state = 13},
  [2239] = {.lex_state = 218, .external_lex_state = 13},
  [2240] = {.lex_state = 121, .external_lex_state = 14},
  [2241] = {.lex_state = 121, .external_lex_state = 14},
  [2242] = {.lex_state = 121, .external_lex_state = 14},
  [2243] = {.lex_state = 121, .external_lex_state = 10},
  [2244] = {.lex_state = 121, .external_lex_state = 10},
  [2245] = {.lex_state = 121, .external_lex_state = 10},
  [2246] = {.lex_state = 163, .external_lex_state = 15},
  [2247] = {.lex_state = 163, .external_lex_state = 15},
  [2248] = {.lex_state = 163, .external_lex_state = 15},
  [2249] = {.lex_state = 90, .external_lex_state = 13},
  [2250] = {.lex_state = 90, .external_lex_state = 13},
  [2251] = {.lex_state = 90, .external_lex_state = 13},
  [2252] = {.lex_state = 205, .external_lex_state = 24},
  [2253] = {.lex_state = 205, .external_lex_state = 24},
  [2254] = {.lex_state = 205, .external_lex_state = 24},
  [2255] = {.lex_state = 223, .external_lex_state = 16},
  [2256] = {.lex_state = 205, .external_lex_state = 24},
  [2257] = {.lex_state = 205, .external_lex_state = 24},
  [2258] = {.lex_state = 205, .external_lex_state = 16},
  [2259] = {.lex_state = 223, .external_lex_state = 16},
  [2260] = {.lex_state = 205, .external_lex_state = 24},
  [2261] = {.lex_state = 223, .external_lex_state = 16},
  [2262] = {.lex_state = 205, .external_lex_state = 24},
  [2263] = {.lex_state = 223, .external_lex_state = 16},
  [2264] = {.lex_state = 205, .external_lex_state = 24},
  [2265] = {.lex_state = 223, .external_lex_state = 16},
  [2266] = {.lex_state = 205, .external_lex_state = 24},
  [2267] = {.lex_state = 223, .external_lex_state = 16},
  [2268] = {.lex_state = 223, .external_lex_state = 24},
  [2269] = {.lex_state = 223, .external_lex_state = 24},
  [2270] = {.lex_state = 223, .external_lex_state = 24},
  [2271] = {.lex_state = 223, .external_lex_state = 24},
  [2272] = {.lex_state = 223, .external_lex_state = 16},
  [2273] = {.lex_state = 223, .external_lex_state = 24},
  [2274] = {.lex_state = 223, .external_lex_state = 16},
  [2275] = {.lex_state = 223, .external_lex_state = 24},
  [2276] = {.lex_state = 223, .external_lex_state = 16},
  [2277] = {.lex_state = 223, .external_lex_state = 24},
  [2278] = {.lex_state = 223, .external_lex_state = 24},
  [2279] = {.lex_state = 68},
  [2280] = {.lex_state = 68},
  [2281] = {.lex_state = 72},
  [2282] = {.lex_state = 68},
  [2283] = {.lex_state = 72},
  [2284] = {.lex_state = 163, .external_lex_state = 13},
  [2285] = {.lex_state = 240, .external_lex_state = 28},
  [2286] = {.lex_state = 230, .external_lex_state = 28},
  [2287] = {.lex_state = 240, .external_lex_state = 28},
  [2288] = {.lex_state = 221, .external_lex_state = 16},
  [2289] = {.lex_state = 240, .external_lex_state = 28},
  [2290] = {.lex_state = 225},
  [2291] = {.lex_state = 223, .external_lex_state = 16},
  [2292] = {.lex_state = 62},
  [2293] = {.lex_state = 151, .external_lex_state = 16},
  [2294] = {.lex_state = 151, .external_lex_state = 16},
  [2295] = {.lex_state = 151, .external_lex_state = 16},
  [2296] = {.lex_state = 240, .external_lex_state = 28},
  [2297] = {.lex_state = 225},
  [2298] = {.lex_state = 223, .external_lex_state = 16},
  [2299] = {.lex_state = 240, .external_lex_state = 28},
  [2300] = {.lex_state = 225},
  [2301] = {.lex_state = 223, .external_lex_state = 16},
  [2302] = {.lex_state = 240, .external_lex_state = 28},
  [2303] = {.lex_state = 240, .external_lex_state = 28},
  [2304] = {.lex_state = 156, .external_lex_state = 25},
  [2305] = {.lex_state = 156, .external_lex_state = 25},
  [2306] = {.lex_state = 156, .external_lex_state = 25},
  [2307] = {.lex_state = 156, .external_lex_state = 25},
  [2308] = {.lex_state = 223, .external_lex_state = 16},
  [2309] = {.lex_state = 156, .external_lex_state = 25},
  [2310] = {.lex_state = 223, .external_lex_state = 16},
  [2311] = {.lex_state = 156, .external_lex_state = 25},
  [2312] = {.lex_state = 223, .external_lex_state = 16},
  [2313] = {.lex_state = 156, .external_lex_state = 25},
  [2314] = {.lex_state = 156, .external_lex_state = 25},
  [2315] = {.lex_state = 156, .external_lex_state = 13},
  [2316] = {.lex_state = 156, .external_lex_state = 13},
  [2317] = {.lex_state = 156, .external_lex_state = 13},
  [2318] = {.lex_state = 156, .external_lex_state = 13},
  [2319] = {.lex_state = 223, .external_lex_state = 16},
  [2320] = {.lex_state = 156, .external_lex_state = 13},
  [2321] = {.lex_state = 223, .external_lex_state = 16},
  [2322] = {.lex_state = 156, .external_lex_state = 13},
  [2323] = {.lex_state = 223, .external_lex_state = 16},
  [2324] = {.lex_state = 156, .external_lex_state = 13},
  [2325] = {.lex_state = 156, .external_lex_state = 13},
  [2326] = {.lex_state = 158, .external_lex_state = 17},
  [2327] = {.lex_state = 158, .external_lex_state = 17},
  [2328] = {.lex_state = 158, .external_lex_state = 17},
  [2329] = {.lex_state = 171, .external_lex_state = 13},
  [2330] = {.lex_state = 232, .external_lex_state = 28},
  [2331] = {.lex_state = 176, .external_lex_state = 19},
  [2332] = {.lex_state = 176, .external_lex_state = 19},
  [2333] = {.lex_state = 176, .external_lex_state = 19},
  [2334] = {.lex_state = 176, .external_lex_state = 19},
  [2335] = {.lex_state = 223, .external_lex_state = 16},
  [2336] = {.lex_state = 176, .external_lex_state = 19},
  [2337] = {.lex_state = 223, .external_lex_state = 16},
  [2338] = {.lex_state = 176, .external_lex_state = 19},
  [2339] = {.lex_state = 223, .external_lex_state = 16},
  [2340] = {.lex_state = 176, .external_lex_state = 19},
  [2341] = {.lex_state = 176, .external_lex_state = 19},
  [2342] = {.lex_state = 236, .external_lex_state = 13},
  [2343] = {.lex_state = 236, .external_lex_state = 13},
  [2344] = {.lex_state = 236, .external_lex_state = 13},
  [2345] = {.lex_state = 236, .external_lex_state = 13},
  [2346] = {.lex_state = 223, .external_lex_state = 16},
  [2347] = {.lex_state = 236, .external_lex_state = 13},
  [2348] = {.lex_state = 223, .external_lex_state = 16},
  [2349] = {.lex_state = 236, .external_lex_state = 13},
  [2350] = {.lex_state = 223, .external_lex_state = 16},
  [2351] = {.lex_state = 236, .external_lex_state = 13},
  [2352] = {.lex_state = 236, .external_lex_state = 13},
  [2353] = {.lex_state = 125, .external_lex_state = 21},
  [2354] = {.lex_state = 125, .external_lex_state = 21},
  [2355] = {.lex_state = 125, .external_lex_state = 21},
  [2356] = {.lex_state = 110, .external_lex_state = 21},
  [2357] = {.lex_state = 110, .external_lex_state = 21},
  [2358] = {.lex_state = 247, .external_lex_state = 7},
  [2359] = {.lex_state = 68},
  [2360] = {.lex_state = 110, .external_lex_state = 23},
  [2361] = {.lex_state = 234, .external_lex_state = 23},
  [2362] = {.lex_state = 114, .external_lex_state = 9},
  [2363] = {.lex_state = 72},
  [2364] = {.lex_state = 82, .external_lex_state = 14},
  [2365] = {.lex_state = 82, .external_lex_state = 14},
  [2366] = {.lex_state = 90},
  [2367] = {.lex_state = 82, .external_lex_state = 14},
  [2368] = {.lex_state = 82, .external_lex_state = 14},
  [2369] = {.lex_state = 82, .external_lex_state = 14},
  [2370] = {.lex_state = 62},
  [2371] = {.lex_state = 151, .external_lex_state = 16},
  [2372] = {.lex_state = 154, .external_lex_state = 6},
  [2373] = {.lex_state = 151, .external_lex_state = 16},
  [2374] = {.lex_state = 151, .external_lex_state = 16},
  [2375] = {.lex_state = 68},
  [2376] = {.lex_state = 163, .external_lex_state = 2},
  [2377] = {.lex_state = 68},
  [2378] = {.lex_state = 171, .external_lex_state = 2},
  [2379] = {.lex_state = 68},
  [2380] = {.lex_state = 163, .external_lex_state = 2},
  [2381] = {.lex_state = 82, .external_lex_state = 3},
  [2382] = {.lex_state = 72},
  [2383] = {.lex_state = 82, .external_lex_state = 10},
  [2384] = {.lex_state = 82, .external_lex_state = 10},
  [2385] = {.lex_state = 90},
  [2386] = {.lex_state = 82, .external_lex_state = 10},
  [2387] = {.lex_state = 82, .external_lex_state = 10},
  [2388] = {.lex_state = 82, .external_lex_state = 10},
  [2389] = {.lex_state = 62},
  [2390] = {.lex_state = 151, .external_lex_state = 16},
  [2391] = {.lex_state = 154, .external_lex_state = 6},
  [2392] = {.lex_state = 151, .external_lex_state = 16},
  [2393] = {.lex_state = 151, .external_lex_state = 16},
  [2394] = {.lex_state = 68},
  [2395] = {.lex_state = 163, .external_lex_state = 2},
  [2396] = {.lex_state = 68},
  [2397] = {.lex_state = 171, .external_lex_state = 2},
  [2398] = {.lex_state = 68},
  [2399] = {.lex_state = 163, .external_lex_state = 2},
  [2400] = {.lex_state = 82, .external_lex_state = 4},
  [2401] = {.lex_state = 87, .external_lex_state = 5},
  [2402] = {.lex_state = 119},
  [2403] = {.lex_state = 127, .external_lex_state = 4},
  [2404] = {.lex_state = 110, .external_lex_state = 8},
  [2405] = {.lex_state = 72},
  [2406] = {.lex_state = 87, .external_lex_state = 5},
  [2407] = {.lex_state = 87, .external_lex_state = 5},
  [2408] = {.lex_state = 247, .external_lex_state = 5},
  [2409] = {.lex_state = 247, .external_lex_state = 5},
  [2410] = {.lex_state = 247, .external_lex_state = 5},
  [2411] = {.lex_state = 247, .external_lex_state = 5},
  [2412] = {.lex_state = 247, .external_lex_state = 7},
  [2413] = {.lex_state = 247, .external_lex_state = 7},
  [2414] = {.lex_state = 87, .external_lex_state = 7},
  [2415] = {.lex_state = 173, .external_lex_state = 2},
  [2416] = {.lex_state = 87, .external_lex_state = 7},
  [2417] = {.lex_state = 72},
  [2418] = {.lex_state = 127, .external_lex_state = 4},
  [2419] = {.lex_state = 110, .external_lex_state = 8},
  [2420] = {.lex_state = 173, .external_lex_state = 2},
  [2421] = {.lex_state = 72},
  [2422] = {.lex_state = 127, .external_lex_state = 4},
  [2423] = {.lex_state = 110, .external_lex_state = 8},
  [2424] = {.lex_state = 72},
  [2425] = {.lex_state = 82, .external_lex_state = 4},
  [2426] = {.lex_state = 110, .external_lex_state = 8},
  [2427] = {.lex_state = 173, .external_lex_state = 2},
  [2428] = {.lex_state = 173, .external_lex_state = 2},
  [2429] = {.lex_state = 72},
  [2430] = {.lex_state = 82, .external_lex_state = 4},
  [2431] = {.lex_state = 110, .external_lex_state = 8},
  [2432] = {.lex_state = 173, .external_lex_state = 2},
  [2433] = {.lex_state = 173, .external_lex_state = 2},
  [2434] = {.lex_state = 234, .external_lex_state = 27},
  [2435] = {.lex_state = 234, .external_lex_state = 27},
  [2436] = {.lex_state = 234, .external_lex_state = 27},
  [2437] = {.lex_state = 223, .external_lex_state = 16},
  [2438] = {.lex_state = 205, .external_lex_state = 24},
  [2439] = {.lex_state = 205, .external_lex_state = 24},
  [2440] = {.lex_state = 205, .external_lex_state = 16},
  [2441] = {.lex_state = 223, .external_lex_state = 16},
  [2442] = {.lex_state = 234, .external_lex_state = 27},
  [2443] = {.lex_state = 223, .external_lex_state = 16},
  [2444] = {.lex_state = 234, .external_lex_state = 27},
  [2445] = {.lex_state = 223, .external_lex_state = 16},
  [2446] = {.lex_state = 234, .external_lex_state = 27},
  [2447] = {.lex_state = 223, .external_lex_state = 16},
  [2448] = {.lex_state = 234, .external_lex_state = 27},
  [2449] = {.lex_state = 223, .external_lex_state = 16},
  [2450] = {.lex_state = 205, .external_lex_state = 24},
  [2451] = {.lex_state = 205, .external_lex_state = 24},
  [2452] = {.lex_state = 205, .external_lex_state = 24},
  [2453] = {.lex_state = 205, .external_lex_state = 24},
  [2454] = {.lex_state = 223, .external_lex_state = 16},
  [2455] = {.lex_state = 205, .external_lex_state = 24},
  [2456] = {.lex_state = 223, .external_lex_state = 16},
  [2457] = {.lex_state = 205, .external_lex_state = 24},
  [2458] = {.lex_state = 223, .external_lex_state = 16},
  [2459] = {.lex_state = 205, .external_lex_state = 24},
  [2460] = {.lex_state = 205, .external_lex_state = 24},
  [2461] = {.lex_state = 223, .external_lex_state = 24},
  [2462] = {.lex_state = 223, .external_lex_state = 24},
  [2463] = {.lex_state = 223, .external_lex_state = 24},
  [2464] = {.lex_state = 68},
  [2465] = {.lex_state = 68},
  [2466] = {.lex_state = 240, .external_lex_state = 28},
  [2467] = {.lex_state = 205, .external_lex_state = 24},
  [2468] = {.lex_state = 205, .external_lex_state = 24},
  [2469] = {.lex_state = 205, .external_lex_state = 16},
  [2470] = {.lex_state = 223, .external_lex_state = 16},
  [2471] = {.lex_state = 240, .external_lex_state = 28},
  [2472] = {.lex_state = 221, .external_lex_state = 16},
  [2473] = {.lex_state = 240, .external_lex_state = 28},
  [2474] = {.lex_state = 225},
  [2475] = {.lex_state = 223, .external_lex_state = 16},
  [2476] = {.lex_state = 240, .external_lex_state = 28},
  [2477] = {.lex_state = 225},
  [2478] = {.lex_state = 223, .external_lex_state = 16},
  [2479] = {.lex_state = 225},
  [2480] = {.lex_state = 223, .external_lex_state = 16},
  [2481] = {.lex_state = 223, .external_lex_state = 16},
  [2482] = {.lex_state = 240, .external_lex_state = 28},
  [2483] = {.lex_state = 223, .external_lex_state = 16},
  [2484] = {.lex_state = 156, .external_lex_state = 25},
  [2485] = {.lex_state = 156, .external_lex_state = 25},
  [2486] = {.lex_state = 156, .external_lex_state = 25},
  [2487] = {.lex_state = 156, .external_lex_state = 13},
  [2488] = {.lex_state = 156, .external_lex_state = 13},
  [2489] = {.lex_state = 156, .external_lex_state = 13},
  [2490] = {.lex_state = 176, .external_lex_state = 19},
  [2491] = {.lex_state = 176, .external_lex_state = 19},
  [2492] = {.lex_state = 176, .external_lex_state = 19},
  [2493] = {.lex_state = 236, .external_lex_state = 13},
  [2494] = {.lex_state = 236, .external_lex_state = 13},
  [2495] = {.lex_state = 236, .external_lex_state = 13},
  [2496] = {.lex_state = 110, .external_lex_state = 21},
  [2497] = {.lex_state = 247, .external_lex_state = 7},
  [2498] = {.lex_state = 119},
  [2499] = {.lex_state = 56},
  [2500] = {.lex_state = 72},
  [2501] = {.lex_state = 56},
  [2502] = {.lex_state = 72},
  [2503] = {.lex_state = 72},
  [2504] = {.lex_state = 234, .external_lex_state = 23},
  [2505] = {.lex_state = 82, .external_lex_state = 3},
  [2506] = {.lex_state = 163},
  [2507] = {.lex_state = 82, .external_lex_state = 14},
  [2508] = {.lex_state = 82, .external_lex_state = 14},
  [2509] = {.lex_state = 82, .external_lex_state = 14},
  [2510] = {.lex_state = 82, .external_lex_state = 14},
  [2511] = {.lex_state = 82, .external_lex_state = 14},
  [2512] = {.lex_state = 221, .external_lex_state = 16},
  [2513] = {.lex_state = 82, .external_lex_state = 14},
  [2514] = {.lex_state = 225},
  [2515] = {.lex_state = 223, .external_lex_state = 16},
  [2516] = {.lex_state = 62},
  [2517] = {.lex_state = 151, .external_lex_state = 16},
  [2518] = {.lex_state = 151, .external_lex_state = 16},
  [2519] = {.lex_state = 151, .external_lex_state = 16},
  [2520] = {.lex_state = 82, .external_lex_state = 14},
  [2521] = {.lex_state = 225},
  [2522] = {.lex_state = 223, .external_lex_state = 16},
  [2523] = {.lex_state = 82, .external_lex_state = 14},
  [2524] = {.lex_state = 225},
  [2525] = {.lex_state = 223, .external_lex_state = 16},
  [2526] = {.lex_state = 82, .external_lex_state = 14},
  [2527] = {.lex_state = 82, .external_lex_state = 14},
  [2528] = {.lex_state = 82, .external_lex_state = 10},
  [2529] = {.lex_state = 82, .external_lex_state = 10},
  [2530] = {.lex_state = 82, .external_lex_state = 10},
  [2531] = {.lex_state = 221, .external_lex_state = 16},
  [2532] = {.lex_state = 82, .external_lex_state = 10},
  [2533] = {.lex_state = 225},
  [2534] = {.lex_state = 223, .external_lex_state = 16},
  [2535] = {.lex_state = 62},
  [2536] = {.lex_state = 151, .external_lex_state = 16},
  [2537] = {.lex_state = 151, .external_lex_state = 16},
  [2538] = {.lex_state = 151, .external_lex_state = 16},
  [2539] = {.lex_state = 82, .external_lex_state = 10},
  [2540] = {.lex_state = 225},
  [2541] = {.lex_state = 223, .external_lex_state = 16},
  [2542] = {.lex_state = 82, .external_lex_state = 10},
  [2543] = {.lex_state = 225},
  [2544] = {.lex_state = 223, .external_lex_state = 16},
  [2545] = {.lex_state = 82, .external_lex_state = 10},
  [2546] = {.lex_state = 82, .external_lex_state = 10},
  [2547] = {.lex_state = 110, .external_lex_state = 23},
  [2548] = {.lex_state = 247, .external_lex_state = 5},
  [2549] = {.lex_state = 247, .external_lex_state = 5},
  [2550] = {.lex_state = 247, .external_lex_state = 5},
  [2551] = {.lex_state = 247, .external_lex_state = 7},
  [2552] = {.lex_state = 173, .external_lex_state = 2},
  [2553] = {.lex_state = 173, .external_lex_state = 2},
  [2554] = {.lex_state = 173, .external_lex_state = 2},
  [2555] = {.lex_state = 72},
  [2556] = {.lex_state = 82, .external_lex_state = 4},
  [2557] = {.lex_state = 110, .external_lex_state = 8},
  [2558] = {.lex_state = 173, .external_lex_state = 2},
  [2559] = {.lex_state = 173, .external_lex_state = 2},
  [2560] = {.lex_state = 173, .external_lex_state = 2},
  [2561] = {.lex_state = 72},
  [2562] = {.lex_state = 82, .external_lex_state = 4},
  [2563] = {.lex_state = 110, .external_lex_state = 8},
  [2564] = {.lex_state = 173, .external_lex_state = 2},
  [2565] = {.lex_state = 234, .external_lex_state = 27},
  [2566] = {.lex_state = 234, .external_lex_state = 27},
  [2567] = {.lex_state = 234, .external_lex_state = 27},
  [2568] = {.lex_state = 234, .external_lex_state = 27},
  [2569] = {.lex_state = 223, .external_lex_state = 16},
  [2570] = {.lex_state = 234, .external_lex_state = 27},
  [2571] = {.lex_state = 223, .external_lex_state = 16},
  [2572] = {.lex_state = 234, .external_lex_state = 27},
  [2573] = {.lex_state = 223, .external_lex_state = 16},
  [2574] = {.lex_state = 234, .external_lex_state = 27},
  [2575] = {.lex_state = 234, .external_lex_state = 27},
  [2576] = {.lex_state = 205, .external_lex_state = 24},
  [2577] = {.lex_state = 205, .external_lex_state = 24},
  [2578] = {.lex_state = 205, .external_lex_state = 24},
  [2579] = {.lex_state = 240, .external_lex_state = 28},
  [2580] = {.lex_state = 240, .external_lex_state = 28},
  [2581] = {.lex_state = 240, .external_lex_state = 28},
  [2582] = {.lex_state = 223, .external_lex_state = 16},
  [2583] = {.lex_state = 205, .external_lex_state = 24},
  [2584] = {.lex_state = 205, .external_lex_state = 24},
  [2585] = {.lex_state = 205, .external_lex_state = 16},
  [2586] = {.lex_state = 223, .external_lex_state = 16},
  [2587] = {.lex_state = 240, .external_lex_state = 28},
  [2588] = {.lex_state = 223, .external_lex_state = 16},
  [2589] = {.lex_state = 240, .external_lex_state = 28},
  [2590] = {.lex_state = 223, .external_lex_state = 16},
  [2591] = {.lex_state = 240, .external_lex_state = 28},
  [2592] = {.lex_state = 223, .external_lex_state = 16},
  [2593] = {.lex_state = 240, .external_lex_state = 28},
  [2594] = {.lex_state = 223, .external_lex_state = 16},
  [2595] = {.lex_state = 110, .external_lex_state = 21},
  [2596] = {.lex_state = 110, .external_lex_state = 23},
  [2597] = {.lex_state = 72},
  [2598] = {.lex_state = 245, .external_lex_state = 10},
  [2599] = {.lex_state = 90},
  [2600] = {.lex_state = 97},
  [2601] = {.lex_state = 245, .external_lex_state = 10},
  [2602] = {.lex_state = 97, .external_lex_state = 6},
  [2603] = {.lex_state = 56, .external_lex_state = 2},
  [2604] = {.lex_state = 56, .external_lex_state = 2},
  [2605] = {.lex_state = 56, .external_lex_state = 2},
  [2606] = {.lex_state = 72},
  [2607] = {.lex_state = 247, .external_lex_state = 27},
  [2608] = {.lex_state = 247, .external_lex_state = 27},
  [2609] = {.lex_state = 247, .external_lex_state = 27},
  [2610] = {.lex_state = 247, .external_lex_state = 27},
  [2611] = {.lex_state = 234, .external_lex_state = 23},
  [2612] = {.lex_state = 82, .external_lex_state = 3},
  [2613] = {.lex_state = 163},
  [2614] = {.lex_state = 82, .external_lex_state = 14},
  [2615] = {.lex_state = 205, .external_lex_state = 24},
  [2616] = {.lex_state = 205, .external_lex_state = 24},
  [2617] = {.lex_state = 205, .external_lex_state = 16},
  [2618] = {.lex_state = 223, .external_lex_state = 16},
  [2619] = {.lex_state = 82, .external_lex_state = 14},
  [2620] = {.lex_state = 221, .external_lex_state = 16},
  [2621] = {.lex_state = 82, .external_lex_state = 14},
  [2622] = {.lex_state = 225},
  [2623] = {.lex_state = 223, .external_lex_state = 16},
  [2624] = {.lex_state = 82, .external_lex_state = 14},
  [2625] = {.lex_state = 225},
  [2626] = {.lex_state = 223, .external_lex_state = 16},
  [2627] = {.lex_state = 225},
  [2628] = {.lex_state = 223, .external_lex_state = 16},
  [2629] = {.lex_state = 223, .external_lex_state = 16},
  [2630] = {.lex_state = 82, .external_lex_state = 14},
  [2631] = {.lex_state = 223, .external_lex_state = 16},
  [2632] = {.lex_state = 82, .external_lex_state = 10},
  [2633] = {.lex_state = 205, .external_lex_state = 24},
  [2634] = {.lex_state = 205, .external_lex_state = 24},
  [2635] = {.lex_state = 205, .external_lex_state = 16},
  [2636] = {.lex_state = 223, .external_lex_state = 16},
  [2637] = {.lex_state = 82, .external_lex_state = 10},
  [2638] = {.lex_state = 221, .external_lex_state = 16},
  [2639] = {.lex_state = 82, .external_lex_state = 10},
  [2640] = {.lex_state = 225},
  [2641] = {.lex_state = 223, .external_lex_state = 16},
  [2642] = {.lex_state = 82, .external_lex_state = 10},
  [2643] = {.lex_state = 225},
  [2644] = {.lex_state = 223, .external_lex_state = 16},
  [2645] = {.lex_state = 225},
  [2646] = {.lex_state = 223, .external_lex_state = 16},
  [2647] = {.lex_state = 223, .external_lex_state = 16},
  [2648] = {.lex_state = 82, .external_lex_state = 10},
  [2649] = {.lex_state = 223, .external_lex_state = 16},
  [2650] = {.lex_state = 247, .external_lex_state = 5},
  [2651] = {.lex_state = 173, .external_lex_state = 2},
  [2652] = {.lex_state = 72},
  [2653] = {.lex_state = 82, .external_lex_state = 4},
  [2654] = {.lex_state = 110, .external_lex_state = 8},
  [2655] = {.lex_state = 173, .external_lex_state = 2},
  [2656] = {.lex_state = 72},
  [2657] = {.lex_state = 82, .external_lex_state = 4},
  [2658] = {.lex_state = 110, .external_lex_state = 8},
  [2659] = {.lex_state = 234, .external_lex_state = 27},
  [2660] = {.lex_state = 234, .external_lex_state = 27},
  [2661] = {.lex_state = 234, .external_lex_state = 27},
  [2662] = {.lex_state = 240, .external_lex_state = 28},
  [2663] = {.lex_state = 240, .external_lex_state = 28},
  [2664] = {.lex_state = 240, .external_lex_state = 28},
  [2665] = {.lex_state = 240, .external_lex_state = 28},
  [2666] = {.lex_state = 223, .external_lex_state = 16},
  [2667] = {.lex_state = 240, .external_lex_state = 28},
  [2668] = {.lex_state = 223, .external_lex_state = 16},
  [2669] = {.lex_state = 240, .external_lex_state = 28},
  [2670] = {.lex_state = 223, .external_lex_state = 16},
  [2671] = {.lex_state = 240, .external_lex_state = 28},
  [2672] = {.lex_state = 240, .external_lex_state = 28},
  [2673] = {.lex_state = 245, .external_lex_state = 10},
  [2674] = {.lex_state = 245, .external_lex_state = 10},
  [2675] = {.lex_state = 72},
  [2676] = {.lex_state = 245, .external_lex_state = 10},
  [2677] = {.lex_state = 245, .external_lex_state = 10},
  [2678] = {.lex_state = 90},
  [2679] = {.lex_state = 245, .external_lex_state = 10},
  [2680] = {.lex_state = 245, .external_lex_state = 10},
  [2681] = {.lex_state = 245, .external_lex_state = 10},
  [2682] = {.lex_state = 62},
  [2683] = {.lex_state = 151, .external_lex_state = 16},
  [2684] = {.lex_state = 154, .external_lex_state = 6},
  [2685] = {.lex_state = 151, .external_lex_state = 16},
  [2686] = {.lex_state = 151, .external_lex_state = 16},
  [2687] = {.lex_state = 68},
  [2688] = {.lex_state = 163, .external_lex_state = 2},
  [2689] = {.lex_state = 68},
  [2690] = {.lex_state = 171, .external_lex_state = 2},
  [2691] = {.lex_state = 68},
  [2692] = {.lex_state = 163, .external_lex_state = 2},
  [2693] = {.lex_state = 247, .external_lex_state = 27},
  [2694] = {.lex_state = 247, .external_lex_state = 27},
  [2695] = {.lex_state = 247, .external_lex_state = 27},
  [2696] = {.lex_state = 82, .external_lex_state = 3},
  [2697] = {.lex_state = 82, .external_lex_state = 14},
  [2698] = {.lex_state = 82, .external_lex_state = 14},
  [2699] = {.lex_state = 82, .external_lex_state = 14},
  [2700] = {.lex_state = 223, .external_lex_state = 16},
  [2701] = {.lex_state = 205, .external_lex_state = 24},
  [2702] = {.lex_state = 205, .external_lex_state = 24},
  [2703] = {.lex_state = 205, .external_lex_state = 16},
  [2704] = {.lex_state = 223, .external_lex_state = 16},
  [2705] = {.lex_state = 82, .external_lex_state = 14},
  [2706] = {.lex_state = 223, .external_lex_state = 16},
  [2707] = {.lex_state = 82, .external_lex_state = 14},
  [2708] = {.lex_state = 223, .external_lex_state = 16},
  [2709] = {.lex_state = 82, .external_lex_state = 14},
  [2710] = {.lex_state = 223, .external_lex_state = 16},
  [2711] = {.lex_state = 82, .external_lex_state = 14},
  [2712] = {.lex_state = 223, .external_lex_state = 16},
  [2713] = {.lex_state = 82, .external_lex_state = 10},
  [2714] = {.lex_state = 82, .external_lex_state = 10},
  [2715] = {.lex_state = 82, .external_lex_state = 10},
  [2716] = {.lex_state = 223, .external_lex_state = 16},
  [2717] = {.lex_state = 205, .external_lex_state = 24},
  [2718] = {.lex_state = 205, .external_lex_state = 24},
  [2719] = {.lex_state = 205, .external_lex_state = 16},
  [2720] = {.lex_state = 223, .external_lex_state = 16},
  [2721] = {.lex_state = 82, .external_lex_state = 10},
  [2722] = {.lex_state = 223, .external_lex_state = 16},
  [2723] = {.lex_state = 82, .external_lex_state = 10},
  [2724] = {.lex_state = 223, .external_lex_state = 16},
  [2725] = {.lex_state = 82, .external_lex_state = 10},
  [2726] = {.lex_state = 223, .external_lex_state = 16},
  [2727] = {.lex_state = 82, .external_lex_state = 10},
  [2728] = {.lex_state = 223, .external_lex_state = 16},
  [2729] = {.lex_state = 173, .external_lex_state = 2},
  [2730] = {.lex_state = 173, .external_lex_state = 2},
  [2731] = {.lex_state = 240, .external_lex_state = 28},
  [2732] = {.lex_state = 240, .external_lex_state = 28},
  [2733] = {.lex_state = 240, .external_lex_state = 28},
  [2734] = {.lex_state = 245, .external_lex_state = 10},
  [2735] = {.lex_state = 245, .external_lex_state = 10},
  [2736] = {.lex_state = 245, .external_lex_state = 10},
  [2737] = {.lex_state = 221, .external_lex_state = 16},
  [2738] = {.lex_state = 245, .external_lex_state = 10},
  [2739] = {.lex_state = 225},
  [2740] = {.lex_state = 223, .external_lex_state = 16},
  [2741] = {.lex_state = 62},
  [2742] = {.lex_state = 151, .external_lex_state = 16},
  [2743] = {.lex_state = 151, .external_lex_state = 16},
  [2744] = {.lex_state = 151, .external_lex_state = 16},
  [2745] = {.lex_state = 245, .external_lex_state = 10},
  [2746] = {.lex_state = 225},
  [2747] = {.lex_state = 223, .external_lex_state = 16},
  [2748] = {.lex_state = 245, .external_lex_state = 10},
  [2749] = {.lex_state = 225},
  [2750] = {.lex_state = 223, .external_lex_state = 16},
  [2751] = {.lex_state = 245, .external_lex_state = 10},
  [2752] = {.lex_state = 245, .external_lex_state = 10},
  [2753] = {.lex_state = 247, .external_lex_state = 27},
  [2754] = {.lex_state = 82, .external_lex_state = 14},
  [2755] = {.lex_state = 82, .external_lex_state = 14},
  [2756] = {.lex_state = 82, .external_lex_state = 14},
  [2757] = {.lex_state = 82, .external_lex_state = 14},
  [2758] = {.lex_state = 223, .external_lex_state = 16},
  [2759] = {.lex_state = 82, .external_lex_state = 14},
  [2760] = {.lex_state = 223, .external_lex_state = 16},
  [2761] = {.lex_state = 82, .external_lex_state = 14},
  [2762] = {.lex_state = 223, .external_lex_state = 16},
  [2763] = {.lex_state = 82, .external_lex_state = 14},
  [2764] = {.lex_state = 82, .external_lex_state = 14},
  [2765] = {.lex_state = 82, .external_lex_state = 10},
  [2766] = {.lex_state = 82, .external_lex_state = 10},
  [2767] = {.lex_state = 82, .external_lex_state = 10},
  [2768] = {.lex_state = 82, .external_lex_state = 10},
  [2769] = {.lex_state = 223, .external_lex_state = 16},
  [2770] = {.lex_state = 82, .external_lex_state = 10},
  [2771] = {.lex_state = 223, .external_lex_state = 16},
  [2772] = {.lex_state = 82, .external_lex_state = 10},
  [2773] = {.lex_state = 223, .external_lex_state = 16},
  [2774] = {.lex_state = 82, .external_lex_state = 10},
  [2775] = {.lex_state = 82, .external_lex_state = 10},
  [2776] = {.lex_state = 245, .external_lex_state = 10},
  [2777] = {.lex_state = 205, .external_lex_state = 24},
  [2778] = {.lex_state = 205, .external_lex_state = 24},
  [2779] = {.lex_state = 205, .external_lex_state = 16},
  [2780] = {.lex_state = 223, .external_lex_state = 16},
  [2781] = {.lex_state = 245, .external_lex_state = 10},
  [2782] = {.lex_state = 221, .external_lex_state = 16},
  [2783] = {.lex_state = 245, .external_lex_state = 10},
  [2784] = {.lex_state = 225},
  [2785] = {.lex_state = 223, .external_lex_state = 16},
  [2786] = {.lex_state = 245, .external_lex_state = 10},
  [2787] = {.lex_state = 225},
  [2788] = {.lex_state = 223, .external_lex_state = 16},
  [2789] = {.lex_state = 225},
  [2790] = {.lex_state = 223, .external_lex_state = 16},
  [2791] = {.lex_state = 223, .external_lex_state = 16},
  [2792] = {.lex_state = 245, .external_lex_state = 10},
  [2793] = {.lex_state = 223, .external_lex_state = 16},
  [2794] = {.lex_state = 82, .external_lex_state = 14},
  [2795] = {.lex_state = 82, .external_lex_state = 14},
  [2796] = {.lex_state = 82, .external_lex_state = 14},
  [2797] = {.lex_state = 82, .external_lex_state = 10},
  [2798] = {.lex_state = 82, .external_lex_state = 10},
  [2799] = {.lex_state = 82, .external_lex_state = 10},
  [2800] = {.lex_state = 245, .external_lex_state = 10},
  [2801] = {.lex_state = 245, .external_lex_state = 10},
  [2802] = {.lex_state = 245, .external_lex_state = 10},
  [2803] = {.lex_state = 223, .external_lex_state = 16},
  [2804] = {.lex_state = 205, .external_lex_state = 24},
  [2805] = {.lex_state = 205, .external_lex_state = 24},
  [2806] = {.lex_state = 205, .external_lex_state = 16},
  [2807] = {.lex_state = 223, .external_lex_state = 16},
  [2808] = {.lex_state = 245, .external_lex_state = 10},
  [2809] = {.lex_state = 223, .external_lex_state = 16},
  [2810] = {.lex_state = 245, .external_lex_state = 10},
  [2811] = {.lex_state = 223, .external_lex_state = 16},
  [2812] = {.lex_state = 245, .external_lex_state = 10},
  [2813] = {.lex_state = 223, .external_lex_state = 16},
  [2814] = {.lex_state = 245, .external_lex_state = 10},
  [2815] = {.lex_state = 223, .external_lex_state = 16},
  [2816] = {.lex_state = 245, .external_lex_state = 10},
  [2817] = {.lex_state = 245, .external_lex_state = 10},
  [2818] = {.lex_state = 245, .external_lex_state = 10},
  [2819] = {.lex_state = 245, .external_lex_state = 10},
  [2820] = {.lex_state = 223, .external_lex_state = 16},
  [2821] = {.lex_state = 245, .external_lex_state = 10},
  [2822] = {.lex_state = 223, .external_lex_state = 16},
  [2823] = {.lex_state = 245, .external_lex_state = 10},
  [2824] = {.lex_state = 223, .external_lex_state = 16},
  [2825] = {.lex_state = 245, .external_lex_state = 10},
  [2826] = {.lex_state = 245, .external_lex_state = 10},
  [2827] = {.lex_state = 245, .external_lex_state = 10},
  [2828] = {.lex_state = 245, .external_lex_state = 10},
  [2829] = {.lex_state = 245, .external_lex_state = 10},
};

enum {
  ts_external_token_heredoc_start,
  ts_external_token__simple_heredoc_body,
  ts_external_token__heredoc_body_beginning,
  ts_external_token__heredoc_body_middle,
  ts_external_token__heredoc_body_end,
  ts_external_token_file_descriptor,
  ts_external_token__empty_value,
  ts_external_token__concat,
  ts_external_token_variable_name,
  ts_external_token_RBRACE,
  ts_external_token_RBRACK,
  ts_external_token_LF,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_heredoc_start] = sym_heredoc_start,
  [ts_external_token__simple_heredoc_body] = sym__simple_heredoc_body,
  [ts_external_token__heredoc_body_beginning] = sym__heredoc_body_beginning,
  [ts_external_token__heredoc_body_middle] = sym__heredoc_body_middle,
  [ts_external_token__heredoc_body_end] = sym__heredoc_body_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[29][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_heredoc_start] = true,
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_RBRACK] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
  },
  [3] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [4] = {
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [6] = {
    [ts_external_token_variable_name] = true,
  },
  [7] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [8] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [9] = {
    [ts_external_token__empty_value] = true,
  },
  [10] = {
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [11] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
  },
  [12] = {
    [ts_external_token_RBRACK] = true,
  },
  [13] = {
    [ts_external_token__concat] = true,
  },
  [14] = {
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [15] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [16] = {
    [ts_external_token_RBRACE] = true,
  },
  [17] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [18] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
  },
  [19] = {
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
  },
  [20] = {
    [ts_external_token_heredoc_start] = true,
  },
  [21] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [22] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
  },
  [23] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [24] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACE] = true,
  },
  [25] = {
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [26] = {
    [ts_external_token_file_descriptor] = true,
  },
  [27] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [28] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_heredoc_start] = ACTIONS(1),
    [sym__simple_heredoc_body] = ACTIONS(1),
    [sym__heredoc_body_beginning] = ACTIONS(1),
    [sym__heredoc_body_middle] = ACTIONS(1),
    [sym__heredoc_body_end] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(3),
    [anon_sym_done] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_fi] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_esac] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SEMI_SEMI] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PIPE_AMP] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_typeset] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(3),
    [anon_sym_unsetenv] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_GT] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(1),
    [anon_sym_LT_AMP] = ACTIONS(1),
    [anon_sym_GT_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_LT_LT_LT] = ACTIONS(1),
    [sym__special_characters] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(3),
    [sym_raw_string] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [aux_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_COLON_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_LT_LPAREN] = ACTIONS(1),
    [anon_sym_GT_LPAREN] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(25),
    [sym__terminated_statement] = STATE(32),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(32),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(9),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(57),
    [anon_sym_GT] = ACTIONS(57),
    [anon_sym_GT_GT] = ACTIONS(59),
    [anon_sym_AMP_GT] = ACTIONS(57),
    [anon_sym_AMP_GT_GT] = ACTIONS(59),
    [anon_sym_LT_AMP] = ACTIONS(59),
    [anon_sym_GT_AMP] = ACTIONS(59),
    [sym_comment] = ACTIONS(53),
  },
  [3] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(63),
    [anon_sym_PLUS_EQ] = ACTIONS(63),
    [sym_comment] = ACTIONS(53),
  },
  [4] = {
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(65),
  },
  [5] = {
    [sym__terminated_statement] = STATE(38),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [6] = {
    [sym__terminated_statement] = STATE(41),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [7] = {
    [sym_concatenation] = STATE(50),
    [sym_string] = STATE(45),
    [sym_simple_expansion] = STATE(45),
    [sym_string_expansion] = STATE(45),
    [sym_expansion] = STATE(45),
    [sym_command_substitution] = STATE(45),
    [sym_process_substitution] = STATE(45),
    [sym__special_characters] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [anon_sym_DOLLAR] = ACTIONS(71),
    [sym_raw_string] = ACTIONS(73),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(75),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(77),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(73),
  },
  [8] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(83),
  },
  [9] = {
    [sym__terminated_statement] = STATE(67),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_case_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_subshell] = STATE(63),
    [sym_pipeline] = STATE(63),
    [sym_list] = STATE(63),
    [sym_negated_command] = STATE(63),
    [sym_test_command] = STATE(63),
    [sym_declaration_command] = STATE(63),
    [sym_unset_command] = STATE(63),
    [sym_command] = STATE(63),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(65),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_program_repeat1] = STATE(67),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_typeset] = ACTIONS(97),
    [anon_sym_export] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_local] = ACTIONS(97),
    [anon_sym_unset] = ACTIONS(99),
    [anon_sym_unsetenv] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(105),
  },
  [10] = {
    [sym_subshell] = STATE(70),
    [sym_test_command] = STATE(70),
    [sym_command] = STATE(70),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(43),
  },
  [11] = {
    [sym__expression] = STATE(82),
    [sym_binary_expression] = STATE(82),
    [sym_unary_expression] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(131),
  },
  [12] = {
    [sym__expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_parenthesized_expression] = STATE(93),
    [sym_concatenation] = STATE(93),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [13] = {
    [sym_variable_assignment] = STATE(105),
    [sym_subscript] = STATE(104),
    [sym_concatenation] = STATE(105),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym_declaration_command_repeat1] = STATE(105),
    [sym_variable_name] = ACTIONS(157),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(159),
    [anon_sym_PIPE_AMP] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(159),
    [anon_sym_PIPE_PIPE] = ACTIONS(159),
    [sym__special_characters] = ACTIONS(161),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(179),
    [sym_word] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_LF] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(159),
  },
  [14] = {
    [sym_concatenation] = STATE(115),
    [sym_string] = STATE(109),
    [sym_simple_expansion] = STATE(109),
    [sym_string_expansion] = STATE(109),
    [sym_expansion] = STATE(109),
    [sym_command_substitution] = STATE(109),
    [sym_process_substitution] = STATE(109),
    [aux_sym_unset_command_repeat1] = STATE(115),
    [anon_sym_PIPE] = ACTIONS(183),
    [anon_sym_SEMI_SEMI] = ACTIONS(183),
    [anon_sym_PIPE_AMP] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [sym__special_characters] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(193),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(195),
    [anon_sym_BQUOTE] = ACTIONS(197),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(201),
    [sym_word] = ACTIONS(191),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_LF] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(183),
  },
  [15] = {
    [sym_concatenation] = STATE(124),
    [sym_string] = STATE(119),
    [sym_simple_expansion] = STATE(119),
    [sym_string_expansion] = STATE(119),
    [sym_expansion] = STATE(119),
    [sym_command_substitution] = STATE(119),
    [sym_process_substitution] = STATE(119),
    [sym__special_characters] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(211),
  },
  [16] = {
    [aux_sym_concatenation_repeat1] = STATE(126),
    [sym__simple_heredoc_body] = ACTIONS(221),
    [sym__heredoc_body_beginning] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(225),
    [anon_sym_SEMI_SEMI] = ACTIONS(225),
    [anon_sym_PIPE_AMP] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_EQ_TILDE] = ACTIONS(225),
    [anon_sym_EQ_EQ] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(225),
    [anon_sym_GT] = ACTIONS(225),
    [anon_sym_GT_GT] = ACTIONS(225),
    [anon_sym_AMP_GT] = ACTIONS(225),
    [anon_sym_AMP_GT_GT] = ACTIONS(225),
    [anon_sym_LT_AMP] = ACTIONS(225),
    [anon_sym_GT_AMP] = ACTIONS(225),
    [anon_sym_LT_LT] = ACTIONS(225),
    [anon_sym_LT_LT_DASH] = ACTIONS(225),
    [anon_sym_LT_LT_LT] = ACTIONS(225),
    [sym__special_characters] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [sym_raw_string] = ACTIONS(225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(225),
    [anon_sym_SEMI] = ACTIONS(225),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_AMP] = ACTIONS(225),
  },
  [17] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(133),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [18] = {
    [sym_string] = STATE(135),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_POUND] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(243),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_0] = ACTIONS(245),
    [anon_sym__] = ACTIONS(245),
  },
  [19] = {
    [aux_sym_concatenation_repeat1] = STATE(126),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_SEMI_SEMI] = ACTIONS(249),
    [anon_sym_PIPE_AMP] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(249),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(249),
    [anon_sym_LT_AMP] = ACTIONS(249),
    [anon_sym_GT_AMP] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(249),
    [anon_sym_LT_LT_LT] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(249),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_LT_LPAREN] = ACTIONS(249),
    [anon_sym_GT_LPAREN] = ACTIONS(249),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(249),
  },
  [20] = {
    [sym_subscript] = STATE(141),
    [sym_variable_name] = ACTIONS(251),
    [anon_sym_DOLLAR] = ACTIONS(253),
    [anon_sym_POUND] = ACTIONS(255),
    [anon_sym_DASH] = ACTIONS(253),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(257),
    [anon_sym_STAR] = ACTIONS(253),
    [anon_sym_AT] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(253),
    [anon_sym_0] = ACTIONS(259),
    [anon_sym__] = ACTIONS(259),
  },
  [21] = {
    [sym_for_statement] = STATE(163),
    [sym_while_statement] = STATE(163),
    [sym_if_statement] = STATE(163),
    [sym_case_statement] = STATE(163),
    [sym_function_definition] = STATE(163),
    [sym_subshell] = STATE(163),
    [sym_pipeline] = STATE(163),
    [sym_list] = STATE(163),
    [sym_negated_command] = STATE(163),
    [sym_test_command] = STATE(163),
    [sym_declaration_command] = STATE(163),
    [sym_unset_command] = STATE(163),
    [sym_command] = STATE(163),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(165),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [22] = {
    [sym_for_statement] = STATE(180),
    [sym_while_statement] = STATE(180),
    [sym_if_statement] = STATE(180),
    [sym_case_statement] = STATE(180),
    [sym_function_definition] = STATE(180),
    [sym_subshell] = STATE(180),
    [sym_pipeline] = STATE(180),
    [sym_list] = STATE(180),
    [sym_negated_command] = STATE(180),
    [sym_test_command] = STATE(180),
    [sym_declaration_command] = STATE(180),
    [sym_unset_command] = STATE(180),
    [sym_command] = STATE(180),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(182),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [23] = {
    [sym_for_statement] = STATE(185),
    [sym_while_statement] = STATE(185),
    [sym_if_statement] = STATE(185),
    [sym_case_statement] = STATE(185),
    [sym_function_definition] = STATE(185),
    [sym_subshell] = STATE(185),
    [sym_pipeline] = STATE(185),
    [sym_list] = STATE(185),
    [sym_negated_command] = STATE(185),
    [sym_test_command] = STATE(185),
    [sym_declaration_command] = STATE(185),
    [sym_unset_command] = STATE(185),
    [sym_command] = STATE(185),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(186),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [24] = {
    [aux_sym_concatenation_repeat1] = STATE(126),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_SEMI_SEMI] = ACTIONS(249),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(249),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(249),
    [anon_sym_LT_AMP] = ACTIONS(249),
    [anon_sym_GT_AMP] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(249),
    [anon_sym_LT_LT_LT] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(249),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_LT_LPAREN] = ACTIONS(249),
    [anon_sym_GT_LPAREN] = ACTIONS(249),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(249),
  },
  [25] = {
    [ts_builtin_sym_end] = ACTIONS(327),
    [sym_comment] = ACTIONS(53),
  },
  [26] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(331),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [27] = {
    [sym_file_redirect] = STATE(201),
    [sym_heredoc_redirect] = STATE(201),
    [sym_heredoc_body] = STATE(200),
    [sym_herestring_redirect] = STATE(201),
    [sym_concatenation] = STATE(202),
    [sym_string] = STATE(199),
    [sym_simple_expansion] = STATE(199),
    [sym_string_expansion] = STATE(199),
    [sym_expansion] = STATE(199),
    [sym_command_substitution] = STATE(199),
    [sym_process_substitution] = STATE(199),
    [aux_sym_while_statement_repeat1] = STATE(201),
    [aux_sym_command_repeat2] = STATE(202),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_SEMI_SEMI] = ACTIONS(343),
    [anon_sym_PIPE_AMP] = ACTIONS(343),
    [anon_sym_AMP_AMP] = ACTIONS(343),
    [anon_sym_PIPE_PIPE] = ACTIONS(343),
    [anon_sym_EQ_TILDE] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(345),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(357),
    [anon_sym_SEMI] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(367),
    [anon_sym_AMP] = ACTIONS(343),
  },
  [28] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(331),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [29] = {
    [anon_sym_EQ] = ACTIONS(63),
    [anon_sym_PLUS_EQ] = ACTIONS(63),
    [sym_comment] = ACTIONS(53),
  },
  [30] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [31] = {
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [anon_sym_esac] = ACTIONS(249),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_RPAREN] = ACTIONS(249),
    [anon_sym_SEMI_SEMI] = ACTIONS(249),
    [anon_sym_PIPE_AMP] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(249),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(249),
    [anon_sym_LT_AMP] = ACTIONS(249),
    [anon_sym_GT_AMP] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(249),
    [anon_sym_LT_LT_LT] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(249),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_LT_LPAREN] = ACTIONS(249),
    [anon_sym_GT_LPAREN] = ACTIONS(249),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(249),
  },
  [32] = {
    [sym__terminated_statement] = STATE(203),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(203),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [33] = {
    [sym_command_name] = STATE(204),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(205),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(43),
  },
  [34] = {
    [sym_concatenation] = STATE(208),
    [sym_string] = STATE(207),
    [sym_simple_expansion] = STATE(207),
    [sym_string_expansion] = STATE(207),
    [sym_expansion] = STATE(207),
    [sym_command_substitution] = STATE(207),
    [sym_process_substitution] = STATE(207),
    [sym__special_characters] = ACTIONS(377),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(379),
  },
  [35] = {
    [sym_concatenation] = STATE(211),
    [sym_string] = STATE(210),
    [sym_simple_expansion] = STATE(210),
    [sym_string_expansion] = STATE(210),
    [sym_expansion] = STATE(210),
    [sym_command_substitution] = STATE(210),
    [sym_process_substitution] = STATE(210),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(383),
  },
  [36] = {
    [sym_concatenation] = STATE(212),
    [sym_string] = STATE(217),
    [sym_array] = STATE(212),
    [sym_simple_expansion] = STATE(217),
    [sym_string_expansion] = STATE(217),
    [sym_expansion] = STATE(217),
    [sym_command_substitution] = STATE(217),
    [sym_process_substitution] = STATE(217),
    [sym__empty_value] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(387),
    [sym__special_characters] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [sym_raw_string] = ACTIONS(395),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(399),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(403),
    [anon_sym_GT_LPAREN] = ACTIONS(403),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(395),
  },
  [37] = {
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(407),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(407),
    [anon_sym_LF] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(407),
  },
  [38] = {
    [sym_do_group] = STATE(225),
    [anon_sym_do] = ACTIONS(411),
    [sym_comment] = ACTIONS(53),
  },
  [39] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(413),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(413),
    [anon_sym_LF] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(413),
  },
  [40] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(413),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(413),
    [anon_sym_LF] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(413),
  },
  [41] = {
    [anon_sym_then] = ACTIONS(417),
    [sym_comment] = ACTIONS(53),
  },
  [42] = {
    [aux_sym_concatenation_repeat1] = STATE(231),
    [sym__concat] = ACTIONS(419),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_SEMI_SEMI] = ACTIONS(423),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_LF] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [43] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(233),
    [anon_sym_DQUOTE] = ACTIONS(427),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [44] = {
    [sym_string] = STATE(235),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [anon_sym_DOLLAR] = ACTIONS(429),
    [sym_raw_string] = ACTIONS(431),
    [anon_sym_POUND] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(429),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(433),
    [anon_sym_STAR] = ACTIONS(429),
    [anon_sym_AT] = ACTIONS(429),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_0] = ACTIONS(435),
    [anon_sym__] = ACTIONS(435),
  },
  [45] = {
    [aux_sym_concatenation_repeat1] = STATE(231),
    [sym__concat] = ACTIONS(419),
    [anon_sym_in] = ACTIONS(437),
    [anon_sym_SEMI_SEMI] = ACTIONS(439),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [46] = {
    [sym_subscript] = STATE(243),
    [sym_variable_name] = ACTIONS(443),
    [anon_sym_DOLLAR] = ACTIONS(445),
    [anon_sym_POUND] = ACTIONS(447),
    [anon_sym_DASH] = ACTIONS(445),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_AT] = ACTIONS(445),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_0] = ACTIONS(451),
    [anon_sym__] = ACTIONS(451),
  },
  [47] = {
    [sym_for_statement] = STATE(244),
    [sym_while_statement] = STATE(244),
    [sym_if_statement] = STATE(244),
    [sym_case_statement] = STATE(244),
    [sym_function_definition] = STATE(244),
    [sym_subshell] = STATE(244),
    [sym_pipeline] = STATE(244),
    [sym_list] = STATE(244),
    [sym_negated_command] = STATE(244),
    [sym_test_command] = STATE(244),
    [sym_declaration_command] = STATE(244),
    [sym_unset_command] = STATE(244),
    [sym_command] = STATE(244),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(245),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [48] = {
    [sym_for_statement] = STATE(246),
    [sym_while_statement] = STATE(246),
    [sym_if_statement] = STATE(246),
    [sym_case_statement] = STATE(246),
    [sym_function_definition] = STATE(246),
    [sym_subshell] = STATE(246),
    [sym_pipeline] = STATE(246),
    [sym_list] = STATE(246),
    [sym_negated_command] = STATE(246),
    [sym_test_command] = STATE(246),
    [sym_declaration_command] = STATE(246),
    [sym_unset_command] = STATE(246),
    [sym_command] = STATE(246),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(247),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [49] = {
    [sym_for_statement] = STATE(248),
    [sym_while_statement] = STATE(248),
    [sym_if_statement] = STATE(248),
    [sym_case_statement] = STATE(248),
    [sym_function_definition] = STATE(248),
    [sym_subshell] = STATE(248),
    [sym_pipeline] = STATE(248),
    [sym_list] = STATE(248),
    [sym_negated_command] = STATE(248),
    [sym_test_command] = STATE(248),
    [sym_declaration_command] = STATE(248),
    [sym_unset_command] = STATE(248),
    [sym_command] = STATE(248),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(249),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [50] = {
    [anon_sym_in] = ACTIONS(437),
    [anon_sym_SEMI_SEMI] = ACTIONS(439),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [51] = {
    [sym_compound_statement] = STATE(252),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [52] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(457),
    [anon_sym_PLUS_EQ] = ACTIONS(457),
    [sym_comment] = ACTIONS(53),
  },
  [53] = {
    [sym__terminated_statement] = STATE(254),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [54] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(459),
  },
  [55] = {
    [sym_subshell] = STATE(70),
    [sym_test_command] = STATE(70),
    [sym_command] = STATE(70),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(103),
  },
  [56] = {
    [sym__expression] = STATE(256),
    [sym_binary_expression] = STATE(256),
    [sym_unary_expression] = STATE(256),
    [sym_parenthesized_expression] = STATE(256),
    [sym_concatenation] = STATE(256),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(131),
  },
  [57] = {
    [sym__expression] = STATE(257),
    [sym_binary_expression] = STATE(257),
    [sym_unary_expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(257),
    [sym_concatenation] = STATE(257),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [58] = {
    [sym_variable_assignment] = STATE(262),
    [sym_subscript] = STATE(261),
    [sym_concatenation] = STATE(262),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym_declaration_command_repeat1] = STATE(262),
    [sym_variable_name] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_RPAREN] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(159),
    [anon_sym_PIPE_AMP] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(159),
    [anon_sym_PIPE_PIPE] = ACTIONS(159),
    [sym__special_characters] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(179),
    [sym_word] = ACTIONS(465),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_LF] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(159),
  },
  [59] = {
    [sym_concatenation] = STATE(265),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [aux_sym_unset_command_repeat1] = STATE(265),
    [anon_sym_PIPE] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_SEMI_SEMI] = ACTIONS(183),
    [anon_sym_PIPE_AMP] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [sym__special_characters] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(193),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(195),
    [anon_sym_BQUOTE] = ACTIONS(197),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(201),
    [sym_word] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_LF] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(183),
  },
  [60] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(221),
    [sym__heredoc_body_beginning] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(225),
    [anon_sym_SEMI_SEMI] = ACTIONS(225),
    [anon_sym_PIPE_AMP] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_EQ_TILDE] = ACTIONS(225),
    [anon_sym_EQ_EQ] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(225),
    [anon_sym_GT] = ACTIONS(225),
    [anon_sym_GT_GT] = ACTIONS(225),
    [anon_sym_AMP_GT] = ACTIONS(225),
    [anon_sym_AMP_GT_GT] = ACTIONS(225),
    [anon_sym_LT_AMP] = ACTIONS(225),
    [anon_sym_GT_AMP] = ACTIONS(225),
    [anon_sym_LT_LT] = ACTIONS(225),
    [anon_sym_LT_LT_DASH] = ACTIONS(225),
    [anon_sym_LT_LT_LT] = ACTIONS(225),
    [sym__special_characters] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [sym_raw_string] = ACTIONS(225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(225),
    [anon_sym_SEMI] = ACTIONS(225),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_AMP] = ACTIONS(225),
  },
  [61] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_RPAREN] = ACTIONS(249),
    [anon_sym_SEMI_SEMI] = ACTIONS(249),
    [anon_sym_PIPE_AMP] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(249),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(249),
    [anon_sym_LT_AMP] = ACTIONS(249),
    [anon_sym_GT_AMP] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(249),
    [anon_sym_LT_LT_LT] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(249),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_LT_LPAREN] = ACTIONS(249),
    [anon_sym_GT_LPAREN] = ACTIONS(249),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(249),
  },
  [62] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_RPAREN] = ACTIONS(249),
    [anon_sym_SEMI_SEMI] = ACTIONS(249),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_PIPE_AMP] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(249),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(249),
    [anon_sym_LT_AMP] = ACTIONS(249),
    [anon_sym_GT_AMP] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(249),
    [anon_sym_LT_LT_LT] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(249),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_LT_LPAREN] = ACTIONS(249),
    [anon_sym_GT_LPAREN] = ACTIONS(249),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(249),
  },
  [63] = {
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(475),
    [anon_sym_SEMI_SEMI] = ACTIONS(477),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(477),
    [anon_sym_LF] = ACTIONS(481),
    [anon_sym_AMP] = ACTIONS(477),
  },
  [64] = {
    [sym_file_redirect] = STATE(278),
    [sym_heredoc_redirect] = STATE(278),
    [sym_heredoc_body] = STATE(200),
    [sym_herestring_redirect] = STATE(278),
    [sym_concatenation] = STATE(279),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [aux_sym_while_statement_repeat1] = STATE(278),
    [aux_sym_command_repeat2] = STATE(279),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(343),
    [anon_sym_SEMI_SEMI] = ACTIONS(343),
    [anon_sym_PIPE_AMP] = ACTIONS(343),
    [anon_sym_AMP_AMP] = ACTIONS(343),
    [anon_sym_PIPE_PIPE] = ACTIONS(343),
    [anon_sym_EQ_TILDE] = ACTIONS(485),
    [anon_sym_EQ_EQ] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym__special_characters] = ACTIONS(491),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(367),
    [anon_sym_AMP] = ACTIONS(343),
  },
  [65] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(475),
    [anon_sym_SEMI_SEMI] = ACTIONS(477),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(477),
    [anon_sym_LF] = ACTIONS(481),
    [anon_sym_AMP] = ACTIONS(477),
  },
  [66] = {
    [anon_sym_EQ] = ACTIONS(457),
    [anon_sym_PLUS_EQ] = ACTIONS(457),
    [sym_comment] = ACTIONS(53),
  },
  [67] = {
    [sym__terminated_statement] = STATE(282),
    [sym_for_statement] = STATE(280),
    [sym_while_statement] = STATE(280),
    [sym_if_statement] = STATE(280),
    [sym_case_statement] = STATE(280),
    [sym_function_definition] = STATE(280),
    [sym_subshell] = STATE(280),
    [sym_pipeline] = STATE(280),
    [sym_list] = STATE(280),
    [sym_negated_command] = STATE(280),
    [sym_test_command] = STATE(280),
    [sym_declaration_command] = STATE(280),
    [sym_unset_command] = STATE(280),
    [sym_command] = STATE(280),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(281),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_program_repeat1] = STATE(282),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_typeset] = ACTIONS(97),
    [anon_sym_export] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_local] = ACTIONS(97),
    [anon_sym_unset] = ACTIONS(99),
    [anon_sym_unsetenv] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(105),
  },
  [68] = {
    [sym_command_name] = STATE(283),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_command_repeat1] = STATE(205),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(495),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(103),
  },
  [69] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_PLUS_EQ] = ACTIONS(497),
    [sym_comment] = ACTIONS(53),
  },
  [70] = {
    [anon_sym_esac] = ACTIONS(499),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_RPAREN] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(499),
    [anon_sym_PIPE_AMP] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(499),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(499),
  },
  [71] = {
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_PLUS_EQ] = ACTIONS(497),
    [sym_comment] = ACTIONS(53),
  },
  [72] = {
    [sym__expression] = STATE(288),
    [sym_binary_expression] = STATE(288),
    [sym_unary_expression] = STATE(288),
    [sym_parenthesized_expression] = STATE(288),
    [sym_concatenation] = STATE(288),
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_string_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(509),
    [sym_test_operator] = ACTIONS(511),
  },
  [73] = {
    [sym__expression] = STATE(289),
    [sym_binary_expression] = STATE(289),
    [sym_unary_expression] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_concatenation] = STATE(289),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(131),
  },
  [74] = {
    [aux_sym_concatenation_repeat1] = STATE(291),
    [sym__concat] = ACTIONS(513),
    [anon_sym_AMP_AMP] = ACTIONS(515),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_RBRACK] = ACTIONS(515),
    [anon_sym_EQ_TILDE] = ACTIONS(515),
    [anon_sym_EQ_EQ] = ACTIONS(515),
    [anon_sym_EQ] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(515),
    [anon_sym_BANG_EQ] = ACTIONS(515),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(515),
  },
  [75] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(293),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [76] = {
    [sym_string] = STATE(295),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(521),
    [sym_raw_string] = ACTIONS(523),
    [anon_sym_POUND] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(525),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_AT] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(521),
    [anon_sym_0] = ACTIONS(527),
    [anon_sym__] = ACTIONS(527),
  },
  [77] = {
    [aux_sym_concatenation_repeat1] = STATE(291),
    [sym__concat] = ACTIONS(513),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_EQ_TILDE] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(529),
    [anon_sym_EQ] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(529),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(529),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(529),
  },
  [78] = {
    [sym_subscript] = STATE(301),
    [sym_variable_name] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(535),
    [anon_sym_POUND] = ACTIONS(537),
    [anon_sym_DASH] = ACTIONS(535),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(535),
    [anon_sym_QMARK] = ACTIONS(535),
    [anon_sym_0] = ACTIONS(541),
    [anon_sym__] = ACTIONS(541),
  },
  [79] = {
    [sym_for_statement] = STATE(302),
    [sym_while_statement] = STATE(302),
    [sym_if_statement] = STATE(302),
    [sym_case_statement] = STATE(302),
    [sym_function_definition] = STATE(302),
    [sym_subshell] = STATE(302),
    [sym_pipeline] = STATE(302),
    [sym_list] = STATE(302),
    [sym_negated_command] = STATE(302),
    [sym_test_command] = STATE(302),
    [sym_declaration_command] = STATE(302),
    [sym_unset_command] = STATE(302),
    [sym_command] = STATE(302),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(303),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [80] = {
    [sym_for_statement] = STATE(304),
    [sym_while_statement] = STATE(304),
    [sym_if_statement] = STATE(304),
    [sym_case_statement] = STATE(304),
    [sym_function_definition] = STATE(304),
    [sym_subshell] = STATE(304),
    [sym_pipeline] = STATE(304),
    [sym_list] = STATE(304),
    [sym_negated_command] = STATE(304),
    [sym_test_command] = STATE(304),
    [sym_declaration_command] = STATE(304),
    [sym_unset_command] = STATE(304),
    [sym_command] = STATE(304),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(305),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [81] = {
    [sym_for_statement] = STATE(306),
    [sym_while_statement] = STATE(306),
    [sym_if_statement] = STATE(306),
    [sym_case_statement] = STATE(306),
    [sym_function_definition] = STATE(306),
    [sym_subshell] = STATE(306),
    [sym_pipeline] = STATE(306),
    [sym_list] = STATE(306),
    [sym_negated_command] = STATE(306),
    [sym_test_command] = STATE(306),
    [sym_declaration_command] = STATE(306),
    [sym_unset_command] = STATE(306),
    [sym_command] = STATE(306),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(307),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [82] = {
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_RBRACK] = ACTIONS(545),
    [anon_sym_EQ_TILDE] = ACTIONS(547),
    [anon_sym_EQ_EQ] = ACTIONS(547),
    [anon_sym_EQ] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(543),
  },
  [83] = {
    [sym__expression] = STATE(311),
    [sym_binary_expression] = STATE(311),
    [sym_unary_expression] = STATE(311),
    [sym_parenthesized_expression] = STATE(311),
    [sym_concatenation] = STATE(311),
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_string_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(509),
    [sym_test_operator] = ACTIONS(511),
  },
  [84] = {
    [sym__expression] = STATE(312),
    [sym_binary_expression] = STATE(312),
    [sym_unary_expression] = STATE(312),
    [sym_parenthesized_expression] = STATE(312),
    [sym_concatenation] = STATE(312),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [85] = {
    [aux_sym_concatenation_repeat1] = STATE(314),
    [sym__concat] = ACTIONS(551),
    [anon_sym_AMP_AMP] = ACTIONS(515),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(515),
    [anon_sym_EQ_TILDE] = ACTIONS(515),
    [anon_sym_EQ_EQ] = ACTIONS(515),
    [anon_sym_EQ] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(515),
    [anon_sym_BANG_EQ] = ACTIONS(515),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(515),
  },
  [86] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(316),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [87] = {
    [sym_string] = STATE(318),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(557),
    [anon_sym_POUND] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(555),
    [anon_sym_AT] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_0] = ACTIONS(561),
    [anon_sym__] = ACTIONS(561),
  },
  [88] = {
    [aux_sym_concatenation_repeat1] = STATE(314),
    [sym__concat] = ACTIONS(551),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(529),
    [anon_sym_EQ_TILDE] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(529),
    [anon_sym_EQ] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(529),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(529),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(529),
  },
  [89] = {
    [sym_subscript] = STATE(324),
    [sym_variable_name] = ACTIONS(563),
    [anon_sym_DOLLAR] = ACTIONS(565),
    [anon_sym_POUND] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(565),
    [anon_sym_AT] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_0] = ACTIONS(571),
    [anon_sym__] = ACTIONS(571),
  },
  [90] = {
    [sym_for_statement] = STATE(325),
    [sym_while_statement] = STATE(325),
    [sym_if_statement] = STATE(325),
    [sym_case_statement] = STATE(325),
    [sym_function_definition] = STATE(325),
    [sym_subshell] = STATE(325),
    [sym_pipeline] = STATE(325),
    [sym_list] = STATE(325),
    [sym_negated_command] = STATE(325),
    [sym_test_command] = STATE(325),
    [sym_declaration_command] = STATE(325),
    [sym_unset_command] = STATE(325),
    [sym_command] = STATE(325),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(326),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [91] = {
    [sym_for_statement] = STATE(327),
    [sym_while_statement] = STATE(327),
    [sym_if_statement] = STATE(327),
    [sym_case_statement] = STATE(327),
    [sym_function_definition] = STATE(327),
    [sym_subshell] = STATE(327),
    [sym_pipeline] = STATE(327),
    [sym_list] = STATE(327),
    [sym_negated_command] = STATE(327),
    [sym_test_command] = STATE(327),
    [sym_declaration_command] = STATE(327),
    [sym_unset_command] = STATE(327),
    [sym_command] = STATE(327),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(328),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [92] = {
    [sym_for_statement] = STATE(329),
    [sym_while_statement] = STATE(329),
    [sym_if_statement] = STATE(329),
    [sym_case_statement] = STATE(329),
    [sym_function_definition] = STATE(329),
    [sym_subshell] = STATE(329),
    [sym_pipeline] = STATE(329),
    [sym_list] = STATE(329),
    [sym_negated_command] = STATE(329),
    [sym_test_command] = STATE(329),
    [sym_declaration_command] = STATE(329),
    [sym_unset_command] = STATE(329),
    [sym_command] = STATE(329),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(330),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [93] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(545),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [94] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(579),
    [anon_sym_PLUS_EQ] = ACTIONS(579),
    [sym_comment] = ACTIONS(53),
  },
  [95] = {
    [aux_sym_concatenation_repeat1] = STATE(335),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(585),
    [anon_sym_SEMI_SEMI] = ACTIONS(585),
    [anon_sym_PIPE_AMP] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [sym__special_characters] = ACTIONS(585),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(585),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(585),
    [anon_sym_LF] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(585),
  },
  [96] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(337),
    [anon_sym_DQUOTE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [97] = {
    [sym_string] = STATE(339),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [sym_raw_string] = ACTIONS(593),
    [anon_sym_POUND] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(591),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(595),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [anon_sym_QMARK] = ACTIONS(591),
    [anon_sym_0] = ACTIONS(597),
    [anon_sym__] = ACTIONS(597),
  },
  [98] = {
    [aux_sym_concatenation_repeat1] = STATE(335),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(599),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_SEMI_SEMI] = ACTIONS(601),
    [anon_sym_PIPE_AMP] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [anon_sym_DOLLAR] = ACTIONS(601),
    [sym_raw_string] = ACTIONS(601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(601),
    [anon_sym_BQUOTE] = ACTIONS(601),
    [anon_sym_LT_LPAREN] = ACTIONS(601),
    [anon_sym_GT_LPAREN] = ACTIONS(601),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(601),
    [sym_word] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(601),
  },
  [99] = {
    [sym_subscript] = STATE(345),
    [sym_variable_name] = ACTIONS(603),
    [anon_sym_DOLLAR] = ACTIONS(605),
    [anon_sym_POUND] = ACTIONS(607),
    [anon_sym_DASH] = ACTIONS(605),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(609),
    [anon_sym_STAR] = ACTIONS(605),
    [anon_sym_AT] = ACTIONS(605),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_0] = ACTIONS(611),
    [anon_sym__] = ACTIONS(611),
  },
  [100] = {
    [sym_for_statement] = STATE(346),
    [sym_while_statement] = STATE(346),
    [sym_if_statement] = STATE(346),
    [sym_case_statement] = STATE(346),
    [sym_function_definition] = STATE(346),
    [sym_subshell] = STATE(346),
    [sym_pipeline] = STATE(346),
    [sym_list] = STATE(346),
    [sym_negated_command] = STATE(346),
    [sym_test_command] = STATE(346),
    [sym_declaration_command] = STATE(346),
    [sym_unset_command] = STATE(346),
    [sym_command] = STATE(346),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(347),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [101] = {
    [sym_for_statement] = STATE(348),
    [sym_while_statement] = STATE(348),
    [sym_if_statement] = STATE(348),
    [sym_case_statement] = STATE(348),
    [sym_function_definition] = STATE(348),
    [sym_subshell] = STATE(348),
    [sym_pipeline] = STATE(348),
    [sym_list] = STATE(348),
    [sym_negated_command] = STATE(348),
    [sym_test_command] = STATE(348),
    [sym_declaration_command] = STATE(348),
    [sym_unset_command] = STATE(348),
    [sym_command] = STATE(348),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(349),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [102] = {
    [sym_for_statement] = STATE(350),
    [sym_while_statement] = STATE(350),
    [sym_if_statement] = STATE(350),
    [sym_case_statement] = STATE(350),
    [sym_function_definition] = STATE(350),
    [sym_subshell] = STATE(350),
    [sym_pipeline] = STATE(350),
    [sym_list] = STATE(350),
    [sym_negated_command] = STATE(350),
    [sym_test_command] = STATE(350),
    [sym_declaration_command] = STATE(350),
    [sym_unset_command] = STATE(350),
    [sym_command] = STATE(350),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(351),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [103] = {
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(615),
    [anon_sym_SEMI_SEMI] = ACTIONS(615),
    [anon_sym_PIPE_AMP] = ACTIONS(615),
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [sym__special_characters] = ACTIONS(615),
    [anon_sym_DQUOTE] = ACTIONS(615),
    [anon_sym_DOLLAR] = ACTIONS(615),
    [sym_raw_string] = ACTIONS(615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(615),
    [anon_sym_BQUOTE] = ACTIONS(615),
    [anon_sym_LT_LPAREN] = ACTIONS(615),
    [anon_sym_GT_LPAREN] = ACTIONS(615),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(615),
    [sym_word] = ACTIONS(615),
    [anon_sym_SEMI] = ACTIONS(615),
    [anon_sym_LF] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(615),
  },
  [104] = {
    [anon_sym_EQ] = ACTIONS(579),
    [anon_sym_PLUS_EQ] = ACTIONS(579),
    [sym_comment] = ACTIONS(53),
  },
  [105] = {
    [sym_variable_assignment] = STATE(352),
    [sym_subscript] = STATE(104),
    [sym_concatenation] = STATE(352),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym_declaration_command_repeat1] = STATE(352),
    [sym_variable_name] = ACTIONS(157),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(617),
    [anon_sym_PIPE_AMP] = ACTIONS(617),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [sym__special_characters] = ACTIONS(161),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(179),
    [sym_word] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LF] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(617),
  },
  [106] = {
    [aux_sym_concatenation_repeat1] = STATE(354),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_SEMI_SEMI] = ACTIONS(623),
    [anon_sym_PIPE_AMP] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(623),
    [sym__special_characters] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [sym_raw_string] = ACTIONS(623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(623),
    [anon_sym_BQUOTE] = ACTIONS(623),
    [anon_sym_LT_LPAREN] = ACTIONS(623),
    [anon_sym_GT_LPAREN] = ACTIONS(623),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(623),
    [sym_word] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(623),
    [anon_sym_LF] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(623),
  },
  [107] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(356),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [108] = {
    [sym_string] = STATE(358),
    [anon_sym_DQUOTE] = ACTIONS(629),
    [anon_sym_DOLLAR] = ACTIONS(631),
    [sym_raw_string] = ACTIONS(633),
    [anon_sym_POUND] = ACTIONS(631),
    [anon_sym_DASH] = ACTIONS(631),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(635),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(631),
    [anon_sym_QMARK] = ACTIONS(631),
    [anon_sym_0] = ACTIONS(637),
    [anon_sym__] = ACTIONS(637),
  },
  [109] = {
    [aux_sym_concatenation_repeat1] = STATE(354),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_SEMI_SEMI] = ACTIONS(639),
    [anon_sym_PIPE_AMP] = ACTIONS(639),
    [anon_sym_AMP_AMP] = ACTIONS(639),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [sym__special_characters] = ACTIONS(639),
    [anon_sym_DQUOTE] = ACTIONS(639),
    [anon_sym_DOLLAR] = ACTIONS(639),
    [sym_raw_string] = ACTIONS(639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(639),
    [anon_sym_BQUOTE] = ACTIONS(639),
    [anon_sym_LT_LPAREN] = ACTIONS(639),
    [anon_sym_GT_LPAREN] = ACTIONS(639),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(639),
    [sym_word] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(639),
    [anon_sym_LF] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(639),
  },
  [110] = {
    [sym_subscript] = STATE(364),
    [sym_variable_name] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(645),
    [anon_sym_POUND] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(645),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(645),
    [anon_sym_AT] = ACTIONS(645),
    [anon_sym_QMARK] = ACTIONS(645),
    [anon_sym_0] = ACTIONS(651),
    [anon_sym__] = ACTIONS(651),
  },
  [111] = {
    [sym_for_statement] = STATE(365),
    [sym_while_statement] = STATE(365),
    [sym_if_statement] = STATE(365),
    [sym_case_statement] = STATE(365),
    [sym_function_definition] = STATE(365),
    [sym_subshell] = STATE(365),
    [sym_pipeline] = STATE(365),
    [sym_list] = STATE(365),
    [sym_negated_command] = STATE(365),
    [sym_test_command] = STATE(365),
    [sym_declaration_command] = STATE(365),
    [sym_unset_command] = STATE(365),
    [sym_command] = STATE(365),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(366),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [112] = {
    [sym_for_statement] = STATE(367),
    [sym_while_statement] = STATE(367),
    [sym_if_statement] = STATE(367),
    [sym_case_statement] = STATE(367),
    [sym_function_definition] = STATE(367),
    [sym_subshell] = STATE(367),
    [sym_pipeline] = STATE(367),
    [sym_list] = STATE(367),
    [sym_negated_command] = STATE(367),
    [sym_test_command] = STATE(367),
    [sym_declaration_command] = STATE(367),
    [sym_unset_command] = STATE(367),
    [sym_command] = STATE(367),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(368),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [113] = {
    [sym_for_statement] = STATE(369),
    [sym_while_statement] = STATE(369),
    [sym_if_statement] = STATE(369),
    [sym_case_statement] = STATE(369),
    [sym_function_definition] = STATE(369),
    [sym_subshell] = STATE(369),
    [sym_pipeline] = STATE(369),
    [sym_list] = STATE(369),
    [sym_negated_command] = STATE(369),
    [sym_test_command] = STATE(369),
    [sym_declaration_command] = STATE(369),
    [sym_unset_command] = STATE(369),
    [sym_command] = STATE(369),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(370),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [114] = {
    [anon_sym_PIPE] = ACTIONS(653),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_SEMI_SEMI] = ACTIONS(653),
    [anon_sym_PIPE_AMP] = ACTIONS(653),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [sym__special_characters] = ACTIONS(653),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_DOLLAR] = ACTIONS(653),
    [sym_raw_string] = ACTIONS(653),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(653),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(653),
    [anon_sym_LT_LPAREN] = ACTIONS(653),
    [anon_sym_GT_LPAREN] = ACTIONS(653),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(653),
    [sym_word] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_LF] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(653),
  },
  [115] = {
    [sym_concatenation] = STATE(371),
    [sym_string] = STATE(109),
    [sym_simple_expansion] = STATE(109),
    [sym_string_expansion] = STATE(109),
    [sym_expansion] = STATE(109),
    [sym_command_substitution] = STATE(109),
    [sym_process_substitution] = STATE(109),
    [aux_sym_unset_command_repeat1] = STATE(371),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(657),
    [anon_sym_PIPE_AMP] = ACTIONS(657),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(657),
    [sym__special_characters] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(193),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(195),
    [anon_sym_BQUOTE] = ACTIONS(197),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(201),
    [sym_word] = ACTIONS(191),
    [anon_sym_SEMI] = ACTIONS(657),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(657),
  },
  [116] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [sym__special_characters] = ACTIONS(661),
    [anon_sym_DQUOTE] = ACTIONS(661),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [sym_raw_string] = ACTIONS(661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(661),
    [anon_sym_BQUOTE] = ACTIONS(661),
    [anon_sym_LT_LPAREN] = ACTIONS(661),
    [anon_sym_GT_LPAREN] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(661),
  },
  [117] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(375),
    [anon_sym_DQUOTE] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [118] = {
    [sym_string] = STATE(377),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(669),
    [sym_raw_string] = ACTIONS(671),
    [anon_sym_POUND] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(669),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_QMARK] = ACTIONS(669),
    [anon_sym_0] = ACTIONS(675),
    [anon_sym__] = ACTIONS(675),
  },
  [119] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [sym__special_characters] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [anon_sym_LT_LPAREN] = ACTIONS(677),
    [anon_sym_GT_LPAREN] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(677),
  },
  [120] = {
    [sym_subscript] = STATE(383),
    [sym_variable_name] = ACTIONS(681),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(683),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_0] = ACTIONS(689),
    [anon_sym__] = ACTIONS(689),
  },
  [121] = {
    [sym_for_statement] = STATE(384),
    [sym_while_statement] = STATE(384),
    [sym_if_statement] = STATE(384),
    [sym_case_statement] = STATE(384),
    [sym_function_definition] = STATE(384),
    [sym_subshell] = STATE(384),
    [sym_pipeline] = STATE(384),
    [sym_list] = STATE(384),
    [sym_negated_command] = STATE(384),
    [sym_test_command] = STATE(384),
    [sym_declaration_command] = STATE(384),
    [sym_unset_command] = STATE(384),
    [sym_command] = STATE(384),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(385),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [122] = {
    [sym_for_statement] = STATE(386),
    [sym_while_statement] = STATE(386),
    [sym_if_statement] = STATE(386),
    [sym_case_statement] = STATE(386),
    [sym_function_definition] = STATE(386),
    [sym_subshell] = STATE(386),
    [sym_pipeline] = STATE(386),
    [sym_list] = STATE(386),
    [sym_negated_command] = STATE(386),
    [sym_test_command] = STATE(386),
    [sym_declaration_command] = STATE(386),
    [sym_unset_command] = STATE(386),
    [sym_command] = STATE(386),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(387),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [123] = {
    [sym_for_statement] = STATE(388),
    [sym_while_statement] = STATE(388),
    [sym_if_statement] = STATE(388),
    [sym_case_statement] = STATE(388),
    [sym_function_definition] = STATE(388),
    [sym_subshell] = STATE(388),
    [sym_pipeline] = STATE(388),
    [sym_list] = STATE(388),
    [sym_negated_command] = STATE(388),
    [sym_test_command] = STATE(388),
    [sym_declaration_command] = STATE(388),
    [sym_unset_command] = STATE(388),
    [sym_command] = STATE(388),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(389),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [124] = {
    [sym_file_descriptor] = ACTIONS(677),
    [sym_variable_name] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [sym__special_characters] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [anon_sym_LT_LPAREN] = ACTIONS(677),
    [anon_sym_GT_LPAREN] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(677),
  },
  [125] = {
    [sym_string] = STATE(390),
    [sym_simple_expansion] = STATE(390),
    [sym_string_expansion] = STATE(390),
    [sym_expansion] = STATE(390),
    [sym_command_substitution] = STATE(390),
    [sym_process_substitution] = STATE(390),
    [sym__special_characters] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(691),
  },
  [126] = {
    [aux_sym_concatenation_repeat1] = STATE(391),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [127] = {
    [sym__simple_heredoc_body] = ACTIONS(697),
    [sym__heredoc_body_beginning] = ACTIONS(697),
    [sym_file_descriptor] = ACTIONS(697),
    [sym__concat] = ACTIONS(697),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_EQ_TILDE] = ACTIONS(699),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(699),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_LT_LT_DASH] = ACTIONS(699),
    [anon_sym_LT_LT_LT] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [128] = {
    [anon_sym_DOLLAR] = ACTIONS(701),
    [sym__string_content] = ACTIONS(703),
    [anon_sym_POUND] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(707),
    [anon_sym_STAR] = ACTIONS(705),
    [anon_sym_AT] = ACTIONS(705),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_0] = ACTIONS(701),
    [anon_sym__] = ACTIONS(701),
  },
  [129] = {
    [sym__concat] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_DOLLAR] = ACTIONS(711),
    [sym__string_content] = ACTIONS(713),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(711),
    [anon_sym_BQUOTE] = ACTIONS(711),
    [sym_comment] = ACTIONS(177),
  },
  [130] = {
    [sym_subscript] = STATE(400),
    [sym_variable_name] = ACTIONS(715),
    [anon_sym_DOLLAR] = ACTIONS(717),
    [anon_sym_POUND] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(717),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(721),
    [anon_sym_STAR] = ACTIONS(717),
    [anon_sym_AT] = ACTIONS(717),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_0] = ACTIONS(723),
    [anon_sym__] = ACTIONS(723),
  },
  [131] = {
    [sym_for_statement] = STATE(401),
    [sym_while_statement] = STATE(401),
    [sym_if_statement] = STATE(401),
    [sym_case_statement] = STATE(401),
    [sym_function_definition] = STATE(401),
    [sym_subshell] = STATE(401),
    [sym_pipeline] = STATE(401),
    [sym_list] = STATE(401),
    [sym_negated_command] = STATE(401),
    [sym_test_command] = STATE(401),
    [sym_declaration_command] = STATE(401),
    [sym_unset_command] = STATE(401),
    [sym_command] = STATE(401),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(402),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [132] = {
    [sym_for_statement] = STATE(403),
    [sym_while_statement] = STATE(403),
    [sym_if_statement] = STATE(403),
    [sym_case_statement] = STATE(403),
    [sym_function_definition] = STATE(403),
    [sym_subshell] = STATE(403),
    [sym_pipeline] = STATE(403),
    [sym_list] = STATE(403),
    [sym_negated_command] = STATE(403),
    [sym_test_command] = STATE(403),
    [sym_declaration_command] = STATE(403),
    [sym_unset_command] = STATE(403),
    [sym_command] = STATE(403),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(404),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [133] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [134] = {
    [sym__simple_heredoc_body] = ACTIONS(727),
    [sym__heredoc_body_beginning] = ACTIONS(727),
    [sym_file_descriptor] = ACTIONS(727),
    [sym__concat] = ACTIONS(727),
    [anon_sym_esac] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [anon_sym_EQ_TILDE] = ACTIONS(729),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(729),
    [anon_sym_AMP_GT] = ACTIONS(729),
    [anon_sym_AMP_GT_GT] = ACTIONS(729),
    [anon_sym_LT_AMP] = ACTIONS(729),
    [anon_sym_GT_AMP] = ACTIONS(729),
    [anon_sym_LT_LT] = ACTIONS(729),
    [anon_sym_LT_LT_DASH] = ACTIONS(729),
    [anon_sym_LT_LT_LT] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [135] = {
    [sym__simple_heredoc_body] = ACTIONS(731),
    [sym__heredoc_body_beginning] = ACTIONS(731),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [anon_sym_LT_LT_LT] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [136] = {
    [sym__simple_heredoc_body] = ACTIONS(735),
    [sym__heredoc_body_beginning] = ACTIONS(735),
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(737),
    [anon_sym_LT_AMP] = ACTIONS(737),
    [anon_sym_GT_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(737),
    [anon_sym_LT_LT_LT] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [137] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [sym_comment] = ACTIONS(53),
  },
  [138] = {
    [sym_concatenation] = STATE(419),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(419),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(745),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(759),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_COLON_QMARK] = ACTIONS(745),
    [anon_sym_COLON_DASH] = ACTIONS(745),
    [anon_sym_PERCENT] = ACTIONS(745),
    [anon_sym_DASH] = ACTIONS(745),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [139] = {
    [sym_subscript] = STATE(423),
    [sym_variable_name] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_AT] = ACTIONS(771),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_0] = ACTIONS(775),
    [anon_sym__] = ACTIONS(775),
  },
  [140] = {
    [sym_concatenation] = STATE(426),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(426),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(783),
    [anon_sym_COLON] = ACTIONS(779),
    [anon_sym_COLON_QMARK] = ACTIONS(779),
    [anon_sym_COLON_DASH] = ACTIONS(779),
    [anon_sym_PERCENT] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [141] = {
    [sym_concatenation] = STATE(429),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(429),
    [anon_sym_RBRACE] = ACTIONS(785),
    [anon_sym_EQ] = ACTIONS(787),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(787),
    [anon_sym_COLON_QMARK] = ACTIONS(787),
    [anon_sym_COLON_DASH] = ACTIONS(787),
    [anon_sym_PERCENT] = ACTIONS(787),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [142] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [sym_comment] = ACTIONS(53),
  },
  [143] = {
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
  },
  [144] = {
    [sym__terminated_statement] = STATE(432),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [145] = {
    [sym__terminated_statement] = STATE(433),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [146] = {
    [sym_concatenation] = STATE(436),
    [sym_string] = STATE(435),
    [sym_simple_expansion] = STATE(435),
    [sym_string_expansion] = STATE(435),
    [sym_expansion] = STATE(435),
    [sym_command_substitution] = STATE(435),
    [sym_process_substitution] = STATE(435),
    [sym__special_characters] = ACTIONS(797),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [anon_sym_DOLLAR] = ACTIONS(71),
    [sym_raw_string] = ACTIONS(799),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(75),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(77),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(799),
  },
  [147] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(801),
  },
  [148] = {
    [sym__terminated_statement] = STATE(440),
    [sym_for_statement] = STATE(438),
    [sym_while_statement] = STATE(438),
    [sym_if_statement] = STATE(438),
    [sym_case_statement] = STATE(438),
    [sym_function_definition] = STATE(438),
    [sym_subshell] = STATE(438),
    [sym_pipeline] = STATE(438),
    [sym_list] = STATE(438),
    [sym_negated_command] = STATE(438),
    [sym_test_command] = STATE(438),
    [sym_declaration_command] = STATE(438),
    [sym_unset_command] = STATE(438),
    [sym_command] = STATE(438),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(439),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_program_repeat1] = STATE(440),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_typeset] = ACTIONS(97),
    [anon_sym_export] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_local] = ACTIONS(97),
    [anon_sym_unset] = ACTIONS(99),
    [anon_sym_unsetenv] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(105),
  },
  [149] = {
    [sym_subshell] = STATE(441),
    [sym_test_command] = STATE(441),
    [sym_command] = STATE(441),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(291),
  },
  [150] = {
    [sym__expression] = STATE(442),
    [sym_binary_expression] = STATE(442),
    [sym_unary_expression] = STATE(442),
    [sym_parenthesized_expression] = STATE(442),
    [sym_concatenation] = STATE(442),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(131),
  },
  [151] = {
    [sym__expression] = STATE(443),
    [sym_binary_expression] = STATE(443),
    [sym_unary_expression] = STATE(443),
    [sym_parenthesized_expression] = STATE(443),
    [sym_concatenation] = STATE(443),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [152] = {
    [sym_variable_assignment] = STATE(455),
    [sym_subscript] = STATE(454),
    [sym_concatenation] = STATE(455),
    [sym_string] = STATE(448),
    [sym_simple_expansion] = STATE(448),
    [sym_string_expansion] = STATE(448),
    [sym_expansion] = STATE(448),
    [sym_command_substitution] = STATE(448),
    [sym_process_substitution] = STATE(448),
    [aux_sym_declaration_command_repeat1] = STATE(455),
    [sym_variable_name] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_RPAREN] = ACTIONS(181),
    [anon_sym_PIPE_AMP] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [sym__special_characters] = ACTIONS(805),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(819),
    [anon_sym_GT_LPAREN] = ACTIONS(819),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(821),
    [sym_word] = ACTIONS(823),
  },
  [153] = {
    [sym_concatenation] = STATE(465),
    [sym_string] = STATE(459),
    [sym_simple_expansion] = STATE(459),
    [sym_string_expansion] = STATE(459),
    [sym_expansion] = STATE(459),
    [sym_command_substitution] = STATE(459),
    [sym_process_substitution] = STATE(459),
    [aux_sym_unset_command_repeat1] = STATE(465),
    [anon_sym_PIPE] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(203),
    [anon_sym_PIPE_AMP] = ACTIONS(203),
    [anon_sym_AMP_AMP] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(203),
    [sym__special_characters] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(841),
    [sym_word] = ACTIONS(843),
  },
  [154] = {
    [aux_sym_concatenation_repeat1] = STATE(467),
    [sym__simple_heredoc_body] = ACTIONS(221),
    [sym__heredoc_body_beginning] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(221),
    [anon_sym_PIPE_AMP] = ACTIONS(221),
    [anon_sym_AMP_AMP] = ACTIONS(221),
    [anon_sym_PIPE_PIPE] = ACTIONS(221),
    [anon_sym_EQ_TILDE] = ACTIONS(225),
    [anon_sym_EQ_EQ] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(225),
    [anon_sym_GT] = ACTIONS(225),
    [anon_sym_GT_GT] = ACTIONS(221),
    [anon_sym_AMP_GT] = ACTIONS(225),
    [anon_sym_AMP_GT_GT] = ACTIONS(221),
    [anon_sym_LT_AMP] = ACTIONS(221),
    [anon_sym_GT_AMP] = ACTIONS(221),
    [anon_sym_LT_LT] = ACTIONS(225),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_LT] = ACTIONS(221),
    [sym__special_characters] = ACTIONS(221),
    [anon_sym_DQUOTE] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [sym_raw_string] = ACTIONS(221),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(225),
  },
  [155] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(469),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [156] = {
    [sym_string] = STATE(471),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(849),
    [anon_sym_AT] = ACTIONS(849),
    [anon_sym_QMARK] = ACTIONS(849),
    [anon_sym_0] = ACTIONS(855),
    [anon_sym__] = ACTIONS(855),
  },
  [157] = {
    [aux_sym_concatenation_repeat1] = STATE(467),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_RPAREN] = ACTIONS(247),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(249),
  },
  [158] = {
    [sym_subscript] = STATE(477),
    [sym_variable_name] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(859),
    [anon_sym_POUND] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(859),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(863),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_AT] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_0] = ACTIONS(865),
    [anon_sym__] = ACTIONS(865),
  },
  [159] = {
    [sym_for_statement] = STATE(478),
    [sym_while_statement] = STATE(478),
    [sym_if_statement] = STATE(478),
    [sym_case_statement] = STATE(478),
    [sym_function_definition] = STATE(478),
    [sym_subshell] = STATE(478),
    [sym_pipeline] = STATE(478),
    [sym_list] = STATE(478),
    [sym_negated_command] = STATE(478),
    [sym_test_command] = STATE(478),
    [sym_declaration_command] = STATE(478),
    [sym_unset_command] = STATE(478),
    [sym_command] = STATE(478),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(479),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [160] = {
    [sym_for_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_function_definition] = STATE(480),
    [sym_subshell] = STATE(480),
    [sym_pipeline] = STATE(480),
    [sym_list] = STATE(480),
    [sym_negated_command] = STATE(480),
    [sym_test_command] = STATE(480),
    [sym_declaration_command] = STATE(480),
    [sym_unset_command] = STATE(480),
    [sym_command] = STATE(480),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(481),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [161] = {
    [sym_for_statement] = STATE(482),
    [sym_while_statement] = STATE(482),
    [sym_if_statement] = STATE(482),
    [sym_case_statement] = STATE(482),
    [sym_function_definition] = STATE(482),
    [sym_subshell] = STATE(482),
    [sym_pipeline] = STATE(482),
    [sym_list] = STATE(482),
    [sym_negated_command] = STATE(482),
    [sym_test_command] = STATE(482),
    [sym_declaration_command] = STATE(482),
    [sym_unset_command] = STATE(482),
    [sym_command] = STATE(482),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(483),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [162] = {
    [aux_sym_concatenation_repeat1] = STATE(467),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_RPAREN] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(249),
  },
  [163] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(871),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [164] = {
    [sym_file_redirect] = STATE(498),
    [sym_heredoc_redirect] = STATE(498),
    [sym_heredoc_body] = STATE(497),
    [sym_herestring_redirect] = STATE(498),
    [sym_concatenation] = STATE(499),
    [sym_string] = STATE(496),
    [sym_simple_expansion] = STATE(496),
    [sym_string_expansion] = STATE(496),
    [sym_expansion] = STATE(496),
    [sym_command_substitution] = STATE(496),
    [sym_process_substitution] = STATE(496),
    [aux_sym_while_statement_repeat1] = STATE(498),
    [aux_sym_command_repeat2] = STATE(499),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(367),
    [anon_sym_PIPE_AMP] = ACTIONS(367),
    [anon_sym_AMP_AMP] = ACTIONS(367),
    [anon_sym_PIPE_PIPE] = ACTIONS(367),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym__special_characters] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(899),
  },
  [165] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(871),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [166] = {
    [anon_sym_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [sym_comment] = ACTIONS(53),
  },
  [167] = {
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_RPAREN] = ACTIONS(247),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(249),
  },
  [168] = {
    [sym_command_name] = STATE(500),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(205),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(901),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(291),
  },
  [169] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(903),
    [anon_sym_PLUS_EQ] = ACTIONS(903),
    [sym_comment] = ACTIONS(53),
  },
  [170] = {
    [sym__terminated_statement] = STATE(502),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [171] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [172] = {
    [sym_subshell] = STATE(441),
    [sym_test_command] = STATE(441),
    [sym_command] = STATE(441),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(321),
  },
  [173] = {
    [sym__expression] = STATE(504),
    [sym_binary_expression] = STATE(504),
    [sym_unary_expression] = STATE(504),
    [sym_parenthesized_expression] = STATE(504),
    [sym_concatenation] = STATE(504),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(131),
  },
  [174] = {
    [sym__expression] = STATE(505),
    [sym_binary_expression] = STATE(505),
    [sym_unary_expression] = STATE(505),
    [sym_parenthesized_expression] = STATE(505),
    [sym_concatenation] = STATE(505),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [175] = {
    [sym_variable_assignment] = STATE(510),
    [sym_subscript] = STATE(509),
    [sym_concatenation] = STATE(510),
    [sym_string] = STATE(508),
    [sym_simple_expansion] = STATE(508),
    [sym_string_expansion] = STATE(508),
    [sym_expansion] = STATE(508),
    [sym_command_substitution] = STATE(508),
    [sym_process_substitution] = STATE(508),
    [aux_sym_declaration_command_repeat1] = STATE(510),
    [sym_variable_name] = ACTIONS(907),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PIPE_AMP] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [sym__special_characters] = ACTIONS(909),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [anon_sym_LT_LPAREN] = ACTIONS(819),
    [anon_sym_GT_LPAREN] = ACTIONS(819),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(821),
    [sym_word] = ACTIONS(913),
  },
  [176] = {
    [sym_concatenation] = STATE(513),
    [sym_string] = STATE(512),
    [sym_simple_expansion] = STATE(512),
    [sym_string_expansion] = STATE(512),
    [sym_expansion] = STATE(512),
    [sym_command_substitution] = STATE(512),
    [sym_process_substitution] = STATE(512),
    [aux_sym_unset_command_repeat1] = STATE(513),
    [anon_sym_PIPE] = ACTIONS(183),
    [anon_sym_PIPE_AMP] = ACTIONS(203),
    [anon_sym_AMP_AMP] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(203),
    [sym__special_characters] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(203),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(841),
    [sym_word] = ACTIONS(919),
  },
  [177] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(221),
    [sym__heredoc_body_beginning] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(225),
    [anon_sym_PIPE_AMP] = ACTIONS(221),
    [anon_sym_AMP_AMP] = ACTIONS(221),
    [anon_sym_PIPE_PIPE] = ACTIONS(221),
    [anon_sym_EQ_TILDE] = ACTIONS(225),
    [anon_sym_EQ_EQ] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(225),
    [anon_sym_GT] = ACTIONS(225),
    [anon_sym_GT_GT] = ACTIONS(221),
    [anon_sym_AMP_GT] = ACTIONS(225),
    [anon_sym_AMP_GT_GT] = ACTIONS(221),
    [anon_sym_LT_AMP] = ACTIONS(221),
    [anon_sym_GT_AMP] = ACTIONS(221),
    [anon_sym_LT_LT] = ACTIONS(225),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_LT] = ACTIONS(221),
    [sym__special_characters] = ACTIONS(221),
    [anon_sym_DQUOTE] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [sym_raw_string] = ACTIONS(221),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(225),
  },
  [178] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(249),
  },
  [179] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(249),
  },
  [180] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(871),
    [sym_comment] = ACTIONS(53),
  },
  [181] = {
    [sym_file_redirect] = STATE(524),
    [sym_heredoc_redirect] = STATE(524),
    [sym_heredoc_body] = STATE(497),
    [sym_herestring_redirect] = STATE(524),
    [sym_concatenation] = STATE(525),
    [sym_string] = STATE(523),
    [sym_simple_expansion] = STATE(523),
    [sym_string_expansion] = STATE(523),
    [sym_expansion] = STATE(523),
    [sym_command_substitution] = STATE(523),
    [sym_process_substitution] = STATE(523),
    [aux_sym_while_statement_repeat1] = STATE(524),
    [aux_sym_command_repeat2] = STATE(525),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_PIPE_AMP] = ACTIONS(367),
    [anon_sym_AMP_AMP] = ACTIONS(367),
    [anon_sym_PIPE_PIPE] = ACTIONS(367),
    [anon_sym_EQ_TILDE] = ACTIONS(931),
    [anon_sym_EQ_EQ] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(943),
  },
  [182] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(871),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [183] = {
    [anon_sym_EQ] = ACTIONS(903),
    [anon_sym_PLUS_EQ] = ACTIONS(903),
    [sym_comment] = ACTIONS(53),
  },
  [184] = {
    [sym_command_name] = STATE(526),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(205),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(945),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(321),
  },
  [185] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [186] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [187] = {
    [anon_sym_RPAREN] = ACTIONS(949),
    [sym_comment] = ACTIONS(53),
  },
  [188] = {
    [sym_for_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_function_definition] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_pipeline] = STATE(529),
    [sym_list] = STATE(529),
    [sym_negated_command] = STATE(529),
    [sym_test_command] = STATE(529),
    [sym_declaration_command] = STATE(529),
    [sym_unset_command] = STATE(529),
    [sym_command] = STATE(529),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(530),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [189] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [ts_builtin_sym_end] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_done] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_fi] = ACTIONS(953),
    [anon_sym_elif] = ACTIONS(953),
    [anon_sym_else] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_esac] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [190] = {
    [sym_for_statement] = STATE(531),
    [sym_while_statement] = STATE(531),
    [sym_if_statement] = STATE(531),
    [sym_case_statement] = STATE(531),
    [sym_function_definition] = STATE(531),
    [sym_subshell] = STATE(531),
    [sym_pipeline] = STATE(531),
    [sym_list] = STATE(531),
    [sym_negated_command] = STATE(531),
    [sym_test_command] = STATE(531),
    [sym_declaration_command] = STATE(531),
    [sym_unset_command] = STATE(531),
    [sym_command] = STATE(531),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(532),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [191] = {
    [anon_sym_esac] = ACTIONS(955),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_RPAREN] = ACTIONS(955),
    [anon_sym_SEMI_SEMI] = ACTIONS(955),
    [anon_sym_PIPE_AMP] = ACTIONS(955),
    [anon_sym_AMP_AMP] = ACTIONS(955),
    [anon_sym_PIPE_PIPE] = ACTIONS(955),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(955),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(955),
  },
  [192] = {
    [sym_simple_expansion] = STATE(536),
    [sym_expansion] = STATE(536),
    [aux_sym_heredoc_body_repeat1] = STATE(536),
    [sym__heredoc_body_middle] = ACTIONS(959),
    [sym__heredoc_body_end] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(963),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(965),
    [sym_comment] = ACTIONS(53),
  },
  [193] = {
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(969),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(969),
    [anon_sym_LT_AMP] = ACTIONS(969),
    [anon_sym_GT_AMP] = ACTIONS(969),
    [sym_comment] = ACTIONS(53),
  },
  [194] = {
    [sym_concatenation] = STATE(540),
    [sym_string] = STATE(539),
    [sym_simple_expansion] = STATE(539),
    [sym_string_expansion] = STATE(539),
    [sym_expansion] = STATE(539),
    [sym_command_substitution] = STATE(539),
    [sym_process_substitution] = STATE(539),
    [sym__special_characters] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(973),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(973),
    [sym_regex] = ACTIONS(975),
  },
  [195] = {
    [sym_concatenation] = STATE(543),
    [sym_string] = STATE(542),
    [sym_simple_expansion] = STATE(542),
    [sym_string_expansion] = STATE(542),
    [sym_expansion] = STATE(542),
    [sym_command_substitution] = STATE(542),
    [sym_process_substitution] = STATE(542),
    [sym__special_characters] = ACTIONS(977),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(979),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(979),
  },
  [196] = {
    [sym_heredoc_start] = ACTIONS(981),
    [sym_comment] = ACTIONS(53),
  },
  [197] = {
    [sym_concatenation] = STATE(547),
    [sym_string] = STATE(546),
    [sym_simple_expansion] = STATE(546),
    [sym_string_expansion] = STATE(546),
    [sym_expansion] = STATE(546),
    [sym_command_substitution] = STATE(546),
    [sym_process_substitution] = STATE(546),
    [sym__special_characters] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(985),
  },
  [198] = {
    [aux_sym_concatenation_repeat1] = STATE(126),
    [sym__simple_heredoc_body] = ACTIONS(987),
    [sym__heredoc_body_beginning] = ACTIONS(987),
    [sym_file_descriptor] = ACTIONS(987),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_SEMI_SEMI] = ACTIONS(989),
    [anon_sym_PIPE_AMP] = ACTIONS(989),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE_PIPE] = ACTIONS(989),
    [anon_sym_EQ_TILDE] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_GT] = ACTIONS(989),
    [anon_sym_GT_GT] = ACTIONS(989),
    [anon_sym_AMP_GT] = ACTIONS(989),
    [anon_sym_AMP_GT_GT] = ACTIONS(989),
    [anon_sym_LT_AMP] = ACTIONS(989),
    [anon_sym_GT_AMP] = ACTIONS(989),
    [anon_sym_LT_LT] = ACTIONS(989),
    [anon_sym_LT_LT_DASH] = ACTIONS(989),
    [anon_sym_LT_LT_LT] = ACTIONS(989),
    [sym__special_characters] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(989),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [sym_raw_string] = ACTIONS(989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(989),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(989),
    [anon_sym_BQUOTE] = ACTIONS(989),
    [anon_sym_LT_LPAREN] = ACTIONS(989),
    [anon_sym_GT_LPAREN] = ACTIONS(989),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(989),
    [anon_sym_SEMI] = ACTIONS(989),
    [anon_sym_LF] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(989),
  },
  [199] = {
    [aux_sym_concatenation_repeat1] = STATE(126),
    [sym__simple_heredoc_body] = ACTIONS(991),
    [sym__heredoc_body_beginning] = ACTIONS(991),
    [sym_file_descriptor] = ACTIONS(991),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_SEMI_SEMI] = ACTIONS(993),
    [anon_sym_PIPE_AMP] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT] = ACTIONS(993),
    [anon_sym_GT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_AMP_GT] = ACTIONS(993),
    [anon_sym_AMP_GT_GT] = ACTIONS(993),
    [anon_sym_LT_AMP] = ACTIONS(993),
    [anon_sym_GT_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_LT_LT_DASH] = ACTIONS(993),
    [anon_sym_LT_LT_LT] = ACTIONS(993),
    [sym__special_characters] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(993),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [sym_raw_string] = ACTIONS(993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(993),
    [anon_sym_LT_LPAREN] = ACTIONS(993),
    [anon_sym_GT_LPAREN] = ACTIONS(993),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(993),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_LF] = ACTIONS(991),
    [anon_sym_AMP] = ACTIONS(993),
  },
  [200] = {
    [anon_sym_esac] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [201] = {
    [sym_file_redirect] = STATE(549),
    [sym_heredoc_redirect] = STATE(549),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(549),
    [aux_sym_while_statement_repeat1] = STATE(549),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [202] = {
    [sym_file_redirect] = STATE(550),
    [sym_heredoc_redirect] = STATE(550),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(550),
    [sym_concatenation] = STATE(551),
    [sym_string] = STATE(199),
    [sym_simple_expansion] = STATE(199),
    [sym_string_expansion] = STATE(199),
    [sym_expansion] = STATE(199),
    [sym_command_substitution] = STATE(199),
    [sym_process_substitution] = STATE(199),
    [aux_sym_while_statement_repeat1] = STATE(550),
    [aux_sym_command_repeat2] = STATE(551),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_EQ_TILDE] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(345),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(357),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [203] = {
    [sym__terminated_statement] = STATE(203),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(203),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [ts_builtin_sym_end] = ACTIONS(1005),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [204] = {
    [sym_file_redirect] = STATE(550),
    [sym_heredoc_redirect] = STATE(550),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(550),
    [sym_concatenation] = STATE(552),
    [sym_string] = STATE(199),
    [sym_simple_expansion] = STATE(199),
    [sym_string_expansion] = STATE(199),
    [sym_expansion] = STATE(199),
    [sym_command_substitution] = STATE(199),
    [sym_process_substitution] = STATE(199),
    [aux_sym_while_statement_repeat1] = STATE(550),
    [aux_sym_command_repeat2] = STATE(552),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_EQ_TILDE] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(345),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(357),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [205] = {
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [aux_sym_command_repeat1] = STATE(205),
    [sym_file_descriptor] = ACTIONS(1073),
    [sym_variable_name] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1082),
    [anon_sym_AMP_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT_GT] = ACTIONS(1082),
    [anon_sym_LT_AMP] = ACTIONS(1082),
    [anon_sym_GT_AMP] = ACTIONS(1082),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1085),
  },
  [206] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [sym__special_characters] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1089),
  },
  [207] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1093),
  },
  [208] = {
    [sym_file_descriptor] = ACTIONS(1093),
    [sym_variable_name] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1093),
  },
  [209] = {
    [aux_sym_concatenation_repeat1] = STATE(555),
    [sym__concat] = ACTIONS(1097),
    [anon_sym_RBRACK] = ACTIONS(1099),
    [sym_comment] = ACTIONS(53),
  },
  [210] = {
    [aux_sym_concatenation_repeat1] = STATE(555),
    [sym__concat] = ACTIONS(1101),
    [anon_sym_RBRACK] = ACTIONS(1103),
    [sym_comment] = ACTIONS(53),
  },
  [211] = {
    [sym__concat] = ACTIONS(1105),
    [anon_sym_RBRACK] = ACTIONS(1103),
    [sym_comment] = ACTIONS(53),
  },
  [212] = {
    [sym_file_descriptor] = ACTIONS(1107),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_esac] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_AMP] = ACTIONS(1109),
    [anon_sym_GT_AMP] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [213] = {
    [sym_concatenation] = STATE(568),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(568),
    [anon_sym_RPAREN] = ACTIONS(1111),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [214] = {
    [aux_sym_concatenation_repeat1] = STATE(570),
    [sym_file_descriptor] = ACTIONS(1129),
    [sym__concat] = ACTIONS(1131),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_AMP] = ACTIONS(1133),
    [anon_sym_GT_AMP] = ACTIONS(1133),
    [sym__special_characters] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1133),
  },
  [215] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(572),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [216] = {
    [sym_string] = STATE(574),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(1137),
    [sym_raw_string] = ACTIONS(1139),
    [anon_sym_POUND] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1141),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1137),
    [anon_sym_QMARK] = ACTIONS(1137),
    [anon_sym_0] = ACTIONS(1143),
    [anon_sym__] = ACTIONS(1143),
  },
  [217] = {
    [aux_sym_concatenation_repeat1] = STATE(570),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(1131),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_AMP] = ACTIONS(1109),
    [anon_sym_GT_AMP] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [218] = {
    [sym_subscript] = STATE(580),
    [sym_variable_name] = ACTIONS(1145),
    [anon_sym_DOLLAR] = ACTIONS(1147),
    [anon_sym_POUND] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(1147),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(1147),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_0] = ACTIONS(1153),
    [anon_sym__] = ACTIONS(1153),
  },
  [219] = {
    [sym_for_statement] = STATE(581),
    [sym_while_statement] = STATE(581),
    [sym_if_statement] = STATE(581),
    [sym_case_statement] = STATE(581),
    [sym_function_definition] = STATE(581),
    [sym_subshell] = STATE(581),
    [sym_pipeline] = STATE(581),
    [sym_list] = STATE(581),
    [sym_negated_command] = STATE(581),
    [sym_test_command] = STATE(581),
    [sym_declaration_command] = STATE(581),
    [sym_unset_command] = STATE(581),
    [sym_command] = STATE(581),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(582),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [220] = {
    [sym_for_statement] = STATE(583),
    [sym_while_statement] = STATE(583),
    [sym_if_statement] = STATE(583),
    [sym_case_statement] = STATE(583),
    [sym_function_definition] = STATE(583),
    [sym_subshell] = STATE(583),
    [sym_pipeline] = STATE(583),
    [sym_list] = STATE(583),
    [sym_negated_command] = STATE(583),
    [sym_test_command] = STATE(583),
    [sym_declaration_command] = STATE(583),
    [sym_unset_command] = STATE(583),
    [sym_command] = STATE(583),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(584),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [221] = {
    [sym_for_statement] = STATE(585),
    [sym_while_statement] = STATE(585),
    [sym_if_statement] = STATE(585),
    [sym_case_statement] = STATE(585),
    [sym_function_definition] = STATE(585),
    [sym_subshell] = STATE(585),
    [sym_pipeline] = STATE(585),
    [sym_list] = STATE(585),
    [sym_negated_command] = STATE(585),
    [sym_test_command] = STATE(585),
    [sym_declaration_command] = STATE(585),
    [sym_unset_command] = STATE(585),
    [sym_command] = STATE(585),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(586),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [222] = {
    [sym_concatenation] = STATE(589),
    [sym_string] = STATE(588),
    [sym_simple_expansion] = STATE(588),
    [sym_string_expansion] = STATE(588),
    [sym_expansion] = STATE(588),
    [sym_command_substitution] = STATE(588),
    [sym_process_substitution] = STATE(588),
    [aux_sym_for_statement_repeat1] = STATE(589),
    [sym__special_characters] = ACTIONS(1155),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [anon_sym_DOLLAR] = ACTIONS(71),
    [sym_raw_string] = ACTIONS(1157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(75),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(77),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1157),
  },
  [223] = {
    [sym_do_group] = STATE(591),
    [anon_sym_do] = ACTIONS(1159),
    [sym_comment] = ACTIONS(53),
  },
  [224] = {
    [sym__terminated_statement] = STATE(593),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(593),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(1161),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [225] = {
    [sym_file_redirect] = STATE(595),
    [sym_heredoc_redirect] = STATE(595),
    [sym_heredoc_body] = STATE(594),
    [sym_herestring_redirect] = STATE(595),
    [aux_sym_while_statement_repeat1] = STATE(595),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(1163),
    [anon_sym_SEMI_SEMI] = ACTIONS(1163),
    [anon_sym_PIPE_AMP] = ACTIONS(1163),
    [anon_sym_AMP_AMP] = ACTIONS(1163),
    [anon_sym_PIPE_PIPE] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_LF] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1163),
  },
  [226] = {
    [anon_sym_do] = ACTIONS(951),
    [anon_sym_then] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
  },
  [227] = {
    [sym__terminated_statement] = STATE(601),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_elif_clause] = STATE(599),
    [sym_else_clause] = STATE(600),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(601),
    [aux_sym_if_statement_repeat1] = STATE(602),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(1167),
    [anon_sym_elif] = ACTIONS(1169),
    [anon_sym_else] = ACTIONS(1171),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [228] = {
    [sym_string] = STATE(603),
    [sym_simple_expansion] = STATE(603),
    [sym_string_expansion] = STATE(603),
    [sym_expansion] = STATE(603),
    [sym_command_substitution] = STATE(603),
    [sym_process_substitution] = STATE(603),
    [sym__special_characters] = ACTIONS(1173),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [anon_sym_DOLLAR] = ACTIONS(71),
    [sym_raw_string] = ACTIONS(1173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(75),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(77),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1173),
  },
  [229] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1175),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1175),
    [anon_sym_LF] = ACTIONS(1177),
    [anon_sym_AMP] = ACTIONS(1175),
  },
  [230] = {
    [anon_sym_in] = ACTIONS(1179),
    [sym_comment] = ACTIONS(53),
  },
  [231] = {
    [aux_sym_concatenation_repeat1] = STATE(606),
    [sym__concat] = ACTIONS(419),
    [anon_sym_in] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [232] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_in] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [233] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [234] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_in] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [235] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [236] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_in] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [237] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1183),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1183),
    [anon_sym_LF] = ACTIONS(1185),
    [anon_sym_AMP] = ACTIONS(1183),
  },
  [238] = {
    [anon_sym_in] = ACTIONS(1187),
    [sym_comment] = ACTIONS(53),
  },
  [239] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1189),
    [sym_comment] = ACTIONS(53),
  },
  [240] = {
    [sym_concatenation] = STATE(613),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(613),
    [anon_sym_RBRACE] = ACTIONS(1191),
    [anon_sym_EQ] = ACTIONS(1193),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1195),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1197),
    [anon_sym_COLON] = ACTIONS(1193),
    [anon_sym_COLON_QMARK] = ACTIONS(1193),
    [anon_sym_COLON_DASH] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [241] = {
    [sym_subscript] = STATE(617),
    [sym_variable_name] = ACTIONS(1199),
    [anon_sym_DOLLAR] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1203),
    [anon_sym_STAR] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1201),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_0] = ACTIONS(1205),
    [anon_sym__] = ACTIONS(1205),
  },
  [242] = {
    [sym_concatenation] = STATE(620),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(620),
    [anon_sym_RBRACE] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(1209),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1213),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_COLON_QMARK] = ACTIONS(1209),
    [anon_sym_COLON_DASH] = ACTIONS(1209),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_DASH] = ACTIONS(1209),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [243] = {
    [sym_concatenation] = STATE(623),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(623),
    [anon_sym_RBRACE] = ACTIONS(1215),
    [anon_sym_EQ] = ACTIONS(1217),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_COLON_QMARK] = ACTIONS(1217),
    [anon_sym_COLON_DASH] = ACTIONS(1217),
    [anon_sym_PERCENT] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [244] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [245] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [246] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(53),
  },
  [247] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [248] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1225),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [249] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1225),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [250] = {
    [anon_sym_RPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(53),
  },
  [251] = {
    [sym__terminated_statement] = STATE(630),
    [sym_for_statement] = STATE(628),
    [sym_while_statement] = STATE(628),
    [sym_if_statement] = STATE(628),
    [sym_case_statement] = STATE(628),
    [sym_function_definition] = STATE(628),
    [sym_subshell] = STATE(628),
    [sym_pipeline] = STATE(628),
    [sym_list] = STATE(628),
    [sym_negated_command] = STATE(628),
    [sym_test_command] = STATE(628),
    [sym_declaration_command] = STATE(628),
    [sym_unset_command] = STATE(628),
    [sym_command] = STATE(628),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(629),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(630),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [252] = {
    [sym_file_redirect] = STATE(633),
    [sym_file_descriptor] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1233),
    [anon_sym_SEMI_SEMI] = ACTIONS(1233),
    [anon_sym_PIPE_AMP] = ACTIONS(1233),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_LF] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1233),
  },
  [253] = {
    [sym_concatenation] = STATE(212),
    [sym_string] = STATE(635),
    [sym_array] = STATE(212),
    [sym_simple_expansion] = STATE(635),
    [sym_string_expansion] = STATE(635),
    [sym_expansion] = STATE(635),
    [sym_command_substitution] = STATE(635),
    [sym_process_substitution] = STATE(635),
    [sym__empty_value] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(387),
    [sym__special_characters] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [sym_raw_string] = ACTIONS(1241),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(399),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(403),
    [anon_sym_GT_LPAREN] = ACTIONS(403),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1241),
  },
  [254] = {
    [sym_do_group] = STATE(636),
    [anon_sym_do] = ACTIONS(411),
    [sym_comment] = ACTIONS(53),
  },
  [255] = {
    [sym_compound_statement] = STATE(638),
    [anon_sym_LPAREN] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [256] = {
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_RBRACK] = ACTIONS(1245),
    [anon_sym_EQ_TILDE] = ACTIONS(547),
    [anon_sym_EQ_EQ] = ACTIONS(547),
    [anon_sym_EQ] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(543),
  },
  [257] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1245),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [258] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(1247),
    [anon_sym_PLUS_EQ] = ACTIONS(1247),
    [sym_comment] = ACTIONS(53),
  },
  [259] = {
    [aux_sym_concatenation_repeat1] = STATE(641),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(585),
    [anon_sym_SEMI_SEMI] = ACTIONS(585),
    [anon_sym_PIPE_AMP] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [sym__special_characters] = ACTIONS(585),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(585),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(585),
    [anon_sym_LF] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(585),
  },
  [260] = {
    [aux_sym_concatenation_repeat1] = STATE(641),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(599),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_RPAREN] = ACTIONS(601),
    [anon_sym_SEMI_SEMI] = ACTIONS(601),
    [anon_sym_PIPE_AMP] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [anon_sym_DOLLAR] = ACTIONS(601),
    [sym_raw_string] = ACTIONS(601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(601),
    [anon_sym_BQUOTE] = ACTIONS(601),
    [anon_sym_LT_LPAREN] = ACTIONS(601),
    [anon_sym_GT_LPAREN] = ACTIONS(601),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(601),
    [sym_word] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(601),
  },
  [261] = {
    [anon_sym_EQ] = ACTIONS(1247),
    [anon_sym_PLUS_EQ] = ACTIONS(1247),
    [sym_comment] = ACTIONS(53),
  },
  [262] = {
    [sym_variable_assignment] = STATE(642),
    [sym_subscript] = STATE(261),
    [sym_concatenation] = STATE(642),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym_declaration_command_repeat1] = STATE(642),
    [sym_variable_name] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(617),
    [anon_sym_PIPE_AMP] = ACTIONS(617),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [sym__special_characters] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(179),
    [sym_word] = ACTIONS(465),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LF] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(617),
  },
  [263] = {
    [aux_sym_concatenation_repeat1] = STATE(643),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_RPAREN] = ACTIONS(623),
    [anon_sym_SEMI_SEMI] = ACTIONS(623),
    [anon_sym_PIPE_AMP] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(623),
    [sym__special_characters] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [sym_raw_string] = ACTIONS(623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(623),
    [anon_sym_BQUOTE] = ACTIONS(623),
    [anon_sym_LT_LPAREN] = ACTIONS(623),
    [anon_sym_GT_LPAREN] = ACTIONS(623),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(623),
    [sym_word] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(623),
    [anon_sym_LF] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(623),
  },
  [264] = {
    [aux_sym_concatenation_repeat1] = STATE(643),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_RPAREN] = ACTIONS(639),
    [anon_sym_SEMI_SEMI] = ACTIONS(639),
    [anon_sym_PIPE_AMP] = ACTIONS(639),
    [anon_sym_AMP_AMP] = ACTIONS(639),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [sym__special_characters] = ACTIONS(639),
    [anon_sym_DQUOTE] = ACTIONS(639),
    [anon_sym_DOLLAR] = ACTIONS(639),
    [sym_raw_string] = ACTIONS(639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(639),
    [anon_sym_BQUOTE] = ACTIONS(639),
    [anon_sym_LT_LPAREN] = ACTIONS(639),
    [anon_sym_GT_LPAREN] = ACTIONS(639),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(639),
    [sym_word] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(639),
    [anon_sym_LF] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(639),
  },
  [265] = {
    [sym_concatenation] = STATE(644),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [aux_sym_unset_command_repeat1] = STATE(644),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_RPAREN] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(657),
    [anon_sym_PIPE_AMP] = ACTIONS(657),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(657),
    [sym__special_characters] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(193),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(195),
    [anon_sym_BQUOTE] = ACTIONS(197),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(201),
    [sym_word] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(657),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(657),
  },
  [266] = {
    [aux_sym_concatenation_repeat1] = STATE(645),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [267] = {
    [anon_sym_RPAREN] = ACTIONS(1249),
    [sym_comment] = ACTIONS(53),
  },
  [268] = {
    [sym_for_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_function_definition] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_pipeline] = STATE(529),
    [sym_list] = STATE(529),
    [sym_negated_command] = STATE(529),
    [sym_test_command] = STATE(529),
    [sym_declaration_command] = STATE(529),
    [sym_unset_command] = STATE(529),
    [sym_command] = STATE(529),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(530),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_typeset] = ACTIONS(97),
    [anon_sym_export] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_local] = ACTIONS(97),
    [anon_sym_unset] = ACTIONS(99),
    [anon_sym_unsetenv] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(105),
  },
  [269] = {
    [anon_sym_esac] = ACTIONS(1251),
    [anon_sym_PIPE] = ACTIONS(1251),
    [anon_sym_RPAREN] = ACTIONS(1251),
    [anon_sym_SEMI_SEMI] = ACTIONS(1251),
    [anon_sym_PIPE_AMP] = ACTIONS(1251),
    [anon_sym_AMP_AMP] = ACTIONS(1251),
    [anon_sym_PIPE_PIPE] = ACTIONS(1251),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_LF] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1251),
  },
  [270] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_RPAREN] = ACTIONS(1255),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [271] = {
    [sym_for_statement] = STATE(648),
    [sym_while_statement] = STATE(648),
    [sym_if_statement] = STATE(648),
    [sym_case_statement] = STATE(648),
    [sym_function_definition] = STATE(648),
    [sym_subshell] = STATE(648),
    [sym_pipeline] = STATE(648),
    [sym_list] = STATE(648),
    [sym_negated_command] = STATE(648),
    [sym_test_command] = STATE(648),
    [sym_declaration_command] = STATE(648),
    [sym_unset_command] = STATE(648),
    [sym_command] = STATE(648),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(649),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_typeset] = ACTIONS(97),
    [anon_sym_export] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_local] = ACTIONS(97),
    [anon_sym_unset] = ACTIONS(99),
    [anon_sym_unsetenv] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(105),
  },
  [272] = {
    [anon_sym_LT] = ACTIONS(1257),
    [anon_sym_GT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT_GT] = ACTIONS(1259),
    [anon_sym_LT_AMP] = ACTIONS(1259),
    [anon_sym_GT_AMP] = ACTIONS(1259),
    [sym_comment] = ACTIONS(53),
  },
  [273] = {
    [sym_concatenation] = STATE(540),
    [sym_string] = STATE(652),
    [sym_simple_expansion] = STATE(652),
    [sym_string_expansion] = STATE(652),
    [sym_expansion] = STATE(652),
    [sym_command_substitution] = STATE(652),
    [sym_process_substitution] = STATE(652),
    [sym__special_characters] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1263),
    [sym_regex] = ACTIONS(975),
  },
  [274] = {
    [sym_concatenation] = STATE(543),
    [sym_string] = STATE(654),
    [sym_simple_expansion] = STATE(654),
    [sym_string_expansion] = STATE(654),
    [sym_expansion] = STATE(654),
    [sym_command_substitution] = STATE(654),
    [sym_process_substitution] = STATE(654),
    [sym__special_characters] = ACTIONS(1265),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1267),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1267),
  },
  [275] = {
    [sym_concatenation] = STATE(547),
    [sym_string] = STATE(656),
    [sym_simple_expansion] = STATE(656),
    [sym_string_expansion] = STATE(656),
    [sym_expansion] = STATE(656),
    [sym_command_substitution] = STATE(656),
    [sym_process_substitution] = STATE(656),
    [sym__special_characters] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1271),
  },
  [276] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(987),
    [sym__heredoc_body_beginning] = ACTIONS(987),
    [sym_file_descriptor] = ACTIONS(987),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_RPAREN] = ACTIONS(989),
    [anon_sym_SEMI_SEMI] = ACTIONS(989),
    [anon_sym_PIPE_AMP] = ACTIONS(989),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE_PIPE] = ACTIONS(989),
    [anon_sym_EQ_TILDE] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_GT] = ACTIONS(989),
    [anon_sym_GT_GT] = ACTIONS(989),
    [anon_sym_AMP_GT] = ACTIONS(989),
    [anon_sym_AMP_GT_GT] = ACTIONS(989),
    [anon_sym_LT_AMP] = ACTIONS(989),
    [anon_sym_GT_AMP] = ACTIONS(989),
    [anon_sym_LT_LT] = ACTIONS(989),
    [anon_sym_LT_LT_DASH] = ACTIONS(989),
    [anon_sym_LT_LT_LT] = ACTIONS(989),
    [sym__special_characters] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(989),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [sym_raw_string] = ACTIONS(989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(989),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(989),
    [anon_sym_BQUOTE] = ACTIONS(989),
    [anon_sym_LT_LPAREN] = ACTIONS(989),
    [anon_sym_GT_LPAREN] = ACTIONS(989),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(989),
    [anon_sym_SEMI] = ACTIONS(989),
    [anon_sym_LF] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(989),
  },
  [277] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(991),
    [sym__heredoc_body_beginning] = ACTIONS(991),
    [sym_file_descriptor] = ACTIONS(991),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_SEMI_SEMI] = ACTIONS(993),
    [anon_sym_PIPE_AMP] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT] = ACTIONS(993),
    [anon_sym_GT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_AMP_GT] = ACTIONS(993),
    [anon_sym_AMP_GT_GT] = ACTIONS(993),
    [anon_sym_LT_AMP] = ACTIONS(993),
    [anon_sym_GT_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_LT_LT_DASH] = ACTIONS(993),
    [anon_sym_LT_LT_LT] = ACTIONS(993),
    [sym__special_characters] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(993),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [sym_raw_string] = ACTIONS(993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(993),
    [anon_sym_LT_LPAREN] = ACTIONS(993),
    [anon_sym_GT_LPAREN] = ACTIONS(993),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(993),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_LF] = ACTIONS(991),
    [anon_sym_AMP] = ACTIONS(993),
  },
  [278] = {
    [sym_file_redirect] = STATE(657),
    [sym_heredoc_redirect] = STATE(657),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(657),
    [aux_sym_while_statement_repeat1] = STATE(657),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [279] = {
    [sym_file_redirect] = STATE(658),
    [sym_heredoc_redirect] = STATE(658),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(658),
    [sym_concatenation] = STATE(659),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [aux_sym_while_statement_repeat1] = STATE(658),
    [aux_sym_command_repeat2] = STATE(659),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_EQ_TILDE] = ACTIONS(485),
    [anon_sym_EQ_EQ] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym__special_characters] = ACTIONS(491),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [280] = {
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_SEMI_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_LF] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1275),
  },
  [281] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_SEMI_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_LF] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1275),
  },
  [282] = {
    [sym__terminated_statement] = STATE(282),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(282),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [283] = {
    [sym_file_redirect] = STATE(658),
    [sym_heredoc_redirect] = STATE(658),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(658),
    [sym_concatenation] = STATE(661),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [aux_sym_while_statement_repeat1] = STATE(658),
    [aux_sym_command_repeat2] = STATE(661),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_EQ_TILDE] = ACTIONS(485),
    [anon_sym_EQ_EQ] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym__special_characters] = ACTIONS(491),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [284] = {
    [sym_concatenation] = STATE(662),
    [sym_string] = STATE(665),
    [sym_array] = STATE(662),
    [sym_simple_expansion] = STATE(665),
    [sym_string_expansion] = STATE(665),
    [sym_expansion] = STATE(665),
    [sym_command_substitution] = STATE(665),
    [sym_process_substitution] = STATE(665),
    [sym__empty_value] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [sym__special_characters] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1285),
  },
  [285] = {
    [sym__expression] = STATE(666),
    [sym_binary_expression] = STATE(666),
    [sym_unary_expression] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_concatenation] = STATE(666),
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_string_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(509),
    [sym_test_operator] = ACTIONS(511),
  },
  [286] = {
    [aux_sym_concatenation_repeat1] = STATE(667),
    [sym__concat] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(515),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_EQ_TILDE] = ACTIONS(515),
    [anon_sym_EQ_EQ] = ACTIONS(515),
    [anon_sym_EQ] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(515),
    [anon_sym_BANG_EQ] = ACTIONS(515),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(515),
  },
  [287] = {
    [aux_sym_concatenation_repeat1] = STATE(667),
    [sym__concat] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_EQ_TILDE] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(529),
    [anon_sym_EQ] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(529),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(529),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(529),
  },
  [288] = {
    [anon_sym_RPAREN] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1289),
    [anon_sym_PIPE_PIPE] = ACTIONS(1289),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_EQ_EQ] = ACTIONS(1291),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1289),
    [anon_sym_GT] = ACTIONS(1289),
    [anon_sym_BANG_EQ] = ACTIONS(1289),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1289),
  },
  [289] = {
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_RBRACK] = ACTIONS(1295),
    [anon_sym_EQ_TILDE] = ACTIONS(547),
    [anon_sym_EQ_EQ] = ACTIONS(547),
    [anon_sym_EQ] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(543),
  },
  [290] = {
    [sym_string] = STATE(671),
    [sym_simple_expansion] = STATE(671),
    [sym_string_expansion] = STATE(671),
    [sym_expansion] = STATE(671),
    [sym_command_substitution] = STATE(671),
    [sym_process_substitution] = STATE(671),
    [sym__special_characters] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(1297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1297),
  },
  [291] = {
    [aux_sym_concatenation_repeat1] = STATE(672),
    [sym__concat] = ACTIONS(513),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_RBRACK] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(693),
    [anon_sym_EQ_EQ] = ACTIONS(693),
    [anon_sym_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(693),
    [anon_sym_GT] = ACTIONS(693),
    [anon_sym_BANG_EQ] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(693),
  },
  [292] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [anon_sym_RBRACK] = ACTIONS(697),
    [anon_sym_EQ_TILDE] = ACTIONS(697),
    [anon_sym_EQ_EQ] = ACTIONS(697),
    [anon_sym_EQ] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_BANG_EQ] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(697),
  },
  [293] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [294] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(727),
    [anon_sym_PIPE_PIPE] = ACTIONS(727),
    [anon_sym_RBRACK] = ACTIONS(727),
    [anon_sym_EQ_TILDE] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_GT] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(727),
  },
  [295] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_RBRACK] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(731),
  },
  [296] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_RBRACK] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(735),
  },
  [297] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1301),
    [sym_comment] = ACTIONS(53),
  },
  [298] = {
    [sym_concatenation] = STATE(677),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(677),
    [anon_sym_RBRACE] = ACTIONS(1303),
    [anon_sym_EQ] = ACTIONS(1305),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1309),
    [anon_sym_COLON] = ACTIONS(1305),
    [anon_sym_COLON_QMARK] = ACTIONS(1305),
    [anon_sym_COLON_DASH] = ACTIONS(1305),
    [anon_sym_PERCENT] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [299] = {
    [sym_subscript] = STATE(681),
    [sym_variable_name] = ACTIONS(1311),
    [anon_sym_DOLLAR] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1313),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1315),
    [anon_sym_STAR] = ACTIONS(1313),
    [anon_sym_AT] = ACTIONS(1313),
    [anon_sym_QMARK] = ACTIONS(1313),
    [anon_sym_0] = ACTIONS(1317),
    [anon_sym__] = ACTIONS(1317),
  },
  [300] = {
    [sym_concatenation] = STATE(684),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(684),
    [anon_sym_RBRACE] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1321),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1325),
    [anon_sym_COLON] = ACTIONS(1321),
    [anon_sym_COLON_QMARK] = ACTIONS(1321),
    [anon_sym_COLON_DASH] = ACTIONS(1321),
    [anon_sym_PERCENT] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [301] = {
    [sym_concatenation] = STATE(687),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(687),
    [anon_sym_RBRACE] = ACTIONS(1327),
    [anon_sym_EQ] = ACTIONS(1329),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1329),
    [anon_sym_COLON_QMARK] = ACTIONS(1329),
    [anon_sym_COLON_DASH] = ACTIONS(1329),
    [anon_sym_PERCENT] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(1329),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [302] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [303] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [304] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1335),
    [sym_comment] = ACTIONS(53),
  },
  [305] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1335),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [306] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1337),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [307] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1337),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [308] = {
    [sym__expression] = STATE(690),
    [sym_binary_expression] = STATE(690),
    [sym_unary_expression] = STATE(690),
    [sym_parenthesized_expression] = STATE(690),
    [sym_concatenation] = STATE(690),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(131),
  },
  [309] = {
    [sym_file_redirect] = STATE(695),
    [sym_heredoc_redirect] = STATE(695),
    [sym_herestring_redirect] = STATE(695),
    [aux_sym_while_statement_repeat1] = STATE(695),
    [sym_file_descriptor] = ACTIONS(1339),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_SEMI_SEMI] = ACTIONS(1341),
    [anon_sym_PIPE_AMP] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1343),
    [anon_sym_GT] = ACTIONS(1343),
    [anon_sym_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_GT] = ACTIONS(1343),
    [anon_sym_AMP_GT_GT] = ACTIONS(1343),
    [anon_sym_LT_AMP] = ACTIONS(1343),
    [anon_sym_GT_AMP] = ACTIONS(1343),
    [anon_sym_LT_LT] = ACTIONS(1345),
    [anon_sym_LT_LT_DASH] = ACTIONS(1345),
    [anon_sym_LT_LT_LT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1341),
    [anon_sym_LF] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1341),
  },
  [310] = {
    [sym__expression] = STATE(690),
    [sym_binary_expression] = STATE(690),
    [sym_unary_expression] = STATE(690),
    [sym_parenthesized_expression] = STATE(690),
    [sym_concatenation] = STATE(690),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1357),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1359),
    [anon_sym_BQUOTE] = ACTIONS(1361),
    [anon_sym_LT_LPAREN] = ACTIONS(1363),
    [anon_sym_GT_LPAREN] = ACTIONS(1363),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(111),
    [sym_regex] = ACTIONS(1365),
  },
  [311] = {
    [anon_sym_RPAREN] = ACTIONS(1367),
    [anon_sym_AMP_AMP] = ACTIONS(1289),
    [anon_sym_PIPE_PIPE] = ACTIONS(1289),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_EQ_EQ] = ACTIONS(1291),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1289),
    [anon_sym_GT] = ACTIONS(1289),
    [anon_sym_BANG_EQ] = ACTIONS(1289),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1289),
  },
  [312] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1295),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [313] = {
    [sym_string] = STATE(698),
    [sym_simple_expansion] = STATE(698),
    [sym_string_expansion] = STATE(698),
    [sym_expansion] = STATE(698),
    [sym_command_substitution] = STATE(698),
    [sym_process_substitution] = STATE(698),
    [sym__special_characters] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(1369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1369),
  },
  [314] = {
    [aux_sym_concatenation_repeat1] = STATE(699),
    [sym__concat] = ACTIONS(551),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(693),
    [anon_sym_EQ_EQ] = ACTIONS(693),
    [anon_sym_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(693),
    [anon_sym_GT] = ACTIONS(693),
    [anon_sym_BANG_EQ] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(693),
  },
  [315] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(697),
    [anon_sym_EQ_TILDE] = ACTIONS(697),
    [anon_sym_EQ_EQ] = ACTIONS(697),
    [anon_sym_EQ] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_BANG_EQ] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(697),
  },
  [316] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [317] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(727),
    [anon_sym_PIPE_PIPE] = ACTIONS(727),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(727),
    [anon_sym_EQ_TILDE] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_GT] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(727),
  },
  [318] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(731),
  },
  [319] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(735),
  },
  [320] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1373),
    [sym_comment] = ACTIONS(53),
  },
  [321] = {
    [sym_concatenation] = STATE(704),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(704),
    [anon_sym_RBRACE] = ACTIONS(1375),
    [anon_sym_EQ] = ACTIONS(1377),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1381),
    [anon_sym_COLON] = ACTIONS(1377),
    [anon_sym_COLON_QMARK] = ACTIONS(1377),
    [anon_sym_COLON_DASH] = ACTIONS(1377),
    [anon_sym_PERCENT] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [322] = {
    [sym_subscript] = STATE(708),
    [sym_variable_name] = ACTIONS(1383),
    [anon_sym_DOLLAR] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1385),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1385),
    [anon_sym_AT] = ACTIONS(1385),
    [anon_sym_QMARK] = ACTIONS(1385),
    [anon_sym_0] = ACTIONS(1389),
    [anon_sym__] = ACTIONS(1389),
  },
  [323] = {
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(711),
    [anon_sym_RBRACE] = ACTIONS(1391),
    [anon_sym_EQ] = ACTIONS(1393),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1395),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1397),
    [anon_sym_COLON] = ACTIONS(1393),
    [anon_sym_COLON_QMARK] = ACTIONS(1393),
    [anon_sym_COLON_DASH] = ACTIONS(1393),
    [anon_sym_PERCENT] = ACTIONS(1393),
    [anon_sym_DASH] = ACTIONS(1393),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [324] = {
    [sym_concatenation] = STATE(714),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(714),
    [anon_sym_RBRACE] = ACTIONS(1399),
    [anon_sym_EQ] = ACTIONS(1401),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1405),
    [anon_sym_COLON] = ACTIONS(1401),
    [anon_sym_COLON_QMARK] = ACTIONS(1401),
    [anon_sym_COLON_DASH] = ACTIONS(1401),
    [anon_sym_PERCENT] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [325] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [326] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [327] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_comment] = ACTIONS(53),
  },
  [328] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [329] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1409),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [330] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1409),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [331] = {
    [sym__expression] = STATE(717),
    [sym_binary_expression] = STATE(717),
    [sym_unary_expression] = STATE(717),
    [sym_parenthesized_expression] = STATE(717),
    [sym_concatenation] = STATE(717),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [332] = {
    [sym__expression] = STATE(717),
    [sym_binary_expression] = STATE(717),
    [sym_unary_expression] = STATE(717),
    [sym_parenthesized_expression] = STATE(717),
    [sym_concatenation] = STATE(717),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1417),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1419),
    [anon_sym_BQUOTE] = ACTIONS(1421),
    [anon_sym_LT_LPAREN] = ACTIONS(1423),
    [anon_sym_GT_LPAREN] = ACTIONS(1423),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(135),
    [sym_regex] = ACTIONS(1425),
  },
  [333] = {
    [sym_concatenation] = STATE(719),
    [sym_string] = STATE(722),
    [sym_array] = STATE(719),
    [sym_simple_expansion] = STATE(722),
    [sym_string_expansion] = STATE(722),
    [sym_expansion] = STATE(722),
    [sym_command_substitution] = STATE(722),
    [sym_process_substitution] = STATE(722),
    [sym__empty_value] = ACTIONS(1427),
    [anon_sym_LPAREN] = ACTIONS(1429),
    [sym__special_characters] = ACTIONS(1431),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(1433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1435),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1439),
    [anon_sym_LT_LPAREN] = ACTIONS(1441),
    [anon_sym_GT_LPAREN] = ACTIONS(1441),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1433),
  },
  [334] = {
    [sym_string] = STATE(723),
    [sym_simple_expansion] = STATE(723),
    [sym_string_expansion] = STATE(723),
    [sym_expansion] = STATE(723),
    [sym_command_substitution] = STATE(723),
    [sym_process_substitution] = STATE(723),
    [sym__special_characters] = ACTIONS(1443),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(1443),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1435),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1439),
    [anon_sym_LT_LPAREN] = ACTIONS(1441),
    [anon_sym_GT_LPAREN] = ACTIONS(1441),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1443),
  },
  [335] = {
    [aux_sym_concatenation_repeat1] = STATE(724),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [336] = {
    [sym__concat] = ACTIONS(697),
    [sym_variable_name] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(699),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [337] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [338] = {
    [sym__concat] = ACTIONS(727),
    [sym_variable_name] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(729),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [339] = {
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [340] = {
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [341] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1447),
    [sym_comment] = ACTIONS(53),
  },
  [342] = {
    [sym_concatenation] = STATE(729),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(729),
    [anon_sym_RBRACE] = ACTIONS(1449),
    [anon_sym_EQ] = ACTIONS(1451),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1453),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1455),
    [anon_sym_COLON] = ACTIONS(1451),
    [anon_sym_COLON_QMARK] = ACTIONS(1451),
    [anon_sym_COLON_DASH] = ACTIONS(1451),
    [anon_sym_PERCENT] = ACTIONS(1451),
    [anon_sym_DASH] = ACTIONS(1451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [343] = {
    [sym_subscript] = STATE(733),
    [sym_variable_name] = ACTIONS(1457),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1459),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_QMARK] = ACTIONS(1459),
    [anon_sym_0] = ACTIONS(1463),
    [anon_sym__] = ACTIONS(1463),
  },
  [344] = {
    [sym_concatenation] = STATE(736),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(736),
    [anon_sym_RBRACE] = ACTIONS(1465),
    [anon_sym_EQ] = ACTIONS(1467),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1471),
    [anon_sym_COLON] = ACTIONS(1467),
    [anon_sym_COLON_QMARK] = ACTIONS(1467),
    [anon_sym_COLON_DASH] = ACTIONS(1467),
    [anon_sym_PERCENT] = ACTIONS(1467),
    [anon_sym_DASH] = ACTIONS(1467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [345] = {
    [sym_concatenation] = STATE(739),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(739),
    [anon_sym_RBRACE] = ACTIONS(1473),
    [anon_sym_EQ] = ACTIONS(1475),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1477),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1479),
    [anon_sym_COLON] = ACTIONS(1475),
    [anon_sym_COLON_QMARK] = ACTIONS(1475),
    [anon_sym_COLON_DASH] = ACTIONS(1475),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(1475),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [346] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1481),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [347] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1481),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [348] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1481),
    [sym_comment] = ACTIONS(53),
  },
  [349] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1481),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [350] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1483),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [351] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1483),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [352] = {
    [sym_variable_assignment] = STATE(352),
    [sym_subscript] = STATE(104),
    [sym_concatenation] = STATE(352),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym_declaration_command_repeat1] = STATE(352),
    [sym_variable_name] = ACTIONS(1485),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_SEMI_SEMI] = ACTIONS(1488),
    [anon_sym_PIPE_AMP] = ACTIONS(1488),
    [anon_sym_AMP_AMP] = ACTIONS(1488),
    [anon_sym_PIPE_PIPE] = ACTIONS(1488),
    [sym__special_characters] = ACTIONS(1490),
    [anon_sym_DQUOTE] = ACTIONS(1493),
    [anon_sym_DOLLAR] = ACTIONS(1496),
    [sym_raw_string] = ACTIONS(1499),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1505),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [anon_sym_LT_LPAREN] = ACTIONS(1511),
    [anon_sym_GT_LPAREN] = ACTIONS(1511),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1514),
    [sym_word] = ACTIONS(1499),
    [anon_sym_SEMI] = ACTIONS(1488),
    [anon_sym_LF] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1488),
  },
  [353] = {
    [sym_string] = STATE(742),
    [sym_simple_expansion] = STATE(742),
    [sym_string_expansion] = STATE(742),
    [sym_expansion] = STATE(742),
    [sym_command_substitution] = STATE(742),
    [sym_process_substitution] = STATE(742),
    [sym__special_characters] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(629),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(1519),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1521),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1523),
    [anon_sym_BQUOTE] = ACTIONS(1525),
    [anon_sym_LT_LPAREN] = ACTIONS(1527),
    [anon_sym_GT_LPAREN] = ACTIONS(1527),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1519),
  },
  [354] = {
    [aux_sym_concatenation_repeat1] = STATE(743),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [355] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(699),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [356] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [357] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(729),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [358] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [359] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [360] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1531),
    [sym_comment] = ACTIONS(53),
  },
  [361] = {
    [sym_concatenation] = STATE(748),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(748),
    [anon_sym_RBRACE] = ACTIONS(1533),
    [anon_sym_EQ] = ACTIONS(1535),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1537),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(1535),
    [anon_sym_COLON_QMARK] = ACTIONS(1535),
    [anon_sym_COLON_DASH] = ACTIONS(1535),
    [anon_sym_PERCENT] = ACTIONS(1535),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [362] = {
    [sym_subscript] = STATE(752),
    [sym_variable_name] = ACTIONS(1541),
    [anon_sym_DOLLAR] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_AT] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(1543),
    [anon_sym_0] = ACTIONS(1547),
    [anon_sym__] = ACTIONS(1547),
  },
  [363] = {
    [sym_concatenation] = STATE(755),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(755),
    [anon_sym_RBRACE] = ACTIONS(1549),
    [anon_sym_EQ] = ACTIONS(1551),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1555),
    [anon_sym_COLON] = ACTIONS(1551),
    [anon_sym_COLON_QMARK] = ACTIONS(1551),
    [anon_sym_COLON_DASH] = ACTIONS(1551),
    [anon_sym_PERCENT] = ACTIONS(1551),
    [anon_sym_DASH] = ACTIONS(1551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [364] = {
    [sym_concatenation] = STATE(758),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(758),
    [anon_sym_RBRACE] = ACTIONS(1557),
    [anon_sym_EQ] = ACTIONS(1559),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1561),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1563),
    [anon_sym_COLON] = ACTIONS(1559),
    [anon_sym_COLON_QMARK] = ACTIONS(1559),
    [anon_sym_COLON_DASH] = ACTIONS(1559),
    [anon_sym_PERCENT] = ACTIONS(1559),
    [anon_sym_DASH] = ACTIONS(1559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [365] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1565),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [366] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1565),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [367] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1565),
    [sym_comment] = ACTIONS(53),
  },
  [368] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1565),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [369] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1567),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [370] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1567),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [371] = {
    [sym_concatenation] = STATE(371),
    [sym_string] = STATE(109),
    [sym_simple_expansion] = STATE(109),
    [sym_string_expansion] = STATE(109),
    [sym_expansion] = STATE(109),
    [sym_command_substitution] = STATE(109),
    [sym_process_substitution] = STATE(109),
    [aux_sym_unset_command_repeat1] = STATE(371),
    [anon_sym_PIPE] = ACTIONS(1569),
    [anon_sym_SEMI_SEMI] = ACTIONS(1569),
    [anon_sym_PIPE_AMP] = ACTIONS(1569),
    [anon_sym_AMP_AMP] = ACTIONS(1569),
    [anon_sym_PIPE_PIPE] = ACTIONS(1569),
    [sym__special_characters] = ACTIONS(1571),
    [anon_sym_DQUOTE] = ACTIONS(1574),
    [anon_sym_DOLLAR] = ACTIONS(1577),
    [sym_raw_string] = ACTIONS(1580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1586),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LPAREN] = ACTIONS(1592),
    [anon_sym_GT_LPAREN] = ACTIONS(1592),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1595),
    [sym_word] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1569),
    [anon_sym_LF] = ACTIONS(1598),
    [anon_sym_AMP] = ACTIONS(1569),
  },
  [372] = {
    [sym_string] = STATE(761),
    [sym_simple_expansion] = STATE(761),
    [sym_string_expansion] = STATE(761),
    [sym_expansion] = STATE(761),
    [sym_command_substitution] = STATE(761),
    [sym_process_substitution] = STATE(761),
    [sym__special_characters] = ACTIONS(1600),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(1600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1600),
  },
  [373] = {
    [aux_sym_concatenation_repeat1] = STATE(762),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(693),
  },
  [374] = {
    [sym_file_descriptor] = ACTIONS(697),
    [sym__concat] = ACTIONS(697),
    [sym_variable_name] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_PIPE_AMP] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(697),
    [anon_sym_AMP_GT] = ACTIONS(699),
    [anon_sym_AMP_GT_GT] = ACTIONS(697),
    [anon_sym_LT_AMP] = ACTIONS(697),
    [anon_sym_GT_AMP] = ACTIONS(697),
    [sym__special_characters] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [anon_sym_LT_LPAREN] = ACTIONS(697),
    [anon_sym_GT_LPAREN] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(697),
  },
  [375] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [376] = {
    [sym_file_descriptor] = ACTIONS(727),
    [sym__concat] = ACTIONS(727),
    [sym_variable_name] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(727),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(727),
    [anon_sym_PIPE_PIPE] = ACTIONS(727),
    [anon_sym_LT] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_AMP_GT] = ACTIONS(729),
    [anon_sym_AMP_GT_GT] = ACTIONS(727),
    [anon_sym_LT_AMP] = ACTIONS(727),
    [anon_sym_GT_AMP] = ACTIONS(727),
    [sym__special_characters] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(727),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [anon_sym_LT_LPAREN] = ACTIONS(727),
    [anon_sym_GT_LPAREN] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(727),
  },
  [377] = {
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(731),
  },
  [378] = {
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(735),
    [anon_sym_LT_AMP] = ACTIONS(735),
    [anon_sym_GT_AMP] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(735),
  },
  [379] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1604),
    [sym_comment] = ACTIONS(53),
  },
  [380] = {
    [sym_concatenation] = STATE(767),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(767),
    [anon_sym_RBRACE] = ACTIONS(1606),
    [anon_sym_EQ] = ACTIONS(1608),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1610),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1612),
    [anon_sym_COLON] = ACTIONS(1608),
    [anon_sym_COLON_QMARK] = ACTIONS(1608),
    [anon_sym_COLON_DASH] = ACTIONS(1608),
    [anon_sym_PERCENT] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [381] = {
    [sym_subscript] = STATE(771),
    [sym_variable_name] = ACTIONS(1614),
    [anon_sym_DOLLAR] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1616),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1618),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_AT] = ACTIONS(1616),
    [anon_sym_QMARK] = ACTIONS(1616),
    [anon_sym_0] = ACTIONS(1620),
    [anon_sym__] = ACTIONS(1620),
  },
  [382] = {
    [sym_concatenation] = STATE(774),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(774),
    [anon_sym_RBRACE] = ACTIONS(1622),
    [anon_sym_EQ] = ACTIONS(1624),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1628),
    [anon_sym_COLON] = ACTIONS(1624),
    [anon_sym_COLON_QMARK] = ACTIONS(1624),
    [anon_sym_COLON_DASH] = ACTIONS(1624),
    [anon_sym_PERCENT] = ACTIONS(1624),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [383] = {
    [sym_concatenation] = STATE(777),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(777),
    [anon_sym_RBRACE] = ACTIONS(1630),
    [anon_sym_EQ] = ACTIONS(1632),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1634),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1636),
    [anon_sym_COLON] = ACTIONS(1632),
    [anon_sym_COLON_QMARK] = ACTIONS(1632),
    [anon_sym_COLON_DASH] = ACTIONS(1632),
    [anon_sym_PERCENT] = ACTIONS(1632),
    [anon_sym_DASH] = ACTIONS(1632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [384] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1638),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [385] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1638),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [386] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1638),
    [sym_comment] = ACTIONS(53),
  },
  [387] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1638),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [388] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1640),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [389] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1640),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [390] = {
    [sym__simple_heredoc_body] = ACTIONS(1642),
    [sym__heredoc_body_beginning] = ACTIONS(1642),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [anon_sym_esac] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_EQ_TILDE] = ACTIONS(1644),
    [anon_sym_EQ_EQ] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [391] = {
    [aux_sym_concatenation_repeat1] = STATE(391),
    [sym__simple_heredoc_body] = ACTIONS(1642),
    [sym__heredoc_body_beginning] = ACTIONS(1642),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1646),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_EQ_TILDE] = ACTIONS(1644),
    [anon_sym_EQ_EQ] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [392] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym__string_content] = ACTIONS(727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
  },
  [393] = {
    [sym__concat] = ACTIONS(1649),
    [anon_sym_DQUOTE] = ACTIONS(1651),
    [anon_sym_DOLLAR] = ACTIONS(1651),
    [sym__string_content] = ACTIONS(1653),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1651),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1651),
    [anon_sym_BQUOTE] = ACTIONS(1651),
    [sym_comment] = ACTIONS(177),
  },
  [394] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym__string_content] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
  },
  [395] = {
    [anon_sym_DQUOTE] = ACTIONS(1651),
    [anon_sym_DOLLAR] = ACTIONS(1651),
    [sym__string_content] = ACTIONS(1653),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1651),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1651),
    [anon_sym_BQUOTE] = ACTIONS(1651),
    [sym_comment] = ACTIONS(177),
  },
  [396] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1655),
    [sym_comment] = ACTIONS(53),
  },
  [397] = {
    [sym_concatenation] = STATE(784),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(784),
    [anon_sym_RBRACE] = ACTIONS(1657),
    [anon_sym_EQ] = ACTIONS(1659),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1663),
    [anon_sym_COLON] = ACTIONS(1659),
    [anon_sym_COLON_QMARK] = ACTIONS(1659),
    [anon_sym_COLON_DASH] = ACTIONS(1659),
    [anon_sym_PERCENT] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [398] = {
    [sym_subscript] = STATE(788),
    [sym_variable_name] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1669),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_AT] = ACTIONS(1667),
    [anon_sym_QMARK] = ACTIONS(1667),
    [anon_sym_0] = ACTIONS(1671),
    [anon_sym__] = ACTIONS(1671),
  },
  [399] = {
    [sym_concatenation] = STATE(791),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(791),
    [anon_sym_RBRACE] = ACTIONS(1673),
    [anon_sym_EQ] = ACTIONS(1675),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1679),
    [anon_sym_COLON] = ACTIONS(1675),
    [anon_sym_COLON_QMARK] = ACTIONS(1675),
    [anon_sym_COLON_DASH] = ACTIONS(1675),
    [anon_sym_PERCENT] = ACTIONS(1675),
    [anon_sym_DASH] = ACTIONS(1675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [400] = {
    [sym_concatenation] = STATE(794),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(794),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(1683),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1685),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1687),
    [anon_sym_COLON] = ACTIONS(1683),
    [anon_sym_COLON_QMARK] = ACTIONS(1683),
    [anon_sym_COLON_DASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [401] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1689),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [402] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1689),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [403] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1689),
    [sym_comment] = ACTIONS(53),
  },
  [404] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1689),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [405] = {
    [sym__simple_heredoc_body] = ACTIONS(1691),
    [sym__heredoc_body_beginning] = ACTIONS(1691),
    [sym_file_descriptor] = ACTIONS(1691),
    [sym__concat] = ACTIONS(1691),
    [anon_sym_esac] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_RPAREN] = ACTIONS(1693),
    [anon_sym_SEMI_SEMI] = ACTIONS(1693),
    [anon_sym_PIPE_AMP] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [anon_sym_EQ_TILDE] = ACTIONS(1693),
    [anon_sym_EQ_EQ] = ACTIONS(1693),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1693),
    [anon_sym_AMP_GT] = ACTIONS(1693),
    [anon_sym_AMP_GT_GT] = ACTIONS(1693),
    [anon_sym_LT_AMP] = ACTIONS(1693),
    [anon_sym_GT_AMP] = ACTIONS(1693),
    [anon_sym_LT_LT] = ACTIONS(1693),
    [anon_sym_LT_LT_DASH] = ACTIONS(1693),
    [anon_sym_LT_LT_LT] = ACTIONS(1693),
    [sym__special_characters] = ACTIONS(1693),
    [anon_sym_DQUOTE] = ACTIONS(1693),
    [anon_sym_DOLLAR] = ACTIONS(1693),
    [sym_raw_string] = ACTIONS(1693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1693),
    [anon_sym_BQUOTE] = ACTIONS(1693),
    [anon_sym_LT_LPAREN] = ACTIONS(1693),
    [anon_sym_GT_LPAREN] = ACTIONS(1693),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1693),
    [anon_sym_LF] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1693),
  },
  [406] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1651),
    [anon_sym_DOLLAR] = ACTIONS(1695),
    [sym__string_content] = ACTIONS(1698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1701),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1704),
    [anon_sym_BQUOTE] = ACTIONS(1707),
    [sym_comment] = ACTIONS(177),
  },
  [407] = {
    [sym_concatenation] = STATE(798),
    [sym_string] = STATE(797),
    [sym_simple_expansion] = STATE(797),
    [sym_string_expansion] = STATE(797),
    [sym_expansion] = STATE(797),
    [sym_command_substitution] = STATE(797),
    [sym_process_substitution] = STATE(797),
    [sym__special_characters] = ACTIONS(1710),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(1712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1712),
  },
  [408] = {
    [sym_concatenation] = STATE(808),
    [sym_string] = STATE(803),
    [sym_simple_expansion] = STATE(803),
    [sym_string_expansion] = STATE(803),
    [sym_expansion] = STATE(803),
    [sym_command_substitution] = STATE(803),
    [sym_process_substitution] = STATE(803),
    [anon_sym_RBRACE] = ACTIONS(1714),
    [sym__special_characters] = ACTIONS(1716),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(1722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1722),
  },
  [409] = {
    [sym__simple_heredoc_body] = ACTIONS(1732),
    [sym__heredoc_body_beginning] = ACTIONS(1732),
    [sym_file_descriptor] = ACTIONS(1732),
    [sym__concat] = ACTIONS(1732),
    [anon_sym_esac] = ACTIONS(1734),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_RPAREN] = ACTIONS(1734),
    [anon_sym_SEMI_SEMI] = ACTIONS(1734),
    [anon_sym_PIPE_AMP] = ACTIONS(1734),
    [anon_sym_AMP_AMP] = ACTIONS(1734),
    [anon_sym_PIPE_PIPE] = ACTIONS(1734),
    [anon_sym_EQ_TILDE] = ACTIONS(1734),
    [anon_sym_EQ_EQ] = ACTIONS(1734),
    [anon_sym_LT] = ACTIONS(1734),
    [anon_sym_GT] = ACTIONS(1734),
    [anon_sym_GT_GT] = ACTIONS(1734),
    [anon_sym_AMP_GT] = ACTIONS(1734),
    [anon_sym_AMP_GT_GT] = ACTIONS(1734),
    [anon_sym_LT_AMP] = ACTIONS(1734),
    [anon_sym_GT_AMP] = ACTIONS(1734),
    [anon_sym_LT_LT] = ACTIONS(1734),
    [anon_sym_LT_LT_DASH] = ACTIONS(1734),
    [anon_sym_LT_LT_LT] = ACTIONS(1734),
    [sym__special_characters] = ACTIONS(1734),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [sym_raw_string] = ACTIONS(1734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1734),
    [anon_sym_BQUOTE] = ACTIONS(1734),
    [anon_sym_LT_LPAREN] = ACTIONS(1734),
    [anon_sym_GT_LPAREN] = ACTIONS(1734),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1734),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_LF] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1734),
  },
  [410] = {
    [aux_sym_concatenation_repeat1] = STATE(810),
    [sym__concat] = ACTIONS(1736),
    [anon_sym_RBRACE] = ACTIONS(1738),
    [anon_sym_EQ] = ACTIONS(1740),
    [sym__special_characters] = ACTIONS(1740),
    [anon_sym_DQUOTE] = ACTIONS(1738),
    [anon_sym_DOLLAR] = ACTIONS(1740),
    [sym_raw_string] = ACTIONS(1738),
    [anon_sym_POUND] = ACTIONS(1738),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1738),
    [anon_sym_COLON] = ACTIONS(1740),
    [anon_sym_COLON_QMARK] = ACTIONS(1740),
    [anon_sym_COLON_DASH] = ACTIONS(1740),
    [anon_sym_PERCENT] = ACTIONS(1740),
    [anon_sym_DASH] = ACTIONS(1740),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1738),
    [anon_sym_LT_LPAREN] = ACTIONS(1738),
    [anon_sym_GT_LPAREN] = ACTIONS(1738),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1740),
  },
  [411] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(812),
    [anon_sym_DQUOTE] = ACTIONS(1742),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [412] = {
    [sym_string] = STATE(814),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(1744),
    [sym_raw_string] = ACTIONS(1746),
    [anon_sym_POUND] = ACTIONS(1744),
    [anon_sym_DASH] = ACTIONS(1744),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1748),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_AT] = ACTIONS(1744),
    [anon_sym_QMARK] = ACTIONS(1744),
    [anon_sym_0] = ACTIONS(1750),
    [anon_sym__] = ACTIONS(1750),
  },
  [413] = {
    [aux_sym_concatenation_repeat1] = STATE(810),
    [sym__concat] = ACTIONS(1736),
    [anon_sym_RBRACE] = ACTIONS(1752),
    [anon_sym_EQ] = ACTIONS(1754),
    [sym__special_characters] = ACTIONS(1754),
    [anon_sym_DQUOTE] = ACTIONS(1752),
    [anon_sym_DOLLAR] = ACTIONS(1754),
    [sym_raw_string] = ACTIONS(1752),
    [anon_sym_POUND] = ACTIONS(1752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1752),
    [anon_sym_COLON] = ACTIONS(1754),
    [anon_sym_COLON_QMARK] = ACTIONS(1754),
    [anon_sym_COLON_DASH] = ACTIONS(1754),
    [anon_sym_PERCENT] = ACTIONS(1754),
    [anon_sym_DASH] = ACTIONS(1754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1752),
    [anon_sym_BQUOTE] = ACTIONS(1752),
    [anon_sym_LT_LPAREN] = ACTIONS(1752),
    [anon_sym_GT_LPAREN] = ACTIONS(1752),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1754),
  },
  [414] = {
    [sym_subscript] = STATE(820),
    [sym_variable_name] = ACTIONS(1756),
    [anon_sym_DOLLAR] = ACTIONS(1758),
    [anon_sym_POUND] = ACTIONS(1760),
    [anon_sym_DASH] = ACTIONS(1758),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1762),
    [anon_sym_STAR] = ACTIONS(1758),
    [anon_sym_AT] = ACTIONS(1758),
    [anon_sym_QMARK] = ACTIONS(1758),
    [anon_sym_0] = ACTIONS(1764),
    [anon_sym__] = ACTIONS(1764),
  },
  [415] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(1766),
  },
  [416] = {
    [sym_for_statement] = STATE(822),
    [sym_while_statement] = STATE(822),
    [sym_if_statement] = STATE(822),
    [sym_case_statement] = STATE(822),
    [sym_function_definition] = STATE(822),
    [sym_subshell] = STATE(822),
    [sym_pipeline] = STATE(822),
    [sym_list] = STATE(822),
    [sym_negated_command] = STATE(822),
    [sym_test_command] = STATE(822),
    [sym_declaration_command] = STATE(822),
    [sym_unset_command] = STATE(822),
    [sym_command] = STATE(822),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(823),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [417] = {
    [sym_for_statement] = STATE(824),
    [sym_while_statement] = STATE(824),
    [sym_if_statement] = STATE(824),
    [sym_case_statement] = STATE(824),
    [sym_function_definition] = STATE(824),
    [sym_subshell] = STATE(824),
    [sym_pipeline] = STATE(824),
    [sym_list] = STATE(824),
    [sym_negated_command] = STATE(824),
    [sym_test_command] = STATE(824),
    [sym_declaration_command] = STATE(824),
    [sym_unset_command] = STATE(824),
    [sym_command] = STATE(824),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(825),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [418] = {
    [sym_for_statement] = STATE(826),
    [sym_while_statement] = STATE(826),
    [sym_if_statement] = STATE(826),
    [sym_case_statement] = STATE(826),
    [sym_function_definition] = STATE(826),
    [sym_subshell] = STATE(826),
    [sym_pipeline] = STATE(826),
    [sym_list] = STATE(826),
    [sym_negated_command] = STATE(826),
    [sym_test_command] = STATE(826),
    [sym_declaration_command] = STATE(826),
    [sym_unset_command] = STATE(826),
    [sym_command] = STATE(826),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(827),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [419] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(1768),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [420] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1774),
    [sym_comment] = ACTIONS(53),
  },
  [421] = {
    [sym_concatenation] = STATE(833),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(833),
    [anon_sym_RBRACE] = ACTIONS(1776),
    [anon_sym_EQ] = ACTIONS(1778),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1780),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1782),
    [anon_sym_COLON] = ACTIONS(1778),
    [anon_sym_COLON_QMARK] = ACTIONS(1778),
    [anon_sym_COLON_DASH] = ACTIONS(1778),
    [anon_sym_PERCENT] = ACTIONS(1778),
    [anon_sym_DASH] = ACTIONS(1778),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [422] = {
    [sym_concatenation] = STATE(836),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(836),
    [anon_sym_RBRACE] = ACTIONS(1784),
    [anon_sym_EQ] = ACTIONS(1786),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1790),
    [anon_sym_COLON] = ACTIONS(1786),
    [anon_sym_COLON_QMARK] = ACTIONS(1786),
    [anon_sym_COLON_DASH] = ACTIONS(1786),
    [anon_sym_PERCENT] = ACTIONS(1786),
    [anon_sym_DASH] = ACTIONS(1786),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [423] = {
    [sym_concatenation] = STATE(838),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(838),
    [anon_sym_RBRACE] = ACTIONS(1714),
    [anon_sym_EQ] = ACTIONS(1792),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1794),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1796),
    [anon_sym_COLON] = ACTIONS(1792),
    [anon_sym_COLON_QMARK] = ACTIONS(1792),
    [anon_sym_COLON_DASH] = ACTIONS(1792),
    [anon_sym_PERCENT] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(1792),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [424] = {
    [sym__simple_heredoc_body] = ACTIONS(1798),
    [sym__heredoc_body_beginning] = ACTIONS(1798),
    [sym_file_descriptor] = ACTIONS(1798),
    [sym__concat] = ACTIONS(1798),
    [anon_sym_esac] = ACTIONS(1800),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1800),
    [anon_sym_SEMI_SEMI] = ACTIONS(1800),
    [anon_sym_PIPE_AMP] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(1800),
    [anon_sym_PIPE_PIPE] = ACTIONS(1800),
    [anon_sym_EQ_TILDE] = ACTIONS(1800),
    [anon_sym_EQ_EQ] = ACTIONS(1800),
    [anon_sym_LT] = ACTIONS(1800),
    [anon_sym_GT] = ACTIONS(1800),
    [anon_sym_GT_GT] = ACTIONS(1800),
    [anon_sym_AMP_GT] = ACTIONS(1800),
    [anon_sym_AMP_GT_GT] = ACTIONS(1800),
    [anon_sym_LT_AMP] = ACTIONS(1800),
    [anon_sym_GT_AMP] = ACTIONS(1800),
    [anon_sym_LT_LT] = ACTIONS(1800),
    [anon_sym_LT_LT_DASH] = ACTIONS(1800),
    [anon_sym_LT_LT_LT] = ACTIONS(1800),
    [sym__special_characters] = ACTIONS(1800),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [sym_raw_string] = ACTIONS(1800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1800),
    [anon_sym_BQUOTE] = ACTIONS(1800),
    [anon_sym_LT_LPAREN] = ACTIONS(1800),
    [anon_sym_GT_LPAREN] = ACTIONS(1800),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1800),
    [anon_sym_SEMI] = ACTIONS(1800),
    [anon_sym_LF] = ACTIONS(1798),
    [anon_sym_AMP] = ACTIONS(1800),
  },
  [425] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(1802),
  },
  [426] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(1804),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [427] = {
    [sym__simple_heredoc_body] = ACTIONS(1806),
    [sym__heredoc_body_beginning] = ACTIONS(1806),
    [sym_file_descriptor] = ACTIONS(1806),
    [sym__concat] = ACTIONS(1806),
    [anon_sym_esac] = ACTIONS(1808),
    [anon_sym_PIPE] = ACTIONS(1808),
    [anon_sym_RPAREN] = ACTIONS(1808),
    [anon_sym_SEMI_SEMI] = ACTIONS(1808),
    [anon_sym_PIPE_AMP] = ACTIONS(1808),
    [anon_sym_AMP_AMP] = ACTIONS(1808),
    [anon_sym_PIPE_PIPE] = ACTIONS(1808),
    [anon_sym_EQ_TILDE] = ACTIONS(1808),
    [anon_sym_EQ_EQ] = ACTIONS(1808),
    [anon_sym_LT] = ACTIONS(1808),
    [anon_sym_GT] = ACTIONS(1808),
    [anon_sym_GT_GT] = ACTIONS(1808),
    [anon_sym_AMP_GT] = ACTIONS(1808),
    [anon_sym_AMP_GT_GT] = ACTIONS(1808),
    [anon_sym_LT_AMP] = ACTIONS(1808),
    [anon_sym_GT_AMP] = ACTIONS(1808),
    [anon_sym_LT_LT] = ACTIONS(1808),
    [anon_sym_LT_LT_DASH] = ACTIONS(1808),
    [anon_sym_LT_LT_LT] = ACTIONS(1808),
    [sym__special_characters] = ACTIONS(1808),
    [anon_sym_DQUOTE] = ACTIONS(1808),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [sym_raw_string] = ACTIONS(1808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1808),
    [anon_sym_BQUOTE] = ACTIONS(1808),
    [anon_sym_LT_LPAREN] = ACTIONS(1808),
    [anon_sym_GT_LPAREN] = ACTIONS(1808),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1808),
    [anon_sym_SEMI] = ACTIONS(1808),
    [anon_sym_LF] = ACTIONS(1806),
    [anon_sym_AMP] = ACTIONS(1808),
  },
  [428] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(1810),
  },
  [429] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(1714),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [430] = {
    [sym_concatenation] = STATE(662),
    [sym_string] = STATE(843),
    [sym_array] = STATE(662),
    [sym_simple_expansion] = STATE(843),
    [sym_string_expansion] = STATE(843),
    [sym_expansion] = STATE(843),
    [sym_command_substitution] = STATE(843),
    [sym_process_substitution] = STATE(843),
    [sym__empty_value] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [sym__special_characters] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(1814),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1814),
  },
  [431] = {
    [anon_sym_in] = ACTIONS(1816),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1820),
    [anon_sym_AMP] = ACTIONS(1818),
  },
  [432] = {
    [sym_do_group] = STATE(847),
    [anon_sym_do] = ACTIONS(1822),
    [sym_comment] = ACTIONS(53),
  },
  [433] = {
    [anon_sym_then] = ACTIONS(1824),
    [sym_comment] = ACTIONS(53),
  },
  [434] = {
    [aux_sym_concatenation_repeat1] = STATE(231),
    [sym__concat] = ACTIONS(419),
    [anon_sym_in] = ACTIONS(1826),
    [anon_sym_SEMI_SEMI] = ACTIONS(1828),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1828),
    [anon_sym_LF] = ACTIONS(1830),
    [anon_sym_AMP] = ACTIONS(1828),
  },
  [435] = {
    [aux_sym_concatenation_repeat1] = STATE(231),
    [sym__concat] = ACTIONS(419),
    [anon_sym_in] = ACTIONS(1832),
    [anon_sym_SEMI_SEMI] = ACTIONS(1834),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1836),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [436] = {
    [anon_sym_in] = ACTIONS(1832),
    [anon_sym_SEMI_SEMI] = ACTIONS(1834),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1836),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [437] = {
    [sym_compound_statement] = STATE(855),
    [anon_sym_LPAREN] = ACTIONS(1838),
    [anon_sym_LBRACE] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
  },
  [438] = {
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(1842),
    [anon_sym_SEMI_SEMI] = ACTIONS(1844),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1844),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1844),
  },
  [439] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(1842),
    [anon_sym_SEMI_SEMI] = ACTIONS(1844),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(1844),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1844),
  },
  [440] = {
    [sym__terminated_statement] = STATE(282),
    [sym_for_statement] = STATE(858),
    [sym_while_statement] = STATE(858),
    [sym_if_statement] = STATE(858),
    [sym_case_statement] = STATE(858),
    [sym_function_definition] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_pipeline] = STATE(858),
    [sym_list] = STATE(858),
    [sym_negated_command] = STATE(858),
    [sym_test_command] = STATE(858),
    [sym_declaration_command] = STATE(858),
    [sym_unset_command] = STATE(858),
    [sym_command] = STATE(858),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(859),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_program_repeat1] = STATE(282),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_typeset] = ACTIONS(97),
    [anon_sym_export] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_local] = ACTIONS(97),
    [anon_sym_unset] = ACTIONS(99),
    [anon_sym_unsetenv] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(105),
  },
  [441] = {
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_RPAREN] = ACTIONS(501),
    [anon_sym_PIPE_AMP] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym_comment] = ACTIONS(53),
  },
  [442] = {
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_RBRACK] = ACTIONS(1848),
    [anon_sym_EQ_TILDE] = ACTIONS(547),
    [anon_sym_EQ_EQ] = ACTIONS(547),
    [anon_sym_EQ] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(543),
  },
  [443] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1848),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [444] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(1850),
    [anon_sym_PLUS_EQ] = ACTIONS(1850),
    [sym_comment] = ACTIONS(53),
  },
  [445] = {
    [aux_sym_concatenation_repeat1] = STATE(863),
    [sym__concat] = ACTIONS(1852),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym__special_characters] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
  },
  [446] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(865),
    [anon_sym_DQUOTE] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [447] = {
    [sym_string] = STATE(867),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [sym_raw_string] = ACTIONS(1858),
    [anon_sym_POUND] = ACTIONS(1856),
    [anon_sym_DASH] = ACTIONS(1856),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1860),
    [anon_sym_STAR] = ACTIONS(1856),
    [anon_sym_AT] = ACTIONS(1856),
    [anon_sym_QMARK] = ACTIONS(1856),
    [anon_sym_0] = ACTIONS(1862),
    [anon_sym__] = ACTIONS(1862),
  },
  [448] = {
    [aux_sym_concatenation_repeat1] = STATE(863),
    [sym__concat] = ACTIONS(1852),
    [sym_variable_name] = ACTIONS(599),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_RPAREN] = ACTIONS(599),
    [anon_sym_PIPE_AMP] = ACTIONS(599),
    [anon_sym_AMP_AMP] = ACTIONS(599),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [sym__special_characters] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(601),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(599),
    [anon_sym_BQUOTE] = ACTIONS(599),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(601),
    [sym_word] = ACTIONS(601),
  },
  [449] = {
    [sym_subscript] = STATE(873),
    [sym_variable_name] = ACTIONS(1864),
    [anon_sym_DOLLAR] = ACTIONS(1866),
    [anon_sym_POUND] = ACTIONS(1868),
    [anon_sym_DASH] = ACTIONS(1866),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1870),
    [anon_sym_STAR] = ACTIONS(1866),
    [anon_sym_AT] = ACTIONS(1866),
    [anon_sym_QMARK] = ACTIONS(1866),
    [anon_sym_0] = ACTIONS(1872),
    [anon_sym__] = ACTIONS(1872),
  },
  [450] = {
    [sym_for_statement] = STATE(874),
    [sym_while_statement] = STATE(874),
    [sym_if_statement] = STATE(874),
    [sym_case_statement] = STATE(874),
    [sym_function_definition] = STATE(874),
    [sym_subshell] = STATE(874),
    [sym_pipeline] = STATE(874),
    [sym_list] = STATE(874),
    [sym_negated_command] = STATE(874),
    [sym_test_command] = STATE(874),
    [sym_declaration_command] = STATE(874),
    [sym_unset_command] = STATE(874),
    [sym_command] = STATE(874),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(875),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [451] = {
    [sym_for_statement] = STATE(876),
    [sym_while_statement] = STATE(876),
    [sym_if_statement] = STATE(876),
    [sym_case_statement] = STATE(876),
    [sym_function_definition] = STATE(876),
    [sym_subshell] = STATE(876),
    [sym_pipeline] = STATE(876),
    [sym_list] = STATE(876),
    [sym_negated_command] = STATE(876),
    [sym_test_command] = STATE(876),
    [sym_declaration_command] = STATE(876),
    [sym_unset_command] = STATE(876),
    [sym_command] = STATE(876),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(877),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [452] = {
    [sym_for_statement] = STATE(878),
    [sym_while_statement] = STATE(878),
    [sym_if_statement] = STATE(878),
    [sym_case_statement] = STATE(878),
    [sym_function_definition] = STATE(878),
    [sym_subshell] = STATE(878),
    [sym_pipeline] = STATE(878),
    [sym_list] = STATE(878),
    [sym_negated_command] = STATE(878),
    [sym_test_command] = STATE(878),
    [sym_declaration_command] = STATE(878),
    [sym_unset_command] = STATE(878),
    [sym_command] = STATE(878),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(879),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [453] = {
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(613),
    [anon_sym_PIPE_AMP] = ACTIONS(613),
    [anon_sym_AMP_AMP] = ACTIONS(613),
    [anon_sym_PIPE_PIPE] = ACTIONS(613),
    [sym__special_characters] = ACTIONS(613),
    [anon_sym_DQUOTE] = ACTIONS(613),
    [anon_sym_DOLLAR] = ACTIONS(615),
    [sym_raw_string] = ACTIONS(613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(613),
    [anon_sym_BQUOTE] = ACTIONS(613),
    [anon_sym_LT_LPAREN] = ACTIONS(613),
    [anon_sym_GT_LPAREN] = ACTIONS(613),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(615),
    [sym_word] = ACTIONS(615),
  },
  [454] = {
    [anon_sym_EQ] = ACTIONS(1850),
    [anon_sym_PLUS_EQ] = ACTIONS(1850),
    [sym_comment] = ACTIONS(53),
  },
  [455] = {
    [sym_variable_assignment] = STATE(880),
    [sym_subscript] = STATE(454),
    [sym_concatenation] = STATE(880),
    [sym_string] = STATE(448),
    [sym_simple_expansion] = STATE(448),
    [sym_string_expansion] = STATE(448),
    [sym_expansion] = STATE(448),
    [sym_command_substitution] = STATE(448),
    [sym_process_substitution] = STATE(448),
    [aux_sym_declaration_command_repeat1] = STATE(880),
    [sym_variable_name] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_RPAREN] = ACTIONS(619),
    [anon_sym_PIPE_AMP] = ACTIONS(619),
    [anon_sym_AMP_AMP] = ACTIONS(619),
    [anon_sym_PIPE_PIPE] = ACTIONS(619),
    [sym__special_characters] = ACTIONS(805),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(819),
    [anon_sym_GT_LPAREN] = ACTIONS(819),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(821),
    [sym_word] = ACTIONS(823),
  },
  [456] = {
    [aux_sym_concatenation_repeat1] = STATE(882),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_RPAREN] = ACTIONS(625),
    [anon_sym_PIPE_AMP] = ACTIONS(625),
    [anon_sym_AMP_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(625),
    [sym__special_characters] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [sym_raw_string] = ACTIONS(625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(625),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LT_LPAREN] = ACTIONS(625),
    [anon_sym_GT_LPAREN] = ACTIONS(625),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(623),
    [sym_word] = ACTIONS(623),
  },
  [457] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(884),
    [anon_sym_DQUOTE] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [458] = {
    [sym_string] = STATE(886),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [sym_raw_string] = ACTIONS(1880),
    [anon_sym_POUND] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1882),
    [anon_sym_STAR] = ACTIONS(1878),
    [anon_sym_AT] = ACTIONS(1878),
    [anon_sym_QMARK] = ACTIONS(1878),
    [anon_sym_0] = ACTIONS(1884),
    [anon_sym__] = ACTIONS(1884),
  },
  [459] = {
    [aux_sym_concatenation_repeat1] = STATE(882),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_RPAREN] = ACTIONS(641),
    [anon_sym_PIPE_AMP] = ACTIONS(641),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [sym__special_characters] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(639),
    [sym_raw_string] = ACTIONS(641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(641),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(641),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [anon_sym_LT_LPAREN] = ACTIONS(641),
    [anon_sym_GT_LPAREN] = ACTIONS(641),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(639),
    [sym_word] = ACTIONS(639),
  },
  [460] = {
    [sym_subscript] = STATE(892),
    [sym_variable_name] = ACTIONS(1886),
    [anon_sym_DOLLAR] = ACTIONS(1888),
    [anon_sym_POUND] = ACTIONS(1890),
    [anon_sym_DASH] = ACTIONS(1888),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1892),
    [anon_sym_STAR] = ACTIONS(1888),
    [anon_sym_AT] = ACTIONS(1888),
    [anon_sym_QMARK] = ACTIONS(1888),
    [anon_sym_0] = ACTIONS(1894),
    [anon_sym__] = ACTIONS(1894),
  },
  [461] = {
    [sym_for_statement] = STATE(893),
    [sym_while_statement] = STATE(893),
    [sym_if_statement] = STATE(893),
    [sym_case_statement] = STATE(893),
    [sym_function_definition] = STATE(893),
    [sym_subshell] = STATE(893),
    [sym_pipeline] = STATE(893),
    [sym_list] = STATE(893),
    [sym_negated_command] = STATE(893),
    [sym_test_command] = STATE(893),
    [sym_declaration_command] = STATE(893),
    [sym_unset_command] = STATE(893),
    [sym_command] = STATE(893),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(894),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [462] = {
    [sym_for_statement] = STATE(895),
    [sym_while_statement] = STATE(895),
    [sym_if_statement] = STATE(895),
    [sym_case_statement] = STATE(895),
    [sym_function_definition] = STATE(895),
    [sym_subshell] = STATE(895),
    [sym_pipeline] = STATE(895),
    [sym_list] = STATE(895),
    [sym_negated_command] = STATE(895),
    [sym_test_command] = STATE(895),
    [sym_declaration_command] = STATE(895),
    [sym_unset_command] = STATE(895),
    [sym_command] = STATE(895),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(896),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [463] = {
    [sym_for_statement] = STATE(897),
    [sym_while_statement] = STATE(897),
    [sym_if_statement] = STATE(897),
    [sym_case_statement] = STATE(897),
    [sym_function_definition] = STATE(897),
    [sym_subshell] = STATE(897),
    [sym_pipeline] = STATE(897),
    [sym_list] = STATE(897),
    [sym_negated_command] = STATE(897),
    [sym_test_command] = STATE(897),
    [sym_declaration_command] = STATE(897),
    [sym_unset_command] = STATE(897),
    [sym_command] = STATE(897),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(898),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [464] = {
    [anon_sym_PIPE] = ACTIONS(653),
    [anon_sym_RPAREN] = ACTIONS(655),
    [anon_sym_PIPE_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(655),
    [sym__special_characters] = ACTIONS(655),
    [anon_sym_DQUOTE] = ACTIONS(655),
    [anon_sym_DOLLAR] = ACTIONS(653),
    [sym_raw_string] = ACTIONS(655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(655),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(655),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_LT_LPAREN] = ACTIONS(655),
    [anon_sym_GT_LPAREN] = ACTIONS(655),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(653),
    [sym_word] = ACTIONS(653),
  },
  [465] = {
    [sym_concatenation] = STATE(899),
    [sym_string] = STATE(459),
    [sym_simple_expansion] = STATE(459),
    [sym_string_expansion] = STATE(459),
    [sym_expansion] = STATE(459),
    [sym_command_substitution] = STATE(459),
    [sym_process_substitution] = STATE(459),
    [aux_sym_unset_command_repeat1] = STATE(899),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_RPAREN] = ACTIONS(659),
    [anon_sym_PIPE_AMP] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [sym__special_characters] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(841),
    [sym_word] = ACTIONS(843),
  },
  [466] = {
    [sym_string] = STATE(900),
    [sym_simple_expansion] = STATE(900),
    [sym_string_expansion] = STATE(900),
    [sym_expansion] = STATE(900),
    [sym_command_substitution] = STATE(900),
    [sym_process_substitution] = STATE(900),
    [sym__special_characters] = ACTIONS(1896),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(1896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1896),
  },
  [467] = {
    [aux_sym_concatenation_repeat1] = STATE(901),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_LT] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(695),
  },
  [468] = {
    [sym__simple_heredoc_body] = ACTIONS(697),
    [sym__heredoc_body_beginning] = ACTIONS(697),
    [sym_file_descriptor] = ACTIONS(697),
    [sym__concat] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_PIPE_AMP] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [anon_sym_EQ_TILDE] = ACTIONS(699),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(697),
    [anon_sym_AMP_GT] = ACTIONS(699),
    [anon_sym_AMP_GT_GT] = ACTIONS(697),
    [anon_sym_LT_AMP] = ACTIONS(697),
    [anon_sym_GT_AMP] = ACTIONS(697),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_LT] = ACTIONS(697),
    [sym__special_characters] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [anon_sym_LT_LPAREN] = ACTIONS(697),
    [anon_sym_GT_LPAREN] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(699),
  },
  [469] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1898),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [470] = {
    [sym__simple_heredoc_body] = ACTIONS(727),
    [sym__heredoc_body_beginning] = ACTIONS(727),
    [sym_file_descriptor] = ACTIONS(727),
    [sym__concat] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(727),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(727),
    [anon_sym_PIPE_PIPE] = ACTIONS(727),
    [anon_sym_EQ_TILDE] = ACTIONS(729),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_AMP_GT] = ACTIONS(729),
    [anon_sym_AMP_GT_GT] = ACTIONS(727),
    [anon_sym_LT_AMP] = ACTIONS(727),
    [anon_sym_GT_AMP] = ACTIONS(727),
    [anon_sym_LT_LT] = ACTIONS(729),
    [anon_sym_LT_LT_DASH] = ACTIONS(727),
    [anon_sym_LT_LT_LT] = ACTIONS(727),
    [sym__special_characters] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(727),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [anon_sym_LT_LPAREN] = ACTIONS(727),
    [anon_sym_GT_LPAREN] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(729),
  },
  [471] = {
    [sym__simple_heredoc_body] = ACTIONS(731),
    [sym__heredoc_body_beginning] = ACTIONS(731),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(733),
  },
  [472] = {
    [sym__simple_heredoc_body] = ACTIONS(735),
    [sym__heredoc_body_beginning] = ACTIONS(735),
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(735),
    [anon_sym_LT_AMP] = ACTIONS(735),
    [anon_sym_GT_AMP] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(735),
    [anon_sym_LT_LT_LT] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(737),
  },
  [473] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1900),
    [sym_comment] = ACTIONS(53),
  },
  [474] = {
    [sym_concatenation] = STATE(906),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(906),
    [anon_sym_RBRACE] = ACTIONS(1902),
    [anon_sym_EQ] = ACTIONS(1904),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1908),
    [anon_sym_COLON] = ACTIONS(1904),
    [anon_sym_COLON_QMARK] = ACTIONS(1904),
    [anon_sym_COLON_DASH] = ACTIONS(1904),
    [anon_sym_PERCENT] = ACTIONS(1904),
    [anon_sym_DASH] = ACTIONS(1904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [475] = {
    [sym_subscript] = STATE(910),
    [sym_variable_name] = ACTIONS(1910),
    [anon_sym_DOLLAR] = ACTIONS(1912),
    [anon_sym_DASH] = ACTIONS(1912),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(1912),
    [anon_sym_AT] = ACTIONS(1912),
    [anon_sym_QMARK] = ACTIONS(1912),
    [anon_sym_0] = ACTIONS(1916),
    [anon_sym__] = ACTIONS(1916),
  },
  [476] = {
    [sym_concatenation] = STATE(913),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(913),
    [anon_sym_RBRACE] = ACTIONS(1918),
    [anon_sym_EQ] = ACTIONS(1920),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1922),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1924),
    [anon_sym_COLON] = ACTIONS(1920),
    [anon_sym_COLON_QMARK] = ACTIONS(1920),
    [anon_sym_COLON_DASH] = ACTIONS(1920),
    [anon_sym_PERCENT] = ACTIONS(1920),
    [anon_sym_DASH] = ACTIONS(1920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [477] = {
    [sym_concatenation] = STATE(916),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(916),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_EQ] = ACTIONS(1928),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1932),
    [anon_sym_COLON] = ACTIONS(1928),
    [anon_sym_COLON_QMARK] = ACTIONS(1928),
    [anon_sym_COLON_DASH] = ACTIONS(1928),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1928),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [478] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1934),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [479] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1934),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [480] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1934),
    [sym_comment] = ACTIONS(53),
  },
  [481] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1934),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [482] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1936),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [483] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1936),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [484] = {
    [anon_sym_RPAREN] = ACTIONS(1938),
    [sym_comment] = ACTIONS(53),
  },
  [485] = {
    [sym_for_statement] = STATE(920),
    [sym_while_statement] = STATE(920),
    [sym_if_statement] = STATE(920),
    [sym_case_statement] = STATE(920),
    [sym_function_definition] = STATE(920),
    [sym_subshell] = STATE(920),
    [sym_pipeline] = STATE(920),
    [sym_list] = STATE(920),
    [sym_negated_command] = STATE(920),
    [sym_test_command] = STATE(920),
    [sym_declaration_command] = STATE(920),
    [sym_unset_command] = STATE(920),
    [sym_command] = STATE(920),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(921),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [486] = {
    [sym__simple_heredoc_body] = ACTIONS(1940),
    [sym__heredoc_body_beginning] = ACTIONS(1940),
    [sym_file_descriptor] = ACTIONS(1940),
    [sym__concat] = ACTIONS(1940),
    [anon_sym_esac] = ACTIONS(1942),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1942),
    [anon_sym_PIPE_AMP] = ACTIONS(1942),
    [anon_sym_AMP_AMP] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1942),
    [anon_sym_EQ_TILDE] = ACTIONS(1942),
    [anon_sym_EQ_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1942),
    [anon_sym_LT_AMP] = ACTIONS(1942),
    [anon_sym_GT_AMP] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_LT_LT_DASH] = ACTIONS(1942),
    [anon_sym_LT_LT_LT] = ACTIONS(1942),
    [sym__special_characters] = ACTIONS(1942),
    [anon_sym_DQUOTE] = ACTIONS(1942),
    [anon_sym_DOLLAR] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1942),
    [anon_sym_BQUOTE] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1942),
    [anon_sym_GT_LPAREN] = ACTIONS(1942),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [487] = {
    [sym_for_statement] = STATE(922),
    [sym_while_statement] = STATE(922),
    [sym_if_statement] = STATE(922),
    [sym_case_statement] = STATE(922),
    [sym_function_definition] = STATE(922),
    [sym_subshell] = STATE(922),
    [sym_pipeline] = STATE(922),
    [sym_list] = STATE(922),
    [sym_negated_command] = STATE(922),
    [sym_test_command] = STATE(922),
    [sym_declaration_command] = STATE(922),
    [sym_unset_command] = STATE(922),
    [sym_command] = STATE(922),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(923),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [488] = {
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_RPAREN] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [sym_comment] = ACTIONS(53),
  },
  [489] = {
    [sym_simple_expansion] = STATE(925),
    [sym_expansion] = STATE(925),
    [aux_sym_heredoc_body_repeat1] = STATE(925),
    [sym__heredoc_body_middle] = ACTIONS(1944),
    [sym__heredoc_body_end] = ACTIONS(1946),
    [anon_sym_DOLLAR] = ACTIONS(963),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(965),
    [sym_comment] = ACTIONS(53),
  },
  [490] = {
    [anon_sym_LT] = ACTIONS(1948),
    [anon_sym_GT] = ACTIONS(1948),
    [anon_sym_GT_GT] = ACTIONS(1950),
    [anon_sym_AMP_GT] = ACTIONS(1948),
    [anon_sym_AMP_GT_GT] = ACTIONS(1950),
    [anon_sym_LT_AMP] = ACTIONS(1950),
    [anon_sym_GT_AMP] = ACTIONS(1950),
    [sym_comment] = ACTIONS(53),
  },
  [491] = {
    [sym_concatenation] = STATE(929),
    [sym_string] = STATE(928),
    [sym_simple_expansion] = STATE(928),
    [sym_string_expansion] = STATE(928),
    [sym_expansion] = STATE(928),
    [sym_command_substitution] = STATE(928),
    [sym_process_substitution] = STATE(928),
    [sym__special_characters] = ACTIONS(1952),
    [anon_sym_DQUOTE] = ACTIONS(1954),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(1956),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1956),
    [sym_regex] = ACTIONS(1966),
  },
  [492] = {
    [sym_concatenation] = STATE(932),
    [sym_string] = STATE(931),
    [sym_simple_expansion] = STATE(931),
    [sym_string_expansion] = STATE(931),
    [sym_expansion] = STATE(931),
    [sym_command_substitution] = STATE(931),
    [sym_process_substitution] = STATE(931),
    [sym__special_characters] = ACTIONS(1968),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(1970),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1970),
  },
  [493] = {
    [sym_heredoc_start] = ACTIONS(1972),
    [sym_comment] = ACTIONS(53),
  },
  [494] = {
    [sym_concatenation] = STATE(936),
    [sym_string] = STATE(935),
    [sym_simple_expansion] = STATE(935),
    [sym_string_expansion] = STATE(935),
    [sym_expansion] = STATE(935),
    [sym_command_substitution] = STATE(935),
    [sym_process_substitution] = STATE(935),
    [sym__special_characters] = ACTIONS(1974),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(1976),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1976),
  },
  [495] = {
    [aux_sym_concatenation_repeat1] = STATE(467),
    [sym__simple_heredoc_body] = ACTIONS(987),
    [sym__heredoc_body_beginning] = ACTIONS(987),
    [sym_file_descriptor] = ACTIONS(987),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_RPAREN] = ACTIONS(987),
    [anon_sym_PIPE_AMP] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(987),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [anon_sym_EQ_TILDE] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_GT] = ACTIONS(989),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_AMP_GT] = ACTIONS(989),
    [anon_sym_AMP_GT_GT] = ACTIONS(987),
    [anon_sym_LT_AMP] = ACTIONS(987),
    [anon_sym_GT_AMP] = ACTIONS(987),
    [anon_sym_LT_LT] = ACTIONS(989),
    [anon_sym_LT_LT_DASH] = ACTIONS(987),
    [anon_sym_LT_LT_LT] = ACTIONS(987),
    [sym__special_characters] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [sym_raw_string] = ACTIONS(987),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(987),
    [anon_sym_BQUOTE] = ACTIONS(987),
    [anon_sym_LT_LPAREN] = ACTIONS(987),
    [anon_sym_GT_LPAREN] = ACTIONS(987),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(989),
  },
  [496] = {
    [aux_sym_concatenation_repeat1] = STATE(467),
    [sym__simple_heredoc_body] = ACTIONS(991),
    [sym__heredoc_body_beginning] = ACTIONS(991),
    [sym_file_descriptor] = ACTIONS(991),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(991),
    [anon_sym_PIPE_AMP] = ACTIONS(991),
    [anon_sym_AMP_AMP] = ACTIONS(991),
    [anon_sym_PIPE_PIPE] = ACTIONS(991),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT] = ACTIONS(993),
    [anon_sym_GT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(991),
    [anon_sym_AMP_GT] = ACTIONS(993),
    [anon_sym_AMP_GT_GT] = ACTIONS(991),
    [anon_sym_LT_AMP] = ACTIONS(991),
    [anon_sym_GT_AMP] = ACTIONS(991),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_LT_LT_DASH] = ACTIONS(991),
    [anon_sym_LT_LT_LT] = ACTIONS(991),
    [sym__special_characters] = ACTIONS(991),
    [anon_sym_DQUOTE] = ACTIONS(991),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [sym_raw_string] = ACTIONS(991),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(991),
    [anon_sym_BQUOTE] = ACTIONS(991),
    [anon_sym_LT_LPAREN] = ACTIONS(991),
    [anon_sym_GT_LPAREN] = ACTIONS(991),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(993),
  },
  [497] = {
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [sym_comment] = ACTIONS(53),
  },
  [498] = {
    [sym_file_redirect] = STATE(938),
    [sym_heredoc_redirect] = STATE(938),
    [sym_heredoc_body] = STATE(937),
    [sym_herestring_redirect] = STATE(938),
    [aux_sym_while_statement_repeat1] = STATE(938),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym_comment] = ACTIONS(53),
  },
  [499] = {
    [sym_file_redirect] = STATE(939),
    [sym_heredoc_redirect] = STATE(939),
    [sym_heredoc_body] = STATE(937),
    [sym_herestring_redirect] = STATE(939),
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(496),
    [sym_simple_expansion] = STATE(496),
    [sym_string_expansion] = STATE(496),
    [sym_expansion] = STATE(496),
    [sym_command_substitution] = STATE(496),
    [sym_process_substitution] = STATE(496),
    [aux_sym_while_statement_repeat1] = STATE(939),
    [aux_sym_command_repeat2] = STATE(940),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym__special_characters] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(899),
  },
  [500] = {
    [sym_file_redirect] = STATE(939),
    [sym_heredoc_redirect] = STATE(939),
    [sym_heredoc_body] = STATE(937),
    [sym_herestring_redirect] = STATE(939),
    [sym_concatenation] = STATE(941),
    [sym_string] = STATE(496),
    [sym_simple_expansion] = STATE(496),
    [sym_string_expansion] = STATE(496),
    [sym_expansion] = STATE(496),
    [sym_command_substitution] = STATE(496),
    [sym_process_substitution] = STATE(496),
    [aux_sym_while_statement_repeat1] = STATE(939),
    [aux_sym_command_repeat2] = STATE(941),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym__special_characters] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(899),
  },
  [501] = {
    [sym_concatenation] = STATE(662),
    [sym_string] = STATE(943),
    [sym_array] = STATE(662),
    [sym_simple_expansion] = STATE(943),
    [sym_string_expansion] = STATE(943),
    [sym_expansion] = STATE(943),
    [sym_command_substitution] = STATE(943),
    [sym_process_substitution] = STATE(943),
    [sym__empty_value] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [sym__special_characters] = ACTIONS(1978),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(1980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1980),
  },
  [502] = {
    [sym_do_group] = STATE(944),
    [anon_sym_do] = ACTIONS(1822),
    [sym_comment] = ACTIONS(53),
  },
  [503] = {
    [sym_compound_statement] = STATE(946),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_LBRACE] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
  },
  [504] = {
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [anon_sym_EQ_TILDE] = ACTIONS(547),
    [anon_sym_EQ_EQ] = ACTIONS(547),
    [anon_sym_EQ] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(543),
  },
  [505] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1984),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [506] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_PLUS_EQ] = ACTIONS(1986),
    [sym_comment] = ACTIONS(53),
  },
  [507] = {
    [aux_sym_concatenation_repeat1] = STATE(949),
    [sym__concat] = ACTIONS(1852),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(585),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym__special_characters] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
  },
  [508] = {
    [aux_sym_concatenation_repeat1] = STATE(949),
    [sym__concat] = ACTIONS(1852),
    [sym_variable_name] = ACTIONS(599),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_PIPE_AMP] = ACTIONS(599),
    [anon_sym_AMP_AMP] = ACTIONS(599),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [sym__special_characters] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(601),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(599),
    [anon_sym_BQUOTE] = ACTIONS(599),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(601),
    [sym_word] = ACTIONS(601),
  },
  [509] = {
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_PLUS_EQ] = ACTIONS(1986),
    [sym_comment] = ACTIONS(53),
  },
  [510] = {
    [sym_variable_assignment] = STATE(950),
    [sym_subscript] = STATE(509),
    [sym_concatenation] = STATE(950),
    [sym_string] = STATE(508),
    [sym_simple_expansion] = STATE(508),
    [sym_string_expansion] = STATE(508),
    [sym_expansion] = STATE(508),
    [sym_command_substitution] = STATE(508),
    [sym_process_substitution] = STATE(508),
    [aux_sym_declaration_command_repeat1] = STATE(950),
    [sym_variable_name] = ACTIONS(907),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_PIPE_AMP] = ACTIONS(619),
    [anon_sym_AMP_AMP] = ACTIONS(619),
    [anon_sym_PIPE_PIPE] = ACTIONS(619),
    [sym__special_characters] = ACTIONS(909),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(619),
    [anon_sym_LT_LPAREN] = ACTIONS(819),
    [anon_sym_GT_LPAREN] = ACTIONS(819),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(821),
    [sym_word] = ACTIONS(913),
  },
  [511] = {
    [aux_sym_concatenation_repeat1] = STATE(951),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_PIPE_AMP] = ACTIONS(625),
    [anon_sym_AMP_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(625),
    [sym__special_characters] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [sym_raw_string] = ACTIONS(625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(625),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LT_LPAREN] = ACTIONS(625),
    [anon_sym_GT_LPAREN] = ACTIONS(625),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(623),
    [sym_word] = ACTIONS(623),
  },
  [512] = {
    [aux_sym_concatenation_repeat1] = STATE(951),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_PIPE_AMP] = ACTIONS(641),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [sym__special_characters] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(639),
    [sym_raw_string] = ACTIONS(641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(641),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(641),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [anon_sym_LT_LPAREN] = ACTIONS(641),
    [anon_sym_GT_LPAREN] = ACTIONS(641),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(639),
    [sym_word] = ACTIONS(639),
  },
  [513] = {
    [sym_concatenation] = STATE(952),
    [sym_string] = STATE(512),
    [sym_simple_expansion] = STATE(512),
    [sym_string_expansion] = STATE(512),
    [sym_expansion] = STATE(512),
    [sym_command_substitution] = STATE(512),
    [sym_process_substitution] = STATE(512),
    [aux_sym_unset_command_repeat1] = STATE(952),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_PIPE_AMP] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [sym__special_characters] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(659),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(841),
    [sym_word] = ACTIONS(919),
  },
  [514] = {
    [aux_sym_concatenation_repeat1] = STATE(953),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_LT] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(695),
  },
  [515] = {
    [anon_sym_RPAREN] = ACTIONS(1988),
    [sym_comment] = ACTIONS(53),
  },
  [516] = {
    [sym_for_statement] = STATE(920),
    [sym_while_statement] = STATE(920),
    [sym_if_statement] = STATE(920),
    [sym_case_statement] = STATE(920),
    [sym_function_definition] = STATE(920),
    [sym_subshell] = STATE(920),
    [sym_pipeline] = STATE(920),
    [sym_list] = STATE(920),
    [sym_negated_command] = STATE(920),
    [sym_test_command] = STATE(920),
    [sym_declaration_command] = STATE(920),
    [sym_unset_command] = STATE(920),
    [sym_command] = STATE(920),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(955),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [517] = {
    [sym_for_statement] = STATE(956),
    [sym_while_statement] = STATE(956),
    [sym_if_statement] = STATE(956),
    [sym_case_statement] = STATE(956),
    [sym_function_definition] = STATE(956),
    [sym_subshell] = STATE(956),
    [sym_pipeline] = STATE(956),
    [sym_list] = STATE(956),
    [sym_negated_command] = STATE(956),
    [sym_test_command] = STATE(956),
    [sym_declaration_command] = STATE(956),
    [sym_unset_command] = STATE(956),
    [sym_command] = STATE(956),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(957),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [518] = {
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_GT_GT] = ACTIONS(1992),
    [anon_sym_AMP_GT] = ACTIONS(1990),
    [anon_sym_AMP_GT_GT] = ACTIONS(1992),
    [anon_sym_LT_AMP] = ACTIONS(1992),
    [anon_sym_GT_AMP] = ACTIONS(1992),
    [sym_comment] = ACTIONS(53),
  },
  [519] = {
    [sym_concatenation] = STATE(929),
    [sym_string] = STATE(960),
    [sym_simple_expansion] = STATE(960),
    [sym_string_expansion] = STATE(960),
    [sym_expansion] = STATE(960),
    [sym_command_substitution] = STATE(960),
    [sym_process_substitution] = STATE(960),
    [sym__special_characters] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1954),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(1996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1996),
    [sym_regex] = ACTIONS(1966),
  },
  [520] = {
    [sym_concatenation] = STATE(932),
    [sym_string] = STATE(962),
    [sym_simple_expansion] = STATE(962),
    [sym_string_expansion] = STATE(962),
    [sym_expansion] = STATE(962),
    [sym_command_substitution] = STATE(962),
    [sym_process_substitution] = STATE(962),
    [sym__special_characters] = ACTIONS(1998),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(2000),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2000),
  },
  [521] = {
    [sym_concatenation] = STATE(936),
    [sym_string] = STATE(964),
    [sym_simple_expansion] = STATE(964),
    [sym_string_expansion] = STATE(964),
    [sym_expansion] = STATE(964),
    [sym_command_substitution] = STATE(964),
    [sym_process_substitution] = STATE(964),
    [sym__special_characters] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(2004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2004),
  },
  [522] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(987),
    [sym__heredoc_body_beginning] = ACTIONS(987),
    [sym_file_descriptor] = ACTIONS(987),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_PIPE_AMP] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(987),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [anon_sym_EQ_TILDE] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_GT] = ACTIONS(989),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_AMP_GT] = ACTIONS(989),
    [anon_sym_AMP_GT_GT] = ACTIONS(987),
    [anon_sym_LT_AMP] = ACTIONS(987),
    [anon_sym_GT_AMP] = ACTIONS(987),
    [anon_sym_LT_LT] = ACTIONS(989),
    [anon_sym_LT_LT_DASH] = ACTIONS(987),
    [anon_sym_LT_LT_LT] = ACTIONS(987),
    [sym__special_characters] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [sym_raw_string] = ACTIONS(987),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(987),
    [anon_sym_BQUOTE] = ACTIONS(987),
    [anon_sym_LT_LPAREN] = ACTIONS(987),
    [anon_sym_GT_LPAREN] = ACTIONS(987),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(989),
  },
  [523] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(991),
    [sym__heredoc_body_beginning] = ACTIONS(991),
    [sym_file_descriptor] = ACTIONS(991),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PIPE_AMP] = ACTIONS(991),
    [anon_sym_AMP_AMP] = ACTIONS(991),
    [anon_sym_PIPE_PIPE] = ACTIONS(991),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT] = ACTIONS(993),
    [anon_sym_GT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(991),
    [anon_sym_AMP_GT] = ACTIONS(993),
    [anon_sym_AMP_GT_GT] = ACTIONS(991),
    [anon_sym_LT_AMP] = ACTIONS(991),
    [anon_sym_GT_AMP] = ACTIONS(991),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_LT_LT_DASH] = ACTIONS(991),
    [anon_sym_LT_LT_LT] = ACTIONS(991),
    [sym__special_characters] = ACTIONS(991),
    [anon_sym_DQUOTE] = ACTIONS(991),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [sym_raw_string] = ACTIONS(991),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(991),
    [anon_sym_BQUOTE] = ACTIONS(991),
    [anon_sym_LT_LPAREN] = ACTIONS(991),
    [anon_sym_GT_LPAREN] = ACTIONS(991),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(993),
  },
  [524] = {
    [sym_file_redirect] = STATE(965),
    [sym_heredoc_redirect] = STATE(965),
    [sym_heredoc_body] = STATE(937),
    [sym_herestring_redirect] = STATE(965),
    [aux_sym_while_statement_repeat1] = STATE(965),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [sym_comment] = ACTIONS(53),
  },
  [525] = {
    [sym_file_redirect] = STATE(966),
    [sym_heredoc_redirect] = STATE(966),
    [sym_heredoc_body] = STATE(937),
    [sym_herestring_redirect] = STATE(966),
    [sym_concatenation] = STATE(967),
    [sym_string] = STATE(523),
    [sym_simple_expansion] = STATE(523),
    [sym_string_expansion] = STATE(523),
    [sym_expansion] = STATE(523),
    [sym_command_substitution] = STATE(523),
    [sym_process_substitution] = STATE(523),
    [aux_sym_while_statement_repeat1] = STATE(966),
    [aux_sym_command_repeat2] = STATE(967),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(931),
    [anon_sym_EQ_EQ] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(943),
  },
  [526] = {
    [sym_file_redirect] = STATE(966),
    [sym_heredoc_redirect] = STATE(966),
    [sym_heredoc_body] = STATE(937),
    [sym_herestring_redirect] = STATE(966),
    [sym_concatenation] = STATE(968),
    [sym_string] = STATE(523),
    [sym_simple_expansion] = STATE(523),
    [sym_string_expansion] = STATE(523),
    [sym_expansion] = STATE(523),
    [sym_command_substitution] = STATE(523),
    [sym_process_substitution] = STATE(523),
    [aux_sym_while_statement_repeat1] = STATE(966),
    [aux_sym_command_repeat2] = STATE(968),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(931),
    [anon_sym_EQ_EQ] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(943),
  },
  [527] = {
    [sym__simple_heredoc_body] = ACTIONS(2006),
    [sym__heredoc_body_beginning] = ACTIONS(2006),
    [sym_file_descriptor] = ACTIONS(2006),
    [sym__concat] = ACTIONS(2006),
    [anon_sym_esac] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_RPAREN] = ACTIONS(2008),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [anon_sym_EQ_TILDE] = ACTIONS(2008),
    [anon_sym_EQ_EQ] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2008),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2008),
    [anon_sym_LT_AMP] = ACTIONS(2008),
    [anon_sym_GT_AMP] = ACTIONS(2008),
    [anon_sym_LT_LT] = ACTIONS(2008),
    [anon_sym_LT_LT_DASH] = ACTIONS(2008),
    [anon_sym_LT_LT_LT] = ACTIONS(2008),
    [sym__special_characters] = ACTIONS(2008),
    [anon_sym_DQUOTE] = ACTIONS(2008),
    [anon_sym_DOLLAR] = ACTIONS(2008),
    [sym_raw_string] = ACTIONS(2008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2008),
    [anon_sym_BQUOTE] = ACTIONS(2008),
    [anon_sym_LT_LPAREN] = ACTIONS(2008),
    [anon_sym_GT_LPAREN] = ACTIONS(2008),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2008),
  },
  [528] = {
    [sym_compound_statement] = STATE(969),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [529] = {
    [anon_sym_esac] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_RPAREN] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2010),
  },
  [530] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_RPAREN] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2010),
  },
  [531] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(2014),
    [anon_sym_PIPE_PIPE] = ACTIONS(2014),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_LF] = ACTIONS(2016),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [532] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(2014),
    [anon_sym_PIPE_PIPE] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_LF] = ACTIONS(2016),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [533] = {
    [anon_sym_esac] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2018),
    [anon_sym_RPAREN] = ACTIONS(2018),
    [anon_sym_SEMI_SEMI] = ACTIONS(2018),
    [anon_sym_PIPE_AMP] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_PIPE_PIPE] = ACTIONS(2018),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2018),
    [anon_sym_LF] = ACTIONS(2020),
    [anon_sym_AMP] = ACTIONS(2018),
  },
  [534] = {
    [anon_sym_DOLLAR] = ACTIONS(2022),
    [anon_sym_POUND] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2022),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2024),
    [anon_sym_STAR] = ACTIONS(2022),
    [anon_sym_AT] = ACTIONS(2022),
    [anon_sym_QMARK] = ACTIONS(2022),
    [anon_sym_0] = ACTIONS(2026),
    [anon_sym__] = ACTIONS(2026),
  },
  [535] = {
    [sym_subscript] = STATE(976),
    [sym_variable_name] = ACTIONS(2028),
    [anon_sym_DOLLAR] = ACTIONS(2030),
    [anon_sym_POUND] = ACTIONS(2032),
    [anon_sym_DASH] = ACTIONS(2030),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2034),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_AT] = ACTIONS(2030),
    [anon_sym_QMARK] = ACTIONS(2030),
    [anon_sym_0] = ACTIONS(2036),
    [anon_sym__] = ACTIONS(2036),
  },
  [536] = {
    [sym_simple_expansion] = STATE(978),
    [sym_expansion] = STATE(978),
    [aux_sym_heredoc_body_repeat1] = STATE(978),
    [sym__heredoc_body_middle] = ACTIONS(2038),
    [sym__heredoc_body_end] = ACTIONS(2040),
    [anon_sym_DOLLAR] = ACTIONS(963),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(965),
    [sym_comment] = ACTIONS(53),
  },
  [537] = {
    [sym_concatenation] = STATE(981),
    [sym_string] = STATE(980),
    [sym_simple_expansion] = STATE(980),
    [sym_string_expansion] = STATE(980),
    [sym_expansion] = STATE(980),
    [sym_command_substitution] = STATE(980),
    [sym_process_substitution] = STATE(980),
    [sym__special_characters] = ACTIONS(2042),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(2044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2044),
  },
  [538] = {
    [aux_sym_concatenation_repeat1] = STATE(126),
    [sym__simple_heredoc_body] = ACTIONS(2046),
    [sym__heredoc_body_beginning] = ACTIONS(2046),
    [sym_file_descriptor] = ACTIONS(2046),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2048),
    [anon_sym_SEMI_SEMI] = ACTIONS(2048),
    [anon_sym_PIPE_AMP] = ACTIONS(2048),
    [anon_sym_AMP_AMP] = ACTIONS(2048),
    [anon_sym_PIPE_PIPE] = ACTIONS(2048),
    [anon_sym_EQ_TILDE] = ACTIONS(2048),
    [anon_sym_EQ_EQ] = ACTIONS(2048),
    [anon_sym_LT] = ACTIONS(2048),
    [anon_sym_GT] = ACTIONS(2048),
    [anon_sym_GT_GT] = ACTIONS(2048),
    [anon_sym_AMP_GT] = ACTIONS(2048),
    [anon_sym_AMP_GT_GT] = ACTIONS(2048),
    [anon_sym_LT_AMP] = ACTIONS(2048),
    [anon_sym_GT_AMP] = ACTIONS(2048),
    [anon_sym_LT_LT] = ACTIONS(2048),
    [anon_sym_LT_LT_DASH] = ACTIONS(2048),
    [anon_sym_LT_LT_LT] = ACTIONS(2048),
    [sym__special_characters] = ACTIONS(2048),
    [anon_sym_DQUOTE] = ACTIONS(2048),
    [anon_sym_DOLLAR] = ACTIONS(2048),
    [sym_raw_string] = ACTIONS(2048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2048),
    [anon_sym_BQUOTE] = ACTIONS(2048),
    [anon_sym_LT_LPAREN] = ACTIONS(2048),
    [anon_sym_GT_LPAREN] = ACTIONS(2048),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2048),
    [anon_sym_SEMI] = ACTIONS(2048),
    [anon_sym_LF] = ACTIONS(2046),
    [anon_sym_AMP] = ACTIONS(2048),
  },
  [539] = {
    [aux_sym_concatenation_repeat1] = STATE(126),
    [sym__simple_heredoc_body] = ACTIONS(2050),
    [sym__heredoc_body_beginning] = ACTIONS(2050),
    [sym_file_descriptor] = ACTIONS(2050),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2052),
    [anon_sym_SEMI_SEMI] = ACTIONS(2052),
    [anon_sym_PIPE_AMP] = ACTIONS(2052),
    [anon_sym_AMP_AMP] = ACTIONS(2052),
    [anon_sym_PIPE_PIPE] = ACTIONS(2052),
    [anon_sym_EQ_TILDE] = ACTIONS(2052),
    [anon_sym_EQ_EQ] = ACTIONS(2052),
    [anon_sym_LT] = ACTIONS(2052),
    [anon_sym_GT] = ACTIONS(2052),
    [anon_sym_GT_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT_GT] = ACTIONS(2052),
    [anon_sym_LT_AMP] = ACTIONS(2052),
    [anon_sym_GT_AMP] = ACTIONS(2052),
    [anon_sym_LT_LT] = ACTIONS(2052),
    [anon_sym_LT_LT_DASH] = ACTIONS(2052),
    [anon_sym_LT_LT_LT] = ACTIONS(2052),
    [sym__special_characters] = ACTIONS(2052),
    [anon_sym_DQUOTE] = ACTIONS(2052),
    [anon_sym_DOLLAR] = ACTIONS(2052),
    [sym_raw_string] = ACTIONS(2052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2052),
    [anon_sym_BQUOTE] = ACTIONS(2052),
    [anon_sym_LT_LPAREN] = ACTIONS(2052),
    [anon_sym_GT_LPAREN] = ACTIONS(2052),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2052),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym_LF] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2052),
  },
  [540] = {
    [sym__simple_heredoc_body] = ACTIONS(2050),
    [sym__heredoc_body_beginning] = ACTIONS(2050),
    [sym_file_descriptor] = ACTIONS(2050),
    [anon_sym_esac] = ACTIONS(2052),
    [anon_sym_PIPE] = ACTIONS(2052),
    [anon_sym_RPAREN] = ACTIONS(2052),
    [anon_sym_SEMI_SEMI] = ACTIONS(2052),
    [anon_sym_PIPE_AMP] = ACTIONS(2052),
    [anon_sym_AMP_AMP] = ACTIONS(2052),
    [anon_sym_PIPE_PIPE] = ACTIONS(2052),
    [anon_sym_EQ_TILDE] = ACTIONS(2052),
    [anon_sym_EQ_EQ] = ACTIONS(2052),
    [anon_sym_LT] = ACTIONS(2052),
    [anon_sym_GT] = ACTIONS(2052),
    [anon_sym_GT_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT_GT] = ACTIONS(2052),
    [anon_sym_LT_AMP] = ACTIONS(2052),
    [anon_sym_GT_AMP] = ACTIONS(2052),
    [anon_sym_LT_LT] = ACTIONS(2052),
    [anon_sym_LT_LT_DASH] = ACTIONS(2052),
    [anon_sym_LT_LT_LT] = ACTIONS(2052),
    [sym__special_characters] = ACTIONS(2052),
    [anon_sym_DQUOTE] = ACTIONS(2052),
    [anon_sym_DOLLAR] = ACTIONS(2052),
    [sym_raw_string] = ACTIONS(2052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2052),
    [anon_sym_BQUOTE] = ACTIONS(2052),
    [anon_sym_LT_LPAREN] = ACTIONS(2052),
    [anon_sym_GT_LPAREN] = ACTIONS(2052),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2052),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym_LF] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2052),
  },
  [541] = {
    [aux_sym_concatenation_repeat1] = STATE(982),
    [sym__simple_heredoc_body] = ACTIONS(661),
    [sym__heredoc_body_beginning] = ACTIONS(661),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(665),
    [anon_sym_LT_LT_LT] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [542] = {
    [aux_sym_concatenation_repeat1] = STATE(982),
    [sym__simple_heredoc_body] = ACTIONS(677),
    [sym__heredoc_body_beginning] = ACTIONS(677),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [543] = {
    [sym__simple_heredoc_body] = ACTIONS(677),
    [sym__heredoc_body_beginning] = ACTIONS(677),
    [sym_file_descriptor] = ACTIONS(677),
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [544] = {
    [sym__simple_heredoc_body] = ACTIONS(2054),
    [sym__heredoc_body_beginning] = ACTIONS(2054),
    [sym_file_descriptor] = ACTIONS(2054),
    [anon_sym_esac] = ACTIONS(2056),
    [anon_sym_PIPE] = ACTIONS(2056),
    [anon_sym_RPAREN] = ACTIONS(2056),
    [anon_sym_SEMI_SEMI] = ACTIONS(2056),
    [anon_sym_PIPE_AMP] = ACTIONS(2056),
    [anon_sym_AMP_AMP] = ACTIONS(2056),
    [anon_sym_PIPE_PIPE] = ACTIONS(2056),
    [anon_sym_LT] = ACTIONS(2056),
    [anon_sym_GT] = ACTIONS(2056),
    [anon_sym_GT_GT] = ACTIONS(2056),
    [anon_sym_AMP_GT] = ACTIONS(2056),
    [anon_sym_AMP_GT_GT] = ACTIONS(2056),
    [anon_sym_LT_AMP] = ACTIONS(2056),
    [anon_sym_GT_AMP] = ACTIONS(2056),
    [anon_sym_LT_LT] = ACTIONS(2056),
    [anon_sym_LT_LT_DASH] = ACTIONS(2056),
    [anon_sym_LT_LT_LT] = ACTIONS(2056),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2056),
    [anon_sym_LF] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2056),
  },
  [545] = {
    [aux_sym_concatenation_repeat1] = STATE(982),
    [sym__simple_heredoc_body] = ACTIONS(2058),
    [sym__heredoc_body_beginning] = ACTIONS(2058),
    [sym_file_descriptor] = ACTIONS(2058),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_SEMI_SEMI] = ACTIONS(2060),
    [anon_sym_PIPE_AMP] = ACTIONS(2060),
    [anon_sym_AMP_AMP] = ACTIONS(2060),
    [anon_sym_PIPE_PIPE] = ACTIONS(2060),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2060),
    [anon_sym_LT_AMP] = ACTIONS(2060),
    [anon_sym_GT_AMP] = ACTIONS(2060),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2060),
    [anon_sym_LT_LT_LT] = ACTIONS(2060),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2060),
  },
  [546] = {
    [aux_sym_concatenation_repeat1] = STATE(982),
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [547] = {
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [anon_sym_esac] = ACTIONS(2064),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_RPAREN] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [548] = {
    [anon_sym_esac] = ACTIONS(2066),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_RPAREN] = ACTIONS(2066),
    [anon_sym_SEMI_SEMI] = ACTIONS(2066),
    [anon_sym_PIPE_AMP] = ACTIONS(2066),
    [anon_sym_AMP_AMP] = ACTIONS(2066),
    [anon_sym_PIPE_PIPE] = ACTIONS(2066),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym_LF] = ACTIONS(2068),
    [anon_sym_AMP] = ACTIONS(2066),
  },
  [549] = {
    [sym_file_redirect] = STATE(549),
    [sym_heredoc_redirect] = STATE(549),
    [sym_herestring_redirect] = STATE(549),
    [aux_sym_while_statement_repeat1] = STATE(549),
    [sym__simple_heredoc_body] = ACTIONS(2070),
    [sym__heredoc_body_beginning] = ACTIONS(2070),
    [sym_file_descriptor] = ACTIONS(2072),
    [anon_sym_PIPE] = ACTIONS(2075),
    [anon_sym_SEMI_SEMI] = ACTIONS(2075),
    [anon_sym_PIPE_AMP] = ACTIONS(2075),
    [anon_sym_AMP_AMP] = ACTIONS(2075),
    [anon_sym_PIPE_PIPE] = ACTIONS(2075),
    [anon_sym_LT] = ACTIONS(2077),
    [anon_sym_GT] = ACTIONS(2077),
    [anon_sym_GT_GT] = ACTIONS(2077),
    [anon_sym_AMP_GT] = ACTIONS(2077),
    [anon_sym_AMP_GT_GT] = ACTIONS(2077),
    [anon_sym_LT_AMP] = ACTIONS(2077),
    [anon_sym_GT_AMP] = ACTIONS(2077),
    [anon_sym_LT_LT] = ACTIONS(2080),
    [anon_sym_LT_LT_DASH] = ACTIONS(2080),
    [anon_sym_LT_LT_LT] = ACTIONS(2083),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_LF] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2075),
  },
  [550] = {
    [sym_file_redirect] = STATE(549),
    [sym_heredoc_redirect] = STATE(549),
    [sym_heredoc_body] = STATE(983),
    [sym_herestring_redirect] = STATE(549),
    [aux_sym_while_statement_repeat1] = STATE(549),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_SEMI_SEMI] = ACTIONS(2066),
    [anon_sym_PIPE_AMP] = ACTIONS(2066),
    [anon_sym_AMP_AMP] = ACTIONS(2066),
    [anon_sym_PIPE_PIPE] = ACTIONS(2066),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym_LF] = ACTIONS(2068),
    [anon_sym_AMP] = ACTIONS(2066),
  },
  [551] = {
    [sym_concatenation] = STATE(551),
    [sym_string] = STATE(199),
    [sym_simple_expansion] = STATE(199),
    [sym_string_expansion] = STATE(199),
    [sym_expansion] = STATE(199),
    [sym_command_substitution] = STATE(199),
    [sym_process_substitution] = STATE(199),
    [aux_sym_command_repeat2] = STATE(551),
    [sym__simple_heredoc_body] = ACTIONS(2050),
    [sym__heredoc_body_beginning] = ACTIONS(2050),
    [sym_file_descriptor] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2052),
    [anon_sym_SEMI_SEMI] = ACTIONS(2052),
    [anon_sym_PIPE_AMP] = ACTIONS(2052),
    [anon_sym_AMP_AMP] = ACTIONS(2052),
    [anon_sym_PIPE_PIPE] = ACTIONS(2052),
    [anon_sym_EQ_TILDE] = ACTIONS(2086),
    [anon_sym_EQ_EQ] = ACTIONS(2086),
    [anon_sym_LT] = ACTIONS(2052),
    [anon_sym_GT] = ACTIONS(2052),
    [anon_sym_GT_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT_GT] = ACTIONS(2052),
    [anon_sym_LT_AMP] = ACTIONS(2052),
    [anon_sym_GT_AMP] = ACTIONS(2052),
    [anon_sym_LT_LT] = ACTIONS(2052),
    [anon_sym_LT_LT_DASH] = ACTIONS(2052),
    [anon_sym_LT_LT_LT] = ACTIONS(2052),
    [sym__special_characters] = ACTIONS(2089),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [anon_sym_DOLLAR] = ACTIONS(2095),
    [sym_raw_string] = ACTIONS(2098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2104),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [anon_sym_LT_LPAREN] = ACTIONS(2110),
    [anon_sym_GT_LPAREN] = ACTIONS(2110),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2098),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym_LF] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2052),
  },
  [552] = {
    [sym_file_redirect] = STATE(984),
    [sym_heredoc_redirect] = STATE(984),
    [sym_heredoc_body] = STATE(983),
    [sym_herestring_redirect] = STATE(984),
    [sym_concatenation] = STATE(551),
    [sym_string] = STATE(199),
    [sym_simple_expansion] = STATE(199),
    [sym_string_expansion] = STATE(199),
    [sym_expansion] = STATE(199),
    [sym_command_substitution] = STATE(199),
    [sym_process_substitution] = STATE(199),
    [aux_sym_while_statement_repeat1] = STATE(984),
    [aux_sym_command_repeat2] = STATE(551),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_SEMI_SEMI] = ACTIONS(2066),
    [anon_sym_PIPE_AMP] = ACTIONS(2066),
    [anon_sym_AMP_AMP] = ACTIONS(2066),
    [anon_sym_PIPE_PIPE] = ACTIONS(2066),
    [anon_sym_EQ_TILDE] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(345),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(357),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym_LF] = ACTIONS(2068),
    [anon_sym_AMP] = ACTIONS(2066),
  },
  [553] = {
    [sym_string] = STATE(671),
    [sym_simple_expansion] = STATE(671),
    [sym_string_expansion] = STATE(671),
    [sym_expansion] = STATE(671),
    [sym_command_substitution] = STATE(671),
    [sym_process_substitution] = STATE(671),
    [anon_sym_RBRACK] = ACTIONS(2113),
    [sym__special_characters] = ACTIONS(2115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(1297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1297),
  },
  [554] = {
    [sym__concat] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2119),
    [anon_sym_PLUS_EQ] = ACTIONS(2119),
    [sym_comment] = ACTIONS(53),
  },
  [555] = {
    [aux_sym_concatenation_repeat1] = STATE(987),
    [sym__concat] = ACTIONS(513),
    [anon_sym_RBRACK] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [556] = {
    [sym_string] = STATE(671),
    [sym_simple_expansion] = STATE(671),
    [sym_string_expansion] = STATE(671),
    [sym_expansion] = STATE(671),
    [sym_command_substitution] = STATE(671),
    [sym_process_substitution] = STATE(671),
    [anon_sym_RBRACK] = ACTIONS(2121),
    [sym__special_characters] = ACTIONS(2115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(1297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1297),
  },
  [557] = {
    [sym__concat] = ACTIONS(2123),
    [anon_sym_EQ] = ACTIONS(2125),
    [anon_sym_PLUS_EQ] = ACTIONS(2125),
    [sym_comment] = ACTIONS(53),
  },
  [558] = {
    [anon_sym_RBRACK] = ACTIONS(2121),
    [sym_comment] = ACTIONS(53),
  },
  [559] = {
    [sym_file_descriptor] = ACTIONS(2127),
    [sym_variable_name] = ACTIONS(2127),
    [anon_sym_esac] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(2129),
    [anon_sym_RPAREN] = ACTIONS(2129),
    [anon_sym_SEMI_SEMI] = ACTIONS(2129),
    [anon_sym_PIPE_AMP] = ACTIONS(2129),
    [anon_sym_AMP_AMP] = ACTIONS(2129),
    [anon_sym_PIPE_PIPE] = ACTIONS(2129),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_GT] = ACTIONS(2129),
    [anon_sym_GT_GT] = ACTIONS(2129),
    [anon_sym_AMP_GT] = ACTIONS(2129),
    [anon_sym_AMP_GT_GT] = ACTIONS(2129),
    [anon_sym_LT_AMP] = ACTIONS(2129),
    [anon_sym_GT_AMP] = ACTIONS(2129),
    [sym__special_characters] = ACTIONS(2129),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_DOLLAR] = ACTIONS(2129),
    [sym_raw_string] = ACTIONS(2129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2129),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [anon_sym_LT_LPAREN] = ACTIONS(2129),
    [anon_sym_GT_LPAREN] = ACTIONS(2129),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_LF] = ACTIONS(2127),
    [anon_sym_AMP] = ACTIONS(2129),
  },
  [560] = {
    [aux_sym_concatenation_repeat1] = STATE(991),
    [sym__concat] = ACTIONS(2131),
    [anon_sym_RPAREN] = ACTIONS(2133),
    [sym__special_characters] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(2133),
    [anon_sym_DOLLAR] = ACTIONS(2135),
    [sym_raw_string] = ACTIONS(2133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2133),
    [anon_sym_BQUOTE] = ACTIONS(2133),
    [anon_sym_LT_LPAREN] = ACTIONS(2133),
    [anon_sym_GT_LPAREN] = ACTIONS(2133),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2133),
  },
  [561] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(993),
    [anon_sym_DQUOTE] = ACTIONS(2137),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [562] = {
    [sym_string] = STATE(995),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(2139),
    [sym_raw_string] = ACTIONS(2141),
    [anon_sym_POUND] = ACTIONS(2139),
    [anon_sym_DASH] = ACTIONS(2139),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(2139),
    [anon_sym_AT] = ACTIONS(2139),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_0] = ACTIONS(2145),
    [anon_sym__] = ACTIONS(2145),
  },
  [563] = {
    [aux_sym_concatenation_repeat1] = STATE(991),
    [sym__concat] = ACTIONS(2131),
    [anon_sym_RPAREN] = ACTIONS(2147),
    [sym__special_characters] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_DOLLAR] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2147),
    [anon_sym_BQUOTE] = ACTIONS(2147),
    [anon_sym_LT_LPAREN] = ACTIONS(2147),
    [anon_sym_GT_LPAREN] = ACTIONS(2147),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2147),
  },
  [564] = {
    [sym_subscript] = STATE(1001),
    [sym_variable_name] = ACTIONS(2151),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_POUND] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2157),
    [anon_sym_STAR] = ACTIONS(2153),
    [anon_sym_AT] = ACTIONS(2153),
    [anon_sym_QMARK] = ACTIONS(2153),
    [anon_sym_0] = ACTIONS(2159),
    [anon_sym__] = ACTIONS(2159),
  },
  [565] = {
    [sym_for_statement] = STATE(1002),
    [sym_while_statement] = STATE(1002),
    [sym_if_statement] = STATE(1002),
    [sym_case_statement] = STATE(1002),
    [sym_function_definition] = STATE(1002),
    [sym_subshell] = STATE(1002),
    [sym_pipeline] = STATE(1002),
    [sym_list] = STATE(1002),
    [sym_negated_command] = STATE(1002),
    [sym_test_command] = STATE(1002),
    [sym_declaration_command] = STATE(1002),
    [sym_unset_command] = STATE(1002),
    [sym_command] = STATE(1002),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(1003),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [566] = {
    [sym_for_statement] = STATE(1004),
    [sym_while_statement] = STATE(1004),
    [sym_if_statement] = STATE(1004),
    [sym_case_statement] = STATE(1004),
    [sym_function_definition] = STATE(1004),
    [sym_subshell] = STATE(1004),
    [sym_pipeline] = STATE(1004),
    [sym_list] = STATE(1004),
    [sym_negated_command] = STATE(1004),
    [sym_test_command] = STATE(1004),
    [sym_declaration_command] = STATE(1004),
    [sym_unset_command] = STATE(1004),
    [sym_command] = STATE(1004),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(1005),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [567] = {
    [sym_for_statement] = STATE(1006),
    [sym_while_statement] = STATE(1006),
    [sym_if_statement] = STATE(1006),
    [sym_case_statement] = STATE(1006),
    [sym_function_definition] = STATE(1006),
    [sym_subshell] = STATE(1006),
    [sym_pipeline] = STATE(1006),
    [sym_list] = STATE(1006),
    [sym_negated_command] = STATE(1006),
    [sym_test_command] = STATE(1006),
    [sym_declaration_command] = STATE(1006),
    [sym_unset_command] = STATE(1006),
    [sym_command] = STATE(1006),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(1007),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [568] = {
    [sym_concatenation] = STATE(1009),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1009),
    [anon_sym_RPAREN] = ACTIONS(2161),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [569] = {
    [sym_string] = STATE(1010),
    [sym_simple_expansion] = STATE(1010),
    [sym_string_expansion] = STATE(1010),
    [sym_expansion] = STATE(1010),
    [sym_command_substitution] = STATE(1010),
    [sym_process_substitution] = STATE(1010),
    [sym__special_characters] = ACTIONS(2163),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [sym_raw_string] = ACTIONS(2163),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(399),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(403),
    [anon_sym_GT_LPAREN] = ACTIONS(403),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2163),
  },
  [570] = {
    [aux_sym_concatenation_repeat1] = STATE(1011),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(1131),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [571] = {
    [sym_file_descriptor] = ACTIONS(697),
    [sym__concat] = ACTIONS(697),
    [sym_variable_name] = ACTIONS(697),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(699),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [572] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(2165),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [573] = {
    [sym_file_descriptor] = ACTIONS(727),
    [sym__concat] = ACTIONS(727),
    [sym_variable_name] = ACTIONS(727),
    [anon_sym_esac] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(729),
    [anon_sym_AMP_GT] = ACTIONS(729),
    [anon_sym_AMP_GT_GT] = ACTIONS(729),
    [anon_sym_LT_AMP] = ACTIONS(729),
    [anon_sym_GT_AMP] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [574] = {
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [575] = {
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(737),
    [anon_sym_LT_AMP] = ACTIONS(737),
    [anon_sym_GT_AMP] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [576] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2167),
    [sym_comment] = ACTIONS(53),
  },
  [577] = {
    [sym_concatenation] = STATE(1016),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1016),
    [anon_sym_RBRACE] = ACTIONS(2169),
    [anon_sym_EQ] = ACTIONS(2171),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2175),
    [anon_sym_COLON] = ACTIONS(2171),
    [anon_sym_COLON_QMARK] = ACTIONS(2171),
    [anon_sym_COLON_DASH] = ACTIONS(2171),
    [anon_sym_PERCENT] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [578] = {
    [sym_subscript] = STATE(1020),
    [sym_variable_name] = ACTIONS(2177),
    [anon_sym_DOLLAR] = ACTIONS(2179),
    [anon_sym_DASH] = ACTIONS(2179),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2179),
    [anon_sym_AT] = ACTIONS(2179),
    [anon_sym_QMARK] = ACTIONS(2179),
    [anon_sym_0] = ACTIONS(2183),
    [anon_sym__] = ACTIONS(2183),
  },
  [579] = {
    [sym_concatenation] = STATE(1023),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1023),
    [anon_sym_RBRACE] = ACTIONS(2185),
    [anon_sym_EQ] = ACTIONS(2187),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2191),
    [anon_sym_COLON] = ACTIONS(2187),
    [anon_sym_COLON_QMARK] = ACTIONS(2187),
    [anon_sym_COLON_DASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [580] = {
    [sym_concatenation] = STATE(1026),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1026),
    [anon_sym_RBRACE] = ACTIONS(2193),
    [anon_sym_EQ] = ACTIONS(2195),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2199),
    [anon_sym_COLON] = ACTIONS(2195),
    [anon_sym_COLON_QMARK] = ACTIONS(2195),
    [anon_sym_COLON_DASH] = ACTIONS(2195),
    [anon_sym_PERCENT] = ACTIONS(2195),
    [anon_sym_DASH] = ACTIONS(2195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [581] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2201),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [582] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2201),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [583] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(2201),
    [sym_comment] = ACTIONS(53),
  },
  [584] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(2201),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [585] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2203),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [586] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2203),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [587] = {
    [aux_sym_concatenation_repeat1] = STATE(1029),
    [sym__concat] = ACTIONS(419),
    [anon_sym_SEMI_SEMI] = ACTIONS(2135),
    [sym__special_characters] = ACTIONS(2135),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [anon_sym_DOLLAR] = ACTIONS(2135),
    [sym_raw_string] = ACTIONS(2135),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2135),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2135),
    [anon_sym_BQUOTE] = ACTIONS(2135),
    [anon_sym_LT_LPAREN] = ACTIONS(2135),
    [anon_sym_GT_LPAREN] = ACTIONS(2135),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2135),
    [anon_sym_SEMI] = ACTIONS(2135),
    [anon_sym_LF] = ACTIONS(2133),
    [anon_sym_AMP] = ACTIONS(2135),
  },
  [588] = {
    [aux_sym_concatenation_repeat1] = STATE(1029),
    [sym__concat] = ACTIONS(419),
    [anon_sym_SEMI_SEMI] = ACTIONS(2149),
    [sym__special_characters] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_DOLLAR] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2149),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2149),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [anon_sym_LT_LPAREN] = ACTIONS(2149),
    [anon_sym_GT_LPAREN] = ACTIONS(2149),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2149),
  },
  [589] = {
    [sym_concatenation] = STATE(1031),
    [sym_string] = STATE(588),
    [sym_simple_expansion] = STATE(588),
    [sym_string_expansion] = STATE(588),
    [sym_expansion] = STATE(588),
    [sym_command_substitution] = STATE(588),
    [sym_process_substitution] = STATE(588),
    [aux_sym_for_statement_repeat1] = STATE(1031),
    [anon_sym_SEMI_SEMI] = ACTIONS(2205),
    [sym__special_characters] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [anon_sym_DOLLAR] = ACTIONS(71),
    [sym_raw_string] = ACTIONS(2211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [anon_sym_LT_LPAREN] = ACTIONS(2219),
    [anon_sym_GT_LPAREN] = ACTIONS(2219),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2211),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_LF] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2205),
  },
  [590] = {
    [sym__terminated_statement] = STATE(1033),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1033),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(2223),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [591] = {
    [anon_sym_esac] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_RPAREN] = ACTIONS(2225),
    [anon_sym_SEMI_SEMI] = ACTIONS(2225),
    [anon_sym_PIPE_AMP] = ACTIONS(2225),
    [anon_sym_AMP_AMP] = ACTIONS(2225),
    [anon_sym_PIPE_PIPE] = ACTIONS(2225),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_LF] = ACTIONS(2227),
    [anon_sym_AMP] = ACTIONS(2225),
  },
  [592] = {
    [sym__simple_heredoc_body] = ACTIONS(2229),
    [sym__heredoc_body_beginning] = ACTIONS(2229),
    [sym_file_descriptor] = ACTIONS(2229),
    [anon_sym_esac] = ACTIONS(2231),
    [anon_sym_PIPE] = ACTIONS(2231),
    [anon_sym_RPAREN] = ACTIONS(2231),
    [anon_sym_SEMI_SEMI] = ACTIONS(2231),
    [anon_sym_PIPE_AMP] = ACTIONS(2231),
    [anon_sym_AMP_AMP] = ACTIONS(2231),
    [anon_sym_PIPE_PIPE] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2231),
    [anon_sym_GT] = ACTIONS(2231),
    [anon_sym_GT_GT] = ACTIONS(2231),
    [anon_sym_AMP_GT] = ACTIONS(2231),
    [anon_sym_AMP_GT_GT] = ACTIONS(2231),
    [anon_sym_LT_AMP] = ACTIONS(2231),
    [anon_sym_GT_AMP] = ACTIONS(2231),
    [anon_sym_LT_LT] = ACTIONS(2231),
    [anon_sym_LT_LT_DASH] = ACTIONS(2231),
    [anon_sym_LT_LT_LT] = ACTIONS(2231),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2231),
    [anon_sym_LF] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
  },
  [593] = {
    [sym__terminated_statement] = STATE(1035),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1035),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [594] = {
    [anon_sym_esac] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_SEMI_SEMI] = ACTIONS(2235),
    [anon_sym_PIPE_AMP] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_LF] = ACTIONS(2237),
    [anon_sym_AMP] = ACTIONS(2235),
  },
  [595] = {
    [sym_file_redirect] = STATE(549),
    [sym_heredoc_redirect] = STATE(549),
    [sym_heredoc_body] = STATE(1036),
    [sym_herestring_redirect] = STATE(549),
    [aux_sym_while_statement_repeat1] = STATE(549),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(2235),
    [anon_sym_SEMI_SEMI] = ACTIONS(2235),
    [anon_sym_PIPE_AMP] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_LF] = ACTIONS(2237),
    [anon_sym_AMP] = ACTIONS(2235),
  },
  [596] = {
    [anon_sym_esac] = ACTIONS(2239),
    [anon_sym_PIPE] = ACTIONS(2239),
    [anon_sym_RPAREN] = ACTIONS(2239),
    [anon_sym_SEMI_SEMI] = ACTIONS(2239),
    [anon_sym_PIPE_AMP] = ACTIONS(2239),
    [anon_sym_AMP_AMP] = ACTIONS(2239),
    [anon_sym_PIPE_PIPE] = ACTIONS(2239),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2239),
    [anon_sym_LF] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
  },
  [597] = {
    [sym__terminated_statement] = STATE(1037),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [598] = {
    [sym__terminated_statement] = STATE(1038),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1038),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(2243),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [599] = {
    [anon_sym_fi] = ACTIONS(2245),
    [anon_sym_elif] = ACTIONS(2245),
    [anon_sym_else] = ACTIONS(2245),
    [sym_comment] = ACTIONS(53),
  },
  [600] = {
    [anon_sym_fi] = ACTIONS(2247),
    [sym_comment] = ACTIONS(53),
  },
  [601] = {
    [sym__terminated_statement] = STATE(1041),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_elif_clause] = STATE(599),
    [sym_else_clause] = STATE(1040),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1041),
    [aux_sym_if_statement_repeat1] = STATE(1042),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(2249),
    [anon_sym_elif] = ACTIONS(1169),
    [anon_sym_else] = ACTIONS(1171),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [602] = {
    [sym_elif_clause] = STATE(599),
    [sym_else_clause] = STATE(1040),
    [aux_sym_if_statement_repeat1] = STATE(1043),
    [anon_sym_fi] = ACTIONS(2247),
    [anon_sym_elif] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2253),
    [sym_comment] = ACTIONS(53),
  },
  [603] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_in] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [604] = {
    [sym_case_item] = STATE(1049),
    [sym_last_case_item] = STATE(1047),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(1049),
    [anon_sym_esac] = ACTIONS(2255),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2261),
  },
  [605] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2263),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2263),
    [anon_sym_LF] = ACTIONS(2265),
    [anon_sym_AMP] = ACTIONS(2263),
  },
  [606] = {
    [aux_sym_concatenation_repeat1] = STATE(606),
    [sym__concat] = ACTIONS(2267),
    [anon_sym_in] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [607] = {
    [sym__concat] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(1693),
    [anon_sym_SEMI_SEMI] = ACTIONS(1693),
    [sym__special_characters] = ACTIONS(1693),
    [anon_sym_DQUOTE] = ACTIONS(1693),
    [anon_sym_DOLLAR] = ACTIONS(1693),
    [sym_raw_string] = ACTIONS(1693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1693),
    [anon_sym_BQUOTE] = ACTIONS(1693),
    [anon_sym_LT_LPAREN] = ACTIONS(1693),
    [anon_sym_GT_LPAREN] = ACTIONS(1693),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1693),
    [anon_sym_LF] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1693),
  },
  [608] = {
    [sym_case_item] = STATE(1053),
    [sym_last_case_item] = STATE(1052),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(1053),
    [anon_sym_esac] = ACTIONS(2270),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2261),
  },
  [609] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2272),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym_LF] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2272),
  },
  [610] = {
    [sym_concatenation] = STATE(1058),
    [sym_string] = STATE(1057),
    [sym_simple_expansion] = STATE(1057),
    [sym_string_expansion] = STATE(1057),
    [sym_expansion] = STATE(1057),
    [sym_command_substitution] = STATE(1057),
    [sym_process_substitution] = STATE(1057),
    [anon_sym_RBRACE] = ACTIONS(2276),
    [sym__special_characters] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(2280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2280),
  },
  [611] = {
    [sym__concat] = ACTIONS(1732),
    [anon_sym_in] = ACTIONS(1734),
    [anon_sym_SEMI_SEMI] = ACTIONS(1734),
    [sym__special_characters] = ACTIONS(1734),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [sym_raw_string] = ACTIONS(1734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1734),
    [anon_sym_BQUOTE] = ACTIONS(1734),
    [anon_sym_LT_LPAREN] = ACTIONS(1734),
    [anon_sym_GT_LPAREN] = ACTIONS(1734),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1734),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_LF] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1734),
  },
  [612] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2282),
  },
  [613] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2284),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [614] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2286),
    [sym_comment] = ACTIONS(53),
  },
  [615] = {
    [sym_concatenation] = STATE(1064),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1064),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_EQ] = ACTIONS(2290),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2294),
    [anon_sym_COLON] = ACTIONS(2290),
    [anon_sym_COLON_QMARK] = ACTIONS(2290),
    [anon_sym_COLON_DASH] = ACTIONS(2290),
    [anon_sym_PERCENT] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [616] = {
    [sym_concatenation] = STATE(1067),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1067),
    [anon_sym_RBRACE] = ACTIONS(2296),
    [anon_sym_EQ] = ACTIONS(2298),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2302),
    [anon_sym_COLON] = ACTIONS(2298),
    [anon_sym_COLON_QMARK] = ACTIONS(2298),
    [anon_sym_COLON_DASH] = ACTIONS(2298),
    [anon_sym_PERCENT] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2298),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [617] = {
    [sym_concatenation] = STATE(1069),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1069),
    [anon_sym_RBRACE] = ACTIONS(2276),
    [anon_sym_EQ] = ACTIONS(2304),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2308),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym_COLON_QMARK] = ACTIONS(2304),
    [anon_sym_COLON_DASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [618] = {
    [sym__concat] = ACTIONS(1798),
    [anon_sym_in] = ACTIONS(1800),
    [anon_sym_SEMI_SEMI] = ACTIONS(1800),
    [sym__special_characters] = ACTIONS(1800),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [sym_raw_string] = ACTIONS(1800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1800),
    [anon_sym_BQUOTE] = ACTIONS(1800),
    [anon_sym_LT_LPAREN] = ACTIONS(1800),
    [anon_sym_GT_LPAREN] = ACTIONS(1800),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1800),
    [anon_sym_SEMI] = ACTIONS(1800),
    [anon_sym_LF] = ACTIONS(1798),
    [anon_sym_AMP] = ACTIONS(1800),
  },
  [619] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2310),
  },
  [620] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [621] = {
    [sym__concat] = ACTIONS(1806),
    [anon_sym_in] = ACTIONS(1808),
    [anon_sym_SEMI_SEMI] = ACTIONS(1808),
    [sym__special_characters] = ACTIONS(1808),
    [anon_sym_DQUOTE] = ACTIONS(1808),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [sym_raw_string] = ACTIONS(1808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1808),
    [anon_sym_BQUOTE] = ACTIONS(1808),
    [anon_sym_LT_LPAREN] = ACTIONS(1808),
    [anon_sym_GT_LPAREN] = ACTIONS(1808),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1808),
    [anon_sym_SEMI] = ACTIONS(1808),
    [anon_sym_LF] = ACTIONS(1806),
    [anon_sym_AMP] = ACTIONS(1808),
  },
  [622] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2314),
  },
  [623] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2276),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [624] = {
    [sym__concat] = ACTIONS(1940),
    [anon_sym_in] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1942),
    [sym__special_characters] = ACTIONS(1942),
    [anon_sym_DQUOTE] = ACTIONS(1942),
    [anon_sym_DOLLAR] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1942),
    [anon_sym_BQUOTE] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1942),
    [anon_sym_GT_LPAREN] = ACTIONS(1942),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [625] = {
    [sym__concat] = ACTIONS(2006),
    [anon_sym_in] = ACTIONS(2008),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [sym__special_characters] = ACTIONS(2008),
    [anon_sym_DQUOTE] = ACTIONS(2008),
    [anon_sym_DOLLAR] = ACTIONS(2008),
    [sym_raw_string] = ACTIONS(2008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2008),
    [anon_sym_BQUOTE] = ACTIONS(2008),
    [anon_sym_LT_LPAREN] = ACTIONS(2008),
    [anon_sym_GT_LPAREN] = ACTIONS(2008),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2008),
  },
  [626] = {
    [sym_compound_statement] = STATE(1073),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [627] = {
    [sym_file_descriptor] = ACTIONS(2316),
    [anon_sym_esac] = ACTIONS(2318),
    [anon_sym_PIPE] = ACTIONS(2318),
    [anon_sym_RPAREN] = ACTIONS(2318),
    [anon_sym_SEMI_SEMI] = ACTIONS(2318),
    [anon_sym_PIPE_AMP] = ACTIONS(2318),
    [anon_sym_AMP_AMP] = ACTIONS(2318),
    [anon_sym_PIPE_PIPE] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2318),
    [anon_sym_GT] = ACTIONS(2318),
    [anon_sym_GT_GT] = ACTIONS(2318),
    [anon_sym_AMP_GT] = ACTIONS(2318),
    [anon_sym_AMP_GT_GT] = ACTIONS(2318),
    [anon_sym_LT_AMP] = ACTIONS(2318),
    [anon_sym_GT_AMP] = ACTIONS(2318),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym_LF] = ACTIONS(2316),
    [anon_sym_AMP] = ACTIONS(2318),
  },
  [628] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(2320),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2320),
    [anon_sym_LF] = ACTIONS(2322),
    [anon_sym_AMP] = ACTIONS(2320),
  },
  [629] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(2320),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(2320),
    [anon_sym_LF] = ACTIONS(2322),
    [anon_sym_AMP] = ACTIONS(2320),
  },
  [630] = {
    [sym__terminated_statement] = STATE(1076),
    [sym_for_statement] = STATE(628),
    [sym_while_statement] = STATE(628),
    [sym_if_statement] = STATE(628),
    [sym_case_statement] = STATE(628),
    [sym_function_definition] = STATE(628),
    [sym_subshell] = STATE(628),
    [sym_pipeline] = STATE(628),
    [sym_list] = STATE(628),
    [sym_negated_command] = STATE(628),
    [sym_test_command] = STATE(628),
    [sym_declaration_command] = STATE(628),
    [sym_unset_command] = STATE(628),
    [sym_command] = STATE(628),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(629),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1076),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(2324),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [631] = {
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_GT] = ACTIONS(2326),
    [anon_sym_GT_GT] = ACTIONS(2328),
    [anon_sym_AMP_GT] = ACTIONS(2326),
    [anon_sym_AMP_GT_GT] = ACTIONS(2328),
    [anon_sym_LT_AMP] = ACTIONS(2328),
    [anon_sym_GT_AMP] = ACTIONS(2328),
    [sym_comment] = ACTIONS(53),
  },
  [632] = {
    [sym_concatenation] = STATE(1080),
    [sym_string] = STATE(1079),
    [sym_simple_expansion] = STATE(1079),
    [sym_string_expansion] = STATE(1079),
    [sym_expansion] = STATE(1079),
    [sym_command_substitution] = STATE(1079),
    [sym_process_substitution] = STATE(1079),
    [sym__special_characters] = ACTIONS(2330),
    [anon_sym_DQUOTE] = ACTIONS(629),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(2332),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1521),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1523),
    [anon_sym_BQUOTE] = ACTIONS(1525),
    [anon_sym_LT_LPAREN] = ACTIONS(1527),
    [anon_sym_GT_LPAREN] = ACTIONS(1527),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2332),
  },
  [633] = {
    [anon_sym_esac] = ACTIONS(2334),
    [anon_sym_PIPE] = ACTIONS(2334),
    [anon_sym_RPAREN] = ACTIONS(2334),
    [anon_sym_SEMI_SEMI] = ACTIONS(2334),
    [anon_sym_PIPE_AMP] = ACTIONS(2334),
    [anon_sym_AMP_AMP] = ACTIONS(2334),
    [anon_sym_PIPE_PIPE] = ACTIONS(2334),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_LF] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2334),
  },
  [634] = {
    [aux_sym_concatenation_repeat1] = STATE(1081),
    [sym_file_descriptor] = ACTIONS(1129),
    [sym__concat] = ACTIONS(1131),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_AMP] = ACTIONS(1133),
    [anon_sym_GT_AMP] = ACTIONS(1133),
    [sym__special_characters] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1133),
  },
  [635] = {
    [aux_sym_concatenation_repeat1] = STATE(1081),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(1131),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_AMP] = ACTIONS(1109),
    [anon_sym_GT_AMP] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [636] = {
    [sym_file_redirect] = STATE(1082),
    [sym_heredoc_redirect] = STATE(1082),
    [sym_heredoc_body] = STATE(594),
    [sym_herestring_redirect] = STATE(1082),
    [aux_sym_while_statement_repeat1] = STATE(1082),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(1163),
    [anon_sym_RPAREN] = ACTIONS(1163),
    [anon_sym_SEMI_SEMI] = ACTIONS(1163),
    [anon_sym_PIPE_AMP] = ACTIONS(1163),
    [anon_sym_AMP_AMP] = ACTIONS(1163),
    [anon_sym_PIPE_PIPE] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_LF] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1163),
  },
  [637] = {
    [anon_sym_RPAREN] = ACTIONS(2338),
    [sym_comment] = ACTIONS(53),
  },
  [638] = {
    [sym_file_redirect] = STATE(633),
    [sym_file_descriptor] = ACTIONS(2340),
    [anon_sym_PIPE] = ACTIONS(1233),
    [anon_sym_RPAREN] = ACTIONS(1233),
    [anon_sym_SEMI_SEMI] = ACTIONS(1233),
    [anon_sym_PIPE_AMP] = ACTIONS(1233),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_GT] = ACTIONS(2342),
    [anon_sym_GT_GT] = ACTIONS(2342),
    [anon_sym_AMP_GT] = ACTIONS(2342),
    [anon_sym_AMP_GT_GT] = ACTIONS(2342),
    [anon_sym_LT_AMP] = ACTIONS(2342),
    [anon_sym_GT_AMP] = ACTIONS(2342),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_LF] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1233),
  },
  [639] = {
    [sym_file_redirect] = STATE(1089),
    [sym_heredoc_redirect] = STATE(1089),
    [sym_herestring_redirect] = STATE(1089),
    [aux_sym_while_statement_repeat1] = STATE(1089),
    [sym_file_descriptor] = ACTIONS(2344),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_RPAREN] = ACTIONS(1341),
    [anon_sym_SEMI_SEMI] = ACTIONS(1341),
    [anon_sym_PIPE_AMP] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2346),
    [anon_sym_LT_AMP] = ACTIONS(2346),
    [anon_sym_GT_AMP] = ACTIONS(2346),
    [anon_sym_LT_LT] = ACTIONS(1345),
    [anon_sym_LT_LT_DASH] = ACTIONS(1345),
    [anon_sym_LT_LT_LT] = ACTIONS(2348),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1341),
    [anon_sym_LF] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1341),
  },
  [640] = {
    [sym_concatenation] = STATE(719),
    [sym_string] = STATE(1091),
    [sym_array] = STATE(719),
    [sym_simple_expansion] = STATE(1091),
    [sym_string_expansion] = STATE(1091),
    [sym_expansion] = STATE(1091),
    [sym_command_substitution] = STATE(1091),
    [sym_process_substitution] = STATE(1091),
    [sym__empty_value] = ACTIONS(1427),
    [anon_sym_LPAREN] = ACTIONS(1429),
    [sym__special_characters] = ACTIONS(2350),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(2352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1435),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1439),
    [anon_sym_LT_LPAREN] = ACTIONS(1441),
    [anon_sym_GT_LPAREN] = ACTIONS(1441),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2352),
  },
  [641] = {
    [aux_sym_concatenation_repeat1] = STATE(1092),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [642] = {
    [sym_variable_assignment] = STATE(642),
    [sym_subscript] = STATE(261),
    [sym_concatenation] = STATE(642),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym_declaration_command_repeat1] = STATE(642),
    [sym_variable_name] = ACTIONS(2354),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_RPAREN] = ACTIONS(1488),
    [anon_sym_SEMI_SEMI] = ACTIONS(1488),
    [anon_sym_PIPE_AMP] = ACTIONS(1488),
    [anon_sym_AMP_AMP] = ACTIONS(1488),
    [anon_sym_PIPE_PIPE] = ACTIONS(1488),
    [sym__special_characters] = ACTIONS(2357),
    [anon_sym_DQUOTE] = ACTIONS(1493),
    [anon_sym_DOLLAR] = ACTIONS(1496),
    [sym_raw_string] = ACTIONS(2360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1505),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [anon_sym_LT_LPAREN] = ACTIONS(1511),
    [anon_sym_GT_LPAREN] = ACTIONS(1511),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1514),
    [sym_word] = ACTIONS(2360),
    [anon_sym_SEMI] = ACTIONS(1488),
    [anon_sym_LF] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1488),
  },
  [643] = {
    [aux_sym_concatenation_repeat1] = STATE(1093),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [644] = {
    [sym_concatenation] = STATE(644),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [aux_sym_unset_command_repeat1] = STATE(644),
    [anon_sym_PIPE] = ACTIONS(1569),
    [anon_sym_RPAREN] = ACTIONS(1569),
    [anon_sym_SEMI_SEMI] = ACTIONS(1569),
    [anon_sym_PIPE_AMP] = ACTIONS(1569),
    [anon_sym_AMP_AMP] = ACTIONS(1569),
    [anon_sym_PIPE_PIPE] = ACTIONS(1569),
    [sym__special_characters] = ACTIONS(2363),
    [anon_sym_DQUOTE] = ACTIONS(1574),
    [anon_sym_DOLLAR] = ACTIONS(1577),
    [sym_raw_string] = ACTIONS(2366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1586),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LPAREN] = ACTIONS(1592),
    [anon_sym_GT_LPAREN] = ACTIONS(1592),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1595),
    [sym_word] = ACTIONS(2366),
    [anon_sym_SEMI] = ACTIONS(1569),
    [anon_sym_LF] = ACTIONS(1598),
    [anon_sym_AMP] = ACTIONS(1569),
  },
  [645] = {
    [aux_sym_concatenation_repeat1] = STATE(645),
    [sym__simple_heredoc_body] = ACTIONS(1642),
    [sym__heredoc_body_beginning] = ACTIONS(1642),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1646),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_EQ_TILDE] = ACTIONS(1644),
    [anon_sym_EQ_EQ] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [646] = {
    [sym_compound_statement] = STATE(1094),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [647] = {
    [anon_sym_esac] = ACTIONS(2369),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_RPAREN] = ACTIONS(2369),
    [anon_sym_SEMI_SEMI] = ACTIONS(2369),
    [anon_sym_PIPE_AMP] = ACTIONS(2369),
    [anon_sym_AMP_AMP] = ACTIONS(2369),
    [anon_sym_PIPE_PIPE] = ACTIONS(2369),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2369),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2369),
  },
  [648] = {
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(2014),
    [anon_sym_SEMI_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(2014),
    [anon_sym_PIPE_PIPE] = ACTIONS(2014),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_LF] = ACTIONS(2016),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [649] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(2014),
    [anon_sym_SEMI_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(2014),
    [anon_sym_PIPE_PIPE] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_LF] = ACTIONS(2016),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [650] = {
    [sym_concatenation] = STATE(981),
    [sym_string] = STATE(1096),
    [sym_simple_expansion] = STATE(1096),
    [sym_string_expansion] = STATE(1096),
    [sym_expansion] = STATE(1096),
    [sym_command_substitution] = STATE(1096),
    [sym_process_substitution] = STATE(1096),
    [sym__special_characters] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(2375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2375),
  },
  [651] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(2046),
    [sym__heredoc_body_beginning] = ACTIONS(2046),
    [sym_file_descriptor] = ACTIONS(2046),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2048),
    [anon_sym_RPAREN] = ACTIONS(2048),
    [anon_sym_SEMI_SEMI] = ACTIONS(2048),
    [anon_sym_PIPE_AMP] = ACTIONS(2048),
    [anon_sym_AMP_AMP] = ACTIONS(2048),
    [anon_sym_PIPE_PIPE] = ACTIONS(2048),
    [anon_sym_EQ_TILDE] = ACTIONS(2048),
    [anon_sym_EQ_EQ] = ACTIONS(2048),
    [anon_sym_LT] = ACTIONS(2048),
    [anon_sym_GT] = ACTIONS(2048),
    [anon_sym_GT_GT] = ACTIONS(2048),
    [anon_sym_AMP_GT] = ACTIONS(2048),
    [anon_sym_AMP_GT_GT] = ACTIONS(2048),
    [anon_sym_LT_AMP] = ACTIONS(2048),
    [anon_sym_GT_AMP] = ACTIONS(2048),
    [anon_sym_LT_LT] = ACTIONS(2048),
    [anon_sym_LT_LT_DASH] = ACTIONS(2048),
    [anon_sym_LT_LT_LT] = ACTIONS(2048),
    [sym__special_characters] = ACTIONS(2048),
    [anon_sym_DQUOTE] = ACTIONS(2048),
    [anon_sym_DOLLAR] = ACTIONS(2048),
    [sym_raw_string] = ACTIONS(2048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2048),
    [anon_sym_BQUOTE] = ACTIONS(2048),
    [anon_sym_LT_LPAREN] = ACTIONS(2048),
    [anon_sym_GT_LPAREN] = ACTIONS(2048),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2048),
    [anon_sym_SEMI] = ACTIONS(2048),
    [anon_sym_LF] = ACTIONS(2046),
    [anon_sym_AMP] = ACTIONS(2048),
  },
  [652] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(2050),
    [sym__heredoc_body_beginning] = ACTIONS(2050),
    [sym_file_descriptor] = ACTIONS(2050),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2052),
    [anon_sym_RPAREN] = ACTIONS(2052),
    [anon_sym_SEMI_SEMI] = ACTIONS(2052),
    [anon_sym_PIPE_AMP] = ACTIONS(2052),
    [anon_sym_AMP_AMP] = ACTIONS(2052),
    [anon_sym_PIPE_PIPE] = ACTIONS(2052),
    [anon_sym_EQ_TILDE] = ACTIONS(2052),
    [anon_sym_EQ_EQ] = ACTIONS(2052),
    [anon_sym_LT] = ACTIONS(2052),
    [anon_sym_GT] = ACTIONS(2052),
    [anon_sym_GT_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT_GT] = ACTIONS(2052),
    [anon_sym_LT_AMP] = ACTIONS(2052),
    [anon_sym_GT_AMP] = ACTIONS(2052),
    [anon_sym_LT_LT] = ACTIONS(2052),
    [anon_sym_LT_LT_DASH] = ACTIONS(2052),
    [anon_sym_LT_LT_LT] = ACTIONS(2052),
    [sym__special_characters] = ACTIONS(2052),
    [anon_sym_DQUOTE] = ACTIONS(2052),
    [anon_sym_DOLLAR] = ACTIONS(2052),
    [sym_raw_string] = ACTIONS(2052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2052),
    [anon_sym_BQUOTE] = ACTIONS(2052),
    [anon_sym_LT_LPAREN] = ACTIONS(2052),
    [anon_sym_GT_LPAREN] = ACTIONS(2052),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2052),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym_LF] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2052),
  },
  [653] = {
    [aux_sym_concatenation_repeat1] = STATE(1097),
    [sym__simple_heredoc_body] = ACTIONS(661),
    [sym__heredoc_body_beginning] = ACTIONS(661),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(665),
    [anon_sym_LT_LT_LT] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [654] = {
    [aux_sym_concatenation_repeat1] = STATE(1097),
    [sym__simple_heredoc_body] = ACTIONS(677),
    [sym__heredoc_body_beginning] = ACTIONS(677),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [655] = {
    [aux_sym_concatenation_repeat1] = STATE(1097),
    [sym__simple_heredoc_body] = ACTIONS(2058),
    [sym__heredoc_body_beginning] = ACTIONS(2058),
    [sym_file_descriptor] = ACTIONS(2058),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_RPAREN] = ACTIONS(2060),
    [anon_sym_SEMI_SEMI] = ACTIONS(2060),
    [anon_sym_PIPE_AMP] = ACTIONS(2060),
    [anon_sym_AMP_AMP] = ACTIONS(2060),
    [anon_sym_PIPE_PIPE] = ACTIONS(2060),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2060),
    [anon_sym_LT_AMP] = ACTIONS(2060),
    [anon_sym_GT_AMP] = ACTIONS(2060),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2060),
    [anon_sym_LT_LT_LT] = ACTIONS(2060),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2060),
  },
  [656] = {
    [aux_sym_concatenation_repeat1] = STATE(1097),
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_RPAREN] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [657] = {
    [sym_file_redirect] = STATE(657),
    [sym_heredoc_redirect] = STATE(657),
    [sym_herestring_redirect] = STATE(657),
    [aux_sym_while_statement_repeat1] = STATE(657),
    [sym__simple_heredoc_body] = ACTIONS(2070),
    [sym__heredoc_body_beginning] = ACTIONS(2070),
    [sym_file_descriptor] = ACTIONS(2377),
    [anon_sym_PIPE] = ACTIONS(2075),
    [anon_sym_RPAREN] = ACTIONS(2075),
    [anon_sym_SEMI_SEMI] = ACTIONS(2075),
    [anon_sym_PIPE_AMP] = ACTIONS(2075),
    [anon_sym_AMP_AMP] = ACTIONS(2075),
    [anon_sym_PIPE_PIPE] = ACTIONS(2075),
    [anon_sym_LT] = ACTIONS(2380),
    [anon_sym_GT] = ACTIONS(2380),
    [anon_sym_GT_GT] = ACTIONS(2380),
    [anon_sym_AMP_GT] = ACTIONS(2380),
    [anon_sym_AMP_GT_GT] = ACTIONS(2380),
    [anon_sym_LT_AMP] = ACTIONS(2380),
    [anon_sym_GT_AMP] = ACTIONS(2380),
    [anon_sym_LT_LT] = ACTIONS(2080),
    [anon_sym_LT_LT_DASH] = ACTIONS(2080),
    [anon_sym_LT_LT_LT] = ACTIONS(2383),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_LF] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2075),
  },
  [658] = {
    [sym_file_redirect] = STATE(657),
    [sym_heredoc_redirect] = STATE(657),
    [sym_heredoc_body] = STATE(983),
    [sym_herestring_redirect] = STATE(657),
    [aux_sym_while_statement_repeat1] = STATE(657),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_RPAREN] = ACTIONS(2066),
    [anon_sym_SEMI_SEMI] = ACTIONS(2066),
    [anon_sym_PIPE_AMP] = ACTIONS(2066),
    [anon_sym_AMP_AMP] = ACTIONS(2066),
    [anon_sym_PIPE_PIPE] = ACTIONS(2066),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym_LF] = ACTIONS(2068),
    [anon_sym_AMP] = ACTIONS(2066),
  },
  [659] = {
    [sym_concatenation] = STATE(659),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [aux_sym_command_repeat2] = STATE(659),
    [sym__simple_heredoc_body] = ACTIONS(2050),
    [sym__heredoc_body_beginning] = ACTIONS(2050),
    [sym_file_descriptor] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2052),
    [anon_sym_RPAREN] = ACTIONS(2052),
    [anon_sym_SEMI_SEMI] = ACTIONS(2052),
    [anon_sym_PIPE_AMP] = ACTIONS(2052),
    [anon_sym_AMP_AMP] = ACTIONS(2052),
    [anon_sym_PIPE_PIPE] = ACTIONS(2052),
    [anon_sym_EQ_TILDE] = ACTIONS(2386),
    [anon_sym_EQ_EQ] = ACTIONS(2386),
    [anon_sym_LT] = ACTIONS(2052),
    [anon_sym_GT] = ACTIONS(2052),
    [anon_sym_GT_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT_GT] = ACTIONS(2052),
    [anon_sym_LT_AMP] = ACTIONS(2052),
    [anon_sym_GT_AMP] = ACTIONS(2052),
    [anon_sym_LT_LT] = ACTIONS(2052),
    [anon_sym_LT_LT_DASH] = ACTIONS(2052),
    [anon_sym_LT_LT_LT] = ACTIONS(2052),
    [sym__special_characters] = ACTIONS(2389),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [anon_sym_DOLLAR] = ACTIONS(2095),
    [sym_raw_string] = ACTIONS(2392),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2104),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [anon_sym_LT_LPAREN] = ACTIONS(2110),
    [anon_sym_GT_LPAREN] = ACTIONS(2110),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym_LF] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2052),
  },
  [660] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_RPAREN] = ACTIONS(2395),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [661] = {
    [sym_file_redirect] = STATE(1099),
    [sym_heredoc_redirect] = STATE(1099),
    [sym_heredoc_body] = STATE(983),
    [sym_herestring_redirect] = STATE(1099),
    [sym_concatenation] = STATE(659),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [aux_sym_while_statement_repeat1] = STATE(1099),
    [aux_sym_command_repeat2] = STATE(659),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_RPAREN] = ACTIONS(2066),
    [anon_sym_SEMI_SEMI] = ACTIONS(2066),
    [anon_sym_PIPE_AMP] = ACTIONS(2066),
    [anon_sym_AMP_AMP] = ACTIONS(2066),
    [anon_sym_PIPE_PIPE] = ACTIONS(2066),
    [anon_sym_EQ_TILDE] = ACTIONS(485),
    [anon_sym_EQ_EQ] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym__special_characters] = ACTIONS(491),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym_LF] = ACTIONS(2068),
    [anon_sym_AMP] = ACTIONS(2066),
  },
  [662] = {
    [sym_file_descriptor] = ACTIONS(1107),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1107),
  },
  [663] = {
    [sym_concatenation] = STATE(1101),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1101),
    [anon_sym_RPAREN] = ACTIONS(2397),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [664] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym_file_descriptor] = ACTIONS(1129),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT_GT] = ACTIONS(1129),
    [anon_sym_LT_AMP] = ACTIONS(1129),
    [anon_sym_GT_AMP] = ACTIONS(1129),
    [sym__special_characters] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1129),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [anon_sym_LT_LPAREN] = ACTIONS(1129),
    [anon_sym_GT_LPAREN] = ACTIONS(1129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1129),
  },
  [665] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1107),
  },
  [666] = {
    [anon_sym_RPAREN] = ACTIONS(1295),
    [anon_sym_AMP_AMP] = ACTIONS(1289),
    [anon_sym_PIPE_PIPE] = ACTIONS(1289),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_EQ_EQ] = ACTIONS(1291),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1289),
    [anon_sym_GT] = ACTIONS(1289),
    [anon_sym_BANG_EQ] = ACTIONS(1289),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1289),
  },
  [667] = {
    [aux_sym_concatenation_repeat1] = STATE(1102),
    [sym__concat] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(693),
    [anon_sym_EQ_EQ] = ACTIONS(693),
    [anon_sym_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(693),
    [anon_sym_GT] = ACTIONS(693),
    [anon_sym_BANG_EQ] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(693),
  },
  [668] = {
    [anon_sym_AMP_AMP] = ACTIONS(2399),
    [anon_sym_PIPE_PIPE] = ACTIONS(2399),
    [anon_sym_RBRACK] = ACTIONS(2399),
    [anon_sym_EQ_TILDE] = ACTIONS(2399),
    [anon_sym_EQ_EQ] = ACTIONS(2399),
    [anon_sym_EQ] = ACTIONS(2401),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_BANG_EQ] = ACTIONS(2399),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2399),
  },
  [669] = {
    [sym__expression] = STATE(717),
    [sym_binary_expression] = STATE(717),
    [sym_unary_expression] = STATE(717),
    [sym_parenthesized_expression] = STATE(717),
    [sym_concatenation] = STATE(717),
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_string_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(509),
    [sym_test_operator] = ACTIONS(511),
  },
  [670] = {
    [sym__expression] = STATE(717),
    [sym_binary_expression] = STATE(717),
    [sym_unary_expression] = STATE(717),
    [sym_parenthesized_expression] = STATE(717),
    [sym_concatenation] = STATE(717),
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_string_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(2403),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1417),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1419),
    [anon_sym_BQUOTE] = ACTIONS(1421),
    [anon_sym_LT_LPAREN] = ACTIONS(1423),
    [anon_sym_GT_LPAREN] = ACTIONS(1423),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(509),
    [sym_test_operator] = ACTIONS(503),
    [sym_regex] = ACTIONS(1425),
  },
  [671] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_RBRACK] = ACTIONS(1642),
    [anon_sym_EQ_TILDE] = ACTIONS(1642),
    [anon_sym_EQ_EQ] = ACTIONS(1642),
    [anon_sym_EQ] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1642),
    [anon_sym_GT] = ACTIONS(1642),
    [anon_sym_BANG_EQ] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1642),
  },
  [672] = {
    [aux_sym_concatenation_repeat1] = STATE(672),
    [sym__concat] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_RBRACK] = ACTIONS(1642),
    [anon_sym_EQ_TILDE] = ACTIONS(1642),
    [anon_sym_EQ_EQ] = ACTIONS(1642),
    [anon_sym_EQ] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1642),
    [anon_sym_GT] = ACTIONS(1642),
    [anon_sym_BANG_EQ] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1642),
  },
  [673] = {
    [sym__concat] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1691),
    [anon_sym_PIPE_PIPE] = ACTIONS(1691),
    [anon_sym_RBRACK] = ACTIONS(1691),
    [anon_sym_EQ_TILDE] = ACTIONS(1691),
    [anon_sym_EQ_EQ] = ACTIONS(1691),
    [anon_sym_EQ] = ACTIONS(1693),
    [anon_sym_LT] = ACTIONS(1691),
    [anon_sym_GT] = ACTIONS(1691),
    [anon_sym_BANG_EQ] = ACTIONS(1691),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1691),
  },
  [674] = {
    [sym_concatenation] = STATE(1106),
    [sym_string] = STATE(1105),
    [sym_simple_expansion] = STATE(1105),
    [sym_string_expansion] = STATE(1105),
    [sym_expansion] = STATE(1105),
    [sym_command_substitution] = STATE(1105),
    [sym_process_substitution] = STATE(1105),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [sym__special_characters] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(2412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2412),
  },
  [675] = {
    [sym__concat] = ACTIONS(1732),
    [anon_sym_AMP_AMP] = ACTIONS(1732),
    [anon_sym_PIPE_PIPE] = ACTIONS(1732),
    [anon_sym_RBRACK] = ACTIONS(1732),
    [anon_sym_EQ_TILDE] = ACTIONS(1732),
    [anon_sym_EQ_EQ] = ACTIONS(1732),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_LT] = ACTIONS(1732),
    [anon_sym_GT] = ACTIONS(1732),
    [anon_sym_BANG_EQ] = ACTIONS(1732),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1732),
  },
  [676] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2414),
  },
  [677] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [678] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2418),
    [sym_comment] = ACTIONS(53),
  },
  [679] = {
    [sym_concatenation] = STATE(1112),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1112),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_EQ] = ACTIONS(2422),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2426),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_COLON_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_DASH] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [680] = {
    [sym_concatenation] = STATE(1115),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1115),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_EQ] = ACTIONS(2430),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2432),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2434),
    [anon_sym_COLON] = ACTIONS(2430),
    [anon_sym_COLON_QMARK] = ACTIONS(2430),
    [anon_sym_COLON_DASH] = ACTIONS(2430),
    [anon_sym_PERCENT] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [681] = {
    [sym_concatenation] = STATE(1117),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1117),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(2436),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2438),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2440),
    [anon_sym_COLON] = ACTIONS(2436),
    [anon_sym_COLON_QMARK] = ACTIONS(2436),
    [anon_sym_COLON_DASH] = ACTIONS(2436),
    [anon_sym_PERCENT] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [682] = {
    [sym__concat] = ACTIONS(1798),
    [anon_sym_AMP_AMP] = ACTIONS(1798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1798),
    [anon_sym_RBRACK] = ACTIONS(1798),
    [anon_sym_EQ_TILDE] = ACTIONS(1798),
    [anon_sym_EQ_EQ] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1800),
    [anon_sym_LT] = ACTIONS(1798),
    [anon_sym_GT] = ACTIONS(1798),
    [anon_sym_BANG_EQ] = ACTIONS(1798),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1798),
  },
  [683] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2442),
  },
  [684] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2444),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [685] = {
    [sym__concat] = ACTIONS(1806),
    [anon_sym_AMP_AMP] = ACTIONS(1806),
    [anon_sym_PIPE_PIPE] = ACTIONS(1806),
    [anon_sym_RBRACK] = ACTIONS(1806),
    [anon_sym_EQ_TILDE] = ACTIONS(1806),
    [anon_sym_EQ_EQ] = ACTIONS(1806),
    [anon_sym_EQ] = ACTIONS(1808),
    [anon_sym_LT] = ACTIONS(1806),
    [anon_sym_GT] = ACTIONS(1806),
    [anon_sym_BANG_EQ] = ACTIONS(1806),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1806),
  },
  [686] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2446),
  },
  [687] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [688] = {
    [sym__concat] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_RBRACK] = ACTIONS(1940),
    [anon_sym_EQ_TILDE] = ACTIONS(1940),
    [anon_sym_EQ_EQ] = ACTIONS(1940),
    [anon_sym_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1940),
    [anon_sym_GT] = ACTIONS(1940),
    [anon_sym_BANG_EQ] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1940),
  },
  [689] = {
    [sym__concat] = ACTIONS(2006),
    [anon_sym_AMP_AMP] = ACTIONS(2006),
    [anon_sym_PIPE_PIPE] = ACTIONS(2006),
    [anon_sym_RBRACK] = ACTIONS(2006),
    [anon_sym_EQ_TILDE] = ACTIONS(2006),
    [anon_sym_EQ_EQ] = ACTIONS(2006),
    [anon_sym_EQ] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2006),
    [anon_sym_GT] = ACTIONS(2006),
    [anon_sym_BANG_EQ] = ACTIONS(2006),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2006),
  },
  [690] = {
    [anon_sym_AMP_AMP] = ACTIONS(2448),
    [anon_sym_PIPE_PIPE] = ACTIONS(2448),
    [anon_sym_RBRACK] = ACTIONS(2448),
    [anon_sym_EQ_TILDE] = ACTIONS(2448),
    [anon_sym_EQ_EQ] = ACTIONS(2448),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_BANG_EQ] = ACTIONS(2448),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2448),
  },
  [691] = {
    [anon_sym_LT] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2452),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [sym_comment] = ACTIONS(53),
  },
  [692] = {
    [sym_concatenation] = STATE(1130),
    [sym_string] = STATE(1125),
    [sym_simple_expansion] = STATE(1125),
    [sym_string_expansion] = STATE(1125),
    [sym_expansion] = STATE(1125),
    [sym_command_substitution] = STATE(1125),
    [sym_process_substitution] = STATE(1125),
    [sym__special_characters] = ACTIONS(2456),
    [anon_sym_DQUOTE] = ACTIONS(2458),
    [anon_sym_DOLLAR] = ACTIONS(2460),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2466),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [anon_sym_LT_LPAREN] = ACTIONS(2470),
    [anon_sym_GT_LPAREN] = ACTIONS(2470),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2462),
  },
  [693] = {
    [sym_heredoc_start] = ACTIONS(2472),
    [sym_comment] = ACTIONS(53),
  },
  [694] = {
    [sym_concatenation] = STATE(1134),
    [sym_string] = STATE(1133),
    [sym_simple_expansion] = STATE(1133),
    [sym_string_expansion] = STATE(1133),
    [sym_expansion] = STATE(1133),
    [sym_command_substitution] = STATE(1133),
    [sym_process_substitution] = STATE(1133),
    [sym__special_characters] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2458),
    [anon_sym_DOLLAR] = ACTIONS(2460),
    [sym_raw_string] = ACTIONS(2476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2466),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [anon_sym_LT_LPAREN] = ACTIONS(2470),
    [anon_sym_GT_LPAREN] = ACTIONS(2470),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2476),
  },
  [695] = {
    [sym_file_redirect] = STATE(1135),
    [sym_heredoc_redirect] = STATE(1135),
    [sym_herestring_redirect] = STATE(1135),
    [aux_sym_while_statement_repeat1] = STATE(1135),
    [sym_file_descriptor] = ACTIONS(1339),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_SEMI_SEMI] = ACTIONS(2478),
    [anon_sym_PIPE_AMP] = ACTIONS(2478),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_LT] = ACTIONS(1343),
    [anon_sym_GT] = ACTIONS(1343),
    [anon_sym_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_GT] = ACTIONS(1343),
    [anon_sym_AMP_GT_GT] = ACTIONS(1343),
    [anon_sym_LT_AMP] = ACTIONS(1343),
    [anon_sym_GT_AMP] = ACTIONS(1343),
    [anon_sym_LT_LT] = ACTIONS(1345),
    [anon_sym_LT_LT_DASH] = ACTIONS(1345),
    [anon_sym_LT_LT_LT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_LF] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2478),
  },
  [696] = {
    [anon_sym_AMP_AMP] = ACTIONS(2448),
    [anon_sym_PIPE_PIPE] = ACTIONS(2448),
    [anon_sym_RBRACK] = ACTIONS(2448),
    [anon_sym_EQ_TILDE] = ACTIONS(2448),
    [anon_sym_EQ_EQ] = ACTIONS(2448),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_BANG_EQ] = ACTIONS(2448),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2448),
  },
  [697] = {
    [anon_sym_RPAREN] = ACTIONS(2399),
    [anon_sym_AMP_AMP] = ACTIONS(2399),
    [anon_sym_PIPE_PIPE] = ACTIONS(2399),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2399),
    [anon_sym_EQ_TILDE] = ACTIONS(2399),
    [anon_sym_EQ_EQ] = ACTIONS(2399),
    [anon_sym_EQ] = ACTIONS(2401),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_BANG_EQ] = ACTIONS(2399),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2399),
  },
  [698] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1642),
    [anon_sym_EQ_TILDE] = ACTIONS(1642),
    [anon_sym_EQ_EQ] = ACTIONS(1642),
    [anon_sym_EQ] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1642),
    [anon_sym_GT] = ACTIONS(1642),
    [anon_sym_BANG_EQ] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1642),
  },
  [699] = {
    [aux_sym_concatenation_repeat1] = STATE(699),
    [sym__concat] = ACTIONS(2482),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1642),
    [anon_sym_EQ_TILDE] = ACTIONS(1642),
    [anon_sym_EQ_EQ] = ACTIONS(1642),
    [anon_sym_EQ] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1642),
    [anon_sym_GT] = ACTIONS(1642),
    [anon_sym_BANG_EQ] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1642),
  },
  [700] = {
    [sym__concat] = ACTIONS(1691),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_RPAREN] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1691),
    [anon_sym_PIPE_PIPE] = ACTIONS(1691),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1691),
    [anon_sym_EQ_TILDE] = ACTIONS(1691),
    [anon_sym_EQ_EQ] = ACTIONS(1691),
    [anon_sym_EQ] = ACTIONS(1693),
    [anon_sym_LT] = ACTIONS(1691),
    [anon_sym_GT] = ACTIONS(1691),
    [anon_sym_BANG_EQ] = ACTIONS(1691),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1691),
  },
  [701] = {
    [sym_concatenation] = STATE(1139),
    [sym_string] = STATE(1138),
    [sym_simple_expansion] = STATE(1138),
    [sym_string_expansion] = STATE(1138),
    [sym_expansion] = STATE(1138),
    [sym_command_substitution] = STATE(1138),
    [sym_process_substitution] = STATE(1138),
    [anon_sym_RBRACE] = ACTIONS(2485),
    [sym__special_characters] = ACTIONS(2487),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(2489),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2489),
  },
  [702] = {
    [sym__concat] = ACTIONS(1732),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [anon_sym_AMP_AMP] = ACTIONS(1732),
    [anon_sym_PIPE_PIPE] = ACTIONS(1732),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1732),
    [anon_sym_EQ_TILDE] = ACTIONS(1732),
    [anon_sym_EQ_EQ] = ACTIONS(1732),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_LT] = ACTIONS(1732),
    [anon_sym_GT] = ACTIONS(1732),
    [anon_sym_BANG_EQ] = ACTIONS(1732),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1732),
  },
  [703] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2491),
  },
  [704] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2493),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [705] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2495),
    [sym_comment] = ACTIONS(53),
  },
  [706] = {
    [sym_concatenation] = STATE(1145),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1145),
    [anon_sym_RBRACE] = ACTIONS(2497),
    [anon_sym_EQ] = ACTIONS(2499),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2501),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2503),
    [anon_sym_COLON] = ACTIONS(2499),
    [anon_sym_COLON_QMARK] = ACTIONS(2499),
    [anon_sym_COLON_DASH] = ACTIONS(2499),
    [anon_sym_PERCENT] = ACTIONS(2499),
    [anon_sym_DASH] = ACTIONS(2499),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [707] = {
    [sym_concatenation] = STATE(1148),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1148),
    [anon_sym_RBRACE] = ACTIONS(2505),
    [anon_sym_EQ] = ACTIONS(2507),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2511),
    [anon_sym_COLON] = ACTIONS(2507),
    [anon_sym_COLON_QMARK] = ACTIONS(2507),
    [anon_sym_COLON_DASH] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_DASH] = ACTIONS(2507),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [708] = {
    [sym_concatenation] = STATE(1150),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1150),
    [anon_sym_RBRACE] = ACTIONS(2485),
    [anon_sym_EQ] = ACTIONS(2513),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2515),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2513),
    [anon_sym_COLON_QMARK] = ACTIONS(2513),
    [anon_sym_COLON_DASH] = ACTIONS(2513),
    [anon_sym_PERCENT] = ACTIONS(2513),
    [anon_sym_DASH] = ACTIONS(2513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [709] = {
    [sym__concat] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1798),
    [anon_sym_AMP_AMP] = ACTIONS(1798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1798),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1798),
    [anon_sym_EQ_TILDE] = ACTIONS(1798),
    [anon_sym_EQ_EQ] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1800),
    [anon_sym_LT] = ACTIONS(1798),
    [anon_sym_GT] = ACTIONS(1798),
    [anon_sym_BANG_EQ] = ACTIONS(1798),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1798),
  },
  [710] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2519),
  },
  [711] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2521),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [712] = {
    [sym__concat] = ACTIONS(1806),
    [anon_sym_PIPE] = ACTIONS(1808),
    [anon_sym_RPAREN] = ACTIONS(1806),
    [anon_sym_AMP_AMP] = ACTIONS(1806),
    [anon_sym_PIPE_PIPE] = ACTIONS(1806),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1806),
    [anon_sym_EQ_TILDE] = ACTIONS(1806),
    [anon_sym_EQ_EQ] = ACTIONS(1806),
    [anon_sym_EQ] = ACTIONS(1808),
    [anon_sym_LT] = ACTIONS(1806),
    [anon_sym_GT] = ACTIONS(1806),
    [anon_sym_BANG_EQ] = ACTIONS(1806),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1806),
  },
  [713] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2523),
  },
  [714] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2485),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [715] = {
    [sym__concat] = ACTIONS(1940),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1940),
    [anon_sym_EQ_TILDE] = ACTIONS(1940),
    [anon_sym_EQ_EQ] = ACTIONS(1940),
    [anon_sym_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1940),
    [anon_sym_GT] = ACTIONS(1940),
    [anon_sym_BANG_EQ] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1940),
  },
  [716] = {
    [sym__concat] = ACTIONS(2006),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_RPAREN] = ACTIONS(2006),
    [anon_sym_AMP_AMP] = ACTIONS(2006),
    [anon_sym_PIPE_PIPE] = ACTIONS(2006),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2006),
    [anon_sym_EQ_TILDE] = ACTIONS(2006),
    [anon_sym_EQ_EQ] = ACTIONS(2006),
    [anon_sym_EQ] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2006),
    [anon_sym_GT] = ACTIONS(2006),
    [anon_sym_BANG_EQ] = ACTIONS(2006),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2006),
  },
  [717] = {
    [anon_sym_RPAREN] = ACTIONS(2448),
    [anon_sym_AMP_AMP] = ACTIONS(2448),
    [anon_sym_PIPE_PIPE] = ACTIONS(2448),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2448),
    [anon_sym_EQ_TILDE] = ACTIONS(2448),
    [anon_sym_EQ_EQ] = ACTIONS(2448),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_BANG_EQ] = ACTIONS(2448),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2448),
  },
  [718] = {
    [anon_sym_RPAREN] = ACTIONS(2448),
    [anon_sym_AMP_AMP] = ACTIONS(2448),
    [anon_sym_PIPE_PIPE] = ACTIONS(2448),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2448),
    [anon_sym_EQ_TILDE] = ACTIONS(2448),
    [anon_sym_EQ_EQ] = ACTIONS(2448),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_BANG_EQ] = ACTIONS(2448),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2448),
  },
  [719] = {
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [720] = {
    [sym_concatenation] = STATE(1155),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1155),
    [anon_sym_RPAREN] = ACTIONS(2525),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [721] = {
    [aux_sym_concatenation_repeat1] = STATE(335),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [sym__special_characters] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1133),
    [sym_word] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1133),
  },
  [722] = {
    [aux_sym_concatenation_repeat1] = STATE(335),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [723] = {
    [sym__concat] = ACTIONS(1642),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [724] = {
    [aux_sym_concatenation_repeat1] = STATE(724),
    [sym__concat] = ACTIONS(2527),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [725] = {
    [sym__concat] = ACTIONS(1691),
    [sym_variable_name] = ACTIONS(1691),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_RPAREN] = ACTIONS(1693),
    [anon_sym_SEMI_SEMI] = ACTIONS(1693),
    [anon_sym_PIPE_AMP] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [sym__special_characters] = ACTIONS(1693),
    [anon_sym_DQUOTE] = ACTIONS(1693),
    [anon_sym_DOLLAR] = ACTIONS(1693),
    [sym_raw_string] = ACTIONS(1693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1693),
    [anon_sym_BQUOTE] = ACTIONS(1693),
    [anon_sym_LT_LPAREN] = ACTIONS(1693),
    [anon_sym_GT_LPAREN] = ACTIONS(1693),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1693),
    [sym_word] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1693),
    [anon_sym_LF] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1693),
  },
  [726] = {
    [sym_concatenation] = STATE(1159),
    [sym_string] = STATE(1158),
    [sym_simple_expansion] = STATE(1158),
    [sym_string_expansion] = STATE(1158),
    [sym_expansion] = STATE(1158),
    [sym_command_substitution] = STATE(1158),
    [sym_process_substitution] = STATE(1158),
    [anon_sym_RBRACE] = ACTIONS(2530),
    [sym__special_characters] = ACTIONS(2532),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2534),
  },
  [727] = {
    [sym__concat] = ACTIONS(1732),
    [sym_variable_name] = ACTIONS(1732),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_RPAREN] = ACTIONS(1734),
    [anon_sym_SEMI_SEMI] = ACTIONS(1734),
    [anon_sym_PIPE_AMP] = ACTIONS(1734),
    [anon_sym_AMP_AMP] = ACTIONS(1734),
    [anon_sym_PIPE_PIPE] = ACTIONS(1734),
    [sym__special_characters] = ACTIONS(1734),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [sym_raw_string] = ACTIONS(1734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1734),
    [anon_sym_BQUOTE] = ACTIONS(1734),
    [anon_sym_LT_LPAREN] = ACTIONS(1734),
    [anon_sym_GT_LPAREN] = ACTIONS(1734),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1734),
    [sym_word] = ACTIONS(1734),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_LF] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1734),
  },
  [728] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2536),
  },
  [729] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2538),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [730] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2540),
    [sym_comment] = ACTIONS(53),
  },
  [731] = {
    [sym_concatenation] = STATE(1165),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1165),
    [anon_sym_RBRACE] = ACTIONS(2542),
    [anon_sym_EQ] = ACTIONS(2544),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2548),
    [anon_sym_COLON] = ACTIONS(2544),
    [anon_sym_COLON_QMARK] = ACTIONS(2544),
    [anon_sym_COLON_DASH] = ACTIONS(2544),
    [anon_sym_PERCENT] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [732] = {
    [sym_concatenation] = STATE(1168),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1168),
    [anon_sym_RBRACE] = ACTIONS(2550),
    [anon_sym_EQ] = ACTIONS(2552),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2556),
    [anon_sym_COLON] = ACTIONS(2552),
    [anon_sym_COLON_QMARK] = ACTIONS(2552),
    [anon_sym_COLON_DASH] = ACTIONS(2552),
    [anon_sym_PERCENT] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2552),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [733] = {
    [sym_concatenation] = STATE(1170),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1170),
    [anon_sym_RBRACE] = ACTIONS(2530),
    [anon_sym_EQ] = ACTIONS(2558),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2560),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2562),
    [anon_sym_COLON] = ACTIONS(2558),
    [anon_sym_COLON_QMARK] = ACTIONS(2558),
    [anon_sym_COLON_DASH] = ACTIONS(2558),
    [anon_sym_PERCENT] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [734] = {
    [sym__concat] = ACTIONS(1798),
    [sym_variable_name] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1800),
    [anon_sym_SEMI_SEMI] = ACTIONS(1800),
    [anon_sym_PIPE_AMP] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(1800),
    [anon_sym_PIPE_PIPE] = ACTIONS(1800),
    [sym__special_characters] = ACTIONS(1800),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [sym_raw_string] = ACTIONS(1800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1800),
    [anon_sym_BQUOTE] = ACTIONS(1800),
    [anon_sym_LT_LPAREN] = ACTIONS(1800),
    [anon_sym_GT_LPAREN] = ACTIONS(1800),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1800),
    [sym_word] = ACTIONS(1800),
    [anon_sym_SEMI] = ACTIONS(1800),
    [anon_sym_LF] = ACTIONS(1798),
    [anon_sym_AMP] = ACTIONS(1800),
  },
  [735] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2564),
  },
  [736] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2566),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [737] = {
    [sym__concat] = ACTIONS(1806),
    [sym_variable_name] = ACTIONS(1806),
    [anon_sym_PIPE] = ACTIONS(1808),
    [anon_sym_RPAREN] = ACTIONS(1808),
    [anon_sym_SEMI_SEMI] = ACTIONS(1808),
    [anon_sym_PIPE_AMP] = ACTIONS(1808),
    [anon_sym_AMP_AMP] = ACTIONS(1808),
    [anon_sym_PIPE_PIPE] = ACTIONS(1808),
    [sym__special_characters] = ACTIONS(1808),
    [anon_sym_DQUOTE] = ACTIONS(1808),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [sym_raw_string] = ACTIONS(1808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1808),
    [anon_sym_BQUOTE] = ACTIONS(1808),
    [anon_sym_LT_LPAREN] = ACTIONS(1808),
    [anon_sym_GT_LPAREN] = ACTIONS(1808),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1808),
    [sym_word] = ACTIONS(1808),
    [anon_sym_SEMI] = ACTIONS(1808),
    [anon_sym_LF] = ACTIONS(1806),
    [anon_sym_AMP] = ACTIONS(1808),
  },
  [738] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2568),
  },
  [739] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2530),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [740] = {
    [sym__concat] = ACTIONS(1940),
    [sym_variable_name] = ACTIONS(1940),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1942),
    [anon_sym_PIPE_AMP] = ACTIONS(1942),
    [anon_sym_AMP_AMP] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1942),
    [sym__special_characters] = ACTIONS(1942),
    [anon_sym_DQUOTE] = ACTIONS(1942),
    [anon_sym_DOLLAR] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1942),
    [anon_sym_BQUOTE] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1942),
    [anon_sym_GT_LPAREN] = ACTIONS(1942),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1942),
    [sym_word] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [741] = {
    [sym__concat] = ACTIONS(2006),
    [sym_variable_name] = ACTIONS(2006),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_RPAREN] = ACTIONS(2008),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [sym__special_characters] = ACTIONS(2008),
    [anon_sym_DQUOTE] = ACTIONS(2008),
    [anon_sym_DOLLAR] = ACTIONS(2008),
    [sym_raw_string] = ACTIONS(2008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2008),
    [anon_sym_BQUOTE] = ACTIONS(2008),
    [anon_sym_LT_LPAREN] = ACTIONS(2008),
    [anon_sym_GT_LPAREN] = ACTIONS(2008),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2008),
    [sym_word] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2008),
  },
  [742] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [743] = {
    [aux_sym_concatenation_repeat1] = STATE(743),
    [sym__concat] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [744] = {
    [sym__concat] = ACTIONS(1691),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_RPAREN] = ACTIONS(1693),
    [anon_sym_SEMI_SEMI] = ACTIONS(1693),
    [anon_sym_PIPE_AMP] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [sym__special_characters] = ACTIONS(1693),
    [anon_sym_DQUOTE] = ACTIONS(1693),
    [anon_sym_DOLLAR] = ACTIONS(1693),
    [sym_raw_string] = ACTIONS(1693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1693),
    [anon_sym_BQUOTE] = ACTIONS(1693),
    [anon_sym_LT_LPAREN] = ACTIONS(1693),
    [anon_sym_GT_LPAREN] = ACTIONS(1693),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1693),
    [sym_word] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1693),
    [anon_sym_LF] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1693),
  },
  [745] = {
    [sym_concatenation] = STATE(1177),
    [sym_string] = STATE(1176),
    [sym_simple_expansion] = STATE(1176),
    [sym_string_expansion] = STATE(1176),
    [sym_expansion] = STATE(1176),
    [sym_command_substitution] = STATE(1176),
    [sym_process_substitution] = STATE(1176),
    [anon_sym_RBRACE] = ACTIONS(2573),
    [sym__special_characters] = ACTIONS(2575),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(2577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2577),
  },
  [746] = {
    [sym__concat] = ACTIONS(1732),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_RPAREN] = ACTIONS(1734),
    [anon_sym_SEMI_SEMI] = ACTIONS(1734),
    [anon_sym_PIPE_AMP] = ACTIONS(1734),
    [anon_sym_AMP_AMP] = ACTIONS(1734),
    [anon_sym_PIPE_PIPE] = ACTIONS(1734),
    [sym__special_characters] = ACTIONS(1734),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [sym_raw_string] = ACTIONS(1734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1734),
    [anon_sym_BQUOTE] = ACTIONS(1734),
    [anon_sym_LT_LPAREN] = ACTIONS(1734),
    [anon_sym_GT_LPAREN] = ACTIONS(1734),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1734),
    [sym_word] = ACTIONS(1734),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_LF] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1734),
  },
  [747] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2579),
  },
  [748] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2581),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [749] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2583),
    [sym_comment] = ACTIONS(53),
  },
  [750] = {
    [sym_concatenation] = STATE(1183),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1183),
    [anon_sym_RBRACE] = ACTIONS(2585),
    [anon_sym_EQ] = ACTIONS(2587),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2591),
    [anon_sym_COLON] = ACTIONS(2587),
    [anon_sym_COLON_QMARK] = ACTIONS(2587),
    [anon_sym_COLON_DASH] = ACTIONS(2587),
    [anon_sym_PERCENT] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [751] = {
    [sym_concatenation] = STATE(1186),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1186),
    [anon_sym_RBRACE] = ACTIONS(2593),
    [anon_sym_EQ] = ACTIONS(2595),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2597),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2599),
    [anon_sym_COLON] = ACTIONS(2595),
    [anon_sym_COLON_QMARK] = ACTIONS(2595),
    [anon_sym_COLON_DASH] = ACTIONS(2595),
    [anon_sym_PERCENT] = ACTIONS(2595),
    [anon_sym_DASH] = ACTIONS(2595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [752] = {
    [sym_concatenation] = STATE(1188),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1188),
    [anon_sym_RBRACE] = ACTIONS(2573),
    [anon_sym_EQ] = ACTIONS(2601),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2603),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2605),
    [anon_sym_COLON] = ACTIONS(2601),
    [anon_sym_COLON_QMARK] = ACTIONS(2601),
    [anon_sym_COLON_DASH] = ACTIONS(2601),
    [anon_sym_PERCENT] = ACTIONS(2601),
    [anon_sym_DASH] = ACTIONS(2601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [753] = {
    [sym__concat] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1800),
    [anon_sym_SEMI_SEMI] = ACTIONS(1800),
    [anon_sym_PIPE_AMP] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(1800),
    [anon_sym_PIPE_PIPE] = ACTIONS(1800),
    [sym__special_characters] = ACTIONS(1800),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [sym_raw_string] = ACTIONS(1800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1800),
    [anon_sym_BQUOTE] = ACTIONS(1800),
    [anon_sym_LT_LPAREN] = ACTIONS(1800),
    [anon_sym_GT_LPAREN] = ACTIONS(1800),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1800),
    [sym_word] = ACTIONS(1800),
    [anon_sym_SEMI] = ACTIONS(1800),
    [anon_sym_LF] = ACTIONS(1798),
    [anon_sym_AMP] = ACTIONS(1800),
  },
  [754] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2607),
  },
  [755] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2609),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [756] = {
    [sym__concat] = ACTIONS(1806),
    [anon_sym_PIPE] = ACTIONS(1808),
    [anon_sym_RPAREN] = ACTIONS(1808),
    [anon_sym_SEMI_SEMI] = ACTIONS(1808),
    [anon_sym_PIPE_AMP] = ACTIONS(1808),
    [anon_sym_AMP_AMP] = ACTIONS(1808),
    [anon_sym_PIPE_PIPE] = ACTIONS(1808),
    [sym__special_characters] = ACTIONS(1808),
    [anon_sym_DQUOTE] = ACTIONS(1808),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [sym_raw_string] = ACTIONS(1808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1808),
    [anon_sym_BQUOTE] = ACTIONS(1808),
    [anon_sym_LT_LPAREN] = ACTIONS(1808),
    [anon_sym_GT_LPAREN] = ACTIONS(1808),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1808),
    [sym_word] = ACTIONS(1808),
    [anon_sym_SEMI] = ACTIONS(1808),
    [anon_sym_LF] = ACTIONS(1806),
    [anon_sym_AMP] = ACTIONS(1808),
  },
  [757] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2611),
  },
  [758] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2573),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [759] = {
    [sym__concat] = ACTIONS(1940),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1942),
    [anon_sym_PIPE_AMP] = ACTIONS(1942),
    [anon_sym_AMP_AMP] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1942),
    [sym__special_characters] = ACTIONS(1942),
    [anon_sym_DQUOTE] = ACTIONS(1942),
    [anon_sym_DOLLAR] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1942),
    [anon_sym_BQUOTE] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1942),
    [anon_sym_GT_LPAREN] = ACTIONS(1942),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1942),
    [sym_word] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [760] = {
    [sym__concat] = ACTIONS(2006),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_RPAREN] = ACTIONS(2008),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [sym__special_characters] = ACTIONS(2008),
    [anon_sym_DQUOTE] = ACTIONS(2008),
    [anon_sym_DOLLAR] = ACTIONS(2008),
    [sym_raw_string] = ACTIONS(2008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2008),
    [anon_sym_BQUOTE] = ACTIONS(2008),
    [anon_sym_LT_LPAREN] = ACTIONS(2008),
    [anon_sym_GT_LPAREN] = ACTIONS(2008),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2008),
    [sym_word] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2008),
  },
  [761] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1642),
  },
  [762] = {
    [aux_sym_concatenation_repeat1] = STATE(762),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(2613),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1642),
  },
  [763] = {
    [sym_file_descriptor] = ACTIONS(1691),
    [sym__concat] = ACTIONS(1691),
    [sym_variable_name] = ACTIONS(1691),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_RPAREN] = ACTIONS(1691),
    [anon_sym_PIPE_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1691),
    [anon_sym_PIPE_PIPE] = ACTIONS(1691),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1691),
    [anon_sym_AMP_GT] = ACTIONS(1693),
    [anon_sym_AMP_GT_GT] = ACTIONS(1691),
    [anon_sym_LT_AMP] = ACTIONS(1691),
    [anon_sym_GT_AMP] = ACTIONS(1691),
    [sym__special_characters] = ACTIONS(1691),
    [anon_sym_DQUOTE] = ACTIONS(1691),
    [anon_sym_DOLLAR] = ACTIONS(1693),
    [sym_raw_string] = ACTIONS(1691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1691),
    [anon_sym_BQUOTE] = ACTIONS(1691),
    [anon_sym_LT_LPAREN] = ACTIONS(1691),
    [anon_sym_GT_LPAREN] = ACTIONS(1691),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1691),
  },
  [764] = {
    [sym_concatenation] = STATE(1195),
    [sym_string] = STATE(1194),
    [sym_simple_expansion] = STATE(1194),
    [sym_string_expansion] = STATE(1194),
    [sym_expansion] = STATE(1194),
    [sym_command_substitution] = STATE(1194),
    [sym_process_substitution] = STATE(1194),
    [anon_sym_RBRACE] = ACTIONS(2616),
    [sym__special_characters] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(2620),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2620),
  },
  [765] = {
    [sym_file_descriptor] = ACTIONS(1732),
    [sym__concat] = ACTIONS(1732),
    [sym_variable_name] = ACTIONS(1732),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [anon_sym_PIPE_AMP] = ACTIONS(1732),
    [anon_sym_AMP_AMP] = ACTIONS(1732),
    [anon_sym_PIPE_PIPE] = ACTIONS(1732),
    [anon_sym_LT] = ACTIONS(1734),
    [anon_sym_GT] = ACTIONS(1734),
    [anon_sym_GT_GT] = ACTIONS(1732),
    [anon_sym_AMP_GT] = ACTIONS(1734),
    [anon_sym_AMP_GT_GT] = ACTIONS(1732),
    [anon_sym_LT_AMP] = ACTIONS(1732),
    [anon_sym_GT_AMP] = ACTIONS(1732),
    [sym__special_characters] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1732),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [sym_raw_string] = ACTIONS(1732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1732),
    [anon_sym_BQUOTE] = ACTIONS(1732),
    [anon_sym_LT_LPAREN] = ACTIONS(1732),
    [anon_sym_GT_LPAREN] = ACTIONS(1732),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1732),
  },
  [766] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2622),
  },
  [767] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2624),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [768] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2626),
    [sym_comment] = ACTIONS(53),
  },
  [769] = {
    [sym_concatenation] = STATE(1201),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1201),
    [anon_sym_RBRACE] = ACTIONS(2628),
    [anon_sym_EQ] = ACTIONS(2630),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2634),
    [anon_sym_COLON] = ACTIONS(2630),
    [anon_sym_COLON_QMARK] = ACTIONS(2630),
    [anon_sym_COLON_DASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_DASH] = ACTIONS(2630),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [770] = {
    [sym_concatenation] = STATE(1204),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1204),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_EQ] = ACTIONS(2638),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2642),
    [anon_sym_COLON] = ACTIONS(2638),
    [anon_sym_COLON_QMARK] = ACTIONS(2638),
    [anon_sym_COLON_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [771] = {
    [sym_concatenation] = STATE(1206),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1206),
    [anon_sym_RBRACE] = ACTIONS(2616),
    [anon_sym_EQ] = ACTIONS(2644),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2646),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2648),
    [anon_sym_COLON] = ACTIONS(2644),
    [anon_sym_COLON_QMARK] = ACTIONS(2644),
    [anon_sym_COLON_DASH] = ACTIONS(2644),
    [anon_sym_PERCENT] = ACTIONS(2644),
    [anon_sym_DASH] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [772] = {
    [sym_file_descriptor] = ACTIONS(1798),
    [sym__concat] = ACTIONS(1798),
    [sym_variable_name] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1798),
    [anon_sym_PIPE_AMP] = ACTIONS(1798),
    [anon_sym_AMP_AMP] = ACTIONS(1798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1798),
    [anon_sym_LT] = ACTIONS(1800),
    [anon_sym_GT] = ACTIONS(1800),
    [anon_sym_GT_GT] = ACTIONS(1798),
    [anon_sym_AMP_GT] = ACTIONS(1800),
    [anon_sym_AMP_GT_GT] = ACTIONS(1798),
    [anon_sym_LT_AMP] = ACTIONS(1798),
    [anon_sym_GT_AMP] = ACTIONS(1798),
    [sym__special_characters] = ACTIONS(1798),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [sym_raw_string] = ACTIONS(1798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1798),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1798),
    [anon_sym_BQUOTE] = ACTIONS(1798),
    [anon_sym_LT_LPAREN] = ACTIONS(1798),
    [anon_sym_GT_LPAREN] = ACTIONS(1798),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1798),
  },
  [773] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2650),
  },
  [774] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2652),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [775] = {
    [sym_file_descriptor] = ACTIONS(1806),
    [sym__concat] = ACTIONS(1806),
    [sym_variable_name] = ACTIONS(1806),
    [anon_sym_PIPE] = ACTIONS(1808),
    [anon_sym_RPAREN] = ACTIONS(1806),
    [anon_sym_PIPE_AMP] = ACTIONS(1806),
    [anon_sym_AMP_AMP] = ACTIONS(1806),
    [anon_sym_PIPE_PIPE] = ACTIONS(1806),
    [anon_sym_LT] = ACTIONS(1808),
    [anon_sym_GT] = ACTIONS(1808),
    [anon_sym_GT_GT] = ACTIONS(1806),
    [anon_sym_AMP_GT] = ACTIONS(1808),
    [anon_sym_AMP_GT_GT] = ACTIONS(1806),
    [anon_sym_LT_AMP] = ACTIONS(1806),
    [anon_sym_GT_AMP] = ACTIONS(1806),
    [sym__special_characters] = ACTIONS(1806),
    [anon_sym_DQUOTE] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [sym_raw_string] = ACTIONS(1806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1806),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1806),
    [anon_sym_BQUOTE] = ACTIONS(1806),
    [anon_sym_LT_LPAREN] = ACTIONS(1806),
    [anon_sym_GT_LPAREN] = ACTIONS(1806),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1806),
  },
  [776] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2654),
  },
  [777] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2616),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [778] = {
    [sym_file_descriptor] = ACTIONS(1940),
    [sym__concat] = ACTIONS(1940),
    [sym_variable_name] = ACTIONS(1940),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1940),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1940),
    [anon_sym_LT_AMP] = ACTIONS(1940),
    [anon_sym_GT_AMP] = ACTIONS(1940),
    [sym__special_characters] = ACTIONS(1940),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [anon_sym_DOLLAR] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1940),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1940),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1940),
    [anon_sym_BQUOTE] = ACTIONS(1940),
    [anon_sym_LT_LPAREN] = ACTIONS(1940),
    [anon_sym_GT_LPAREN] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1940),
  },
  [779] = {
    [sym_file_descriptor] = ACTIONS(2006),
    [sym__concat] = ACTIONS(2006),
    [sym_variable_name] = ACTIONS(2006),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_RPAREN] = ACTIONS(2006),
    [anon_sym_PIPE_AMP] = ACTIONS(2006),
    [anon_sym_AMP_AMP] = ACTIONS(2006),
    [anon_sym_PIPE_PIPE] = ACTIONS(2006),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2006),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2006),
    [anon_sym_LT_AMP] = ACTIONS(2006),
    [anon_sym_GT_AMP] = ACTIONS(2006),
    [sym__special_characters] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [anon_sym_DOLLAR] = ACTIONS(2008),
    [sym_raw_string] = ACTIONS(2006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2006),
    [anon_sym_BQUOTE] = ACTIONS(2006),
    [anon_sym_LT_LPAREN] = ACTIONS(2006),
    [anon_sym_GT_LPAREN] = ACTIONS(2006),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2006),
  },
  [780] = {
    [anon_sym_DQUOTE] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [sym__string_content] = ACTIONS(2658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2656),
    [anon_sym_BQUOTE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(177),
  },
  [781] = {
    [sym_concatenation] = STATE(1213),
    [sym_string] = STATE(1212),
    [sym_simple_expansion] = STATE(1212),
    [sym_string_expansion] = STATE(1212),
    [sym_expansion] = STATE(1212),
    [sym_command_substitution] = STATE(1212),
    [sym_process_substitution] = STATE(1212),
    [anon_sym_RBRACE] = ACTIONS(2660),
    [sym__special_characters] = ACTIONS(2662),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2664),
  },
  [782] = {
    [sym__concat] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [sym__string_content] = ACTIONS(1732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1734),
    [anon_sym_BQUOTE] = ACTIONS(1734),
    [sym_comment] = ACTIONS(177),
  },
  [783] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2666),
  },
  [784] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2668),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [785] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2670),
    [sym_comment] = ACTIONS(53),
  },
  [786] = {
    [sym_concatenation] = STATE(1219),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1219),
    [anon_sym_RBRACE] = ACTIONS(2672),
    [anon_sym_EQ] = ACTIONS(2674),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2676),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2678),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_COLON_QMARK] = ACTIONS(2674),
    [anon_sym_COLON_DASH] = ACTIONS(2674),
    [anon_sym_PERCENT] = ACTIONS(2674),
    [anon_sym_DASH] = ACTIONS(2674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [787] = {
    [sym_concatenation] = STATE(1222),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1222),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_EQ] = ACTIONS(2682),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2684),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2686),
    [anon_sym_COLON] = ACTIONS(2682),
    [anon_sym_COLON_QMARK] = ACTIONS(2682),
    [anon_sym_COLON_DASH] = ACTIONS(2682),
    [anon_sym_PERCENT] = ACTIONS(2682),
    [anon_sym_DASH] = ACTIONS(2682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [788] = {
    [sym_concatenation] = STATE(1224),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1224),
    [anon_sym_RBRACE] = ACTIONS(2660),
    [anon_sym_EQ] = ACTIONS(2688),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2692),
    [anon_sym_COLON] = ACTIONS(2688),
    [anon_sym_COLON_QMARK] = ACTIONS(2688),
    [anon_sym_COLON_DASH] = ACTIONS(2688),
    [anon_sym_PERCENT] = ACTIONS(2688),
    [anon_sym_DASH] = ACTIONS(2688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [789] = {
    [sym__concat] = ACTIONS(1798),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [sym__string_content] = ACTIONS(1798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1800),
    [anon_sym_BQUOTE] = ACTIONS(1800),
    [sym_comment] = ACTIONS(177),
  },
  [790] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2694),
  },
  [791] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2696),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [792] = {
    [sym__concat] = ACTIONS(1806),
    [anon_sym_DQUOTE] = ACTIONS(1808),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [sym__string_content] = ACTIONS(1806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1808),
    [anon_sym_BQUOTE] = ACTIONS(1808),
    [sym_comment] = ACTIONS(177),
  },
  [793] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2698),
  },
  [794] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2660),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [795] = {
    [sym__concat] = ACTIONS(1940),
    [anon_sym_DQUOTE] = ACTIONS(1942),
    [anon_sym_DOLLAR] = ACTIONS(1942),
    [sym__string_content] = ACTIONS(1940),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1942),
    [anon_sym_BQUOTE] = ACTIONS(1942),
    [sym_comment] = ACTIONS(177),
  },
  [796] = {
    [aux_sym_concatenation_repeat1] = STATE(555),
    [sym__concat] = ACTIONS(2700),
    [anon_sym_RBRACK] = ACTIONS(2702),
    [sym_comment] = ACTIONS(53),
  },
  [797] = {
    [aux_sym_concatenation_repeat1] = STATE(555),
    [sym__concat] = ACTIONS(2704),
    [anon_sym_RBRACK] = ACTIONS(2706),
    [sym_comment] = ACTIONS(53),
  },
  [798] = {
    [sym__concat] = ACTIONS(2708),
    [anon_sym_RBRACK] = ACTIONS(2706),
    [sym_comment] = ACTIONS(53),
  },
  [799] = {
    [sym__simple_heredoc_body] = ACTIONS(2710),
    [sym__heredoc_body_beginning] = ACTIONS(2710),
    [sym_file_descriptor] = ACTIONS(2710),
    [sym__concat] = ACTIONS(2710),
    [anon_sym_esac] = ACTIONS(2712),
    [anon_sym_PIPE] = ACTIONS(2712),
    [anon_sym_RPAREN] = ACTIONS(2712),
    [anon_sym_SEMI_SEMI] = ACTIONS(2712),
    [anon_sym_PIPE_AMP] = ACTIONS(2712),
    [anon_sym_AMP_AMP] = ACTIONS(2712),
    [anon_sym_PIPE_PIPE] = ACTIONS(2712),
    [anon_sym_EQ_TILDE] = ACTIONS(2712),
    [anon_sym_EQ_EQ] = ACTIONS(2712),
    [anon_sym_LT] = ACTIONS(2712),
    [anon_sym_GT] = ACTIONS(2712),
    [anon_sym_GT_GT] = ACTIONS(2712),
    [anon_sym_AMP_GT] = ACTIONS(2712),
    [anon_sym_AMP_GT_GT] = ACTIONS(2712),
    [anon_sym_LT_AMP] = ACTIONS(2712),
    [anon_sym_GT_AMP] = ACTIONS(2712),
    [anon_sym_LT_LT] = ACTIONS(2712),
    [anon_sym_LT_LT_DASH] = ACTIONS(2712),
    [anon_sym_LT_LT_LT] = ACTIONS(2712),
    [sym__special_characters] = ACTIONS(2712),
    [anon_sym_DQUOTE] = ACTIONS(2712),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [sym_raw_string] = ACTIONS(2712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2712),
    [anon_sym_BQUOTE] = ACTIONS(2712),
    [anon_sym_LT_LPAREN] = ACTIONS(2712),
    [anon_sym_GT_LPAREN] = ACTIONS(2712),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_LF] = ACTIONS(2710),
    [anon_sym_AMP] = ACTIONS(2712),
  },
  [800] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(2716),
    [sym_comment] = ACTIONS(53),
  },
  [801] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(1237),
    [anon_sym_DQUOTE] = ACTIONS(2718),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [802] = {
    [sym_string] = STATE(1239),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(2720),
    [sym_raw_string] = ACTIONS(2722),
    [anon_sym_POUND] = ACTIONS(2720),
    [anon_sym_DASH] = ACTIONS(2720),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2724),
    [anon_sym_STAR] = ACTIONS(2720),
    [anon_sym_AT] = ACTIONS(2720),
    [anon_sym_QMARK] = ACTIONS(2720),
    [anon_sym_0] = ACTIONS(2726),
    [anon_sym__] = ACTIONS(2726),
  },
  [803] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(2728),
    [sym_comment] = ACTIONS(53),
  },
  [804] = {
    [sym_subscript] = STATE(1246),
    [sym_variable_name] = ACTIONS(2730),
    [anon_sym_DOLLAR] = ACTIONS(2732),
    [anon_sym_POUND] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2732),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2736),
    [anon_sym_STAR] = ACTIONS(2732),
    [anon_sym_AT] = ACTIONS(2732),
    [anon_sym_QMARK] = ACTIONS(2732),
    [anon_sym_0] = ACTIONS(2738),
    [anon_sym__] = ACTIONS(2738),
  },
  [805] = {
    [sym_for_statement] = STATE(1247),
    [sym_while_statement] = STATE(1247),
    [sym_if_statement] = STATE(1247),
    [sym_case_statement] = STATE(1247),
    [sym_function_definition] = STATE(1247),
    [sym_subshell] = STATE(1247),
    [sym_pipeline] = STATE(1247),
    [sym_list] = STATE(1247),
    [sym_negated_command] = STATE(1247),
    [sym_test_command] = STATE(1247),
    [sym_declaration_command] = STATE(1247),
    [sym_unset_command] = STATE(1247),
    [sym_command] = STATE(1247),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(1248),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [806] = {
    [sym_for_statement] = STATE(1249),
    [sym_while_statement] = STATE(1249),
    [sym_if_statement] = STATE(1249),
    [sym_case_statement] = STATE(1249),
    [sym_function_definition] = STATE(1249),
    [sym_subshell] = STATE(1249),
    [sym_pipeline] = STATE(1249),
    [sym_list] = STATE(1249),
    [sym_negated_command] = STATE(1249),
    [sym_test_command] = STATE(1249),
    [sym_declaration_command] = STATE(1249),
    [sym_unset_command] = STATE(1249),
    [sym_command] = STATE(1249),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(1250),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [807] = {
    [sym_for_statement] = STATE(1251),
    [sym_while_statement] = STATE(1251),
    [sym_if_statement] = STATE(1251),
    [sym_case_statement] = STATE(1251),
    [sym_function_definition] = STATE(1251),
    [sym_subshell] = STATE(1251),
    [sym_pipeline] = STATE(1251),
    [sym_list] = STATE(1251),
    [sym_negated_command] = STATE(1251),
    [sym_test_command] = STATE(1251),
    [sym_declaration_command] = STATE(1251),
    [sym_unset_command] = STATE(1251),
    [sym_command] = STATE(1251),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(1252),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [808] = {
    [anon_sym_RBRACE] = ACTIONS(2728),
    [sym_comment] = ACTIONS(53),
  },
  [809] = {
    [sym_string] = STATE(1253),
    [sym_simple_expansion] = STATE(1253),
    [sym_string_expansion] = STATE(1253),
    [sym_expansion] = STATE(1253),
    [sym_command_substitution] = STATE(1253),
    [sym_process_substitution] = STATE(1253),
    [sym__special_characters] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(2740),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2740),
  },
  [810] = {
    [aux_sym_concatenation_repeat1] = STATE(1254),
    [sym__concat] = ACTIONS(1736),
    [anon_sym_RBRACE] = ACTIONS(693),
    [anon_sym_EQ] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_POUND] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_COLON] = ACTIONS(695),
    [anon_sym_COLON_QMARK] = ACTIONS(695),
    [anon_sym_COLON_DASH] = ACTIONS(695),
    [anon_sym_PERCENT] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
  },
  [811] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(697),
    [anon_sym_EQ] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(697),
    [anon_sym_POUND] = ACTIONS(697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(697),
    [anon_sym_COLON] = ACTIONS(699),
    [anon_sym_COLON_QMARK] = ACTIONS(699),
    [anon_sym_COLON_DASH] = ACTIONS(699),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [anon_sym_LT_LPAREN] = ACTIONS(697),
    [anon_sym_GT_LPAREN] = ACTIONS(697),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(699),
  },
  [812] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(2742),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [813] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_RBRACE] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(727),
    [anon_sym_POUND] = ACTIONS(727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(727),
    [anon_sym_COLON] = ACTIONS(729),
    [anon_sym_COLON_QMARK] = ACTIONS(729),
    [anon_sym_COLON_DASH] = ACTIONS(729),
    [anon_sym_PERCENT] = ACTIONS(729),
    [anon_sym_DASH] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(727),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [anon_sym_LT_LPAREN] = ACTIONS(727),
    [anon_sym_GT_LPAREN] = ACTIONS(727),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(729),
  },
  [814] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_POUND] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_COLON] = ACTIONS(733),
    [anon_sym_COLON_QMARK] = ACTIONS(733),
    [anon_sym_COLON_DASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(733),
  },
  [815] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_POUND] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_COLON] = ACTIONS(737),
    [anon_sym_COLON_QMARK] = ACTIONS(737),
    [anon_sym_COLON_DASH] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_DASH] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(737),
  },
  [816] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2744),
    [sym_comment] = ACTIONS(53),
  },
  [817] = {
    [sym_concatenation] = STATE(1259),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1259),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_EQ] = ACTIONS(2748),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2752),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_COLON_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_DASH] = ACTIONS(2748),
    [anon_sym_PERCENT] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [818] = {
    [sym_subscript] = STATE(1263),
    [sym_variable_name] = ACTIONS(2754),
    [anon_sym_DOLLAR] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2758),
    [anon_sym_STAR] = ACTIONS(2756),
    [anon_sym_AT] = ACTIONS(2756),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_0] = ACTIONS(2760),
    [anon_sym__] = ACTIONS(2760),
  },
  [819] = {
    [sym_concatenation] = STATE(1266),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1266),
    [anon_sym_RBRACE] = ACTIONS(2762),
    [anon_sym_EQ] = ACTIONS(2764),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2766),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2768),
    [anon_sym_COLON] = ACTIONS(2764),
    [anon_sym_COLON_QMARK] = ACTIONS(2764),
    [anon_sym_COLON_DASH] = ACTIONS(2764),
    [anon_sym_PERCENT] = ACTIONS(2764),
    [anon_sym_DASH] = ACTIONS(2764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [820] = {
    [sym_concatenation] = STATE(1269),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1269),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2774),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2776),
    [anon_sym_COLON] = ACTIONS(2772),
    [anon_sym_COLON_QMARK] = ACTIONS(2772),
    [anon_sym_COLON_DASH] = ACTIONS(2772),
    [anon_sym_PERCENT] = ACTIONS(2772),
    [anon_sym_DASH] = ACTIONS(2772),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [821] = {
    [sym_concatenation] = STATE(1271),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1271),
    [anon_sym_RBRACE] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2780),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2782),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(2780),
    [anon_sym_COLON_QMARK] = ACTIONS(2780),
    [anon_sym_COLON_DASH] = ACTIONS(2780),
    [anon_sym_PERCENT] = ACTIONS(2780),
    [anon_sym_DASH] = ACTIONS(2780),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [822] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2784),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [823] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2784),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [824] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(2784),
    [sym_comment] = ACTIONS(53),
  },
  [825] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(2784),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [826] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2786),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [827] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2786),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [828] = {
    [sym__simple_heredoc_body] = ACTIONS(2788),
    [sym__heredoc_body_beginning] = ACTIONS(2788),
    [sym_file_descriptor] = ACTIONS(2788),
    [sym__concat] = ACTIONS(2788),
    [anon_sym_esac] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_RPAREN] = ACTIONS(2790),
    [anon_sym_SEMI_SEMI] = ACTIONS(2790),
    [anon_sym_PIPE_AMP] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2790),
    [anon_sym_PIPE_PIPE] = ACTIONS(2790),
    [anon_sym_EQ_TILDE] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_AMP_GT] = ACTIONS(2790),
    [anon_sym_AMP_GT_GT] = ACTIONS(2790),
    [anon_sym_LT_AMP] = ACTIONS(2790),
    [anon_sym_GT_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_LT_LT_DASH] = ACTIONS(2790),
    [anon_sym_LT_LT_LT] = ACTIONS(2790),
    [sym__special_characters] = ACTIONS(2790),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym_raw_string] = ACTIONS(2790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2790),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [anon_sym_LT_LPAREN] = ACTIONS(2790),
    [anon_sym_GT_LPAREN] = ACTIONS(2790),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2790),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_LF] = ACTIONS(2788),
    [anon_sym_AMP] = ACTIONS(2790),
  },
  [829] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2792),
    [anon_sym_EQ] = ACTIONS(2794),
    [sym__special_characters] = ACTIONS(2797),
    [anon_sym_DQUOTE] = ACTIONS(2800),
    [anon_sym_DOLLAR] = ACTIONS(2803),
    [sym_raw_string] = ACTIONS(2806),
    [anon_sym_POUND] = ACTIONS(2809),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2812),
    [anon_sym_COLON] = ACTIONS(2794),
    [anon_sym_COLON_QMARK] = ACTIONS(2794),
    [anon_sym_COLON_DASH] = ACTIONS(2794),
    [anon_sym_PERCENT] = ACTIONS(2794),
    [anon_sym_DASH] = ACTIONS(2794),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2815),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [anon_sym_LT_LPAREN] = ACTIONS(2821),
    [anon_sym_GT_LPAREN] = ACTIONS(2821),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2824),
  },
  [830] = {
    [sym_concatenation] = STATE(1276),
    [sym_string] = STATE(1275),
    [sym_simple_expansion] = STATE(1275),
    [sym_string_expansion] = STATE(1275),
    [sym_expansion] = STATE(1275),
    [sym_command_substitution] = STATE(1275),
    [sym_process_substitution] = STATE(1275),
    [anon_sym_RBRACE] = ACTIONS(2728),
    [sym__special_characters] = ACTIONS(2827),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(2829),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2829),
  },
  [831] = {
    [sym__simple_heredoc_body] = ACTIONS(2831),
    [sym__heredoc_body_beginning] = ACTIONS(2831),
    [sym_file_descriptor] = ACTIONS(2831),
    [sym__concat] = ACTIONS(2831),
    [anon_sym_esac] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2833),
    [anon_sym_SEMI_SEMI] = ACTIONS(2833),
    [anon_sym_PIPE_AMP] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [anon_sym_EQ_TILDE] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_AMP_GT] = ACTIONS(2833),
    [anon_sym_AMP_GT_GT] = ACTIONS(2833),
    [anon_sym_LT_AMP] = ACTIONS(2833),
    [anon_sym_GT_AMP] = ACTIONS(2833),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_DASH] = ACTIONS(2833),
    [anon_sym_LT_LT_LT] = ACTIONS(2833),
    [sym__special_characters] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [sym_raw_string] = ACTIONS(2833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2833),
    [anon_sym_BQUOTE] = ACTIONS(2833),
    [anon_sym_LT_LPAREN] = ACTIONS(2833),
    [anon_sym_GT_LPAREN] = ACTIONS(2833),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2831),
    [anon_sym_AMP] = ACTIONS(2833),
  },
  [832] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2835),
  },
  [833] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [834] = {
    [sym__simple_heredoc_body] = ACTIONS(2839),
    [sym__heredoc_body_beginning] = ACTIONS(2839),
    [sym_file_descriptor] = ACTIONS(2839),
    [sym__concat] = ACTIONS(2839),
    [anon_sym_esac] = ACTIONS(2841),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_RPAREN] = ACTIONS(2841),
    [anon_sym_SEMI_SEMI] = ACTIONS(2841),
    [anon_sym_PIPE_AMP] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [anon_sym_EQ_TILDE] = ACTIONS(2841),
    [anon_sym_EQ_EQ] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_GT] = ACTIONS(2841),
    [anon_sym_GT_GT] = ACTIONS(2841),
    [anon_sym_AMP_GT] = ACTIONS(2841),
    [anon_sym_AMP_GT_GT] = ACTIONS(2841),
    [anon_sym_LT_AMP] = ACTIONS(2841),
    [anon_sym_GT_AMP] = ACTIONS(2841),
    [anon_sym_LT_LT] = ACTIONS(2841),
    [anon_sym_LT_LT_DASH] = ACTIONS(2841),
    [anon_sym_LT_LT_LT] = ACTIONS(2841),
    [sym__special_characters] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2841),
    [sym_raw_string] = ACTIONS(2841),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2841),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2841),
    [anon_sym_BQUOTE] = ACTIONS(2841),
    [anon_sym_LT_LPAREN] = ACTIONS(2841),
    [anon_sym_GT_LPAREN] = ACTIONS(2841),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2839),
    [anon_sym_AMP] = ACTIONS(2841),
  },
  [835] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2843),
  },
  [836] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2845),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [837] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2847),
  },
  [838] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(2728),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [839] = {
    [sym_concatenation] = STATE(1283),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1283),
    [anon_sym_RBRACE] = ACTIONS(2849),
    [anon_sym_EQ] = ACTIONS(2851),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2853),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_COLON_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_DASH] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [840] = {
    [sym__simple_heredoc_body] = ACTIONS(2855),
    [sym__heredoc_body_beginning] = ACTIONS(2855),
    [sym_file_descriptor] = ACTIONS(2855),
    [sym__concat] = ACTIONS(2855),
    [anon_sym_esac] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2857),
    [anon_sym_SEMI_SEMI] = ACTIONS(2857),
    [anon_sym_PIPE_AMP] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2857),
    [anon_sym_EQ_TILDE] = ACTIONS(2857),
    [anon_sym_EQ_EQ] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT_GT] = ACTIONS(2857),
    [anon_sym_LT_AMP] = ACTIONS(2857),
    [anon_sym_GT_AMP] = ACTIONS(2857),
    [anon_sym_LT_LT] = ACTIONS(2857),
    [anon_sym_LT_LT_DASH] = ACTIONS(2857),
    [anon_sym_LT_LT_LT] = ACTIONS(2857),
    [sym__special_characters] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2857),
    [anon_sym_BQUOTE] = ACTIONS(2857),
    [anon_sym_LT_LPAREN] = ACTIONS(2857),
    [anon_sym_GT_LPAREN] = ACTIONS(2857),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [841] = {
    [sym_concatenation] = STATE(1285),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1285),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2861),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2863),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(2861),
    [anon_sym_COLON_QMARK] = ACTIONS(2861),
    [anon_sym_COLON_DASH] = ACTIONS(2861),
    [anon_sym_PERCENT] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [842] = {
    [aux_sym_concatenation_repeat1] = STATE(1286),
    [sym_file_descriptor] = ACTIONS(1129),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(1129),
    [anon_sym_PIPE_AMP] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT_GT] = ACTIONS(1129),
    [anon_sym_LT_AMP] = ACTIONS(1129),
    [anon_sym_GT_AMP] = ACTIONS(1129),
    [sym__special_characters] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1129),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [anon_sym_LT_LPAREN] = ACTIONS(1129),
    [anon_sym_GT_LPAREN] = ACTIONS(1129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1129),
  },
  [843] = {
    [aux_sym_concatenation_repeat1] = STATE(1286),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1107),
  },
  [844] = {
    [sym_concatenation] = STATE(1287),
    [sym_string] = STATE(588),
    [sym_simple_expansion] = STATE(588),
    [sym_string_expansion] = STATE(588),
    [sym_expansion] = STATE(588),
    [sym_command_substitution] = STATE(588),
    [sym_process_substitution] = STATE(588),
    [aux_sym_for_statement_repeat1] = STATE(1287),
    [sym__special_characters] = ACTIONS(1155),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [anon_sym_DOLLAR] = ACTIONS(71),
    [sym_raw_string] = ACTIONS(1157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(75),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(77),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1157),
  },
  [845] = {
    [sym_do_group] = STATE(1289),
    [anon_sym_do] = ACTIONS(2865),
    [sym_comment] = ACTIONS(53),
  },
  [846] = {
    [sym__terminated_statement] = STATE(1291),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1291),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [847] = {
    [sym_file_redirect] = STATE(1293),
    [sym_heredoc_redirect] = STATE(1293),
    [sym_heredoc_body] = STATE(1292),
    [sym_herestring_redirect] = STATE(1293),
    [aux_sym_while_statement_repeat1] = STATE(1293),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(1163),
    [anon_sym_RPAREN] = ACTIONS(1165),
    [anon_sym_PIPE_AMP] = ACTIONS(1165),
    [anon_sym_AMP_AMP] = ACTIONS(1165),
    [anon_sym_PIPE_PIPE] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym_comment] = ACTIONS(53),
  },
  [848] = {
    [sym__terminated_statement] = STATE(1296),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_elif_clause] = STATE(599),
    [sym_else_clause] = STATE(1295),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1296),
    [aux_sym_if_statement_repeat1] = STATE(1297),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(2869),
    [anon_sym_elif] = ACTIONS(1169),
    [anon_sym_else] = ACTIONS(1171),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [849] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2871),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2871),
  },
  [850] = {
    [anon_sym_in] = ACTIONS(2875),
    [sym_comment] = ACTIONS(53),
  },
  [851] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2877),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym_LF] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
  },
  [852] = {
    [anon_sym_in] = ACTIONS(2881),
    [sym_comment] = ACTIONS(53),
  },
  [853] = {
    [anon_sym_RPAREN] = ACTIONS(2883),
    [sym_comment] = ACTIONS(53),
  },
  [854] = {
    [sym__terminated_statement] = STATE(1304),
    [sym_for_statement] = STATE(628),
    [sym_while_statement] = STATE(628),
    [sym_if_statement] = STATE(628),
    [sym_case_statement] = STATE(628),
    [sym_function_definition] = STATE(628),
    [sym_subshell] = STATE(628),
    [sym_pipeline] = STATE(628),
    [sym_list] = STATE(628),
    [sym_negated_command] = STATE(628),
    [sym_test_command] = STATE(628),
    [sym_declaration_command] = STATE(628),
    [sym_unset_command] = STATE(628),
    [sym_command] = STATE(628),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(629),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1304),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [855] = {
    [sym_file_redirect] = STATE(1307),
    [sym_file_descriptor] = ACTIONS(2887),
    [anon_sym_PIPE] = ACTIONS(1233),
    [anon_sym_RPAREN] = ACTIONS(1237),
    [anon_sym_PIPE_AMP] = ACTIONS(1237),
    [anon_sym_AMP_AMP] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_GT_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT] = ACTIONS(2889),
    [anon_sym_AMP_GT_GT] = ACTIONS(2891),
    [anon_sym_LT_AMP] = ACTIONS(2891),
    [anon_sym_GT_AMP] = ACTIONS(2891),
    [sym_comment] = ACTIONS(53),
  },
  [856] = {
    [anon_sym_PIPE] = ACTIONS(1251),
    [anon_sym_RPAREN] = ACTIONS(1253),
    [anon_sym_PIPE_AMP] = ACTIONS(1253),
    [anon_sym_AMP_AMP] = ACTIONS(1253),
    [anon_sym_PIPE_PIPE] = ACTIONS(1253),
    [anon_sym_BQUOTE] = ACTIONS(1253),
    [sym_comment] = ACTIONS(53),
  },
  [857] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_RPAREN] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [858] = {
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_SEMI_SEMI] = ACTIONS(2897),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym_LF] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2897),
  },
  [859] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_SEMI_SEMI] = ACTIONS(2897),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym_LF] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2897),
  },
  [860] = {
    [sym_file_redirect] = STATE(1314),
    [sym_heredoc_redirect] = STATE(1314),
    [sym_herestring_redirect] = STATE(1314),
    [aux_sym_while_statement_repeat1] = STATE(1314),
    [sym_file_descriptor] = ACTIONS(2901),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_RPAREN] = ACTIONS(1349),
    [anon_sym_PIPE_AMP] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_GT_GT] = ACTIONS(2905),
    [anon_sym_AMP_GT] = ACTIONS(2903),
    [anon_sym_AMP_GT_GT] = ACTIONS(2905),
    [anon_sym_LT_AMP] = ACTIONS(2905),
    [anon_sym_GT_AMP] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2907),
    [anon_sym_LT_LT_DASH] = ACTIONS(2909),
    [anon_sym_LT_LT_LT] = ACTIONS(2911),
    [sym_comment] = ACTIONS(53),
  },
  [861] = {
    [sym_concatenation] = STATE(1315),
    [sym_string] = STATE(1318),
    [sym_array] = STATE(1315),
    [sym_simple_expansion] = STATE(1318),
    [sym_string_expansion] = STATE(1318),
    [sym_expansion] = STATE(1318),
    [sym_command_substitution] = STATE(1318),
    [sym_process_substitution] = STATE(1318),
    [sym__empty_value] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [sym__special_characters] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(2919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(819),
    [anon_sym_GT_LPAREN] = ACTIONS(819),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2919),
  },
  [862] = {
    [sym_string] = STATE(1319),
    [sym_simple_expansion] = STATE(1319),
    [sym_string_expansion] = STATE(1319),
    [sym_expansion] = STATE(1319),
    [sym_command_substitution] = STATE(1319),
    [sym_process_substitution] = STATE(1319),
    [sym__special_characters] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(2921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(819),
    [anon_sym_GT_LPAREN] = ACTIONS(819),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2921),
  },
  [863] = {
    [aux_sym_concatenation_repeat1] = STATE(1320),
    [sym__concat] = ACTIONS(1852),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
  },
  [864] = {
    [sym__concat] = ACTIONS(697),
    [sym_variable_name] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_PIPE_AMP] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [sym__special_characters] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [anon_sym_LT_LPAREN] = ACTIONS(697),
    [anon_sym_GT_LPAREN] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(699),
    [sym_word] = ACTIONS(699),
  },
  [865] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(2923),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [866] = {
    [sym__concat] = ACTIONS(727),
    [sym_variable_name] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(727),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(727),
    [anon_sym_PIPE_PIPE] = ACTIONS(727),
    [sym__special_characters] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(727),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [anon_sym_LT_LPAREN] = ACTIONS(727),
    [anon_sym_GT_LPAREN] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(729),
    [sym_word] = ACTIONS(729),
  },
  [867] = {
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
  },
  [868] = {
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
  },
  [869] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2925),
    [sym_comment] = ACTIONS(53),
  },
  [870] = {
    [sym_concatenation] = STATE(1325),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1325),
    [anon_sym_RBRACE] = ACTIONS(2927),
    [anon_sym_EQ] = ACTIONS(2929),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2931),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2933),
    [anon_sym_COLON] = ACTIONS(2929),
    [anon_sym_COLON_QMARK] = ACTIONS(2929),
    [anon_sym_COLON_DASH] = ACTIONS(2929),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [871] = {
    [sym_subscript] = STATE(1329),
    [sym_variable_name] = ACTIONS(2935),
    [anon_sym_DOLLAR] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2937),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2939),
    [anon_sym_STAR] = ACTIONS(2937),
    [anon_sym_AT] = ACTIONS(2937),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_0] = ACTIONS(2941),
    [anon_sym__] = ACTIONS(2941),
  },
  [872] = {
    [sym_concatenation] = STATE(1332),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1332),
    [anon_sym_RBRACE] = ACTIONS(2943),
    [anon_sym_EQ] = ACTIONS(2945),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2949),
    [anon_sym_COLON] = ACTIONS(2945),
    [anon_sym_COLON_QMARK] = ACTIONS(2945),
    [anon_sym_COLON_DASH] = ACTIONS(2945),
    [anon_sym_PERCENT] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [873] = {
    [sym_concatenation] = STATE(1335),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1335),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [anon_sym_EQ] = ACTIONS(2953),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2957),
    [anon_sym_COLON] = ACTIONS(2953),
    [anon_sym_COLON_QMARK] = ACTIONS(2953),
    [anon_sym_COLON_DASH] = ACTIONS(2953),
    [anon_sym_PERCENT] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(2953),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [874] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [875] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [876] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(2959),
    [sym_comment] = ACTIONS(53),
  },
  [877] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(2959),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [878] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2961),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [879] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2961),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [880] = {
    [sym_variable_assignment] = STATE(880),
    [sym_subscript] = STATE(454),
    [sym_concatenation] = STATE(880),
    [sym_string] = STATE(448),
    [sym_simple_expansion] = STATE(448),
    [sym_string_expansion] = STATE(448),
    [sym_expansion] = STATE(448),
    [sym_command_substitution] = STATE(448),
    [sym_process_substitution] = STATE(448),
    [aux_sym_declaration_command_repeat1] = STATE(880),
    [sym_variable_name] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_RPAREN] = ACTIONS(1517),
    [anon_sym_PIPE_AMP] = ACTIONS(1517),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [sym__special_characters] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2969),
    [anon_sym_DOLLAR] = ACTIONS(2972),
    [sym_raw_string] = ACTIONS(2975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2978),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2981),
    [anon_sym_BQUOTE] = ACTIONS(2984),
    [anon_sym_LT_LPAREN] = ACTIONS(2987),
    [anon_sym_GT_LPAREN] = ACTIONS(2987),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2990),
    [sym_word] = ACTIONS(2993),
  },
  [881] = {
    [sym_string] = STATE(1338),
    [sym_simple_expansion] = STATE(1338),
    [sym_string_expansion] = STATE(1338),
    [sym_expansion] = STATE(1338),
    [sym_command_substitution] = STATE(1338),
    [sym_process_substitution] = STATE(1338),
    [sym__special_characters] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(2996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2996),
  },
  [882] = {
    [aux_sym_concatenation_repeat1] = STATE(1339),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
  },
  [883] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_PIPE_AMP] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [sym__special_characters] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [anon_sym_LT_LPAREN] = ACTIONS(697),
    [anon_sym_GT_LPAREN] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(699),
    [sym_word] = ACTIONS(699),
  },
  [884] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(2998),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [885] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(727),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(727),
    [anon_sym_PIPE_PIPE] = ACTIONS(727),
    [sym__special_characters] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(727),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [anon_sym_LT_LPAREN] = ACTIONS(727),
    [anon_sym_GT_LPAREN] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(729),
    [sym_word] = ACTIONS(729),
  },
  [886] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
  },
  [887] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
  },
  [888] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(3000),
    [sym_comment] = ACTIONS(53),
  },
  [889] = {
    [sym_concatenation] = STATE(1344),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1344),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_EQ] = ACTIONS(3004),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3008),
    [anon_sym_COLON] = ACTIONS(3004),
    [anon_sym_COLON_QMARK] = ACTIONS(3004),
    [anon_sym_COLON_DASH] = ACTIONS(3004),
    [anon_sym_PERCENT] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3004),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [890] = {
    [sym_subscript] = STATE(1348),
    [sym_variable_name] = ACTIONS(3010),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3014),
    [anon_sym_STAR] = ACTIONS(3012),
    [anon_sym_AT] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_0] = ACTIONS(3016),
    [anon_sym__] = ACTIONS(3016),
  },
  [891] = {
    [sym_concatenation] = STATE(1351),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1351),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_EQ] = ACTIONS(3020),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3022),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3024),
    [anon_sym_COLON] = ACTIONS(3020),
    [anon_sym_COLON_QMARK] = ACTIONS(3020),
    [anon_sym_COLON_DASH] = ACTIONS(3020),
    [anon_sym_PERCENT] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [892] = {
    [sym_concatenation] = STATE(1354),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1354),
    [anon_sym_RBRACE] = ACTIONS(3026),
    [anon_sym_EQ] = ACTIONS(3028),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3032),
    [anon_sym_COLON] = ACTIONS(3028),
    [anon_sym_COLON_QMARK] = ACTIONS(3028),
    [anon_sym_COLON_DASH] = ACTIONS(3028),
    [anon_sym_PERCENT] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [893] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3034),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [894] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3034),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [895] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3034),
    [sym_comment] = ACTIONS(53),
  },
  [896] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(3034),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [897] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [898] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [899] = {
    [sym_concatenation] = STATE(899),
    [sym_string] = STATE(459),
    [sym_simple_expansion] = STATE(459),
    [sym_string_expansion] = STATE(459),
    [sym_expansion] = STATE(459),
    [sym_command_substitution] = STATE(459),
    [sym_process_substitution] = STATE(459),
    [aux_sym_unset_command_repeat1] = STATE(899),
    [anon_sym_PIPE] = ACTIONS(1569),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [anon_sym_PIPE_AMP] = ACTIONS(1598),
    [anon_sym_AMP_AMP] = ACTIONS(1598),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [sym__special_characters] = ACTIONS(3038),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [anon_sym_DOLLAR] = ACTIONS(3044),
    [sym_raw_string] = ACTIONS(3047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3050),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3053),
    [anon_sym_BQUOTE] = ACTIONS(3056),
    [anon_sym_LT_LPAREN] = ACTIONS(3059),
    [anon_sym_GT_LPAREN] = ACTIONS(3059),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3062),
    [sym_word] = ACTIONS(3065),
  },
  [900] = {
    [sym__simple_heredoc_body] = ACTIONS(1642),
    [sym__heredoc_body_beginning] = ACTIONS(1642),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_EQ_TILDE] = ACTIONS(1644),
    [anon_sym_EQ_EQ] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1642),
    [anon_sym_LT_LT_LT] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1644),
  },
  [901] = {
    [aux_sym_concatenation_repeat1] = STATE(901),
    [sym__simple_heredoc_body] = ACTIONS(1642),
    [sym__heredoc_body_beginning] = ACTIONS(1642),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(3068),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_EQ_TILDE] = ACTIONS(1644),
    [anon_sym_EQ_EQ] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1642),
    [anon_sym_LT_LT_LT] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1644),
  },
  [902] = {
    [sym__simple_heredoc_body] = ACTIONS(1691),
    [sym__heredoc_body_beginning] = ACTIONS(1691),
    [sym_file_descriptor] = ACTIONS(1691),
    [sym__concat] = ACTIONS(1691),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_RPAREN] = ACTIONS(1691),
    [anon_sym_PIPE_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1691),
    [anon_sym_PIPE_PIPE] = ACTIONS(1691),
    [anon_sym_EQ_TILDE] = ACTIONS(1693),
    [anon_sym_EQ_EQ] = ACTIONS(1693),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1691),
    [anon_sym_AMP_GT] = ACTIONS(1693),
    [anon_sym_AMP_GT_GT] = ACTIONS(1691),
    [anon_sym_LT_AMP] = ACTIONS(1691),
    [anon_sym_GT_AMP] = ACTIONS(1691),
    [anon_sym_LT_LT] = ACTIONS(1693),
    [anon_sym_LT_LT_DASH] = ACTIONS(1691),
    [anon_sym_LT_LT_LT] = ACTIONS(1691),
    [sym__special_characters] = ACTIONS(1691),
    [anon_sym_DQUOTE] = ACTIONS(1691),
    [anon_sym_DOLLAR] = ACTIONS(1693),
    [sym_raw_string] = ACTIONS(1691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1691),
    [anon_sym_BQUOTE] = ACTIONS(1691),
    [anon_sym_LT_LPAREN] = ACTIONS(1691),
    [anon_sym_GT_LPAREN] = ACTIONS(1691),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1693),
  },
  [903] = {
    [sym_concatenation] = STATE(1360),
    [sym_string] = STATE(1359),
    [sym_simple_expansion] = STATE(1359),
    [sym_string_expansion] = STATE(1359),
    [sym_expansion] = STATE(1359),
    [sym_command_substitution] = STATE(1359),
    [sym_process_substitution] = STATE(1359),
    [anon_sym_RBRACE] = ACTIONS(3071),
    [sym__special_characters] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(3075),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3075),
  },
  [904] = {
    [sym__simple_heredoc_body] = ACTIONS(1732),
    [sym__heredoc_body_beginning] = ACTIONS(1732),
    [sym_file_descriptor] = ACTIONS(1732),
    [sym__concat] = ACTIONS(1732),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [anon_sym_PIPE_AMP] = ACTIONS(1732),
    [anon_sym_AMP_AMP] = ACTIONS(1732),
    [anon_sym_PIPE_PIPE] = ACTIONS(1732),
    [anon_sym_EQ_TILDE] = ACTIONS(1734),
    [anon_sym_EQ_EQ] = ACTIONS(1734),
    [anon_sym_LT] = ACTIONS(1734),
    [anon_sym_GT] = ACTIONS(1734),
    [anon_sym_GT_GT] = ACTIONS(1732),
    [anon_sym_AMP_GT] = ACTIONS(1734),
    [anon_sym_AMP_GT_GT] = ACTIONS(1732),
    [anon_sym_LT_AMP] = ACTIONS(1732),
    [anon_sym_GT_AMP] = ACTIONS(1732),
    [anon_sym_LT_LT] = ACTIONS(1734),
    [anon_sym_LT_LT_DASH] = ACTIONS(1732),
    [anon_sym_LT_LT_LT] = ACTIONS(1732),
    [sym__special_characters] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1732),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [sym_raw_string] = ACTIONS(1732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1732),
    [anon_sym_BQUOTE] = ACTIONS(1732),
    [anon_sym_LT_LPAREN] = ACTIONS(1732),
    [anon_sym_GT_LPAREN] = ACTIONS(1732),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1734),
  },
  [905] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3077),
  },
  [906] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [907] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(3081),
    [sym_comment] = ACTIONS(53),
  },
  [908] = {
    [sym_concatenation] = STATE(1366),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1366),
    [anon_sym_RBRACE] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3085),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3089),
    [anon_sym_COLON] = ACTIONS(3085),
    [anon_sym_COLON_QMARK] = ACTIONS(3085),
    [anon_sym_COLON_DASH] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_DASH] = ACTIONS(3085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [909] = {
    [sym_concatenation] = STATE(1369),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1369),
    [anon_sym_RBRACE] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(3093),
    [anon_sym_COLON_QMARK] = ACTIONS(3093),
    [anon_sym_COLON_DASH] = ACTIONS(3093),
    [anon_sym_PERCENT] = ACTIONS(3093),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [910] = {
    [sym_concatenation] = STATE(1371),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1371),
    [anon_sym_RBRACE] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3099),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3103),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_COLON_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_DASH] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [911] = {
    [sym__simple_heredoc_body] = ACTIONS(1798),
    [sym__heredoc_body_beginning] = ACTIONS(1798),
    [sym_file_descriptor] = ACTIONS(1798),
    [sym__concat] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1798),
    [anon_sym_PIPE_AMP] = ACTIONS(1798),
    [anon_sym_AMP_AMP] = ACTIONS(1798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1798),
    [anon_sym_EQ_TILDE] = ACTIONS(1800),
    [anon_sym_EQ_EQ] = ACTIONS(1800),
    [anon_sym_LT] = ACTIONS(1800),
    [anon_sym_GT] = ACTIONS(1800),
    [anon_sym_GT_GT] = ACTIONS(1798),
    [anon_sym_AMP_GT] = ACTIONS(1800),
    [anon_sym_AMP_GT_GT] = ACTIONS(1798),
    [anon_sym_LT_AMP] = ACTIONS(1798),
    [anon_sym_GT_AMP] = ACTIONS(1798),
    [anon_sym_LT_LT] = ACTIONS(1800),
    [anon_sym_LT_LT_DASH] = ACTIONS(1798),
    [anon_sym_LT_LT_LT] = ACTIONS(1798),
    [sym__special_characters] = ACTIONS(1798),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [sym_raw_string] = ACTIONS(1798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1798),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1798),
    [anon_sym_BQUOTE] = ACTIONS(1798),
    [anon_sym_LT_LPAREN] = ACTIONS(1798),
    [anon_sym_GT_LPAREN] = ACTIONS(1798),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1800),
  },
  [912] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3105),
  },
  [913] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [914] = {
    [sym__simple_heredoc_body] = ACTIONS(1806),
    [sym__heredoc_body_beginning] = ACTIONS(1806),
    [sym_file_descriptor] = ACTIONS(1806),
    [sym__concat] = ACTIONS(1806),
    [anon_sym_PIPE] = ACTIONS(1808),
    [anon_sym_RPAREN] = ACTIONS(1806),
    [anon_sym_PIPE_AMP] = ACTIONS(1806),
    [anon_sym_AMP_AMP] = ACTIONS(1806),
    [anon_sym_PIPE_PIPE] = ACTIONS(1806),
    [anon_sym_EQ_TILDE] = ACTIONS(1808),
    [anon_sym_EQ_EQ] = ACTIONS(1808),
    [anon_sym_LT] = ACTIONS(1808),
    [anon_sym_GT] = ACTIONS(1808),
    [anon_sym_GT_GT] = ACTIONS(1806),
    [anon_sym_AMP_GT] = ACTIONS(1808),
    [anon_sym_AMP_GT_GT] = ACTIONS(1806),
    [anon_sym_LT_AMP] = ACTIONS(1806),
    [anon_sym_GT_AMP] = ACTIONS(1806),
    [anon_sym_LT_LT] = ACTIONS(1808),
    [anon_sym_LT_LT_DASH] = ACTIONS(1806),
    [anon_sym_LT_LT_LT] = ACTIONS(1806),
    [sym__special_characters] = ACTIONS(1806),
    [anon_sym_DQUOTE] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [sym_raw_string] = ACTIONS(1806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1806),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1806),
    [anon_sym_BQUOTE] = ACTIONS(1806),
    [anon_sym_LT_LPAREN] = ACTIONS(1806),
    [anon_sym_GT_LPAREN] = ACTIONS(1806),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1808),
  },
  [915] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3109),
  },
  [916] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [917] = {
    [sym__simple_heredoc_body] = ACTIONS(1940),
    [sym__heredoc_body_beginning] = ACTIONS(1940),
    [sym_file_descriptor] = ACTIONS(1940),
    [sym__concat] = ACTIONS(1940),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_EQ_TILDE] = ACTIONS(1942),
    [anon_sym_EQ_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1940),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1940),
    [anon_sym_LT_AMP] = ACTIONS(1940),
    [anon_sym_GT_AMP] = ACTIONS(1940),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_LT_LT_DASH] = ACTIONS(1940),
    [anon_sym_LT_LT_LT] = ACTIONS(1940),
    [sym__special_characters] = ACTIONS(1940),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [anon_sym_DOLLAR] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1940),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1940),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1940),
    [anon_sym_BQUOTE] = ACTIONS(1940),
    [anon_sym_LT_LPAREN] = ACTIONS(1940),
    [anon_sym_GT_LPAREN] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1942),
  },
  [918] = {
    [sym__simple_heredoc_body] = ACTIONS(2006),
    [sym__heredoc_body_beginning] = ACTIONS(2006),
    [sym_file_descriptor] = ACTIONS(2006),
    [sym__concat] = ACTIONS(2006),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_RPAREN] = ACTIONS(2006),
    [anon_sym_PIPE_AMP] = ACTIONS(2006),
    [anon_sym_AMP_AMP] = ACTIONS(2006),
    [anon_sym_PIPE_PIPE] = ACTIONS(2006),
    [anon_sym_EQ_TILDE] = ACTIONS(2008),
    [anon_sym_EQ_EQ] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2006),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2006),
    [anon_sym_LT_AMP] = ACTIONS(2006),
    [anon_sym_GT_AMP] = ACTIONS(2006),
    [anon_sym_LT_LT] = ACTIONS(2008),
    [anon_sym_LT_LT_DASH] = ACTIONS(2006),
    [anon_sym_LT_LT_LT] = ACTIONS(2006),
    [sym__special_characters] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [anon_sym_DOLLAR] = ACTIONS(2008),
    [sym_raw_string] = ACTIONS(2006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2006),
    [anon_sym_BQUOTE] = ACTIONS(2006),
    [anon_sym_LT_LPAREN] = ACTIONS(2006),
    [anon_sym_GT_LPAREN] = ACTIONS(2006),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2008),
  },
  [919] = {
    [sym_compound_statement] = STATE(1375),
    [anon_sym_LBRACE] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
  },
  [920] = {
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_RPAREN] = ACTIONS(2012),
    [anon_sym_PIPE_AMP] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_BQUOTE] = ACTIONS(2012),
    [sym_comment] = ACTIONS(53),
  },
  [921] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_RPAREN] = ACTIONS(2012),
    [anon_sym_PIPE_AMP] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [922] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2016),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(2016),
    [anon_sym_PIPE_PIPE] = ACTIONS(2016),
    [sym_comment] = ACTIONS(53),
  },
  [923] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2016),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(2016),
    [anon_sym_PIPE_PIPE] = ACTIONS(2016),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [924] = {
    [anon_sym_PIPE] = ACTIONS(2018),
    [anon_sym_RPAREN] = ACTIONS(2020),
    [anon_sym_PIPE_AMP] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2020),
    [anon_sym_PIPE_PIPE] = ACTIONS(2020),
    [anon_sym_BQUOTE] = ACTIONS(2020),
    [sym_comment] = ACTIONS(53),
  },
  [925] = {
    [sym_simple_expansion] = STATE(978),
    [sym_expansion] = STATE(978),
    [aux_sym_heredoc_body_repeat1] = STATE(978),
    [sym__heredoc_body_middle] = ACTIONS(2038),
    [sym__heredoc_body_end] = ACTIONS(3111),
    [anon_sym_DOLLAR] = ACTIONS(963),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(965),
    [sym_comment] = ACTIONS(53),
  },
  [926] = {
    [sym_concatenation] = STATE(1379),
    [sym_string] = STATE(1378),
    [sym_simple_expansion] = STATE(1378),
    [sym_string_expansion] = STATE(1378),
    [sym_expansion] = STATE(1378),
    [sym_command_substitution] = STATE(1378),
    [sym_process_substitution] = STATE(1378),
    [sym__special_characters] = ACTIONS(3113),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(3115),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3115),
  },
  [927] = {
    [aux_sym_concatenation_repeat1] = STATE(467),
    [sym__simple_heredoc_body] = ACTIONS(2046),
    [sym__heredoc_body_beginning] = ACTIONS(2046),
    [sym_file_descriptor] = ACTIONS(2046),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2048),
    [anon_sym_RPAREN] = ACTIONS(2046),
    [anon_sym_PIPE_AMP] = ACTIONS(2046),
    [anon_sym_AMP_AMP] = ACTIONS(2046),
    [anon_sym_PIPE_PIPE] = ACTIONS(2046),
    [anon_sym_EQ_TILDE] = ACTIONS(2048),
    [anon_sym_EQ_EQ] = ACTIONS(2048),
    [anon_sym_LT] = ACTIONS(2048),
    [anon_sym_GT] = ACTIONS(2048),
    [anon_sym_GT_GT] = ACTIONS(2046),
    [anon_sym_AMP_GT] = ACTIONS(2048),
    [anon_sym_AMP_GT_GT] = ACTIONS(2046),
    [anon_sym_LT_AMP] = ACTIONS(2046),
    [anon_sym_GT_AMP] = ACTIONS(2046),
    [anon_sym_LT_LT] = ACTIONS(2048),
    [anon_sym_LT_LT_DASH] = ACTIONS(2046),
    [anon_sym_LT_LT_LT] = ACTIONS(2046),
    [sym__special_characters] = ACTIONS(2046),
    [anon_sym_DQUOTE] = ACTIONS(2046),
    [anon_sym_DOLLAR] = ACTIONS(2048),
    [sym_raw_string] = ACTIONS(2046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2046),
    [anon_sym_BQUOTE] = ACTIONS(2046),
    [anon_sym_LT_LPAREN] = ACTIONS(2046),
    [anon_sym_GT_LPAREN] = ACTIONS(2046),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2048),
  },
  [928] = {
    [aux_sym_concatenation_repeat1] = STATE(467),
    [sym__simple_heredoc_body] = ACTIONS(2050),
    [sym__heredoc_body_beginning] = ACTIONS(2050),
    [sym_file_descriptor] = ACTIONS(2050),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2052),
    [anon_sym_RPAREN] = ACTIONS(2050),
    [anon_sym_PIPE_AMP] = ACTIONS(2050),
    [anon_sym_AMP_AMP] = ACTIONS(2050),
    [anon_sym_PIPE_PIPE] = ACTIONS(2050),
    [anon_sym_EQ_TILDE] = ACTIONS(2052),
    [anon_sym_EQ_EQ] = ACTIONS(2052),
    [anon_sym_LT] = ACTIONS(2052),
    [anon_sym_GT] = ACTIONS(2052),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_AMP_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT_GT] = ACTIONS(2050),
    [anon_sym_LT_AMP] = ACTIONS(2050),
    [anon_sym_GT_AMP] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2052),
    [anon_sym_LT_LT_DASH] = ACTIONS(2050),
    [anon_sym_LT_LT_LT] = ACTIONS(2050),
    [sym__special_characters] = ACTIONS(2050),
    [anon_sym_DQUOTE] = ACTIONS(2050),
    [anon_sym_DOLLAR] = ACTIONS(2052),
    [sym_raw_string] = ACTIONS(2050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2050),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2050),
    [anon_sym_BQUOTE] = ACTIONS(2050),
    [anon_sym_LT_LPAREN] = ACTIONS(2050),
    [anon_sym_GT_LPAREN] = ACTIONS(2050),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2052),
  },
  [929] = {
    [sym__simple_heredoc_body] = ACTIONS(2050),
    [sym__heredoc_body_beginning] = ACTIONS(2050),
    [sym_file_descriptor] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2052),
    [anon_sym_RPAREN] = ACTIONS(2050),
    [anon_sym_PIPE_AMP] = ACTIONS(2050),
    [anon_sym_AMP_AMP] = ACTIONS(2050),
    [anon_sym_PIPE_PIPE] = ACTIONS(2050),
    [anon_sym_EQ_TILDE] = ACTIONS(2052),
    [anon_sym_EQ_EQ] = ACTIONS(2052),
    [anon_sym_LT] = ACTIONS(2052),
    [anon_sym_GT] = ACTIONS(2052),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_AMP_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT_GT] = ACTIONS(2050),
    [anon_sym_LT_AMP] = ACTIONS(2050),
    [anon_sym_GT_AMP] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2052),
    [anon_sym_LT_LT_DASH] = ACTIONS(2050),
    [anon_sym_LT_LT_LT] = ACTIONS(2050),
    [sym__special_characters] = ACTIONS(2050),
    [anon_sym_DQUOTE] = ACTIONS(2050),
    [anon_sym_DOLLAR] = ACTIONS(2052),
    [sym_raw_string] = ACTIONS(2050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2050),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2050),
    [anon_sym_BQUOTE] = ACTIONS(2050),
    [anon_sym_LT_LPAREN] = ACTIONS(2050),
    [anon_sym_GT_LPAREN] = ACTIONS(2050),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2052),
  },
  [930] = {
    [aux_sym_concatenation_repeat1] = STATE(1380),
    [sym__simple_heredoc_body] = ACTIONS(661),
    [sym__heredoc_body_beginning] = ACTIONS(661),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
  },
  [931] = {
    [aux_sym_concatenation_repeat1] = STATE(1380),
    [sym__simple_heredoc_body] = ACTIONS(677),
    [sym__heredoc_body_beginning] = ACTIONS(677),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [anon_sym_LT_LT_LT] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [932] = {
    [sym__simple_heredoc_body] = ACTIONS(677),
    [sym__heredoc_body_beginning] = ACTIONS(677),
    [sym_file_descriptor] = ACTIONS(677),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [anon_sym_LT_LT_LT] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [933] = {
    [sym__simple_heredoc_body] = ACTIONS(2054),
    [sym__heredoc_body_beginning] = ACTIONS(2054),
    [sym_file_descriptor] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(2056),
    [anon_sym_RPAREN] = ACTIONS(2054),
    [anon_sym_PIPE_AMP] = ACTIONS(2054),
    [anon_sym_AMP_AMP] = ACTIONS(2054),
    [anon_sym_PIPE_PIPE] = ACTIONS(2054),
    [anon_sym_LT] = ACTIONS(2056),
    [anon_sym_GT] = ACTIONS(2056),
    [anon_sym_GT_GT] = ACTIONS(2054),
    [anon_sym_AMP_GT] = ACTIONS(2056),
    [anon_sym_AMP_GT_GT] = ACTIONS(2054),
    [anon_sym_LT_AMP] = ACTIONS(2054),
    [anon_sym_GT_AMP] = ACTIONS(2054),
    [anon_sym_LT_LT] = ACTIONS(2056),
    [anon_sym_LT_LT_DASH] = ACTIONS(2054),
    [anon_sym_LT_LT_LT] = ACTIONS(2054),
    [anon_sym_BQUOTE] = ACTIONS(2054),
    [sym_comment] = ACTIONS(53),
  },
  [934] = {
    [aux_sym_concatenation_repeat1] = STATE(1380),
    [sym__simple_heredoc_body] = ACTIONS(2058),
    [sym__heredoc_body_beginning] = ACTIONS(2058),
    [sym_file_descriptor] = ACTIONS(2058),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_RPAREN] = ACTIONS(2058),
    [anon_sym_PIPE_AMP] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_PIPE_PIPE] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2058),
    [anon_sym_LT_AMP] = ACTIONS(2058),
    [anon_sym_GT_AMP] = ACTIONS(2058),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2058),
    [anon_sym_LT_LT_LT] = ACTIONS(2058),
    [sym_comment] = ACTIONS(53),
  },
  [935] = {
    [aux_sym_concatenation_repeat1] = STATE(1380),
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_RPAREN] = ACTIONS(2062),
    [anon_sym_PIPE_AMP] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_PIPE_PIPE] = ACTIONS(2062),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2062),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2062),
    [anon_sym_LT_AMP] = ACTIONS(2062),
    [anon_sym_GT_AMP] = ACTIONS(2062),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2062),
    [anon_sym_LT_LT_LT] = ACTIONS(2062),
    [sym_comment] = ACTIONS(53),
  },
  [936] = {
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_RPAREN] = ACTIONS(2062),
    [anon_sym_PIPE_AMP] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_PIPE_PIPE] = ACTIONS(2062),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2062),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2062),
    [anon_sym_LT_AMP] = ACTIONS(2062),
    [anon_sym_GT_AMP] = ACTIONS(2062),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2062),
    [anon_sym_LT_LT_LT] = ACTIONS(2062),
    [anon_sym_BQUOTE] = ACTIONS(2062),
    [sym_comment] = ACTIONS(53),
  },
  [937] = {
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_RPAREN] = ACTIONS(2068),
    [anon_sym_PIPE_AMP] = ACTIONS(2068),
    [anon_sym_AMP_AMP] = ACTIONS(2068),
    [anon_sym_PIPE_PIPE] = ACTIONS(2068),
    [anon_sym_BQUOTE] = ACTIONS(2068),
    [sym_comment] = ACTIONS(53),
  },
  [938] = {
    [sym_file_redirect] = STATE(938),
    [sym_heredoc_redirect] = STATE(938),
    [sym_herestring_redirect] = STATE(938),
    [aux_sym_while_statement_repeat1] = STATE(938),
    [sym__simple_heredoc_body] = ACTIONS(2070),
    [sym__heredoc_body_beginning] = ACTIONS(2070),
    [sym_file_descriptor] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(2075),
    [anon_sym_RPAREN] = ACTIONS(2070),
    [anon_sym_PIPE_AMP] = ACTIONS(2070),
    [anon_sym_AMP_AMP] = ACTIONS(2070),
    [anon_sym_PIPE_PIPE] = ACTIONS(2070),
    [anon_sym_LT] = ACTIONS(3120),
    [anon_sym_GT] = ACTIONS(3120),
    [anon_sym_GT_GT] = ACTIONS(3123),
    [anon_sym_AMP_GT] = ACTIONS(3120),
    [anon_sym_AMP_GT_GT] = ACTIONS(3123),
    [anon_sym_LT_AMP] = ACTIONS(3123),
    [anon_sym_GT_AMP] = ACTIONS(3123),
    [anon_sym_LT_LT] = ACTIONS(3126),
    [anon_sym_LT_LT_DASH] = ACTIONS(3129),
    [anon_sym_LT_LT_LT] = ACTIONS(3132),
    [sym_comment] = ACTIONS(53),
  },
  [939] = {
    [sym_file_redirect] = STATE(938),
    [sym_heredoc_redirect] = STATE(938),
    [sym_heredoc_body] = STATE(1381),
    [sym_herestring_redirect] = STATE(938),
    [aux_sym_while_statement_repeat1] = STATE(938),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_RPAREN] = ACTIONS(2068),
    [anon_sym_PIPE_AMP] = ACTIONS(2068),
    [anon_sym_AMP_AMP] = ACTIONS(2068),
    [anon_sym_PIPE_PIPE] = ACTIONS(2068),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym_comment] = ACTIONS(53),
  },
  [940] = {
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(496),
    [sym_simple_expansion] = STATE(496),
    [sym_string_expansion] = STATE(496),
    [sym_expansion] = STATE(496),
    [sym_command_substitution] = STATE(496),
    [sym_process_substitution] = STATE(496),
    [aux_sym_command_repeat2] = STATE(940),
    [sym__simple_heredoc_body] = ACTIONS(2050),
    [sym__heredoc_body_beginning] = ACTIONS(2050),
    [sym_file_descriptor] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2052),
    [anon_sym_RPAREN] = ACTIONS(2050),
    [anon_sym_PIPE_AMP] = ACTIONS(2050),
    [anon_sym_AMP_AMP] = ACTIONS(2050),
    [anon_sym_PIPE_PIPE] = ACTIONS(2050),
    [anon_sym_EQ_TILDE] = ACTIONS(3135),
    [anon_sym_EQ_EQ] = ACTIONS(3135),
    [anon_sym_LT] = ACTIONS(2052),
    [anon_sym_GT] = ACTIONS(2052),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_AMP_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT_GT] = ACTIONS(2050),
    [anon_sym_LT_AMP] = ACTIONS(2050),
    [anon_sym_GT_AMP] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2052),
    [anon_sym_LT_LT_DASH] = ACTIONS(2050),
    [anon_sym_LT_LT_LT] = ACTIONS(2050),
    [sym__special_characters] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(3144),
    [sym_raw_string] = ACTIONS(3147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3153),
    [anon_sym_BQUOTE] = ACTIONS(3156),
    [anon_sym_LT_LPAREN] = ACTIONS(3159),
    [anon_sym_GT_LPAREN] = ACTIONS(3159),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3162),
  },
  [941] = {
    [sym_file_redirect] = STATE(1382),
    [sym_heredoc_redirect] = STATE(1382),
    [sym_heredoc_body] = STATE(1381),
    [sym_herestring_redirect] = STATE(1382),
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(496),
    [sym_simple_expansion] = STATE(496),
    [sym_string_expansion] = STATE(496),
    [sym_expansion] = STATE(496),
    [sym_command_substitution] = STATE(496),
    [sym_process_substitution] = STATE(496),
    [aux_sym_while_statement_repeat1] = STATE(1382),
    [aux_sym_command_repeat2] = STATE(940),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_RPAREN] = ACTIONS(2068),
    [anon_sym_PIPE_AMP] = ACTIONS(2068),
    [anon_sym_AMP_AMP] = ACTIONS(2068),
    [anon_sym_PIPE_PIPE] = ACTIONS(2068),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym__special_characters] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(899),
  },
  [942] = {
    [aux_sym_concatenation_repeat1] = STATE(1383),
    [sym_file_descriptor] = ACTIONS(1129),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT_GT] = ACTIONS(1129),
    [anon_sym_LT_AMP] = ACTIONS(1129),
    [anon_sym_GT_AMP] = ACTIONS(1129),
    [sym__special_characters] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1129),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [anon_sym_LT_LPAREN] = ACTIONS(1129),
    [anon_sym_GT_LPAREN] = ACTIONS(1129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1129),
  },
  [943] = {
    [aux_sym_concatenation_repeat1] = STATE(1383),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1107),
  },
  [944] = {
    [sym_file_redirect] = STATE(1384),
    [sym_heredoc_redirect] = STATE(1384),
    [sym_heredoc_body] = STATE(1292),
    [sym_herestring_redirect] = STATE(1384),
    [aux_sym_while_statement_repeat1] = STATE(1384),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(1163),
    [anon_sym_PIPE_AMP] = ACTIONS(1165),
    [anon_sym_AMP_AMP] = ACTIONS(1165),
    [anon_sym_PIPE_PIPE] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(53),
  },
  [945] = {
    [anon_sym_RPAREN] = ACTIONS(3165),
    [sym_comment] = ACTIONS(53),
  },
  [946] = {
    [sym_file_redirect] = STATE(1307),
    [sym_file_descriptor] = ACTIONS(3167),
    [anon_sym_PIPE] = ACTIONS(1233),
    [anon_sym_PIPE_AMP] = ACTIONS(1237),
    [anon_sym_AMP_AMP] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(3169),
    [anon_sym_GT] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3171),
    [anon_sym_AMP_GT] = ACTIONS(3169),
    [anon_sym_AMP_GT_GT] = ACTIONS(3171),
    [anon_sym_LT_AMP] = ACTIONS(3171),
    [anon_sym_GT_AMP] = ACTIONS(3171),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(53),
  },
  [947] = {
    [sym_file_redirect] = STATE(1391),
    [sym_heredoc_redirect] = STATE(1391),
    [sym_herestring_redirect] = STATE(1391),
    [aux_sym_while_statement_repeat1] = STATE(1391),
    [sym_file_descriptor] = ACTIONS(3173),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_PIPE_AMP] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(3175),
    [anon_sym_GT] = ACTIONS(3175),
    [anon_sym_GT_GT] = ACTIONS(3177),
    [anon_sym_AMP_GT] = ACTIONS(3175),
    [anon_sym_AMP_GT_GT] = ACTIONS(3177),
    [anon_sym_LT_AMP] = ACTIONS(3177),
    [anon_sym_GT_AMP] = ACTIONS(3177),
    [anon_sym_LT_LT] = ACTIONS(2907),
    [anon_sym_LT_LT_DASH] = ACTIONS(2909),
    [anon_sym_LT_LT_LT] = ACTIONS(3179),
    [anon_sym_BQUOTE] = ACTIONS(1349),
    [sym_comment] = ACTIONS(53),
  },
  [948] = {
    [sym_concatenation] = STATE(1315),
    [sym_string] = STATE(1393),
    [sym_array] = STATE(1315),
    [sym_simple_expansion] = STATE(1393),
    [sym_string_expansion] = STATE(1393),
    [sym_expansion] = STATE(1393),
    [sym_command_substitution] = STATE(1393),
    [sym_process_substitution] = STATE(1393),
    [sym__empty_value] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [sym__special_characters] = ACTIONS(3181),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(3183),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(819),
    [anon_sym_GT_LPAREN] = ACTIONS(819),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3183),
  },
  [949] = {
    [aux_sym_concatenation_repeat1] = STATE(1394),
    [sym__concat] = ACTIONS(1852),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
  },
  [950] = {
    [sym_variable_assignment] = STATE(950),
    [sym_subscript] = STATE(509),
    [sym_concatenation] = STATE(950),
    [sym_string] = STATE(508),
    [sym_simple_expansion] = STATE(508),
    [sym_string_expansion] = STATE(508),
    [sym_expansion] = STATE(508),
    [sym_command_substitution] = STATE(508),
    [sym_process_substitution] = STATE(508),
    [aux_sym_declaration_command_repeat1] = STATE(950),
    [sym_variable_name] = ACTIONS(3185),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_PIPE_AMP] = ACTIONS(1517),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [sym__special_characters] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(2969),
    [anon_sym_DOLLAR] = ACTIONS(2972),
    [sym_raw_string] = ACTIONS(3191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2978),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2981),
    [anon_sym_BQUOTE] = ACTIONS(2984),
    [anon_sym_LT_LPAREN] = ACTIONS(2987),
    [anon_sym_GT_LPAREN] = ACTIONS(2987),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2990),
    [sym_word] = ACTIONS(3194),
  },
  [951] = {
    [aux_sym_concatenation_repeat1] = STATE(1395),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
  },
  [952] = {
    [sym_concatenation] = STATE(952),
    [sym_string] = STATE(512),
    [sym_simple_expansion] = STATE(512),
    [sym_string_expansion] = STATE(512),
    [sym_expansion] = STATE(512),
    [sym_command_substitution] = STATE(512),
    [sym_process_substitution] = STATE(512),
    [aux_sym_unset_command_repeat1] = STATE(952),
    [anon_sym_PIPE] = ACTIONS(1569),
    [anon_sym_PIPE_AMP] = ACTIONS(1598),
    [anon_sym_AMP_AMP] = ACTIONS(1598),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [sym__special_characters] = ACTIONS(3197),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [anon_sym_DOLLAR] = ACTIONS(3044),
    [sym_raw_string] = ACTIONS(3200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3050),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3053),
    [anon_sym_BQUOTE] = ACTIONS(3056),
    [anon_sym_LT_LPAREN] = ACTIONS(3059),
    [anon_sym_GT_LPAREN] = ACTIONS(3059),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3062),
    [sym_word] = ACTIONS(3203),
  },
  [953] = {
    [aux_sym_concatenation_repeat1] = STATE(953),
    [sym__simple_heredoc_body] = ACTIONS(1642),
    [sym__heredoc_body_beginning] = ACTIONS(1642),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(3068),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_EQ_TILDE] = ACTIONS(1644),
    [anon_sym_EQ_EQ] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1642),
    [anon_sym_LT_LT_LT] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1644),
  },
  [954] = {
    [sym_compound_statement] = STATE(1396),
    [anon_sym_LBRACE] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
  },
  [955] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(2012),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [956] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(2016),
    [anon_sym_PIPE_PIPE] = ACTIONS(2016),
    [anon_sym_BQUOTE] = ACTIONS(2016),
    [sym_comment] = ACTIONS(53),
  },
  [957] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(2016),
    [anon_sym_PIPE_PIPE] = ACTIONS(2016),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [958] = {
    [sym_concatenation] = STATE(1379),
    [sym_string] = STATE(1398),
    [sym_simple_expansion] = STATE(1398),
    [sym_string_expansion] = STATE(1398),
    [sym_expansion] = STATE(1398),
    [sym_command_substitution] = STATE(1398),
    [sym_process_substitution] = STATE(1398),
    [sym__special_characters] = ACTIONS(3206),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(3208),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3208),
  },
  [959] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(2046),
    [sym__heredoc_body_beginning] = ACTIONS(2046),
    [sym_file_descriptor] = ACTIONS(2046),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2048),
    [anon_sym_PIPE_AMP] = ACTIONS(2046),
    [anon_sym_AMP_AMP] = ACTIONS(2046),
    [anon_sym_PIPE_PIPE] = ACTIONS(2046),
    [anon_sym_EQ_TILDE] = ACTIONS(2048),
    [anon_sym_EQ_EQ] = ACTIONS(2048),
    [anon_sym_LT] = ACTIONS(2048),
    [anon_sym_GT] = ACTIONS(2048),
    [anon_sym_GT_GT] = ACTIONS(2046),
    [anon_sym_AMP_GT] = ACTIONS(2048),
    [anon_sym_AMP_GT_GT] = ACTIONS(2046),
    [anon_sym_LT_AMP] = ACTIONS(2046),
    [anon_sym_GT_AMP] = ACTIONS(2046),
    [anon_sym_LT_LT] = ACTIONS(2048),
    [anon_sym_LT_LT_DASH] = ACTIONS(2046),
    [anon_sym_LT_LT_LT] = ACTIONS(2046),
    [sym__special_characters] = ACTIONS(2046),
    [anon_sym_DQUOTE] = ACTIONS(2046),
    [anon_sym_DOLLAR] = ACTIONS(2048),
    [sym_raw_string] = ACTIONS(2046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2046),
    [anon_sym_BQUOTE] = ACTIONS(2046),
    [anon_sym_LT_LPAREN] = ACTIONS(2046),
    [anon_sym_GT_LPAREN] = ACTIONS(2046),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2048),
  },
  [960] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(2050),
    [sym__heredoc_body_beginning] = ACTIONS(2050),
    [sym_file_descriptor] = ACTIONS(2050),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2052),
    [anon_sym_PIPE_AMP] = ACTIONS(2050),
    [anon_sym_AMP_AMP] = ACTIONS(2050),
    [anon_sym_PIPE_PIPE] = ACTIONS(2050),
    [anon_sym_EQ_TILDE] = ACTIONS(2052),
    [anon_sym_EQ_EQ] = ACTIONS(2052),
    [anon_sym_LT] = ACTIONS(2052),
    [anon_sym_GT] = ACTIONS(2052),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_AMP_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT_GT] = ACTIONS(2050),
    [anon_sym_LT_AMP] = ACTIONS(2050),
    [anon_sym_GT_AMP] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2052),
    [anon_sym_LT_LT_DASH] = ACTIONS(2050),
    [anon_sym_LT_LT_LT] = ACTIONS(2050),
    [sym__special_characters] = ACTIONS(2050),
    [anon_sym_DQUOTE] = ACTIONS(2050),
    [anon_sym_DOLLAR] = ACTIONS(2052),
    [sym_raw_string] = ACTIONS(2050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2050),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2050),
    [anon_sym_BQUOTE] = ACTIONS(2050),
    [anon_sym_LT_LPAREN] = ACTIONS(2050),
    [anon_sym_GT_LPAREN] = ACTIONS(2050),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2052),
  },
  [961] = {
    [aux_sym_concatenation_repeat1] = STATE(1399),
    [sym__simple_heredoc_body] = ACTIONS(661),
    [sym__heredoc_body_beginning] = ACTIONS(661),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [anon_sym_BQUOTE] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
  },
  [962] = {
    [aux_sym_concatenation_repeat1] = STATE(1399),
    [sym__simple_heredoc_body] = ACTIONS(677),
    [sym__heredoc_body_beginning] = ACTIONS(677),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [anon_sym_LT_LT_LT] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [963] = {
    [aux_sym_concatenation_repeat1] = STATE(1399),
    [sym__simple_heredoc_body] = ACTIONS(2058),
    [sym__heredoc_body_beginning] = ACTIONS(2058),
    [sym_file_descriptor] = ACTIONS(2058),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_PIPE_AMP] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_PIPE_PIPE] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2058),
    [anon_sym_LT_AMP] = ACTIONS(2058),
    [anon_sym_GT_AMP] = ACTIONS(2058),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2058),
    [anon_sym_LT_LT_LT] = ACTIONS(2058),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(53),
  },
  [964] = {
    [aux_sym_concatenation_repeat1] = STATE(1399),
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_PIPE_PIPE] = ACTIONS(2062),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2062),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2062),
    [anon_sym_LT_AMP] = ACTIONS(2062),
    [anon_sym_GT_AMP] = ACTIONS(2062),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2062),
    [anon_sym_LT_LT_LT] = ACTIONS(2062),
    [anon_sym_BQUOTE] = ACTIONS(2062),
    [sym_comment] = ACTIONS(53),
  },
  [965] = {
    [sym_file_redirect] = STATE(965),
    [sym_heredoc_redirect] = STATE(965),
    [sym_herestring_redirect] = STATE(965),
    [aux_sym_while_statement_repeat1] = STATE(965),
    [sym__simple_heredoc_body] = ACTIONS(2070),
    [sym__heredoc_body_beginning] = ACTIONS(2070),
    [sym_file_descriptor] = ACTIONS(3210),
    [anon_sym_PIPE] = ACTIONS(2075),
    [anon_sym_PIPE_AMP] = ACTIONS(2070),
    [anon_sym_AMP_AMP] = ACTIONS(2070),
    [anon_sym_PIPE_PIPE] = ACTIONS(2070),
    [anon_sym_LT] = ACTIONS(3213),
    [anon_sym_GT] = ACTIONS(3213),
    [anon_sym_GT_GT] = ACTIONS(3216),
    [anon_sym_AMP_GT] = ACTIONS(3213),
    [anon_sym_AMP_GT_GT] = ACTIONS(3216),
    [anon_sym_LT_AMP] = ACTIONS(3216),
    [anon_sym_GT_AMP] = ACTIONS(3216),
    [anon_sym_LT_LT] = ACTIONS(3126),
    [anon_sym_LT_LT_DASH] = ACTIONS(3129),
    [anon_sym_LT_LT_LT] = ACTIONS(3219),
    [anon_sym_BQUOTE] = ACTIONS(2070),
    [sym_comment] = ACTIONS(53),
  },
  [966] = {
    [sym_file_redirect] = STATE(965),
    [sym_heredoc_redirect] = STATE(965),
    [sym_heredoc_body] = STATE(1381),
    [sym_herestring_redirect] = STATE(965),
    [aux_sym_while_statement_repeat1] = STATE(965),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_PIPE_AMP] = ACTIONS(2068),
    [anon_sym_AMP_AMP] = ACTIONS(2068),
    [anon_sym_PIPE_PIPE] = ACTIONS(2068),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(2068),
    [sym_comment] = ACTIONS(53),
  },
  [967] = {
    [sym_concatenation] = STATE(967),
    [sym_string] = STATE(523),
    [sym_simple_expansion] = STATE(523),
    [sym_string_expansion] = STATE(523),
    [sym_expansion] = STATE(523),
    [sym_command_substitution] = STATE(523),
    [sym_process_substitution] = STATE(523),
    [aux_sym_command_repeat2] = STATE(967),
    [sym__simple_heredoc_body] = ACTIONS(2050),
    [sym__heredoc_body_beginning] = ACTIONS(2050),
    [sym_file_descriptor] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2052),
    [anon_sym_PIPE_AMP] = ACTIONS(2050),
    [anon_sym_AMP_AMP] = ACTIONS(2050),
    [anon_sym_PIPE_PIPE] = ACTIONS(2050),
    [anon_sym_EQ_TILDE] = ACTIONS(3222),
    [anon_sym_EQ_EQ] = ACTIONS(3222),
    [anon_sym_LT] = ACTIONS(2052),
    [anon_sym_GT] = ACTIONS(2052),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_AMP_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT_GT] = ACTIONS(2050),
    [anon_sym_LT_AMP] = ACTIONS(2050),
    [anon_sym_GT_AMP] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2052),
    [anon_sym_LT_LT_DASH] = ACTIONS(2050),
    [anon_sym_LT_LT_LT] = ACTIONS(2050),
    [sym__special_characters] = ACTIONS(3225),
    [anon_sym_DQUOTE] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(3144),
    [sym_raw_string] = ACTIONS(3228),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3153),
    [anon_sym_BQUOTE] = ACTIONS(3156),
    [anon_sym_LT_LPAREN] = ACTIONS(3159),
    [anon_sym_GT_LPAREN] = ACTIONS(3159),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3231),
  },
  [968] = {
    [sym_file_redirect] = STATE(1400),
    [sym_heredoc_redirect] = STATE(1400),
    [sym_heredoc_body] = STATE(1381),
    [sym_herestring_redirect] = STATE(1400),
    [sym_concatenation] = STATE(967),
    [sym_string] = STATE(523),
    [sym_simple_expansion] = STATE(523),
    [sym_string_expansion] = STATE(523),
    [sym_expansion] = STATE(523),
    [sym_command_substitution] = STATE(523),
    [sym_process_substitution] = STATE(523),
    [aux_sym_while_statement_repeat1] = STATE(1400),
    [aux_sym_command_repeat2] = STATE(967),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_PIPE_AMP] = ACTIONS(2068),
    [anon_sym_AMP_AMP] = ACTIONS(2068),
    [anon_sym_PIPE_PIPE] = ACTIONS(2068),
    [anon_sym_EQ_TILDE] = ACTIONS(931),
    [anon_sym_EQ_EQ] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(2068),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(943),
  },
  [969] = {
    [sym_file_redirect] = STATE(1401),
    [sym_file_descriptor] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(2334),
    [anon_sym_SEMI_SEMI] = ACTIONS(2334),
    [anon_sym_PIPE_AMP] = ACTIONS(2334),
    [anon_sym_AMP_AMP] = ACTIONS(2334),
    [anon_sym_PIPE_PIPE] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_LF] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2334),
  },
  [970] = {
    [sym__heredoc_body_middle] = ACTIONS(727),
    [sym__heredoc_body_end] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
  },
  [971] = {
    [sym__heredoc_body_middle] = ACTIONS(735),
    [sym__heredoc_body_end] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
  },
  [972] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(3234),
    [sym_comment] = ACTIONS(53),
  },
  [973] = {
    [sym_concatenation] = STATE(1405),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1405),
    [anon_sym_RBRACE] = ACTIONS(3236),
    [anon_sym_EQ] = ACTIONS(3238),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3240),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3242),
    [anon_sym_COLON] = ACTIONS(3238),
    [anon_sym_COLON_QMARK] = ACTIONS(3238),
    [anon_sym_COLON_DASH] = ACTIONS(3238),
    [anon_sym_PERCENT] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(3238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [974] = {
    [sym_subscript] = STATE(1409),
    [sym_variable_name] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3246),
    [anon_sym_DASH] = ACTIONS(3246),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3248),
    [anon_sym_STAR] = ACTIONS(3246),
    [anon_sym_AT] = ACTIONS(3246),
    [anon_sym_QMARK] = ACTIONS(3246),
    [anon_sym_0] = ACTIONS(3250),
    [anon_sym__] = ACTIONS(3250),
  },
  [975] = {
    [sym_concatenation] = STATE(1412),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1412),
    [anon_sym_RBRACE] = ACTIONS(3252),
    [anon_sym_EQ] = ACTIONS(3254),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3258),
    [anon_sym_COLON] = ACTIONS(3254),
    [anon_sym_COLON_QMARK] = ACTIONS(3254),
    [anon_sym_COLON_DASH] = ACTIONS(3254),
    [anon_sym_PERCENT] = ACTIONS(3254),
    [anon_sym_DASH] = ACTIONS(3254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [976] = {
    [sym_concatenation] = STATE(1415),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1415),
    [anon_sym_RBRACE] = ACTIONS(3260),
    [anon_sym_EQ] = ACTIONS(3262),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3266),
    [anon_sym_COLON] = ACTIONS(3262),
    [anon_sym_COLON_QMARK] = ACTIONS(3262),
    [anon_sym_COLON_DASH] = ACTIONS(3262),
    [anon_sym_PERCENT] = ACTIONS(3262),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [977] = {
    [anon_sym_esac] = ACTIONS(3268),
    [anon_sym_PIPE] = ACTIONS(3268),
    [anon_sym_RPAREN] = ACTIONS(3268),
    [anon_sym_SEMI_SEMI] = ACTIONS(3268),
    [anon_sym_PIPE_AMP] = ACTIONS(3268),
    [anon_sym_AMP_AMP] = ACTIONS(3268),
    [anon_sym_PIPE_PIPE] = ACTIONS(3268),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym_LF] = ACTIONS(3270),
    [anon_sym_AMP] = ACTIONS(3268),
  },
  [978] = {
    [sym_simple_expansion] = STATE(978),
    [sym_expansion] = STATE(978),
    [aux_sym_heredoc_body_repeat1] = STATE(978),
    [sym__heredoc_body_middle] = ACTIONS(3272),
    [sym__heredoc_body_end] = ACTIONS(3275),
    [anon_sym_DOLLAR] = ACTIONS(3277),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3280),
    [sym_comment] = ACTIONS(53),
  },
  [979] = {
    [aux_sym_concatenation_repeat1] = STATE(982),
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [980] = {
    [aux_sym_concatenation_repeat1] = STATE(982),
    [sym__simple_heredoc_body] = ACTIONS(1093),
    [sym__heredoc_body_beginning] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [981] = {
    [sym__simple_heredoc_body] = ACTIONS(1093),
    [sym__heredoc_body_beginning] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1093),
    [anon_sym_esac] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [982] = {
    [aux_sym_concatenation_repeat1] = STATE(1416),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [983] = {
    [anon_sym_esac] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3283),
    [anon_sym_RPAREN] = ACTIONS(3283),
    [anon_sym_SEMI_SEMI] = ACTIONS(3283),
    [anon_sym_PIPE_AMP] = ACTIONS(3283),
    [anon_sym_AMP_AMP] = ACTIONS(3283),
    [anon_sym_PIPE_PIPE] = ACTIONS(3283),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_LF] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3283),
  },
  [984] = {
    [sym_file_redirect] = STATE(549),
    [sym_heredoc_redirect] = STATE(549),
    [sym_heredoc_body] = STATE(1417),
    [sym_herestring_redirect] = STATE(549),
    [aux_sym_while_statement_repeat1] = STATE(549),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(3283),
    [anon_sym_SEMI_SEMI] = ACTIONS(3283),
    [anon_sym_PIPE_AMP] = ACTIONS(3283),
    [anon_sym_AMP_AMP] = ACTIONS(3283),
    [anon_sym_PIPE_PIPE] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_LF] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3283),
  },
  [985] = {
    [sym__concat] = ACTIONS(3287),
    [anon_sym_EQ] = ACTIONS(3289),
    [anon_sym_PLUS_EQ] = ACTIONS(3289),
    [sym_comment] = ACTIONS(53),
  },
  [986] = {
    [anon_sym_EQ] = ACTIONS(3289),
    [anon_sym_PLUS_EQ] = ACTIONS(3289),
    [sym_comment] = ACTIONS(53),
  },
  [987] = {
    [aux_sym_concatenation_repeat1] = STATE(987),
    [sym__concat] = ACTIONS(2405),
    [anon_sym_RBRACK] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
  },
  [988] = {
    [sym__concat] = ACTIONS(3291),
    [anon_sym_EQ] = ACTIONS(3293),
    [anon_sym_PLUS_EQ] = ACTIONS(3293),
    [sym_comment] = ACTIONS(53),
  },
  [989] = {
    [anon_sym_EQ] = ACTIONS(3293),
    [anon_sym_PLUS_EQ] = ACTIONS(3293),
    [sym_comment] = ACTIONS(53),
  },
  [990] = {
    [sym_string] = STATE(1420),
    [sym_simple_expansion] = STATE(1420),
    [sym_string_expansion] = STATE(1420),
    [sym_expansion] = STATE(1420),
    [sym_command_substitution] = STATE(1420),
    [sym_process_substitution] = STATE(1420),
    [sym__special_characters] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(3295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3295),
  },
  [991] = {
    [aux_sym_concatenation_repeat1] = STATE(1421),
    [sym__concat] = ACTIONS(2131),
    [anon_sym_RPAREN] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(693),
  },
  [992] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_RPAREN] = ACTIONS(697),
    [sym__special_characters] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [anon_sym_LT_LPAREN] = ACTIONS(697),
    [anon_sym_GT_LPAREN] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(697),
  },
  [993] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(3297),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [994] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_RPAREN] = ACTIONS(727),
    [sym__special_characters] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(727),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [anon_sym_LT_LPAREN] = ACTIONS(727),
    [anon_sym_GT_LPAREN] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(727),
  },
  [995] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(731),
  },
  [996] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(735),
  },
  [997] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(3299),
    [sym_comment] = ACTIONS(53),
  },
  [998] = {
    [sym_concatenation] = STATE(1426),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1426),
    [anon_sym_RBRACE] = ACTIONS(3301),
    [anon_sym_EQ] = ACTIONS(3303),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3307),
    [anon_sym_COLON] = ACTIONS(3303),
    [anon_sym_COLON_QMARK] = ACTIONS(3303),
    [anon_sym_COLON_DASH] = ACTIONS(3303),
    [anon_sym_PERCENT] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [999] = {
    [sym_subscript] = STATE(1430),
    [sym_variable_name] = ACTIONS(3309),
    [anon_sym_DOLLAR] = ACTIONS(3311),
    [anon_sym_DASH] = ACTIONS(3311),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3313),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_AT] = ACTIONS(3311),
    [anon_sym_QMARK] = ACTIONS(3311),
    [anon_sym_0] = ACTIONS(3315),
    [anon_sym__] = ACTIONS(3315),
  },
  [1000] = {
    [sym_concatenation] = STATE(1433),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1433),
    [anon_sym_RBRACE] = ACTIONS(3317),
    [anon_sym_EQ] = ACTIONS(3319),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3323),
    [anon_sym_COLON] = ACTIONS(3319),
    [anon_sym_COLON_QMARK] = ACTIONS(3319),
    [anon_sym_COLON_DASH] = ACTIONS(3319),
    [anon_sym_PERCENT] = ACTIONS(3319),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1001] = {
    [sym_concatenation] = STATE(1436),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1436),
    [anon_sym_RBRACE] = ACTIONS(3325),
    [anon_sym_EQ] = ACTIONS(3327),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3331),
    [anon_sym_COLON] = ACTIONS(3327),
    [anon_sym_COLON_QMARK] = ACTIONS(3327),
    [anon_sym_COLON_DASH] = ACTIONS(3327),
    [anon_sym_PERCENT] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(3327),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1002] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3333),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [1003] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3333),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1004] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3333),
    [sym_comment] = ACTIONS(53),
  },
  [1005] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(3333),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1006] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3335),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [1007] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3335),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1008] = {
    [sym_file_descriptor] = ACTIONS(3337),
    [sym_variable_name] = ACTIONS(3337),
    [anon_sym_esac] = ACTIONS(3339),
    [anon_sym_PIPE] = ACTIONS(3339),
    [anon_sym_RPAREN] = ACTIONS(3339),
    [anon_sym_SEMI_SEMI] = ACTIONS(3339),
    [anon_sym_PIPE_AMP] = ACTIONS(3339),
    [anon_sym_AMP_AMP] = ACTIONS(3339),
    [anon_sym_PIPE_PIPE] = ACTIONS(3339),
    [anon_sym_LT] = ACTIONS(3339),
    [anon_sym_GT] = ACTIONS(3339),
    [anon_sym_GT_GT] = ACTIONS(3339),
    [anon_sym_AMP_GT] = ACTIONS(3339),
    [anon_sym_AMP_GT_GT] = ACTIONS(3339),
    [anon_sym_LT_AMP] = ACTIONS(3339),
    [anon_sym_GT_AMP] = ACTIONS(3339),
    [sym__special_characters] = ACTIONS(3339),
    [anon_sym_DQUOTE] = ACTIONS(3339),
    [anon_sym_DOLLAR] = ACTIONS(3339),
    [sym_raw_string] = ACTIONS(3339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3339),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [anon_sym_LT_LPAREN] = ACTIONS(3339),
    [anon_sym_GT_LPAREN] = ACTIONS(3339),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3339),
    [anon_sym_SEMI] = ACTIONS(3339),
    [anon_sym_LF] = ACTIONS(3337),
    [anon_sym_AMP] = ACTIONS(3339),
  },
  [1009] = {
    [sym_concatenation] = STATE(1009),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1009),
    [anon_sym_RPAREN] = ACTIONS(3341),
    [sym__special_characters] = ACTIONS(3343),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [anon_sym_DOLLAR] = ACTIONS(3349),
    [sym_raw_string] = ACTIONS(3352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3355),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3358),
    [anon_sym_BQUOTE] = ACTIONS(3361),
    [anon_sym_LT_LPAREN] = ACTIONS(3364),
    [anon_sym_GT_LPAREN] = ACTIONS(3364),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3352),
  },
  [1010] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_esac] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1011] = {
    [aux_sym_concatenation_repeat1] = STATE(1011),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(3367),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1012] = {
    [sym_file_descriptor] = ACTIONS(1691),
    [sym__concat] = ACTIONS(1691),
    [sym_variable_name] = ACTIONS(1691),
    [anon_sym_esac] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_RPAREN] = ACTIONS(1693),
    [anon_sym_SEMI_SEMI] = ACTIONS(1693),
    [anon_sym_PIPE_AMP] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1693),
    [anon_sym_AMP_GT] = ACTIONS(1693),
    [anon_sym_AMP_GT_GT] = ACTIONS(1693),
    [anon_sym_LT_AMP] = ACTIONS(1693),
    [anon_sym_GT_AMP] = ACTIONS(1693),
    [sym__special_characters] = ACTIONS(1693),
    [anon_sym_DQUOTE] = ACTIONS(1693),
    [anon_sym_DOLLAR] = ACTIONS(1693),
    [sym_raw_string] = ACTIONS(1693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1693),
    [anon_sym_BQUOTE] = ACTIONS(1693),
    [anon_sym_LT_LPAREN] = ACTIONS(1693),
    [anon_sym_GT_LPAREN] = ACTIONS(1693),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1693),
    [anon_sym_LF] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1693),
  },
  [1013] = {
    [sym_concatenation] = STATE(1442),
    [sym_string] = STATE(1441),
    [sym_simple_expansion] = STATE(1441),
    [sym_string_expansion] = STATE(1441),
    [sym_expansion] = STATE(1441),
    [sym_command_substitution] = STATE(1441),
    [sym_process_substitution] = STATE(1441),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [sym__special_characters] = ACTIONS(3372),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(3374),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3374),
  },
  [1014] = {
    [sym_file_descriptor] = ACTIONS(1732),
    [sym__concat] = ACTIONS(1732),
    [sym_variable_name] = ACTIONS(1732),
    [anon_sym_esac] = ACTIONS(1734),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_RPAREN] = ACTIONS(1734),
    [anon_sym_SEMI_SEMI] = ACTIONS(1734),
    [anon_sym_PIPE_AMP] = ACTIONS(1734),
    [anon_sym_AMP_AMP] = ACTIONS(1734),
    [anon_sym_PIPE_PIPE] = ACTIONS(1734),
    [anon_sym_LT] = ACTIONS(1734),
    [anon_sym_GT] = ACTIONS(1734),
    [anon_sym_GT_GT] = ACTIONS(1734),
    [anon_sym_AMP_GT] = ACTIONS(1734),
    [anon_sym_AMP_GT_GT] = ACTIONS(1734),
    [anon_sym_LT_AMP] = ACTIONS(1734),
    [anon_sym_GT_AMP] = ACTIONS(1734),
    [sym__special_characters] = ACTIONS(1734),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [sym_raw_string] = ACTIONS(1734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1734),
    [anon_sym_BQUOTE] = ACTIONS(1734),
    [anon_sym_LT_LPAREN] = ACTIONS(1734),
    [anon_sym_GT_LPAREN] = ACTIONS(1734),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1734),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_LF] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1734),
  },
  [1015] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3376),
  },
  [1016] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3378),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1017] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(3380),
    [sym_comment] = ACTIONS(53),
  },
  [1018] = {
    [sym_concatenation] = STATE(1448),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1448),
    [anon_sym_RBRACE] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(3384),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3386),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3388),
    [anon_sym_COLON] = ACTIONS(3384),
    [anon_sym_COLON_QMARK] = ACTIONS(3384),
    [anon_sym_COLON_DASH] = ACTIONS(3384),
    [anon_sym_PERCENT] = ACTIONS(3384),
    [anon_sym_DASH] = ACTIONS(3384),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1019] = {
    [sym_concatenation] = STATE(1451),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1451),
    [anon_sym_RBRACE] = ACTIONS(3390),
    [anon_sym_EQ] = ACTIONS(3392),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3394),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3396),
    [anon_sym_COLON] = ACTIONS(3392),
    [anon_sym_COLON_QMARK] = ACTIONS(3392),
    [anon_sym_COLON_DASH] = ACTIONS(3392),
    [anon_sym_PERCENT] = ACTIONS(3392),
    [anon_sym_DASH] = ACTIONS(3392),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1020] = {
    [sym_concatenation] = STATE(1453),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1453),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_EQ] = ACTIONS(3398),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3402),
    [anon_sym_COLON] = ACTIONS(3398),
    [anon_sym_COLON_QMARK] = ACTIONS(3398),
    [anon_sym_COLON_DASH] = ACTIONS(3398),
    [anon_sym_PERCENT] = ACTIONS(3398),
    [anon_sym_DASH] = ACTIONS(3398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1021] = {
    [sym_file_descriptor] = ACTIONS(1798),
    [sym__concat] = ACTIONS(1798),
    [sym_variable_name] = ACTIONS(1798),
    [anon_sym_esac] = ACTIONS(1800),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1800),
    [anon_sym_SEMI_SEMI] = ACTIONS(1800),
    [anon_sym_PIPE_AMP] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(1800),
    [anon_sym_PIPE_PIPE] = ACTIONS(1800),
    [anon_sym_LT] = ACTIONS(1800),
    [anon_sym_GT] = ACTIONS(1800),
    [anon_sym_GT_GT] = ACTIONS(1800),
    [anon_sym_AMP_GT] = ACTIONS(1800),
    [anon_sym_AMP_GT_GT] = ACTIONS(1800),
    [anon_sym_LT_AMP] = ACTIONS(1800),
    [anon_sym_GT_AMP] = ACTIONS(1800),
    [sym__special_characters] = ACTIONS(1800),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [sym_raw_string] = ACTIONS(1800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1800),
    [anon_sym_BQUOTE] = ACTIONS(1800),
    [anon_sym_LT_LPAREN] = ACTIONS(1800),
    [anon_sym_GT_LPAREN] = ACTIONS(1800),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1800),
    [anon_sym_SEMI] = ACTIONS(1800),
    [anon_sym_LF] = ACTIONS(1798),
    [anon_sym_AMP] = ACTIONS(1800),
  },
  [1022] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3404),
  },
  [1023] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3406),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1024] = {
    [sym_file_descriptor] = ACTIONS(1806),
    [sym__concat] = ACTIONS(1806),
    [sym_variable_name] = ACTIONS(1806),
    [anon_sym_esac] = ACTIONS(1808),
    [anon_sym_PIPE] = ACTIONS(1808),
    [anon_sym_RPAREN] = ACTIONS(1808),
    [anon_sym_SEMI_SEMI] = ACTIONS(1808),
    [anon_sym_PIPE_AMP] = ACTIONS(1808),
    [anon_sym_AMP_AMP] = ACTIONS(1808),
    [anon_sym_PIPE_PIPE] = ACTIONS(1808),
    [anon_sym_LT] = ACTIONS(1808),
    [anon_sym_GT] = ACTIONS(1808),
    [anon_sym_GT_GT] = ACTIONS(1808),
    [anon_sym_AMP_GT] = ACTIONS(1808),
    [anon_sym_AMP_GT_GT] = ACTIONS(1808),
    [anon_sym_LT_AMP] = ACTIONS(1808),
    [anon_sym_GT_AMP] = ACTIONS(1808),
    [sym__special_characters] = ACTIONS(1808),
    [anon_sym_DQUOTE] = ACTIONS(1808),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [sym_raw_string] = ACTIONS(1808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1808),
    [anon_sym_BQUOTE] = ACTIONS(1808),
    [anon_sym_LT_LPAREN] = ACTIONS(1808),
    [anon_sym_GT_LPAREN] = ACTIONS(1808),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1808),
    [anon_sym_SEMI] = ACTIONS(1808),
    [anon_sym_LF] = ACTIONS(1806),
    [anon_sym_AMP] = ACTIONS(1808),
  },
  [1025] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3408),
  },
  [1026] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1027] = {
    [sym_file_descriptor] = ACTIONS(1940),
    [sym__concat] = ACTIONS(1940),
    [sym_variable_name] = ACTIONS(1940),
    [anon_sym_esac] = ACTIONS(1942),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1942),
    [anon_sym_PIPE_AMP] = ACTIONS(1942),
    [anon_sym_AMP_AMP] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1942),
    [anon_sym_LT_AMP] = ACTIONS(1942),
    [anon_sym_GT_AMP] = ACTIONS(1942),
    [sym__special_characters] = ACTIONS(1942),
    [anon_sym_DQUOTE] = ACTIONS(1942),
    [anon_sym_DOLLAR] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1942),
    [anon_sym_BQUOTE] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1942),
    [anon_sym_GT_LPAREN] = ACTIONS(1942),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [1028] = {
    [sym_file_descriptor] = ACTIONS(2006),
    [sym__concat] = ACTIONS(2006),
    [sym_variable_name] = ACTIONS(2006),
    [anon_sym_esac] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_RPAREN] = ACTIONS(2008),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2008),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2008),
    [anon_sym_LT_AMP] = ACTIONS(2008),
    [anon_sym_GT_AMP] = ACTIONS(2008),
    [sym__special_characters] = ACTIONS(2008),
    [anon_sym_DQUOTE] = ACTIONS(2008),
    [anon_sym_DOLLAR] = ACTIONS(2008),
    [sym_raw_string] = ACTIONS(2008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2008),
    [anon_sym_BQUOTE] = ACTIONS(2008),
    [anon_sym_LT_LPAREN] = ACTIONS(2008),
    [anon_sym_GT_LPAREN] = ACTIONS(2008),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2008),
  },
  [1029] = {
    [aux_sym_concatenation_repeat1] = STATE(1457),
    [sym__concat] = ACTIONS(419),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [1030] = {
    [sym_do_group] = STATE(1458),
    [anon_sym_do] = ACTIONS(1159),
    [sym_comment] = ACTIONS(53),
  },
  [1031] = {
    [sym_concatenation] = STATE(1031),
    [sym_string] = STATE(588),
    [sym_simple_expansion] = STATE(588),
    [sym_string_expansion] = STATE(588),
    [sym_expansion] = STATE(588),
    [sym_command_substitution] = STATE(588),
    [sym_process_substitution] = STATE(588),
    [aux_sym_for_statement_repeat1] = STATE(1031),
    [anon_sym_SEMI_SEMI] = ACTIONS(3410),
    [sym__special_characters] = ACTIONS(3412),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [anon_sym_DOLLAR] = ACTIONS(3418),
    [sym_raw_string] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3424),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3427),
    [anon_sym_BQUOTE] = ACTIONS(3430),
    [anon_sym_LT_LPAREN] = ACTIONS(3433),
    [anon_sym_GT_LPAREN] = ACTIONS(3433),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3421),
    [anon_sym_SEMI] = ACTIONS(3410),
    [anon_sym_LF] = ACTIONS(3341),
    [anon_sym_AMP] = ACTIONS(3410),
  },
  [1032] = {
    [anon_sym_esac] = ACTIONS(2231),
    [anon_sym_PIPE] = ACTIONS(2231),
    [anon_sym_RPAREN] = ACTIONS(2231),
    [anon_sym_SEMI_SEMI] = ACTIONS(2231),
    [anon_sym_PIPE_AMP] = ACTIONS(2231),
    [anon_sym_AMP_AMP] = ACTIONS(2231),
    [anon_sym_PIPE_PIPE] = ACTIONS(2231),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2231),
    [anon_sym_LF] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
  },
  [1033] = {
    [sym__terminated_statement] = STATE(1035),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1035),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(3436),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1034] = {
    [sym__simple_heredoc_body] = ACTIONS(3438),
    [sym__heredoc_body_beginning] = ACTIONS(3438),
    [sym_file_descriptor] = ACTIONS(3438),
    [anon_sym_esac] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3440),
    [anon_sym_RPAREN] = ACTIONS(3440),
    [anon_sym_SEMI_SEMI] = ACTIONS(3440),
    [anon_sym_PIPE_AMP] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_GT] = ACTIONS(3440),
    [anon_sym_GT_GT] = ACTIONS(3440),
    [anon_sym_AMP_GT] = ACTIONS(3440),
    [anon_sym_AMP_GT_GT] = ACTIONS(3440),
    [anon_sym_LT_AMP] = ACTIONS(3440),
    [anon_sym_GT_AMP] = ACTIONS(3440),
    [anon_sym_LT_LT] = ACTIONS(3440),
    [anon_sym_LT_LT_DASH] = ACTIONS(3440),
    [anon_sym_LT_LT_LT] = ACTIONS(3440),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3440),
    [anon_sym_LF] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3440),
  },
  [1035] = {
    [sym__terminated_statement] = STATE(1035),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1035),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_done] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [1036] = {
    [anon_sym_esac] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(3444),
    [anon_sym_RPAREN] = ACTIONS(3444),
    [anon_sym_SEMI_SEMI] = ACTIONS(3444),
    [anon_sym_PIPE_AMP] = ACTIONS(3444),
    [anon_sym_AMP_AMP] = ACTIONS(3444),
    [anon_sym_PIPE_PIPE] = ACTIONS(3444),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3444),
    [anon_sym_LF] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3444),
  },
  [1037] = {
    [anon_sym_then] = ACTIONS(3448),
    [sym_comment] = ACTIONS(53),
  },
  [1038] = {
    [sym__terminated_statement] = STATE(1461),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1461),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(3450),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1039] = {
    [anon_sym_esac] = ACTIONS(3452),
    [anon_sym_PIPE] = ACTIONS(3452),
    [anon_sym_RPAREN] = ACTIONS(3452),
    [anon_sym_SEMI_SEMI] = ACTIONS(3452),
    [anon_sym_PIPE_AMP] = ACTIONS(3452),
    [anon_sym_AMP_AMP] = ACTIONS(3452),
    [anon_sym_PIPE_PIPE] = ACTIONS(3452),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym_LF] = ACTIONS(3454),
    [anon_sym_AMP] = ACTIONS(3452),
  },
  [1040] = {
    [anon_sym_fi] = ACTIONS(3456),
    [sym_comment] = ACTIONS(53),
  },
  [1041] = {
    [sym__terminated_statement] = STATE(1041),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1041),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_fi] = ACTIONS(3442),
    [anon_sym_elif] = ACTIONS(3442),
    [anon_sym_else] = ACTIONS(3442),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [1042] = {
    [sym_elif_clause] = STATE(599),
    [sym_else_clause] = STATE(1463),
    [aux_sym_if_statement_repeat1] = STATE(1043),
    [anon_sym_fi] = ACTIONS(3456),
    [anon_sym_elif] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2253),
    [sym_comment] = ACTIONS(53),
  },
  [1043] = {
    [sym_elif_clause] = STATE(599),
    [aux_sym_if_statement_repeat1] = STATE(1043),
    [anon_sym_fi] = ACTIONS(3458),
    [anon_sym_elif] = ACTIONS(3460),
    [anon_sym_else] = ACTIONS(3458),
    [sym_comment] = ACTIONS(53),
  },
  [1044] = {
    [anon_sym_esac] = ACTIONS(3463),
    [anon_sym_PIPE] = ACTIONS(3463),
    [anon_sym_RPAREN] = ACTIONS(3463),
    [anon_sym_SEMI_SEMI] = ACTIONS(3463),
    [anon_sym_PIPE_AMP] = ACTIONS(3463),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3463),
    [anon_sym_LF] = ACTIONS(3465),
    [anon_sym_AMP] = ACTIONS(3463),
  },
  [1045] = {
    [aux_sym_case_item_repeat1] = STATE(1466),
    [aux_sym_concatenation_repeat1] = STATE(1467),
    [sym__concat] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(3467),
    [anon_sym_RPAREN] = ACTIONS(3469),
    [sym_comment] = ACTIONS(53),
  },
  [1046] = {
    [aux_sym_case_item_repeat1] = STATE(1469),
    [aux_sym_concatenation_repeat1] = STATE(1467),
    [sym__concat] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(3467),
    [anon_sym_RPAREN] = ACTIONS(3471),
    [sym_comment] = ACTIONS(53),
  },
  [1047] = {
    [anon_sym_esac] = ACTIONS(3473),
    [sym_comment] = ACTIONS(53),
  },
  [1048] = {
    [aux_sym_case_item_repeat1] = STATE(1469),
    [anon_sym_PIPE] = ACTIONS(3467),
    [anon_sym_RPAREN] = ACTIONS(3471),
    [sym_comment] = ACTIONS(53),
  },
  [1049] = {
    [sym_case_item] = STATE(1472),
    [sym_last_case_item] = STATE(1471),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(1472),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2259),
  },
  [1050] = {
    [sym_case_item] = STATE(1474),
    [sym_last_case_item] = STATE(1471),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(1474),
    [anon_sym_esac] = ACTIONS(3475),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2261),
  },
  [1051] = {
    [anon_sym_esac] = ACTIONS(3477),
    [anon_sym_PIPE] = ACTIONS(3477),
    [anon_sym_RPAREN] = ACTIONS(3477),
    [anon_sym_SEMI_SEMI] = ACTIONS(3477),
    [anon_sym_PIPE_AMP] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_PIPE_PIPE] = ACTIONS(3477),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3477),
    [anon_sym_LF] = ACTIONS(3479),
    [anon_sym_AMP] = ACTIONS(3477),
  },
  [1052] = {
    [anon_sym_esac] = ACTIONS(3481),
    [sym_comment] = ACTIONS(53),
  },
  [1053] = {
    [sym_case_item] = STATE(1472),
    [sym_last_case_item] = STATE(1476),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(1472),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2259),
  },
  [1054] = {
    [sym_case_item] = STATE(1478),
    [sym_last_case_item] = STATE(1476),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(1478),
    [anon_sym_esac] = ACTIONS(3483),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2261),
  },
  [1055] = {
    [sym__concat] = ACTIONS(2710),
    [anon_sym_in] = ACTIONS(2712),
    [anon_sym_SEMI_SEMI] = ACTIONS(2712),
    [sym__special_characters] = ACTIONS(2712),
    [anon_sym_DQUOTE] = ACTIONS(2712),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [sym_raw_string] = ACTIONS(2712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2712),
    [anon_sym_BQUOTE] = ACTIONS(2712),
    [anon_sym_LT_LPAREN] = ACTIONS(2712),
    [anon_sym_GT_LPAREN] = ACTIONS(2712),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_LF] = ACTIONS(2710),
    [anon_sym_AMP] = ACTIONS(2712),
  },
  [1056] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3485),
    [sym_comment] = ACTIONS(53),
  },
  [1057] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3487),
    [sym_comment] = ACTIONS(53),
  },
  [1058] = {
    [anon_sym_RBRACE] = ACTIONS(3487),
    [sym_comment] = ACTIONS(53),
  },
  [1059] = {
    [sym_concatenation] = STATE(1482),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1482),
    [anon_sym_RBRACE] = ACTIONS(3489),
    [anon_sym_EQ] = ACTIONS(3491),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3491),
    [anon_sym_COLON_QMARK] = ACTIONS(3491),
    [anon_sym_COLON_DASH] = ACTIONS(3491),
    [anon_sym_PERCENT] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(3491),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1060] = {
    [sym__concat] = ACTIONS(2788),
    [anon_sym_in] = ACTIONS(2790),
    [anon_sym_SEMI_SEMI] = ACTIONS(2790),
    [sym__special_characters] = ACTIONS(2790),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym_raw_string] = ACTIONS(2790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2790),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [anon_sym_LT_LPAREN] = ACTIONS(2790),
    [anon_sym_GT_LPAREN] = ACTIONS(2790),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2790),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_LF] = ACTIONS(2788),
    [anon_sym_AMP] = ACTIONS(2790),
  },
  [1061] = {
    [sym_concatenation] = STATE(1485),
    [sym_string] = STATE(1484),
    [sym_simple_expansion] = STATE(1484),
    [sym_string_expansion] = STATE(1484),
    [sym_expansion] = STATE(1484),
    [sym_command_substitution] = STATE(1484),
    [sym_process_substitution] = STATE(1484),
    [anon_sym_RBRACE] = ACTIONS(3487),
    [sym__special_characters] = ACTIONS(3495),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(3497),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3497),
  },
  [1062] = {
    [sym__concat] = ACTIONS(2831),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_SEMI_SEMI] = ACTIONS(2833),
    [sym__special_characters] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [sym_raw_string] = ACTIONS(2833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2833),
    [anon_sym_BQUOTE] = ACTIONS(2833),
    [anon_sym_LT_LPAREN] = ACTIONS(2833),
    [anon_sym_GT_LPAREN] = ACTIONS(2833),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2831),
    [anon_sym_AMP] = ACTIONS(2833),
  },
  [1063] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3499),
  },
  [1064] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3501),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1065] = {
    [sym__concat] = ACTIONS(2839),
    [anon_sym_in] = ACTIONS(2841),
    [anon_sym_SEMI_SEMI] = ACTIONS(2841),
    [sym__special_characters] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2841),
    [sym_raw_string] = ACTIONS(2841),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2841),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2841),
    [anon_sym_BQUOTE] = ACTIONS(2841),
    [anon_sym_LT_LPAREN] = ACTIONS(2841),
    [anon_sym_GT_LPAREN] = ACTIONS(2841),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2839),
    [anon_sym_AMP] = ACTIONS(2841),
  },
  [1066] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3503),
  },
  [1067] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1068] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3507),
  },
  [1069] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1070] = {
    [sym_concatenation] = STATE(1492),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1492),
    [anon_sym_RBRACE] = ACTIONS(3509),
    [anon_sym_EQ] = ACTIONS(3511),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_DASH] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1071] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_in] = ACTIONS(2857),
    [anon_sym_SEMI_SEMI] = ACTIONS(2857),
    [sym__special_characters] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2857),
    [anon_sym_BQUOTE] = ACTIONS(2857),
    [anon_sym_LT_LPAREN] = ACTIONS(2857),
    [anon_sym_GT_LPAREN] = ACTIONS(2857),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [1072] = {
    [sym_concatenation] = STATE(1494),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1494),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3517),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3519),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3517),
    [anon_sym_COLON_QMARK] = ACTIONS(3517),
    [anon_sym_COLON_DASH] = ACTIONS(3517),
    [anon_sym_PERCENT] = ACTIONS(3517),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1073] = {
    [sym_file_redirect] = STATE(1495),
    [sym_file_descriptor] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(3521),
    [anon_sym_SEMI_SEMI] = ACTIONS(3521),
    [anon_sym_PIPE_AMP] = ACTIONS(3521),
    [anon_sym_AMP_AMP] = ACTIONS(3521),
    [anon_sym_PIPE_PIPE] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3521),
    [anon_sym_LF] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
  },
  [1074] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RBRACE] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [1075] = {
    [sym_file_descriptor] = ACTIONS(3525),
    [anon_sym_esac] = ACTIONS(3527),
    [anon_sym_PIPE] = ACTIONS(3527),
    [anon_sym_RPAREN] = ACTIONS(3527),
    [anon_sym_SEMI_SEMI] = ACTIONS(3527),
    [anon_sym_PIPE_AMP] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_GT_GT] = ACTIONS(3527),
    [anon_sym_AMP_GT] = ACTIONS(3527),
    [anon_sym_AMP_GT_GT] = ACTIONS(3527),
    [anon_sym_LT_AMP] = ACTIONS(3527),
    [anon_sym_GT_AMP] = ACTIONS(3527),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym_LF] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
  },
  [1076] = {
    [sym__terminated_statement] = STATE(1076),
    [sym_for_statement] = STATE(628),
    [sym_while_statement] = STATE(628),
    [sym_if_statement] = STATE(628),
    [sym_case_statement] = STATE(628),
    [sym_function_definition] = STATE(628),
    [sym_subshell] = STATE(628),
    [sym_pipeline] = STATE(628),
    [sym_list] = STATE(628),
    [sym_negated_command] = STATE(628),
    [sym_test_command] = STATE(628),
    [sym_declaration_command] = STATE(628),
    [sym_unset_command] = STATE(628),
    [sym_command] = STATE(628),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(629),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1076),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [1077] = {
    [sym_concatenation] = STATE(1498),
    [sym_string] = STATE(1497),
    [sym_simple_expansion] = STATE(1497),
    [sym_string_expansion] = STATE(1497),
    [sym_expansion] = STATE(1497),
    [sym_command_substitution] = STATE(1497),
    [sym_process_substitution] = STATE(1497),
    [sym__special_characters] = ACTIONS(3529),
    [anon_sym_DQUOTE] = ACTIONS(629),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(3531),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1521),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1523),
    [anon_sym_BQUOTE] = ACTIONS(1525),
    [anon_sym_LT_LPAREN] = ACTIONS(1527),
    [anon_sym_GT_LPAREN] = ACTIONS(1527),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3531),
  },
  [1078] = {
    [aux_sym_concatenation_repeat1] = STATE(1499),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [1079] = {
    [aux_sym_concatenation_repeat1] = STATE(1499),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [1080] = {
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [1081] = {
    [aux_sym_concatenation_repeat1] = STATE(1500),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(1131),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [1082] = {
    [sym_file_redirect] = STATE(657),
    [sym_heredoc_redirect] = STATE(657),
    [sym_heredoc_body] = STATE(1036),
    [sym_herestring_redirect] = STATE(657),
    [aux_sym_while_statement_repeat1] = STATE(657),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_SEMI_SEMI] = ACTIONS(2235),
    [anon_sym_PIPE_AMP] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_LF] = ACTIONS(2237),
    [anon_sym_AMP] = ACTIONS(2235),
  },
  [1083] = {
    [sym_compound_statement] = STATE(1501),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [1084] = {
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_GT] = ACTIONS(3533),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_GT] = ACTIONS(3533),
    [anon_sym_AMP_GT_GT] = ACTIONS(3535),
    [anon_sym_LT_AMP] = ACTIONS(3535),
    [anon_sym_GT_AMP] = ACTIONS(3535),
    [sym_comment] = ACTIONS(53),
  },
  [1085] = {
    [sym_concatenation] = STATE(1080),
    [sym_string] = STATE(1504),
    [sym_simple_expansion] = STATE(1504),
    [sym_string_expansion] = STATE(1504),
    [sym_expansion] = STATE(1504),
    [sym_command_substitution] = STATE(1504),
    [sym_process_substitution] = STATE(1504),
    [sym__special_characters] = ACTIONS(3537),
    [anon_sym_DQUOTE] = ACTIONS(629),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(3539),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1521),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1523),
    [anon_sym_BQUOTE] = ACTIONS(1525),
    [anon_sym_LT_LPAREN] = ACTIONS(1527),
    [anon_sym_GT_LPAREN] = ACTIONS(1527),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3539),
  },
  [1086] = {
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_GT] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3543),
    [anon_sym_AMP_GT] = ACTIONS(3541),
    [anon_sym_AMP_GT_GT] = ACTIONS(3543),
    [anon_sym_LT_AMP] = ACTIONS(3543),
    [anon_sym_GT_AMP] = ACTIONS(3543),
    [sym_comment] = ACTIONS(53),
  },
  [1087] = {
    [sym_concatenation] = STATE(1130),
    [sym_string] = STATE(1507),
    [sym_simple_expansion] = STATE(1507),
    [sym_string_expansion] = STATE(1507),
    [sym_expansion] = STATE(1507),
    [sym_command_substitution] = STATE(1507),
    [sym_process_substitution] = STATE(1507),
    [sym__special_characters] = ACTIONS(3545),
    [anon_sym_DQUOTE] = ACTIONS(2458),
    [anon_sym_DOLLAR] = ACTIONS(2460),
    [sym_raw_string] = ACTIONS(3547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2466),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [anon_sym_LT_LPAREN] = ACTIONS(2470),
    [anon_sym_GT_LPAREN] = ACTIONS(2470),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3547),
  },
  [1088] = {
    [sym_concatenation] = STATE(1134),
    [sym_string] = STATE(1509),
    [sym_simple_expansion] = STATE(1509),
    [sym_string_expansion] = STATE(1509),
    [sym_expansion] = STATE(1509),
    [sym_command_substitution] = STATE(1509),
    [sym_process_substitution] = STATE(1509),
    [sym__special_characters] = ACTIONS(3549),
    [anon_sym_DQUOTE] = ACTIONS(2458),
    [anon_sym_DOLLAR] = ACTIONS(2460),
    [sym_raw_string] = ACTIONS(3551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2466),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [anon_sym_LT_LPAREN] = ACTIONS(2470),
    [anon_sym_GT_LPAREN] = ACTIONS(2470),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3551),
  },
  [1089] = {
    [sym_file_redirect] = STATE(1510),
    [sym_heredoc_redirect] = STATE(1510),
    [sym_herestring_redirect] = STATE(1510),
    [aux_sym_while_statement_repeat1] = STATE(1510),
    [sym_file_descriptor] = ACTIONS(2344),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_RPAREN] = ACTIONS(2478),
    [anon_sym_SEMI_SEMI] = ACTIONS(2478),
    [anon_sym_PIPE_AMP] = ACTIONS(2478),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2346),
    [anon_sym_LT_AMP] = ACTIONS(2346),
    [anon_sym_GT_AMP] = ACTIONS(2346),
    [anon_sym_LT_LT] = ACTIONS(1345),
    [anon_sym_LT_LT_DASH] = ACTIONS(1345),
    [anon_sym_LT_LT_LT] = ACTIONS(2348),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_LF] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2478),
  },
  [1090] = {
    [aux_sym_concatenation_repeat1] = STATE(641),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [sym__special_characters] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1133),
    [sym_word] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1133),
  },
  [1091] = {
    [aux_sym_concatenation_repeat1] = STATE(641),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [1092] = {
    [aux_sym_concatenation_repeat1] = STATE(1092),
    [sym__concat] = ACTIONS(2527),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1093] = {
    [aux_sym_concatenation_repeat1] = STATE(1093),
    [sym__concat] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1094] = {
    [sym_file_redirect] = STATE(1401),
    [sym_file_descriptor] = ACTIONS(2340),
    [anon_sym_PIPE] = ACTIONS(2334),
    [anon_sym_RPAREN] = ACTIONS(2334),
    [anon_sym_SEMI_SEMI] = ACTIONS(2334),
    [anon_sym_PIPE_AMP] = ACTIONS(2334),
    [anon_sym_AMP_AMP] = ACTIONS(2334),
    [anon_sym_PIPE_PIPE] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_GT] = ACTIONS(2342),
    [anon_sym_GT_GT] = ACTIONS(2342),
    [anon_sym_AMP_GT] = ACTIONS(2342),
    [anon_sym_AMP_GT_GT] = ACTIONS(2342),
    [anon_sym_LT_AMP] = ACTIONS(2342),
    [anon_sym_GT_AMP] = ACTIONS(2342),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_LF] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2334),
  },
  [1095] = {
    [aux_sym_concatenation_repeat1] = STATE(1097),
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1096] = {
    [aux_sym_concatenation_repeat1] = STATE(1097),
    [sym__simple_heredoc_body] = ACTIONS(1093),
    [sym__heredoc_body_beginning] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [1097] = {
    [aux_sym_concatenation_repeat1] = STATE(1511),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [1098] = {
    [anon_sym_esac] = ACTIONS(3553),
    [anon_sym_PIPE] = ACTIONS(3553),
    [anon_sym_RPAREN] = ACTIONS(3553),
    [anon_sym_SEMI_SEMI] = ACTIONS(3553),
    [anon_sym_PIPE_AMP] = ACTIONS(3553),
    [anon_sym_AMP_AMP] = ACTIONS(3553),
    [anon_sym_PIPE_PIPE] = ACTIONS(3553),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3553),
    [anon_sym_LF] = ACTIONS(3555),
    [anon_sym_AMP] = ACTIONS(3553),
  },
  [1099] = {
    [sym_file_redirect] = STATE(657),
    [sym_heredoc_redirect] = STATE(657),
    [sym_heredoc_body] = STATE(1417),
    [sym_herestring_redirect] = STATE(657),
    [aux_sym_while_statement_repeat1] = STATE(657),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(3283),
    [anon_sym_RPAREN] = ACTIONS(3283),
    [anon_sym_SEMI_SEMI] = ACTIONS(3283),
    [anon_sym_PIPE_AMP] = ACTIONS(3283),
    [anon_sym_AMP_AMP] = ACTIONS(3283),
    [anon_sym_PIPE_PIPE] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_LF] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3283),
  },
  [1100] = {
    [sym_file_descriptor] = ACTIONS(2127),
    [sym_variable_name] = ACTIONS(2127),
    [anon_sym_PIPE] = ACTIONS(2129),
    [anon_sym_RPAREN] = ACTIONS(2127),
    [anon_sym_PIPE_AMP] = ACTIONS(2127),
    [anon_sym_AMP_AMP] = ACTIONS(2127),
    [anon_sym_PIPE_PIPE] = ACTIONS(2127),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_GT] = ACTIONS(2129),
    [anon_sym_GT_GT] = ACTIONS(2127),
    [anon_sym_AMP_GT] = ACTIONS(2129),
    [anon_sym_AMP_GT_GT] = ACTIONS(2127),
    [anon_sym_LT_AMP] = ACTIONS(2127),
    [anon_sym_GT_AMP] = ACTIONS(2127),
    [sym__special_characters] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(2127),
    [anon_sym_DOLLAR] = ACTIONS(2129),
    [sym_raw_string] = ACTIONS(2127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2127),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2127),
    [anon_sym_BQUOTE] = ACTIONS(2127),
    [anon_sym_LT_LPAREN] = ACTIONS(2127),
    [anon_sym_GT_LPAREN] = ACTIONS(2127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2127),
  },
  [1101] = {
    [sym_concatenation] = STATE(1009),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1009),
    [anon_sym_RPAREN] = ACTIONS(3557),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [1102] = {
    [aux_sym_concatenation_repeat1] = STATE(1102),
    [sym__concat] = ACTIONS(2482),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_EQ_TILDE] = ACTIONS(1642),
    [anon_sym_EQ_EQ] = ACTIONS(1642),
    [anon_sym_EQ] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1642),
    [anon_sym_GT] = ACTIONS(1642),
    [anon_sym_BANG_EQ] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1642),
  },
  [1103] = {
    [sym__concat] = ACTIONS(2710),
    [anon_sym_AMP_AMP] = ACTIONS(2710),
    [anon_sym_PIPE_PIPE] = ACTIONS(2710),
    [anon_sym_RBRACK] = ACTIONS(2710),
    [anon_sym_EQ_TILDE] = ACTIONS(2710),
    [anon_sym_EQ_EQ] = ACTIONS(2710),
    [anon_sym_EQ] = ACTIONS(2712),
    [anon_sym_LT] = ACTIONS(2710),
    [anon_sym_GT] = ACTIONS(2710),
    [anon_sym_BANG_EQ] = ACTIONS(2710),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2710),
  },
  [1104] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3559),
    [sym_comment] = ACTIONS(53),
  },
  [1105] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3561),
    [sym_comment] = ACTIONS(53),
  },
  [1106] = {
    [anon_sym_RBRACE] = ACTIONS(3561),
    [sym_comment] = ACTIONS(53),
  },
  [1107] = {
    [sym_concatenation] = STATE(1516),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1516),
    [anon_sym_RBRACE] = ACTIONS(3563),
    [anon_sym_EQ] = ACTIONS(3565),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3565),
    [anon_sym_COLON_QMARK] = ACTIONS(3565),
    [anon_sym_COLON_DASH] = ACTIONS(3565),
    [anon_sym_PERCENT] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1108] = {
    [sym__concat] = ACTIONS(2788),
    [anon_sym_AMP_AMP] = ACTIONS(2788),
    [anon_sym_PIPE_PIPE] = ACTIONS(2788),
    [anon_sym_RBRACK] = ACTIONS(2788),
    [anon_sym_EQ_TILDE] = ACTIONS(2788),
    [anon_sym_EQ_EQ] = ACTIONS(2788),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2788),
    [anon_sym_GT] = ACTIONS(2788),
    [anon_sym_BANG_EQ] = ACTIONS(2788),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2788),
  },
  [1109] = {
    [sym_concatenation] = STATE(1519),
    [sym_string] = STATE(1518),
    [sym_simple_expansion] = STATE(1518),
    [sym_string_expansion] = STATE(1518),
    [sym_expansion] = STATE(1518),
    [sym_command_substitution] = STATE(1518),
    [sym_process_substitution] = STATE(1518),
    [anon_sym_RBRACE] = ACTIONS(3561),
    [sym__special_characters] = ACTIONS(3569),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(3571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3571),
  },
  [1110] = {
    [sym__concat] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_RBRACK] = ACTIONS(2831),
    [anon_sym_EQ_TILDE] = ACTIONS(2831),
    [anon_sym_EQ_EQ] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_BANG_EQ] = ACTIONS(2831),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2831),
  },
  [1111] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3573),
  },
  [1112] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1113] = {
    [sym__concat] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_RBRACK] = ACTIONS(2839),
    [anon_sym_EQ_TILDE] = ACTIONS(2839),
    [anon_sym_EQ_EQ] = ACTIONS(2839),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2839),
    [anon_sym_GT] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2839),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2839),
  },
  [1114] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3577),
  },
  [1115] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3579),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1116] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3581),
  },
  [1117] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3561),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1118] = {
    [sym_concatenation] = STATE(1526),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1526),
    [anon_sym_RBRACE] = ACTIONS(3583),
    [anon_sym_EQ] = ACTIONS(3585),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3587),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_COLON_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_DASH] = ACTIONS(3585),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1119] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_RBRACK] = ACTIONS(2855),
    [anon_sym_EQ_TILDE] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2855),
  },
  [1120] = {
    [sym_concatenation] = STATE(1528),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1528),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_EQ] = ACTIONS(3591),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3593),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3591),
    [anon_sym_COLON_QMARK] = ACTIONS(3591),
    [anon_sym_COLON_DASH] = ACTIONS(3591),
    [anon_sym_PERCENT] = ACTIONS(3591),
    [anon_sym_DASH] = ACTIONS(3591),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1121] = {
    [sym_concatenation] = STATE(1531),
    [sym_string] = STATE(1530),
    [sym_simple_expansion] = STATE(1530),
    [sym_string_expansion] = STATE(1530),
    [sym_expansion] = STATE(1530),
    [sym_command_substitution] = STATE(1530),
    [sym_process_substitution] = STATE(1530),
    [sym__special_characters] = ACTIONS(3595),
    [anon_sym_DQUOTE] = ACTIONS(2458),
    [anon_sym_DOLLAR] = ACTIONS(2460),
    [sym_raw_string] = ACTIONS(3597),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2466),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [anon_sym_LT_LPAREN] = ACTIONS(2470),
    [anon_sym_GT_LPAREN] = ACTIONS(2470),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3597),
  },
  [1122] = {
    [aux_sym_concatenation_repeat1] = STATE(1533),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(665),
    [anon_sym_LT_LT_LT] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [1123] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(1535),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [1124] = {
    [sym_string] = STATE(1537),
    [anon_sym_DQUOTE] = ACTIONS(2458),
    [anon_sym_DOLLAR] = ACTIONS(3603),
    [sym_raw_string] = ACTIONS(3605),
    [anon_sym_POUND] = ACTIONS(3603),
    [anon_sym_DASH] = ACTIONS(3603),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3603),
    [anon_sym_AT] = ACTIONS(3603),
    [anon_sym_QMARK] = ACTIONS(3603),
    [anon_sym_0] = ACTIONS(3609),
    [anon_sym__] = ACTIONS(3609),
  },
  [1125] = {
    [aux_sym_concatenation_repeat1] = STATE(1533),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [1126] = {
    [sym_subscript] = STATE(1543),
    [sym_variable_name] = ACTIONS(3611),
    [anon_sym_DOLLAR] = ACTIONS(3613),
    [anon_sym_POUND] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3613),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3617),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_AT] = ACTIONS(3613),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_0] = ACTIONS(3619),
    [anon_sym__] = ACTIONS(3619),
  },
  [1127] = {
    [sym_for_statement] = STATE(1544),
    [sym_while_statement] = STATE(1544),
    [sym_if_statement] = STATE(1544),
    [sym_case_statement] = STATE(1544),
    [sym_function_definition] = STATE(1544),
    [sym_subshell] = STATE(1544),
    [sym_pipeline] = STATE(1544),
    [sym_list] = STATE(1544),
    [sym_negated_command] = STATE(1544),
    [sym_test_command] = STATE(1544),
    [sym_declaration_command] = STATE(1544),
    [sym_unset_command] = STATE(1544),
    [sym_command] = STATE(1544),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(1545),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [1128] = {
    [sym_for_statement] = STATE(1546),
    [sym_while_statement] = STATE(1546),
    [sym_if_statement] = STATE(1546),
    [sym_case_statement] = STATE(1546),
    [sym_function_definition] = STATE(1546),
    [sym_subshell] = STATE(1546),
    [sym_pipeline] = STATE(1546),
    [sym_list] = STATE(1546),
    [sym_negated_command] = STATE(1546),
    [sym_test_command] = STATE(1546),
    [sym_declaration_command] = STATE(1546),
    [sym_unset_command] = STATE(1546),
    [sym_command] = STATE(1546),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(1547),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [1129] = {
    [sym_for_statement] = STATE(1548),
    [sym_while_statement] = STATE(1548),
    [sym_if_statement] = STATE(1548),
    [sym_case_statement] = STATE(1548),
    [sym_function_definition] = STATE(1548),
    [sym_subshell] = STATE(1548),
    [sym_pipeline] = STATE(1548),
    [sym_list] = STATE(1548),
    [sym_negated_command] = STATE(1548),
    [sym_test_command] = STATE(1548),
    [sym_declaration_command] = STATE(1548),
    [sym_unset_command] = STATE(1548),
    [sym_command] = STATE(1548),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(1549),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [1130] = {
    [sym_file_descriptor] = ACTIONS(677),
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [1131] = {
    [sym_file_descriptor] = ACTIONS(2054),
    [anon_sym_esac] = ACTIONS(2056),
    [anon_sym_PIPE] = ACTIONS(2056),
    [anon_sym_RPAREN] = ACTIONS(2056),
    [anon_sym_SEMI_SEMI] = ACTIONS(2056),
    [anon_sym_PIPE_AMP] = ACTIONS(2056),
    [anon_sym_AMP_AMP] = ACTIONS(2056),
    [anon_sym_PIPE_PIPE] = ACTIONS(2056),
    [anon_sym_LT] = ACTIONS(2056),
    [anon_sym_GT] = ACTIONS(2056),
    [anon_sym_GT_GT] = ACTIONS(2056),
    [anon_sym_AMP_GT] = ACTIONS(2056),
    [anon_sym_AMP_GT_GT] = ACTIONS(2056),
    [anon_sym_LT_AMP] = ACTIONS(2056),
    [anon_sym_GT_AMP] = ACTIONS(2056),
    [anon_sym_LT_LT] = ACTIONS(2056),
    [anon_sym_LT_LT_DASH] = ACTIONS(2056),
    [anon_sym_LT_LT_LT] = ACTIONS(2056),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2056),
    [anon_sym_LF] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2056),
  },
  [1132] = {
    [aux_sym_concatenation_repeat1] = STATE(1533),
    [sym_file_descriptor] = ACTIONS(2058),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_SEMI_SEMI] = ACTIONS(2060),
    [anon_sym_PIPE_AMP] = ACTIONS(2060),
    [anon_sym_AMP_AMP] = ACTIONS(2060),
    [anon_sym_PIPE_PIPE] = ACTIONS(2060),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2060),
    [anon_sym_LT_AMP] = ACTIONS(2060),
    [anon_sym_GT_AMP] = ACTIONS(2060),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2060),
    [anon_sym_LT_LT_LT] = ACTIONS(2060),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2060),
  },
  [1133] = {
    [aux_sym_concatenation_repeat1] = STATE(1533),
    [sym_file_descriptor] = ACTIONS(2062),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [1134] = {
    [sym_file_descriptor] = ACTIONS(2062),
    [anon_sym_esac] = ACTIONS(2064),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_RPAREN] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [1135] = {
    [sym_file_redirect] = STATE(1135),
    [sym_heredoc_redirect] = STATE(1135),
    [sym_herestring_redirect] = STATE(1135),
    [aux_sym_while_statement_repeat1] = STATE(1135),
    [sym_file_descriptor] = ACTIONS(3621),
    [anon_sym_PIPE] = ACTIONS(2075),
    [anon_sym_SEMI_SEMI] = ACTIONS(2075),
    [anon_sym_PIPE_AMP] = ACTIONS(2075),
    [anon_sym_AMP_AMP] = ACTIONS(2075),
    [anon_sym_PIPE_PIPE] = ACTIONS(2075),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(3624),
    [anon_sym_GT_GT] = ACTIONS(3624),
    [anon_sym_AMP_GT] = ACTIONS(3624),
    [anon_sym_AMP_GT_GT] = ACTIONS(3624),
    [anon_sym_LT_AMP] = ACTIONS(3624),
    [anon_sym_GT_AMP] = ACTIONS(3624),
    [anon_sym_LT_LT] = ACTIONS(3627),
    [anon_sym_LT_LT_DASH] = ACTIONS(3627),
    [anon_sym_LT_LT_LT] = ACTIONS(3630),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_LF] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2075),
  },
  [1136] = {
    [sym__concat] = ACTIONS(2710),
    [anon_sym_PIPE] = ACTIONS(2712),
    [anon_sym_RPAREN] = ACTIONS(2710),
    [anon_sym_AMP_AMP] = ACTIONS(2710),
    [anon_sym_PIPE_PIPE] = ACTIONS(2710),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2710),
    [anon_sym_EQ_TILDE] = ACTIONS(2710),
    [anon_sym_EQ_EQ] = ACTIONS(2710),
    [anon_sym_EQ] = ACTIONS(2712),
    [anon_sym_LT] = ACTIONS(2710),
    [anon_sym_GT] = ACTIONS(2710),
    [anon_sym_BANG_EQ] = ACTIONS(2710),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2710),
  },
  [1137] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3633),
    [sym_comment] = ACTIONS(53),
  },
  [1138] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [sym_comment] = ACTIONS(53),
  },
  [1139] = {
    [anon_sym_RBRACE] = ACTIONS(3635),
    [sym_comment] = ACTIONS(53),
  },
  [1140] = {
    [sym_concatenation] = STATE(1553),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1553),
    [anon_sym_RBRACE] = ACTIONS(3637),
    [anon_sym_EQ] = ACTIONS(3639),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3639),
    [anon_sym_COLON_QMARK] = ACTIONS(3639),
    [anon_sym_COLON_DASH] = ACTIONS(3639),
    [anon_sym_PERCENT] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1141] = {
    [sym__concat] = ACTIONS(2788),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_RPAREN] = ACTIONS(2788),
    [anon_sym_AMP_AMP] = ACTIONS(2788),
    [anon_sym_PIPE_PIPE] = ACTIONS(2788),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2788),
    [anon_sym_EQ_TILDE] = ACTIONS(2788),
    [anon_sym_EQ_EQ] = ACTIONS(2788),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2788),
    [anon_sym_GT] = ACTIONS(2788),
    [anon_sym_BANG_EQ] = ACTIONS(2788),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2788),
  },
  [1142] = {
    [sym_concatenation] = STATE(1556),
    [sym_string] = STATE(1555),
    [sym_simple_expansion] = STATE(1555),
    [sym_string_expansion] = STATE(1555),
    [sym_expansion] = STATE(1555),
    [sym_command_substitution] = STATE(1555),
    [sym_process_substitution] = STATE(1555),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [sym__special_characters] = ACTIONS(3643),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(3645),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3645),
  },
  [1143] = {
    [sym__concat] = ACTIONS(2831),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2831),
    [anon_sym_EQ_TILDE] = ACTIONS(2831),
    [anon_sym_EQ_EQ] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_BANG_EQ] = ACTIONS(2831),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2831),
  },
  [1144] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3647),
  },
  [1145] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3649),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1146] = {
    [sym__concat] = ACTIONS(2839),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_RPAREN] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2839),
    [anon_sym_EQ_TILDE] = ACTIONS(2839),
    [anon_sym_EQ_EQ] = ACTIONS(2839),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2839),
    [anon_sym_GT] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2839),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2839),
  },
  [1147] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3651),
  },
  [1148] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3653),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1149] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3655),
  },
  [1150] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1151] = {
    [sym_concatenation] = STATE(1563),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1563),
    [anon_sym_RBRACE] = ACTIONS(3657),
    [anon_sym_EQ] = ACTIONS(3659),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3659),
    [anon_sym_COLON_QMARK] = ACTIONS(3659),
    [anon_sym_COLON_DASH] = ACTIONS(3659),
    [anon_sym_PERCENT] = ACTIONS(3659),
    [anon_sym_DASH] = ACTIONS(3659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1152] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2855),
    [anon_sym_EQ_TILDE] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2855),
  },
  [1153] = {
    [sym_concatenation] = STATE(1565),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1565),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(3665),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3665),
    [anon_sym_COLON_QMARK] = ACTIONS(3665),
    [anon_sym_COLON_DASH] = ACTIONS(3665),
    [anon_sym_PERCENT] = ACTIONS(3665),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1154] = {
    [sym_variable_name] = ACTIONS(2127),
    [anon_sym_PIPE] = ACTIONS(2129),
    [anon_sym_RPAREN] = ACTIONS(2129),
    [anon_sym_SEMI_SEMI] = ACTIONS(2129),
    [anon_sym_PIPE_AMP] = ACTIONS(2129),
    [anon_sym_AMP_AMP] = ACTIONS(2129),
    [anon_sym_PIPE_PIPE] = ACTIONS(2129),
    [sym__special_characters] = ACTIONS(2129),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_DOLLAR] = ACTIONS(2129),
    [sym_raw_string] = ACTIONS(2129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2129),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [anon_sym_LT_LPAREN] = ACTIONS(2129),
    [anon_sym_GT_LPAREN] = ACTIONS(2129),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2129),
    [sym_word] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_LF] = ACTIONS(2127),
    [anon_sym_AMP] = ACTIONS(2129),
  },
  [1155] = {
    [sym_concatenation] = STATE(1009),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1009),
    [anon_sym_RPAREN] = ACTIONS(3669),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [1156] = {
    [sym__concat] = ACTIONS(2710),
    [sym_variable_name] = ACTIONS(2710),
    [anon_sym_PIPE] = ACTIONS(2712),
    [anon_sym_RPAREN] = ACTIONS(2712),
    [anon_sym_SEMI_SEMI] = ACTIONS(2712),
    [anon_sym_PIPE_AMP] = ACTIONS(2712),
    [anon_sym_AMP_AMP] = ACTIONS(2712),
    [anon_sym_PIPE_PIPE] = ACTIONS(2712),
    [sym__special_characters] = ACTIONS(2712),
    [anon_sym_DQUOTE] = ACTIONS(2712),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [sym_raw_string] = ACTIONS(2712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2712),
    [anon_sym_BQUOTE] = ACTIONS(2712),
    [anon_sym_LT_LPAREN] = ACTIONS(2712),
    [anon_sym_GT_LPAREN] = ACTIONS(2712),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2712),
    [sym_word] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_LF] = ACTIONS(2710),
    [anon_sym_AMP] = ACTIONS(2712),
  },
  [1157] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [sym_comment] = ACTIONS(53),
  },
  [1158] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3673),
    [sym_comment] = ACTIONS(53),
  },
  [1159] = {
    [anon_sym_RBRACE] = ACTIONS(3673),
    [sym_comment] = ACTIONS(53),
  },
  [1160] = {
    [sym_concatenation] = STATE(1570),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1570),
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_EQ] = ACTIONS(3677),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3677),
    [anon_sym_COLON_QMARK] = ACTIONS(3677),
    [anon_sym_COLON_DASH] = ACTIONS(3677),
    [anon_sym_PERCENT] = ACTIONS(3677),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1161] = {
    [sym__concat] = ACTIONS(2788),
    [sym_variable_name] = ACTIONS(2788),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_RPAREN] = ACTIONS(2790),
    [anon_sym_SEMI_SEMI] = ACTIONS(2790),
    [anon_sym_PIPE_AMP] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2790),
    [anon_sym_PIPE_PIPE] = ACTIONS(2790),
    [sym__special_characters] = ACTIONS(2790),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym_raw_string] = ACTIONS(2790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2790),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [anon_sym_LT_LPAREN] = ACTIONS(2790),
    [anon_sym_GT_LPAREN] = ACTIONS(2790),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2790),
    [sym_word] = ACTIONS(2790),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_LF] = ACTIONS(2788),
    [anon_sym_AMP] = ACTIONS(2790),
  },
  [1162] = {
    [sym_concatenation] = STATE(1573),
    [sym_string] = STATE(1572),
    [sym_simple_expansion] = STATE(1572),
    [sym_string_expansion] = STATE(1572),
    [sym_expansion] = STATE(1572),
    [sym_command_substitution] = STATE(1572),
    [sym_process_substitution] = STATE(1572),
    [anon_sym_RBRACE] = ACTIONS(3673),
    [sym__special_characters] = ACTIONS(3681),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(3683),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3683),
  },
  [1163] = {
    [sym__concat] = ACTIONS(2831),
    [sym_variable_name] = ACTIONS(2831),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2833),
    [anon_sym_SEMI_SEMI] = ACTIONS(2833),
    [anon_sym_PIPE_AMP] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [sym__special_characters] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [sym_raw_string] = ACTIONS(2833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2833),
    [anon_sym_BQUOTE] = ACTIONS(2833),
    [anon_sym_LT_LPAREN] = ACTIONS(2833),
    [anon_sym_GT_LPAREN] = ACTIONS(2833),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2833),
    [sym_word] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2831),
    [anon_sym_AMP] = ACTIONS(2833),
  },
  [1164] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3685),
  },
  [1165] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1166] = {
    [sym__concat] = ACTIONS(2839),
    [sym_variable_name] = ACTIONS(2839),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_RPAREN] = ACTIONS(2841),
    [anon_sym_SEMI_SEMI] = ACTIONS(2841),
    [anon_sym_PIPE_AMP] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [sym__special_characters] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2841),
    [sym_raw_string] = ACTIONS(2841),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2841),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2841),
    [anon_sym_BQUOTE] = ACTIONS(2841),
    [anon_sym_LT_LPAREN] = ACTIONS(2841),
    [anon_sym_GT_LPAREN] = ACTIONS(2841),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2841),
    [sym_word] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2839),
    [anon_sym_AMP] = ACTIONS(2841),
  },
  [1167] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3689),
  },
  [1168] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3691),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1169] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3693),
  },
  [1170] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3673),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1171] = {
    [sym_concatenation] = STATE(1580),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1580),
    [anon_sym_RBRACE] = ACTIONS(3695),
    [anon_sym_EQ] = ACTIONS(3697),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_COLON_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_DASH] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1172] = {
    [sym__concat] = ACTIONS(2855),
    [sym_variable_name] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2857),
    [anon_sym_SEMI_SEMI] = ACTIONS(2857),
    [anon_sym_PIPE_AMP] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2857),
    [sym__special_characters] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2857),
    [anon_sym_BQUOTE] = ACTIONS(2857),
    [anon_sym_LT_LPAREN] = ACTIONS(2857),
    [anon_sym_GT_LPAREN] = ACTIONS(2857),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2857),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [1173] = {
    [sym_concatenation] = STATE(1582),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1582),
    [anon_sym_RBRACE] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(3703),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3705),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3703),
    [anon_sym_COLON_QMARK] = ACTIONS(3703),
    [anon_sym_COLON_DASH] = ACTIONS(3703),
    [anon_sym_PERCENT] = ACTIONS(3703),
    [anon_sym_DASH] = ACTIONS(3703),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1174] = {
    [sym__concat] = ACTIONS(2710),
    [anon_sym_PIPE] = ACTIONS(2712),
    [anon_sym_RPAREN] = ACTIONS(2712),
    [anon_sym_SEMI_SEMI] = ACTIONS(2712),
    [anon_sym_PIPE_AMP] = ACTIONS(2712),
    [anon_sym_AMP_AMP] = ACTIONS(2712),
    [anon_sym_PIPE_PIPE] = ACTIONS(2712),
    [sym__special_characters] = ACTIONS(2712),
    [anon_sym_DQUOTE] = ACTIONS(2712),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [sym_raw_string] = ACTIONS(2712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2712),
    [anon_sym_BQUOTE] = ACTIONS(2712),
    [anon_sym_LT_LPAREN] = ACTIONS(2712),
    [anon_sym_GT_LPAREN] = ACTIONS(2712),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2712),
    [sym_word] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_LF] = ACTIONS(2710),
    [anon_sym_AMP] = ACTIONS(2712),
  },
  [1175] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3707),
    [sym_comment] = ACTIONS(53),
  },
  [1176] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3709),
    [sym_comment] = ACTIONS(53),
  },
  [1177] = {
    [anon_sym_RBRACE] = ACTIONS(3709),
    [sym_comment] = ACTIONS(53),
  },
  [1178] = {
    [sym_concatenation] = STATE(1586),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1586),
    [anon_sym_RBRACE] = ACTIONS(3711),
    [anon_sym_EQ] = ACTIONS(3713),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3713),
    [anon_sym_COLON_QMARK] = ACTIONS(3713),
    [anon_sym_COLON_DASH] = ACTIONS(3713),
    [anon_sym_PERCENT] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3713),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1179] = {
    [sym__concat] = ACTIONS(2788),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_RPAREN] = ACTIONS(2790),
    [anon_sym_SEMI_SEMI] = ACTIONS(2790),
    [anon_sym_PIPE_AMP] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2790),
    [anon_sym_PIPE_PIPE] = ACTIONS(2790),
    [sym__special_characters] = ACTIONS(2790),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym_raw_string] = ACTIONS(2790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2790),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [anon_sym_LT_LPAREN] = ACTIONS(2790),
    [anon_sym_GT_LPAREN] = ACTIONS(2790),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2790),
    [sym_word] = ACTIONS(2790),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_LF] = ACTIONS(2788),
    [anon_sym_AMP] = ACTIONS(2790),
  },
  [1180] = {
    [sym_concatenation] = STATE(1589),
    [sym_string] = STATE(1588),
    [sym_simple_expansion] = STATE(1588),
    [sym_string_expansion] = STATE(1588),
    [sym_expansion] = STATE(1588),
    [sym_command_substitution] = STATE(1588),
    [sym_process_substitution] = STATE(1588),
    [anon_sym_RBRACE] = ACTIONS(3709),
    [sym__special_characters] = ACTIONS(3717),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(3719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3719),
  },
  [1181] = {
    [sym__concat] = ACTIONS(2831),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2833),
    [anon_sym_SEMI_SEMI] = ACTIONS(2833),
    [anon_sym_PIPE_AMP] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [sym__special_characters] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [sym_raw_string] = ACTIONS(2833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2833),
    [anon_sym_BQUOTE] = ACTIONS(2833),
    [anon_sym_LT_LPAREN] = ACTIONS(2833),
    [anon_sym_GT_LPAREN] = ACTIONS(2833),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2833),
    [sym_word] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2831),
    [anon_sym_AMP] = ACTIONS(2833),
  },
  [1182] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3721),
  },
  [1183] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3723),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1184] = {
    [sym__concat] = ACTIONS(2839),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_RPAREN] = ACTIONS(2841),
    [anon_sym_SEMI_SEMI] = ACTIONS(2841),
    [anon_sym_PIPE_AMP] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [sym__special_characters] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2841),
    [sym_raw_string] = ACTIONS(2841),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2841),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2841),
    [anon_sym_BQUOTE] = ACTIONS(2841),
    [anon_sym_LT_LPAREN] = ACTIONS(2841),
    [anon_sym_GT_LPAREN] = ACTIONS(2841),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2841),
    [sym_word] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2839),
    [anon_sym_AMP] = ACTIONS(2841),
  },
  [1185] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3725),
  },
  [1186] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3727),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1187] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3729),
  },
  [1188] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3709),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1189] = {
    [sym_concatenation] = STATE(1596),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1596),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_EQ] = ACTIONS(3733),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3733),
    [anon_sym_COLON_QMARK] = ACTIONS(3733),
    [anon_sym_COLON_DASH] = ACTIONS(3733),
    [anon_sym_PERCENT] = ACTIONS(3733),
    [anon_sym_DASH] = ACTIONS(3733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1190] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2857),
    [anon_sym_SEMI_SEMI] = ACTIONS(2857),
    [anon_sym_PIPE_AMP] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2857),
    [sym__special_characters] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2857),
    [anon_sym_BQUOTE] = ACTIONS(2857),
    [anon_sym_LT_LPAREN] = ACTIONS(2857),
    [anon_sym_GT_LPAREN] = ACTIONS(2857),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2857),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [1191] = {
    [sym_concatenation] = STATE(1598),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1598),
    [anon_sym_RBRACE] = ACTIONS(3737),
    [anon_sym_EQ] = ACTIONS(3739),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3739),
    [anon_sym_COLON_QMARK] = ACTIONS(3739),
    [anon_sym_COLON_DASH] = ACTIONS(3739),
    [anon_sym_PERCENT] = ACTIONS(3739),
    [anon_sym_DASH] = ACTIONS(3739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1192] = {
    [sym_file_descriptor] = ACTIONS(2710),
    [sym__concat] = ACTIONS(2710),
    [sym_variable_name] = ACTIONS(2710),
    [anon_sym_PIPE] = ACTIONS(2712),
    [anon_sym_RPAREN] = ACTIONS(2710),
    [anon_sym_PIPE_AMP] = ACTIONS(2710),
    [anon_sym_AMP_AMP] = ACTIONS(2710),
    [anon_sym_PIPE_PIPE] = ACTIONS(2710),
    [anon_sym_LT] = ACTIONS(2712),
    [anon_sym_GT] = ACTIONS(2712),
    [anon_sym_GT_GT] = ACTIONS(2710),
    [anon_sym_AMP_GT] = ACTIONS(2712),
    [anon_sym_AMP_GT_GT] = ACTIONS(2710),
    [anon_sym_LT_AMP] = ACTIONS(2710),
    [anon_sym_GT_AMP] = ACTIONS(2710),
    [sym__special_characters] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(2710),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [sym_raw_string] = ACTIONS(2710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2710),
    [anon_sym_BQUOTE] = ACTIONS(2710),
    [anon_sym_LT_LPAREN] = ACTIONS(2710),
    [anon_sym_GT_LPAREN] = ACTIONS(2710),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2710),
  },
  [1193] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3743),
    [sym_comment] = ACTIONS(53),
  },
  [1194] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3745),
    [sym_comment] = ACTIONS(53),
  },
  [1195] = {
    [anon_sym_RBRACE] = ACTIONS(3745),
    [sym_comment] = ACTIONS(53),
  },
  [1196] = {
    [sym_concatenation] = STATE(1602),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1602),
    [anon_sym_RBRACE] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3749),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3749),
    [anon_sym_COLON_QMARK] = ACTIONS(3749),
    [anon_sym_COLON_DASH] = ACTIONS(3749),
    [anon_sym_PERCENT] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1197] = {
    [sym_file_descriptor] = ACTIONS(2788),
    [sym__concat] = ACTIONS(2788),
    [sym_variable_name] = ACTIONS(2788),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_RPAREN] = ACTIONS(2788),
    [anon_sym_PIPE_AMP] = ACTIONS(2788),
    [anon_sym_AMP_AMP] = ACTIONS(2788),
    [anon_sym_PIPE_PIPE] = ACTIONS(2788),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2788),
    [anon_sym_AMP_GT] = ACTIONS(2790),
    [anon_sym_AMP_GT_GT] = ACTIONS(2788),
    [anon_sym_LT_AMP] = ACTIONS(2788),
    [anon_sym_GT_AMP] = ACTIONS(2788),
    [sym__special_characters] = ACTIONS(2788),
    [anon_sym_DQUOTE] = ACTIONS(2788),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym_raw_string] = ACTIONS(2788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2788),
    [anon_sym_BQUOTE] = ACTIONS(2788),
    [anon_sym_LT_LPAREN] = ACTIONS(2788),
    [anon_sym_GT_LPAREN] = ACTIONS(2788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2788),
  },
  [1198] = {
    [sym_concatenation] = STATE(1605),
    [sym_string] = STATE(1604),
    [sym_simple_expansion] = STATE(1604),
    [sym_string_expansion] = STATE(1604),
    [sym_expansion] = STATE(1604),
    [sym_command_substitution] = STATE(1604),
    [sym_process_substitution] = STATE(1604),
    [anon_sym_RBRACE] = ACTIONS(3745),
    [sym__special_characters] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(3755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3755),
  },
  [1199] = {
    [sym_file_descriptor] = ACTIONS(2831),
    [sym__concat] = ACTIONS(2831),
    [sym_variable_name] = ACTIONS(2831),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2831),
    [anon_sym_PIPE_AMP] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2831),
    [anon_sym_AMP_GT] = ACTIONS(2833),
    [anon_sym_AMP_GT_GT] = ACTIONS(2831),
    [anon_sym_LT_AMP] = ACTIONS(2831),
    [anon_sym_GT_AMP] = ACTIONS(2831),
    [sym__special_characters] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [sym_raw_string] = ACTIONS(2831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2831),
    [anon_sym_BQUOTE] = ACTIONS(2831),
    [anon_sym_LT_LPAREN] = ACTIONS(2831),
    [anon_sym_GT_LPAREN] = ACTIONS(2831),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2831),
  },
  [1200] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3757),
  },
  [1201] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1202] = {
    [sym_file_descriptor] = ACTIONS(2839),
    [sym__concat] = ACTIONS(2839),
    [sym_variable_name] = ACTIONS(2839),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_RPAREN] = ACTIONS(2839),
    [anon_sym_PIPE_AMP] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_GT] = ACTIONS(2841),
    [anon_sym_GT_GT] = ACTIONS(2839),
    [anon_sym_AMP_GT] = ACTIONS(2841),
    [anon_sym_AMP_GT_GT] = ACTIONS(2839),
    [anon_sym_LT_AMP] = ACTIONS(2839),
    [anon_sym_GT_AMP] = ACTIONS(2839),
    [sym__special_characters] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_DOLLAR] = ACTIONS(2841),
    [sym_raw_string] = ACTIONS(2839),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2839),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2839),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_LT_LPAREN] = ACTIONS(2839),
    [anon_sym_GT_LPAREN] = ACTIONS(2839),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2839),
  },
  [1203] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3761),
  },
  [1204] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3763),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1205] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3765),
  },
  [1206] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3745),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1207] = {
    [sym_concatenation] = STATE(1612),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1612),
    [anon_sym_RBRACE] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3769),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3771),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3769),
    [anon_sym_COLON_QMARK] = ACTIONS(3769),
    [anon_sym_COLON_DASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1208] = {
    [sym_file_descriptor] = ACTIONS(2855),
    [sym__concat] = ACTIONS(2855),
    [sym_variable_name] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_AMP_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT_GT] = ACTIONS(2855),
    [anon_sym_LT_AMP] = ACTIONS(2855),
    [anon_sym_GT_AMP] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2855),
  },
  [1209] = {
    [sym_concatenation] = STATE(1614),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1614),
    [anon_sym_RBRACE] = ACTIONS(3773),
    [anon_sym_EQ] = ACTIONS(3775),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3775),
    [anon_sym_COLON_QMARK] = ACTIONS(3775),
    [anon_sym_COLON_DASH] = ACTIONS(3775),
    [anon_sym_PERCENT] = ACTIONS(3775),
    [anon_sym_DASH] = ACTIONS(3775),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1210] = {
    [sym__concat] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(2712),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [sym__string_content] = ACTIONS(2710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2712),
    [anon_sym_BQUOTE] = ACTIONS(2712),
    [sym_comment] = ACTIONS(177),
  },
  [1211] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3779),
    [sym_comment] = ACTIONS(53),
  },
  [1212] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [sym_comment] = ACTIONS(53),
  },
  [1213] = {
    [anon_sym_RBRACE] = ACTIONS(3781),
    [sym_comment] = ACTIONS(53),
  },
  [1214] = {
    [sym_concatenation] = STATE(1618),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1618),
    [anon_sym_RBRACE] = ACTIONS(3783),
    [anon_sym_EQ] = ACTIONS(3785),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_COLON_QMARK] = ACTIONS(3785),
    [anon_sym_COLON_DASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1215] = {
    [sym__concat] = ACTIONS(2788),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym__string_content] = ACTIONS(2788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2790),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [sym_comment] = ACTIONS(177),
  },
  [1216] = {
    [sym_concatenation] = STATE(1621),
    [sym_string] = STATE(1620),
    [sym_simple_expansion] = STATE(1620),
    [sym_string_expansion] = STATE(1620),
    [sym_expansion] = STATE(1620),
    [sym_command_substitution] = STATE(1620),
    [sym_process_substitution] = STATE(1620),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [sym__special_characters] = ACTIONS(3789),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(3791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3791),
  },
  [1217] = {
    [sym__concat] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [sym__string_content] = ACTIONS(2831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2833),
    [anon_sym_BQUOTE] = ACTIONS(2833),
    [sym_comment] = ACTIONS(177),
  },
  [1218] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3793),
  },
  [1219] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3795),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1220] = {
    [sym__concat] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2841),
    [sym__string_content] = ACTIONS(2839),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2841),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2841),
    [anon_sym_BQUOTE] = ACTIONS(2841),
    [sym_comment] = ACTIONS(177),
  },
  [1221] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3797),
  },
  [1222] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3799),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1223] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3801),
  },
  [1224] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1225] = {
    [sym_concatenation] = STATE(1628),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1628),
    [anon_sym_RBRACE] = ACTIONS(3803),
    [anon_sym_EQ] = ACTIONS(3805),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3805),
    [anon_sym_COLON_QMARK] = ACTIONS(3805),
    [anon_sym_COLON_DASH] = ACTIONS(3805),
    [anon_sym_PERCENT] = ACTIONS(3805),
    [anon_sym_DASH] = ACTIONS(3805),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1226] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym__string_content] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2857),
    [anon_sym_BQUOTE] = ACTIONS(2857),
    [sym_comment] = ACTIONS(177),
  },
  [1227] = {
    [sym_concatenation] = STATE(1630),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1630),
    [anon_sym_RBRACE] = ACTIONS(3809),
    [anon_sym_EQ] = ACTIONS(3811),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3813),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3811),
    [anon_sym_COLON_QMARK] = ACTIONS(3811),
    [anon_sym_COLON_DASH] = ACTIONS(3811),
    [anon_sym_PERCENT] = ACTIONS(3811),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1228] = {
    [sym_string] = STATE(671),
    [sym_simple_expansion] = STATE(671),
    [sym_string_expansion] = STATE(671),
    [sym_expansion] = STATE(671),
    [sym_command_substitution] = STATE(671),
    [sym_process_substitution] = STATE(671),
    [anon_sym_RBRACK] = ACTIONS(3815),
    [sym__special_characters] = ACTIONS(2115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(1297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1297),
  },
  [1229] = {
    [sym__concat] = ACTIONS(3817),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_EQ] = ACTIONS(3819),
    [sym__special_characters] = ACTIONS(3819),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_DOLLAR] = ACTIONS(3819),
    [sym_raw_string] = ACTIONS(2119),
    [anon_sym_POUND] = ACTIONS(2119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2119),
    [aux_sym_SLASH] = ACTIONS(2119),
    [anon_sym_COLON] = ACTIONS(3819),
    [anon_sym_COLON_QMARK] = ACTIONS(3819),
    [anon_sym_COLON_DASH] = ACTIONS(3819),
    [anon_sym_PERCENT] = ACTIONS(3819),
    [anon_sym_DASH] = ACTIONS(3819),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2119),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [anon_sym_LT_LPAREN] = ACTIONS(2119),
    [anon_sym_GT_LPAREN] = ACTIONS(2119),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3819),
  },
  [1230] = {
    [sym_string] = STATE(671),
    [sym_simple_expansion] = STATE(671),
    [sym_string_expansion] = STATE(671),
    [sym_expansion] = STATE(671),
    [sym_command_substitution] = STATE(671),
    [sym_process_substitution] = STATE(671),
    [anon_sym_RBRACK] = ACTIONS(3821),
    [sym__special_characters] = ACTIONS(2115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(1297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1297),
  },
  [1231] = {
    [sym__concat] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_EQ] = ACTIONS(3825),
    [sym__special_characters] = ACTIONS(3825),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [anon_sym_DOLLAR] = ACTIONS(3825),
    [sym_raw_string] = ACTIONS(2125),
    [anon_sym_POUND] = ACTIONS(2125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2125),
    [aux_sym_SLASH] = ACTIONS(2125),
    [anon_sym_COLON] = ACTIONS(3825),
    [anon_sym_COLON_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_DASH] = ACTIONS(3825),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2125),
    [anon_sym_BQUOTE] = ACTIONS(2125),
    [anon_sym_LT_LPAREN] = ACTIONS(2125),
    [anon_sym_GT_LPAREN] = ACTIONS(2125),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3825),
  },
  [1232] = {
    [anon_sym_RBRACK] = ACTIONS(3821),
    [sym_comment] = ACTIONS(53),
  },
  [1233] = {
    [sym_string] = STATE(1635),
    [sym_simple_expansion] = STATE(1635),
    [sym_string_expansion] = STATE(1635),
    [sym_expansion] = STATE(1635),
    [sym_command_substitution] = STATE(1635),
    [sym_process_substitution] = STATE(1635),
    [sym__special_characters] = ACTIONS(3827),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(3827),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3827),
  },
  [1234] = {
    [sym__simple_heredoc_body] = ACTIONS(3829),
    [sym__heredoc_body_beginning] = ACTIONS(3829),
    [sym_file_descriptor] = ACTIONS(3829),
    [sym__concat] = ACTIONS(3829),
    [anon_sym_esac] = ACTIONS(3831),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_RPAREN] = ACTIONS(3831),
    [anon_sym_SEMI_SEMI] = ACTIONS(3831),
    [anon_sym_PIPE_AMP] = ACTIONS(3831),
    [anon_sym_AMP_AMP] = ACTIONS(3831),
    [anon_sym_PIPE_PIPE] = ACTIONS(3831),
    [anon_sym_EQ_TILDE] = ACTIONS(3831),
    [anon_sym_EQ_EQ] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_GT] = ACTIONS(3831),
    [anon_sym_GT_GT] = ACTIONS(3831),
    [anon_sym_AMP_GT] = ACTIONS(3831),
    [anon_sym_AMP_GT_GT] = ACTIONS(3831),
    [anon_sym_LT_AMP] = ACTIONS(3831),
    [anon_sym_GT_AMP] = ACTIONS(3831),
    [anon_sym_LT_LT] = ACTIONS(3831),
    [anon_sym_LT_LT_DASH] = ACTIONS(3831),
    [anon_sym_LT_LT_LT] = ACTIONS(3831),
    [sym__special_characters] = ACTIONS(3831),
    [anon_sym_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [sym_raw_string] = ACTIONS(3831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3831),
    [anon_sym_BQUOTE] = ACTIONS(3831),
    [anon_sym_LT_LPAREN] = ACTIONS(3831),
    [anon_sym_GT_LPAREN] = ACTIONS(3831),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3831),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_LF] = ACTIONS(3829),
    [anon_sym_AMP] = ACTIONS(3831),
  },
  [1235] = {
    [aux_sym_concatenation_repeat1] = STATE(1636),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [1236] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
  },
  [1237] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(3833),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [1238] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_RBRACE] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
  },
  [1239] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
  },
  [1240] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
  },
  [1241] = {
    [sym__simple_heredoc_body] = ACTIONS(3835),
    [sym__heredoc_body_beginning] = ACTIONS(3835),
    [sym_file_descriptor] = ACTIONS(3835),
    [sym__concat] = ACTIONS(3835),
    [anon_sym_esac] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3837),
    [anon_sym_RPAREN] = ACTIONS(3837),
    [anon_sym_SEMI_SEMI] = ACTIONS(3837),
    [anon_sym_PIPE_AMP] = ACTIONS(3837),
    [anon_sym_AMP_AMP] = ACTIONS(3837),
    [anon_sym_PIPE_PIPE] = ACTIONS(3837),
    [anon_sym_EQ_TILDE] = ACTIONS(3837),
    [anon_sym_EQ_EQ] = ACTIONS(3837),
    [anon_sym_LT] = ACTIONS(3837),
    [anon_sym_GT] = ACTIONS(3837),
    [anon_sym_GT_GT] = ACTIONS(3837),
    [anon_sym_AMP_GT] = ACTIONS(3837),
    [anon_sym_AMP_GT_GT] = ACTIONS(3837),
    [anon_sym_LT_AMP] = ACTIONS(3837),
    [anon_sym_GT_AMP] = ACTIONS(3837),
    [anon_sym_LT_LT] = ACTIONS(3837),
    [anon_sym_LT_LT_DASH] = ACTIONS(3837),
    [anon_sym_LT_LT_LT] = ACTIONS(3837),
    [sym__special_characters] = ACTIONS(3837),
    [anon_sym_DQUOTE] = ACTIONS(3837),
    [anon_sym_DOLLAR] = ACTIONS(3837),
    [sym_raw_string] = ACTIONS(3837),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3837),
    [anon_sym_BQUOTE] = ACTIONS(3837),
    [anon_sym_LT_LPAREN] = ACTIONS(3837),
    [anon_sym_GT_LPAREN] = ACTIONS(3837),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3837),
    [anon_sym_SEMI] = ACTIONS(3837),
    [anon_sym_LF] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
  },
  [1242] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(3839),
    [sym_comment] = ACTIONS(53),
  },
  [1243] = {
    [sym_concatenation] = STATE(1641),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1641),
    [anon_sym_RBRACE] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3843),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3847),
    [anon_sym_COLON] = ACTIONS(3843),
    [anon_sym_COLON_QMARK] = ACTIONS(3843),
    [anon_sym_COLON_DASH] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [anon_sym_DASH] = ACTIONS(3843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1244] = {
    [sym_subscript] = STATE(1645),
    [sym_variable_name] = ACTIONS(3849),
    [anon_sym_DOLLAR] = ACTIONS(3851),
    [anon_sym_DASH] = ACTIONS(3851),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3853),
    [anon_sym_STAR] = ACTIONS(3851),
    [anon_sym_AT] = ACTIONS(3851),
    [anon_sym_QMARK] = ACTIONS(3851),
    [anon_sym_0] = ACTIONS(3855),
    [anon_sym__] = ACTIONS(3855),
  },
  [1245] = {
    [sym_concatenation] = STATE(1648),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1648),
    [anon_sym_RBRACE] = ACTIONS(3857),
    [anon_sym_EQ] = ACTIONS(3859),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3863),
    [anon_sym_COLON] = ACTIONS(3859),
    [anon_sym_COLON_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_DASH] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1246] = {
    [sym_concatenation] = STATE(1651),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1651),
    [anon_sym_RBRACE] = ACTIONS(3865),
    [anon_sym_EQ] = ACTIONS(3867),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3871),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_DASH] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1247] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3873),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [1248] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3873),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1249] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3873),
    [sym_comment] = ACTIONS(53),
  },
  [1250] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(3873),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1251] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3875),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [1252] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3875),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1253] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [anon_sym_EQ] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_POUND] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_COLON] = ACTIONS(1644),
    [anon_sym_COLON_QMARK] = ACTIONS(1644),
    [anon_sym_COLON_DASH] = ACTIONS(1644),
    [anon_sym_PERCENT] = ACTIONS(1644),
    [anon_sym_DASH] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1644),
  },
  [1254] = {
    [aux_sym_concatenation_repeat1] = STATE(1254),
    [sym__concat] = ACTIONS(3877),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [anon_sym_EQ] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_POUND] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_COLON] = ACTIONS(1644),
    [anon_sym_COLON_QMARK] = ACTIONS(1644),
    [anon_sym_COLON_DASH] = ACTIONS(1644),
    [anon_sym_PERCENT] = ACTIONS(1644),
    [anon_sym_DASH] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1644),
  },
  [1255] = {
    [sym__concat] = ACTIONS(1691),
    [anon_sym_RBRACE] = ACTIONS(1691),
    [anon_sym_EQ] = ACTIONS(1693),
    [sym__special_characters] = ACTIONS(1693),
    [anon_sym_DQUOTE] = ACTIONS(1691),
    [anon_sym_DOLLAR] = ACTIONS(1693),
    [sym_raw_string] = ACTIONS(1691),
    [anon_sym_POUND] = ACTIONS(1691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1691),
    [anon_sym_COLON] = ACTIONS(1693),
    [anon_sym_COLON_QMARK] = ACTIONS(1693),
    [anon_sym_COLON_DASH] = ACTIONS(1693),
    [anon_sym_PERCENT] = ACTIONS(1693),
    [anon_sym_DASH] = ACTIONS(1693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1691),
    [anon_sym_BQUOTE] = ACTIONS(1691),
    [anon_sym_LT_LPAREN] = ACTIONS(1691),
    [anon_sym_GT_LPAREN] = ACTIONS(1691),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1693),
  },
  [1256] = {
    [sym_concatenation] = STATE(1657),
    [sym_string] = STATE(1656),
    [sym_simple_expansion] = STATE(1656),
    [sym_string_expansion] = STATE(1656),
    [sym_expansion] = STATE(1656),
    [sym_command_substitution] = STATE(1656),
    [sym_process_substitution] = STATE(1656),
    [anon_sym_RBRACE] = ACTIONS(3880),
    [sym__special_characters] = ACTIONS(3882),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(3884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3884),
  },
  [1257] = {
    [sym__concat] = ACTIONS(1732),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_EQ] = ACTIONS(1734),
    [sym__special_characters] = ACTIONS(1734),
    [anon_sym_DQUOTE] = ACTIONS(1732),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [sym_raw_string] = ACTIONS(1732),
    [anon_sym_POUND] = ACTIONS(1732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1732),
    [anon_sym_COLON] = ACTIONS(1734),
    [anon_sym_COLON_QMARK] = ACTIONS(1734),
    [anon_sym_COLON_DASH] = ACTIONS(1734),
    [anon_sym_PERCENT] = ACTIONS(1734),
    [anon_sym_DASH] = ACTIONS(1734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1732),
    [anon_sym_BQUOTE] = ACTIONS(1732),
    [anon_sym_LT_LPAREN] = ACTIONS(1732),
    [anon_sym_GT_LPAREN] = ACTIONS(1732),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1734),
  },
  [1258] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3886),
  },
  [1259] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3888),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1260] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(3890),
    [sym_comment] = ACTIONS(53),
  },
  [1261] = {
    [sym_concatenation] = STATE(1663),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1663),
    [anon_sym_RBRACE] = ACTIONS(3892),
    [anon_sym_EQ] = ACTIONS(3894),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3894),
    [anon_sym_COLON_QMARK] = ACTIONS(3894),
    [anon_sym_COLON_DASH] = ACTIONS(3894),
    [anon_sym_PERCENT] = ACTIONS(3894),
    [anon_sym_DASH] = ACTIONS(3894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1262] = {
    [sym_concatenation] = STATE(1666),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1666),
    [anon_sym_RBRACE] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3902),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3906),
    [anon_sym_COLON] = ACTIONS(3902),
    [anon_sym_COLON_QMARK] = ACTIONS(3902),
    [anon_sym_COLON_DASH] = ACTIONS(3902),
    [anon_sym_PERCENT] = ACTIONS(3902),
    [anon_sym_DASH] = ACTIONS(3902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1263] = {
    [sym_concatenation] = STATE(1668),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1668),
    [anon_sym_RBRACE] = ACTIONS(3880),
    [anon_sym_EQ] = ACTIONS(3908),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3912),
    [anon_sym_COLON] = ACTIONS(3908),
    [anon_sym_COLON_QMARK] = ACTIONS(3908),
    [anon_sym_COLON_DASH] = ACTIONS(3908),
    [anon_sym_PERCENT] = ACTIONS(3908),
    [anon_sym_DASH] = ACTIONS(3908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1264] = {
    [sym__concat] = ACTIONS(1798),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1800),
    [sym__special_characters] = ACTIONS(1800),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [sym_raw_string] = ACTIONS(1798),
    [anon_sym_POUND] = ACTIONS(1798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1798),
    [anon_sym_COLON] = ACTIONS(1800),
    [anon_sym_COLON_QMARK] = ACTIONS(1800),
    [anon_sym_COLON_DASH] = ACTIONS(1800),
    [anon_sym_PERCENT] = ACTIONS(1800),
    [anon_sym_DASH] = ACTIONS(1800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1798),
    [anon_sym_BQUOTE] = ACTIONS(1798),
    [anon_sym_LT_LPAREN] = ACTIONS(1798),
    [anon_sym_GT_LPAREN] = ACTIONS(1798),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1800),
  },
  [1265] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3914),
  },
  [1266] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3916),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1267] = {
    [sym__concat] = ACTIONS(1806),
    [anon_sym_RBRACE] = ACTIONS(1806),
    [anon_sym_EQ] = ACTIONS(1808),
    [sym__special_characters] = ACTIONS(1808),
    [anon_sym_DQUOTE] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [sym_raw_string] = ACTIONS(1806),
    [anon_sym_POUND] = ACTIONS(1806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1806),
    [anon_sym_COLON] = ACTIONS(1808),
    [anon_sym_COLON_QMARK] = ACTIONS(1808),
    [anon_sym_COLON_DASH] = ACTIONS(1808),
    [anon_sym_PERCENT] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1806),
    [anon_sym_BQUOTE] = ACTIONS(1806),
    [anon_sym_LT_LPAREN] = ACTIONS(1806),
    [anon_sym_GT_LPAREN] = ACTIONS(1806),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1808),
  },
  [1268] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3918),
  },
  [1269] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3880),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1270] = {
    [sym__simple_heredoc_body] = ACTIONS(3920),
    [sym__heredoc_body_beginning] = ACTIONS(3920),
    [sym_file_descriptor] = ACTIONS(3920),
    [sym__concat] = ACTIONS(3920),
    [anon_sym_esac] = ACTIONS(3922),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_RPAREN] = ACTIONS(3922),
    [anon_sym_SEMI_SEMI] = ACTIONS(3922),
    [anon_sym_PIPE_AMP] = ACTIONS(3922),
    [anon_sym_AMP_AMP] = ACTIONS(3922),
    [anon_sym_PIPE_PIPE] = ACTIONS(3922),
    [anon_sym_EQ_TILDE] = ACTIONS(3922),
    [anon_sym_EQ_EQ] = ACTIONS(3922),
    [anon_sym_LT] = ACTIONS(3922),
    [anon_sym_GT] = ACTIONS(3922),
    [anon_sym_GT_GT] = ACTIONS(3922),
    [anon_sym_AMP_GT] = ACTIONS(3922),
    [anon_sym_AMP_GT_GT] = ACTIONS(3922),
    [anon_sym_LT_AMP] = ACTIONS(3922),
    [anon_sym_GT_AMP] = ACTIONS(3922),
    [anon_sym_LT_LT] = ACTIONS(3922),
    [anon_sym_LT_LT_DASH] = ACTIONS(3922),
    [anon_sym_LT_LT_LT] = ACTIONS(3922),
    [sym__special_characters] = ACTIONS(3922),
    [anon_sym_DQUOTE] = ACTIONS(3922),
    [anon_sym_DOLLAR] = ACTIONS(3922),
    [sym_raw_string] = ACTIONS(3922),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3922),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3922),
    [anon_sym_BQUOTE] = ACTIONS(3922),
    [anon_sym_LT_LPAREN] = ACTIONS(3922),
    [anon_sym_GT_LPAREN] = ACTIONS(3922),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3922),
    [anon_sym_SEMI] = ACTIONS(3922),
    [anon_sym_LF] = ACTIONS(3920),
    [anon_sym_AMP] = ACTIONS(3922),
  },
  [1271] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3924),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1272] = {
    [sym__concat] = ACTIONS(1940),
    [anon_sym_RBRACE] = ACTIONS(1940),
    [anon_sym_EQ] = ACTIONS(1942),
    [sym__special_characters] = ACTIONS(1942),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [anon_sym_DOLLAR] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1940),
    [anon_sym_POUND] = ACTIONS(1940),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1940),
    [anon_sym_COLON] = ACTIONS(1942),
    [anon_sym_COLON_QMARK] = ACTIONS(1942),
    [anon_sym_COLON_DASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1942),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1940),
    [anon_sym_BQUOTE] = ACTIONS(1940),
    [anon_sym_LT_LPAREN] = ACTIONS(1940),
    [anon_sym_GT_LPAREN] = ACTIONS(1940),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1942),
  },
  [1273] = {
    [sym__concat] = ACTIONS(2006),
    [anon_sym_RBRACE] = ACTIONS(2006),
    [anon_sym_EQ] = ACTIONS(2008),
    [sym__special_characters] = ACTIONS(2008),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [anon_sym_DOLLAR] = ACTIONS(2008),
    [sym_raw_string] = ACTIONS(2006),
    [anon_sym_POUND] = ACTIONS(2006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2006),
    [anon_sym_COLON] = ACTIONS(2008),
    [anon_sym_COLON_QMARK] = ACTIONS(2008),
    [anon_sym_COLON_DASH] = ACTIONS(2008),
    [anon_sym_PERCENT] = ACTIONS(2008),
    [anon_sym_DASH] = ACTIONS(2008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2006),
    [anon_sym_BQUOTE] = ACTIONS(2006),
    [anon_sym_LT_LPAREN] = ACTIONS(2006),
    [anon_sym_GT_LPAREN] = ACTIONS(2006),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2008),
  },
  [1274] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3926),
    [sym_comment] = ACTIONS(53),
  },
  [1275] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(3928),
    [sym_comment] = ACTIONS(53),
  },
  [1276] = {
    [anon_sym_RBRACE] = ACTIONS(3928),
    [sym_comment] = ACTIONS(53),
  },
  [1277] = {
    [sym_concatenation] = STATE(1676),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1676),
    [anon_sym_RBRACE] = ACTIONS(3930),
    [anon_sym_EQ] = ACTIONS(3932),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3934),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3932),
    [anon_sym_COLON_QMARK] = ACTIONS(3932),
    [anon_sym_COLON_DASH] = ACTIONS(3932),
    [anon_sym_PERCENT] = ACTIONS(3932),
    [anon_sym_DASH] = ACTIONS(3932),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1278] = {
    [sym__simple_heredoc_body] = ACTIONS(3936),
    [sym__heredoc_body_beginning] = ACTIONS(3936),
    [sym_file_descriptor] = ACTIONS(3936),
    [sym__concat] = ACTIONS(3936),
    [anon_sym_esac] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3938),
    [anon_sym_RPAREN] = ACTIONS(3938),
    [anon_sym_SEMI_SEMI] = ACTIONS(3938),
    [anon_sym_PIPE_AMP] = ACTIONS(3938),
    [anon_sym_AMP_AMP] = ACTIONS(3938),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_EQ_TILDE] = ACTIONS(3938),
    [anon_sym_EQ_EQ] = ACTIONS(3938),
    [anon_sym_LT] = ACTIONS(3938),
    [anon_sym_GT] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3938),
    [anon_sym_AMP_GT] = ACTIONS(3938),
    [anon_sym_AMP_GT_GT] = ACTIONS(3938),
    [anon_sym_LT_AMP] = ACTIONS(3938),
    [anon_sym_GT_AMP] = ACTIONS(3938),
    [anon_sym_LT_LT] = ACTIONS(3938),
    [anon_sym_LT_LT_DASH] = ACTIONS(3938),
    [anon_sym_LT_LT_LT] = ACTIONS(3938),
    [sym__special_characters] = ACTIONS(3938),
    [anon_sym_DQUOTE] = ACTIONS(3938),
    [anon_sym_DOLLAR] = ACTIONS(3938),
    [sym_raw_string] = ACTIONS(3938),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3938),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3938),
    [anon_sym_BQUOTE] = ACTIONS(3938),
    [anon_sym_LT_LPAREN] = ACTIONS(3938),
    [anon_sym_GT_LPAREN] = ACTIONS(3938),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3938),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_LF] = ACTIONS(3936),
    [anon_sym_AMP] = ACTIONS(3938),
  },
  [1279] = {
    [sym_concatenation] = STATE(1678),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1678),
    [anon_sym_RBRACE] = ACTIONS(3940),
    [anon_sym_EQ] = ACTIONS(3942),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_DASH] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1280] = {
    [sym__simple_heredoc_body] = ACTIONS(3946),
    [sym__heredoc_body_beginning] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3946),
    [anon_sym_esac] = ACTIONS(3948),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3948),
    [anon_sym_SEMI_SEMI] = ACTIONS(3948),
    [anon_sym_PIPE_AMP] = ACTIONS(3948),
    [anon_sym_AMP_AMP] = ACTIONS(3948),
    [anon_sym_PIPE_PIPE] = ACTIONS(3948),
    [anon_sym_EQ_TILDE] = ACTIONS(3948),
    [anon_sym_EQ_EQ] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3948),
    [anon_sym_GT_GT] = ACTIONS(3948),
    [anon_sym_AMP_GT] = ACTIONS(3948),
    [anon_sym_AMP_GT_GT] = ACTIONS(3948),
    [anon_sym_LT_AMP] = ACTIONS(3948),
    [anon_sym_GT_AMP] = ACTIONS(3948),
    [anon_sym_LT_LT] = ACTIONS(3948),
    [anon_sym_LT_LT_DASH] = ACTIONS(3948),
    [anon_sym_LT_LT_LT] = ACTIONS(3948),
    [sym__special_characters] = ACTIONS(3948),
    [anon_sym_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3948),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3948),
    [anon_sym_BQUOTE] = ACTIONS(3948),
    [anon_sym_LT_LPAREN] = ACTIONS(3948),
    [anon_sym_GT_LPAREN] = ACTIONS(3948),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3948),
    [anon_sym_LF] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3948),
  },
  [1281] = {
    [sym_concatenation] = STATE(1680),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1680),
    [anon_sym_RBRACE] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3952),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3954),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3952),
    [anon_sym_COLON_QMARK] = ACTIONS(3952),
    [anon_sym_COLON_DASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [anon_sym_DASH] = ACTIONS(3952),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1282] = {
    [sym__simple_heredoc_body] = ACTIONS(3956),
    [sym__heredoc_body_beginning] = ACTIONS(3956),
    [sym_file_descriptor] = ACTIONS(3956),
    [sym__concat] = ACTIONS(3956),
    [anon_sym_esac] = ACTIONS(3958),
    [anon_sym_PIPE] = ACTIONS(3958),
    [anon_sym_RPAREN] = ACTIONS(3958),
    [anon_sym_SEMI_SEMI] = ACTIONS(3958),
    [anon_sym_PIPE_AMP] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_EQ_TILDE] = ACTIONS(3958),
    [anon_sym_EQ_EQ] = ACTIONS(3958),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_GT] = ACTIONS(3958),
    [anon_sym_AMP_GT] = ACTIONS(3958),
    [anon_sym_AMP_GT_GT] = ACTIONS(3958),
    [anon_sym_LT_AMP] = ACTIONS(3958),
    [anon_sym_GT_AMP] = ACTIONS(3958),
    [anon_sym_LT_LT] = ACTIONS(3958),
    [anon_sym_LT_LT_DASH] = ACTIONS(3958),
    [anon_sym_LT_LT_LT] = ACTIONS(3958),
    [sym__special_characters] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [sym_raw_string] = ACTIONS(3958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3958),
    [anon_sym_BQUOTE] = ACTIONS(3958),
    [anon_sym_LT_LPAREN] = ACTIONS(3958),
    [anon_sym_GT_LPAREN] = ACTIONS(3958),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3958),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_LF] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
  },
  [1283] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3960),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1284] = {
    [sym__simple_heredoc_body] = ACTIONS(3962),
    [sym__heredoc_body_beginning] = ACTIONS(3962),
    [sym_file_descriptor] = ACTIONS(3962),
    [sym__concat] = ACTIONS(3962),
    [anon_sym_esac] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_RPAREN] = ACTIONS(3964),
    [anon_sym_SEMI_SEMI] = ACTIONS(3964),
    [anon_sym_PIPE_AMP] = ACTIONS(3964),
    [anon_sym_AMP_AMP] = ACTIONS(3964),
    [anon_sym_PIPE_PIPE] = ACTIONS(3964),
    [anon_sym_EQ_TILDE] = ACTIONS(3964),
    [anon_sym_EQ_EQ] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_GT] = ACTIONS(3964),
    [anon_sym_GT_GT] = ACTIONS(3964),
    [anon_sym_AMP_GT] = ACTIONS(3964),
    [anon_sym_AMP_GT_GT] = ACTIONS(3964),
    [anon_sym_LT_AMP] = ACTIONS(3964),
    [anon_sym_GT_AMP] = ACTIONS(3964),
    [anon_sym_LT_LT] = ACTIONS(3964),
    [anon_sym_LT_LT_DASH] = ACTIONS(3964),
    [anon_sym_LT_LT_LT] = ACTIONS(3964),
    [sym__special_characters] = ACTIONS(3964),
    [anon_sym_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3964),
    [sym_raw_string] = ACTIONS(3964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3964),
    [anon_sym_BQUOTE] = ACTIONS(3964),
    [anon_sym_LT_LPAREN] = ACTIONS(3964),
    [anon_sym_GT_LPAREN] = ACTIONS(3964),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3964),
    [anon_sym_SEMI] = ACTIONS(3964),
    [anon_sym_LF] = ACTIONS(3962),
    [anon_sym_AMP] = ACTIONS(3964),
  },
  [1285] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1286] = {
    [aux_sym_concatenation_repeat1] = STATE(1683),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(693),
  },
  [1287] = {
    [sym_concatenation] = STATE(1031),
    [sym_string] = STATE(588),
    [sym_simple_expansion] = STATE(588),
    [sym_string_expansion] = STATE(588),
    [sym_expansion] = STATE(588),
    [sym_command_substitution] = STATE(588),
    [sym_process_substitution] = STATE(588),
    [aux_sym_for_statement_repeat1] = STATE(1031),
    [anon_sym_SEMI_SEMI] = ACTIONS(3968),
    [sym__special_characters] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [anon_sym_DOLLAR] = ACTIONS(71),
    [sym_raw_string] = ACTIONS(2211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [anon_sym_LT_LPAREN] = ACTIONS(2219),
    [anon_sym_GT_LPAREN] = ACTIONS(2219),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2211),
    [anon_sym_SEMI] = ACTIONS(3968),
    [anon_sym_LF] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3968),
  },
  [1288] = {
    [sym__terminated_statement] = STATE(1686),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1686),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1289] = {
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_RPAREN] = ACTIONS(2227),
    [anon_sym_PIPE_AMP] = ACTIONS(2227),
    [anon_sym_AMP_AMP] = ACTIONS(2227),
    [anon_sym_PIPE_PIPE] = ACTIONS(2227),
    [anon_sym_BQUOTE] = ACTIONS(2227),
    [sym_comment] = ACTIONS(53),
  },
  [1290] = {
    [sym__simple_heredoc_body] = ACTIONS(2229),
    [sym__heredoc_body_beginning] = ACTIONS(2229),
    [sym_file_descriptor] = ACTIONS(2229),
    [anon_sym_PIPE] = ACTIONS(2231),
    [anon_sym_RPAREN] = ACTIONS(2229),
    [anon_sym_PIPE_AMP] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_PIPE_PIPE] = ACTIONS(2229),
    [anon_sym_LT] = ACTIONS(2231),
    [anon_sym_GT] = ACTIONS(2231),
    [anon_sym_GT_GT] = ACTIONS(2229),
    [anon_sym_AMP_GT] = ACTIONS(2231),
    [anon_sym_AMP_GT_GT] = ACTIONS(2229),
    [anon_sym_LT_AMP] = ACTIONS(2229),
    [anon_sym_GT_AMP] = ACTIONS(2229),
    [anon_sym_LT_LT] = ACTIONS(2231),
    [anon_sym_LT_LT_DASH] = ACTIONS(2229),
    [anon_sym_LT_LT_LT] = ACTIONS(2229),
    [anon_sym_BQUOTE] = ACTIONS(2229),
    [sym_comment] = ACTIONS(53),
  },
  [1291] = {
    [sym__terminated_statement] = STATE(1035),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1035),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(3974),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1292] = {
    [anon_sym_PIPE] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2237),
    [anon_sym_PIPE_AMP] = ACTIONS(2237),
    [anon_sym_AMP_AMP] = ACTIONS(2237),
    [anon_sym_PIPE_PIPE] = ACTIONS(2237),
    [anon_sym_BQUOTE] = ACTIONS(2237),
    [sym_comment] = ACTIONS(53),
  },
  [1293] = {
    [sym_file_redirect] = STATE(938),
    [sym_heredoc_redirect] = STATE(938),
    [sym_heredoc_body] = STATE(1688),
    [sym_herestring_redirect] = STATE(938),
    [aux_sym_while_statement_repeat1] = STATE(938),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2237),
    [anon_sym_PIPE_AMP] = ACTIONS(2237),
    [anon_sym_AMP_AMP] = ACTIONS(2237),
    [anon_sym_PIPE_PIPE] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym_comment] = ACTIONS(53),
  },
  [1294] = {
    [anon_sym_PIPE] = ACTIONS(2239),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [anon_sym_PIPE_AMP] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_BQUOTE] = ACTIONS(2241),
    [sym_comment] = ACTIONS(53),
  },
  [1295] = {
    [anon_sym_fi] = ACTIONS(3976),
    [sym_comment] = ACTIONS(53),
  },
  [1296] = {
    [sym__terminated_statement] = STATE(1041),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_elif_clause] = STATE(599),
    [sym_else_clause] = STATE(1690),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1041),
    [aux_sym_if_statement_repeat1] = STATE(1691),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(3978),
    [anon_sym_elif] = ACTIONS(1169),
    [anon_sym_else] = ACTIONS(1171),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1297] = {
    [sym_elif_clause] = STATE(599),
    [sym_else_clause] = STATE(1690),
    [aux_sym_if_statement_repeat1] = STATE(1043),
    [anon_sym_fi] = ACTIONS(3976),
    [anon_sym_elif] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2253),
    [sym_comment] = ACTIONS(53),
  },
  [1298] = {
    [sym_case_item] = STATE(1694),
    [sym_last_case_item] = STATE(1693),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(1694),
    [anon_sym_esac] = ACTIONS(3980),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2261),
  },
  [1299] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(3982),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3982),
    [anon_sym_LF] = ACTIONS(3984),
    [anon_sym_AMP] = ACTIONS(3982),
  },
  [1300] = {
    [sym_case_item] = STATE(1698),
    [sym_last_case_item] = STATE(1697),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(1698),
    [anon_sym_esac] = ACTIONS(3986),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2261),
  },
  [1301] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(3988),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3988),
    [anon_sym_LF] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3988),
  },
  [1302] = {
    [sym_compound_statement] = STATE(1700),
    [anon_sym_LBRACE] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
  },
  [1303] = {
    [sym_file_descriptor] = ACTIONS(2316),
    [anon_sym_PIPE] = ACTIONS(2318),
    [anon_sym_RPAREN] = ACTIONS(2316),
    [anon_sym_PIPE_AMP] = ACTIONS(2316),
    [anon_sym_AMP_AMP] = ACTIONS(2316),
    [anon_sym_PIPE_PIPE] = ACTIONS(2316),
    [anon_sym_LT] = ACTIONS(2318),
    [anon_sym_GT] = ACTIONS(2318),
    [anon_sym_GT_GT] = ACTIONS(2316),
    [anon_sym_AMP_GT] = ACTIONS(2318),
    [anon_sym_AMP_GT_GT] = ACTIONS(2316),
    [anon_sym_LT_AMP] = ACTIONS(2316),
    [anon_sym_GT_AMP] = ACTIONS(2316),
    [anon_sym_BQUOTE] = ACTIONS(2316),
    [sym_comment] = ACTIONS(53),
  },
  [1304] = {
    [sym__terminated_statement] = STATE(1076),
    [sym_for_statement] = STATE(628),
    [sym_while_statement] = STATE(628),
    [sym_if_statement] = STATE(628),
    [sym_case_statement] = STATE(628),
    [sym_function_definition] = STATE(628),
    [sym_subshell] = STATE(628),
    [sym_pipeline] = STATE(628),
    [sym_list] = STATE(628),
    [sym_negated_command] = STATE(628),
    [sym_test_command] = STATE(628),
    [sym_declaration_command] = STATE(628),
    [sym_unset_command] = STATE(628),
    [sym_command] = STATE(628),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(629),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1076),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(3992),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1305] = {
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(3994),
    [anon_sym_GT_GT] = ACTIONS(3996),
    [anon_sym_AMP_GT] = ACTIONS(3994),
    [anon_sym_AMP_GT_GT] = ACTIONS(3996),
    [anon_sym_LT_AMP] = ACTIONS(3996),
    [anon_sym_GT_AMP] = ACTIONS(3996),
    [sym_comment] = ACTIONS(53),
  },
  [1306] = {
    [sym_concatenation] = STATE(1705),
    [sym_string] = STATE(1704),
    [sym_simple_expansion] = STATE(1704),
    [sym_string_expansion] = STATE(1704),
    [sym_expansion] = STATE(1704),
    [sym_command_substitution] = STATE(1704),
    [sym_process_substitution] = STATE(1704),
    [sym__special_characters] = ACTIONS(3998),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(4000),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4000),
  },
  [1307] = {
    [anon_sym_PIPE] = ACTIONS(2334),
    [anon_sym_RPAREN] = ACTIONS(2336),
    [anon_sym_PIPE_AMP] = ACTIONS(2336),
    [anon_sym_AMP_AMP] = ACTIONS(2336),
    [anon_sym_PIPE_PIPE] = ACTIONS(2336),
    [anon_sym_BQUOTE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(53),
  },
  [1308] = {
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [sym_comment] = ACTIONS(53),
  },
  [1309] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_RPAREN] = ACTIONS(4002),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [1310] = {
    [anon_sym_LT] = ACTIONS(4004),
    [anon_sym_GT] = ACTIONS(4004),
    [anon_sym_GT_GT] = ACTIONS(4006),
    [anon_sym_AMP_GT] = ACTIONS(4004),
    [anon_sym_AMP_GT_GT] = ACTIONS(4006),
    [anon_sym_LT_AMP] = ACTIONS(4006),
    [anon_sym_GT_AMP] = ACTIONS(4006),
    [sym_comment] = ACTIONS(53),
  },
  [1311] = {
    [sym_concatenation] = STATE(1716),
    [sym_string] = STATE(1711),
    [sym_simple_expansion] = STATE(1711),
    [sym_string_expansion] = STATE(1711),
    [sym_expansion] = STATE(1711),
    [sym_command_substitution] = STATE(1711),
    [sym_process_substitution] = STATE(1711),
    [sym__special_characters] = ACTIONS(4008),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4012),
    [sym_raw_string] = ACTIONS(4014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4020),
    [anon_sym_LT_LPAREN] = ACTIONS(4022),
    [anon_sym_GT_LPAREN] = ACTIONS(4022),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4014),
  },
  [1312] = {
    [sym_heredoc_start] = ACTIONS(4024),
    [sym_comment] = ACTIONS(53),
  },
  [1313] = {
    [sym_concatenation] = STATE(1720),
    [sym_string] = STATE(1719),
    [sym_simple_expansion] = STATE(1719),
    [sym_string_expansion] = STATE(1719),
    [sym_expansion] = STATE(1719),
    [sym_command_substitution] = STATE(1719),
    [sym_process_substitution] = STATE(1719),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4012),
    [sym_raw_string] = ACTIONS(4028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4020),
    [anon_sym_LT_LPAREN] = ACTIONS(4022),
    [anon_sym_GT_LPAREN] = ACTIONS(4022),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4028),
  },
  [1314] = {
    [sym_file_redirect] = STATE(1721),
    [sym_heredoc_redirect] = STATE(1721),
    [sym_herestring_redirect] = STATE(1721),
    [aux_sym_while_statement_repeat1] = STATE(1721),
    [sym_file_descriptor] = ACTIONS(2901),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_RPAREN] = ACTIONS(2480),
    [anon_sym_PIPE_AMP] = ACTIONS(2480),
    [anon_sym_AMP_AMP] = ACTIONS(2480),
    [anon_sym_PIPE_PIPE] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_GT_GT] = ACTIONS(2905),
    [anon_sym_AMP_GT] = ACTIONS(2903),
    [anon_sym_AMP_GT_GT] = ACTIONS(2905),
    [anon_sym_LT_AMP] = ACTIONS(2905),
    [anon_sym_GT_AMP] = ACTIONS(2905),
    [anon_sym_LT_LT] = ACTIONS(2907),
    [anon_sym_LT_LT_DASH] = ACTIONS(2909),
    [anon_sym_LT_LT_LT] = ACTIONS(2911),
    [sym_comment] = ACTIONS(53),
  },
  [1315] = {
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
  },
  [1316] = {
    [sym_concatenation] = STATE(1723),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1723),
    [anon_sym_RPAREN] = ACTIONS(4030),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [1317] = {
    [aux_sym_concatenation_repeat1] = STATE(863),
    [sym__concat] = ACTIONS(1852),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(1129),
    [anon_sym_PIPE_AMP] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [sym__special_characters] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1129),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [anon_sym_LT_LPAREN] = ACTIONS(1129),
    [anon_sym_GT_LPAREN] = ACTIONS(1129),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1133),
    [sym_word] = ACTIONS(1133),
  },
  [1318] = {
    [aux_sym_concatenation_repeat1] = STATE(863),
    [sym__concat] = ACTIONS(1852),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
  },
  [1319] = {
    [sym__concat] = ACTIONS(1642),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
  },
  [1320] = {
    [aux_sym_concatenation_repeat1] = STATE(1320),
    [sym__concat] = ACTIONS(4032),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
  },
  [1321] = {
    [sym__concat] = ACTIONS(1691),
    [sym_variable_name] = ACTIONS(1691),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_RPAREN] = ACTIONS(1691),
    [anon_sym_PIPE_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1691),
    [anon_sym_PIPE_PIPE] = ACTIONS(1691),
    [sym__special_characters] = ACTIONS(1691),
    [anon_sym_DQUOTE] = ACTIONS(1691),
    [anon_sym_DOLLAR] = ACTIONS(1693),
    [sym_raw_string] = ACTIONS(1691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1691),
    [anon_sym_BQUOTE] = ACTIONS(1691),
    [anon_sym_LT_LPAREN] = ACTIONS(1691),
    [anon_sym_GT_LPAREN] = ACTIONS(1691),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1693),
    [sym_word] = ACTIONS(1693),
  },
  [1322] = {
    [sym_concatenation] = STATE(1727),
    [sym_string] = STATE(1726),
    [sym_simple_expansion] = STATE(1726),
    [sym_string_expansion] = STATE(1726),
    [sym_expansion] = STATE(1726),
    [sym_command_substitution] = STATE(1726),
    [sym_process_substitution] = STATE(1726),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [sym__special_characters] = ACTIONS(4037),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(4039),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4039),
  },
  [1323] = {
    [sym__concat] = ACTIONS(1732),
    [sym_variable_name] = ACTIONS(1732),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [anon_sym_PIPE_AMP] = ACTIONS(1732),
    [anon_sym_AMP_AMP] = ACTIONS(1732),
    [anon_sym_PIPE_PIPE] = ACTIONS(1732),
    [sym__special_characters] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1732),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [sym_raw_string] = ACTIONS(1732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1732),
    [anon_sym_BQUOTE] = ACTIONS(1732),
    [anon_sym_LT_LPAREN] = ACTIONS(1732),
    [anon_sym_GT_LPAREN] = ACTIONS(1732),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1734),
    [sym_word] = ACTIONS(1734),
  },
  [1324] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4041),
  },
  [1325] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4043),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1326] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(4045),
    [sym_comment] = ACTIONS(53),
  },
  [1327] = {
    [sym_concatenation] = STATE(1733),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1733),
    [anon_sym_RBRACE] = ACTIONS(4047),
    [anon_sym_EQ] = ACTIONS(4049),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4053),
    [anon_sym_COLON] = ACTIONS(4049),
    [anon_sym_COLON_QMARK] = ACTIONS(4049),
    [anon_sym_COLON_DASH] = ACTIONS(4049),
    [anon_sym_PERCENT] = ACTIONS(4049),
    [anon_sym_DASH] = ACTIONS(4049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1328] = {
    [sym_concatenation] = STATE(1736),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1736),
    [anon_sym_RBRACE] = ACTIONS(4055),
    [anon_sym_EQ] = ACTIONS(4057),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4061),
    [anon_sym_COLON] = ACTIONS(4057),
    [anon_sym_COLON_QMARK] = ACTIONS(4057),
    [anon_sym_COLON_DASH] = ACTIONS(4057),
    [anon_sym_PERCENT] = ACTIONS(4057),
    [anon_sym_DASH] = ACTIONS(4057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1329] = {
    [sym_concatenation] = STATE(1738),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1738),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(4063),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4067),
    [anon_sym_COLON] = ACTIONS(4063),
    [anon_sym_COLON_QMARK] = ACTIONS(4063),
    [anon_sym_COLON_DASH] = ACTIONS(4063),
    [anon_sym_PERCENT] = ACTIONS(4063),
    [anon_sym_DASH] = ACTIONS(4063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1330] = {
    [sym__concat] = ACTIONS(1798),
    [sym_variable_name] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1798),
    [anon_sym_PIPE_AMP] = ACTIONS(1798),
    [anon_sym_AMP_AMP] = ACTIONS(1798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1798),
    [sym__special_characters] = ACTIONS(1798),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [sym_raw_string] = ACTIONS(1798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1798),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1798),
    [anon_sym_BQUOTE] = ACTIONS(1798),
    [anon_sym_LT_LPAREN] = ACTIONS(1798),
    [anon_sym_GT_LPAREN] = ACTIONS(1798),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1800),
    [sym_word] = ACTIONS(1800),
  },
  [1331] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4069),
  },
  [1332] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1333] = {
    [sym__concat] = ACTIONS(1806),
    [sym_variable_name] = ACTIONS(1806),
    [anon_sym_PIPE] = ACTIONS(1808),
    [anon_sym_RPAREN] = ACTIONS(1806),
    [anon_sym_PIPE_AMP] = ACTIONS(1806),
    [anon_sym_AMP_AMP] = ACTIONS(1806),
    [anon_sym_PIPE_PIPE] = ACTIONS(1806),
    [sym__special_characters] = ACTIONS(1806),
    [anon_sym_DQUOTE] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [sym_raw_string] = ACTIONS(1806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1806),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1806),
    [anon_sym_BQUOTE] = ACTIONS(1806),
    [anon_sym_LT_LPAREN] = ACTIONS(1806),
    [anon_sym_GT_LPAREN] = ACTIONS(1806),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1808),
    [sym_word] = ACTIONS(1808),
  },
  [1334] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4073),
  },
  [1335] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1336] = {
    [sym__concat] = ACTIONS(1940),
    [sym_variable_name] = ACTIONS(1940),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [sym__special_characters] = ACTIONS(1940),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [anon_sym_DOLLAR] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1940),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1940),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1940),
    [anon_sym_BQUOTE] = ACTIONS(1940),
    [anon_sym_LT_LPAREN] = ACTIONS(1940),
    [anon_sym_GT_LPAREN] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1942),
    [sym_word] = ACTIONS(1942),
  },
  [1337] = {
    [sym__concat] = ACTIONS(2006),
    [sym_variable_name] = ACTIONS(2006),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_RPAREN] = ACTIONS(2006),
    [anon_sym_PIPE_AMP] = ACTIONS(2006),
    [anon_sym_AMP_AMP] = ACTIONS(2006),
    [anon_sym_PIPE_PIPE] = ACTIONS(2006),
    [sym__special_characters] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [anon_sym_DOLLAR] = ACTIONS(2008),
    [sym_raw_string] = ACTIONS(2006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2006),
    [anon_sym_BQUOTE] = ACTIONS(2006),
    [anon_sym_LT_LPAREN] = ACTIONS(2006),
    [anon_sym_GT_LPAREN] = ACTIONS(2006),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2008),
    [sym_word] = ACTIONS(2008),
  },
  [1338] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
  },
  [1339] = {
    [aux_sym_concatenation_repeat1] = STATE(1339),
    [sym__concat] = ACTIONS(4075),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
  },
  [1340] = {
    [sym__concat] = ACTIONS(1691),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_RPAREN] = ACTIONS(1691),
    [anon_sym_PIPE_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1691),
    [anon_sym_PIPE_PIPE] = ACTIONS(1691),
    [sym__special_characters] = ACTIONS(1691),
    [anon_sym_DQUOTE] = ACTIONS(1691),
    [anon_sym_DOLLAR] = ACTIONS(1693),
    [sym_raw_string] = ACTIONS(1691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1691),
    [anon_sym_BQUOTE] = ACTIONS(1691),
    [anon_sym_LT_LPAREN] = ACTIONS(1691),
    [anon_sym_GT_LPAREN] = ACTIONS(1691),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1693),
    [sym_word] = ACTIONS(1693),
  },
  [1341] = {
    [sym_concatenation] = STATE(1745),
    [sym_string] = STATE(1744),
    [sym_simple_expansion] = STATE(1744),
    [sym_string_expansion] = STATE(1744),
    [sym_expansion] = STATE(1744),
    [sym_command_substitution] = STATE(1744),
    [sym_process_substitution] = STATE(1744),
    [anon_sym_RBRACE] = ACTIONS(4078),
    [sym__special_characters] = ACTIONS(4080),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(4082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4082),
  },
  [1342] = {
    [sym__concat] = ACTIONS(1732),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [anon_sym_PIPE_AMP] = ACTIONS(1732),
    [anon_sym_AMP_AMP] = ACTIONS(1732),
    [anon_sym_PIPE_PIPE] = ACTIONS(1732),
    [sym__special_characters] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1732),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [sym_raw_string] = ACTIONS(1732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1732),
    [anon_sym_BQUOTE] = ACTIONS(1732),
    [anon_sym_LT_LPAREN] = ACTIONS(1732),
    [anon_sym_GT_LPAREN] = ACTIONS(1732),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1734),
    [sym_word] = ACTIONS(1734),
  },
  [1343] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4084),
  },
  [1344] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1345] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(4088),
    [sym_comment] = ACTIONS(53),
  },
  [1346] = {
    [sym_concatenation] = STATE(1751),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1751),
    [anon_sym_RBRACE] = ACTIONS(4090),
    [anon_sym_EQ] = ACTIONS(4092),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4094),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4096),
    [anon_sym_COLON] = ACTIONS(4092),
    [anon_sym_COLON_QMARK] = ACTIONS(4092),
    [anon_sym_COLON_DASH] = ACTIONS(4092),
    [anon_sym_PERCENT] = ACTIONS(4092),
    [anon_sym_DASH] = ACTIONS(4092),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1347] = {
    [sym_concatenation] = STATE(1754),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1754),
    [anon_sym_RBRACE] = ACTIONS(4098),
    [anon_sym_EQ] = ACTIONS(4100),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4102),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4104),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_DASH] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1348] = {
    [sym_concatenation] = STATE(1756),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1756),
    [anon_sym_RBRACE] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4106),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4106),
    [anon_sym_COLON_QMARK] = ACTIONS(4106),
    [anon_sym_COLON_DASH] = ACTIONS(4106),
    [anon_sym_PERCENT] = ACTIONS(4106),
    [anon_sym_DASH] = ACTIONS(4106),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1349] = {
    [sym__concat] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1798),
    [anon_sym_PIPE_AMP] = ACTIONS(1798),
    [anon_sym_AMP_AMP] = ACTIONS(1798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1798),
    [sym__special_characters] = ACTIONS(1798),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [sym_raw_string] = ACTIONS(1798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1798),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1798),
    [anon_sym_BQUOTE] = ACTIONS(1798),
    [anon_sym_LT_LPAREN] = ACTIONS(1798),
    [anon_sym_GT_LPAREN] = ACTIONS(1798),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1800),
    [sym_word] = ACTIONS(1800),
  },
  [1350] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4112),
  },
  [1351] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4114),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1352] = {
    [sym__concat] = ACTIONS(1806),
    [anon_sym_PIPE] = ACTIONS(1808),
    [anon_sym_RPAREN] = ACTIONS(1806),
    [anon_sym_PIPE_AMP] = ACTIONS(1806),
    [anon_sym_AMP_AMP] = ACTIONS(1806),
    [anon_sym_PIPE_PIPE] = ACTIONS(1806),
    [sym__special_characters] = ACTIONS(1806),
    [anon_sym_DQUOTE] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [sym_raw_string] = ACTIONS(1806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1806),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1806),
    [anon_sym_BQUOTE] = ACTIONS(1806),
    [anon_sym_LT_LPAREN] = ACTIONS(1806),
    [anon_sym_GT_LPAREN] = ACTIONS(1806),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1808),
    [sym_word] = ACTIONS(1808),
  },
  [1353] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4116),
  },
  [1354] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1355] = {
    [sym__concat] = ACTIONS(1940),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [sym__special_characters] = ACTIONS(1940),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [anon_sym_DOLLAR] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1940),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1940),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1940),
    [anon_sym_BQUOTE] = ACTIONS(1940),
    [anon_sym_LT_LPAREN] = ACTIONS(1940),
    [anon_sym_GT_LPAREN] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1942),
    [sym_word] = ACTIONS(1942),
  },
  [1356] = {
    [sym__concat] = ACTIONS(2006),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_RPAREN] = ACTIONS(2006),
    [anon_sym_PIPE_AMP] = ACTIONS(2006),
    [anon_sym_AMP_AMP] = ACTIONS(2006),
    [anon_sym_PIPE_PIPE] = ACTIONS(2006),
    [sym__special_characters] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [anon_sym_DOLLAR] = ACTIONS(2008),
    [sym_raw_string] = ACTIONS(2006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2006),
    [anon_sym_BQUOTE] = ACTIONS(2006),
    [anon_sym_LT_LPAREN] = ACTIONS(2006),
    [anon_sym_GT_LPAREN] = ACTIONS(2006),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2008),
    [sym_word] = ACTIONS(2008),
  },
  [1357] = {
    [sym__simple_heredoc_body] = ACTIONS(2710),
    [sym__heredoc_body_beginning] = ACTIONS(2710),
    [sym_file_descriptor] = ACTIONS(2710),
    [sym__concat] = ACTIONS(2710),
    [anon_sym_PIPE] = ACTIONS(2712),
    [anon_sym_RPAREN] = ACTIONS(2710),
    [anon_sym_PIPE_AMP] = ACTIONS(2710),
    [anon_sym_AMP_AMP] = ACTIONS(2710),
    [anon_sym_PIPE_PIPE] = ACTIONS(2710),
    [anon_sym_EQ_TILDE] = ACTIONS(2712),
    [anon_sym_EQ_EQ] = ACTIONS(2712),
    [anon_sym_LT] = ACTIONS(2712),
    [anon_sym_GT] = ACTIONS(2712),
    [anon_sym_GT_GT] = ACTIONS(2710),
    [anon_sym_AMP_GT] = ACTIONS(2712),
    [anon_sym_AMP_GT_GT] = ACTIONS(2710),
    [anon_sym_LT_AMP] = ACTIONS(2710),
    [anon_sym_GT_AMP] = ACTIONS(2710),
    [anon_sym_LT_LT] = ACTIONS(2712),
    [anon_sym_LT_LT_DASH] = ACTIONS(2710),
    [anon_sym_LT_LT_LT] = ACTIONS(2710),
    [sym__special_characters] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(2710),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [sym_raw_string] = ACTIONS(2710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2710),
    [anon_sym_BQUOTE] = ACTIONS(2710),
    [anon_sym_LT_LPAREN] = ACTIONS(2710),
    [anon_sym_GT_LPAREN] = ACTIONS(2710),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2712),
  },
  [1358] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4118),
    [sym_comment] = ACTIONS(53),
  },
  [1359] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4120),
    [sym_comment] = ACTIONS(53),
  },
  [1360] = {
    [anon_sym_RBRACE] = ACTIONS(4120),
    [sym_comment] = ACTIONS(53),
  },
  [1361] = {
    [sym_concatenation] = STATE(1763),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1763),
    [anon_sym_RBRACE] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4124),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4126),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4124),
    [anon_sym_COLON_QMARK] = ACTIONS(4124),
    [anon_sym_COLON_DASH] = ACTIONS(4124),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_DASH] = ACTIONS(4124),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1362] = {
    [sym__simple_heredoc_body] = ACTIONS(2788),
    [sym__heredoc_body_beginning] = ACTIONS(2788),
    [sym_file_descriptor] = ACTIONS(2788),
    [sym__concat] = ACTIONS(2788),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_RPAREN] = ACTIONS(2788),
    [anon_sym_PIPE_AMP] = ACTIONS(2788),
    [anon_sym_AMP_AMP] = ACTIONS(2788),
    [anon_sym_PIPE_PIPE] = ACTIONS(2788),
    [anon_sym_EQ_TILDE] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2788),
    [anon_sym_AMP_GT] = ACTIONS(2790),
    [anon_sym_AMP_GT_GT] = ACTIONS(2788),
    [anon_sym_LT_AMP] = ACTIONS(2788),
    [anon_sym_GT_AMP] = ACTIONS(2788),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_LT_LT_DASH] = ACTIONS(2788),
    [anon_sym_LT_LT_LT] = ACTIONS(2788),
    [sym__special_characters] = ACTIONS(2788),
    [anon_sym_DQUOTE] = ACTIONS(2788),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym_raw_string] = ACTIONS(2788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2788),
    [anon_sym_BQUOTE] = ACTIONS(2788),
    [anon_sym_LT_LPAREN] = ACTIONS(2788),
    [anon_sym_GT_LPAREN] = ACTIONS(2788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2790),
  },
  [1363] = {
    [sym_concatenation] = STATE(1766),
    [sym_string] = STATE(1765),
    [sym_simple_expansion] = STATE(1765),
    [sym_string_expansion] = STATE(1765),
    [sym_expansion] = STATE(1765),
    [sym_command_substitution] = STATE(1765),
    [sym_process_substitution] = STATE(1765),
    [anon_sym_RBRACE] = ACTIONS(4120),
    [sym__special_characters] = ACTIONS(4128),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(4130),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4130),
  },
  [1364] = {
    [sym__simple_heredoc_body] = ACTIONS(2831),
    [sym__heredoc_body_beginning] = ACTIONS(2831),
    [sym_file_descriptor] = ACTIONS(2831),
    [sym__concat] = ACTIONS(2831),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2831),
    [anon_sym_PIPE_AMP] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_EQ_TILDE] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2831),
    [anon_sym_AMP_GT] = ACTIONS(2833),
    [anon_sym_AMP_GT_GT] = ACTIONS(2831),
    [anon_sym_LT_AMP] = ACTIONS(2831),
    [anon_sym_GT_AMP] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_DASH] = ACTIONS(2831),
    [anon_sym_LT_LT_LT] = ACTIONS(2831),
    [sym__special_characters] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [sym_raw_string] = ACTIONS(2831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2831),
    [anon_sym_BQUOTE] = ACTIONS(2831),
    [anon_sym_LT_LPAREN] = ACTIONS(2831),
    [anon_sym_GT_LPAREN] = ACTIONS(2831),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2833),
  },
  [1365] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4132),
  },
  [1366] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4134),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1367] = {
    [sym__simple_heredoc_body] = ACTIONS(2839),
    [sym__heredoc_body_beginning] = ACTIONS(2839),
    [sym_file_descriptor] = ACTIONS(2839),
    [sym__concat] = ACTIONS(2839),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_RPAREN] = ACTIONS(2839),
    [anon_sym_PIPE_AMP] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_EQ_TILDE] = ACTIONS(2841),
    [anon_sym_EQ_EQ] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_GT] = ACTIONS(2841),
    [anon_sym_GT_GT] = ACTIONS(2839),
    [anon_sym_AMP_GT] = ACTIONS(2841),
    [anon_sym_AMP_GT_GT] = ACTIONS(2839),
    [anon_sym_LT_AMP] = ACTIONS(2839),
    [anon_sym_GT_AMP] = ACTIONS(2839),
    [anon_sym_LT_LT] = ACTIONS(2841),
    [anon_sym_LT_LT_DASH] = ACTIONS(2839),
    [anon_sym_LT_LT_LT] = ACTIONS(2839),
    [sym__special_characters] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_DOLLAR] = ACTIONS(2841),
    [sym_raw_string] = ACTIONS(2839),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2839),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2839),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_LT_LPAREN] = ACTIONS(2839),
    [anon_sym_GT_LPAREN] = ACTIONS(2839),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2841),
  },
  [1368] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4136),
  },
  [1369] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1370] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4140),
  },
  [1371] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4120),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1372] = {
    [sym_concatenation] = STATE(1773),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1773),
    [anon_sym_RBRACE] = ACTIONS(4142),
    [anon_sym_EQ] = ACTIONS(4144),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4146),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COLON_QMARK] = ACTIONS(4144),
    [anon_sym_COLON_DASH] = ACTIONS(4144),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_DASH] = ACTIONS(4144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1373] = {
    [sym__simple_heredoc_body] = ACTIONS(2855),
    [sym__heredoc_body_beginning] = ACTIONS(2855),
    [sym_file_descriptor] = ACTIONS(2855),
    [sym__concat] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_EQ_TILDE] = ACTIONS(2857),
    [anon_sym_EQ_EQ] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_AMP_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT_GT] = ACTIONS(2855),
    [anon_sym_LT_AMP] = ACTIONS(2855),
    [anon_sym_GT_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2857),
    [anon_sym_LT_LT_DASH] = ACTIONS(2855),
    [anon_sym_LT_LT_LT] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2857),
  },
  [1374] = {
    [sym_concatenation] = STATE(1775),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1775),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_EQ] = ACTIONS(4150),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4152),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4150),
    [anon_sym_COLON_QMARK] = ACTIONS(4150),
    [anon_sym_COLON_DASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [anon_sym_DASH] = ACTIONS(4150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1375] = {
    [sym_file_redirect] = STATE(1776),
    [sym_file_descriptor] = ACTIONS(2887),
    [anon_sym_PIPE] = ACTIONS(2334),
    [anon_sym_RPAREN] = ACTIONS(2336),
    [anon_sym_PIPE_AMP] = ACTIONS(2336),
    [anon_sym_AMP_AMP] = ACTIONS(2336),
    [anon_sym_PIPE_PIPE] = ACTIONS(2336),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_GT_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT] = ACTIONS(2889),
    [anon_sym_AMP_GT_GT] = ACTIONS(2891),
    [anon_sym_LT_AMP] = ACTIONS(2891),
    [anon_sym_GT_AMP] = ACTIONS(2891),
    [sym_comment] = ACTIONS(53),
  },
  [1376] = {
    [anon_sym_PIPE] = ACTIONS(3268),
    [anon_sym_RPAREN] = ACTIONS(3270),
    [anon_sym_PIPE_AMP] = ACTIONS(3270),
    [anon_sym_AMP_AMP] = ACTIONS(3270),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_BQUOTE] = ACTIONS(3270),
    [sym_comment] = ACTIONS(53),
  },
  [1377] = {
    [aux_sym_concatenation_repeat1] = STATE(1380),
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [sym_comment] = ACTIONS(53),
  },
  [1378] = {
    [aux_sym_concatenation_repeat1] = STATE(1380),
    [sym__simple_heredoc_body] = ACTIONS(1093),
    [sym__heredoc_body_beginning] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [1379] = {
    [sym__simple_heredoc_body] = ACTIONS(1093),
    [sym__heredoc_body_beginning] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [1380] = {
    [aux_sym_concatenation_repeat1] = STATE(1777),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_LT] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [1381] = {
    [anon_sym_PIPE] = ACTIONS(3283),
    [anon_sym_RPAREN] = ACTIONS(3285),
    [anon_sym_PIPE_AMP] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym_comment] = ACTIONS(53),
  },
  [1382] = {
    [sym_file_redirect] = STATE(938),
    [sym_heredoc_redirect] = STATE(938),
    [sym_heredoc_body] = STATE(1778),
    [sym_herestring_redirect] = STATE(938),
    [aux_sym_while_statement_repeat1] = STATE(938),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(3283),
    [anon_sym_RPAREN] = ACTIONS(3285),
    [anon_sym_PIPE_AMP] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym_comment] = ACTIONS(53),
  },
  [1383] = {
    [aux_sym_concatenation_repeat1] = STATE(1779),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(693),
  },
  [1384] = {
    [sym_file_redirect] = STATE(965),
    [sym_heredoc_redirect] = STATE(965),
    [sym_heredoc_body] = STATE(1688),
    [sym_herestring_redirect] = STATE(965),
    [aux_sym_while_statement_repeat1] = STATE(965),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(2235),
    [anon_sym_PIPE_AMP] = ACTIONS(2237),
    [anon_sym_AMP_AMP] = ACTIONS(2237),
    [anon_sym_PIPE_PIPE] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(2237),
    [sym_comment] = ACTIONS(53),
  },
  [1385] = {
    [sym_compound_statement] = STATE(1780),
    [anon_sym_LBRACE] = ACTIONS(1840),
    [sym_comment] = ACTIONS(53),
  },
  [1386] = {
    [anon_sym_LT] = ACTIONS(4154),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4156),
    [anon_sym_AMP_GT] = ACTIONS(4154),
    [anon_sym_AMP_GT_GT] = ACTIONS(4156),
    [anon_sym_LT_AMP] = ACTIONS(4156),
    [anon_sym_GT_AMP] = ACTIONS(4156),
    [sym_comment] = ACTIONS(53),
  },
  [1387] = {
    [sym_concatenation] = STATE(1705),
    [sym_string] = STATE(1783),
    [sym_simple_expansion] = STATE(1783),
    [sym_string_expansion] = STATE(1783),
    [sym_expansion] = STATE(1783),
    [sym_command_substitution] = STATE(1783),
    [sym_process_substitution] = STATE(1783),
    [sym__special_characters] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(4160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4160),
  },
  [1388] = {
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_GT] = ACTIONS(4162),
    [anon_sym_GT_GT] = ACTIONS(4164),
    [anon_sym_AMP_GT] = ACTIONS(4162),
    [anon_sym_AMP_GT_GT] = ACTIONS(4164),
    [anon_sym_LT_AMP] = ACTIONS(4164),
    [anon_sym_GT_AMP] = ACTIONS(4164),
    [sym_comment] = ACTIONS(53),
  },
  [1389] = {
    [sym_concatenation] = STATE(1716),
    [sym_string] = STATE(1786),
    [sym_simple_expansion] = STATE(1786),
    [sym_string_expansion] = STATE(1786),
    [sym_expansion] = STATE(1786),
    [sym_command_substitution] = STATE(1786),
    [sym_process_substitution] = STATE(1786),
    [sym__special_characters] = ACTIONS(4166),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4012),
    [sym_raw_string] = ACTIONS(4168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4020),
    [anon_sym_LT_LPAREN] = ACTIONS(4022),
    [anon_sym_GT_LPAREN] = ACTIONS(4022),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4168),
  },
  [1390] = {
    [sym_concatenation] = STATE(1720),
    [sym_string] = STATE(1788),
    [sym_simple_expansion] = STATE(1788),
    [sym_string_expansion] = STATE(1788),
    [sym_expansion] = STATE(1788),
    [sym_command_substitution] = STATE(1788),
    [sym_process_substitution] = STATE(1788),
    [sym__special_characters] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4012),
    [sym_raw_string] = ACTIONS(4172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4020),
    [anon_sym_LT_LPAREN] = ACTIONS(4022),
    [anon_sym_GT_LPAREN] = ACTIONS(4022),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4172),
  },
  [1391] = {
    [sym_file_redirect] = STATE(1789),
    [sym_heredoc_redirect] = STATE(1789),
    [sym_herestring_redirect] = STATE(1789),
    [aux_sym_while_statement_repeat1] = STATE(1789),
    [sym_file_descriptor] = ACTIONS(3173),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_PIPE_AMP] = ACTIONS(2480),
    [anon_sym_AMP_AMP] = ACTIONS(2480),
    [anon_sym_PIPE_PIPE] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(3175),
    [anon_sym_GT] = ACTIONS(3175),
    [anon_sym_GT_GT] = ACTIONS(3177),
    [anon_sym_AMP_GT] = ACTIONS(3175),
    [anon_sym_AMP_GT_GT] = ACTIONS(3177),
    [anon_sym_LT_AMP] = ACTIONS(3177),
    [anon_sym_GT_AMP] = ACTIONS(3177),
    [anon_sym_LT_LT] = ACTIONS(2907),
    [anon_sym_LT_LT_DASH] = ACTIONS(2909),
    [anon_sym_LT_LT_LT] = ACTIONS(3179),
    [anon_sym_BQUOTE] = ACTIONS(2480),
    [sym_comment] = ACTIONS(53),
  },
  [1392] = {
    [aux_sym_concatenation_repeat1] = STATE(949),
    [sym__concat] = ACTIONS(1852),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [sym__special_characters] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1129),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [anon_sym_LT_LPAREN] = ACTIONS(1129),
    [anon_sym_GT_LPAREN] = ACTIONS(1129),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1133),
    [sym_word] = ACTIONS(1133),
  },
  [1393] = {
    [aux_sym_concatenation_repeat1] = STATE(949),
    [sym__concat] = ACTIONS(1852),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
  },
  [1394] = {
    [aux_sym_concatenation_repeat1] = STATE(1394),
    [sym__concat] = ACTIONS(4032),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
  },
  [1395] = {
    [aux_sym_concatenation_repeat1] = STATE(1395),
    [sym__concat] = ACTIONS(4075),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
  },
  [1396] = {
    [sym_file_redirect] = STATE(1776),
    [sym_file_descriptor] = ACTIONS(3167),
    [anon_sym_PIPE] = ACTIONS(2334),
    [anon_sym_PIPE_AMP] = ACTIONS(2336),
    [anon_sym_AMP_AMP] = ACTIONS(2336),
    [anon_sym_PIPE_PIPE] = ACTIONS(2336),
    [anon_sym_LT] = ACTIONS(3169),
    [anon_sym_GT] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3171),
    [anon_sym_AMP_GT] = ACTIONS(3169),
    [anon_sym_AMP_GT_GT] = ACTIONS(3171),
    [anon_sym_LT_AMP] = ACTIONS(3171),
    [anon_sym_GT_AMP] = ACTIONS(3171),
    [anon_sym_BQUOTE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(53),
  },
  [1397] = {
    [aux_sym_concatenation_repeat1] = STATE(1399),
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(53),
  },
  [1398] = {
    [aux_sym_concatenation_repeat1] = STATE(1399),
    [sym__simple_heredoc_body] = ACTIONS(1093),
    [sym__heredoc_body_beginning] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [1399] = {
    [aux_sym_concatenation_repeat1] = STATE(1790),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_LT] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [1400] = {
    [sym_file_redirect] = STATE(965),
    [sym_heredoc_redirect] = STATE(965),
    [sym_heredoc_body] = STATE(1778),
    [sym_herestring_redirect] = STATE(965),
    [aux_sym_while_statement_repeat1] = STATE(965),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(3283),
    [anon_sym_PIPE_AMP] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym_comment] = ACTIONS(53),
  },
  [1401] = {
    [anon_sym_esac] = ACTIONS(3521),
    [anon_sym_PIPE] = ACTIONS(3521),
    [anon_sym_RPAREN] = ACTIONS(3521),
    [anon_sym_SEMI_SEMI] = ACTIONS(3521),
    [anon_sym_PIPE_AMP] = ACTIONS(3521),
    [anon_sym_AMP_AMP] = ACTIONS(3521),
    [anon_sym_PIPE_PIPE] = ACTIONS(3521),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3521),
    [anon_sym_LF] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
  },
  [1402] = {
    [sym_concatenation] = STATE(1794),
    [sym_string] = STATE(1793),
    [sym_simple_expansion] = STATE(1793),
    [sym_string_expansion] = STATE(1793),
    [sym_expansion] = STATE(1793),
    [sym_command_substitution] = STATE(1793),
    [sym_process_substitution] = STATE(1793),
    [anon_sym_RBRACE] = ACTIONS(4174),
    [sym__special_characters] = ACTIONS(4176),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(4178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4178),
  },
  [1403] = {
    [sym__heredoc_body_middle] = ACTIONS(1732),
    [sym__heredoc_body_end] = ACTIONS(1732),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1732),
    [sym_comment] = ACTIONS(53),
  },
  [1404] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4180),
  },
  [1405] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1406] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(4184),
    [sym_comment] = ACTIONS(53),
  },
  [1407] = {
    [sym_concatenation] = STATE(1800),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1800),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4188),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4192),
    [anon_sym_COLON] = ACTIONS(4188),
    [anon_sym_COLON_QMARK] = ACTIONS(4188),
    [anon_sym_COLON_DASH] = ACTIONS(4188),
    [anon_sym_PERCENT] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4188),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1408] = {
    [sym_concatenation] = STATE(1803),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1803),
    [anon_sym_RBRACE] = ACTIONS(4194),
    [anon_sym_EQ] = ACTIONS(4196),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4200),
    [anon_sym_COLON] = ACTIONS(4196),
    [anon_sym_COLON_QMARK] = ACTIONS(4196),
    [anon_sym_COLON_DASH] = ACTIONS(4196),
    [anon_sym_PERCENT] = ACTIONS(4196),
    [anon_sym_DASH] = ACTIONS(4196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1409] = {
    [sym_concatenation] = STATE(1805),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1805),
    [anon_sym_RBRACE] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4202),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_DASH] = ACTIONS(4202),
    [anon_sym_PERCENT] = ACTIONS(4202),
    [anon_sym_DASH] = ACTIONS(4202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1410] = {
    [sym__heredoc_body_middle] = ACTIONS(1798),
    [sym__heredoc_body_end] = ACTIONS(1798),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1798),
    [sym_comment] = ACTIONS(53),
  },
  [1411] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4208),
  },
  [1412] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4210),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1413] = {
    [sym__heredoc_body_middle] = ACTIONS(1806),
    [sym__heredoc_body_end] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1806),
    [sym_comment] = ACTIONS(53),
  },
  [1414] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4212),
  },
  [1415] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1416] = {
    [aux_sym_concatenation_repeat1] = STATE(1416),
    [sym__simple_heredoc_body] = ACTIONS(1642),
    [sym__heredoc_body_beginning] = ACTIONS(1642),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1646),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1417] = {
    [anon_sym_esac] = ACTIONS(4214),
    [anon_sym_PIPE] = ACTIONS(4214),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_SEMI_SEMI] = ACTIONS(4214),
    [anon_sym_PIPE_AMP] = ACTIONS(4214),
    [anon_sym_AMP_AMP] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(4214),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_LF] = ACTIONS(4216),
    [anon_sym_AMP] = ACTIONS(4214),
  },
  [1418] = {
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_PLUS_EQ] = ACTIONS(4218),
    [sym_comment] = ACTIONS(53),
  },
  [1419] = {
    [anon_sym_EQ] = ACTIONS(4220),
    [anon_sym_PLUS_EQ] = ACTIONS(4220),
    [sym_comment] = ACTIONS(53),
  },
  [1420] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1642),
  },
  [1421] = {
    [aux_sym_concatenation_repeat1] = STATE(1421),
    [sym__concat] = ACTIONS(4222),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1642),
  },
  [1422] = {
    [sym__concat] = ACTIONS(1691),
    [anon_sym_RPAREN] = ACTIONS(1691),
    [sym__special_characters] = ACTIONS(1691),
    [anon_sym_DQUOTE] = ACTIONS(1691),
    [anon_sym_DOLLAR] = ACTIONS(1693),
    [sym_raw_string] = ACTIONS(1691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1691),
    [anon_sym_BQUOTE] = ACTIONS(1691),
    [anon_sym_LT_LPAREN] = ACTIONS(1691),
    [anon_sym_GT_LPAREN] = ACTIONS(1691),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1691),
  },
  [1423] = {
    [sym_concatenation] = STATE(1812),
    [sym_string] = STATE(1811),
    [sym_simple_expansion] = STATE(1811),
    [sym_string_expansion] = STATE(1811),
    [sym_expansion] = STATE(1811),
    [sym_command_substitution] = STATE(1811),
    [sym_process_substitution] = STATE(1811),
    [anon_sym_RBRACE] = ACTIONS(4225),
    [sym__special_characters] = ACTIONS(4227),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(4229),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4229),
  },
  [1424] = {
    [sym__concat] = ACTIONS(1732),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [sym__special_characters] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1732),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [sym_raw_string] = ACTIONS(1732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1732),
    [anon_sym_BQUOTE] = ACTIONS(1732),
    [anon_sym_LT_LPAREN] = ACTIONS(1732),
    [anon_sym_GT_LPAREN] = ACTIONS(1732),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1732),
  },
  [1425] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4231),
  },
  [1426] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4233),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1427] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(4235),
    [sym_comment] = ACTIONS(53),
  },
  [1428] = {
    [sym_concatenation] = STATE(1818),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1818),
    [anon_sym_RBRACE] = ACTIONS(4237),
    [anon_sym_EQ] = ACTIONS(4239),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4241),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4243),
    [anon_sym_COLON] = ACTIONS(4239),
    [anon_sym_COLON_QMARK] = ACTIONS(4239),
    [anon_sym_COLON_DASH] = ACTIONS(4239),
    [anon_sym_PERCENT] = ACTIONS(4239),
    [anon_sym_DASH] = ACTIONS(4239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1429] = {
    [sym_concatenation] = STATE(1821),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1821),
    [anon_sym_RBRACE] = ACTIONS(4245),
    [anon_sym_EQ] = ACTIONS(4247),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4251),
    [anon_sym_COLON] = ACTIONS(4247),
    [anon_sym_COLON_QMARK] = ACTIONS(4247),
    [anon_sym_COLON_DASH] = ACTIONS(4247),
    [anon_sym_PERCENT] = ACTIONS(4247),
    [anon_sym_DASH] = ACTIONS(4247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1430] = {
    [sym_concatenation] = STATE(1823),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1823),
    [anon_sym_RBRACE] = ACTIONS(4225),
    [anon_sym_EQ] = ACTIONS(4253),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4257),
    [anon_sym_COLON] = ACTIONS(4253),
    [anon_sym_COLON_QMARK] = ACTIONS(4253),
    [anon_sym_COLON_DASH] = ACTIONS(4253),
    [anon_sym_PERCENT] = ACTIONS(4253),
    [anon_sym_DASH] = ACTIONS(4253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1431] = {
    [sym__concat] = ACTIONS(1798),
    [anon_sym_RPAREN] = ACTIONS(1798),
    [sym__special_characters] = ACTIONS(1798),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [sym_raw_string] = ACTIONS(1798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1798),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1798),
    [anon_sym_BQUOTE] = ACTIONS(1798),
    [anon_sym_LT_LPAREN] = ACTIONS(1798),
    [anon_sym_GT_LPAREN] = ACTIONS(1798),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1798),
  },
  [1432] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4259),
  },
  [1433] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4261),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1434] = {
    [sym__concat] = ACTIONS(1806),
    [anon_sym_RPAREN] = ACTIONS(1806),
    [sym__special_characters] = ACTIONS(1806),
    [anon_sym_DQUOTE] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [sym_raw_string] = ACTIONS(1806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1806),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1806),
    [anon_sym_BQUOTE] = ACTIONS(1806),
    [anon_sym_LT_LPAREN] = ACTIONS(1806),
    [anon_sym_GT_LPAREN] = ACTIONS(1806),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1806),
  },
  [1435] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4263),
  },
  [1436] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4225),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1437] = {
    [sym__concat] = ACTIONS(1940),
    [anon_sym_RPAREN] = ACTIONS(1940),
    [sym__special_characters] = ACTIONS(1940),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [anon_sym_DOLLAR] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1940),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1940),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1940),
    [anon_sym_BQUOTE] = ACTIONS(1940),
    [anon_sym_LT_LPAREN] = ACTIONS(1940),
    [anon_sym_GT_LPAREN] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1940),
  },
  [1438] = {
    [sym__concat] = ACTIONS(2006),
    [anon_sym_RPAREN] = ACTIONS(2006),
    [sym__special_characters] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [anon_sym_DOLLAR] = ACTIONS(2008),
    [sym_raw_string] = ACTIONS(2006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2006),
    [anon_sym_BQUOTE] = ACTIONS(2006),
    [anon_sym_LT_LPAREN] = ACTIONS(2006),
    [anon_sym_GT_LPAREN] = ACTIONS(2006),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2006),
  },
  [1439] = {
    [sym_file_descriptor] = ACTIONS(2710),
    [sym__concat] = ACTIONS(2710),
    [sym_variable_name] = ACTIONS(2710),
    [anon_sym_esac] = ACTIONS(2712),
    [anon_sym_PIPE] = ACTIONS(2712),
    [anon_sym_RPAREN] = ACTIONS(2712),
    [anon_sym_SEMI_SEMI] = ACTIONS(2712),
    [anon_sym_PIPE_AMP] = ACTIONS(2712),
    [anon_sym_AMP_AMP] = ACTIONS(2712),
    [anon_sym_PIPE_PIPE] = ACTIONS(2712),
    [anon_sym_LT] = ACTIONS(2712),
    [anon_sym_GT] = ACTIONS(2712),
    [anon_sym_GT_GT] = ACTIONS(2712),
    [anon_sym_AMP_GT] = ACTIONS(2712),
    [anon_sym_AMP_GT_GT] = ACTIONS(2712),
    [anon_sym_LT_AMP] = ACTIONS(2712),
    [anon_sym_GT_AMP] = ACTIONS(2712),
    [sym__special_characters] = ACTIONS(2712),
    [anon_sym_DQUOTE] = ACTIONS(2712),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [sym_raw_string] = ACTIONS(2712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2712),
    [anon_sym_BQUOTE] = ACTIONS(2712),
    [anon_sym_LT_LPAREN] = ACTIONS(2712),
    [anon_sym_GT_LPAREN] = ACTIONS(2712),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_LF] = ACTIONS(2710),
    [anon_sym_AMP] = ACTIONS(2712),
  },
  [1440] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4265),
    [sym_comment] = ACTIONS(53),
  },
  [1441] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4267),
    [sym_comment] = ACTIONS(53),
  },
  [1442] = {
    [anon_sym_RBRACE] = ACTIONS(4267),
    [sym_comment] = ACTIONS(53),
  },
  [1443] = {
    [sym_concatenation] = STATE(1830),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1830),
    [anon_sym_RBRACE] = ACTIONS(4269),
    [anon_sym_EQ] = ACTIONS(4271),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4273),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4271),
    [anon_sym_COLON_QMARK] = ACTIONS(4271),
    [anon_sym_COLON_DASH] = ACTIONS(4271),
    [anon_sym_PERCENT] = ACTIONS(4271),
    [anon_sym_DASH] = ACTIONS(4271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1444] = {
    [sym_file_descriptor] = ACTIONS(2788),
    [sym__concat] = ACTIONS(2788),
    [sym_variable_name] = ACTIONS(2788),
    [anon_sym_esac] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_RPAREN] = ACTIONS(2790),
    [anon_sym_SEMI_SEMI] = ACTIONS(2790),
    [anon_sym_PIPE_AMP] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2790),
    [anon_sym_PIPE_PIPE] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_AMP_GT] = ACTIONS(2790),
    [anon_sym_AMP_GT_GT] = ACTIONS(2790),
    [anon_sym_LT_AMP] = ACTIONS(2790),
    [anon_sym_GT_AMP] = ACTIONS(2790),
    [sym__special_characters] = ACTIONS(2790),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym_raw_string] = ACTIONS(2790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2790),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [anon_sym_LT_LPAREN] = ACTIONS(2790),
    [anon_sym_GT_LPAREN] = ACTIONS(2790),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2790),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_LF] = ACTIONS(2788),
    [anon_sym_AMP] = ACTIONS(2790),
  },
  [1445] = {
    [sym_concatenation] = STATE(1833),
    [sym_string] = STATE(1832),
    [sym_simple_expansion] = STATE(1832),
    [sym_string_expansion] = STATE(1832),
    [sym_expansion] = STATE(1832),
    [sym_command_substitution] = STATE(1832),
    [sym_process_substitution] = STATE(1832),
    [anon_sym_RBRACE] = ACTIONS(4267),
    [sym__special_characters] = ACTIONS(4275),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(4277),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4277),
  },
  [1446] = {
    [sym_file_descriptor] = ACTIONS(2831),
    [sym__concat] = ACTIONS(2831),
    [sym_variable_name] = ACTIONS(2831),
    [anon_sym_esac] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2833),
    [anon_sym_SEMI_SEMI] = ACTIONS(2833),
    [anon_sym_PIPE_AMP] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_AMP_GT] = ACTIONS(2833),
    [anon_sym_AMP_GT_GT] = ACTIONS(2833),
    [anon_sym_LT_AMP] = ACTIONS(2833),
    [anon_sym_GT_AMP] = ACTIONS(2833),
    [sym__special_characters] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [sym_raw_string] = ACTIONS(2833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2833),
    [anon_sym_BQUOTE] = ACTIONS(2833),
    [anon_sym_LT_LPAREN] = ACTIONS(2833),
    [anon_sym_GT_LPAREN] = ACTIONS(2833),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2831),
    [anon_sym_AMP] = ACTIONS(2833),
  },
  [1447] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4279),
  },
  [1448] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4281),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1449] = {
    [sym_file_descriptor] = ACTIONS(2839),
    [sym__concat] = ACTIONS(2839),
    [sym_variable_name] = ACTIONS(2839),
    [anon_sym_esac] = ACTIONS(2841),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_RPAREN] = ACTIONS(2841),
    [anon_sym_SEMI_SEMI] = ACTIONS(2841),
    [anon_sym_PIPE_AMP] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_GT] = ACTIONS(2841),
    [anon_sym_GT_GT] = ACTIONS(2841),
    [anon_sym_AMP_GT] = ACTIONS(2841),
    [anon_sym_AMP_GT_GT] = ACTIONS(2841),
    [anon_sym_LT_AMP] = ACTIONS(2841),
    [anon_sym_GT_AMP] = ACTIONS(2841),
    [sym__special_characters] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2841),
    [sym_raw_string] = ACTIONS(2841),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2841),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2841),
    [anon_sym_BQUOTE] = ACTIONS(2841),
    [anon_sym_LT_LPAREN] = ACTIONS(2841),
    [anon_sym_GT_LPAREN] = ACTIONS(2841),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2839),
    [anon_sym_AMP] = ACTIONS(2841),
  },
  [1450] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4283),
  },
  [1451] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4285),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1452] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4287),
  },
  [1453] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4267),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1454] = {
    [sym_concatenation] = STATE(1840),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1840),
    [anon_sym_RBRACE] = ACTIONS(4289),
    [anon_sym_EQ] = ACTIONS(4291),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4293),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4291),
    [anon_sym_COLON_QMARK] = ACTIONS(4291),
    [anon_sym_COLON_DASH] = ACTIONS(4291),
    [anon_sym_PERCENT] = ACTIONS(4291),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1455] = {
    [sym_file_descriptor] = ACTIONS(2855),
    [sym__concat] = ACTIONS(2855),
    [sym_variable_name] = ACTIONS(2855),
    [anon_sym_esac] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2857),
    [anon_sym_SEMI_SEMI] = ACTIONS(2857),
    [anon_sym_PIPE_AMP] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT_GT] = ACTIONS(2857),
    [anon_sym_LT_AMP] = ACTIONS(2857),
    [anon_sym_GT_AMP] = ACTIONS(2857),
    [sym__special_characters] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2857),
    [anon_sym_BQUOTE] = ACTIONS(2857),
    [anon_sym_LT_LPAREN] = ACTIONS(2857),
    [anon_sym_GT_LPAREN] = ACTIONS(2857),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [1456] = {
    [sym_concatenation] = STATE(1842),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1842),
    [anon_sym_RBRACE] = ACTIONS(4295),
    [anon_sym_EQ] = ACTIONS(4297),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4297),
    [anon_sym_COLON_QMARK] = ACTIONS(4297),
    [anon_sym_COLON_DASH] = ACTIONS(4297),
    [anon_sym_PERCENT] = ACTIONS(4297),
    [anon_sym_DASH] = ACTIONS(4297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1457] = {
    [aux_sym_concatenation_repeat1] = STATE(1457),
    [sym__concat] = ACTIONS(2267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1458] = {
    [anon_sym_esac] = ACTIONS(4301),
    [anon_sym_PIPE] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(4301),
    [anon_sym_SEMI_SEMI] = ACTIONS(4301),
    [anon_sym_PIPE_AMP] = ACTIONS(4301),
    [anon_sym_AMP_AMP] = ACTIONS(4301),
    [anon_sym_PIPE_PIPE] = ACTIONS(4301),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4301),
    [anon_sym_LF] = ACTIONS(4303),
    [anon_sym_AMP] = ACTIONS(4301),
  },
  [1459] = {
    [anon_sym_esac] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3440),
    [anon_sym_RPAREN] = ACTIONS(3440),
    [anon_sym_SEMI_SEMI] = ACTIONS(3440),
    [anon_sym_PIPE_AMP] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE] = ACTIONS(3440),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3440),
    [anon_sym_LF] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3440),
  },
  [1460] = {
    [sym__terminated_statement] = STATE(1843),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1843),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(4305),
    [anon_sym_elif] = ACTIONS(4305),
    [anon_sym_else] = ACTIONS(4305),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1461] = {
    [sym__terminated_statement] = STATE(1461),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1461),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_fi] = ACTIONS(3442),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [1462] = {
    [anon_sym_esac] = ACTIONS(4307),
    [anon_sym_PIPE] = ACTIONS(4307),
    [anon_sym_RPAREN] = ACTIONS(4307),
    [anon_sym_SEMI_SEMI] = ACTIONS(4307),
    [anon_sym_PIPE_AMP] = ACTIONS(4307),
    [anon_sym_AMP_AMP] = ACTIONS(4307),
    [anon_sym_PIPE_PIPE] = ACTIONS(4307),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4307),
    [anon_sym_LF] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4307),
  },
  [1463] = {
    [anon_sym_fi] = ACTIONS(4311),
    [sym_comment] = ACTIONS(53),
  },
  [1464] = {
    [sym_concatenation] = STATE(1847),
    [sym_string] = STATE(1846),
    [sym_simple_expansion] = STATE(1846),
    [sym_string_expansion] = STATE(1846),
    [sym_expansion] = STATE(1846),
    [sym_command_substitution] = STATE(1846),
    [sym_process_substitution] = STATE(1846),
    [sym__special_characters] = ACTIONS(4313),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(4315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4315),
  },
  [1465] = {
    [sym__terminated_statement] = STATE(1864),
    [sym_for_statement] = STATE(1860),
    [sym_while_statement] = STATE(1860),
    [sym_if_statement] = STATE(1860),
    [sym_case_statement] = STATE(1860),
    [sym_function_definition] = STATE(1860),
    [sym_subshell] = STATE(1860),
    [sym_pipeline] = STATE(1860),
    [sym_list] = STATE(1860),
    [sym_negated_command] = STATE(1860),
    [sym_test_command] = STATE(1860),
    [sym_declaration_command] = STATE(1860),
    [sym_unset_command] = STATE(1860),
    [sym_command] = STATE(1860),
    [sym_command_name] = STATE(1861),
    [sym_variable_assignment] = STATE(1862),
    [sym_subscript] = STATE(1863),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(1858),
    [sym_simple_expansion] = STATE(1858),
    [sym_string_expansion] = STATE(1858),
    [sym_expansion] = STATE(1858),
    [sym_command_substitution] = STATE(1858),
    [sym_process_substitution] = STATE(1858),
    [aux_sym_program_repeat1] = STATE(1864),
    [aux_sym_command_repeat1] = STATE(1865),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4317),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4319),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(4321),
    [anon_sym_SEMI_SEMI] = ACTIONS(4323),
    [anon_sym_function] = ACTIONS(4325),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4327),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4331),
    [anon_sym_declare] = ACTIONS(4333),
    [anon_sym_typeset] = ACTIONS(4333),
    [anon_sym_export] = ACTIONS(4333),
    [anon_sym_readonly] = ACTIONS(4333),
    [anon_sym_local] = ACTIONS(4333),
    [anon_sym_unset] = ACTIONS(4335),
    [anon_sym_unsetenv] = ACTIONS(4335),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4337),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4341),
  },
  [1466] = {
    [aux_sym_case_item_repeat1] = STATE(1867),
    [anon_sym_PIPE] = ACTIONS(3467),
    [anon_sym_RPAREN] = ACTIONS(4343),
    [sym_comment] = ACTIONS(53),
  },
  [1467] = {
    [aux_sym_concatenation_repeat1] = STATE(1868),
    [sym__concat] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_RPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [1468] = {
    [sym__terminated_statement] = STATE(1872),
    [sym_for_statement] = STATE(1870),
    [sym_while_statement] = STATE(1870),
    [sym_if_statement] = STATE(1870),
    [sym_case_statement] = STATE(1870),
    [sym_function_definition] = STATE(1870),
    [sym_subshell] = STATE(1870),
    [sym_pipeline] = STATE(1870),
    [sym_list] = STATE(1870),
    [sym_negated_command] = STATE(1870),
    [sym_test_command] = STATE(1870),
    [sym_declaration_command] = STATE(1870),
    [sym_unset_command] = STATE(1870),
    [sym_command] = STATE(1870),
    [sym_command_name] = STATE(1861),
    [sym_variable_assignment] = STATE(1871),
    [sym_subscript] = STATE(1863),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(1858),
    [sym_simple_expansion] = STATE(1858),
    [sym_string_expansion] = STATE(1858),
    [sym_expansion] = STATE(1858),
    [sym_command_substitution] = STATE(1858),
    [sym_process_substitution] = STATE(1858),
    [aux_sym_program_repeat1] = STATE(1872),
    [aux_sym_command_repeat1] = STATE(1865),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4317),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4319),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(4345),
    [anon_sym_SEMI_SEMI] = ACTIONS(4347),
    [anon_sym_function] = ACTIONS(4325),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4327),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4331),
    [anon_sym_declare] = ACTIONS(4333),
    [anon_sym_typeset] = ACTIONS(4333),
    [anon_sym_export] = ACTIONS(4333),
    [anon_sym_readonly] = ACTIONS(4333),
    [anon_sym_local] = ACTIONS(4333),
    [anon_sym_unset] = ACTIONS(4335),
    [anon_sym_unsetenv] = ACTIONS(4335),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4337),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4341),
  },
  [1469] = {
    [aux_sym_case_item_repeat1] = STATE(1867),
    [anon_sym_PIPE] = ACTIONS(3467),
    [anon_sym_RPAREN] = ACTIONS(4349),
    [sym_comment] = ACTIONS(53),
  },
  [1470] = {
    [anon_sym_esac] = ACTIONS(4351),
    [anon_sym_PIPE] = ACTIONS(4351),
    [anon_sym_RPAREN] = ACTIONS(4351),
    [anon_sym_SEMI_SEMI] = ACTIONS(4351),
    [anon_sym_PIPE_AMP] = ACTIONS(4351),
    [anon_sym_AMP_AMP] = ACTIONS(4351),
    [anon_sym_PIPE_PIPE] = ACTIONS(4351),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4351),
    [anon_sym_LF] = ACTIONS(4353),
    [anon_sym_AMP] = ACTIONS(4351),
  },
  [1471] = {
    [anon_sym_esac] = ACTIONS(4355),
    [sym_comment] = ACTIONS(53),
  },
  [1472] = {
    [sym_case_item] = STATE(1472),
    [sym_concatenation] = STATE(1877),
    [sym_string] = STATE(1876),
    [sym_simple_expansion] = STATE(1876),
    [sym_string_expansion] = STATE(1876),
    [sym_expansion] = STATE(1876),
    [sym_command_substitution] = STATE(1876),
    [sym_process_substitution] = STATE(1876),
    [aux_sym_case_statement_repeat1] = STATE(1472),
    [sym__special_characters] = ACTIONS(4357),
    [anon_sym_DQUOTE] = ACTIONS(4360),
    [anon_sym_DOLLAR] = ACTIONS(4363),
    [sym_raw_string] = ACTIONS(4366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4372),
    [anon_sym_BQUOTE] = ACTIONS(4375),
    [anon_sym_LT_LPAREN] = ACTIONS(4378),
    [anon_sym_GT_LPAREN] = ACTIONS(4378),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4366),
  },
  [1473] = {
    [anon_sym_esac] = ACTIONS(4381),
    [anon_sym_PIPE] = ACTIONS(4381),
    [anon_sym_RPAREN] = ACTIONS(4381),
    [anon_sym_SEMI_SEMI] = ACTIONS(4381),
    [anon_sym_PIPE_AMP] = ACTIONS(4381),
    [anon_sym_AMP_AMP] = ACTIONS(4381),
    [anon_sym_PIPE_PIPE] = ACTIONS(4381),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4381),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4381),
  },
  [1474] = {
    [sym_case_item] = STATE(1472),
    [sym_last_case_item] = STATE(1878),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(1472),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2259),
  },
  [1475] = {
    [anon_sym_esac] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_RPAREN] = ACTIONS(4385),
    [anon_sym_SEMI_SEMI] = ACTIONS(4385),
    [anon_sym_PIPE_AMP] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_PIPE_PIPE] = ACTIONS(4385),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym_LF] = ACTIONS(4387),
    [anon_sym_AMP] = ACTIONS(4385),
  },
  [1476] = {
    [anon_sym_esac] = ACTIONS(4389),
    [sym_comment] = ACTIONS(53),
  },
  [1477] = {
    [anon_sym_esac] = ACTIONS(4391),
    [anon_sym_PIPE] = ACTIONS(4391),
    [anon_sym_RPAREN] = ACTIONS(4391),
    [anon_sym_SEMI_SEMI] = ACTIONS(4391),
    [anon_sym_PIPE_AMP] = ACTIONS(4391),
    [anon_sym_AMP_AMP] = ACTIONS(4391),
    [anon_sym_PIPE_PIPE] = ACTIONS(4391),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4391),
    [anon_sym_LF] = ACTIONS(4393),
    [anon_sym_AMP] = ACTIONS(4391),
  },
  [1478] = {
    [sym_case_item] = STATE(1472),
    [sym_last_case_item] = STATE(1880),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(1472),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2259),
  },
  [1479] = {
    [sym__concat] = ACTIONS(3829),
    [anon_sym_in] = ACTIONS(3831),
    [anon_sym_SEMI_SEMI] = ACTIONS(3831),
    [sym__special_characters] = ACTIONS(3831),
    [anon_sym_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [sym_raw_string] = ACTIONS(3831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3831),
    [anon_sym_BQUOTE] = ACTIONS(3831),
    [anon_sym_LT_LPAREN] = ACTIONS(3831),
    [anon_sym_GT_LPAREN] = ACTIONS(3831),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3831),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_LF] = ACTIONS(3829),
    [anon_sym_AMP] = ACTIONS(3831),
  },
  [1480] = {
    [sym__concat] = ACTIONS(3835),
    [anon_sym_in] = ACTIONS(3837),
    [anon_sym_SEMI_SEMI] = ACTIONS(3837),
    [sym__special_characters] = ACTIONS(3837),
    [anon_sym_DQUOTE] = ACTIONS(3837),
    [anon_sym_DOLLAR] = ACTIONS(3837),
    [sym_raw_string] = ACTIONS(3837),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3837),
    [anon_sym_BQUOTE] = ACTIONS(3837),
    [anon_sym_LT_LPAREN] = ACTIONS(3837),
    [anon_sym_GT_LPAREN] = ACTIONS(3837),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3837),
    [anon_sym_SEMI] = ACTIONS(3837),
    [anon_sym_LF] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
  },
  [1481] = {
    [sym__concat] = ACTIONS(3920),
    [anon_sym_in] = ACTIONS(3922),
    [anon_sym_SEMI_SEMI] = ACTIONS(3922),
    [sym__special_characters] = ACTIONS(3922),
    [anon_sym_DQUOTE] = ACTIONS(3922),
    [anon_sym_DOLLAR] = ACTIONS(3922),
    [sym_raw_string] = ACTIONS(3922),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3922),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3922),
    [anon_sym_BQUOTE] = ACTIONS(3922),
    [anon_sym_LT_LPAREN] = ACTIONS(3922),
    [anon_sym_GT_LPAREN] = ACTIONS(3922),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3922),
    [anon_sym_SEMI] = ACTIONS(3922),
    [anon_sym_LF] = ACTIONS(3920),
    [anon_sym_AMP] = ACTIONS(3922),
  },
  [1482] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4395),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1483] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4397),
    [sym_comment] = ACTIONS(53),
  },
  [1484] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4399),
    [sym_comment] = ACTIONS(53),
  },
  [1485] = {
    [anon_sym_RBRACE] = ACTIONS(4399),
    [sym_comment] = ACTIONS(53),
  },
  [1486] = {
    [sym_concatenation] = STATE(1885),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1885),
    [anon_sym_RBRACE] = ACTIONS(4401),
    [anon_sym_EQ] = ACTIONS(4403),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4403),
    [anon_sym_COLON_QMARK] = ACTIONS(4403),
    [anon_sym_COLON_DASH] = ACTIONS(4403),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_DASH] = ACTIONS(4403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1487] = {
    [sym__concat] = ACTIONS(3936),
    [anon_sym_in] = ACTIONS(3938),
    [anon_sym_SEMI_SEMI] = ACTIONS(3938),
    [sym__special_characters] = ACTIONS(3938),
    [anon_sym_DQUOTE] = ACTIONS(3938),
    [anon_sym_DOLLAR] = ACTIONS(3938),
    [sym_raw_string] = ACTIONS(3938),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3938),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3938),
    [anon_sym_BQUOTE] = ACTIONS(3938),
    [anon_sym_LT_LPAREN] = ACTIONS(3938),
    [anon_sym_GT_LPAREN] = ACTIONS(3938),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3938),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_LF] = ACTIONS(3936),
    [anon_sym_AMP] = ACTIONS(3938),
  },
  [1488] = {
    [sym_concatenation] = STATE(1887),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1887),
    [anon_sym_RBRACE] = ACTIONS(4407),
    [anon_sym_EQ] = ACTIONS(4409),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4409),
    [anon_sym_COLON_QMARK] = ACTIONS(4409),
    [anon_sym_COLON_DASH] = ACTIONS(4409),
    [anon_sym_PERCENT] = ACTIONS(4409),
    [anon_sym_DASH] = ACTIONS(4409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1489] = {
    [sym__concat] = ACTIONS(3946),
    [anon_sym_in] = ACTIONS(3948),
    [anon_sym_SEMI_SEMI] = ACTIONS(3948),
    [sym__special_characters] = ACTIONS(3948),
    [anon_sym_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3948),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3948),
    [anon_sym_BQUOTE] = ACTIONS(3948),
    [anon_sym_LT_LPAREN] = ACTIONS(3948),
    [anon_sym_GT_LPAREN] = ACTIONS(3948),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3948),
    [anon_sym_LF] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3948),
  },
  [1490] = {
    [sym_concatenation] = STATE(1889),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1889),
    [anon_sym_RBRACE] = ACTIONS(4413),
    [anon_sym_EQ] = ACTIONS(4415),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4417),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4415),
    [anon_sym_COLON_QMARK] = ACTIONS(4415),
    [anon_sym_COLON_DASH] = ACTIONS(4415),
    [anon_sym_PERCENT] = ACTIONS(4415),
    [anon_sym_DASH] = ACTIONS(4415),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1491] = {
    [sym__concat] = ACTIONS(3956),
    [anon_sym_in] = ACTIONS(3958),
    [anon_sym_SEMI_SEMI] = ACTIONS(3958),
    [sym__special_characters] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [sym_raw_string] = ACTIONS(3958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3958),
    [anon_sym_BQUOTE] = ACTIONS(3958),
    [anon_sym_LT_LPAREN] = ACTIONS(3958),
    [anon_sym_GT_LPAREN] = ACTIONS(3958),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3958),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_LF] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
  },
  [1492] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4419),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1493] = {
    [sym__concat] = ACTIONS(3962),
    [anon_sym_in] = ACTIONS(3964),
    [anon_sym_SEMI_SEMI] = ACTIONS(3964),
    [sym__special_characters] = ACTIONS(3964),
    [anon_sym_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3964),
    [sym_raw_string] = ACTIONS(3964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3964),
    [anon_sym_BQUOTE] = ACTIONS(3964),
    [anon_sym_LT_LPAREN] = ACTIONS(3964),
    [anon_sym_GT_LPAREN] = ACTIONS(3964),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3964),
    [anon_sym_SEMI] = ACTIONS(3964),
    [anon_sym_LF] = ACTIONS(3962),
    [anon_sym_AMP] = ACTIONS(3964),
  },
  [1494] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4421),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1495] = {
    [anon_sym_esac] = ACTIONS(4423),
    [anon_sym_PIPE] = ACTIONS(4423),
    [anon_sym_RPAREN] = ACTIONS(4423),
    [anon_sym_SEMI_SEMI] = ACTIONS(4423),
    [anon_sym_PIPE_AMP] = ACTIONS(4423),
    [anon_sym_AMP_AMP] = ACTIONS(4423),
    [anon_sym_PIPE_PIPE] = ACTIONS(4423),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4423),
    [anon_sym_LF] = ACTIONS(4425),
    [anon_sym_AMP] = ACTIONS(4423),
  },
  [1496] = {
    [aux_sym_concatenation_repeat1] = STATE(1499),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1497] = {
    [aux_sym_concatenation_repeat1] = STATE(1499),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [1498] = {
    [anon_sym_esac] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [1499] = {
    [aux_sym_concatenation_repeat1] = STATE(1892),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [1500] = {
    [aux_sym_concatenation_repeat1] = STATE(1500),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(3367),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1501] = {
    [sym_file_redirect] = STATE(1495),
    [sym_file_descriptor] = ACTIONS(2340),
    [anon_sym_PIPE] = ACTIONS(3521),
    [anon_sym_RPAREN] = ACTIONS(3521),
    [anon_sym_SEMI_SEMI] = ACTIONS(3521),
    [anon_sym_PIPE_AMP] = ACTIONS(3521),
    [anon_sym_AMP_AMP] = ACTIONS(3521),
    [anon_sym_PIPE_PIPE] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_GT] = ACTIONS(2342),
    [anon_sym_GT_GT] = ACTIONS(2342),
    [anon_sym_AMP_GT] = ACTIONS(2342),
    [anon_sym_AMP_GT_GT] = ACTIONS(2342),
    [anon_sym_LT_AMP] = ACTIONS(2342),
    [anon_sym_GT_AMP] = ACTIONS(2342),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3521),
    [anon_sym_LF] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
  },
  [1502] = {
    [sym_concatenation] = STATE(1498),
    [sym_string] = STATE(1894),
    [sym_simple_expansion] = STATE(1894),
    [sym_string_expansion] = STATE(1894),
    [sym_expansion] = STATE(1894),
    [sym_command_substitution] = STATE(1894),
    [sym_process_substitution] = STATE(1894),
    [sym__special_characters] = ACTIONS(4427),
    [anon_sym_DQUOTE] = ACTIONS(629),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(4429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1521),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1523),
    [anon_sym_BQUOTE] = ACTIONS(1525),
    [anon_sym_LT_LPAREN] = ACTIONS(1527),
    [anon_sym_GT_LPAREN] = ACTIONS(1527),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4429),
  },
  [1503] = {
    [aux_sym_concatenation_repeat1] = STATE(1895),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [1504] = {
    [aux_sym_concatenation_repeat1] = STATE(1895),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [1505] = {
    [sym_concatenation] = STATE(1531),
    [sym_string] = STATE(1897),
    [sym_simple_expansion] = STATE(1897),
    [sym_string_expansion] = STATE(1897),
    [sym_expansion] = STATE(1897),
    [sym_command_substitution] = STATE(1897),
    [sym_process_substitution] = STATE(1897),
    [sym__special_characters] = ACTIONS(4431),
    [anon_sym_DQUOTE] = ACTIONS(2458),
    [anon_sym_DOLLAR] = ACTIONS(2460),
    [sym_raw_string] = ACTIONS(4433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2466),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [anon_sym_LT_LPAREN] = ACTIONS(2470),
    [anon_sym_GT_LPAREN] = ACTIONS(2470),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4433),
  },
  [1506] = {
    [aux_sym_concatenation_repeat1] = STATE(1898),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(665),
    [anon_sym_LT_LT_LT] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [1507] = {
    [aux_sym_concatenation_repeat1] = STATE(1898),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [1508] = {
    [aux_sym_concatenation_repeat1] = STATE(1898),
    [sym_file_descriptor] = ACTIONS(2058),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_RPAREN] = ACTIONS(2060),
    [anon_sym_SEMI_SEMI] = ACTIONS(2060),
    [anon_sym_PIPE_AMP] = ACTIONS(2060),
    [anon_sym_AMP_AMP] = ACTIONS(2060),
    [anon_sym_PIPE_PIPE] = ACTIONS(2060),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2060),
    [anon_sym_LT_AMP] = ACTIONS(2060),
    [anon_sym_GT_AMP] = ACTIONS(2060),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2060),
    [anon_sym_LT_LT_LT] = ACTIONS(2060),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2060),
  },
  [1509] = {
    [aux_sym_concatenation_repeat1] = STATE(1898),
    [sym_file_descriptor] = ACTIONS(2062),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_RPAREN] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [1510] = {
    [sym_file_redirect] = STATE(1510),
    [sym_heredoc_redirect] = STATE(1510),
    [sym_herestring_redirect] = STATE(1510),
    [aux_sym_while_statement_repeat1] = STATE(1510),
    [sym_file_descriptor] = ACTIONS(4435),
    [anon_sym_PIPE] = ACTIONS(2075),
    [anon_sym_RPAREN] = ACTIONS(2075),
    [anon_sym_SEMI_SEMI] = ACTIONS(2075),
    [anon_sym_PIPE_AMP] = ACTIONS(2075),
    [anon_sym_AMP_AMP] = ACTIONS(2075),
    [anon_sym_PIPE_PIPE] = ACTIONS(2075),
    [anon_sym_LT] = ACTIONS(4438),
    [anon_sym_GT] = ACTIONS(4438),
    [anon_sym_GT_GT] = ACTIONS(4438),
    [anon_sym_AMP_GT] = ACTIONS(4438),
    [anon_sym_AMP_GT_GT] = ACTIONS(4438),
    [anon_sym_LT_AMP] = ACTIONS(4438),
    [anon_sym_GT_AMP] = ACTIONS(4438),
    [anon_sym_LT_LT] = ACTIONS(3627),
    [anon_sym_LT_LT_DASH] = ACTIONS(3627),
    [anon_sym_LT_LT_LT] = ACTIONS(4441),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_LF] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2075),
  },
  [1511] = {
    [aux_sym_concatenation_repeat1] = STATE(1511),
    [sym__simple_heredoc_body] = ACTIONS(1642),
    [sym__heredoc_body_beginning] = ACTIONS(1642),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1646),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1512] = {
    [sym_file_descriptor] = ACTIONS(3337),
    [sym_variable_name] = ACTIONS(3337),
    [anon_sym_PIPE] = ACTIONS(3339),
    [anon_sym_RPAREN] = ACTIONS(3337),
    [anon_sym_PIPE_AMP] = ACTIONS(3337),
    [anon_sym_AMP_AMP] = ACTIONS(3337),
    [anon_sym_PIPE_PIPE] = ACTIONS(3337),
    [anon_sym_LT] = ACTIONS(3339),
    [anon_sym_GT] = ACTIONS(3339),
    [anon_sym_GT_GT] = ACTIONS(3337),
    [anon_sym_AMP_GT] = ACTIONS(3339),
    [anon_sym_AMP_GT_GT] = ACTIONS(3337),
    [anon_sym_LT_AMP] = ACTIONS(3337),
    [anon_sym_GT_AMP] = ACTIONS(3337),
    [sym__special_characters] = ACTIONS(3337),
    [anon_sym_DQUOTE] = ACTIONS(3337),
    [anon_sym_DOLLAR] = ACTIONS(3339),
    [sym_raw_string] = ACTIONS(3337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3337),
    [anon_sym_BQUOTE] = ACTIONS(3337),
    [anon_sym_LT_LPAREN] = ACTIONS(3337),
    [anon_sym_GT_LPAREN] = ACTIONS(3337),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3337),
  },
  [1513] = {
    [sym__concat] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_RBRACK] = ACTIONS(3829),
    [anon_sym_EQ_TILDE] = ACTIONS(3829),
    [anon_sym_EQ_EQ] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3829),
    [anon_sym_GT] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3829),
  },
  [1514] = {
    [sym__concat] = ACTIONS(3835),
    [anon_sym_AMP_AMP] = ACTIONS(3835),
    [anon_sym_PIPE_PIPE] = ACTIONS(3835),
    [anon_sym_RBRACK] = ACTIONS(3835),
    [anon_sym_EQ_TILDE] = ACTIONS(3835),
    [anon_sym_EQ_EQ] = ACTIONS(3835),
    [anon_sym_EQ] = ACTIONS(3837),
    [anon_sym_LT] = ACTIONS(3835),
    [anon_sym_GT] = ACTIONS(3835),
    [anon_sym_BANG_EQ] = ACTIONS(3835),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3835),
  },
  [1515] = {
    [sym__concat] = ACTIONS(3920),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3920),
    [anon_sym_RBRACK] = ACTIONS(3920),
    [anon_sym_EQ_TILDE] = ACTIONS(3920),
    [anon_sym_EQ_EQ] = ACTIONS(3920),
    [anon_sym_EQ] = ACTIONS(3922),
    [anon_sym_LT] = ACTIONS(3920),
    [anon_sym_GT] = ACTIONS(3920),
    [anon_sym_BANG_EQ] = ACTIONS(3920),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3920),
  },
  [1516] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4444),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1517] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [sym_comment] = ACTIONS(53),
  },
  [1518] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4448),
    [sym_comment] = ACTIONS(53),
  },
  [1519] = {
    [anon_sym_RBRACE] = ACTIONS(4448),
    [sym_comment] = ACTIONS(53),
  },
  [1520] = {
    [sym_concatenation] = STATE(1903),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1903),
    [anon_sym_RBRACE] = ACTIONS(4450),
    [anon_sym_EQ] = ACTIONS(4452),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4452),
    [anon_sym_COLON_QMARK] = ACTIONS(4452),
    [anon_sym_COLON_DASH] = ACTIONS(4452),
    [anon_sym_PERCENT] = ACTIONS(4452),
    [anon_sym_DASH] = ACTIONS(4452),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1521] = {
    [sym__concat] = ACTIONS(3936),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3936),
    [anon_sym_RBRACK] = ACTIONS(3936),
    [anon_sym_EQ_TILDE] = ACTIONS(3936),
    [anon_sym_EQ_EQ] = ACTIONS(3936),
    [anon_sym_EQ] = ACTIONS(3938),
    [anon_sym_LT] = ACTIONS(3936),
    [anon_sym_GT] = ACTIONS(3936),
    [anon_sym_BANG_EQ] = ACTIONS(3936),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3936),
  },
  [1522] = {
    [sym_concatenation] = STATE(1905),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1905),
    [anon_sym_RBRACE] = ACTIONS(4456),
    [anon_sym_EQ] = ACTIONS(4458),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4460),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4458),
    [anon_sym_COLON_QMARK] = ACTIONS(4458),
    [anon_sym_COLON_DASH] = ACTIONS(4458),
    [anon_sym_PERCENT] = ACTIONS(4458),
    [anon_sym_DASH] = ACTIONS(4458),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1523] = {
    [sym__concat] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_RBRACK] = ACTIONS(3946),
    [anon_sym_EQ_TILDE] = ACTIONS(3946),
    [anon_sym_EQ_EQ] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3946),
  },
  [1524] = {
    [sym_concatenation] = STATE(1907),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1907),
    [anon_sym_RBRACE] = ACTIONS(4462),
    [anon_sym_EQ] = ACTIONS(4464),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4464),
    [anon_sym_COLON_QMARK] = ACTIONS(4464),
    [anon_sym_COLON_DASH] = ACTIONS(4464),
    [anon_sym_PERCENT] = ACTIONS(4464),
    [anon_sym_DASH] = ACTIONS(4464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1525] = {
    [sym__concat] = ACTIONS(3956),
    [anon_sym_AMP_AMP] = ACTIONS(3956),
    [anon_sym_PIPE_PIPE] = ACTIONS(3956),
    [anon_sym_RBRACK] = ACTIONS(3956),
    [anon_sym_EQ_TILDE] = ACTIONS(3956),
    [anon_sym_EQ_EQ] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(3958),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_GT] = ACTIONS(3956),
    [anon_sym_BANG_EQ] = ACTIONS(3956),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3956),
  },
  [1526] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4468),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1527] = {
    [sym__concat] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_RBRACK] = ACTIONS(3962),
    [anon_sym_EQ_TILDE] = ACTIONS(3962),
    [anon_sym_EQ_EQ] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3962),
    [anon_sym_GT] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3962),
  },
  [1528] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4470),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1529] = {
    [aux_sym_concatenation_repeat1] = STATE(1533),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1530] = {
    [aux_sym_concatenation_repeat1] = STATE(1533),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [1531] = {
    [sym_file_descriptor] = ACTIONS(1093),
    [anon_sym_esac] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [1532] = {
    [sym_string] = STATE(1910),
    [sym_simple_expansion] = STATE(1910),
    [sym_string_expansion] = STATE(1910),
    [sym_expansion] = STATE(1910),
    [sym_command_substitution] = STATE(1910),
    [sym_process_substitution] = STATE(1910),
    [sym__special_characters] = ACTIONS(4472),
    [anon_sym_DQUOTE] = ACTIONS(2458),
    [anon_sym_DOLLAR] = ACTIONS(2460),
    [sym_raw_string] = ACTIONS(4472),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2466),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [anon_sym_LT_LPAREN] = ACTIONS(2470),
    [anon_sym_GT_LPAREN] = ACTIONS(2470),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4472),
  },
  [1533] = {
    [aux_sym_concatenation_repeat1] = STATE(1911),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [1534] = {
    [sym_file_descriptor] = ACTIONS(697),
    [sym__concat] = ACTIONS(697),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(699),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_LT_LT_DASH] = ACTIONS(699),
    [anon_sym_LT_LT_LT] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [1535] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(4474),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [1536] = {
    [sym_file_descriptor] = ACTIONS(727),
    [sym__concat] = ACTIONS(727),
    [anon_sym_esac] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(729),
    [anon_sym_AMP_GT] = ACTIONS(729),
    [anon_sym_AMP_GT_GT] = ACTIONS(729),
    [anon_sym_LT_AMP] = ACTIONS(729),
    [anon_sym_GT_AMP] = ACTIONS(729),
    [anon_sym_LT_LT] = ACTIONS(729),
    [anon_sym_LT_LT_DASH] = ACTIONS(729),
    [anon_sym_LT_LT_LT] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [1537] = {
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [anon_sym_LT_LT_LT] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [1538] = {
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(737),
    [anon_sym_LT_AMP] = ACTIONS(737),
    [anon_sym_GT_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(737),
    [anon_sym_LT_LT_LT] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [1539] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(4476),
    [sym_comment] = ACTIONS(53),
  },
  [1540] = {
    [sym_concatenation] = STATE(1916),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1916),
    [anon_sym_RBRACE] = ACTIONS(4478),
    [anon_sym_EQ] = ACTIONS(4480),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4484),
    [anon_sym_COLON] = ACTIONS(4480),
    [anon_sym_COLON_QMARK] = ACTIONS(4480),
    [anon_sym_COLON_DASH] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4480),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1541] = {
    [sym_subscript] = STATE(1920),
    [sym_variable_name] = ACTIONS(4486),
    [anon_sym_DOLLAR] = ACTIONS(4488),
    [anon_sym_DASH] = ACTIONS(4488),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4490),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AT] = ACTIONS(4488),
    [anon_sym_QMARK] = ACTIONS(4488),
    [anon_sym_0] = ACTIONS(4492),
    [anon_sym__] = ACTIONS(4492),
  },
  [1542] = {
    [sym_concatenation] = STATE(1923),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1923),
    [anon_sym_RBRACE] = ACTIONS(4494),
    [anon_sym_EQ] = ACTIONS(4496),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4500),
    [anon_sym_COLON] = ACTIONS(4496),
    [anon_sym_COLON_QMARK] = ACTIONS(4496),
    [anon_sym_COLON_DASH] = ACTIONS(4496),
    [anon_sym_PERCENT] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4496),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1543] = {
    [sym_concatenation] = STATE(1926),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1926),
    [anon_sym_RBRACE] = ACTIONS(4502),
    [anon_sym_EQ] = ACTIONS(4504),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4508),
    [anon_sym_COLON] = ACTIONS(4504),
    [anon_sym_COLON_QMARK] = ACTIONS(4504),
    [anon_sym_COLON_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1544] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(4510),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [1545] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(4510),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1546] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(4510),
    [sym_comment] = ACTIONS(53),
  },
  [1547] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(4510),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1548] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(4512),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [1549] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(4512),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1550] = {
    [sym__concat] = ACTIONS(3829),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_RPAREN] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3829),
    [anon_sym_EQ_TILDE] = ACTIONS(3829),
    [anon_sym_EQ_EQ] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3829),
    [anon_sym_GT] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3829),
  },
  [1551] = {
    [sym__concat] = ACTIONS(3835),
    [anon_sym_PIPE] = ACTIONS(3837),
    [anon_sym_RPAREN] = ACTIONS(3835),
    [anon_sym_AMP_AMP] = ACTIONS(3835),
    [anon_sym_PIPE_PIPE] = ACTIONS(3835),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3835),
    [anon_sym_EQ_TILDE] = ACTIONS(3835),
    [anon_sym_EQ_EQ] = ACTIONS(3835),
    [anon_sym_EQ] = ACTIONS(3837),
    [anon_sym_LT] = ACTIONS(3835),
    [anon_sym_GT] = ACTIONS(3835),
    [anon_sym_BANG_EQ] = ACTIONS(3835),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3835),
  },
  [1552] = {
    [sym__concat] = ACTIONS(3920),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_RPAREN] = ACTIONS(3920),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3920),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3920),
    [anon_sym_EQ_TILDE] = ACTIONS(3920),
    [anon_sym_EQ_EQ] = ACTIONS(3920),
    [anon_sym_EQ] = ACTIONS(3922),
    [anon_sym_LT] = ACTIONS(3920),
    [anon_sym_GT] = ACTIONS(3920),
    [anon_sym_BANG_EQ] = ACTIONS(3920),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3920),
  },
  [1553] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1554] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4516),
    [sym_comment] = ACTIONS(53),
  },
  [1555] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4518),
    [sym_comment] = ACTIONS(53),
  },
  [1556] = {
    [anon_sym_RBRACE] = ACTIONS(4518),
    [sym_comment] = ACTIONS(53),
  },
  [1557] = {
    [sym_concatenation] = STATE(1933),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1933),
    [anon_sym_RBRACE] = ACTIONS(4520),
    [anon_sym_EQ] = ACTIONS(4522),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4522),
    [anon_sym_COLON_QMARK] = ACTIONS(4522),
    [anon_sym_COLON_DASH] = ACTIONS(4522),
    [anon_sym_PERCENT] = ACTIONS(4522),
    [anon_sym_DASH] = ACTIONS(4522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1558] = {
    [sym__concat] = ACTIONS(3936),
    [anon_sym_PIPE] = ACTIONS(3938),
    [anon_sym_RPAREN] = ACTIONS(3936),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3936),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3936),
    [anon_sym_EQ_TILDE] = ACTIONS(3936),
    [anon_sym_EQ_EQ] = ACTIONS(3936),
    [anon_sym_EQ] = ACTIONS(3938),
    [anon_sym_LT] = ACTIONS(3936),
    [anon_sym_GT] = ACTIONS(3936),
    [anon_sym_BANG_EQ] = ACTIONS(3936),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3936),
  },
  [1559] = {
    [sym_concatenation] = STATE(1935),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1935),
    [anon_sym_RBRACE] = ACTIONS(4526),
    [anon_sym_EQ] = ACTIONS(4528),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4530),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4528),
    [anon_sym_COLON_QMARK] = ACTIONS(4528),
    [anon_sym_COLON_DASH] = ACTIONS(4528),
    [anon_sym_PERCENT] = ACTIONS(4528),
    [anon_sym_DASH] = ACTIONS(4528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1560] = {
    [sym__concat] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3946),
    [anon_sym_EQ_TILDE] = ACTIONS(3946),
    [anon_sym_EQ_EQ] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3946),
  },
  [1561] = {
    [sym_concatenation] = STATE(1937),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1937),
    [anon_sym_RBRACE] = ACTIONS(4532),
    [anon_sym_EQ] = ACTIONS(4534),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4534),
    [anon_sym_COLON_QMARK] = ACTIONS(4534),
    [anon_sym_COLON_DASH] = ACTIONS(4534),
    [anon_sym_PERCENT] = ACTIONS(4534),
    [anon_sym_DASH] = ACTIONS(4534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1562] = {
    [sym__concat] = ACTIONS(3956),
    [anon_sym_PIPE] = ACTIONS(3958),
    [anon_sym_RPAREN] = ACTIONS(3956),
    [anon_sym_AMP_AMP] = ACTIONS(3956),
    [anon_sym_PIPE_PIPE] = ACTIONS(3956),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3956),
    [anon_sym_EQ_TILDE] = ACTIONS(3956),
    [anon_sym_EQ_EQ] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(3958),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_GT] = ACTIONS(3956),
    [anon_sym_BANG_EQ] = ACTIONS(3956),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3956),
  },
  [1563] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4538),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1564] = {
    [sym__concat] = ACTIONS(3962),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_RPAREN] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3962),
    [anon_sym_EQ_TILDE] = ACTIONS(3962),
    [anon_sym_EQ_EQ] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3962),
    [anon_sym_GT] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3962),
  },
  [1565] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4540),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1566] = {
    [sym_variable_name] = ACTIONS(3337),
    [anon_sym_PIPE] = ACTIONS(3339),
    [anon_sym_RPAREN] = ACTIONS(3339),
    [anon_sym_SEMI_SEMI] = ACTIONS(3339),
    [anon_sym_PIPE_AMP] = ACTIONS(3339),
    [anon_sym_AMP_AMP] = ACTIONS(3339),
    [anon_sym_PIPE_PIPE] = ACTIONS(3339),
    [sym__special_characters] = ACTIONS(3339),
    [anon_sym_DQUOTE] = ACTIONS(3339),
    [anon_sym_DOLLAR] = ACTIONS(3339),
    [sym_raw_string] = ACTIONS(3339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3339),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [anon_sym_LT_LPAREN] = ACTIONS(3339),
    [anon_sym_GT_LPAREN] = ACTIONS(3339),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3339),
    [sym_word] = ACTIONS(3339),
    [anon_sym_SEMI] = ACTIONS(3339),
    [anon_sym_LF] = ACTIONS(3337),
    [anon_sym_AMP] = ACTIONS(3339),
  },
  [1567] = {
    [sym__concat] = ACTIONS(3829),
    [sym_variable_name] = ACTIONS(3829),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_RPAREN] = ACTIONS(3831),
    [anon_sym_SEMI_SEMI] = ACTIONS(3831),
    [anon_sym_PIPE_AMP] = ACTIONS(3831),
    [anon_sym_AMP_AMP] = ACTIONS(3831),
    [anon_sym_PIPE_PIPE] = ACTIONS(3831),
    [sym__special_characters] = ACTIONS(3831),
    [anon_sym_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [sym_raw_string] = ACTIONS(3831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3831),
    [anon_sym_BQUOTE] = ACTIONS(3831),
    [anon_sym_LT_LPAREN] = ACTIONS(3831),
    [anon_sym_GT_LPAREN] = ACTIONS(3831),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3831),
    [sym_word] = ACTIONS(3831),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_LF] = ACTIONS(3829),
    [anon_sym_AMP] = ACTIONS(3831),
  },
  [1568] = {
    [sym__concat] = ACTIONS(3835),
    [sym_variable_name] = ACTIONS(3835),
    [anon_sym_PIPE] = ACTIONS(3837),
    [anon_sym_RPAREN] = ACTIONS(3837),
    [anon_sym_SEMI_SEMI] = ACTIONS(3837),
    [anon_sym_PIPE_AMP] = ACTIONS(3837),
    [anon_sym_AMP_AMP] = ACTIONS(3837),
    [anon_sym_PIPE_PIPE] = ACTIONS(3837),
    [sym__special_characters] = ACTIONS(3837),
    [anon_sym_DQUOTE] = ACTIONS(3837),
    [anon_sym_DOLLAR] = ACTIONS(3837),
    [sym_raw_string] = ACTIONS(3837),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3837),
    [anon_sym_BQUOTE] = ACTIONS(3837),
    [anon_sym_LT_LPAREN] = ACTIONS(3837),
    [anon_sym_GT_LPAREN] = ACTIONS(3837),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3837),
    [sym_word] = ACTIONS(3837),
    [anon_sym_SEMI] = ACTIONS(3837),
    [anon_sym_LF] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
  },
  [1569] = {
    [sym__concat] = ACTIONS(3920),
    [sym_variable_name] = ACTIONS(3920),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_RPAREN] = ACTIONS(3922),
    [anon_sym_SEMI_SEMI] = ACTIONS(3922),
    [anon_sym_PIPE_AMP] = ACTIONS(3922),
    [anon_sym_AMP_AMP] = ACTIONS(3922),
    [anon_sym_PIPE_PIPE] = ACTIONS(3922),
    [sym__special_characters] = ACTIONS(3922),
    [anon_sym_DQUOTE] = ACTIONS(3922),
    [anon_sym_DOLLAR] = ACTIONS(3922),
    [sym_raw_string] = ACTIONS(3922),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3922),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3922),
    [anon_sym_BQUOTE] = ACTIONS(3922),
    [anon_sym_LT_LPAREN] = ACTIONS(3922),
    [anon_sym_GT_LPAREN] = ACTIONS(3922),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3922),
    [sym_word] = ACTIONS(3922),
    [anon_sym_SEMI] = ACTIONS(3922),
    [anon_sym_LF] = ACTIONS(3920),
    [anon_sym_AMP] = ACTIONS(3922),
  },
  [1570] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4542),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1571] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4544),
    [sym_comment] = ACTIONS(53),
  },
  [1572] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4546),
    [sym_comment] = ACTIONS(53),
  },
  [1573] = {
    [anon_sym_RBRACE] = ACTIONS(4546),
    [sym_comment] = ACTIONS(53),
  },
  [1574] = {
    [sym_concatenation] = STATE(1944),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1944),
    [anon_sym_RBRACE] = ACTIONS(4548),
    [anon_sym_EQ] = ACTIONS(4550),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4552),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4550),
    [anon_sym_COLON_QMARK] = ACTIONS(4550),
    [anon_sym_COLON_DASH] = ACTIONS(4550),
    [anon_sym_PERCENT] = ACTIONS(4550),
    [anon_sym_DASH] = ACTIONS(4550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1575] = {
    [sym__concat] = ACTIONS(3936),
    [sym_variable_name] = ACTIONS(3936),
    [anon_sym_PIPE] = ACTIONS(3938),
    [anon_sym_RPAREN] = ACTIONS(3938),
    [anon_sym_SEMI_SEMI] = ACTIONS(3938),
    [anon_sym_PIPE_AMP] = ACTIONS(3938),
    [anon_sym_AMP_AMP] = ACTIONS(3938),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [sym__special_characters] = ACTIONS(3938),
    [anon_sym_DQUOTE] = ACTIONS(3938),
    [anon_sym_DOLLAR] = ACTIONS(3938),
    [sym_raw_string] = ACTIONS(3938),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3938),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3938),
    [anon_sym_BQUOTE] = ACTIONS(3938),
    [anon_sym_LT_LPAREN] = ACTIONS(3938),
    [anon_sym_GT_LPAREN] = ACTIONS(3938),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3938),
    [sym_word] = ACTIONS(3938),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_LF] = ACTIONS(3936),
    [anon_sym_AMP] = ACTIONS(3938),
  },
  [1576] = {
    [sym_concatenation] = STATE(1946),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1946),
    [anon_sym_RBRACE] = ACTIONS(4554),
    [anon_sym_EQ] = ACTIONS(4556),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4558),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4556),
    [anon_sym_COLON_QMARK] = ACTIONS(4556),
    [anon_sym_COLON_DASH] = ACTIONS(4556),
    [anon_sym_PERCENT] = ACTIONS(4556),
    [anon_sym_DASH] = ACTIONS(4556),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1577] = {
    [sym__concat] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3948),
    [anon_sym_SEMI_SEMI] = ACTIONS(3948),
    [anon_sym_PIPE_AMP] = ACTIONS(3948),
    [anon_sym_AMP_AMP] = ACTIONS(3948),
    [anon_sym_PIPE_PIPE] = ACTIONS(3948),
    [sym__special_characters] = ACTIONS(3948),
    [anon_sym_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3948),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3948),
    [anon_sym_BQUOTE] = ACTIONS(3948),
    [anon_sym_LT_LPAREN] = ACTIONS(3948),
    [anon_sym_GT_LPAREN] = ACTIONS(3948),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3948),
    [sym_word] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3948),
    [anon_sym_LF] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3948),
  },
  [1578] = {
    [sym_concatenation] = STATE(1948),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1948),
    [anon_sym_RBRACE] = ACTIONS(4560),
    [anon_sym_EQ] = ACTIONS(4562),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4562),
    [anon_sym_COLON_QMARK] = ACTIONS(4562),
    [anon_sym_COLON_DASH] = ACTIONS(4562),
    [anon_sym_PERCENT] = ACTIONS(4562),
    [anon_sym_DASH] = ACTIONS(4562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1579] = {
    [sym__concat] = ACTIONS(3956),
    [sym_variable_name] = ACTIONS(3956),
    [anon_sym_PIPE] = ACTIONS(3958),
    [anon_sym_RPAREN] = ACTIONS(3958),
    [anon_sym_SEMI_SEMI] = ACTIONS(3958),
    [anon_sym_PIPE_AMP] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [sym__special_characters] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [sym_raw_string] = ACTIONS(3958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3958),
    [anon_sym_BQUOTE] = ACTIONS(3958),
    [anon_sym_LT_LPAREN] = ACTIONS(3958),
    [anon_sym_GT_LPAREN] = ACTIONS(3958),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3958),
    [sym_word] = ACTIONS(3958),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_LF] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
  },
  [1580] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4566),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1581] = {
    [sym__concat] = ACTIONS(3962),
    [sym_variable_name] = ACTIONS(3962),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_RPAREN] = ACTIONS(3964),
    [anon_sym_SEMI_SEMI] = ACTIONS(3964),
    [anon_sym_PIPE_AMP] = ACTIONS(3964),
    [anon_sym_AMP_AMP] = ACTIONS(3964),
    [anon_sym_PIPE_PIPE] = ACTIONS(3964),
    [sym__special_characters] = ACTIONS(3964),
    [anon_sym_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3964),
    [sym_raw_string] = ACTIONS(3964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3964),
    [anon_sym_BQUOTE] = ACTIONS(3964),
    [anon_sym_LT_LPAREN] = ACTIONS(3964),
    [anon_sym_GT_LPAREN] = ACTIONS(3964),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3964),
    [sym_word] = ACTIONS(3964),
    [anon_sym_SEMI] = ACTIONS(3964),
    [anon_sym_LF] = ACTIONS(3962),
    [anon_sym_AMP] = ACTIONS(3964),
  },
  [1582] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4568),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1583] = {
    [sym__concat] = ACTIONS(3829),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_RPAREN] = ACTIONS(3831),
    [anon_sym_SEMI_SEMI] = ACTIONS(3831),
    [anon_sym_PIPE_AMP] = ACTIONS(3831),
    [anon_sym_AMP_AMP] = ACTIONS(3831),
    [anon_sym_PIPE_PIPE] = ACTIONS(3831),
    [sym__special_characters] = ACTIONS(3831),
    [anon_sym_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [sym_raw_string] = ACTIONS(3831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3831),
    [anon_sym_BQUOTE] = ACTIONS(3831),
    [anon_sym_LT_LPAREN] = ACTIONS(3831),
    [anon_sym_GT_LPAREN] = ACTIONS(3831),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3831),
    [sym_word] = ACTIONS(3831),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_LF] = ACTIONS(3829),
    [anon_sym_AMP] = ACTIONS(3831),
  },
  [1584] = {
    [sym__concat] = ACTIONS(3835),
    [anon_sym_PIPE] = ACTIONS(3837),
    [anon_sym_RPAREN] = ACTIONS(3837),
    [anon_sym_SEMI_SEMI] = ACTIONS(3837),
    [anon_sym_PIPE_AMP] = ACTIONS(3837),
    [anon_sym_AMP_AMP] = ACTIONS(3837),
    [anon_sym_PIPE_PIPE] = ACTIONS(3837),
    [sym__special_characters] = ACTIONS(3837),
    [anon_sym_DQUOTE] = ACTIONS(3837),
    [anon_sym_DOLLAR] = ACTIONS(3837),
    [sym_raw_string] = ACTIONS(3837),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3837),
    [anon_sym_BQUOTE] = ACTIONS(3837),
    [anon_sym_LT_LPAREN] = ACTIONS(3837),
    [anon_sym_GT_LPAREN] = ACTIONS(3837),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3837),
    [sym_word] = ACTIONS(3837),
    [anon_sym_SEMI] = ACTIONS(3837),
    [anon_sym_LF] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
  },
  [1585] = {
    [sym__concat] = ACTIONS(3920),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_RPAREN] = ACTIONS(3922),
    [anon_sym_SEMI_SEMI] = ACTIONS(3922),
    [anon_sym_PIPE_AMP] = ACTIONS(3922),
    [anon_sym_AMP_AMP] = ACTIONS(3922),
    [anon_sym_PIPE_PIPE] = ACTIONS(3922),
    [sym__special_characters] = ACTIONS(3922),
    [anon_sym_DQUOTE] = ACTIONS(3922),
    [anon_sym_DOLLAR] = ACTIONS(3922),
    [sym_raw_string] = ACTIONS(3922),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3922),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3922),
    [anon_sym_BQUOTE] = ACTIONS(3922),
    [anon_sym_LT_LPAREN] = ACTIONS(3922),
    [anon_sym_GT_LPAREN] = ACTIONS(3922),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3922),
    [sym_word] = ACTIONS(3922),
    [anon_sym_SEMI] = ACTIONS(3922),
    [anon_sym_LF] = ACTIONS(3920),
    [anon_sym_AMP] = ACTIONS(3922),
  },
  [1586] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4570),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1587] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
  },
  [1588] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4574),
    [sym_comment] = ACTIONS(53),
  },
  [1589] = {
    [anon_sym_RBRACE] = ACTIONS(4574),
    [sym_comment] = ACTIONS(53),
  },
  [1590] = {
    [sym_concatenation] = STATE(1955),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1955),
    [anon_sym_RBRACE] = ACTIONS(4576),
    [anon_sym_EQ] = ACTIONS(4578),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4578),
    [anon_sym_COLON_QMARK] = ACTIONS(4578),
    [anon_sym_COLON_DASH] = ACTIONS(4578),
    [anon_sym_PERCENT] = ACTIONS(4578),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1591] = {
    [sym__concat] = ACTIONS(3936),
    [anon_sym_PIPE] = ACTIONS(3938),
    [anon_sym_RPAREN] = ACTIONS(3938),
    [anon_sym_SEMI_SEMI] = ACTIONS(3938),
    [anon_sym_PIPE_AMP] = ACTIONS(3938),
    [anon_sym_AMP_AMP] = ACTIONS(3938),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [sym__special_characters] = ACTIONS(3938),
    [anon_sym_DQUOTE] = ACTIONS(3938),
    [anon_sym_DOLLAR] = ACTIONS(3938),
    [sym_raw_string] = ACTIONS(3938),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3938),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3938),
    [anon_sym_BQUOTE] = ACTIONS(3938),
    [anon_sym_LT_LPAREN] = ACTIONS(3938),
    [anon_sym_GT_LPAREN] = ACTIONS(3938),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3938),
    [sym_word] = ACTIONS(3938),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_LF] = ACTIONS(3936),
    [anon_sym_AMP] = ACTIONS(3938),
  },
  [1592] = {
    [sym_concatenation] = STATE(1957),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1957),
    [anon_sym_RBRACE] = ACTIONS(4582),
    [anon_sym_EQ] = ACTIONS(4584),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4584),
    [anon_sym_COLON_QMARK] = ACTIONS(4584),
    [anon_sym_COLON_DASH] = ACTIONS(4584),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [anon_sym_DASH] = ACTIONS(4584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1593] = {
    [sym__concat] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3948),
    [anon_sym_SEMI_SEMI] = ACTIONS(3948),
    [anon_sym_PIPE_AMP] = ACTIONS(3948),
    [anon_sym_AMP_AMP] = ACTIONS(3948),
    [anon_sym_PIPE_PIPE] = ACTIONS(3948),
    [sym__special_characters] = ACTIONS(3948),
    [anon_sym_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3948),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3948),
    [anon_sym_BQUOTE] = ACTIONS(3948),
    [anon_sym_LT_LPAREN] = ACTIONS(3948),
    [anon_sym_GT_LPAREN] = ACTIONS(3948),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3948),
    [sym_word] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3948),
    [anon_sym_LF] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3948),
  },
  [1594] = {
    [sym_concatenation] = STATE(1959),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1959),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [anon_sym_EQ] = ACTIONS(4590),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4592),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4590),
    [anon_sym_COLON_QMARK] = ACTIONS(4590),
    [anon_sym_COLON_DASH] = ACTIONS(4590),
    [anon_sym_PERCENT] = ACTIONS(4590),
    [anon_sym_DASH] = ACTIONS(4590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1595] = {
    [sym__concat] = ACTIONS(3956),
    [anon_sym_PIPE] = ACTIONS(3958),
    [anon_sym_RPAREN] = ACTIONS(3958),
    [anon_sym_SEMI_SEMI] = ACTIONS(3958),
    [anon_sym_PIPE_AMP] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [sym__special_characters] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [sym_raw_string] = ACTIONS(3958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3958),
    [anon_sym_BQUOTE] = ACTIONS(3958),
    [anon_sym_LT_LPAREN] = ACTIONS(3958),
    [anon_sym_GT_LPAREN] = ACTIONS(3958),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3958),
    [sym_word] = ACTIONS(3958),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_LF] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
  },
  [1596] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4594),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1597] = {
    [sym__concat] = ACTIONS(3962),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_RPAREN] = ACTIONS(3964),
    [anon_sym_SEMI_SEMI] = ACTIONS(3964),
    [anon_sym_PIPE_AMP] = ACTIONS(3964),
    [anon_sym_AMP_AMP] = ACTIONS(3964),
    [anon_sym_PIPE_PIPE] = ACTIONS(3964),
    [sym__special_characters] = ACTIONS(3964),
    [anon_sym_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3964),
    [sym_raw_string] = ACTIONS(3964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3964),
    [anon_sym_BQUOTE] = ACTIONS(3964),
    [anon_sym_LT_LPAREN] = ACTIONS(3964),
    [anon_sym_GT_LPAREN] = ACTIONS(3964),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3964),
    [sym_word] = ACTIONS(3964),
    [anon_sym_SEMI] = ACTIONS(3964),
    [anon_sym_LF] = ACTIONS(3962),
    [anon_sym_AMP] = ACTIONS(3964),
  },
  [1598] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1599] = {
    [sym_file_descriptor] = ACTIONS(3829),
    [sym__concat] = ACTIONS(3829),
    [sym_variable_name] = ACTIONS(3829),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_RPAREN] = ACTIONS(3829),
    [anon_sym_PIPE_AMP] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_GT] = ACTIONS(3831),
    [anon_sym_GT_GT] = ACTIONS(3829),
    [anon_sym_AMP_GT] = ACTIONS(3831),
    [anon_sym_AMP_GT_GT] = ACTIONS(3829),
    [anon_sym_LT_AMP] = ACTIONS(3829),
    [anon_sym_GT_AMP] = ACTIONS(3829),
    [sym__special_characters] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [sym_raw_string] = ACTIONS(3829),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3829),
    [anon_sym_BQUOTE] = ACTIONS(3829),
    [anon_sym_LT_LPAREN] = ACTIONS(3829),
    [anon_sym_GT_LPAREN] = ACTIONS(3829),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3829),
  },
  [1600] = {
    [sym_file_descriptor] = ACTIONS(3835),
    [sym__concat] = ACTIONS(3835),
    [sym_variable_name] = ACTIONS(3835),
    [anon_sym_PIPE] = ACTIONS(3837),
    [anon_sym_RPAREN] = ACTIONS(3835),
    [anon_sym_PIPE_AMP] = ACTIONS(3835),
    [anon_sym_AMP_AMP] = ACTIONS(3835),
    [anon_sym_PIPE_PIPE] = ACTIONS(3835),
    [anon_sym_LT] = ACTIONS(3837),
    [anon_sym_GT] = ACTIONS(3837),
    [anon_sym_GT_GT] = ACTIONS(3835),
    [anon_sym_AMP_GT] = ACTIONS(3837),
    [anon_sym_AMP_GT_GT] = ACTIONS(3835),
    [anon_sym_LT_AMP] = ACTIONS(3835),
    [anon_sym_GT_AMP] = ACTIONS(3835),
    [sym__special_characters] = ACTIONS(3835),
    [anon_sym_DQUOTE] = ACTIONS(3835),
    [anon_sym_DOLLAR] = ACTIONS(3837),
    [sym_raw_string] = ACTIONS(3835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3835),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3835),
    [anon_sym_BQUOTE] = ACTIONS(3835),
    [anon_sym_LT_LPAREN] = ACTIONS(3835),
    [anon_sym_GT_LPAREN] = ACTIONS(3835),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3835),
  },
  [1601] = {
    [sym_file_descriptor] = ACTIONS(3920),
    [sym__concat] = ACTIONS(3920),
    [sym_variable_name] = ACTIONS(3920),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_RPAREN] = ACTIONS(3920),
    [anon_sym_PIPE_AMP] = ACTIONS(3920),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3920),
    [anon_sym_LT] = ACTIONS(3922),
    [anon_sym_GT] = ACTIONS(3922),
    [anon_sym_GT_GT] = ACTIONS(3920),
    [anon_sym_AMP_GT] = ACTIONS(3922),
    [anon_sym_AMP_GT_GT] = ACTIONS(3920),
    [anon_sym_LT_AMP] = ACTIONS(3920),
    [anon_sym_GT_AMP] = ACTIONS(3920),
    [sym__special_characters] = ACTIONS(3920),
    [anon_sym_DQUOTE] = ACTIONS(3920),
    [anon_sym_DOLLAR] = ACTIONS(3922),
    [sym_raw_string] = ACTIONS(3920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3920),
    [anon_sym_BQUOTE] = ACTIONS(3920),
    [anon_sym_LT_LPAREN] = ACTIONS(3920),
    [anon_sym_GT_LPAREN] = ACTIONS(3920),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3920),
  },
  [1602] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4598),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1603] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4600),
    [sym_comment] = ACTIONS(53),
  },
  [1604] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4602),
    [sym_comment] = ACTIONS(53),
  },
  [1605] = {
    [anon_sym_RBRACE] = ACTIONS(4602),
    [sym_comment] = ACTIONS(53),
  },
  [1606] = {
    [sym_concatenation] = STATE(1966),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1966),
    [anon_sym_RBRACE] = ACTIONS(4604),
    [anon_sym_EQ] = ACTIONS(4606),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4606),
    [anon_sym_COLON_QMARK] = ACTIONS(4606),
    [anon_sym_COLON_DASH] = ACTIONS(4606),
    [anon_sym_PERCENT] = ACTIONS(4606),
    [anon_sym_DASH] = ACTIONS(4606),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1607] = {
    [sym_file_descriptor] = ACTIONS(3936),
    [sym__concat] = ACTIONS(3936),
    [sym_variable_name] = ACTIONS(3936),
    [anon_sym_PIPE] = ACTIONS(3938),
    [anon_sym_RPAREN] = ACTIONS(3936),
    [anon_sym_PIPE_AMP] = ACTIONS(3936),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3936),
    [anon_sym_LT] = ACTIONS(3938),
    [anon_sym_GT] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3936),
    [anon_sym_AMP_GT] = ACTIONS(3938),
    [anon_sym_AMP_GT_GT] = ACTIONS(3936),
    [anon_sym_LT_AMP] = ACTIONS(3936),
    [anon_sym_GT_AMP] = ACTIONS(3936),
    [sym__special_characters] = ACTIONS(3936),
    [anon_sym_DQUOTE] = ACTIONS(3936),
    [anon_sym_DOLLAR] = ACTIONS(3938),
    [sym_raw_string] = ACTIONS(3936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3936),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3936),
    [anon_sym_BQUOTE] = ACTIONS(3936),
    [anon_sym_LT_LPAREN] = ACTIONS(3936),
    [anon_sym_GT_LPAREN] = ACTIONS(3936),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3936),
  },
  [1608] = {
    [sym_concatenation] = STATE(1968),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1968),
    [anon_sym_RBRACE] = ACTIONS(4610),
    [anon_sym_EQ] = ACTIONS(4612),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4614),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4612),
    [anon_sym_COLON_QMARK] = ACTIONS(4612),
    [anon_sym_COLON_DASH] = ACTIONS(4612),
    [anon_sym_PERCENT] = ACTIONS(4612),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1609] = {
    [sym_file_descriptor] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3948),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3948),
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [sym__special_characters] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3946),
  },
  [1610] = {
    [sym_concatenation] = STATE(1970),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1970),
    [anon_sym_RBRACE] = ACTIONS(4616),
    [anon_sym_EQ] = ACTIONS(4618),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4620),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4618),
    [anon_sym_COLON_QMARK] = ACTIONS(4618),
    [anon_sym_COLON_DASH] = ACTIONS(4618),
    [anon_sym_PERCENT] = ACTIONS(4618),
    [anon_sym_DASH] = ACTIONS(4618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1611] = {
    [sym_file_descriptor] = ACTIONS(3956),
    [sym__concat] = ACTIONS(3956),
    [sym_variable_name] = ACTIONS(3956),
    [anon_sym_PIPE] = ACTIONS(3958),
    [anon_sym_RPAREN] = ACTIONS(3956),
    [anon_sym_PIPE_AMP] = ACTIONS(3956),
    [anon_sym_AMP_AMP] = ACTIONS(3956),
    [anon_sym_PIPE_PIPE] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_GT] = ACTIONS(3956),
    [anon_sym_AMP_GT] = ACTIONS(3958),
    [anon_sym_AMP_GT_GT] = ACTIONS(3956),
    [anon_sym_LT_AMP] = ACTIONS(3956),
    [anon_sym_GT_AMP] = ACTIONS(3956),
    [sym__special_characters] = ACTIONS(3956),
    [anon_sym_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [sym_raw_string] = ACTIONS(3956),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3956),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3956),
    [anon_sym_BQUOTE] = ACTIONS(3956),
    [anon_sym_LT_LPAREN] = ACTIONS(3956),
    [anon_sym_GT_LPAREN] = ACTIONS(3956),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3956),
  },
  [1612] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4622),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1613] = {
    [sym_file_descriptor] = ACTIONS(3962),
    [sym__concat] = ACTIONS(3962),
    [sym_variable_name] = ACTIONS(3962),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_RPAREN] = ACTIONS(3962),
    [anon_sym_PIPE_AMP] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_GT] = ACTIONS(3964),
    [anon_sym_GT_GT] = ACTIONS(3962),
    [anon_sym_AMP_GT] = ACTIONS(3964),
    [anon_sym_AMP_GT_GT] = ACTIONS(3962),
    [anon_sym_LT_AMP] = ACTIONS(3962),
    [anon_sym_GT_AMP] = ACTIONS(3962),
    [sym__special_characters] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_DOLLAR] = ACTIONS(3964),
    [sym_raw_string] = ACTIONS(3962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3962),
    [anon_sym_BQUOTE] = ACTIONS(3962),
    [anon_sym_LT_LPAREN] = ACTIONS(3962),
    [anon_sym_GT_LPAREN] = ACTIONS(3962),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3962),
  },
  [1614] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4624),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1615] = {
    [sym__concat] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [sym__string_content] = ACTIONS(3829),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3831),
    [anon_sym_BQUOTE] = ACTIONS(3831),
    [sym_comment] = ACTIONS(177),
  },
  [1616] = {
    [sym__concat] = ACTIONS(3835),
    [anon_sym_DQUOTE] = ACTIONS(3837),
    [anon_sym_DOLLAR] = ACTIONS(3837),
    [sym__string_content] = ACTIONS(3835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3837),
    [anon_sym_BQUOTE] = ACTIONS(3837),
    [sym_comment] = ACTIONS(177),
  },
  [1617] = {
    [sym__concat] = ACTIONS(3920),
    [anon_sym_DQUOTE] = ACTIONS(3922),
    [anon_sym_DOLLAR] = ACTIONS(3922),
    [sym__string_content] = ACTIONS(3920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3922),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3922),
    [anon_sym_BQUOTE] = ACTIONS(3922),
    [sym_comment] = ACTIONS(177),
  },
  [1618] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4626),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1619] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4628),
    [sym_comment] = ACTIONS(53),
  },
  [1620] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4630),
    [sym_comment] = ACTIONS(53),
  },
  [1621] = {
    [anon_sym_RBRACE] = ACTIONS(4630),
    [sym_comment] = ACTIONS(53),
  },
  [1622] = {
    [sym_concatenation] = STATE(1977),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1977),
    [anon_sym_RBRACE] = ACTIONS(4632),
    [anon_sym_EQ] = ACTIONS(4634),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4636),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4634),
    [anon_sym_COLON_QMARK] = ACTIONS(4634),
    [anon_sym_COLON_DASH] = ACTIONS(4634),
    [anon_sym_PERCENT] = ACTIONS(4634),
    [anon_sym_DASH] = ACTIONS(4634),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1623] = {
    [sym__concat] = ACTIONS(3936),
    [anon_sym_DQUOTE] = ACTIONS(3938),
    [anon_sym_DOLLAR] = ACTIONS(3938),
    [sym__string_content] = ACTIONS(3936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3938),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3938),
    [anon_sym_BQUOTE] = ACTIONS(3938),
    [sym_comment] = ACTIONS(177),
  },
  [1624] = {
    [sym_concatenation] = STATE(1979),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1979),
    [anon_sym_RBRACE] = ACTIONS(4638),
    [anon_sym_EQ] = ACTIONS(4640),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4640),
    [anon_sym_COLON_QMARK] = ACTIONS(4640),
    [anon_sym_COLON_DASH] = ACTIONS(4640),
    [anon_sym_PERCENT] = ACTIONS(4640),
    [anon_sym_DASH] = ACTIONS(4640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1625] = {
    [sym__concat] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3948),
    [sym__string_content] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3948),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3948),
    [anon_sym_BQUOTE] = ACTIONS(3948),
    [sym_comment] = ACTIONS(177),
  },
  [1626] = {
    [sym_concatenation] = STATE(1981),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1981),
    [anon_sym_RBRACE] = ACTIONS(4644),
    [anon_sym_EQ] = ACTIONS(4646),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4646),
    [anon_sym_COLON_QMARK] = ACTIONS(4646),
    [anon_sym_COLON_DASH] = ACTIONS(4646),
    [anon_sym_PERCENT] = ACTIONS(4646),
    [anon_sym_DASH] = ACTIONS(4646),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1627] = {
    [sym__concat] = ACTIONS(3956),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [sym__string_content] = ACTIONS(3956),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3958),
    [anon_sym_BQUOTE] = ACTIONS(3958),
    [sym_comment] = ACTIONS(177),
  },
  [1628] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4650),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1629] = {
    [sym__concat] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3964),
    [sym__string_content] = ACTIONS(3962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3964),
    [anon_sym_BQUOTE] = ACTIONS(3964),
    [sym_comment] = ACTIONS(177),
  },
  [1630] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4652),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1631] = {
    [sym__concat] = ACTIONS(4654),
    [anon_sym_RBRACE] = ACTIONS(3289),
    [anon_sym_EQ] = ACTIONS(4656),
    [sym__special_characters] = ACTIONS(4656),
    [anon_sym_DQUOTE] = ACTIONS(3289),
    [anon_sym_DOLLAR] = ACTIONS(4656),
    [sym_raw_string] = ACTIONS(3289),
    [anon_sym_POUND] = ACTIONS(3289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3289),
    [aux_sym_SLASH] = ACTIONS(3289),
    [anon_sym_COLON] = ACTIONS(4656),
    [anon_sym_COLON_QMARK] = ACTIONS(4656),
    [anon_sym_COLON_DASH] = ACTIONS(4656),
    [anon_sym_PERCENT] = ACTIONS(4656),
    [anon_sym_DASH] = ACTIONS(4656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3289),
    [anon_sym_BQUOTE] = ACTIONS(3289),
    [anon_sym_LT_LPAREN] = ACTIONS(3289),
    [anon_sym_GT_LPAREN] = ACTIONS(3289),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4656),
  },
  [1632] = {
    [anon_sym_RBRACE] = ACTIONS(3289),
    [anon_sym_EQ] = ACTIONS(4656),
    [sym__special_characters] = ACTIONS(4656),
    [anon_sym_DQUOTE] = ACTIONS(3289),
    [anon_sym_DOLLAR] = ACTIONS(4656),
    [sym_raw_string] = ACTIONS(3289),
    [anon_sym_POUND] = ACTIONS(3289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3289),
    [aux_sym_SLASH] = ACTIONS(3289),
    [anon_sym_COLON] = ACTIONS(4656),
    [anon_sym_COLON_QMARK] = ACTIONS(4656),
    [anon_sym_COLON_DASH] = ACTIONS(4656),
    [anon_sym_PERCENT] = ACTIONS(4656),
    [anon_sym_DASH] = ACTIONS(4656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3289),
    [anon_sym_BQUOTE] = ACTIONS(3289),
    [anon_sym_LT_LPAREN] = ACTIONS(3289),
    [anon_sym_GT_LPAREN] = ACTIONS(3289),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4656),
  },
  [1633] = {
    [sym__concat] = ACTIONS(4658),
    [anon_sym_RBRACE] = ACTIONS(3293),
    [anon_sym_EQ] = ACTIONS(4660),
    [sym__special_characters] = ACTIONS(4660),
    [anon_sym_DQUOTE] = ACTIONS(3293),
    [anon_sym_DOLLAR] = ACTIONS(4660),
    [sym_raw_string] = ACTIONS(3293),
    [anon_sym_POUND] = ACTIONS(3293),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3293),
    [aux_sym_SLASH] = ACTIONS(3293),
    [anon_sym_COLON] = ACTIONS(4660),
    [anon_sym_COLON_QMARK] = ACTIONS(4660),
    [anon_sym_COLON_DASH] = ACTIONS(4660),
    [anon_sym_PERCENT] = ACTIONS(4660),
    [anon_sym_DASH] = ACTIONS(4660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3293),
    [anon_sym_BQUOTE] = ACTIONS(3293),
    [anon_sym_LT_LPAREN] = ACTIONS(3293),
    [anon_sym_GT_LPAREN] = ACTIONS(3293),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4660),
  },
  [1634] = {
    [anon_sym_RBRACE] = ACTIONS(3293),
    [anon_sym_EQ] = ACTIONS(4660),
    [sym__special_characters] = ACTIONS(4660),
    [anon_sym_DQUOTE] = ACTIONS(3293),
    [anon_sym_DOLLAR] = ACTIONS(4660),
    [sym_raw_string] = ACTIONS(3293),
    [anon_sym_POUND] = ACTIONS(3293),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3293),
    [aux_sym_SLASH] = ACTIONS(3293),
    [anon_sym_COLON] = ACTIONS(4660),
    [anon_sym_COLON_QMARK] = ACTIONS(4660),
    [anon_sym_COLON_DASH] = ACTIONS(4660),
    [anon_sym_PERCENT] = ACTIONS(4660),
    [anon_sym_DASH] = ACTIONS(4660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3293),
    [anon_sym_BQUOTE] = ACTIONS(3293),
    [anon_sym_LT_LPAREN] = ACTIONS(3293),
    [anon_sym_GT_LPAREN] = ACTIONS(3293),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4660),
  },
  [1635] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
  },
  [1636] = {
    [aux_sym_concatenation_repeat1] = STATE(1636),
    [sym__concat] = ACTIONS(4662),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
  },
  [1637] = {
    [sym__concat] = ACTIONS(1691),
    [anon_sym_RBRACE] = ACTIONS(1691),
    [sym_comment] = ACTIONS(53),
  },
  [1638] = {
    [sym_concatenation] = STATE(1989),
    [sym_string] = STATE(1988),
    [sym_simple_expansion] = STATE(1988),
    [sym_string_expansion] = STATE(1988),
    [sym_expansion] = STATE(1988),
    [sym_command_substitution] = STATE(1988),
    [sym_process_substitution] = STATE(1988),
    [anon_sym_RBRACE] = ACTIONS(4665),
    [sym__special_characters] = ACTIONS(4667),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(4669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4669),
  },
  [1639] = {
    [sym__concat] = ACTIONS(1732),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [sym_comment] = ACTIONS(53),
  },
  [1640] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4671),
  },
  [1641] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4673),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1642] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(4675),
    [sym_comment] = ACTIONS(53),
  },
  [1643] = {
    [sym_concatenation] = STATE(1995),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1995),
    [anon_sym_RBRACE] = ACTIONS(4677),
    [anon_sym_EQ] = ACTIONS(4679),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4683),
    [anon_sym_COLON] = ACTIONS(4679),
    [anon_sym_COLON_QMARK] = ACTIONS(4679),
    [anon_sym_COLON_DASH] = ACTIONS(4679),
    [anon_sym_PERCENT] = ACTIONS(4679),
    [anon_sym_DASH] = ACTIONS(4679),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1644] = {
    [sym_concatenation] = STATE(1998),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1998),
    [anon_sym_RBRACE] = ACTIONS(4685),
    [anon_sym_EQ] = ACTIONS(4687),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4689),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4691),
    [anon_sym_COLON] = ACTIONS(4687),
    [anon_sym_COLON_QMARK] = ACTIONS(4687),
    [anon_sym_COLON_DASH] = ACTIONS(4687),
    [anon_sym_PERCENT] = ACTIONS(4687),
    [anon_sym_DASH] = ACTIONS(4687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1645] = {
    [sym_concatenation] = STATE(2000),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2000),
    [anon_sym_RBRACE] = ACTIONS(4665),
    [anon_sym_EQ] = ACTIONS(4693),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4697),
    [anon_sym_COLON] = ACTIONS(4693),
    [anon_sym_COLON_QMARK] = ACTIONS(4693),
    [anon_sym_COLON_DASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1646] = {
    [sym__concat] = ACTIONS(1798),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [sym_comment] = ACTIONS(53),
  },
  [1647] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4699),
  },
  [1648] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4701),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1649] = {
    [sym__concat] = ACTIONS(1806),
    [anon_sym_RBRACE] = ACTIONS(1806),
    [sym_comment] = ACTIONS(53),
  },
  [1650] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4703),
  },
  [1651] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4665),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1652] = {
    [sym__concat] = ACTIONS(1940),
    [anon_sym_RBRACE] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
  },
  [1653] = {
    [sym__concat] = ACTIONS(2006),
    [anon_sym_RBRACE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(53),
  },
  [1654] = {
    [sym__concat] = ACTIONS(2710),
    [anon_sym_RBRACE] = ACTIONS(2710),
    [anon_sym_EQ] = ACTIONS(2712),
    [sym__special_characters] = ACTIONS(2712),
    [anon_sym_DQUOTE] = ACTIONS(2710),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [sym_raw_string] = ACTIONS(2710),
    [anon_sym_POUND] = ACTIONS(2710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2710),
    [anon_sym_COLON] = ACTIONS(2712),
    [anon_sym_COLON_QMARK] = ACTIONS(2712),
    [anon_sym_COLON_DASH] = ACTIONS(2712),
    [anon_sym_PERCENT] = ACTIONS(2712),
    [anon_sym_DASH] = ACTIONS(2712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2710),
    [anon_sym_BQUOTE] = ACTIONS(2710),
    [anon_sym_LT_LPAREN] = ACTIONS(2710),
    [anon_sym_GT_LPAREN] = ACTIONS(2710),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2712),
  },
  [1655] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4705),
    [sym_comment] = ACTIONS(53),
  },
  [1656] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4707),
    [sym_comment] = ACTIONS(53),
  },
  [1657] = {
    [anon_sym_RBRACE] = ACTIONS(4707),
    [sym_comment] = ACTIONS(53),
  },
  [1658] = {
    [sym_concatenation] = STATE(2007),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2007),
    [anon_sym_RBRACE] = ACTIONS(4709),
    [anon_sym_EQ] = ACTIONS(4711),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4713),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4711),
    [anon_sym_COLON_QMARK] = ACTIONS(4711),
    [anon_sym_COLON_DASH] = ACTIONS(4711),
    [anon_sym_PERCENT] = ACTIONS(4711),
    [anon_sym_DASH] = ACTIONS(4711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1659] = {
    [sym__concat] = ACTIONS(2788),
    [anon_sym_RBRACE] = ACTIONS(2788),
    [anon_sym_EQ] = ACTIONS(2790),
    [sym__special_characters] = ACTIONS(2790),
    [anon_sym_DQUOTE] = ACTIONS(2788),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym_raw_string] = ACTIONS(2788),
    [anon_sym_POUND] = ACTIONS(2788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2788),
    [anon_sym_COLON] = ACTIONS(2790),
    [anon_sym_COLON_QMARK] = ACTIONS(2790),
    [anon_sym_COLON_DASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2788),
    [anon_sym_BQUOTE] = ACTIONS(2788),
    [anon_sym_LT_LPAREN] = ACTIONS(2788),
    [anon_sym_GT_LPAREN] = ACTIONS(2788),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2790),
  },
  [1660] = {
    [sym_concatenation] = STATE(2010),
    [sym_string] = STATE(2009),
    [sym_simple_expansion] = STATE(2009),
    [sym_string_expansion] = STATE(2009),
    [sym_expansion] = STATE(2009),
    [sym_command_substitution] = STATE(2009),
    [sym_process_substitution] = STATE(2009),
    [anon_sym_RBRACE] = ACTIONS(4707),
    [sym__special_characters] = ACTIONS(4715),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(4717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4717),
  },
  [1661] = {
    [sym__concat] = ACTIONS(2831),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [sym__special_characters] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [sym_raw_string] = ACTIONS(2831),
    [anon_sym_POUND] = ACTIONS(2831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2831),
    [anon_sym_COLON] = ACTIONS(2833),
    [anon_sym_COLON_QMARK] = ACTIONS(2833),
    [anon_sym_COLON_DASH] = ACTIONS(2833),
    [anon_sym_PERCENT] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2831),
    [anon_sym_BQUOTE] = ACTIONS(2831),
    [anon_sym_LT_LPAREN] = ACTIONS(2831),
    [anon_sym_GT_LPAREN] = ACTIONS(2831),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2833),
  },
  [1662] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4719),
  },
  [1663] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4721),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1664] = {
    [sym__concat] = ACTIONS(2839),
    [anon_sym_RBRACE] = ACTIONS(2839),
    [anon_sym_EQ] = ACTIONS(2841),
    [sym__special_characters] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_DOLLAR] = ACTIONS(2841),
    [sym_raw_string] = ACTIONS(2839),
    [anon_sym_POUND] = ACTIONS(2839),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2839),
    [anon_sym_COLON] = ACTIONS(2841),
    [anon_sym_COLON_QMARK] = ACTIONS(2841),
    [anon_sym_COLON_DASH] = ACTIONS(2841),
    [anon_sym_PERCENT] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2841),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2839),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_LT_LPAREN] = ACTIONS(2839),
    [anon_sym_GT_LPAREN] = ACTIONS(2839),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2841),
  },
  [1665] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4723),
  },
  [1666] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4725),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1667] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4727),
  },
  [1668] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4707),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1669] = {
    [sym_concatenation] = STATE(2017),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2017),
    [anon_sym_RBRACE] = ACTIONS(4729),
    [anon_sym_EQ] = ACTIONS(4731),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4731),
    [anon_sym_COLON_QMARK] = ACTIONS(4731),
    [anon_sym_COLON_DASH] = ACTIONS(4731),
    [anon_sym_PERCENT] = ACTIONS(4731),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1670] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_RBRACE] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [sym__special_characters] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_POUND] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_COLON] = ACTIONS(2857),
    [anon_sym_COLON_QMARK] = ACTIONS(2857),
    [anon_sym_COLON_DASH] = ACTIONS(2857),
    [anon_sym_PERCENT] = ACTIONS(2857),
    [anon_sym_DASH] = ACTIONS(2857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2857),
  },
  [1671] = {
    [sym_concatenation] = STATE(2019),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2019),
    [anon_sym_RBRACE] = ACTIONS(4735),
    [anon_sym_EQ] = ACTIONS(4737),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4737),
    [anon_sym_COLON_QMARK] = ACTIONS(4737),
    [anon_sym_COLON_DASH] = ACTIONS(4737),
    [anon_sym_PERCENT] = ACTIONS(4737),
    [anon_sym_DASH] = ACTIONS(4737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1672] = {
    [sym__simple_heredoc_body] = ACTIONS(4741),
    [sym__heredoc_body_beginning] = ACTIONS(4741),
    [sym_file_descriptor] = ACTIONS(4741),
    [sym__concat] = ACTIONS(4741),
    [anon_sym_esac] = ACTIONS(4743),
    [anon_sym_PIPE] = ACTIONS(4743),
    [anon_sym_RPAREN] = ACTIONS(4743),
    [anon_sym_SEMI_SEMI] = ACTIONS(4743),
    [anon_sym_PIPE_AMP] = ACTIONS(4743),
    [anon_sym_AMP_AMP] = ACTIONS(4743),
    [anon_sym_PIPE_PIPE] = ACTIONS(4743),
    [anon_sym_EQ_TILDE] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4743),
    [anon_sym_LT] = ACTIONS(4743),
    [anon_sym_GT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_AMP_GT] = ACTIONS(4743),
    [anon_sym_AMP_GT_GT] = ACTIONS(4743),
    [anon_sym_LT_AMP] = ACTIONS(4743),
    [anon_sym_GT_AMP] = ACTIONS(4743),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_LT_LT_DASH] = ACTIONS(4743),
    [anon_sym_LT_LT_LT] = ACTIONS(4743),
    [sym__special_characters] = ACTIONS(4743),
    [anon_sym_DQUOTE] = ACTIONS(4743),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [sym_raw_string] = ACTIONS(4743),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4743),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [anon_sym_LT_LPAREN] = ACTIONS(4743),
    [anon_sym_GT_LPAREN] = ACTIONS(4743),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4743),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_LF] = ACTIONS(4741),
    [anon_sym_AMP] = ACTIONS(4743),
  },
  [1673] = {
    [sym__simple_heredoc_body] = ACTIONS(4745),
    [sym__heredoc_body_beginning] = ACTIONS(4745),
    [sym_file_descriptor] = ACTIONS(4745),
    [sym__concat] = ACTIONS(4745),
    [anon_sym_esac] = ACTIONS(4747),
    [anon_sym_PIPE] = ACTIONS(4747),
    [anon_sym_RPAREN] = ACTIONS(4747),
    [anon_sym_SEMI_SEMI] = ACTIONS(4747),
    [anon_sym_PIPE_AMP] = ACTIONS(4747),
    [anon_sym_AMP_AMP] = ACTIONS(4747),
    [anon_sym_PIPE_PIPE] = ACTIONS(4747),
    [anon_sym_EQ_TILDE] = ACTIONS(4747),
    [anon_sym_EQ_EQ] = ACTIONS(4747),
    [anon_sym_LT] = ACTIONS(4747),
    [anon_sym_GT] = ACTIONS(4747),
    [anon_sym_GT_GT] = ACTIONS(4747),
    [anon_sym_AMP_GT] = ACTIONS(4747),
    [anon_sym_AMP_GT_GT] = ACTIONS(4747),
    [anon_sym_LT_AMP] = ACTIONS(4747),
    [anon_sym_GT_AMP] = ACTIONS(4747),
    [anon_sym_LT_LT] = ACTIONS(4747),
    [anon_sym_LT_LT_DASH] = ACTIONS(4747),
    [anon_sym_LT_LT_LT] = ACTIONS(4747),
    [sym__special_characters] = ACTIONS(4747),
    [anon_sym_DQUOTE] = ACTIONS(4747),
    [anon_sym_DOLLAR] = ACTIONS(4747),
    [sym_raw_string] = ACTIONS(4747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4747),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4747),
    [anon_sym_BQUOTE] = ACTIONS(4747),
    [anon_sym_LT_LPAREN] = ACTIONS(4747),
    [anon_sym_GT_LPAREN] = ACTIONS(4747),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4747),
    [anon_sym_SEMI] = ACTIONS(4747),
    [anon_sym_LF] = ACTIONS(4745),
    [anon_sym_AMP] = ACTIONS(4747),
  },
  [1674] = {
    [sym__simple_heredoc_body] = ACTIONS(4749),
    [sym__heredoc_body_beginning] = ACTIONS(4749),
    [sym_file_descriptor] = ACTIONS(4749),
    [sym__concat] = ACTIONS(4749),
    [anon_sym_esac] = ACTIONS(4751),
    [anon_sym_PIPE] = ACTIONS(4751),
    [anon_sym_RPAREN] = ACTIONS(4751),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_EQ_TILDE] = ACTIONS(4751),
    [anon_sym_EQ_EQ] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4751),
    [anon_sym_GT] = ACTIONS(4751),
    [anon_sym_GT_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT_GT] = ACTIONS(4751),
    [anon_sym_LT_AMP] = ACTIONS(4751),
    [anon_sym_GT_AMP] = ACTIONS(4751),
    [anon_sym_LT_LT] = ACTIONS(4751),
    [anon_sym_LT_LT_DASH] = ACTIONS(4751),
    [anon_sym_LT_LT_LT] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4751),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4751),
    [anon_sym_LF] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(4751),
  },
  [1675] = {
    [sym__simple_heredoc_body] = ACTIONS(4753),
    [sym__heredoc_body_beginning] = ACTIONS(4753),
    [sym_file_descriptor] = ACTIONS(4753),
    [sym__concat] = ACTIONS(4753),
    [anon_sym_esac] = ACTIONS(4755),
    [anon_sym_PIPE] = ACTIONS(4755),
    [anon_sym_RPAREN] = ACTIONS(4755),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_EQ_TILDE] = ACTIONS(4755),
    [anon_sym_EQ_EQ] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4755),
    [anon_sym_GT] = ACTIONS(4755),
    [anon_sym_GT_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT_GT] = ACTIONS(4755),
    [anon_sym_LT_AMP] = ACTIONS(4755),
    [anon_sym_GT_AMP] = ACTIONS(4755),
    [anon_sym_LT_LT] = ACTIONS(4755),
    [anon_sym_LT_LT_DASH] = ACTIONS(4755),
    [anon_sym_LT_LT_LT] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4755),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_LF] = ACTIONS(4753),
    [anon_sym_AMP] = ACTIONS(4755),
  },
  [1676] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4757),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1677] = {
    [sym__simple_heredoc_body] = ACTIONS(4759),
    [sym__heredoc_body_beginning] = ACTIONS(4759),
    [sym_file_descriptor] = ACTIONS(4759),
    [sym__concat] = ACTIONS(4759),
    [anon_sym_esac] = ACTIONS(4761),
    [anon_sym_PIPE] = ACTIONS(4761),
    [anon_sym_RPAREN] = ACTIONS(4761),
    [anon_sym_SEMI_SEMI] = ACTIONS(4761),
    [anon_sym_PIPE_AMP] = ACTIONS(4761),
    [anon_sym_AMP_AMP] = ACTIONS(4761),
    [anon_sym_PIPE_PIPE] = ACTIONS(4761),
    [anon_sym_EQ_TILDE] = ACTIONS(4761),
    [anon_sym_EQ_EQ] = ACTIONS(4761),
    [anon_sym_LT] = ACTIONS(4761),
    [anon_sym_GT] = ACTIONS(4761),
    [anon_sym_GT_GT] = ACTIONS(4761),
    [anon_sym_AMP_GT] = ACTIONS(4761),
    [anon_sym_AMP_GT_GT] = ACTIONS(4761),
    [anon_sym_LT_AMP] = ACTIONS(4761),
    [anon_sym_GT_AMP] = ACTIONS(4761),
    [anon_sym_LT_LT] = ACTIONS(4761),
    [anon_sym_LT_LT_DASH] = ACTIONS(4761),
    [anon_sym_LT_LT_LT] = ACTIONS(4761),
    [sym__special_characters] = ACTIONS(4761),
    [anon_sym_DQUOTE] = ACTIONS(4761),
    [anon_sym_DOLLAR] = ACTIONS(4761),
    [sym_raw_string] = ACTIONS(4761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4761),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4761),
    [anon_sym_BQUOTE] = ACTIONS(4761),
    [anon_sym_LT_LPAREN] = ACTIONS(4761),
    [anon_sym_GT_LPAREN] = ACTIONS(4761),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4761),
    [anon_sym_SEMI] = ACTIONS(4761),
    [anon_sym_LF] = ACTIONS(4759),
    [anon_sym_AMP] = ACTIONS(4761),
  },
  [1678] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4763),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1679] = {
    [sym__simple_heredoc_body] = ACTIONS(4765),
    [sym__heredoc_body_beginning] = ACTIONS(4765),
    [sym_file_descriptor] = ACTIONS(4765),
    [sym__concat] = ACTIONS(4765),
    [anon_sym_esac] = ACTIONS(4767),
    [anon_sym_PIPE] = ACTIONS(4767),
    [anon_sym_RPAREN] = ACTIONS(4767),
    [anon_sym_SEMI_SEMI] = ACTIONS(4767),
    [anon_sym_PIPE_AMP] = ACTIONS(4767),
    [anon_sym_AMP_AMP] = ACTIONS(4767),
    [anon_sym_PIPE_PIPE] = ACTIONS(4767),
    [anon_sym_EQ_TILDE] = ACTIONS(4767),
    [anon_sym_EQ_EQ] = ACTIONS(4767),
    [anon_sym_LT] = ACTIONS(4767),
    [anon_sym_GT] = ACTIONS(4767),
    [anon_sym_GT_GT] = ACTIONS(4767),
    [anon_sym_AMP_GT] = ACTIONS(4767),
    [anon_sym_AMP_GT_GT] = ACTIONS(4767),
    [anon_sym_LT_AMP] = ACTIONS(4767),
    [anon_sym_GT_AMP] = ACTIONS(4767),
    [anon_sym_LT_LT] = ACTIONS(4767),
    [anon_sym_LT_LT_DASH] = ACTIONS(4767),
    [anon_sym_LT_LT_LT] = ACTIONS(4767),
    [sym__special_characters] = ACTIONS(4767),
    [anon_sym_DQUOTE] = ACTIONS(4767),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [sym_raw_string] = ACTIONS(4767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4767),
    [anon_sym_BQUOTE] = ACTIONS(4767),
    [anon_sym_LT_LPAREN] = ACTIONS(4767),
    [anon_sym_GT_LPAREN] = ACTIONS(4767),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4767),
    [anon_sym_SEMI] = ACTIONS(4767),
    [anon_sym_LF] = ACTIONS(4765),
    [anon_sym_AMP] = ACTIONS(4767),
  },
  [1680] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4769),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1681] = {
    [sym__simple_heredoc_body] = ACTIONS(4771),
    [sym__heredoc_body_beginning] = ACTIONS(4771),
    [sym_file_descriptor] = ACTIONS(4771),
    [sym__concat] = ACTIONS(4771),
    [anon_sym_esac] = ACTIONS(4773),
    [anon_sym_PIPE] = ACTIONS(4773),
    [anon_sym_RPAREN] = ACTIONS(4773),
    [anon_sym_SEMI_SEMI] = ACTIONS(4773),
    [anon_sym_PIPE_AMP] = ACTIONS(4773),
    [anon_sym_AMP_AMP] = ACTIONS(4773),
    [anon_sym_PIPE_PIPE] = ACTIONS(4773),
    [anon_sym_EQ_TILDE] = ACTIONS(4773),
    [anon_sym_EQ_EQ] = ACTIONS(4773),
    [anon_sym_LT] = ACTIONS(4773),
    [anon_sym_GT] = ACTIONS(4773),
    [anon_sym_GT_GT] = ACTIONS(4773),
    [anon_sym_AMP_GT] = ACTIONS(4773),
    [anon_sym_AMP_GT_GT] = ACTIONS(4773),
    [anon_sym_LT_AMP] = ACTIONS(4773),
    [anon_sym_GT_AMP] = ACTIONS(4773),
    [anon_sym_LT_LT] = ACTIONS(4773),
    [anon_sym_LT_LT_DASH] = ACTIONS(4773),
    [anon_sym_LT_LT_LT] = ACTIONS(4773),
    [sym__special_characters] = ACTIONS(4773),
    [anon_sym_DQUOTE] = ACTIONS(4773),
    [anon_sym_DOLLAR] = ACTIONS(4773),
    [sym_raw_string] = ACTIONS(4773),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4773),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4773),
    [anon_sym_BQUOTE] = ACTIONS(4773),
    [anon_sym_LT_LPAREN] = ACTIONS(4773),
    [anon_sym_GT_LPAREN] = ACTIONS(4773),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4773),
    [anon_sym_SEMI] = ACTIONS(4773),
    [anon_sym_LF] = ACTIONS(4771),
    [anon_sym_AMP] = ACTIONS(4773),
  },
  [1682] = {
    [sym__simple_heredoc_body] = ACTIONS(4775),
    [sym__heredoc_body_beginning] = ACTIONS(4775),
    [sym_file_descriptor] = ACTIONS(4775),
    [sym__concat] = ACTIONS(4775),
    [anon_sym_esac] = ACTIONS(4777),
    [anon_sym_PIPE] = ACTIONS(4777),
    [anon_sym_RPAREN] = ACTIONS(4777),
    [anon_sym_SEMI_SEMI] = ACTIONS(4777),
    [anon_sym_PIPE_AMP] = ACTIONS(4777),
    [anon_sym_AMP_AMP] = ACTIONS(4777),
    [anon_sym_PIPE_PIPE] = ACTIONS(4777),
    [anon_sym_EQ_TILDE] = ACTIONS(4777),
    [anon_sym_EQ_EQ] = ACTIONS(4777),
    [anon_sym_LT] = ACTIONS(4777),
    [anon_sym_GT] = ACTIONS(4777),
    [anon_sym_GT_GT] = ACTIONS(4777),
    [anon_sym_AMP_GT] = ACTIONS(4777),
    [anon_sym_AMP_GT_GT] = ACTIONS(4777),
    [anon_sym_LT_AMP] = ACTIONS(4777),
    [anon_sym_GT_AMP] = ACTIONS(4777),
    [anon_sym_LT_LT] = ACTIONS(4777),
    [anon_sym_LT_LT_DASH] = ACTIONS(4777),
    [anon_sym_LT_LT_LT] = ACTIONS(4777),
    [sym__special_characters] = ACTIONS(4777),
    [anon_sym_DQUOTE] = ACTIONS(4777),
    [anon_sym_DOLLAR] = ACTIONS(4777),
    [sym_raw_string] = ACTIONS(4777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4777),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4777),
    [anon_sym_BQUOTE] = ACTIONS(4777),
    [anon_sym_LT_LPAREN] = ACTIONS(4777),
    [anon_sym_GT_LPAREN] = ACTIONS(4777),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4777),
    [anon_sym_SEMI] = ACTIONS(4777),
    [anon_sym_LF] = ACTIONS(4775),
    [anon_sym_AMP] = ACTIONS(4777),
  },
  [1683] = {
    [aux_sym_concatenation_repeat1] = STATE(1683),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(2613),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1642),
  },
  [1684] = {
    [sym_do_group] = STATE(2023),
    [anon_sym_do] = ACTIONS(2865),
    [sym_comment] = ACTIONS(53),
  },
  [1685] = {
    [anon_sym_PIPE] = ACTIONS(2231),
    [anon_sym_RPAREN] = ACTIONS(2229),
    [anon_sym_PIPE_AMP] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_PIPE_PIPE] = ACTIONS(2229),
    [anon_sym_BQUOTE] = ACTIONS(2229),
    [sym_comment] = ACTIONS(53),
  },
  [1686] = {
    [sym__terminated_statement] = STATE(1035),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1035),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(4779),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1687] = {
    [sym__simple_heredoc_body] = ACTIONS(3438),
    [sym__heredoc_body_beginning] = ACTIONS(3438),
    [sym_file_descriptor] = ACTIONS(3438),
    [anon_sym_PIPE] = ACTIONS(3440),
    [anon_sym_RPAREN] = ACTIONS(3438),
    [anon_sym_PIPE_AMP] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_GT] = ACTIONS(3440),
    [anon_sym_GT_GT] = ACTIONS(3438),
    [anon_sym_AMP_GT] = ACTIONS(3440),
    [anon_sym_AMP_GT_GT] = ACTIONS(3438),
    [anon_sym_LT_AMP] = ACTIONS(3438),
    [anon_sym_GT_AMP] = ACTIONS(3438),
    [anon_sym_LT_LT] = ACTIONS(3440),
    [anon_sym_LT_LT_DASH] = ACTIONS(3438),
    [anon_sym_LT_LT_LT] = ACTIONS(3438),
    [anon_sym_BQUOTE] = ACTIONS(3438),
    [sym_comment] = ACTIONS(53),
  },
  [1688] = {
    [anon_sym_PIPE] = ACTIONS(3444),
    [anon_sym_RPAREN] = ACTIONS(3446),
    [anon_sym_PIPE_AMP] = ACTIONS(3446),
    [anon_sym_AMP_AMP] = ACTIONS(3446),
    [anon_sym_PIPE_PIPE] = ACTIONS(3446),
    [anon_sym_BQUOTE] = ACTIONS(3446),
    [sym_comment] = ACTIONS(53),
  },
  [1689] = {
    [anon_sym_PIPE] = ACTIONS(3452),
    [anon_sym_RPAREN] = ACTIONS(3454),
    [anon_sym_PIPE_AMP] = ACTIONS(3454),
    [anon_sym_AMP_AMP] = ACTIONS(3454),
    [anon_sym_PIPE_PIPE] = ACTIONS(3454),
    [anon_sym_BQUOTE] = ACTIONS(3454),
    [sym_comment] = ACTIONS(53),
  },
  [1690] = {
    [anon_sym_fi] = ACTIONS(4781),
    [sym_comment] = ACTIONS(53),
  },
  [1691] = {
    [sym_elif_clause] = STATE(599),
    [sym_else_clause] = STATE(2026),
    [aux_sym_if_statement_repeat1] = STATE(1043),
    [anon_sym_fi] = ACTIONS(4781),
    [anon_sym_elif] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2253),
    [sym_comment] = ACTIONS(53),
  },
  [1692] = {
    [anon_sym_PIPE] = ACTIONS(3463),
    [anon_sym_RPAREN] = ACTIONS(3465),
    [anon_sym_PIPE_AMP] = ACTIONS(3465),
    [anon_sym_AMP_AMP] = ACTIONS(3465),
    [anon_sym_PIPE_PIPE] = ACTIONS(3465),
    [anon_sym_BQUOTE] = ACTIONS(3465),
    [sym_comment] = ACTIONS(53),
  },
  [1693] = {
    [anon_sym_esac] = ACTIONS(4783),
    [sym_comment] = ACTIONS(53),
  },
  [1694] = {
    [sym_case_item] = STATE(1472),
    [sym_last_case_item] = STATE(2028),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(1472),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2259),
  },
  [1695] = {
    [sym_case_item] = STATE(2030),
    [sym_last_case_item] = STATE(2028),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(2030),
    [anon_sym_esac] = ACTIONS(4785),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2261),
  },
  [1696] = {
    [anon_sym_PIPE] = ACTIONS(3477),
    [anon_sym_RPAREN] = ACTIONS(3479),
    [anon_sym_PIPE_AMP] = ACTIONS(3479),
    [anon_sym_AMP_AMP] = ACTIONS(3479),
    [anon_sym_PIPE_PIPE] = ACTIONS(3479),
    [anon_sym_BQUOTE] = ACTIONS(3479),
    [sym_comment] = ACTIONS(53),
  },
  [1697] = {
    [anon_sym_esac] = ACTIONS(4787),
    [sym_comment] = ACTIONS(53),
  },
  [1698] = {
    [sym_case_item] = STATE(1472),
    [sym_last_case_item] = STATE(2032),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(1472),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2259),
  },
  [1699] = {
    [sym_case_item] = STATE(2034),
    [sym_last_case_item] = STATE(2032),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(2034),
    [anon_sym_esac] = ACTIONS(4789),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2261),
  },
  [1700] = {
    [sym_file_redirect] = STATE(2035),
    [sym_file_descriptor] = ACTIONS(2887),
    [anon_sym_PIPE] = ACTIONS(3521),
    [anon_sym_RPAREN] = ACTIONS(3523),
    [anon_sym_PIPE_AMP] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_GT_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT] = ACTIONS(2889),
    [anon_sym_AMP_GT_GT] = ACTIONS(2891),
    [anon_sym_LT_AMP] = ACTIONS(2891),
    [anon_sym_GT_AMP] = ACTIONS(2891),
    [sym_comment] = ACTIONS(53),
  },
  [1701] = {
    [sym_file_descriptor] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3527),
    [anon_sym_RPAREN] = ACTIONS(3525),
    [anon_sym_PIPE_AMP] = ACTIONS(3525),
    [anon_sym_AMP_AMP] = ACTIONS(3525),
    [anon_sym_PIPE_PIPE] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_AMP_GT] = ACTIONS(3527),
    [anon_sym_AMP_GT_GT] = ACTIONS(3525),
    [anon_sym_LT_AMP] = ACTIONS(3525),
    [anon_sym_GT_AMP] = ACTIONS(3525),
    [anon_sym_BQUOTE] = ACTIONS(3525),
    [sym_comment] = ACTIONS(53),
  },
  [1702] = {
    [sym_concatenation] = STATE(2038),
    [sym_string] = STATE(2037),
    [sym_simple_expansion] = STATE(2037),
    [sym_string_expansion] = STATE(2037),
    [sym_expansion] = STATE(2037),
    [sym_command_substitution] = STATE(2037),
    [sym_process_substitution] = STATE(2037),
    [sym__special_characters] = ACTIONS(4791),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(4793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4793),
  },
  [1703] = {
    [aux_sym_concatenation_repeat1] = STATE(2039),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
  },
  [1704] = {
    [aux_sym_concatenation_repeat1] = STATE(2039),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [1705] = {
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [1706] = {
    [anon_sym_PIPE] = ACTIONS(3553),
    [anon_sym_RPAREN] = ACTIONS(3555),
    [anon_sym_PIPE_AMP] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BQUOTE] = ACTIONS(3555),
    [sym_comment] = ACTIONS(53),
  },
  [1707] = {
    [sym_concatenation] = STATE(2042),
    [sym_string] = STATE(2041),
    [sym_simple_expansion] = STATE(2041),
    [sym_string_expansion] = STATE(2041),
    [sym_expansion] = STATE(2041),
    [sym_command_substitution] = STATE(2041),
    [sym_process_substitution] = STATE(2041),
    [sym__special_characters] = ACTIONS(4795),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4012),
    [sym_raw_string] = ACTIONS(4797),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4020),
    [anon_sym_LT_LPAREN] = ACTIONS(4022),
    [anon_sym_GT_LPAREN] = ACTIONS(4022),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4797),
  },
  [1708] = {
    [aux_sym_concatenation_repeat1] = STATE(2044),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(4799),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
  },
  [1709] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(2046),
    [anon_sym_DQUOTE] = ACTIONS(4801),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [1710] = {
    [sym_string] = STATE(2048),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4803),
    [sym_raw_string] = ACTIONS(4805),
    [anon_sym_POUND] = ACTIONS(4803),
    [anon_sym_DASH] = ACTIONS(4803),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4807),
    [anon_sym_STAR] = ACTIONS(4803),
    [anon_sym_AT] = ACTIONS(4803),
    [anon_sym_QMARK] = ACTIONS(4803),
    [anon_sym_0] = ACTIONS(4809),
    [anon_sym__] = ACTIONS(4809),
  },
  [1711] = {
    [aux_sym_concatenation_repeat1] = STATE(2044),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(4799),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [anon_sym_LT_LT_LT] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [1712] = {
    [sym_subscript] = STATE(2054),
    [sym_variable_name] = ACTIONS(4811),
    [anon_sym_DOLLAR] = ACTIONS(4813),
    [anon_sym_POUND] = ACTIONS(4815),
    [anon_sym_DASH] = ACTIONS(4813),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4817),
    [anon_sym_STAR] = ACTIONS(4813),
    [anon_sym_AT] = ACTIONS(4813),
    [anon_sym_QMARK] = ACTIONS(4813),
    [anon_sym_0] = ACTIONS(4819),
    [anon_sym__] = ACTIONS(4819),
  },
  [1713] = {
    [sym_for_statement] = STATE(2055),
    [sym_while_statement] = STATE(2055),
    [sym_if_statement] = STATE(2055),
    [sym_case_statement] = STATE(2055),
    [sym_function_definition] = STATE(2055),
    [sym_subshell] = STATE(2055),
    [sym_pipeline] = STATE(2055),
    [sym_list] = STATE(2055),
    [sym_negated_command] = STATE(2055),
    [sym_test_command] = STATE(2055),
    [sym_declaration_command] = STATE(2055),
    [sym_unset_command] = STATE(2055),
    [sym_command] = STATE(2055),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2056),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [1714] = {
    [sym_for_statement] = STATE(2057),
    [sym_while_statement] = STATE(2057),
    [sym_if_statement] = STATE(2057),
    [sym_case_statement] = STATE(2057),
    [sym_function_definition] = STATE(2057),
    [sym_subshell] = STATE(2057),
    [sym_pipeline] = STATE(2057),
    [sym_list] = STATE(2057),
    [sym_negated_command] = STATE(2057),
    [sym_test_command] = STATE(2057),
    [sym_declaration_command] = STATE(2057),
    [sym_unset_command] = STATE(2057),
    [sym_command] = STATE(2057),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(2058),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [1715] = {
    [sym_for_statement] = STATE(2059),
    [sym_while_statement] = STATE(2059),
    [sym_if_statement] = STATE(2059),
    [sym_case_statement] = STATE(2059),
    [sym_function_definition] = STATE(2059),
    [sym_subshell] = STATE(2059),
    [sym_pipeline] = STATE(2059),
    [sym_list] = STATE(2059),
    [sym_negated_command] = STATE(2059),
    [sym_test_command] = STATE(2059),
    [sym_declaration_command] = STATE(2059),
    [sym_unset_command] = STATE(2059),
    [sym_command] = STATE(2059),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2060),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [1716] = {
    [sym_file_descriptor] = ACTIONS(677),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [anon_sym_LT_LT_LT] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [1717] = {
    [sym_file_descriptor] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(2056),
    [anon_sym_RPAREN] = ACTIONS(2054),
    [anon_sym_PIPE_AMP] = ACTIONS(2054),
    [anon_sym_AMP_AMP] = ACTIONS(2054),
    [anon_sym_PIPE_PIPE] = ACTIONS(2054),
    [anon_sym_LT] = ACTIONS(2056),
    [anon_sym_GT] = ACTIONS(2056),
    [anon_sym_GT_GT] = ACTIONS(2054),
    [anon_sym_AMP_GT] = ACTIONS(2056),
    [anon_sym_AMP_GT_GT] = ACTIONS(2054),
    [anon_sym_LT_AMP] = ACTIONS(2054),
    [anon_sym_GT_AMP] = ACTIONS(2054),
    [anon_sym_LT_LT] = ACTIONS(2056),
    [anon_sym_LT_LT_DASH] = ACTIONS(2054),
    [anon_sym_LT_LT_LT] = ACTIONS(2054),
    [anon_sym_BQUOTE] = ACTIONS(2054),
    [sym_comment] = ACTIONS(53),
  },
  [1718] = {
    [aux_sym_concatenation_repeat1] = STATE(2044),
    [sym_file_descriptor] = ACTIONS(2058),
    [sym__concat] = ACTIONS(4799),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_RPAREN] = ACTIONS(2058),
    [anon_sym_PIPE_AMP] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_PIPE_PIPE] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2058),
    [anon_sym_LT_AMP] = ACTIONS(2058),
    [anon_sym_GT_AMP] = ACTIONS(2058),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2058),
    [anon_sym_LT_LT_LT] = ACTIONS(2058),
    [sym_comment] = ACTIONS(53),
  },
  [1719] = {
    [aux_sym_concatenation_repeat1] = STATE(2044),
    [sym_file_descriptor] = ACTIONS(2062),
    [sym__concat] = ACTIONS(4799),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_RPAREN] = ACTIONS(2062),
    [anon_sym_PIPE_AMP] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_PIPE_PIPE] = ACTIONS(2062),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2062),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2062),
    [anon_sym_LT_AMP] = ACTIONS(2062),
    [anon_sym_GT_AMP] = ACTIONS(2062),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2062),
    [anon_sym_LT_LT_LT] = ACTIONS(2062),
    [sym_comment] = ACTIONS(53),
  },
  [1720] = {
    [sym_file_descriptor] = ACTIONS(2062),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_RPAREN] = ACTIONS(2062),
    [anon_sym_PIPE_AMP] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_PIPE_PIPE] = ACTIONS(2062),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2062),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2062),
    [anon_sym_LT_AMP] = ACTIONS(2062),
    [anon_sym_GT_AMP] = ACTIONS(2062),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2062),
    [anon_sym_LT_LT_LT] = ACTIONS(2062),
    [anon_sym_BQUOTE] = ACTIONS(2062),
    [sym_comment] = ACTIONS(53),
  },
  [1721] = {
    [sym_file_redirect] = STATE(1721),
    [sym_heredoc_redirect] = STATE(1721),
    [sym_herestring_redirect] = STATE(1721),
    [aux_sym_while_statement_repeat1] = STATE(1721),
    [sym_file_descriptor] = ACTIONS(4821),
    [anon_sym_PIPE] = ACTIONS(2075),
    [anon_sym_RPAREN] = ACTIONS(2070),
    [anon_sym_PIPE_AMP] = ACTIONS(2070),
    [anon_sym_AMP_AMP] = ACTIONS(2070),
    [anon_sym_PIPE_PIPE] = ACTIONS(2070),
    [anon_sym_LT] = ACTIONS(4824),
    [anon_sym_GT] = ACTIONS(4824),
    [anon_sym_GT_GT] = ACTIONS(4827),
    [anon_sym_AMP_GT] = ACTIONS(4824),
    [anon_sym_AMP_GT_GT] = ACTIONS(4827),
    [anon_sym_LT_AMP] = ACTIONS(4827),
    [anon_sym_GT_AMP] = ACTIONS(4827),
    [anon_sym_LT_LT] = ACTIONS(4830),
    [anon_sym_LT_LT_DASH] = ACTIONS(4833),
    [anon_sym_LT_LT_LT] = ACTIONS(4836),
    [sym_comment] = ACTIONS(53),
  },
  [1722] = {
    [sym_variable_name] = ACTIONS(2127),
    [anon_sym_PIPE] = ACTIONS(2129),
    [anon_sym_RPAREN] = ACTIONS(2127),
    [anon_sym_PIPE_AMP] = ACTIONS(2127),
    [anon_sym_AMP_AMP] = ACTIONS(2127),
    [anon_sym_PIPE_PIPE] = ACTIONS(2127),
    [sym__special_characters] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(2127),
    [anon_sym_DOLLAR] = ACTIONS(2129),
    [sym_raw_string] = ACTIONS(2127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2127),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2127),
    [anon_sym_BQUOTE] = ACTIONS(2127),
    [anon_sym_LT_LPAREN] = ACTIONS(2127),
    [anon_sym_GT_LPAREN] = ACTIONS(2127),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2129),
    [sym_word] = ACTIONS(2129),
  },
  [1723] = {
    [sym_concatenation] = STATE(1009),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1009),
    [anon_sym_RPAREN] = ACTIONS(4839),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [1724] = {
    [sym__concat] = ACTIONS(2710),
    [sym_variable_name] = ACTIONS(2710),
    [anon_sym_PIPE] = ACTIONS(2712),
    [anon_sym_RPAREN] = ACTIONS(2710),
    [anon_sym_PIPE_AMP] = ACTIONS(2710),
    [anon_sym_AMP_AMP] = ACTIONS(2710),
    [anon_sym_PIPE_PIPE] = ACTIONS(2710),
    [sym__special_characters] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(2710),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [sym_raw_string] = ACTIONS(2710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2710),
    [anon_sym_BQUOTE] = ACTIONS(2710),
    [anon_sym_LT_LPAREN] = ACTIONS(2710),
    [anon_sym_GT_LPAREN] = ACTIONS(2710),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2712),
    [sym_word] = ACTIONS(2712),
  },
  [1725] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4841),
    [sym_comment] = ACTIONS(53),
  },
  [1726] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4843),
    [sym_comment] = ACTIONS(53),
  },
  [1727] = {
    [anon_sym_RBRACE] = ACTIONS(4843),
    [sym_comment] = ACTIONS(53),
  },
  [1728] = {
    [sym_concatenation] = STATE(2065),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2065),
    [anon_sym_RBRACE] = ACTIONS(4845),
    [anon_sym_EQ] = ACTIONS(4847),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4849),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4847),
    [anon_sym_COLON_QMARK] = ACTIONS(4847),
    [anon_sym_COLON_DASH] = ACTIONS(4847),
    [anon_sym_PERCENT] = ACTIONS(4847),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1729] = {
    [sym__concat] = ACTIONS(2788),
    [sym_variable_name] = ACTIONS(2788),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_RPAREN] = ACTIONS(2788),
    [anon_sym_PIPE_AMP] = ACTIONS(2788),
    [anon_sym_AMP_AMP] = ACTIONS(2788),
    [anon_sym_PIPE_PIPE] = ACTIONS(2788),
    [sym__special_characters] = ACTIONS(2788),
    [anon_sym_DQUOTE] = ACTIONS(2788),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym_raw_string] = ACTIONS(2788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2788),
    [anon_sym_BQUOTE] = ACTIONS(2788),
    [anon_sym_LT_LPAREN] = ACTIONS(2788),
    [anon_sym_GT_LPAREN] = ACTIONS(2788),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2790),
    [sym_word] = ACTIONS(2790),
  },
  [1730] = {
    [sym_concatenation] = STATE(2068),
    [sym_string] = STATE(2067),
    [sym_simple_expansion] = STATE(2067),
    [sym_string_expansion] = STATE(2067),
    [sym_expansion] = STATE(2067),
    [sym_command_substitution] = STATE(2067),
    [sym_process_substitution] = STATE(2067),
    [anon_sym_RBRACE] = ACTIONS(4843),
    [sym__special_characters] = ACTIONS(4851),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(4853),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4853),
  },
  [1731] = {
    [sym__concat] = ACTIONS(2831),
    [sym_variable_name] = ACTIONS(2831),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2831),
    [anon_sym_PIPE_AMP] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [sym__special_characters] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [sym_raw_string] = ACTIONS(2831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2831),
    [anon_sym_BQUOTE] = ACTIONS(2831),
    [anon_sym_LT_LPAREN] = ACTIONS(2831),
    [anon_sym_GT_LPAREN] = ACTIONS(2831),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2833),
    [sym_word] = ACTIONS(2833),
  },
  [1732] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4855),
  },
  [1733] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4857),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1734] = {
    [sym__concat] = ACTIONS(2839),
    [sym_variable_name] = ACTIONS(2839),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_RPAREN] = ACTIONS(2839),
    [anon_sym_PIPE_AMP] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [sym__special_characters] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_DOLLAR] = ACTIONS(2841),
    [sym_raw_string] = ACTIONS(2839),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2839),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2839),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_LT_LPAREN] = ACTIONS(2839),
    [anon_sym_GT_LPAREN] = ACTIONS(2839),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2841),
    [sym_word] = ACTIONS(2841),
  },
  [1735] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4859),
  },
  [1736] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4861),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1737] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4863),
  },
  [1738] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4843),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1739] = {
    [sym_concatenation] = STATE(2075),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2075),
    [anon_sym_RBRACE] = ACTIONS(4865),
    [anon_sym_EQ] = ACTIONS(4867),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4867),
    [anon_sym_COLON_QMARK] = ACTIONS(4867),
    [anon_sym_COLON_DASH] = ACTIONS(4867),
    [anon_sym_PERCENT] = ACTIONS(4867),
    [anon_sym_DASH] = ACTIONS(4867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1740] = {
    [sym__concat] = ACTIONS(2855),
    [sym_variable_name] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2857),
    [sym_word] = ACTIONS(2857),
  },
  [1741] = {
    [sym_concatenation] = STATE(2077),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2077),
    [anon_sym_RBRACE] = ACTIONS(4871),
    [anon_sym_EQ] = ACTIONS(4873),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4873),
    [anon_sym_COLON_QMARK] = ACTIONS(4873),
    [anon_sym_COLON_DASH] = ACTIONS(4873),
    [anon_sym_PERCENT] = ACTIONS(4873),
    [anon_sym_DASH] = ACTIONS(4873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1742] = {
    [sym__concat] = ACTIONS(2710),
    [anon_sym_PIPE] = ACTIONS(2712),
    [anon_sym_RPAREN] = ACTIONS(2710),
    [anon_sym_PIPE_AMP] = ACTIONS(2710),
    [anon_sym_AMP_AMP] = ACTIONS(2710),
    [anon_sym_PIPE_PIPE] = ACTIONS(2710),
    [sym__special_characters] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(2710),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [sym_raw_string] = ACTIONS(2710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2710),
    [anon_sym_BQUOTE] = ACTIONS(2710),
    [anon_sym_LT_LPAREN] = ACTIONS(2710),
    [anon_sym_GT_LPAREN] = ACTIONS(2710),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2712),
    [sym_word] = ACTIONS(2712),
  },
  [1743] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4877),
    [sym_comment] = ACTIONS(53),
  },
  [1744] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4879),
    [sym_comment] = ACTIONS(53),
  },
  [1745] = {
    [anon_sym_RBRACE] = ACTIONS(4879),
    [sym_comment] = ACTIONS(53),
  },
  [1746] = {
    [sym_concatenation] = STATE(2081),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2081),
    [anon_sym_RBRACE] = ACTIONS(4881),
    [anon_sym_EQ] = ACTIONS(4883),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4883),
    [anon_sym_COLON_QMARK] = ACTIONS(4883),
    [anon_sym_COLON_DASH] = ACTIONS(4883),
    [anon_sym_PERCENT] = ACTIONS(4883),
    [anon_sym_DASH] = ACTIONS(4883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1747] = {
    [sym__concat] = ACTIONS(2788),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_RPAREN] = ACTIONS(2788),
    [anon_sym_PIPE_AMP] = ACTIONS(2788),
    [anon_sym_AMP_AMP] = ACTIONS(2788),
    [anon_sym_PIPE_PIPE] = ACTIONS(2788),
    [sym__special_characters] = ACTIONS(2788),
    [anon_sym_DQUOTE] = ACTIONS(2788),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym_raw_string] = ACTIONS(2788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2788),
    [anon_sym_BQUOTE] = ACTIONS(2788),
    [anon_sym_LT_LPAREN] = ACTIONS(2788),
    [anon_sym_GT_LPAREN] = ACTIONS(2788),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2790),
    [sym_word] = ACTIONS(2790),
  },
  [1748] = {
    [sym_concatenation] = STATE(2084),
    [sym_string] = STATE(2083),
    [sym_simple_expansion] = STATE(2083),
    [sym_string_expansion] = STATE(2083),
    [sym_expansion] = STATE(2083),
    [sym_command_substitution] = STATE(2083),
    [sym_process_substitution] = STATE(2083),
    [anon_sym_RBRACE] = ACTIONS(4879),
    [sym__special_characters] = ACTIONS(4887),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(4889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4889),
  },
  [1749] = {
    [sym__concat] = ACTIONS(2831),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2831),
    [anon_sym_PIPE_AMP] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [sym__special_characters] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [sym_raw_string] = ACTIONS(2831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2831),
    [anon_sym_BQUOTE] = ACTIONS(2831),
    [anon_sym_LT_LPAREN] = ACTIONS(2831),
    [anon_sym_GT_LPAREN] = ACTIONS(2831),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2833),
    [sym_word] = ACTIONS(2833),
  },
  [1750] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4891),
  },
  [1751] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4893),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1752] = {
    [sym__concat] = ACTIONS(2839),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_RPAREN] = ACTIONS(2839),
    [anon_sym_PIPE_AMP] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [sym__special_characters] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_DOLLAR] = ACTIONS(2841),
    [sym_raw_string] = ACTIONS(2839),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2839),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2839),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_LT_LPAREN] = ACTIONS(2839),
    [anon_sym_GT_LPAREN] = ACTIONS(2839),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2841),
    [sym_word] = ACTIONS(2841),
  },
  [1753] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4895),
  },
  [1754] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4897),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1755] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4899),
  },
  [1756] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4879),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1757] = {
    [sym_concatenation] = STATE(2091),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2091),
    [anon_sym_RBRACE] = ACTIONS(4901),
    [anon_sym_EQ] = ACTIONS(4903),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4903),
    [anon_sym_COLON_QMARK] = ACTIONS(4903),
    [anon_sym_COLON_DASH] = ACTIONS(4903),
    [anon_sym_PERCENT] = ACTIONS(4903),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1758] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2857),
    [sym_word] = ACTIONS(2857),
  },
  [1759] = {
    [sym_concatenation] = STATE(2093),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2093),
    [anon_sym_RBRACE] = ACTIONS(4907),
    [anon_sym_EQ] = ACTIONS(4909),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4909),
    [anon_sym_COLON_QMARK] = ACTIONS(4909),
    [anon_sym_COLON_DASH] = ACTIONS(4909),
    [anon_sym_PERCENT] = ACTIONS(4909),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1760] = {
    [sym__simple_heredoc_body] = ACTIONS(3829),
    [sym__heredoc_body_beginning] = ACTIONS(3829),
    [sym_file_descriptor] = ACTIONS(3829),
    [sym__concat] = ACTIONS(3829),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_RPAREN] = ACTIONS(3829),
    [anon_sym_PIPE_AMP] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_EQ_TILDE] = ACTIONS(3831),
    [anon_sym_EQ_EQ] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_GT] = ACTIONS(3831),
    [anon_sym_GT_GT] = ACTIONS(3829),
    [anon_sym_AMP_GT] = ACTIONS(3831),
    [anon_sym_AMP_GT_GT] = ACTIONS(3829),
    [anon_sym_LT_AMP] = ACTIONS(3829),
    [anon_sym_GT_AMP] = ACTIONS(3829),
    [anon_sym_LT_LT] = ACTIONS(3831),
    [anon_sym_LT_LT_DASH] = ACTIONS(3829),
    [anon_sym_LT_LT_LT] = ACTIONS(3829),
    [sym__special_characters] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [sym_raw_string] = ACTIONS(3829),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3829),
    [anon_sym_BQUOTE] = ACTIONS(3829),
    [anon_sym_LT_LPAREN] = ACTIONS(3829),
    [anon_sym_GT_LPAREN] = ACTIONS(3829),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3831),
  },
  [1761] = {
    [sym__simple_heredoc_body] = ACTIONS(3835),
    [sym__heredoc_body_beginning] = ACTIONS(3835),
    [sym_file_descriptor] = ACTIONS(3835),
    [sym__concat] = ACTIONS(3835),
    [anon_sym_PIPE] = ACTIONS(3837),
    [anon_sym_RPAREN] = ACTIONS(3835),
    [anon_sym_PIPE_AMP] = ACTIONS(3835),
    [anon_sym_AMP_AMP] = ACTIONS(3835),
    [anon_sym_PIPE_PIPE] = ACTIONS(3835),
    [anon_sym_EQ_TILDE] = ACTIONS(3837),
    [anon_sym_EQ_EQ] = ACTIONS(3837),
    [anon_sym_LT] = ACTIONS(3837),
    [anon_sym_GT] = ACTIONS(3837),
    [anon_sym_GT_GT] = ACTIONS(3835),
    [anon_sym_AMP_GT] = ACTIONS(3837),
    [anon_sym_AMP_GT_GT] = ACTIONS(3835),
    [anon_sym_LT_AMP] = ACTIONS(3835),
    [anon_sym_GT_AMP] = ACTIONS(3835),
    [anon_sym_LT_LT] = ACTIONS(3837),
    [anon_sym_LT_LT_DASH] = ACTIONS(3835),
    [anon_sym_LT_LT_LT] = ACTIONS(3835),
    [sym__special_characters] = ACTIONS(3835),
    [anon_sym_DQUOTE] = ACTIONS(3835),
    [anon_sym_DOLLAR] = ACTIONS(3837),
    [sym_raw_string] = ACTIONS(3835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3835),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3835),
    [anon_sym_BQUOTE] = ACTIONS(3835),
    [anon_sym_LT_LPAREN] = ACTIONS(3835),
    [anon_sym_GT_LPAREN] = ACTIONS(3835),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3837),
  },
  [1762] = {
    [sym__simple_heredoc_body] = ACTIONS(3920),
    [sym__heredoc_body_beginning] = ACTIONS(3920),
    [sym_file_descriptor] = ACTIONS(3920),
    [sym__concat] = ACTIONS(3920),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_RPAREN] = ACTIONS(3920),
    [anon_sym_PIPE_AMP] = ACTIONS(3920),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3920),
    [anon_sym_EQ_TILDE] = ACTIONS(3922),
    [anon_sym_EQ_EQ] = ACTIONS(3922),
    [anon_sym_LT] = ACTIONS(3922),
    [anon_sym_GT] = ACTIONS(3922),
    [anon_sym_GT_GT] = ACTIONS(3920),
    [anon_sym_AMP_GT] = ACTIONS(3922),
    [anon_sym_AMP_GT_GT] = ACTIONS(3920),
    [anon_sym_LT_AMP] = ACTIONS(3920),
    [anon_sym_GT_AMP] = ACTIONS(3920),
    [anon_sym_LT_LT] = ACTIONS(3922),
    [anon_sym_LT_LT_DASH] = ACTIONS(3920),
    [anon_sym_LT_LT_LT] = ACTIONS(3920),
    [sym__special_characters] = ACTIONS(3920),
    [anon_sym_DQUOTE] = ACTIONS(3920),
    [anon_sym_DOLLAR] = ACTIONS(3922),
    [sym_raw_string] = ACTIONS(3920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3920),
    [anon_sym_BQUOTE] = ACTIONS(3920),
    [anon_sym_LT_LPAREN] = ACTIONS(3920),
    [anon_sym_GT_LPAREN] = ACTIONS(3920),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3922),
  },
  [1763] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4913),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1764] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4915),
    [sym_comment] = ACTIONS(53),
  },
  [1765] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4917),
    [sym_comment] = ACTIONS(53),
  },
  [1766] = {
    [anon_sym_RBRACE] = ACTIONS(4917),
    [sym_comment] = ACTIONS(53),
  },
  [1767] = {
    [sym_concatenation] = STATE(2098),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2098),
    [anon_sym_RBRACE] = ACTIONS(4919),
    [anon_sym_EQ] = ACTIONS(4921),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4923),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4921),
    [anon_sym_COLON_QMARK] = ACTIONS(4921),
    [anon_sym_COLON_DASH] = ACTIONS(4921),
    [anon_sym_PERCENT] = ACTIONS(4921),
    [anon_sym_DASH] = ACTIONS(4921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1768] = {
    [sym__simple_heredoc_body] = ACTIONS(3936),
    [sym__heredoc_body_beginning] = ACTIONS(3936),
    [sym_file_descriptor] = ACTIONS(3936),
    [sym__concat] = ACTIONS(3936),
    [anon_sym_PIPE] = ACTIONS(3938),
    [anon_sym_RPAREN] = ACTIONS(3936),
    [anon_sym_PIPE_AMP] = ACTIONS(3936),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3936),
    [anon_sym_EQ_TILDE] = ACTIONS(3938),
    [anon_sym_EQ_EQ] = ACTIONS(3938),
    [anon_sym_LT] = ACTIONS(3938),
    [anon_sym_GT] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3936),
    [anon_sym_AMP_GT] = ACTIONS(3938),
    [anon_sym_AMP_GT_GT] = ACTIONS(3936),
    [anon_sym_LT_AMP] = ACTIONS(3936),
    [anon_sym_GT_AMP] = ACTIONS(3936),
    [anon_sym_LT_LT] = ACTIONS(3938),
    [anon_sym_LT_LT_DASH] = ACTIONS(3936),
    [anon_sym_LT_LT_LT] = ACTIONS(3936),
    [sym__special_characters] = ACTIONS(3936),
    [anon_sym_DQUOTE] = ACTIONS(3936),
    [anon_sym_DOLLAR] = ACTIONS(3938),
    [sym_raw_string] = ACTIONS(3936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3936),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3936),
    [anon_sym_BQUOTE] = ACTIONS(3936),
    [anon_sym_LT_LPAREN] = ACTIONS(3936),
    [anon_sym_GT_LPAREN] = ACTIONS(3936),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3938),
  },
  [1769] = {
    [sym_concatenation] = STATE(2100),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2100),
    [anon_sym_RBRACE] = ACTIONS(4925),
    [anon_sym_EQ] = ACTIONS(4927),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4927),
    [anon_sym_COLON_QMARK] = ACTIONS(4927),
    [anon_sym_COLON_DASH] = ACTIONS(4927),
    [anon_sym_PERCENT] = ACTIONS(4927),
    [anon_sym_DASH] = ACTIONS(4927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1770] = {
    [sym__simple_heredoc_body] = ACTIONS(3946),
    [sym__heredoc_body_beginning] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_EQ_TILDE] = ACTIONS(3948),
    [anon_sym_EQ_EQ] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3948),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3948),
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3948),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [sym__special_characters] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3948),
  },
  [1771] = {
    [sym_concatenation] = STATE(2102),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2102),
    [anon_sym_RBRACE] = ACTIONS(4931),
    [anon_sym_EQ] = ACTIONS(4933),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4935),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_DASH] = ACTIONS(4933),
    [anon_sym_PERCENT] = ACTIONS(4933),
    [anon_sym_DASH] = ACTIONS(4933),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1772] = {
    [sym__simple_heredoc_body] = ACTIONS(3956),
    [sym__heredoc_body_beginning] = ACTIONS(3956),
    [sym_file_descriptor] = ACTIONS(3956),
    [sym__concat] = ACTIONS(3956),
    [anon_sym_PIPE] = ACTIONS(3958),
    [anon_sym_RPAREN] = ACTIONS(3956),
    [anon_sym_PIPE_AMP] = ACTIONS(3956),
    [anon_sym_AMP_AMP] = ACTIONS(3956),
    [anon_sym_PIPE_PIPE] = ACTIONS(3956),
    [anon_sym_EQ_TILDE] = ACTIONS(3958),
    [anon_sym_EQ_EQ] = ACTIONS(3958),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_GT] = ACTIONS(3956),
    [anon_sym_AMP_GT] = ACTIONS(3958),
    [anon_sym_AMP_GT_GT] = ACTIONS(3956),
    [anon_sym_LT_AMP] = ACTIONS(3956),
    [anon_sym_GT_AMP] = ACTIONS(3956),
    [anon_sym_LT_LT] = ACTIONS(3958),
    [anon_sym_LT_LT_DASH] = ACTIONS(3956),
    [anon_sym_LT_LT_LT] = ACTIONS(3956),
    [sym__special_characters] = ACTIONS(3956),
    [anon_sym_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [sym_raw_string] = ACTIONS(3956),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3956),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3956),
    [anon_sym_BQUOTE] = ACTIONS(3956),
    [anon_sym_LT_LPAREN] = ACTIONS(3956),
    [anon_sym_GT_LPAREN] = ACTIONS(3956),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3958),
  },
  [1773] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4937),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1774] = {
    [sym__simple_heredoc_body] = ACTIONS(3962),
    [sym__heredoc_body_beginning] = ACTIONS(3962),
    [sym_file_descriptor] = ACTIONS(3962),
    [sym__concat] = ACTIONS(3962),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_RPAREN] = ACTIONS(3962),
    [anon_sym_PIPE_AMP] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_EQ_TILDE] = ACTIONS(3964),
    [anon_sym_EQ_EQ] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_GT] = ACTIONS(3964),
    [anon_sym_GT_GT] = ACTIONS(3962),
    [anon_sym_AMP_GT] = ACTIONS(3964),
    [anon_sym_AMP_GT_GT] = ACTIONS(3962),
    [anon_sym_LT_AMP] = ACTIONS(3962),
    [anon_sym_GT_AMP] = ACTIONS(3962),
    [anon_sym_LT_LT] = ACTIONS(3964),
    [anon_sym_LT_LT_DASH] = ACTIONS(3962),
    [anon_sym_LT_LT_LT] = ACTIONS(3962),
    [sym__special_characters] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_DOLLAR] = ACTIONS(3964),
    [sym_raw_string] = ACTIONS(3962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3962),
    [anon_sym_BQUOTE] = ACTIONS(3962),
    [anon_sym_LT_LPAREN] = ACTIONS(3962),
    [anon_sym_GT_LPAREN] = ACTIONS(3962),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3964),
  },
  [1775] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4939),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1776] = {
    [anon_sym_PIPE] = ACTIONS(3521),
    [anon_sym_RPAREN] = ACTIONS(3523),
    [anon_sym_PIPE_AMP] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BQUOTE] = ACTIONS(3523),
    [sym_comment] = ACTIONS(53),
  },
  [1777] = {
    [aux_sym_concatenation_repeat1] = STATE(1777),
    [sym__simple_heredoc_body] = ACTIONS(1642),
    [sym__heredoc_body_beginning] = ACTIONS(1642),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(3068),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1642),
    [anon_sym_LT_LT_LT] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
  },
  [1778] = {
    [anon_sym_PIPE] = ACTIONS(4214),
    [anon_sym_RPAREN] = ACTIONS(4216),
    [anon_sym_PIPE_AMP] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BQUOTE] = ACTIONS(4216),
    [sym_comment] = ACTIONS(53),
  },
  [1779] = {
    [aux_sym_concatenation_repeat1] = STATE(1779),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(2613),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [anon_sym_LT_LPAREN] = ACTIONS(1642),
    [anon_sym_GT_LPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1642),
  },
  [1780] = {
    [sym_file_redirect] = STATE(2035),
    [sym_file_descriptor] = ACTIONS(3167),
    [anon_sym_PIPE] = ACTIONS(3521),
    [anon_sym_PIPE_AMP] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_LT] = ACTIONS(3169),
    [anon_sym_GT] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3171),
    [anon_sym_AMP_GT] = ACTIONS(3169),
    [anon_sym_AMP_GT_GT] = ACTIONS(3171),
    [anon_sym_LT_AMP] = ACTIONS(3171),
    [anon_sym_GT_AMP] = ACTIONS(3171),
    [anon_sym_BQUOTE] = ACTIONS(3523),
    [sym_comment] = ACTIONS(53),
  },
  [1781] = {
    [sym_concatenation] = STATE(2038),
    [sym_string] = STATE(2106),
    [sym_simple_expansion] = STATE(2106),
    [sym_string_expansion] = STATE(2106),
    [sym_expansion] = STATE(2106),
    [sym_command_substitution] = STATE(2106),
    [sym_process_substitution] = STATE(2106),
    [sym__special_characters] = ACTIONS(4941),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(4943),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4943),
  },
  [1782] = {
    [aux_sym_concatenation_repeat1] = STATE(2107),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_BQUOTE] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
  },
  [1783] = {
    [aux_sym_concatenation_repeat1] = STATE(2107),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [1784] = {
    [sym_concatenation] = STATE(2042),
    [sym_string] = STATE(2109),
    [sym_simple_expansion] = STATE(2109),
    [sym_string_expansion] = STATE(2109),
    [sym_expansion] = STATE(2109),
    [sym_command_substitution] = STATE(2109),
    [sym_process_substitution] = STATE(2109),
    [sym__special_characters] = ACTIONS(4945),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4012),
    [sym_raw_string] = ACTIONS(4947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4020),
    [anon_sym_LT_LPAREN] = ACTIONS(4022),
    [anon_sym_GT_LPAREN] = ACTIONS(4022),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4947),
  },
  [1785] = {
    [aux_sym_concatenation_repeat1] = STATE(2110),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(4799),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [anon_sym_BQUOTE] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
  },
  [1786] = {
    [aux_sym_concatenation_repeat1] = STATE(2110),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(4799),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [anon_sym_LT_LT_LT] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [1787] = {
    [aux_sym_concatenation_repeat1] = STATE(2110),
    [sym_file_descriptor] = ACTIONS(2058),
    [sym__concat] = ACTIONS(4799),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_PIPE_AMP] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_PIPE_PIPE] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2058),
    [anon_sym_LT_AMP] = ACTIONS(2058),
    [anon_sym_GT_AMP] = ACTIONS(2058),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2058),
    [anon_sym_LT_LT_LT] = ACTIONS(2058),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(53),
  },
  [1788] = {
    [aux_sym_concatenation_repeat1] = STATE(2110),
    [sym_file_descriptor] = ACTIONS(2062),
    [sym__concat] = ACTIONS(4799),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_PIPE_PIPE] = ACTIONS(2062),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2062),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2062),
    [anon_sym_LT_AMP] = ACTIONS(2062),
    [anon_sym_GT_AMP] = ACTIONS(2062),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2062),
    [anon_sym_LT_LT_LT] = ACTIONS(2062),
    [anon_sym_BQUOTE] = ACTIONS(2062),
    [sym_comment] = ACTIONS(53),
  },
  [1789] = {
    [sym_file_redirect] = STATE(1789),
    [sym_heredoc_redirect] = STATE(1789),
    [sym_herestring_redirect] = STATE(1789),
    [aux_sym_while_statement_repeat1] = STATE(1789),
    [sym_file_descriptor] = ACTIONS(4949),
    [anon_sym_PIPE] = ACTIONS(2075),
    [anon_sym_PIPE_AMP] = ACTIONS(2070),
    [anon_sym_AMP_AMP] = ACTIONS(2070),
    [anon_sym_PIPE_PIPE] = ACTIONS(2070),
    [anon_sym_LT] = ACTIONS(4952),
    [anon_sym_GT] = ACTIONS(4952),
    [anon_sym_GT_GT] = ACTIONS(4955),
    [anon_sym_AMP_GT] = ACTIONS(4952),
    [anon_sym_AMP_GT_GT] = ACTIONS(4955),
    [anon_sym_LT_AMP] = ACTIONS(4955),
    [anon_sym_GT_AMP] = ACTIONS(4955),
    [anon_sym_LT_LT] = ACTIONS(4830),
    [anon_sym_LT_LT_DASH] = ACTIONS(4833),
    [anon_sym_LT_LT_LT] = ACTIONS(4958),
    [anon_sym_BQUOTE] = ACTIONS(2070),
    [sym_comment] = ACTIONS(53),
  },
  [1790] = {
    [aux_sym_concatenation_repeat1] = STATE(1790),
    [sym__simple_heredoc_body] = ACTIONS(1642),
    [sym__heredoc_body_beginning] = ACTIONS(1642),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(3068),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1642),
    [anon_sym_LT_LT_LT] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
  },
  [1791] = {
    [sym__heredoc_body_middle] = ACTIONS(2710),
    [sym__heredoc_body_end] = ACTIONS(2710),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2710),
    [sym_comment] = ACTIONS(53),
  },
  [1792] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4961),
    [sym_comment] = ACTIONS(53),
  },
  [1793] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4963),
    [sym_comment] = ACTIONS(53),
  },
  [1794] = {
    [anon_sym_RBRACE] = ACTIONS(4963),
    [sym_comment] = ACTIONS(53),
  },
  [1795] = {
    [sym_concatenation] = STATE(2114),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2114),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_EQ] = ACTIONS(4967),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4969),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4967),
    [anon_sym_COLON_QMARK] = ACTIONS(4967),
    [anon_sym_COLON_DASH] = ACTIONS(4967),
    [anon_sym_PERCENT] = ACTIONS(4967),
    [anon_sym_DASH] = ACTIONS(4967),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1796] = {
    [sym__heredoc_body_middle] = ACTIONS(2788),
    [sym__heredoc_body_end] = ACTIONS(2788),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2788),
    [sym_comment] = ACTIONS(53),
  },
  [1797] = {
    [sym_concatenation] = STATE(2117),
    [sym_string] = STATE(2116),
    [sym_simple_expansion] = STATE(2116),
    [sym_string_expansion] = STATE(2116),
    [sym_expansion] = STATE(2116),
    [sym_command_substitution] = STATE(2116),
    [sym_process_substitution] = STATE(2116),
    [anon_sym_RBRACE] = ACTIONS(4963),
    [sym__special_characters] = ACTIONS(4971),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(4973),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4973),
  },
  [1798] = {
    [sym__heredoc_body_middle] = ACTIONS(2831),
    [sym__heredoc_body_end] = ACTIONS(2831),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2831),
    [sym_comment] = ACTIONS(53),
  },
  [1799] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4975),
  },
  [1800] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4977),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1801] = {
    [sym__heredoc_body_middle] = ACTIONS(2839),
    [sym__heredoc_body_end] = ACTIONS(2839),
    [anon_sym_DOLLAR] = ACTIONS(2841),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2839),
    [sym_comment] = ACTIONS(53),
  },
  [1802] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4979),
  },
  [1803] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4981),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1804] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4983),
  },
  [1805] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4963),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1806] = {
    [sym_concatenation] = STATE(2124),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2124),
    [anon_sym_RBRACE] = ACTIONS(4985),
    [anon_sym_EQ] = ACTIONS(4987),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4987),
    [anon_sym_COLON_QMARK] = ACTIONS(4987),
    [anon_sym_COLON_DASH] = ACTIONS(4987),
    [anon_sym_PERCENT] = ACTIONS(4987),
    [anon_sym_DASH] = ACTIONS(4987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1807] = {
    [sym__heredoc_body_middle] = ACTIONS(2855),
    [sym__heredoc_body_end] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
  },
  [1808] = {
    [sym_concatenation] = STATE(2126),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2126),
    [anon_sym_RBRACE] = ACTIONS(4991),
    [anon_sym_EQ] = ACTIONS(4993),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4993),
    [anon_sym_COLON_QMARK] = ACTIONS(4993),
    [anon_sym_COLON_DASH] = ACTIONS(4993),
    [anon_sym_PERCENT] = ACTIONS(4993),
    [anon_sym_DASH] = ACTIONS(4993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1809] = {
    [sym__concat] = ACTIONS(2710),
    [anon_sym_RPAREN] = ACTIONS(2710),
    [sym__special_characters] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(2710),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [sym_raw_string] = ACTIONS(2710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2710),
    [anon_sym_BQUOTE] = ACTIONS(2710),
    [anon_sym_LT_LPAREN] = ACTIONS(2710),
    [anon_sym_GT_LPAREN] = ACTIONS(2710),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2710),
  },
  [1810] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4997),
    [sym_comment] = ACTIONS(53),
  },
  [1811] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(4999),
    [sym_comment] = ACTIONS(53),
  },
  [1812] = {
    [anon_sym_RBRACE] = ACTIONS(4999),
    [sym_comment] = ACTIONS(53),
  },
  [1813] = {
    [sym_concatenation] = STATE(2130),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2130),
    [anon_sym_RBRACE] = ACTIONS(5001),
    [anon_sym_EQ] = ACTIONS(5003),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5005),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5003),
    [anon_sym_COLON_QMARK] = ACTIONS(5003),
    [anon_sym_COLON_DASH] = ACTIONS(5003),
    [anon_sym_PERCENT] = ACTIONS(5003),
    [anon_sym_DASH] = ACTIONS(5003),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1814] = {
    [sym__concat] = ACTIONS(2788),
    [anon_sym_RPAREN] = ACTIONS(2788),
    [sym__special_characters] = ACTIONS(2788),
    [anon_sym_DQUOTE] = ACTIONS(2788),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym_raw_string] = ACTIONS(2788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2788),
    [anon_sym_BQUOTE] = ACTIONS(2788),
    [anon_sym_LT_LPAREN] = ACTIONS(2788),
    [anon_sym_GT_LPAREN] = ACTIONS(2788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2788),
  },
  [1815] = {
    [sym_concatenation] = STATE(2133),
    [sym_string] = STATE(2132),
    [sym_simple_expansion] = STATE(2132),
    [sym_string_expansion] = STATE(2132),
    [sym_expansion] = STATE(2132),
    [sym_command_substitution] = STATE(2132),
    [sym_process_substitution] = STATE(2132),
    [anon_sym_RBRACE] = ACTIONS(4999),
    [sym__special_characters] = ACTIONS(5007),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(5009),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5009),
  },
  [1816] = {
    [sym__concat] = ACTIONS(2831),
    [anon_sym_RPAREN] = ACTIONS(2831),
    [sym__special_characters] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [sym_raw_string] = ACTIONS(2831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2831),
    [anon_sym_BQUOTE] = ACTIONS(2831),
    [anon_sym_LT_LPAREN] = ACTIONS(2831),
    [anon_sym_GT_LPAREN] = ACTIONS(2831),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2831),
  },
  [1817] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5011),
  },
  [1818] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5013),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1819] = {
    [sym__concat] = ACTIONS(2839),
    [anon_sym_RPAREN] = ACTIONS(2839),
    [sym__special_characters] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_DOLLAR] = ACTIONS(2841),
    [sym_raw_string] = ACTIONS(2839),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2839),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2839),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_LT_LPAREN] = ACTIONS(2839),
    [anon_sym_GT_LPAREN] = ACTIONS(2839),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2839),
  },
  [1820] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5015),
  },
  [1821] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5017),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1822] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5019),
  },
  [1823] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(4999),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1824] = {
    [sym_concatenation] = STATE(2140),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2140),
    [anon_sym_RBRACE] = ACTIONS(5021),
    [anon_sym_EQ] = ACTIONS(5023),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5025),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5023),
    [anon_sym_COLON_QMARK] = ACTIONS(5023),
    [anon_sym_COLON_DASH] = ACTIONS(5023),
    [anon_sym_PERCENT] = ACTIONS(5023),
    [anon_sym_DASH] = ACTIONS(5023),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1825] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [sym__special_characters] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2855),
  },
  [1826] = {
    [sym_concatenation] = STATE(2142),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2142),
    [anon_sym_RBRACE] = ACTIONS(5027),
    [anon_sym_EQ] = ACTIONS(5029),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5031),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5029),
    [anon_sym_COLON_QMARK] = ACTIONS(5029),
    [anon_sym_COLON_DASH] = ACTIONS(5029),
    [anon_sym_PERCENT] = ACTIONS(5029),
    [anon_sym_DASH] = ACTIONS(5029),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1827] = {
    [sym_file_descriptor] = ACTIONS(3829),
    [sym__concat] = ACTIONS(3829),
    [sym_variable_name] = ACTIONS(3829),
    [anon_sym_esac] = ACTIONS(3831),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_RPAREN] = ACTIONS(3831),
    [anon_sym_SEMI_SEMI] = ACTIONS(3831),
    [anon_sym_PIPE_AMP] = ACTIONS(3831),
    [anon_sym_AMP_AMP] = ACTIONS(3831),
    [anon_sym_PIPE_PIPE] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_GT] = ACTIONS(3831),
    [anon_sym_GT_GT] = ACTIONS(3831),
    [anon_sym_AMP_GT] = ACTIONS(3831),
    [anon_sym_AMP_GT_GT] = ACTIONS(3831),
    [anon_sym_LT_AMP] = ACTIONS(3831),
    [anon_sym_GT_AMP] = ACTIONS(3831),
    [sym__special_characters] = ACTIONS(3831),
    [anon_sym_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [sym_raw_string] = ACTIONS(3831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3831),
    [anon_sym_BQUOTE] = ACTIONS(3831),
    [anon_sym_LT_LPAREN] = ACTIONS(3831),
    [anon_sym_GT_LPAREN] = ACTIONS(3831),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3831),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_LF] = ACTIONS(3829),
    [anon_sym_AMP] = ACTIONS(3831),
  },
  [1828] = {
    [sym_file_descriptor] = ACTIONS(3835),
    [sym__concat] = ACTIONS(3835),
    [sym_variable_name] = ACTIONS(3835),
    [anon_sym_esac] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3837),
    [anon_sym_RPAREN] = ACTIONS(3837),
    [anon_sym_SEMI_SEMI] = ACTIONS(3837),
    [anon_sym_PIPE_AMP] = ACTIONS(3837),
    [anon_sym_AMP_AMP] = ACTIONS(3837),
    [anon_sym_PIPE_PIPE] = ACTIONS(3837),
    [anon_sym_LT] = ACTIONS(3837),
    [anon_sym_GT] = ACTIONS(3837),
    [anon_sym_GT_GT] = ACTIONS(3837),
    [anon_sym_AMP_GT] = ACTIONS(3837),
    [anon_sym_AMP_GT_GT] = ACTIONS(3837),
    [anon_sym_LT_AMP] = ACTIONS(3837),
    [anon_sym_GT_AMP] = ACTIONS(3837),
    [sym__special_characters] = ACTIONS(3837),
    [anon_sym_DQUOTE] = ACTIONS(3837),
    [anon_sym_DOLLAR] = ACTIONS(3837),
    [sym_raw_string] = ACTIONS(3837),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3837),
    [anon_sym_BQUOTE] = ACTIONS(3837),
    [anon_sym_LT_LPAREN] = ACTIONS(3837),
    [anon_sym_GT_LPAREN] = ACTIONS(3837),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3837),
    [anon_sym_SEMI] = ACTIONS(3837),
    [anon_sym_LF] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
  },
  [1829] = {
    [sym_file_descriptor] = ACTIONS(3920),
    [sym__concat] = ACTIONS(3920),
    [sym_variable_name] = ACTIONS(3920),
    [anon_sym_esac] = ACTIONS(3922),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_RPAREN] = ACTIONS(3922),
    [anon_sym_SEMI_SEMI] = ACTIONS(3922),
    [anon_sym_PIPE_AMP] = ACTIONS(3922),
    [anon_sym_AMP_AMP] = ACTIONS(3922),
    [anon_sym_PIPE_PIPE] = ACTIONS(3922),
    [anon_sym_LT] = ACTIONS(3922),
    [anon_sym_GT] = ACTIONS(3922),
    [anon_sym_GT_GT] = ACTIONS(3922),
    [anon_sym_AMP_GT] = ACTIONS(3922),
    [anon_sym_AMP_GT_GT] = ACTIONS(3922),
    [anon_sym_LT_AMP] = ACTIONS(3922),
    [anon_sym_GT_AMP] = ACTIONS(3922),
    [sym__special_characters] = ACTIONS(3922),
    [anon_sym_DQUOTE] = ACTIONS(3922),
    [anon_sym_DOLLAR] = ACTIONS(3922),
    [sym_raw_string] = ACTIONS(3922),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3922),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3922),
    [anon_sym_BQUOTE] = ACTIONS(3922),
    [anon_sym_LT_LPAREN] = ACTIONS(3922),
    [anon_sym_GT_LPAREN] = ACTIONS(3922),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3922),
    [anon_sym_SEMI] = ACTIONS(3922),
    [anon_sym_LF] = ACTIONS(3920),
    [anon_sym_AMP] = ACTIONS(3922),
  },
  [1830] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5033),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1831] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5035),
    [sym_comment] = ACTIONS(53),
  },
  [1832] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5037),
    [sym_comment] = ACTIONS(53),
  },
  [1833] = {
    [anon_sym_RBRACE] = ACTIONS(5037),
    [sym_comment] = ACTIONS(53),
  },
  [1834] = {
    [sym_concatenation] = STATE(2147),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2147),
    [anon_sym_RBRACE] = ACTIONS(5039),
    [anon_sym_EQ] = ACTIONS(5041),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5041),
    [anon_sym_COLON_QMARK] = ACTIONS(5041),
    [anon_sym_COLON_DASH] = ACTIONS(5041),
    [anon_sym_PERCENT] = ACTIONS(5041),
    [anon_sym_DASH] = ACTIONS(5041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1835] = {
    [sym_file_descriptor] = ACTIONS(3936),
    [sym__concat] = ACTIONS(3936),
    [sym_variable_name] = ACTIONS(3936),
    [anon_sym_esac] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3938),
    [anon_sym_RPAREN] = ACTIONS(3938),
    [anon_sym_SEMI_SEMI] = ACTIONS(3938),
    [anon_sym_PIPE_AMP] = ACTIONS(3938),
    [anon_sym_AMP_AMP] = ACTIONS(3938),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_LT] = ACTIONS(3938),
    [anon_sym_GT] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3938),
    [anon_sym_AMP_GT] = ACTIONS(3938),
    [anon_sym_AMP_GT_GT] = ACTIONS(3938),
    [anon_sym_LT_AMP] = ACTIONS(3938),
    [anon_sym_GT_AMP] = ACTIONS(3938),
    [sym__special_characters] = ACTIONS(3938),
    [anon_sym_DQUOTE] = ACTIONS(3938),
    [anon_sym_DOLLAR] = ACTIONS(3938),
    [sym_raw_string] = ACTIONS(3938),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3938),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3938),
    [anon_sym_BQUOTE] = ACTIONS(3938),
    [anon_sym_LT_LPAREN] = ACTIONS(3938),
    [anon_sym_GT_LPAREN] = ACTIONS(3938),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3938),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_LF] = ACTIONS(3936),
    [anon_sym_AMP] = ACTIONS(3938),
  },
  [1836] = {
    [sym_concatenation] = STATE(2149),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2149),
    [anon_sym_RBRACE] = ACTIONS(5045),
    [anon_sym_EQ] = ACTIONS(5047),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5047),
    [anon_sym_COLON_QMARK] = ACTIONS(5047),
    [anon_sym_COLON_DASH] = ACTIONS(5047),
    [anon_sym_PERCENT] = ACTIONS(5047),
    [anon_sym_DASH] = ACTIONS(5047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1837] = {
    [sym_file_descriptor] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3946),
    [anon_sym_esac] = ACTIONS(3948),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3948),
    [anon_sym_SEMI_SEMI] = ACTIONS(3948),
    [anon_sym_PIPE_AMP] = ACTIONS(3948),
    [anon_sym_AMP_AMP] = ACTIONS(3948),
    [anon_sym_PIPE_PIPE] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3948),
    [anon_sym_GT_GT] = ACTIONS(3948),
    [anon_sym_AMP_GT] = ACTIONS(3948),
    [anon_sym_AMP_GT_GT] = ACTIONS(3948),
    [anon_sym_LT_AMP] = ACTIONS(3948),
    [anon_sym_GT_AMP] = ACTIONS(3948),
    [sym__special_characters] = ACTIONS(3948),
    [anon_sym_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3948),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3948),
    [anon_sym_BQUOTE] = ACTIONS(3948),
    [anon_sym_LT_LPAREN] = ACTIONS(3948),
    [anon_sym_GT_LPAREN] = ACTIONS(3948),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3948),
    [anon_sym_LF] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3948),
  },
  [1838] = {
    [sym_concatenation] = STATE(2151),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2151),
    [anon_sym_RBRACE] = ACTIONS(5051),
    [anon_sym_EQ] = ACTIONS(5053),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5053),
    [anon_sym_COLON_QMARK] = ACTIONS(5053),
    [anon_sym_COLON_DASH] = ACTIONS(5053),
    [anon_sym_PERCENT] = ACTIONS(5053),
    [anon_sym_DASH] = ACTIONS(5053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1839] = {
    [sym_file_descriptor] = ACTIONS(3956),
    [sym__concat] = ACTIONS(3956),
    [sym_variable_name] = ACTIONS(3956),
    [anon_sym_esac] = ACTIONS(3958),
    [anon_sym_PIPE] = ACTIONS(3958),
    [anon_sym_RPAREN] = ACTIONS(3958),
    [anon_sym_SEMI_SEMI] = ACTIONS(3958),
    [anon_sym_PIPE_AMP] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_GT] = ACTIONS(3958),
    [anon_sym_AMP_GT] = ACTIONS(3958),
    [anon_sym_AMP_GT_GT] = ACTIONS(3958),
    [anon_sym_LT_AMP] = ACTIONS(3958),
    [anon_sym_GT_AMP] = ACTIONS(3958),
    [sym__special_characters] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [sym_raw_string] = ACTIONS(3958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3958),
    [anon_sym_BQUOTE] = ACTIONS(3958),
    [anon_sym_LT_LPAREN] = ACTIONS(3958),
    [anon_sym_GT_LPAREN] = ACTIONS(3958),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3958),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_LF] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
  },
  [1840] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5057),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1841] = {
    [sym_file_descriptor] = ACTIONS(3962),
    [sym__concat] = ACTIONS(3962),
    [sym_variable_name] = ACTIONS(3962),
    [anon_sym_esac] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_RPAREN] = ACTIONS(3964),
    [anon_sym_SEMI_SEMI] = ACTIONS(3964),
    [anon_sym_PIPE_AMP] = ACTIONS(3964),
    [anon_sym_AMP_AMP] = ACTIONS(3964),
    [anon_sym_PIPE_PIPE] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_GT] = ACTIONS(3964),
    [anon_sym_GT_GT] = ACTIONS(3964),
    [anon_sym_AMP_GT] = ACTIONS(3964),
    [anon_sym_AMP_GT_GT] = ACTIONS(3964),
    [anon_sym_LT_AMP] = ACTIONS(3964),
    [anon_sym_GT_AMP] = ACTIONS(3964),
    [sym__special_characters] = ACTIONS(3964),
    [anon_sym_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3964),
    [sym_raw_string] = ACTIONS(3964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3964),
    [anon_sym_BQUOTE] = ACTIONS(3964),
    [anon_sym_LT_LPAREN] = ACTIONS(3964),
    [anon_sym_GT_LPAREN] = ACTIONS(3964),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3964),
    [anon_sym_SEMI] = ACTIONS(3964),
    [anon_sym_LF] = ACTIONS(3962),
    [anon_sym_AMP] = ACTIONS(3964),
  },
  [1842] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5059),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1843] = {
    [sym__terminated_statement] = STATE(1041),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1041),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(5061),
    [anon_sym_elif] = ACTIONS(5061),
    [anon_sym_else] = ACTIONS(5061),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1844] = {
    [anon_sym_esac] = ACTIONS(5063),
    [anon_sym_PIPE] = ACTIONS(5063),
    [anon_sym_RPAREN] = ACTIONS(5063),
    [anon_sym_SEMI_SEMI] = ACTIONS(5063),
    [anon_sym_PIPE_AMP] = ACTIONS(5063),
    [anon_sym_AMP_AMP] = ACTIONS(5063),
    [anon_sym_PIPE_PIPE] = ACTIONS(5063),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5063),
    [anon_sym_LF] = ACTIONS(5065),
    [anon_sym_AMP] = ACTIONS(5063),
  },
  [1845] = {
    [aux_sym_concatenation_repeat1] = STATE(1467),
    [sym__concat] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(5067),
    [anon_sym_RPAREN] = ACTIONS(5067),
    [sym_comment] = ACTIONS(53),
  },
  [1846] = {
    [aux_sym_concatenation_repeat1] = STATE(1467),
    [sym__concat] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(5069),
    [anon_sym_RPAREN] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
  },
  [1847] = {
    [anon_sym_PIPE] = ACTIONS(5069),
    [anon_sym_RPAREN] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
  },
  [1848] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(5071),
    [anon_sym_PLUS_EQ] = ACTIONS(5071),
    [sym_comment] = ACTIONS(53),
  },
  [1849] = {
    [sym__terminated_statement] = STATE(2155),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1850] = {
    [anon_sym_esac] = ACTIONS(5073),
    [sym__special_characters] = ACTIONS(5075),
    [anon_sym_DQUOTE] = ACTIONS(5075),
    [anon_sym_DOLLAR] = ACTIONS(5077),
    [sym_raw_string] = ACTIONS(5075),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5075),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5075),
    [anon_sym_BQUOTE] = ACTIONS(5075),
    [anon_sym_LT_LPAREN] = ACTIONS(5075),
    [anon_sym_GT_LPAREN] = ACTIONS(5075),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5077),
  },
  [1851] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5079),
  },
  [1852] = {
    [sym_subshell] = STATE(70),
    [sym_test_command] = STATE(70),
    [sym_command] = STATE(70),
    [sym_command_name] = STATE(1861),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(1858),
    [sym_simple_expansion] = STATE(1858),
    [sym_string_expansion] = STATE(1858),
    [sym_expansion] = STATE(1858),
    [sym_command_substitution] = STATE(1858),
    [sym_process_substitution] = STATE(1858),
    [aux_sym_command_repeat1] = STATE(1865),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4331),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4337),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4339),
  },
  [1853] = {
    [sym__expression] = STATE(2157),
    [sym_binary_expression] = STATE(2157),
    [sym_unary_expression] = STATE(2157),
    [sym_parenthesized_expression] = STATE(2157),
    [sym_concatenation] = STATE(2157),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(131),
  },
  [1854] = {
    [sym__expression] = STATE(2158),
    [sym_binary_expression] = STATE(2158),
    [sym_unary_expression] = STATE(2158),
    [sym_parenthesized_expression] = STATE(2158),
    [sym_concatenation] = STATE(2158),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [1855] = {
    [sym_variable_assignment] = STATE(2170),
    [sym_subscript] = STATE(2169),
    [sym_concatenation] = STATE(2170),
    [sym_string] = STATE(2163),
    [sym_simple_expansion] = STATE(2163),
    [sym_string_expansion] = STATE(2163),
    [sym_expansion] = STATE(2163),
    [sym_command_substitution] = STATE(2163),
    [sym_process_substitution] = STATE(2163),
    [aux_sym_declaration_command_repeat1] = STATE(2170),
    [sym_variable_name] = ACTIONS(5081),
    [anon_sym_esac] = ACTIONS(159),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(159),
    [anon_sym_PIPE_AMP] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(159),
    [anon_sym_PIPE_PIPE] = ACTIONS(159),
    [sym__special_characters] = ACTIONS(5083),
    [anon_sym_DQUOTE] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [sym_raw_string] = ACTIONS(5089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5093),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5097),
    [anon_sym_GT_LPAREN] = ACTIONS(5097),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5099),
    [sym_word] = ACTIONS(5089),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_LF] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(159),
  },
  [1856] = {
    [sym_concatenation] = STATE(2180),
    [sym_string] = STATE(2174),
    [sym_simple_expansion] = STATE(2174),
    [sym_string_expansion] = STATE(2174),
    [sym_expansion] = STATE(2174),
    [sym_command_substitution] = STATE(2174),
    [sym_process_substitution] = STATE(2174),
    [aux_sym_unset_command_repeat1] = STATE(2180),
    [anon_sym_esac] = ACTIONS(183),
    [anon_sym_PIPE] = ACTIONS(183),
    [anon_sym_SEMI_SEMI] = ACTIONS(183),
    [anon_sym_PIPE_AMP] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [sym__special_characters] = ACTIONS(5101),
    [anon_sym_DQUOTE] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [sym_raw_string] = ACTIONS(5107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5111),
    [anon_sym_BQUOTE] = ACTIONS(5113),
    [anon_sym_LT_LPAREN] = ACTIONS(5115),
    [anon_sym_GT_LPAREN] = ACTIONS(5115),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5117),
    [sym_word] = ACTIONS(5107),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_LF] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(183),
  },
  [1857] = {
    [aux_sym_concatenation_repeat1] = STATE(2181),
    [sym__simple_heredoc_body] = ACTIONS(221),
    [sym__heredoc_body_beginning] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [sym__concat] = ACTIONS(223),
    [anon_sym_esac] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(225),
    [anon_sym_SEMI_SEMI] = ACTIONS(225),
    [anon_sym_PIPE_AMP] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_EQ_TILDE] = ACTIONS(225),
    [anon_sym_EQ_EQ] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(225),
    [anon_sym_GT] = ACTIONS(225),
    [anon_sym_GT_GT] = ACTIONS(225),
    [anon_sym_AMP_GT] = ACTIONS(225),
    [anon_sym_AMP_GT_GT] = ACTIONS(225),
    [anon_sym_LT_AMP] = ACTIONS(225),
    [anon_sym_GT_AMP] = ACTIONS(225),
    [anon_sym_LT_LT] = ACTIONS(225),
    [anon_sym_LT_LT_DASH] = ACTIONS(225),
    [anon_sym_LT_LT_LT] = ACTIONS(225),
    [sym__special_characters] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [sym_raw_string] = ACTIONS(225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(225),
    [anon_sym_SEMI] = ACTIONS(225),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_AMP] = ACTIONS(225),
  },
  [1858] = {
    [aux_sym_concatenation_repeat1] = STATE(2181),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(223),
    [anon_sym_esac] = ACTIONS(249),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_SEMI_SEMI] = ACTIONS(249),
    [anon_sym_PIPE_AMP] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(249),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(249),
    [anon_sym_LT_AMP] = ACTIONS(249),
    [anon_sym_GT_AMP] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(249),
    [anon_sym_LT_LT_LT] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(249),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_LT_LPAREN] = ACTIONS(249),
    [anon_sym_GT_LPAREN] = ACTIONS(249),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(249),
  },
  [1859] = {
    [aux_sym_concatenation_repeat1] = STATE(2181),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(223),
    [anon_sym_esac] = ACTIONS(249),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_SEMI_SEMI] = ACTIONS(249),
    [anon_sym_LPAREN] = ACTIONS(5119),
    [anon_sym_PIPE_AMP] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(249),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(249),
    [anon_sym_LT_AMP] = ACTIONS(249),
    [anon_sym_GT_AMP] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(249),
    [anon_sym_LT_LT_LT] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(249),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_LT_LPAREN] = ACTIONS(249),
    [anon_sym_GT_LPAREN] = ACTIONS(249),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(249),
  },
  [1860] = {
    [anon_sym_esac] = ACTIONS(5073),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI_SEMI] = ACTIONS(5123),
    [anon_sym_PIPE_AMP] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [1861] = {
    [sym_file_redirect] = STATE(2192),
    [sym_heredoc_redirect] = STATE(2192),
    [sym_heredoc_body] = STATE(200),
    [sym_herestring_redirect] = STATE(2192),
    [sym_concatenation] = STATE(2193),
    [sym_string] = STATE(2191),
    [sym_simple_expansion] = STATE(2191),
    [sym_string_expansion] = STATE(2191),
    [sym_expansion] = STATE(2191),
    [sym_command_substitution] = STATE(2191),
    [sym_process_substitution] = STATE(2191),
    [aux_sym_while_statement_repeat1] = STATE(2192),
    [aux_sym_command_repeat2] = STATE(2193),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5127),
    [anon_sym_esac] = ACTIONS(343),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_SEMI_SEMI] = ACTIONS(343),
    [anon_sym_PIPE_AMP] = ACTIONS(343),
    [anon_sym_AMP_AMP] = ACTIONS(343),
    [anon_sym_PIPE_PIPE] = ACTIONS(343),
    [anon_sym_EQ_TILDE] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5131),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT_GT] = ACTIONS(5131),
    [anon_sym_LT_AMP] = ACTIONS(5131),
    [anon_sym_GT_AMP] = ACTIONS(5131),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [sym__special_characters] = ACTIONS(5135),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(5137),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5137),
    [anon_sym_SEMI] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(367),
    [anon_sym_AMP] = ACTIONS(343),
  },
  [1862] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(5073),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI_SEMI] = ACTIONS(5123),
    [anon_sym_PIPE_AMP] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [1863] = {
    [anon_sym_EQ] = ACTIONS(5071),
    [anon_sym_PLUS_EQ] = ACTIONS(5071),
    [sym_comment] = ACTIONS(53),
  },
  [1864] = {
    [sym__terminated_statement] = STATE(2197),
    [sym_for_statement] = STATE(2195),
    [sym_while_statement] = STATE(2195),
    [sym_if_statement] = STATE(2195),
    [sym_case_statement] = STATE(2195),
    [sym_function_definition] = STATE(2195),
    [sym_subshell] = STATE(2195),
    [sym_pipeline] = STATE(2195),
    [sym_list] = STATE(2195),
    [sym_negated_command] = STATE(2195),
    [sym_test_command] = STATE(2195),
    [sym_declaration_command] = STATE(2195),
    [sym_unset_command] = STATE(2195),
    [sym_command] = STATE(2195),
    [sym_command_name] = STATE(1861),
    [sym_variable_assignment] = STATE(2196),
    [sym_subscript] = STATE(1863),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(1858),
    [sym_simple_expansion] = STATE(1858),
    [sym_string_expansion] = STATE(1858),
    [sym_expansion] = STATE(1858),
    [sym_command_substitution] = STATE(1858),
    [sym_process_substitution] = STATE(1858),
    [aux_sym_program_repeat1] = STATE(2197),
    [aux_sym_command_repeat1] = STATE(1865),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4317),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4319),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5073),
    [anon_sym_SEMI_SEMI] = ACTIONS(5139),
    [anon_sym_function] = ACTIONS(4325),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4327),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4331),
    [anon_sym_declare] = ACTIONS(4333),
    [anon_sym_typeset] = ACTIONS(4333),
    [anon_sym_export] = ACTIONS(4333),
    [anon_sym_readonly] = ACTIONS(4333),
    [anon_sym_local] = ACTIONS(4333),
    [anon_sym_unset] = ACTIONS(4335),
    [anon_sym_unsetenv] = ACTIONS(4335),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4337),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4341),
  },
  [1865] = {
    [sym_command_name] = STATE(2198),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(1858),
    [sym_simple_expansion] = STATE(1858),
    [sym_string_expansion] = STATE(1858),
    [sym_expansion] = STATE(1858),
    [sym_command_substitution] = STATE(1858),
    [sym_process_substitution] = STATE(1858),
    [aux_sym_command_repeat1] = STATE(205),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(5141),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4339),
  },
  [1866] = {
    [sym__terminated_statement] = STATE(2199),
    [sym_for_statement] = STATE(2195),
    [sym_while_statement] = STATE(2195),
    [sym_if_statement] = STATE(2195),
    [sym_case_statement] = STATE(2195),
    [sym_function_definition] = STATE(2195),
    [sym_subshell] = STATE(2195),
    [sym_pipeline] = STATE(2195),
    [sym_list] = STATE(2195),
    [sym_negated_command] = STATE(2195),
    [sym_test_command] = STATE(2195),
    [sym_declaration_command] = STATE(2195),
    [sym_unset_command] = STATE(2195),
    [sym_command] = STATE(2195),
    [sym_command_name] = STATE(1861),
    [sym_variable_assignment] = STATE(2196),
    [sym_subscript] = STATE(1863),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(1858),
    [sym_simple_expansion] = STATE(1858),
    [sym_string_expansion] = STATE(1858),
    [sym_expansion] = STATE(1858),
    [sym_command_substitution] = STATE(1858),
    [sym_process_substitution] = STATE(1858),
    [aux_sym_program_repeat1] = STATE(2199),
    [aux_sym_command_repeat1] = STATE(1865),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4317),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4319),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5073),
    [anon_sym_SEMI_SEMI] = ACTIONS(5139),
    [anon_sym_function] = ACTIONS(4325),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4327),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4331),
    [anon_sym_declare] = ACTIONS(4333),
    [anon_sym_typeset] = ACTIONS(4333),
    [anon_sym_export] = ACTIONS(4333),
    [anon_sym_readonly] = ACTIONS(4333),
    [anon_sym_local] = ACTIONS(4333),
    [anon_sym_unset] = ACTIONS(4335),
    [anon_sym_unsetenv] = ACTIONS(4335),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4337),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4341),
  },
  [1867] = {
    [aux_sym_case_item_repeat1] = STATE(1867),
    [anon_sym_PIPE] = ACTIONS(5143),
    [anon_sym_RPAREN] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
  },
  [1868] = {
    [aux_sym_concatenation_repeat1] = STATE(1868),
    [sym__concat] = ACTIONS(2482),
    [anon_sym_PIPE] = ACTIONS(1642),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
  },
  [1869] = {
    [anon_sym_esac] = ACTIONS(5146),
    [sym__special_characters] = ACTIONS(5148),
    [anon_sym_DQUOTE] = ACTIONS(5148),
    [anon_sym_DOLLAR] = ACTIONS(5150),
    [sym_raw_string] = ACTIONS(5148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5148),
    [anon_sym_BQUOTE] = ACTIONS(5148),
    [anon_sym_LT_LPAREN] = ACTIONS(5148),
    [anon_sym_GT_LPAREN] = ACTIONS(5148),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5150),
  },
  [1870] = {
    [anon_sym_esac] = ACTIONS(5146),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI_SEMI] = ACTIONS(5152),
    [anon_sym_PIPE_AMP] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [1871] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(5146),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI_SEMI] = ACTIONS(5152),
    [anon_sym_PIPE_AMP] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [1872] = {
    [sym__terminated_statement] = STATE(2197),
    [sym_for_statement] = STATE(2202),
    [sym_while_statement] = STATE(2202),
    [sym_if_statement] = STATE(2202),
    [sym_case_statement] = STATE(2202),
    [sym_function_definition] = STATE(2202),
    [sym_subshell] = STATE(2202),
    [sym_pipeline] = STATE(2202),
    [sym_list] = STATE(2202),
    [sym_negated_command] = STATE(2202),
    [sym_test_command] = STATE(2202),
    [sym_declaration_command] = STATE(2202),
    [sym_unset_command] = STATE(2202),
    [sym_command] = STATE(2202),
    [sym_command_name] = STATE(1861),
    [sym_variable_assignment] = STATE(2203),
    [sym_subscript] = STATE(1863),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(1858),
    [sym_simple_expansion] = STATE(1858),
    [sym_string_expansion] = STATE(1858),
    [sym_expansion] = STATE(1858),
    [sym_command_substitution] = STATE(1858),
    [sym_process_substitution] = STATE(1858),
    [aux_sym_program_repeat1] = STATE(2197),
    [aux_sym_command_repeat1] = STATE(1865),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4317),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4319),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5146),
    [anon_sym_SEMI_SEMI] = ACTIONS(5154),
    [anon_sym_function] = ACTIONS(4325),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4327),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4331),
    [anon_sym_declare] = ACTIONS(4333),
    [anon_sym_typeset] = ACTIONS(4333),
    [anon_sym_export] = ACTIONS(4333),
    [anon_sym_readonly] = ACTIONS(4333),
    [anon_sym_local] = ACTIONS(4333),
    [anon_sym_unset] = ACTIONS(4335),
    [anon_sym_unsetenv] = ACTIONS(4335),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4337),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4341),
  },
  [1873] = {
    [sym__terminated_statement] = STATE(2204),
    [sym_for_statement] = STATE(2202),
    [sym_while_statement] = STATE(2202),
    [sym_if_statement] = STATE(2202),
    [sym_case_statement] = STATE(2202),
    [sym_function_definition] = STATE(2202),
    [sym_subshell] = STATE(2202),
    [sym_pipeline] = STATE(2202),
    [sym_list] = STATE(2202),
    [sym_negated_command] = STATE(2202),
    [sym_test_command] = STATE(2202),
    [sym_declaration_command] = STATE(2202),
    [sym_unset_command] = STATE(2202),
    [sym_command] = STATE(2202),
    [sym_command_name] = STATE(1861),
    [sym_variable_assignment] = STATE(2203),
    [sym_subscript] = STATE(1863),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(1858),
    [sym_simple_expansion] = STATE(1858),
    [sym_string_expansion] = STATE(1858),
    [sym_expansion] = STATE(1858),
    [sym_command_substitution] = STATE(1858),
    [sym_process_substitution] = STATE(1858),
    [aux_sym_program_repeat1] = STATE(2204),
    [aux_sym_command_repeat1] = STATE(1865),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4317),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4319),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5146),
    [anon_sym_SEMI_SEMI] = ACTIONS(5154),
    [anon_sym_function] = ACTIONS(4325),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4327),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4331),
    [anon_sym_declare] = ACTIONS(4333),
    [anon_sym_typeset] = ACTIONS(4333),
    [anon_sym_export] = ACTIONS(4333),
    [anon_sym_readonly] = ACTIONS(4333),
    [anon_sym_local] = ACTIONS(4333),
    [anon_sym_unset] = ACTIONS(4335),
    [anon_sym_unsetenv] = ACTIONS(4335),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4337),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4341),
  },
  [1874] = {
    [anon_sym_esac] = ACTIONS(5156),
    [anon_sym_PIPE] = ACTIONS(5156),
    [anon_sym_RPAREN] = ACTIONS(5156),
    [anon_sym_SEMI_SEMI] = ACTIONS(5156),
    [anon_sym_PIPE_AMP] = ACTIONS(5156),
    [anon_sym_AMP_AMP] = ACTIONS(5156),
    [anon_sym_PIPE_PIPE] = ACTIONS(5156),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5156),
    [anon_sym_LF] = ACTIONS(5158),
    [anon_sym_AMP] = ACTIONS(5156),
  },
  [1875] = {
    [aux_sym_case_item_repeat1] = STATE(2206),
    [aux_sym_concatenation_repeat1] = STATE(1467),
    [sym__concat] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(3467),
    [anon_sym_RPAREN] = ACTIONS(5160),
    [sym_comment] = ACTIONS(53),
  },
  [1876] = {
    [aux_sym_case_item_repeat1] = STATE(2208),
    [aux_sym_concatenation_repeat1] = STATE(1467),
    [sym__concat] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(3467),
    [anon_sym_RPAREN] = ACTIONS(5162),
    [sym_comment] = ACTIONS(53),
  },
  [1877] = {
    [aux_sym_case_item_repeat1] = STATE(2208),
    [anon_sym_PIPE] = ACTIONS(3467),
    [anon_sym_RPAREN] = ACTIONS(5162),
    [sym_comment] = ACTIONS(53),
  },
  [1878] = {
    [anon_sym_esac] = ACTIONS(5164),
    [sym_comment] = ACTIONS(53),
  },
  [1879] = {
    [anon_sym_esac] = ACTIONS(5166),
    [anon_sym_PIPE] = ACTIONS(5166),
    [anon_sym_RPAREN] = ACTIONS(5166),
    [anon_sym_SEMI_SEMI] = ACTIONS(5166),
    [anon_sym_PIPE_AMP] = ACTIONS(5166),
    [anon_sym_AMP_AMP] = ACTIONS(5166),
    [anon_sym_PIPE_PIPE] = ACTIONS(5166),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5166),
    [anon_sym_LF] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5166),
  },
  [1880] = {
    [anon_sym_esac] = ACTIONS(5170),
    [sym_comment] = ACTIONS(53),
  },
  [1881] = {
    [sym__concat] = ACTIONS(4741),
    [anon_sym_in] = ACTIONS(4743),
    [anon_sym_SEMI_SEMI] = ACTIONS(4743),
    [sym__special_characters] = ACTIONS(4743),
    [anon_sym_DQUOTE] = ACTIONS(4743),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [sym_raw_string] = ACTIONS(4743),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4743),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [anon_sym_LT_LPAREN] = ACTIONS(4743),
    [anon_sym_GT_LPAREN] = ACTIONS(4743),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4743),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_LF] = ACTIONS(4741),
    [anon_sym_AMP] = ACTIONS(4743),
  },
  [1882] = {
    [sym__concat] = ACTIONS(4745),
    [anon_sym_in] = ACTIONS(4747),
    [anon_sym_SEMI_SEMI] = ACTIONS(4747),
    [sym__special_characters] = ACTIONS(4747),
    [anon_sym_DQUOTE] = ACTIONS(4747),
    [anon_sym_DOLLAR] = ACTIONS(4747),
    [sym_raw_string] = ACTIONS(4747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4747),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4747),
    [anon_sym_BQUOTE] = ACTIONS(4747),
    [anon_sym_LT_LPAREN] = ACTIONS(4747),
    [anon_sym_GT_LPAREN] = ACTIONS(4747),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4747),
    [anon_sym_SEMI] = ACTIONS(4747),
    [anon_sym_LF] = ACTIONS(4745),
    [anon_sym_AMP] = ACTIONS(4747),
  },
  [1883] = {
    [sym__concat] = ACTIONS(4749),
    [anon_sym_in] = ACTIONS(4751),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4751),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4751),
    [anon_sym_LF] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(4751),
  },
  [1884] = {
    [sym__concat] = ACTIONS(4753),
    [anon_sym_in] = ACTIONS(4755),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4755),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_LF] = ACTIONS(4753),
    [anon_sym_AMP] = ACTIONS(4755),
  },
  [1885] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5172),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1886] = {
    [sym__concat] = ACTIONS(4759),
    [anon_sym_in] = ACTIONS(4761),
    [anon_sym_SEMI_SEMI] = ACTIONS(4761),
    [sym__special_characters] = ACTIONS(4761),
    [anon_sym_DQUOTE] = ACTIONS(4761),
    [anon_sym_DOLLAR] = ACTIONS(4761),
    [sym_raw_string] = ACTIONS(4761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4761),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4761),
    [anon_sym_BQUOTE] = ACTIONS(4761),
    [anon_sym_LT_LPAREN] = ACTIONS(4761),
    [anon_sym_GT_LPAREN] = ACTIONS(4761),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4761),
    [anon_sym_SEMI] = ACTIONS(4761),
    [anon_sym_LF] = ACTIONS(4759),
    [anon_sym_AMP] = ACTIONS(4761),
  },
  [1887] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5174),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1888] = {
    [sym__concat] = ACTIONS(4765),
    [anon_sym_in] = ACTIONS(4767),
    [anon_sym_SEMI_SEMI] = ACTIONS(4767),
    [sym__special_characters] = ACTIONS(4767),
    [anon_sym_DQUOTE] = ACTIONS(4767),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [sym_raw_string] = ACTIONS(4767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4767),
    [anon_sym_BQUOTE] = ACTIONS(4767),
    [anon_sym_LT_LPAREN] = ACTIONS(4767),
    [anon_sym_GT_LPAREN] = ACTIONS(4767),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4767),
    [anon_sym_SEMI] = ACTIONS(4767),
    [anon_sym_LF] = ACTIONS(4765),
    [anon_sym_AMP] = ACTIONS(4767),
  },
  [1889] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5176),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1890] = {
    [sym__concat] = ACTIONS(4771),
    [anon_sym_in] = ACTIONS(4773),
    [anon_sym_SEMI_SEMI] = ACTIONS(4773),
    [sym__special_characters] = ACTIONS(4773),
    [anon_sym_DQUOTE] = ACTIONS(4773),
    [anon_sym_DOLLAR] = ACTIONS(4773),
    [sym_raw_string] = ACTIONS(4773),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4773),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4773),
    [anon_sym_BQUOTE] = ACTIONS(4773),
    [anon_sym_LT_LPAREN] = ACTIONS(4773),
    [anon_sym_GT_LPAREN] = ACTIONS(4773),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4773),
    [anon_sym_SEMI] = ACTIONS(4773),
    [anon_sym_LF] = ACTIONS(4771),
    [anon_sym_AMP] = ACTIONS(4773),
  },
  [1891] = {
    [sym__concat] = ACTIONS(4775),
    [anon_sym_in] = ACTIONS(4777),
    [anon_sym_SEMI_SEMI] = ACTIONS(4777),
    [sym__special_characters] = ACTIONS(4777),
    [anon_sym_DQUOTE] = ACTIONS(4777),
    [anon_sym_DOLLAR] = ACTIONS(4777),
    [sym_raw_string] = ACTIONS(4777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4777),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4777),
    [anon_sym_BQUOTE] = ACTIONS(4777),
    [anon_sym_LT_LPAREN] = ACTIONS(4777),
    [anon_sym_GT_LPAREN] = ACTIONS(4777),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4777),
    [anon_sym_SEMI] = ACTIONS(4777),
    [anon_sym_LF] = ACTIONS(4775),
    [anon_sym_AMP] = ACTIONS(4777),
  },
  [1892] = {
    [aux_sym_concatenation_repeat1] = STATE(1892),
    [sym__concat] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1893] = {
    [aux_sym_concatenation_repeat1] = STATE(1895),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1894] = {
    [aux_sym_concatenation_repeat1] = STATE(1895),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [1895] = {
    [aux_sym_concatenation_repeat1] = STATE(2214),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [1896] = {
    [aux_sym_concatenation_repeat1] = STATE(1898),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1897] = {
    [aux_sym_concatenation_repeat1] = STATE(1898),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [1898] = {
    [aux_sym_concatenation_repeat1] = STATE(2215),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [1899] = {
    [sym__concat] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_RBRACK] = ACTIONS(4741),
    [anon_sym_EQ_TILDE] = ACTIONS(4741),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_EQ] = ACTIONS(4743),
    [anon_sym_LT] = ACTIONS(4741),
    [anon_sym_GT] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4741),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4741),
  },
  [1900] = {
    [sym__concat] = ACTIONS(4745),
    [anon_sym_AMP_AMP] = ACTIONS(4745),
    [anon_sym_PIPE_PIPE] = ACTIONS(4745),
    [anon_sym_RBRACK] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_EQ_EQ] = ACTIONS(4745),
    [anon_sym_EQ] = ACTIONS(4747),
    [anon_sym_LT] = ACTIONS(4745),
    [anon_sym_GT] = ACTIONS(4745),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4745),
  },
  [1901] = {
    [sym__concat] = ACTIONS(4749),
    [anon_sym_AMP_AMP] = ACTIONS(4749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4749),
    [anon_sym_RBRACK] = ACTIONS(4749),
    [anon_sym_EQ_TILDE] = ACTIONS(4749),
    [anon_sym_EQ_EQ] = ACTIONS(4749),
    [anon_sym_EQ] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4749),
    [anon_sym_GT] = ACTIONS(4749),
    [anon_sym_BANG_EQ] = ACTIONS(4749),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4749),
  },
  [1902] = {
    [sym__concat] = ACTIONS(4753),
    [anon_sym_AMP_AMP] = ACTIONS(4753),
    [anon_sym_PIPE_PIPE] = ACTIONS(4753),
    [anon_sym_RBRACK] = ACTIONS(4753),
    [anon_sym_EQ_TILDE] = ACTIONS(4753),
    [anon_sym_EQ_EQ] = ACTIONS(4753),
    [anon_sym_EQ] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_BANG_EQ] = ACTIONS(4753),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4753),
  },
  [1903] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5178),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1904] = {
    [sym__concat] = ACTIONS(4759),
    [anon_sym_AMP_AMP] = ACTIONS(4759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4759),
    [anon_sym_RBRACK] = ACTIONS(4759),
    [anon_sym_EQ_TILDE] = ACTIONS(4759),
    [anon_sym_EQ_EQ] = ACTIONS(4759),
    [anon_sym_EQ] = ACTIONS(4761),
    [anon_sym_LT] = ACTIONS(4759),
    [anon_sym_GT] = ACTIONS(4759),
    [anon_sym_BANG_EQ] = ACTIONS(4759),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4759),
  },
  [1905] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5180),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1906] = {
    [sym__concat] = ACTIONS(4765),
    [anon_sym_AMP_AMP] = ACTIONS(4765),
    [anon_sym_PIPE_PIPE] = ACTIONS(4765),
    [anon_sym_RBRACK] = ACTIONS(4765),
    [anon_sym_EQ_TILDE] = ACTIONS(4765),
    [anon_sym_EQ_EQ] = ACTIONS(4765),
    [anon_sym_EQ] = ACTIONS(4767),
    [anon_sym_LT] = ACTIONS(4765),
    [anon_sym_GT] = ACTIONS(4765),
    [anon_sym_BANG_EQ] = ACTIONS(4765),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4765),
  },
  [1907] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5182),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1908] = {
    [sym__concat] = ACTIONS(4771),
    [anon_sym_AMP_AMP] = ACTIONS(4771),
    [anon_sym_PIPE_PIPE] = ACTIONS(4771),
    [anon_sym_RBRACK] = ACTIONS(4771),
    [anon_sym_EQ_TILDE] = ACTIONS(4771),
    [anon_sym_EQ_EQ] = ACTIONS(4771),
    [anon_sym_EQ] = ACTIONS(4773),
    [anon_sym_LT] = ACTIONS(4771),
    [anon_sym_GT] = ACTIONS(4771),
    [anon_sym_BANG_EQ] = ACTIONS(4771),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4771),
  },
  [1909] = {
    [sym__concat] = ACTIONS(4775),
    [anon_sym_AMP_AMP] = ACTIONS(4775),
    [anon_sym_PIPE_PIPE] = ACTIONS(4775),
    [anon_sym_RBRACK] = ACTIONS(4775),
    [anon_sym_EQ_TILDE] = ACTIONS(4775),
    [anon_sym_EQ_EQ] = ACTIONS(4775),
    [anon_sym_EQ] = ACTIONS(4777),
    [anon_sym_LT] = ACTIONS(4775),
    [anon_sym_GT] = ACTIONS(4775),
    [anon_sym_BANG_EQ] = ACTIONS(4775),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4775),
  },
  [1910] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [anon_sym_esac] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1911] = {
    [aux_sym_concatenation_repeat1] = STATE(1911),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [1912] = {
    [sym_file_descriptor] = ACTIONS(1691),
    [sym__concat] = ACTIONS(1691),
    [anon_sym_esac] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_RPAREN] = ACTIONS(1693),
    [anon_sym_SEMI_SEMI] = ACTIONS(1693),
    [anon_sym_PIPE_AMP] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1693),
    [anon_sym_AMP_GT] = ACTIONS(1693),
    [anon_sym_AMP_GT_GT] = ACTIONS(1693),
    [anon_sym_LT_AMP] = ACTIONS(1693),
    [anon_sym_GT_AMP] = ACTIONS(1693),
    [anon_sym_LT_LT] = ACTIONS(1693),
    [anon_sym_LT_LT_DASH] = ACTIONS(1693),
    [anon_sym_LT_LT_LT] = ACTIONS(1693),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1693),
    [anon_sym_LF] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1693),
  },
  [1913] = {
    [sym_concatenation] = STATE(2222),
    [sym_string] = STATE(2221),
    [sym_simple_expansion] = STATE(2221),
    [sym_string_expansion] = STATE(2221),
    [sym_expansion] = STATE(2221),
    [sym_command_substitution] = STATE(2221),
    [sym_process_substitution] = STATE(2221),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [sym__special_characters] = ACTIONS(5189),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(5191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5191),
  },
  [1914] = {
    [sym_file_descriptor] = ACTIONS(1732),
    [sym__concat] = ACTIONS(1732),
    [anon_sym_esac] = ACTIONS(1734),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_RPAREN] = ACTIONS(1734),
    [anon_sym_SEMI_SEMI] = ACTIONS(1734),
    [anon_sym_PIPE_AMP] = ACTIONS(1734),
    [anon_sym_AMP_AMP] = ACTIONS(1734),
    [anon_sym_PIPE_PIPE] = ACTIONS(1734),
    [anon_sym_LT] = ACTIONS(1734),
    [anon_sym_GT] = ACTIONS(1734),
    [anon_sym_GT_GT] = ACTIONS(1734),
    [anon_sym_AMP_GT] = ACTIONS(1734),
    [anon_sym_AMP_GT_GT] = ACTIONS(1734),
    [anon_sym_LT_AMP] = ACTIONS(1734),
    [anon_sym_GT_AMP] = ACTIONS(1734),
    [anon_sym_LT_LT] = ACTIONS(1734),
    [anon_sym_LT_LT_DASH] = ACTIONS(1734),
    [anon_sym_LT_LT_LT] = ACTIONS(1734),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_LF] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1734),
  },
  [1915] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5193),
  },
  [1916] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5195),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1917] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(5197),
    [sym_comment] = ACTIONS(53),
  },
  [1918] = {
    [sym_concatenation] = STATE(2228),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2228),
    [anon_sym_RBRACE] = ACTIONS(5199),
    [anon_sym_EQ] = ACTIONS(5201),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5203),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5205),
    [anon_sym_COLON] = ACTIONS(5201),
    [anon_sym_COLON_QMARK] = ACTIONS(5201),
    [anon_sym_COLON_DASH] = ACTIONS(5201),
    [anon_sym_PERCENT] = ACTIONS(5201),
    [anon_sym_DASH] = ACTIONS(5201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1919] = {
    [sym_concatenation] = STATE(2231),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2231),
    [anon_sym_RBRACE] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(5209),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5213),
    [anon_sym_COLON] = ACTIONS(5209),
    [anon_sym_COLON_QMARK] = ACTIONS(5209),
    [anon_sym_COLON_DASH] = ACTIONS(5209),
    [anon_sym_PERCENT] = ACTIONS(5209),
    [anon_sym_DASH] = ACTIONS(5209),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1920] = {
    [sym_concatenation] = STATE(2233),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2233),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_EQ] = ACTIONS(5215),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5219),
    [anon_sym_COLON] = ACTIONS(5215),
    [anon_sym_COLON_QMARK] = ACTIONS(5215),
    [anon_sym_COLON_DASH] = ACTIONS(5215),
    [anon_sym_PERCENT] = ACTIONS(5215),
    [anon_sym_DASH] = ACTIONS(5215),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1921] = {
    [sym_file_descriptor] = ACTIONS(1798),
    [sym__concat] = ACTIONS(1798),
    [anon_sym_esac] = ACTIONS(1800),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1800),
    [anon_sym_SEMI_SEMI] = ACTIONS(1800),
    [anon_sym_PIPE_AMP] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(1800),
    [anon_sym_PIPE_PIPE] = ACTIONS(1800),
    [anon_sym_LT] = ACTIONS(1800),
    [anon_sym_GT] = ACTIONS(1800),
    [anon_sym_GT_GT] = ACTIONS(1800),
    [anon_sym_AMP_GT] = ACTIONS(1800),
    [anon_sym_AMP_GT_GT] = ACTIONS(1800),
    [anon_sym_LT_AMP] = ACTIONS(1800),
    [anon_sym_GT_AMP] = ACTIONS(1800),
    [anon_sym_LT_LT] = ACTIONS(1800),
    [anon_sym_LT_LT_DASH] = ACTIONS(1800),
    [anon_sym_LT_LT_LT] = ACTIONS(1800),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1800),
    [anon_sym_LF] = ACTIONS(1798),
    [anon_sym_AMP] = ACTIONS(1800),
  },
  [1922] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5221),
  },
  [1923] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5223),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1924] = {
    [sym_file_descriptor] = ACTIONS(1806),
    [sym__concat] = ACTIONS(1806),
    [anon_sym_esac] = ACTIONS(1808),
    [anon_sym_PIPE] = ACTIONS(1808),
    [anon_sym_RPAREN] = ACTIONS(1808),
    [anon_sym_SEMI_SEMI] = ACTIONS(1808),
    [anon_sym_PIPE_AMP] = ACTIONS(1808),
    [anon_sym_AMP_AMP] = ACTIONS(1808),
    [anon_sym_PIPE_PIPE] = ACTIONS(1808),
    [anon_sym_LT] = ACTIONS(1808),
    [anon_sym_GT] = ACTIONS(1808),
    [anon_sym_GT_GT] = ACTIONS(1808),
    [anon_sym_AMP_GT] = ACTIONS(1808),
    [anon_sym_AMP_GT_GT] = ACTIONS(1808),
    [anon_sym_LT_AMP] = ACTIONS(1808),
    [anon_sym_GT_AMP] = ACTIONS(1808),
    [anon_sym_LT_LT] = ACTIONS(1808),
    [anon_sym_LT_LT_DASH] = ACTIONS(1808),
    [anon_sym_LT_LT_LT] = ACTIONS(1808),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1808),
    [anon_sym_LF] = ACTIONS(1806),
    [anon_sym_AMP] = ACTIONS(1808),
  },
  [1925] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5225),
  },
  [1926] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1927] = {
    [sym_file_descriptor] = ACTIONS(1940),
    [sym__concat] = ACTIONS(1940),
    [anon_sym_esac] = ACTIONS(1942),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1942),
    [anon_sym_PIPE_AMP] = ACTIONS(1942),
    [anon_sym_AMP_AMP] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1942),
    [anon_sym_LT_AMP] = ACTIONS(1942),
    [anon_sym_GT_AMP] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_LT_LT_DASH] = ACTIONS(1942),
    [anon_sym_LT_LT_LT] = ACTIONS(1942),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [1928] = {
    [sym_file_descriptor] = ACTIONS(2006),
    [sym__concat] = ACTIONS(2006),
    [anon_sym_esac] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_RPAREN] = ACTIONS(2008),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2008),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2008),
    [anon_sym_LT_AMP] = ACTIONS(2008),
    [anon_sym_GT_AMP] = ACTIONS(2008),
    [anon_sym_LT_LT] = ACTIONS(2008),
    [anon_sym_LT_LT_DASH] = ACTIONS(2008),
    [anon_sym_LT_LT_LT] = ACTIONS(2008),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2008),
  },
  [1929] = {
    [sym__concat] = ACTIONS(4741),
    [anon_sym_PIPE] = ACTIONS(4743),
    [anon_sym_RPAREN] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4741),
    [anon_sym_EQ_TILDE] = ACTIONS(4741),
    [anon_sym_EQ_EQ] = ACTIONS(4741),
    [anon_sym_EQ] = ACTIONS(4743),
    [anon_sym_LT] = ACTIONS(4741),
    [anon_sym_GT] = ACTIONS(4741),
    [anon_sym_BANG_EQ] = ACTIONS(4741),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4741),
  },
  [1930] = {
    [sym__concat] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(4747),
    [anon_sym_RPAREN] = ACTIONS(4745),
    [anon_sym_AMP_AMP] = ACTIONS(4745),
    [anon_sym_PIPE_PIPE] = ACTIONS(4745),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4745),
    [anon_sym_EQ_EQ] = ACTIONS(4745),
    [anon_sym_EQ] = ACTIONS(4747),
    [anon_sym_LT] = ACTIONS(4745),
    [anon_sym_GT] = ACTIONS(4745),
    [anon_sym_BANG_EQ] = ACTIONS(4745),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4745),
  },
  [1931] = {
    [sym__concat] = ACTIONS(4749),
    [anon_sym_PIPE] = ACTIONS(4751),
    [anon_sym_RPAREN] = ACTIONS(4749),
    [anon_sym_AMP_AMP] = ACTIONS(4749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4749),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4749),
    [anon_sym_EQ_TILDE] = ACTIONS(4749),
    [anon_sym_EQ_EQ] = ACTIONS(4749),
    [anon_sym_EQ] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4749),
    [anon_sym_GT] = ACTIONS(4749),
    [anon_sym_BANG_EQ] = ACTIONS(4749),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4749),
  },
  [1932] = {
    [sym__concat] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4755),
    [anon_sym_RPAREN] = ACTIONS(4753),
    [anon_sym_AMP_AMP] = ACTIONS(4753),
    [anon_sym_PIPE_PIPE] = ACTIONS(4753),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4753),
    [anon_sym_EQ_TILDE] = ACTIONS(4753),
    [anon_sym_EQ_EQ] = ACTIONS(4753),
    [anon_sym_EQ] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4753),
    [anon_sym_GT] = ACTIONS(4753),
    [anon_sym_BANG_EQ] = ACTIONS(4753),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4753),
  },
  [1933] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5227),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1934] = {
    [sym__concat] = ACTIONS(4759),
    [anon_sym_PIPE] = ACTIONS(4761),
    [anon_sym_RPAREN] = ACTIONS(4759),
    [anon_sym_AMP_AMP] = ACTIONS(4759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4759),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4759),
    [anon_sym_EQ_TILDE] = ACTIONS(4759),
    [anon_sym_EQ_EQ] = ACTIONS(4759),
    [anon_sym_EQ] = ACTIONS(4761),
    [anon_sym_LT] = ACTIONS(4759),
    [anon_sym_GT] = ACTIONS(4759),
    [anon_sym_BANG_EQ] = ACTIONS(4759),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4759),
  },
  [1935] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5229),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1936] = {
    [sym__concat] = ACTIONS(4765),
    [anon_sym_PIPE] = ACTIONS(4767),
    [anon_sym_RPAREN] = ACTIONS(4765),
    [anon_sym_AMP_AMP] = ACTIONS(4765),
    [anon_sym_PIPE_PIPE] = ACTIONS(4765),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4765),
    [anon_sym_EQ_TILDE] = ACTIONS(4765),
    [anon_sym_EQ_EQ] = ACTIONS(4765),
    [anon_sym_EQ] = ACTIONS(4767),
    [anon_sym_LT] = ACTIONS(4765),
    [anon_sym_GT] = ACTIONS(4765),
    [anon_sym_BANG_EQ] = ACTIONS(4765),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4765),
  },
  [1937] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5231),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1938] = {
    [sym__concat] = ACTIONS(4771),
    [anon_sym_PIPE] = ACTIONS(4773),
    [anon_sym_RPAREN] = ACTIONS(4771),
    [anon_sym_AMP_AMP] = ACTIONS(4771),
    [anon_sym_PIPE_PIPE] = ACTIONS(4771),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4771),
    [anon_sym_EQ_TILDE] = ACTIONS(4771),
    [anon_sym_EQ_EQ] = ACTIONS(4771),
    [anon_sym_EQ] = ACTIONS(4773),
    [anon_sym_LT] = ACTIONS(4771),
    [anon_sym_GT] = ACTIONS(4771),
    [anon_sym_BANG_EQ] = ACTIONS(4771),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4771),
  },
  [1939] = {
    [sym__concat] = ACTIONS(4775),
    [anon_sym_PIPE] = ACTIONS(4777),
    [anon_sym_RPAREN] = ACTIONS(4775),
    [anon_sym_AMP_AMP] = ACTIONS(4775),
    [anon_sym_PIPE_PIPE] = ACTIONS(4775),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4775),
    [anon_sym_EQ_TILDE] = ACTIONS(4775),
    [anon_sym_EQ_EQ] = ACTIONS(4775),
    [anon_sym_EQ] = ACTIONS(4777),
    [anon_sym_LT] = ACTIONS(4775),
    [anon_sym_GT] = ACTIONS(4775),
    [anon_sym_BANG_EQ] = ACTIONS(4775),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4775),
  },
  [1940] = {
    [sym__concat] = ACTIONS(4741),
    [sym_variable_name] = ACTIONS(4741),
    [anon_sym_PIPE] = ACTIONS(4743),
    [anon_sym_RPAREN] = ACTIONS(4743),
    [anon_sym_SEMI_SEMI] = ACTIONS(4743),
    [anon_sym_PIPE_AMP] = ACTIONS(4743),
    [anon_sym_AMP_AMP] = ACTIONS(4743),
    [anon_sym_PIPE_PIPE] = ACTIONS(4743),
    [sym__special_characters] = ACTIONS(4743),
    [anon_sym_DQUOTE] = ACTIONS(4743),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [sym_raw_string] = ACTIONS(4743),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4743),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [anon_sym_LT_LPAREN] = ACTIONS(4743),
    [anon_sym_GT_LPAREN] = ACTIONS(4743),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4743),
    [sym_word] = ACTIONS(4743),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_LF] = ACTIONS(4741),
    [anon_sym_AMP] = ACTIONS(4743),
  },
  [1941] = {
    [sym__concat] = ACTIONS(4745),
    [sym_variable_name] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(4747),
    [anon_sym_RPAREN] = ACTIONS(4747),
    [anon_sym_SEMI_SEMI] = ACTIONS(4747),
    [anon_sym_PIPE_AMP] = ACTIONS(4747),
    [anon_sym_AMP_AMP] = ACTIONS(4747),
    [anon_sym_PIPE_PIPE] = ACTIONS(4747),
    [sym__special_characters] = ACTIONS(4747),
    [anon_sym_DQUOTE] = ACTIONS(4747),
    [anon_sym_DOLLAR] = ACTIONS(4747),
    [sym_raw_string] = ACTIONS(4747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4747),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4747),
    [anon_sym_BQUOTE] = ACTIONS(4747),
    [anon_sym_LT_LPAREN] = ACTIONS(4747),
    [anon_sym_GT_LPAREN] = ACTIONS(4747),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4747),
    [sym_word] = ACTIONS(4747),
    [anon_sym_SEMI] = ACTIONS(4747),
    [anon_sym_LF] = ACTIONS(4745),
    [anon_sym_AMP] = ACTIONS(4747),
  },
  [1942] = {
    [sym__concat] = ACTIONS(4749),
    [sym_variable_name] = ACTIONS(4749),
    [anon_sym_PIPE] = ACTIONS(4751),
    [anon_sym_RPAREN] = ACTIONS(4751),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4751),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4751),
    [sym_word] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4751),
    [anon_sym_LF] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(4751),
  },
  [1943] = {
    [sym__concat] = ACTIONS(4753),
    [sym_variable_name] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4755),
    [anon_sym_RPAREN] = ACTIONS(4755),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4755),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4755),
    [sym_word] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_LF] = ACTIONS(4753),
    [anon_sym_AMP] = ACTIONS(4755),
  },
  [1944] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5233),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1945] = {
    [sym__concat] = ACTIONS(4759),
    [sym_variable_name] = ACTIONS(4759),
    [anon_sym_PIPE] = ACTIONS(4761),
    [anon_sym_RPAREN] = ACTIONS(4761),
    [anon_sym_SEMI_SEMI] = ACTIONS(4761),
    [anon_sym_PIPE_AMP] = ACTIONS(4761),
    [anon_sym_AMP_AMP] = ACTIONS(4761),
    [anon_sym_PIPE_PIPE] = ACTIONS(4761),
    [sym__special_characters] = ACTIONS(4761),
    [anon_sym_DQUOTE] = ACTIONS(4761),
    [anon_sym_DOLLAR] = ACTIONS(4761),
    [sym_raw_string] = ACTIONS(4761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4761),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4761),
    [anon_sym_BQUOTE] = ACTIONS(4761),
    [anon_sym_LT_LPAREN] = ACTIONS(4761),
    [anon_sym_GT_LPAREN] = ACTIONS(4761),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4761),
    [sym_word] = ACTIONS(4761),
    [anon_sym_SEMI] = ACTIONS(4761),
    [anon_sym_LF] = ACTIONS(4759),
    [anon_sym_AMP] = ACTIONS(4761),
  },
  [1946] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5235),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1947] = {
    [sym__concat] = ACTIONS(4765),
    [sym_variable_name] = ACTIONS(4765),
    [anon_sym_PIPE] = ACTIONS(4767),
    [anon_sym_RPAREN] = ACTIONS(4767),
    [anon_sym_SEMI_SEMI] = ACTIONS(4767),
    [anon_sym_PIPE_AMP] = ACTIONS(4767),
    [anon_sym_AMP_AMP] = ACTIONS(4767),
    [anon_sym_PIPE_PIPE] = ACTIONS(4767),
    [sym__special_characters] = ACTIONS(4767),
    [anon_sym_DQUOTE] = ACTIONS(4767),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [sym_raw_string] = ACTIONS(4767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4767),
    [anon_sym_BQUOTE] = ACTIONS(4767),
    [anon_sym_LT_LPAREN] = ACTIONS(4767),
    [anon_sym_GT_LPAREN] = ACTIONS(4767),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4767),
    [sym_word] = ACTIONS(4767),
    [anon_sym_SEMI] = ACTIONS(4767),
    [anon_sym_LF] = ACTIONS(4765),
    [anon_sym_AMP] = ACTIONS(4767),
  },
  [1948] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5237),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1949] = {
    [sym__concat] = ACTIONS(4771),
    [sym_variable_name] = ACTIONS(4771),
    [anon_sym_PIPE] = ACTIONS(4773),
    [anon_sym_RPAREN] = ACTIONS(4773),
    [anon_sym_SEMI_SEMI] = ACTIONS(4773),
    [anon_sym_PIPE_AMP] = ACTIONS(4773),
    [anon_sym_AMP_AMP] = ACTIONS(4773),
    [anon_sym_PIPE_PIPE] = ACTIONS(4773),
    [sym__special_characters] = ACTIONS(4773),
    [anon_sym_DQUOTE] = ACTIONS(4773),
    [anon_sym_DOLLAR] = ACTIONS(4773),
    [sym_raw_string] = ACTIONS(4773),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4773),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4773),
    [anon_sym_BQUOTE] = ACTIONS(4773),
    [anon_sym_LT_LPAREN] = ACTIONS(4773),
    [anon_sym_GT_LPAREN] = ACTIONS(4773),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4773),
    [sym_word] = ACTIONS(4773),
    [anon_sym_SEMI] = ACTIONS(4773),
    [anon_sym_LF] = ACTIONS(4771),
    [anon_sym_AMP] = ACTIONS(4773),
  },
  [1950] = {
    [sym__concat] = ACTIONS(4775),
    [sym_variable_name] = ACTIONS(4775),
    [anon_sym_PIPE] = ACTIONS(4777),
    [anon_sym_RPAREN] = ACTIONS(4777),
    [anon_sym_SEMI_SEMI] = ACTIONS(4777),
    [anon_sym_PIPE_AMP] = ACTIONS(4777),
    [anon_sym_AMP_AMP] = ACTIONS(4777),
    [anon_sym_PIPE_PIPE] = ACTIONS(4777),
    [sym__special_characters] = ACTIONS(4777),
    [anon_sym_DQUOTE] = ACTIONS(4777),
    [anon_sym_DOLLAR] = ACTIONS(4777),
    [sym_raw_string] = ACTIONS(4777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4777),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4777),
    [anon_sym_BQUOTE] = ACTIONS(4777),
    [anon_sym_LT_LPAREN] = ACTIONS(4777),
    [anon_sym_GT_LPAREN] = ACTIONS(4777),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4777),
    [sym_word] = ACTIONS(4777),
    [anon_sym_SEMI] = ACTIONS(4777),
    [anon_sym_LF] = ACTIONS(4775),
    [anon_sym_AMP] = ACTIONS(4777),
  },
  [1951] = {
    [sym__concat] = ACTIONS(4741),
    [anon_sym_PIPE] = ACTIONS(4743),
    [anon_sym_RPAREN] = ACTIONS(4743),
    [anon_sym_SEMI_SEMI] = ACTIONS(4743),
    [anon_sym_PIPE_AMP] = ACTIONS(4743),
    [anon_sym_AMP_AMP] = ACTIONS(4743),
    [anon_sym_PIPE_PIPE] = ACTIONS(4743),
    [sym__special_characters] = ACTIONS(4743),
    [anon_sym_DQUOTE] = ACTIONS(4743),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [sym_raw_string] = ACTIONS(4743),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4743),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [anon_sym_LT_LPAREN] = ACTIONS(4743),
    [anon_sym_GT_LPAREN] = ACTIONS(4743),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4743),
    [sym_word] = ACTIONS(4743),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_LF] = ACTIONS(4741),
    [anon_sym_AMP] = ACTIONS(4743),
  },
  [1952] = {
    [sym__concat] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(4747),
    [anon_sym_RPAREN] = ACTIONS(4747),
    [anon_sym_SEMI_SEMI] = ACTIONS(4747),
    [anon_sym_PIPE_AMP] = ACTIONS(4747),
    [anon_sym_AMP_AMP] = ACTIONS(4747),
    [anon_sym_PIPE_PIPE] = ACTIONS(4747),
    [sym__special_characters] = ACTIONS(4747),
    [anon_sym_DQUOTE] = ACTIONS(4747),
    [anon_sym_DOLLAR] = ACTIONS(4747),
    [sym_raw_string] = ACTIONS(4747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4747),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4747),
    [anon_sym_BQUOTE] = ACTIONS(4747),
    [anon_sym_LT_LPAREN] = ACTIONS(4747),
    [anon_sym_GT_LPAREN] = ACTIONS(4747),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4747),
    [sym_word] = ACTIONS(4747),
    [anon_sym_SEMI] = ACTIONS(4747),
    [anon_sym_LF] = ACTIONS(4745),
    [anon_sym_AMP] = ACTIONS(4747),
  },
  [1953] = {
    [sym__concat] = ACTIONS(4749),
    [anon_sym_PIPE] = ACTIONS(4751),
    [anon_sym_RPAREN] = ACTIONS(4751),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4751),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4751),
    [sym_word] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4751),
    [anon_sym_LF] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(4751),
  },
  [1954] = {
    [sym__concat] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4755),
    [anon_sym_RPAREN] = ACTIONS(4755),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4755),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4755),
    [sym_word] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_LF] = ACTIONS(4753),
    [anon_sym_AMP] = ACTIONS(4755),
  },
  [1955] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5239),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1956] = {
    [sym__concat] = ACTIONS(4759),
    [anon_sym_PIPE] = ACTIONS(4761),
    [anon_sym_RPAREN] = ACTIONS(4761),
    [anon_sym_SEMI_SEMI] = ACTIONS(4761),
    [anon_sym_PIPE_AMP] = ACTIONS(4761),
    [anon_sym_AMP_AMP] = ACTIONS(4761),
    [anon_sym_PIPE_PIPE] = ACTIONS(4761),
    [sym__special_characters] = ACTIONS(4761),
    [anon_sym_DQUOTE] = ACTIONS(4761),
    [anon_sym_DOLLAR] = ACTIONS(4761),
    [sym_raw_string] = ACTIONS(4761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4761),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4761),
    [anon_sym_BQUOTE] = ACTIONS(4761),
    [anon_sym_LT_LPAREN] = ACTIONS(4761),
    [anon_sym_GT_LPAREN] = ACTIONS(4761),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4761),
    [sym_word] = ACTIONS(4761),
    [anon_sym_SEMI] = ACTIONS(4761),
    [anon_sym_LF] = ACTIONS(4759),
    [anon_sym_AMP] = ACTIONS(4761),
  },
  [1957] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5241),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1958] = {
    [sym__concat] = ACTIONS(4765),
    [anon_sym_PIPE] = ACTIONS(4767),
    [anon_sym_RPAREN] = ACTIONS(4767),
    [anon_sym_SEMI_SEMI] = ACTIONS(4767),
    [anon_sym_PIPE_AMP] = ACTIONS(4767),
    [anon_sym_AMP_AMP] = ACTIONS(4767),
    [anon_sym_PIPE_PIPE] = ACTIONS(4767),
    [sym__special_characters] = ACTIONS(4767),
    [anon_sym_DQUOTE] = ACTIONS(4767),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [sym_raw_string] = ACTIONS(4767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4767),
    [anon_sym_BQUOTE] = ACTIONS(4767),
    [anon_sym_LT_LPAREN] = ACTIONS(4767),
    [anon_sym_GT_LPAREN] = ACTIONS(4767),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4767),
    [sym_word] = ACTIONS(4767),
    [anon_sym_SEMI] = ACTIONS(4767),
    [anon_sym_LF] = ACTIONS(4765),
    [anon_sym_AMP] = ACTIONS(4767),
  },
  [1959] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5243),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1960] = {
    [sym__concat] = ACTIONS(4771),
    [anon_sym_PIPE] = ACTIONS(4773),
    [anon_sym_RPAREN] = ACTIONS(4773),
    [anon_sym_SEMI_SEMI] = ACTIONS(4773),
    [anon_sym_PIPE_AMP] = ACTIONS(4773),
    [anon_sym_AMP_AMP] = ACTIONS(4773),
    [anon_sym_PIPE_PIPE] = ACTIONS(4773),
    [sym__special_characters] = ACTIONS(4773),
    [anon_sym_DQUOTE] = ACTIONS(4773),
    [anon_sym_DOLLAR] = ACTIONS(4773),
    [sym_raw_string] = ACTIONS(4773),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4773),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4773),
    [anon_sym_BQUOTE] = ACTIONS(4773),
    [anon_sym_LT_LPAREN] = ACTIONS(4773),
    [anon_sym_GT_LPAREN] = ACTIONS(4773),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4773),
    [sym_word] = ACTIONS(4773),
    [anon_sym_SEMI] = ACTIONS(4773),
    [anon_sym_LF] = ACTIONS(4771),
    [anon_sym_AMP] = ACTIONS(4773),
  },
  [1961] = {
    [sym__concat] = ACTIONS(4775),
    [anon_sym_PIPE] = ACTIONS(4777),
    [anon_sym_RPAREN] = ACTIONS(4777),
    [anon_sym_SEMI_SEMI] = ACTIONS(4777),
    [anon_sym_PIPE_AMP] = ACTIONS(4777),
    [anon_sym_AMP_AMP] = ACTIONS(4777),
    [anon_sym_PIPE_PIPE] = ACTIONS(4777),
    [sym__special_characters] = ACTIONS(4777),
    [anon_sym_DQUOTE] = ACTIONS(4777),
    [anon_sym_DOLLAR] = ACTIONS(4777),
    [sym_raw_string] = ACTIONS(4777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4777),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4777),
    [anon_sym_BQUOTE] = ACTIONS(4777),
    [anon_sym_LT_LPAREN] = ACTIONS(4777),
    [anon_sym_GT_LPAREN] = ACTIONS(4777),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4777),
    [sym_word] = ACTIONS(4777),
    [anon_sym_SEMI] = ACTIONS(4777),
    [anon_sym_LF] = ACTIONS(4775),
    [anon_sym_AMP] = ACTIONS(4777),
  },
  [1962] = {
    [sym_file_descriptor] = ACTIONS(4741),
    [sym__concat] = ACTIONS(4741),
    [sym_variable_name] = ACTIONS(4741),
    [anon_sym_PIPE] = ACTIONS(4743),
    [anon_sym_RPAREN] = ACTIONS(4741),
    [anon_sym_PIPE_AMP] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_LT] = ACTIONS(4743),
    [anon_sym_GT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4741),
    [anon_sym_AMP_GT] = ACTIONS(4743),
    [anon_sym_AMP_GT_GT] = ACTIONS(4741),
    [anon_sym_LT_AMP] = ACTIONS(4741),
    [anon_sym_GT_AMP] = ACTIONS(4741),
    [sym__special_characters] = ACTIONS(4741),
    [anon_sym_DQUOTE] = ACTIONS(4741),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [sym_raw_string] = ACTIONS(4741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4741),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4741),
    [anon_sym_BQUOTE] = ACTIONS(4741),
    [anon_sym_LT_LPAREN] = ACTIONS(4741),
    [anon_sym_GT_LPAREN] = ACTIONS(4741),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4741),
  },
  [1963] = {
    [sym_file_descriptor] = ACTIONS(4745),
    [sym__concat] = ACTIONS(4745),
    [sym_variable_name] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(4747),
    [anon_sym_RPAREN] = ACTIONS(4745),
    [anon_sym_PIPE_AMP] = ACTIONS(4745),
    [anon_sym_AMP_AMP] = ACTIONS(4745),
    [anon_sym_PIPE_PIPE] = ACTIONS(4745),
    [anon_sym_LT] = ACTIONS(4747),
    [anon_sym_GT] = ACTIONS(4747),
    [anon_sym_GT_GT] = ACTIONS(4745),
    [anon_sym_AMP_GT] = ACTIONS(4747),
    [anon_sym_AMP_GT_GT] = ACTIONS(4745),
    [anon_sym_LT_AMP] = ACTIONS(4745),
    [anon_sym_GT_AMP] = ACTIONS(4745),
    [sym__special_characters] = ACTIONS(4745),
    [anon_sym_DQUOTE] = ACTIONS(4745),
    [anon_sym_DOLLAR] = ACTIONS(4747),
    [sym_raw_string] = ACTIONS(4745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4745),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4745),
    [anon_sym_BQUOTE] = ACTIONS(4745),
    [anon_sym_LT_LPAREN] = ACTIONS(4745),
    [anon_sym_GT_LPAREN] = ACTIONS(4745),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4745),
  },
  [1964] = {
    [sym_file_descriptor] = ACTIONS(4749),
    [sym__concat] = ACTIONS(4749),
    [sym_variable_name] = ACTIONS(4749),
    [anon_sym_PIPE] = ACTIONS(4751),
    [anon_sym_RPAREN] = ACTIONS(4749),
    [anon_sym_PIPE_AMP] = ACTIONS(4749),
    [anon_sym_AMP_AMP] = ACTIONS(4749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4749),
    [anon_sym_LT] = ACTIONS(4751),
    [anon_sym_GT] = ACTIONS(4751),
    [anon_sym_GT_GT] = ACTIONS(4749),
    [anon_sym_AMP_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT_GT] = ACTIONS(4749),
    [anon_sym_LT_AMP] = ACTIONS(4749),
    [anon_sym_GT_AMP] = ACTIONS(4749),
    [sym__special_characters] = ACTIONS(4749),
    [anon_sym_DQUOTE] = ACTIONS(4749),
    [anon_sym_DOLLAR] = ACTIONS(4751),
    [sym_raw_string] = ACTIONS(4749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4749),
    [anon_sym_BQUOTE] = ACTIONS(4749),
    [anon_sym_LT_LPAREN] = ACTIONS(4749),
    [anon_sym_GT_LPAREN] = ACTIONS(4749),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4749),
  },
  [1965] = {
    [sym_file_descriptor] = ACTIONS(4753),
    [sym__concat] = ACTIONS(4753),
    [sym_variable_name] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4755),
    [anon_sym_RPAREN] = ACTIONS(4753),
    [anon_sym_PIPE_AMP] = ACTIONS(4753),
    [anon_sym_AMP_AMP] = ACTIONS(4753),
    [anon_sym_PIPE_PIPE] = ACTIONS(4753),
    [anon_sym_LT] = ACTIONS(4755),
    [anon_sym_GT] = ACTIONS(4755),
    [anon_sym_GT_GT] = ACTIONS(4753),
    [anon_sym_AMP_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT_GT] = ACTIONS(4753),
    [anon_sym_LT_AMP] = ACTIONS(4753),
    [anon_sym_GT_AMP] = ACTIONS(4753),
    [sym__special_characters] = ACTIONS(4753),
    [anon_sym_DQUOTE] = ACTIONS(4753),
    [anon_sym_DOLLAR] = ACTIONS(4755),
    [sym_raw_string] = ACTIONS(4753),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4753),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4753),
    [anon_sym_BQUOTE] = ACTIONS(4753),
    [anon_sym_LT_LPAREN] = ACTIONS(4753),
    [anon_sym_GT_LPAREN] = ACTIONS(4753),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4753),
  },
  [1966] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5245),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1967] = {
    [sym_file_descriptor] = ACTIONS(4759),
    [sym__concat] = ACTIONS(4759),
    [sym_variable_name] = ACTIONS(4759),
    [anon_sym_PIPE] = ACTIONS(4761),
    [anon_sym_RPAREN] = ACTIONS(4759),
    [anon_sym_PIPE_AMP] = ACTIONS(4759),
    [anon_sym_AMP_AMP] = ACTIONS(4759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4759),
    [anon_sym_LT] = ACTIONS(4761),
    [anon_sym_GT] = ACTIONS(4761),
    [anon_sym_GT_GT] = ACTIONS(4759),
    [anon_sym_AMP_GT] = ACTIONS(4761),
    [anon_sym_AMP_GT_GT] = ACTIONS(4759),
    [anon_sym_LT_AMP] = ACTIONS(4759),
    [anon_sym_GT_AMP] = ACTIONS(4759),
    [sym__special_characters] = ACTIONS(4759),
    [anon_sym_DQUOTE] = ACTIONS(4759),
    [anon_sym_DOLLAR] = ACTIONS(4761),
    [sym_raw_string] = ACTIONS(4759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4759),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4759),
    [anon_sym_BQUOTE] = ACTIONS(4759),
    [anon_sym_LT_LPAREN] = ACTIONS(4759),
    [anon_sym_GT_LPAREN] = ACTIONS(4759),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4759),
  },
  [1968] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5247),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1969] = {
    [sym_file_descriptor] = ACTIONS(4765),
    [sym__concat] = ACTIONS(4765),
    [sym_variable_name] = ACTIONS(4765),
    [anon_sym_PIPE] = ACTIONS(4767),
    [anon_sym_RPAREN] = ACTIONS(4765),
    [anon_sym_PIPE_AMP] = ACTIONS(4765),
    [anon_sym_AMP_AMP] = ACTIONS(4765),
    [anon_sym_PIPE_PIPE] = ACTIONS(4765),
    [anon_sym_LT] = ACTIONS(4767),
    [anon_sym_GT] = ACTIONS(4767),
    [anon_sym_GT_GT] = ACTIONS(4765),
    [anon_sym_AMP_GT] = ACTIONS(4767),
    [anon_sym_AMP_GT_GT] = ACTIONS(4765),
    [anon_sym_LT_AMP] = ACTIONS(4765),
    [anon_sym_GT_AMP] = ACTIONS(4765),
    [sym__special_characters] = ACTIONS(4765),
    [anon_sym_DQUOTE] = ACTIONS(4765),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [sym_raw_string] = ACTIONS(4765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4765),
    [anon_sym_BQUOTE] = ACTIONS(4765),
    [anon_sym_LT_LPAREN] = ACTIONS(4765),
    [anon_sym_GT_LPAREN] = ACTIONS(4765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4765),
  },
  [1970] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5249),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1971] = {
    [sym_file_descriptor] = ACTIONS(4771),
    [sym__concat] = ACTIONS(4771),
    [sym_variable_name] = ACTIONS(4771),
    [anon_sym_PIPE] = ACTIONS(4773),
    [anon_sym_RPAREN] = ACTIONS(4771),
    [anon_sym_PIPE_AMP] = ACTIONS(4771),
    [anon_sym_AMP_AMP] = ACTIONS(4771),
    [anon_sym_PIPE_PIPE] = ACTIONS(4771),
    [anon_sym_LT] = ACTIONS(4773),
    [anon_sym_GT] = ACTIONS(4773),
    [anon_sym_GT_GT] = ACTIONS(4771),
    [anon_sym_AMP_GT] = ACTIONS(4773),
    [anon_sym_AMP_GT_GT] = ACTIONS(4771),
    [anon_sym_LT_AMP] = ACTIONS(4771),
    [anon_sym_GT_AMP] = ACTIONS(4771),
    [sym__special_characters] = ACTIONS(4771),
    [anon_sym_DQUOTE] = ACTIONS(4771),
    [anon_sym_DOLLAR] = ACTIONS(4773),
    [sym_raw_string] = ACTIONS(4771),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4771),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4771),
    [anon_sym_BQUOTE] = ACTIONS(4771),
    [anon_sym_LT_LPAREN] = ACTIONS(4771),
    [anon_sym_GT_LPAREN] = ACTIONS(4771),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4771),
  },
  [1972] = {
    [sym_file_descriptor] = ACTIONS(4775),
    [sym__concat] = ACTIONS(4775),
    [sym_variable_name] = ACTIONS(4775),
    [anon_sym_PIPE] = ACTIONS(4777),
    [anon_sym_RPAREN] = ACTIONS(4775),
    [anon_sym_PIPE_AMP] = ACTIONS(4775),
    [anon_sym_AMP_AMP] = ACTIONS(4775),
    [anon_sym_PIPE_PIPE] = ACTIONS(4775),
    [anon_sym_LT] = ACTIONS(4777),
    [anon_sym_GT] = ACTIONS(4777),
    [anon_sym_GT_GT] = ACTIONS(4775),
    [anon_sym_AMP_GT] = ACTIONS(4777),
    [anon_sym_AMP_GT_GT] = ACTIONS(4775),
    [anon_sym_LT_AMP] = ACTIONS(4775),
    [anon_sym_GT_AMP] = ACTIONS(4775),
    [sym__special_characters] = ACTIONS(4775),
    [anon_sym_DQUOTE] = ACTIONS(4775),
    [anon_sym_DOLLAR] = ACTIONS(4777),
    [sym_raw_string] = ACTIONS(4775),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4775),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4775),
    [anon_sym_BQUOTE] = ACTIONS(4775),
    [anon_sym_LT_LPAREN] = ACTIONS(4775),
    [anon_sym_GT_LPAREN] = ACTIONS(4775),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4775),
  },
  [1973] = {
    [sym__concat] = ACTIONS(4741),
    [anon_sym_DQUOTE] = ACTIONS(4743),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [sym__string_content] = ACTIONS(4741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4743),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [sym_comment] = ACTIONS(177),
  },
  [1974] = {
    [sym__concat] = ACTIONS(4745),
    [anon_sym_DQUOTE] = ACTIONS(4747),
    [anon_sym_DOLLAR] = ACTIONS(4747),
    [sym__string_content] = ACTIONS(4745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4747),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4747),
    [anon_sym_BQUOTE] = ACTIONS(4747),
    [sym_comment] = ACTIONS(177),
  },
  [1975] = {
    [sym__concat] = ACTIONS(4749),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4751),
    [sym__string_content] = ACTIONS(4749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [sym_comment] = ACTIONS(177),
  },
  [1976] = {
    [sym__concat] = ACTIONS(4753),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4755),
    [sym__string_content] = ACTIONS(4753),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [sym_comment] = ACTIONS(177),
  },
  [1977] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5251),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1978] = {
    [sym__concat] = ACTIONS(4759),
    [anon_sym_DQUOTE] = ACTIONS(4761),
    [anon_sym_DOLLAR] = ACTIONS(4761),
    [sym__string_content] = ACTIONS(4759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4761),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4761),
    [anon_sym_BQUOTE] = ACTIONS(4761),
    [sym_comment] = ACTIONS(177),
  },
  [1979] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5253),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1980] = {
    [sym__concat] = ACTIONS(4765),
    [anon_sym_DQUOTE] = ACTIONS(4767),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [sym__string_content] = ACTIONS(4765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4767),
    [anon_sym_BQUOTE] = ACTIONS(4767),
    [sym_comment] = ACTIONS(177),
  },
  [1981] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5255),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1982] = {
    [sym__concat] = ACTIONS(4771),
    [anon_sym_DQUOTE] = ACTIONS(4773),
    [anon_sym_DOLLAR] = ACTIONS(4773),
    [sym__string_content] = ACTIONS(4771),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4773),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4773),
    [anon_sym_BQUOTE] = ACTIONS(4773),
    [sym_comment] = ACTIONS(177),
  },
  [1983] = {
    [sym__concat] = ACTIONS(4775),
    [anon_sym_DQUOTE] = ACTIONS(4777),
    [anon_sym_DOLLAR] = ACTIONS(4777),
    [sym__string_content] = ACTIONS(4775),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4777),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4777),
    [anon_sym_BQUOTE] = ACTIONS(4777),
    [sym_comment] = ACTIONS(177),
  },
  [1984] = {
    [anon_sym_RBRACE] = ACTIONS(4218),
    [anon_sym_EQ] = ACTIONS(5257),
    [sym__special_characters] = ACTIONS(5257),
    [anon_sym_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(5257),
    [sym_raw_string] = ACTIONS(4218),
    [anon_sym_POUND] = ACTIONS(4218),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4218),
    [aux_sym_SLASH] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(5257),
    [anon_sym_COLON_QMARK] = ACTIONS(5257),
    [anon_sym_COLON_DASH] = ACTIONS(5257),
    [anon_sym_PERCENT] = ACTIONS(5257),
    [anon_sym_DASH] = ACTIONS(5257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4218),
    [anon_sym_BQUOTE] = ACTIONS(4218),
    [anon_sym_LT_LPAREN] = ACTIONS(4218),
    [anon_sym_GT_LPAREN] = ACTIONS(4218),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5257),
  },
  [1985] = {
    [anon_sym_RBRACE] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(5259),
    [sym__special_characters] = ACTIONS(5259),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_DOLLAR] = ACTIONS(5259),
    [sym_raw_string] = ACTIONS(4220),
    [anon_sym_POUND] = ACTIONS(4220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4220),
    [aux_sym_SLASH] = ACTIONS(4220),
    [anon_sym_COLON] = ACTIONS(5259),
    [anon_sym_COLON_QMARK] = ACTIONS(5259),
    [anon_sym_COLON_DASH] = ACTIONS(5259),
    [anon_sym_PERCENT] = ACTIONS(5259),
    [anon_sym_DASH] = ACTIONS(5259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4220),
    [anon_sym_BQUOTE] = ACTIONS(4220),
    [anon_sym_LT_LPAREN] = ACTIONS(4220),
    [anon_sym_GT_LPAREN] = ACTIONS(4220),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5259),
  },
  [1986] = {
    [sym__concat] = ACTIONS(2710),
    [anon_sym_RBRACE] = ACTIONS(2710),
    [sym_comment] = ACTIONS(53),
  },
  [1987] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5261),
    [sym_comment] = ACTIONS(53),
  },
  [1988] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5263),
    [sym_comment] = ACTIONS(53),
  },
  [1989] = {
    [anon_sym_RBRACE] = ACTIONS(5263),
    [sym_comment] = ACTIONS(53),
  },
  [1990] = {
    [sym_concatenation] = STATE(2255),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2255),
    [anon_sym_RBRACE] = ACTIONS(5265),
    [anon_sym_EQ] = ACTIONS(5267),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5267),
    [anon_sym_COLON_QMARK] = ACTIONS(5267),
    [anon_sym_COLON_DASH] = ACTIONS(5267),
    [anon_sym_PERCENT] = ACTIONS(5267),
    [anon_sym_DASH] = ACTIONS(5267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1991] = {
    [sym__concat] = ACTIONS(2788),
    [anon_sym_RBRACE] = ACTIONS(2788),
    [sym_comment] = ACTIONS(53),
  },
  [1992] = {
    [sym_concatenation] = STATE(2258),
    [sym_string] = STATE(2257),
    [sym_simple_expansion] = STATE(2257),
    [sym_string_expansion] = STATE(2257),
    [sym_expansion] = STATE(2257),
    [sym_command_substitution] = STATE(2257),
    [sym_process_substitution] = STATE(2257),
    [anon_sym_RBRACE] = ACTIONS(5263),
    [sym__special_characters] = ACTIONS(5271),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(5273),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5273),
  },
  [1993] = {
    [sym__concat] = ACTIONS(2831),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [sym_comment] = ACTIONS(53),
  },
  [1994] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5275),
  },
  [1995] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5277),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1996] = {
    [sym__concat] = ACTIONS(2839),
    [anon_sym_RBRACE] = ACTIONS(2839),
    [sym_comment] = ACTIONS(53),
  },
  [1997] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5279),
  },
  [1998] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5281),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1999] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5283),
  },
  [2000] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5263),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2001] = {
    [sym_concatenation] = STATE(2265),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2265),
    [anon_sym_RBRACE] = ACTIONS(5285),
    [anon_sym_EQ] = ACTIONS(5287),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5287),
    [anon_sym_COLON_QMARK] = ACTIONS(5287),
    [anon_sym_COLON_DASH] = ACTIONS(5287),
    [anon_sym_PERCENT] = ACTIONS(5287),
    [anon_sym_DASH] = ACTIONS(5287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2002] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_RBRACE] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
  },
  [2003] = {
    [sym_concatenation] = STATE(2267),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2267),
    [anon_sym_RBRACE] = ACTIONS(5291),
    [anon_sym_EQ] = ACTIONS(5293),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5293),
    [anon_sym_COLON_QMARK] = ACTIONS(5293),
    [anon_sym_COLON_DASH] = ACTIONS(5293),
    [anon_sym_PERCENT] = ACTIONS(5293),
    [anon_sym_DASH] = ACTIONS(5293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2004] = {
    [sym__concat] = ACTIONS(3829),
    [anon_sym_RBRACE] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [sym__special_characters] = ACTIONS(3831),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [sym_raw_string] = ACTIONS(3829),
    [anon_sym_POUND] = ACTIONS(3829),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3829),
    [anon_sym_COLON] = ACTIONS(3831),
    [anon_sym_COLON_QMARK] = ACTIONS(3831),
    [anon_sym_COLON_DASH] = ACTIONS(3831),
    [anon_sym_PERCENT] = ACTIONS(3831),
    [anon_sym_DASH] = ACTIONS(3831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3829),
    [anon_sym_BQUOTE] = ACTIONS(3829),
    [anon_sym_LT_LPAREN] = ACTIONS(3829),
    [anon_sym_GT_LPAREN] = ACTIONS(3829),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3831),
  },
  [2005] = {
    [sym__concat] = ACTIONS(3835),
    [anon_sym_RBRACE] = ACTIONS(3835),
    [anon_sym_EQ] = ACTIONS(3837),
    [sym__special_characters] = ACTIONS(3837),
    [anon_sym_DQUOTE] = ACTIONS(3835),
    [anon_sym_DOLLAR] = ACTIONS(3837),
    [sym_raw_string] = ACTIONS(3835),
    [anon_sym_POUND] = ACTIONS(3835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3835),
    [anon_sym_COLON] = ACTIONS(3837),
    [anon_sym_COLON_QMARK] = ACTIONS(3837),
    [anon_sym_COLON_DASH] = ACTIONS(3837),
    [anon_sym_PERCENT] = ACTIONS(3837),
    [anon_sym_DASH] = ACTIONS(3837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3835),
    [anon_sym_BQUOTE] = ACTIONS(3835),
    [anon_sym_LT_LPAREN] = ACTIONS(3835),
    [anon_sym_GT_LPAREN] = ACTIONS(3835),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3837),
  },
  [2006] = {
    [sym__concat] = ACTIONS(3920),
    [anon_sym_RBRACE] = ACTIONS(3920),
    [anon_sym_EQ] = ACTIONS(3922),
    [sym__special_characters] = ACTIONS(3922),
    [anon_sym_DQUOTE] = ACTIONS(3920),
    [anon_sym_DOLLAR] = ACTIONS(3922),
    [sym_raw_string] = ACTIONS(3920),
    [anon_sym_POUND] = ACTIONS(3920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3920),
    [anon_sym_COLON] = ACTIONS(3922),
    [anon_sym_COLON_QMARK] = ACTIONS(3922),
    [anon_sym_COLON_DASH] = ACTIONS(3922),
    [anon_sym_PERCENT] = ACTIONS(3922),
    [anon_sym_DASH] = ACTIONS(3922),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3920),
    [anon_sym_BQUOTE] = ACTIONS(3920),
    [anon_sym_LT_LPAREN] = ACTIONS(3920),
    [anon_sym_GT_LPAREN] = ACTIONS(3920),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3922),
  },
  [2007] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5297),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2008] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5299),
    [sym_comment] = ACTIONS(53),
  },
  [2009] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5301),
    [sym_comment] = ACTIONS(53),
  },
  [2010] = {
    [anon_sym_RBRACE] = ACTIONS(5301),
    [sym_comment] = ACTIONS(53),
  },
  [2011] = {
    [sym_concatenation] = STATE(2272),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2272),
    [anon_sym_RBRACE] = ACTIONS(5303),
    [anon_sym_EQ] = ACTIONS(5305),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5305),
    [anon_sym_COLON_QMARK] = ACTIONS(5305),
    [anon_sym_COLON_DASH] = ACTIONS(5305),
    [anon_sym_PERCENT] = ACTIONS(5305),
    [anon_sym_DASH] = ACTIONS(5305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2012] = {
    [sym__concat] = ACTIONS(3936),
    [anon_sym_RBRACE] = ACTIONS(3936),
    [anon_sym_EQ] = ACTIONS(3938),
    [sym__special_characters] = ACTIONS(3938),
    [anon_sym_DQUOTE] = ACTIONS(3936),
    [anon_sym_DOLLAR] = ACTIONS(3938),
    [sym_raw_string] = ACTIONS(3936),
    [anon_sym_POUND] = ACTIONS(3936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3936),
    [anon_sym_COLON] = ACTIONS(3938),
    [anon_sym_COLON_QMARK] = ACTIONS(3938),
    [anon_sym_COLON_DASH] = ACTIONS(3938),
    [anon_sym_PERCENT] = ACTIONS(3938),
    [anon_sym_DASH] = ACTIONS(3938),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3936),
    [anon_sym_BQUOTE] = ACTIONS(3936),
    [anon_sym_LT_LPAREN] = ACTIONS(3936),
    [anon_sym_GT_LPAREN] = ACTIONS(3936),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3938),
  },
  [2013] = {
    [sym_concatenation] = STATE(2274),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2274),
    [anon_sym_RBRACE] = ACTIONS(5309),
    [anon_sym_EQ] = ACTIONS(5311),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_COLON_QMARK] = ACTIONS(5311),
    [anon_sym_COLON_DASH] = ACTIONS(5311),
    [anon_sym_PERCENT] = ACTIONS(5311),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2014] = {
    [sym__concat] = ACTIONS(3946),
    [anon_sym_RBRACE] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3948),
    [sym__special_characters] = ACTIONS(3948),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3946),
    [anon_sym_POUND] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_COLON] = ACTIONS(3948),
    [anon_sym_COLON_QMARK] = ACTIONS(3948),
    [anon_sym_COLON_DASH] = ACTIONS(3948),
    [anon_sym_PERCENT] = ACTIONS(3948),
    [anon_sym_DASH] = ACTIONS(3948),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3948),
  },
  [2015] = {
    [sym_concatenation] = STATE(2276),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2276),
    [anon_sym_RBRACE] = ACTIONS(5315),
    [anon_sym_EQ] = ACTIONS(5317),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5317),
    [anon_sym_COLON_QMARK] = ACTIONS(5317),
    [anon_sym_COLON_DASH] = ACTIONS(5317),
    [anon_sym_PERCENT] = ACTIONS(5317),
    [anon_sym_DASH] = ACTIONS(5317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2016] = {
    [sym__concat] = ACTIONS(3956),
    [anon_sym_RBRACE] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(3958),
    [sym__special_characters] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [sym_raw_string] = ACTIONS(3956),
    [anon_sym_POUND] = ACTIONS(3956),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_DASH] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3956),
    [anon_sym_BQUOTE] = ACTIONS(3956),
    [anon_sym_LT_LPAREN] = ACTIONS(3956),
    [anon_sym_GT_LPAREN] = ACTIONS(3956),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3958),
  },
  [2017] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5321),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2018] = {
    [sym__concat] = ACTIONS(3962),
    [anon_sym_RBRACE] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3964),
    [sym__special_characters] = ACTIONS(3964),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_DOLLAR] = ACTIONS(3964),
    [sym_raw_string] = ACTIONS(3962),
    [anon_sym_POUND] = ACTIONS(3962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3962),
    [anon_sym_COLON] = ACTIONS(3964),
    [anon_sym_COLON_QMARK] = ACTIONS(3964),
    [anon_sym_COLON_DASH] = ACTIONS(3964),
    [anon_sym_PERCENT] = ACTIONS(3964),
    [anon_sym_DASH] = ACTIONS(3964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3962),
    [anon_sym_BQUOTE] = ACTIONS(3962),
    [anon_sym_LT_LPAREN] = ACTIONS(3962),
    [anon_sym_GT_LPAREN] = ACTIONS(3962),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3964),
  },
  [2019] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5323),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2020] = {
    [sym__simple_heredoc_body] = ACTIONS(5325),
    [sym__heredoc_body_beginning] = ACTIONS(5325),
    [sym_file_descriptor] = ACTIONS(5325),
    [sym__concat] = ACTIONS(5325),
    [anon_sym_esac] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_RPAREN] = ACTIONS(5327),
    [anon_sym_SEMI_SEMI] = ACTIONS(5327),
    [anon_sym_PIPE_AMP] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [anon_sym_EQ_TILDE] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_GT_GT] = ACTIONS(5327),
    [anon_sym_AMP_GT] = ACTIONS(5327),
    [anon_sym_AMP_GT_GT] = ACTIONS(5327),
    [anon_sym_LT_AMP] = ACTIONS(5327),
    [anon_sym_GT_AMP] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5327),
    [anon_sym_LT_LT_LT] = ACTIONS(5327),
    [sym__special_characters] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [sym_raw_string] = ACTIONS(5327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5327),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5327),
    [anon_sym_BQUOTE] = ACTIONS(5327),
    [anon_sym_LT_LPAREN] = ACTIONS(5327),
    [anon_sym_GT_LPAREN] = ACTIONS(5327),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5327),
    [anon_sym_SEMI] = ACTIONS(5327),
    [anon_sym_LF] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
  },
  [2021] = {
    [sym__simple_heredoc_body] = ACTIONS(5329),
    [sym__heredoc_body_beginning] = ACTIONS(5329),
    [sym_file_descriptor] = ACTIONS(5329),
    [sym__concat] = ACTIONS(5329),
    [anon_sym_esac] = ACTIONS(5331),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5331),
    [anon_sym_SEMI_SEMI] = ACTIONS(5331),
    [anon_sym_PIPE_AMP] = ACTIONS(5331),
    [anon_sym_AMP_AMP] = ACTIONS(5331),
    [anon_sym_PIPE_PIPE] = ACTIONS(5331),
    [anon_sym_EQ_TILDE] = ACTIONS(5331),
    [anon_sym_EQ_EQ] = ACTIONS(5331),
    [anon_sym_LT] = ACTIONS(5331),
    [anon_sym_GT] = ACTIONS(5331),
    [anon_sym_GT_GT] = ACTIONS(5331),
    [anon_sym_AMP_GT] = ACTIONS(5331),
    [anon_sym_AMP_GT_GT] = ACTIONS(5331),
    [anon_sym_LT_AMP] = ACTIONS(5331),
    [anon_sym_GT_AMP] = ACTIONS(5331),
    [anon_sym_LT_LT] = ACTIONS(5331),
    [anon_sym_LT_LT_DASH] = ACTIONS(5331),
    [anon_sym_LT_LT_LT] = ACTIONS(5331),
    [sym__special_characters] = ACTIONS(5331),
    [anon_sym_DQUOTE] = ACTIONS(5331),
    [anon_sym_DOLLAR] = ACTIONS(5331),
    [sym_raw_string] = ACTIONS(5331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5331),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5331),
    [anon_sym_BQUOTE] = ACTIONS(5331),
    [anon_sym_LT_LPAREN] = ACTIONS(5331),
    [anon_sym_GT_LPAREN] = ACTIONS(5331),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5331),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LF] = ACTIONS(5329),
    [anon_sym_AMP] = ACTIONS(5331),
  },
  [2022] = {
    [sym__simple_heredoc_body] = ACTIONS(5333),
    [sym__heredoc_body_beginning] = ACTIONS(5333),
    [sym_file_descriptor] = ACTIONS(5333),
    [sym__concat] = ACTIONS(5333),
    [anon_sym_esac] = ACTIONS(5335),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_RPAREN] = ACTIONS(5335),
    [anon_sym_SEMI_SEMI] = ACTIONS(5335),
    [anon_sym_PIPE_AMP] = ACTIONS(5335),
    [anon_sym_AMP_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5335),
    [anon_sym_EQ_TILDE] = ACTIONS(5335),
    [anon_sym_EQ_EQ] = ACTIONS(5335),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_GT] = ACTIONS(5335),
    [anon_sym_AMP_GT] = ACTIONS(5335),
    [anon_sym_AMP_GT_GT] = ACTIONS(5335),
    [anon_sym_LT_AMP] = ACTIONS(5335),
    [anon_sym_GT_AMP] = ACTIONS(5335),
    [anon_sym_LT_LT] = ACTIONS(5335),
    [anon_sym_LT_LT_DASH] = ACTIONS(5335),
    [anon_sym_LT_LT_LT] = ACTIONS(5335),
    [sym__special_characters] = ACTIONS(5335),
    [anon_sym_DQUOTE] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5335),
    [sym_raw_string] = ACTIONS(5335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5335),
    [anon_sym_BQUOTE] = ACTIONS(5335),
    [anon_sym_LT_LPAREN] = ACTIONS(5335),
    [anon_sym_GT_LPAREN] = ACTIONS(5335),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5335),
    [anon_sym_SEMI] = ACTIONS(5335),
    [anon_sym_LF] = ACTIONS(5333),
    [anon_sym_AMP] = ACTIONS(5335),
  },
  [2023] = {
    [anon_sym_PIPE] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(4303),
    [anon_sym_PIPE_AMP] = ACTIONS(4303),
    [anon_sym_AMP_AMP] = ACTIONS(4303),
    [anon_sym_PIPE_PIPE] = ACTIONS(4303),
    [anon_sym_BQUOTE] = ACTIONS(4303),
    [sym_comment] = ACTIONS(53),
  },
  [2024] = {
    [anon_sym_PIPE] = ACTIONS(3440),
    [anon_sym_RPAREN] = ACTIONS(3438),
    [anon_sym_PIPE_AMP] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BQUOTE] = ACTIONS(3438),
    [sym_comment] = ACTIONS(53),
  },
  [2025] = {
    [anon_sym_PIPE] = ACTIONS(4307),
    [anon_sym_RPAREN] = ACTIONS(4309),
    [anon_sym_PIPE_AMP] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4309),
    [anon_sym_PIPE_PIPE] = ACTIONS(4309),
    [anon_sym_BQUOTE] = ACTIONS(4309),
    [sym_comment] = ACTIONS(53),
  },
  [2026] = {
    [anon_sym_fi] = ACTIONS(5337),
    [sym_comment] = ACTIONS(53),
  },
  [2027] = {
    [anon_sym_PIPE] = ACTIONS(4351),
    [anon_sym_RPAREN] = ACTIONS(4353),
    [anon_sym_PIPE_AMP] = ACTIONS(4353),
    [anon_sym_AMP_AMP] = ACTIONS(4353),
    [anon_sym_PIPE_PIPE] = ACTIONS(4353),
    [anon_sym_BQUOTE] = ACTIONS(4353),
    [sym_comment] = ACTIONS(53),
  },
  [2028] = {
    [anon_sym_esac] = ACTIONS(5339),
    [sym_comment] = ACTIONS(53),
  },
  [2029] = {
    [anon_sym_PIPE] = ACTIONS(4381),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_PIPE_AMP] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [sym_comment] = ACTIONS(53),
  },
  [2030] = {
    [sym_case_item] = STATE(1472),
    [sym_last_case_item] = STATE(2281),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(1472),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2259),
  },
  [2031] = {
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_RPAREN] = ACTIONS(4387),
    [anon_sym_PIPE_AMP] = ACTIONS(4387),
    [anon_sym_AMP_AMP] = ACTIONS(4387),
    [anon_sym_PIPE_PIPE] = ACTIONS(4387),
    [anon_sym_BQUOTE] = ACTIONS(4387),
    [sym_comment] = ACTIONS(53),
  },
  [2032] = {
    [anon_sym_esac] = ACTIONS(5341),
    [sym_comment] = ACTIONS(53),
  },
  [2033] = {
    [anon_sym_PIPE] = ACTIONS(4391),
    [anon_sym_RPAREN] = ACTIONS(4393),
    [anon_sym_PIPE_AMP] = ACTIONS(4393),
    [anon_sym_AMP_AMP] = ACTIONS(4393),
    [anon_sym_PIPE_PIPE] = ACTIONS(4393),
    [anon_sym_BQUOTE] = ACTIONS(4393),
    [sym_comment] = ACTIONS(53),
  },
  [2034] = {
    [sym_case_item] = STATE(1472),
    [sym_last_case_item] = STATE(2283),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1046),
    [sym_simple_expansion] = STATE(1046),
    [sym_string_expansion] = STATE(1046),
    [sym_expansion] = STATE(1046),
    [sym_command_substitution] = STATE(1046),
    [sym_process_substitution] = STATE(1046),
    [aux_sym_case_statement_repeat1] = STATE(1472),
    [sym__special_characters] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2259),
  },
  [2035] = {
    [anon_sym_PIPE] = ACTIONS(4423),
    [anon_sym_RPAREN] = ACTIONS(4425),
    [anon_sym_PIPE_AMP] = ACTIONS(4425),
    [anon_sym_AMP_AMP] = ACTIONS(4425),
    [anon_sym_PIPE_PIPE] = ACTIONS(4425),
    [anon_sym_BQUOTE] = ACTIONS(4425),
    [sym_comment] = ACTIONS(53),
  },
  [2036] = {
    [aux_sym_concatenation_repeat1] = STATE(2039),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(53),
  },
  [2037] = {
    [aux_sym_concatenation_repeat1] = STATE(2039),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [2038] = {
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [2039] = {
    [aux_sym_concatenation_repeat1] = STATE(2284),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [2040] = {
    [aux_sym_concatenation_repeat1] = STATE(2044),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(4799),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [sym_comment] = ACTIONS(53),
  },
  [2041] = {
    [aux_sym_concatenation_repeat1] = STATE(2044),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(4799),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [2042] = {
    [sym_file_descriptor] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [2043] = {
    [sym_string] = STATE(2285),
    [sym_simple_expansion] = STATE(2285),
    [sym_string_expansion] = STATE(2285),
    [sym_expansion] = STATE(2285),
    [sym_command_substitution] = STATE(2285),
    [sym_process_substitution] = STATE(2285),
    [sym__special_characters] = ACTIONS(5343),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4012),
    [sym_raw_string] = ACTIONS(5343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4020),
    [anon_sym_LT_LPAREN] = ACTIONS(4022),
    [anon_sym_GT_LPAREN] = ACTIONS(4022),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5343),
  },
  [2044] = {
    [aux_sym_concatenation_repeat1] = STATE(2286),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(4799),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_LT] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [2045] = {
    [sym_file_descriptor] = ACTIONS(697),
    [sym__concat] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_PIPE_AMP] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(697),
    [anon_sym_AMP_GT] = ACTIONS(699),
    [anon_sym_AMP_GT_GT] = ACTIONS(697),
    [anon_sym_LT_AMP] = ACTIONS(697),
    [anon_sym_GT_AMP] = ACTIONS(697),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_LT] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
  },
  [2046] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(5345),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2047] = {
    [sym_file_descriptor] = ACTIONS(727),
    [sym__concat] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(727),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(727),
    [anon_sym_PIPE_PIPE] = ACTIONS(727),
    [anon_sym_LT] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_AMP_GT] = ACTIONS(729),
    [anon_sym_AMP_GT_GT] = ACTIONS(727),
    [anon_sym_LT_AMP] = ACTIONS(727),
    [anon_sym_GT_AMP] = ACTIONS(727),
    [anon_sym_LT_LT] = ACTIONS(729),
    [anon_sym_LT_LT_DASH] = ACTIONS(727),
    [anon_sym_LT_LT_LT] = ACTIONS(727),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
  },
  [2048] = {
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
  },
  [2049] = {
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(735),
    [anon_sym_LT_AMP] = ACTIONS(735),
    [anon_sym_GT_AMP] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(735),
    [anon_sym_LT_LT_LT] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
  },
  [2050] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(5347),
    [sym_comment] = ACTIONS(53),
  },
  [2051] = {
    [sym_concatenation] = STATE(2291),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2291),
    [anon_sym_RBRACE] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5351),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5355),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_COLON_QMARK] = ACTIONS(5351),
    [anon_sym_COLON_DASH] = ACTIONS(5351),
    [anon_sym_PERCENT] = ACTIONS(5351),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2052] = {
    [sym_subscript] = STATE(2295),
    [sym_variable_name] = ACTIONS(5357),
    [anon_sym_DOLLAR] = ACTIONS(5359),
    [anon_sym_DASH] = ACTIONS(5359),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5361),
    [anon_sym_STAR] = ACTIONS(5359),
    [anon_sym_AT] = ACTIONS(5359),
    [anon_sym_QMARK] = ACTIONS(5359),
    [anon_sym_0] = ACTIONS(5363),
    [anon_sym__] = ACTIONS(5363),
  },
  [2053] = {
    [sym_concatenation] = STATE(2298),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2298),
    [anon_sym_RBRACE] = ACTIONS(5365),
    [anon_sym_EQ] = ACTIONS(5367),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5371),
    [anon_sym_COLON] = ACTIONS(5367),
    [anon_sym_COLON_QMARK] = ACTIONS(5367),
    [anon_sym_COLON_DASH] = ACTIONS(5367),
    [anon_sym_PERCENT] = ACTIONS(5367),
    [anon_sym_DASH] = ACTIONS(5367),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2054] = {
    [sym_concatenation] = STATE(2301),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2301),
    [anon_sym_RBRACE] = ACTIONS(5373),
    [anon_sym_EQ] = ACTIONS(5375),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5379),
    [anon_sym_COLON] = ACTIONS(5375),
    [anon_sym_COLON_QMARK] = ACTIONS(5375),
    [anon_sym_COLON_DASH] = ACTIONS(5375),
    [anon_sym_PERCENT] = ACTIONS(5375),
    [anon_sym_DASH] = ACTIONS(5375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2055] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5381),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2056] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5381),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2057] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(5381),
    [sym_comment] = ACTIONS(53),
  },
  [2058] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(5381),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2059] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5383),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2060] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5383),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2061] = {
    [sym_variable_name] = ACTIONS(3337),
    [anon_sym_PIPE] = ACTIONS(3339),
    [anon_sym_RPAREN] = ACTIONS(3337),
    [anon_sym_PIPE_AMP] = ACTIONS(3337),
    [anon_sym_AMP_AMP] = ACTIONS(3337),
    [anon_sym_PIPE_PIPE] = ACTIONS(3337),
    [sym__special_characters] = ACTIONS(3337),
    [anon_sym_DQUOTE] = ACTIONS(3337),
    [anon_sym_DOLLAR] = ACTIONS(3339),
    [sym_raw_string] = ACTIONS(3337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3337),
    [anon_sym_BQUOTE] = ACTIONS(3337),
    [anon_sym_LT_LPAREN] = ACTIONS(3337),
    [anon_sym_GT_LPAREN] = ACTIONS(3337),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3339),
    [sym_word] = ACTIONS(3339),
  },
  [2062] = {
    [sym__concat] = ACTIONS(3829),
    [sym_variable_name] = ACTIONS(3829),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_RPAREN] = ACTIONS(3829),
    [anon_sym_PIPE_AMP] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [sym__special_characters] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [sym_raw_string] = ACTIONS(3829),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3829),
    [anon_sym_BQUOTE] = ACTIONS(3829),
    [anon_sym_LT_LPAREN] = ACTIONS(3829),
    [anon_sym_GT_LPAREN] = ACTIONS(3829),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3831),
    [sym_word] = ACTIONS(3831),
  },
  [2063] = {
    [sym__concat] = ACTIONS(3835),
    [sym_variable_name] = ACTIONS(3835),
    [anon_sym_PIPE] = ACTIONS(3837),
    [anon_sym_RPAREN] = ACTIONS(3835),
    [anon_sym_PIPE_AMP] = ACTIONS(3835),
    [anon_sym_AMP_AMP] = ACTIONS(3835),
    [anon_sym_PIPE_PIPE] = ACTIONS(3835),
    [sym__special_characters] = ACTIONS(3835),
    [anon_sym_DQUOTE] = ACTIONS(3835),
    [anon_sym_DOLLAR] = ACTIONS(3837),
    [sym_raw_string] = ACTIONS(3835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3835),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3835),
    [anon_sym_BQUOTE] = ACTIONS(3835),
    [anon_sym_LT_LPAREN] = ACTIONS(3835),
    [anon_sym_GT_LPAREN] = ACTIONS(3835),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3837),
    [sym_word] = ACTIONS(3837),
  },
  [2064] = {
    [sym__concat] = ACTIONS(3920),
    [sym_variable_name] = ACTIONS(3920),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_RPAREN] = ACTIONS(3920),
    [anon_sym_PIPE_AMP] = ACTIONS(3920),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3920),
    [sym__special_characters] = ACTIONS(3920),
    [anon_sym_DQUOTE] = ACTIONS(3920),
    [anon_sym_DOLLAR] = ACTIONS(3922),
    [sym_raw_string] = ACTIONS(3920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3920),
    [anon_sym_BQUOTE] = ACTIONS(3920),
    [anon_sym_LT_LPAREN] = ACTIONS(3920),
    [anon_sym_GT_LPAREN] = ACTIONS(3920),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3922),
    [sym_word] = ACTIONS(3922),
  },
  [2065] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5385),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2066] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5387),
    [sym_comment] = ACTIONS(53),
  },
  [2067] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [sym_comment] = ACTIONS(53),
  },
  [2068] = {
    [anon_sym_RBRACE] = ACTIONS(5389),
    [sym_comment] = ACTIONS(53),
  },
  [2069] = {
    [sym_concatenation] = STATE(2308),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2308),
    [anon_sym_RBRACE] = ACTIONS(5391),
    [anon_sym_EQ] = ACTIONS(5393),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5395),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5393),
    [anon_sym_COLON_QMARK] = ACTIONS(5393),
    [anon_sym_COLON_DASH] = ACTIONS(5393),
    [anon_sym_PERCENT] = ACTIONS(5393),
    [anon_sym_DASH] = ACTIONS(5393),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2070] = {
    [sym__concat] = ACTIONS(3936),
    [sym_variable_name] = ACTIONS(3936),
    [anon_sym_PIPE] = ACTIONS(3938),
    [anon_sym_RPAREN] = ACTIONS(3936),
    [anon_sym_PIPE_AMP] = ACTIONS(3936),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3936),
    [sym__special_characters] = ACTIONS(3936),
    [anon_sym_DQUOTE] = ACTIONS(3936),
    [anon_sym_DOLLAR] = ACTIONS(3938),
    [sym_raw_string] = ACTIONS(3936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3936),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3936),
    [anon_sym_BQUOTE] = ACTIONS(3936),
    [anon_sym_LT_LPAREN] = ACTIONS(3936),
    [anon_sym_GT_LPAREN] = ACTIONS(3936),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3938),
    [sym_word] = ACTIONS(3938),
  },
  [2071] = {
    [sym_concatenation] = STATE(2310),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2310),
    [anon_sym_RBRACE] = ACTIONS(5397),
    [anon_sym_EQ] = ACTIONS(5399),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5399),
    [anon_sym_COLON_QMARK] = ACTIONS(5399),
    [anon_sym_COLON_DASH] = ACTIONS(5399),
    [anon_sym_PERCENT] = ACTIONS(5399),
    [anon_sym_DASH] = ACTIONS(5399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2072] = {
    [sym__concat] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym__special_characters] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3948),
    [sym_word] = ACTIONS(3948),
  },
  [2073] = {
    [sym_concatenation] = STATE(2312),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2312),
    [anon_sym_RBRACE] = ACTIONS(5403),
    [anon_sym_EQ] = ACTIONS(5405),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5405),
    [anon_sym_COLON_QMARK] = ACTIONS(5405),
    [anon_sym_COLON_DASH] = ACTIONS(5405),
    [anon_sym_PERCENT] = ACTIONS(5405),
    [anon_sym_DASH] = ACTIONS(5405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2074] = {
    [sym__concat] = ACTIONS(3956),
    [sym_variable_name] = ACTIONS(3956),
    [anon_sym_PIPE] = ACTIONS(3958),
    [anon_sym_RPAREN] = ACTIONS(3956),
    [anon_sym_PIPE_AMP] = ACTIONS(3956),
    [anon_sym_AMP_AMP] = ACTIONS(3956),
    [anon_sym_PIPE_PIPE] = ACTIONS(3956),
    [sym__special_characters] = ACTIONS(3956),
    [anon_sym_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [sym_raw_string] = ACTIONS(3956),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3956),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3956),
    [anon_sym_BQUOTE] = ACTIONS(3956),
    [anon_sym_LT_LPAREN] = ACTIONS(3956),
    [anon_sym_GT_LPAREN] = ACTIONS(3956),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3958),
    [sym_word] = ACTIONS(3958),
  },
  [2075] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5409),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2076] = {
    [sym__concat] = ACTIONS(3962),
    [sym_variable_name] = ACTIONS(3962),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_RPAREN] = ACTIONS(3962),
    [anon_sym_PIPE_AMP] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [sym__special_characters] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_DOLLAR] = ACTIONS(3964),
    [sym_raw_string] = ACTIONS(3962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3962),
    [anon_sym_BQUOTE] = ACTIONS(3962),
    [anon_sym_LT_LPAREN] = ACTIONS(3962),
    [anon_sym_GT_LPAREN] = ACTIONS(3962),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3964),
    [sym_word] = ACTIONS(3964),
  },
  [2077] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2078] = {
    [sym__concat] = ACTIONS(3829),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_RPAREN] = ACTIONS(3829),
    [anon_sym_PIPE_AMP] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [sym__special_characters] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [sym_raw_string] = ACTIONS(3829),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3829),
    [anon_sym_BQUOTE] = ACTIONS(3829),
    [anon_sym_LT_LPAREN] = ACTIONS(3829),
    [anon_sym_GT_LPAREN] = ACTIONS(3829),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3831),
    [sym_word] = ACTIONS(3831),
  },
  [2079] = {
    [sym__concat] = ACTIONS(3835),
    [anon_sym_PIPE] = ACTIONS(3837),
    [anon_sym_RPAREN] = ACTIONS(3835),
    [anon_sym_PIPE_AMP] = ACTIONS(3835),
    [anon_sym_AMP_AMP] = ACTIONS(3835),
    [anon_sym_PIPE_PIPE] = ACTIONS(3835),
    [sym__special_characters] = ACTIONS(3835),
    [anon_sym_DQUOTE] = ACTIONS(3835),
    [anon_sym_DOLLAR] = ACTIONS(3837),
    [sym_raw_string] = ACTIONS(3835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3835),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3835),
    [anon_sym_BQUOTE] = ACTIONS(3835),
    [anon_sym_LT_LPAREN] = ACTIONS(3835),
    [anon_sym_GT_LPAREN] = ACTIONS(3835),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3837),
    [sym_word] = ACTIONS(3837),
  },
  [2080] = {
    [sym__concat] = ACTIONS(3920),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_RPAREN] = ACTIONS(3920),
    [anon_sym_PIPE_AMP] = ACTIONS(3920),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3920),
    [sym__special_characters] = ACTIONS(3920),
    [anon_sym_DQUOTE] = ACTIONS(3920),
    [anon_sym_DOLLAR] = ACTIONS(3922),
    [sym_raw_string] = ACTIONS(3920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3920),
    [anon_sym_BQUOTE] = ACTIONS(3920),
    [anon_sym_LT_LPAREN] = ACTIONS(3920),
    [anon_sym_GT_LPAREN] = ACTIONS(3920),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3922),
    [sym_word] = ACTIONS(3922),
  },
  [2081] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5413),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2082] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5415),
    [sym_comment] = ACTIONS(53),
  },
  [2083] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5417),
    [sym_comment] = ACTIONS(53),
  },
  [2084] = {
    [anon_sym_RBRACE] = ACTIONS(5417),
    [sym_comment] = ACTIONS(53),
  },
  [2085] = {
    [sym_concatenation] = STATE(2319),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2319),
    [anon_sym_RBRACE] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5421),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5421),
    [anon_sym_COLON_QMARK] = ACTIONS(5421),
    [anon_sym_COLON_DASH] = ACTIONS(5421),
    [anon_sym_PERCENT] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2086] = {
    [sym__concat] = ACTIONS(3936),
    [anon_sym_PIPE] = ACTIONS(3938),
    [anon_sym_RPAREN] = ACTIONS(3936),
    [anon_sym_PIPE_AMP] = ACTIONS(3936),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3936),
    [sym__special_characters] = ACTIONS(3936),
    [anon_sym_DQUOTE] = ACTIONS(3936),
    [anon_sym_DOLLAR] = ACTIONS(3938),
    [sym_raw_string] = ACTIONS(3936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3936),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3936),
    [anon_sym_BQUOTE] = ACTIONS(3936),
    [anon_sym_LT_LPAREN] = ACTIONS(3936),
    [anon_sym_GT_LPAREN] = ACTIONS(3936),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3938),
    [sym_word] = ACTIONS(3938),
  },
  [2087] = {
    [sym_concatenation] = STATE(2321),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2321),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_EQ] = ACTIONS(5427),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5427),
    [anon_sym_COLON_QMARK] = ACTIONS(5427),
    [anon_sym_COLON_DASH] = ACTIONS(5427),
    [anon_sym_PERCENT] = ACTIONS(5427),
    [anon_sym_DASH] = ACTIONS(5427),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2088] = {
    [sym__concat] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym__special_characters] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3948),
    [sym_word] = ACTIONS(3948),
  },
  [2089] = {
    [sym_concatenation] = STATE(2323),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2323),
    [anon_sym_RBRACE] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5433),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5435),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5433),
    [anon_sym_COLON_QMARK] = ACTIONS(5433),
    [anon_sym_COLON_DASH] = ACTIONS(5433),
    [anon_sym_PERCENT] = ACTIONS(5433),
    [anon_sym_DASH] = ACTIONS(5433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2090] = {
    [sym__concat] = ACTIONS(3956),
    [anon_sym_PIPE] = ACTIONS(3958),
    [anon_sym_RPAREN] = ACTIONS(3956),
    [anon_sym_PIPE_AMP] = ACTIONS(3956),
    [anon_sym_AMP_AMP] = ACTIONS(3956),
    [anon_sym_PIPE_PIPE] = ACTIONS(3956),
    [sym__special_characters] = ACTIONS(3956),
    [anon_sym_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [sym_raw_string] = ACTIONS(3956),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3956),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3956),
    [anon_sym_BQUOTE] = ACTIONS(3956),
    [anon_sym_LT_LPAREN] = ACTIONS(3956),
    [anon_sym_GT_LPAREN] = ACTIONS(3956),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3958),
    [sym_word] = ACTIONS(3958),
  },
  [2091] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5437),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2092] = {
    [sym__concat] = ACTIONS(3962),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_RPAREN] = ACTIONS(3962),
    [anon_sym_PIPE_AMP] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [sym__special_characters] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_DOLLAR] = ACTIONS(3964),
    [sym_raw_string] = ACTIONS(3962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3962),
    [anon_sym_BQUOTE] = ACTIONS(3962),
    [anon_sym_LT_LPAREN] = ACTIONS(3962),
    [anon_sym_GT_LPAREN] = ACTIONS(3962),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3964),
    [sym_word] = ACTIONS(3964),
  },
  [2093] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2094] = {
    [sym__simple_heredoc_body] = ACTIONS(4741),
    [sym__heredoc_body_beginning] = ACTIONS(4741),
    [sym_file_descriptor] = ACTIONS(4741),
    [sym__concat] = ACTIONS(4741),
    [anon_sym_PIPE] = ACTIONS(4743),
    [anon_sym_RPAREN] = ACTIONS(4741),
    [anon_sym_PIPE_AMP] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_EQ_TILDE] = ACTIONS(4743),
    [anon_sym_EQ_EQ] = ACTIONS(4743),
    [anon_sym_LT] = ACTIONS(4743),
    [anon_sym_GT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4741),
    [anon_sym_AMP_GT] = ACTIONS(4743),
    [anon_sym_AMP_GT_GT] = ACTIONS(4741),
    [anon_sym_LT_AMP] = ACTIONS(4741),
    [anon_sym_GT_AMP] = ACTIONS(4741),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_LT_LT_DASH] = ACTIONS(4741),
    [anon_sym_LT_LT_LT] = ACTIONS(4741),
    [sym__special_characters] = ACTIONS(4741),
    [anon_sym_DQUOTE] = ACTIONS(4741),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [sym_raw_string] = ACTIONS(4741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4741),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4741),
    [anon_sym_BQUOTE] = ACTIONS(4741),
    [anon_sym_LT_LPAREN] = ACTIONS(4741),
    [anon_sym_GT_LPAREN] = ACTIONS(4741),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4743),
  },
  [2095] = {
    [sym__simple_heredoc_body] = ACTIONS(4745),
    [sym__heredoc_body_beginning] = ACTIONS(4745),
    [sym_file_descriptor] = ACTIONS(4745),
    [sym__concat] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(4747),
    [anon_sym_RPAREN] = ACTIONS(4745),
    [anon_sym_PIPE_AMP] = ACTIONS(4745),
    [anon_sym_AMP_AMP] = ACTIONS(4745),
    [anon_sym_PIPE_PIPE] = ACTIONS(4745),
    [anon_sym_EQ_TILDE] = ACTIONS(4747),
    [anon_sym_EQ_EQ] = ACTIONS(4747),
    [anon_sym_LT] = ACTIONS(4747),
    [anon_sym_GT] = ACTIONS(4747),
    [anon_sym_GT_GT] = ACTIONS(4745),
    [anon_sym_AMP_GT] = ACTIONS(4747),
    [anon_sym_AMP_GT_GT] = ACTIONS(4745),
    [anon_sym_LT_AMP] = ACTIONS(4745),
    [anon_sym_GT_AMP] = ACTIONS(4745),
    [anon_sym_LT_LT] = ACTIONS(4747),
    [anon_sym_LT_LT_DASH] = ACTIONS(4745),
    [anon_sym_LT_LT_LT] = ACTIONS(4745),
    [sym__special_characters] = ACTIONS(4745),
    [anon_sym_DQUOTE] = ACTIONS(4745),
    [anon_sym_DOLLAR] = ACTIONS(4747),
    [sym_raw_string] = ACTIONS(4745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4745),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4745),
    [anon_sym_BQUOTE] = ACTIONS(4745),
    [anon_sym_LT_LPAREN] = ACTIONS(4745),
    [anon_sym_GT_LPAREN] = ACTIONS(4745),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4747),
  },
  [2096] = {
    [sym__simple_heredoc_body] = ACTIONS(4749),
    [sym__heredoc_body_beginning] = ACTIONS(4749),
    [sym_file_descriptor] = ACTIONS(4749),
    [sym__concat] = ACTIONS(4749),
    [anon_sym_PIPE] = ACTIONS(4751),
    [anon_sym_RPAREN] = ACTIONS(4749),
    [anon_sym_PIPE_AMP] = ACTIONS(4749),
    [anon_sym_AMP_AMP] = ACTIONS(4749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4749),
    [anon_sym_EQ_TILDE] = ACTIONS(4751),
    [anon_sym_EQ_EQ] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4751),
    [anon_sym_GT] = ACTIONS(4751),
    [anon_sym_GT_GT] = ACTIONS(4749),
    [anon_sym_AMP_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT_GT] = ACTIONS(4749),
    [anon_sym_LT_AMP] = ACTIONS(4749),
    [anon_sym_GT_AMP] = ACTIONS(4749),
    [anon_sym_LT_LT] = ACTIONS(4751),
    [anon_sym_LT_LT_DASH] = ACTIONS(4749),
    [anon_sym_LT_LT_LT] = ACTIONS(4749),
    [sym__special_characters] = ACTIONS(4749),
    [anon_sym_DQUOTE] = ACTIONS(4749),
    [anon_sym_DOLLAR] = ACTIONS(4751),
    [sym_raw_string] = ACTIONS(4749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4749),
    [anon_sym_BQUOTE] = ACTIONS(4749),
    [anon_sym_LT_LPAREN] = ACTIONS(4749),
    [anon_sym_GT_LPAREN] = ACTIONS(4749),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4751),
  },
  [2097] = {
    [sym__simple_heredoc_body] = ACTIONS(4753),
    [sym__heredoc_body_beginning] = ACTIONS(4753),
    [sym_file_descriptor] = ACTIONS(4753),
    [sym__concat] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4755),
    [anon_sym_RPAREN] = ACTIONS(4753),
    [anon_sym_PIPE_AMP] = ACTIONS(4753),
    [anon_sym_AMP_AMP] = ACTIONS(4753),
    [anon_sym_PIPE_PIPE] = ACTIONS(4753),
    [anon_sym_EQ_TILDE] = ACTIONS(4755),
    [anon_sym_EQ_EQ] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4755),
    [anon_sym_GT] = ACTIONS(4755),
    [anon_sym_GT_GT] = ACTIONS(4753),
    [anon_sym_AMP_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT_GT] = ACTIONS(4753),
    [anon_sym_LT_AMP] = ACTIONS(4753),
    [anon_sym_GT_AMP] = ACTIONS(4753),
    [anon_sym_LT_LT] = ACTIONS(4755),
    [anon_sym_LT_LT_DASH] = ACTIONS(4753),
    [anon_sym_LT_LT_LT] = ACTIONS(4753),
    [sym__special_characters] = ACTIONS(4753),
    [anon_sym_DQUOTE] = ACTIONS(4753),
    [anon_sym_DOLLAR] = ACTIONS(4755),
    [sym_raw_string] = ACTIONS(4753),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4753),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4753),
    [anon_sym_BQUOTE] = ACTIONS(4753),
    [anon_sym_LT_LPAREN] = ACTIONS(4753),
    [anon_sym_GT_LPAREN] = ACTIONS(4753),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4755),
  },
  [2098] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5441),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2099] = {
    [sym__simple_heredoc_body] = ACTIONS(4759),
    [sym__heredoc_body_beginning] = ACTIONS(4759),
    [sym_file_descriptor] = ACTIONS(4759),
    [sym__concat] = ACTIONS(4759),
    [anon_sym_PIPE] = ACTIONS(4761),
    [anon_sym_RPAREN] = ACTIONS(4759),
    [anon_sym_PIPE_AMP] = ACTIONS(4759),
    [anon_sym_AMP_AMP] = ACTIONS(4759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4759),
    [anon_sym_EQ_TILDE] = ACTIONS(4761),
    [anon_sym_EQ_EQ] = ACTIONS(4761),
    [anon_sym_LT] = ACTIONS(4761),
    [anon_sym_GT] = ACTIONS(4761),
    [anon_sym_GT_GT] = ACTIONS(4759),
    [anon_sym_AMP_GT] = ACTIONS(4761),
    [anon_sym_AMP_GT_GT] = ACTIONS(4759),
    [anon_sym_LT_AMP] = ACTIONS(4759),
    [anon_sym_GT_AMP] = ACTIONS(4759),
    [anon_sym_LT_LT] = ACTIONS(4761),
    [anon_sym_LT_LT_DASH] = ACTIONS(4759),
    [anon_sym_LT_LT_LT] = ACTIONS(4759),
    [sym__special_characters] = ACTIONS(4759),
    [anon_sym_DQUOTE] = ACTIONS(4759),
    [anon_sym_DOLLAR] = ACTIONS(4761),
    [sym_raw_string] = ACTIONS(4759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4759),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4759),
    [anon_sym_BQUOTE] = ACTIONS(4759),
    [anon_sym_LT_LPAREN] = ACTIONS(4759),
    [anon_sym_GT_LPAREN] = ACTIONS(4759),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4761),
  },
  [2100] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2101] = {
    [sym__simple_heredoc_body] = ACTIONS(4765),
    [sym__heredoc_body_beginning] = ACTIONS(4765),
    [sym_file_descriptor] = ACTIONS(4765),
    [sym__concat] = ACTIONS(4765),
    [anon_sym_PIPE] = ACTIONS(4767),
    [anon_sym_RPAREN] = ACTIONS(4765),
    [anon_sym_PIPE_AMP] = ACTIONS(4765),
    [anon_sym_AMP_AMP] = ACTIONS(4765),
    [anon_sym_PIPE_PIPE] = ACTIONS(4765),
    [anon_sym_EQ_TILDE] = ACTIONS(4767),
    [anon_sym_EQ_EQ] = ACTIONS(4767),
    [anon_sym_LT] = ACTIONS(4767),
    [anon_sym_GT] = ACTIONS(4767),
    [anon_sym_GT_GT] = ACTIONS(4765),
    [anon_sym_AMP_GT] = ACTIONS(4767),
    [anon_sym_AMP_GT_GT] = ACTIONS(4765),
    [anon_sym_LT_AMP] = ACTIONS(4765),
    [anon_sym_GT_AMP] = ACTIONS(4765),
    [anon_sym_LT_LT] = ACTIONS(4767),
    [anon_sym_LT_LT_DASH] = ACTIONS(4765),
    [anon_sym_LT_LT_LT] = ACTIONS(4765),
    [sym__special_characters] = ACTIONS(4765),
    [anon_sym_DQUOTE] = ACTIONS(4765),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [sym_raw_string] = ACTIONS(4765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4765),
    [anon_sym_BQUOTE] = ACTIONS(4765),
    [anon_sym_LT_LPAREN] = ACTIONS(4765),
    [anon_sym_GT_LPAREN] = ACTIONS(4765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4767),
  },
  [2102] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2103] = {
    [sym__simple_heredoc_body] = ACTIONS(4771),
    [sym__heredoc_body_beginning] = ACTIONS(4771),
    [sym_file_descriptor] = ACTIONS(4771),
    [sym__concat] = ACTIONS(4771),
    [anon_sym_PIPE] = ACTIONS(4773),
    [anon_sym_RPAREN] = ACTIONS(4771),
    [anon_sym_PIPE_AMP] = ACTIONS(4771),
    [anon_sym_AMP_AMP] = ACTIONS(4771),
    [anon_sym_PIPE_PIPE] = ACTIONS(4771),
    [anon_sym_EQ_TILDE] = ACTIONS(4773),
    [anon_sym_EQ_EQ] = ACTIONS(4773),
    [anon_sym_LT] = ACTIONS(4773),
    [anon_sym_GT] = ACTIONS(4773),
    [anon_sym_GT_GT] = ACTIONS(4771),
    [anon_sym_AMP_GT] = ACTIONS(4773),
    [anon_sym_AMP_GT_GT] = ACTIONS(4771),
    [anon_sym_LT_AMP] = ACTIONS(4771),
    [anon_sym_GT_AMP] = ACTIONS(4771),
    [anon_sym_LT_LT] = ACTIONS(4773),
    [anon_sym_LT_LT_DASH] = ACTIONS(4771),
    [anon_sym_LT_LT_LT] = ACTIONS(4771),
    [sym__special_characters] = ACTIONS(4771),
    [anon_sym_DQUOTE] = ACTIONS(4771),
    [anon_sym_DOLLAR] = ACTIONS(4773),
    [sym_raw_string] = ACTIONS(4771),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4771),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4771),
    [anon_sym_BQUOTE] = ACTIONS(4771),
    [anon_sym_LT_LPAREN] = ACTIONS(4771),
    [anon_sym_GT_LPAREN] = ACTIONS(4771),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4773),
  },
  [2104] = {
    [sym__simple_heredoc_body] = ACTIONS(4775),
    [sym__heredoc_body_beginning] = ACTIONS(4775),
    [sym_file_descriptor] = ACTIONS(4775),
    [sym__concat] = ACTIONS(4775),
    [anon_sym_PIPE] = ACTIONS(4777),
    [anon_sym_RPAREN] = ACTIONS(4775),
    [anon_sym_PIPE_AMP] = ACTIONS(4775),
    [anon_sym_AMP_AMP] = ACTIONS(4775),
    [anon_sym_PIPE_PIPE] = ACTIONS(4775),
    [anon_sym_EQ_TILDE] = ACTIONS(4777),
    [anon_sym_EQ_EQ] = ACTIONS(4777),
    [anon_sym_LT] = ACTIONS(4777),
    [anon_sym_GT] = ACTIONS(4777),
    [anon_sym_GT_GT] = ACTIONS(4775),
    [anon_sym_AMP_GT] = ACTIONS(4777),
    [anon_sym_AMP_GT_GT] = ACTIONS(4775),
    [anon_sym_LT_AMP] = ACTIONS(4775),
    [anon_sym_GT_AMP] = ACTIONS(4775),
    [anon_sym_LT_LT] = ACTIONS(4777),
    [anon_sym_LT_LT_DASH] = ACTIONS(4775),
    [anon_sym_LT_LT_LT] = ACTIONS(4775),
    [sym__special_characters] = ACTIONS(4775),
    [anon_sym_DQUOTE] = ACTIONS(4775),
    [anon_sym_DOLLAR] = ACTIONS(4777),
    [sym_raw_string] = ACTIONS(4775),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4775),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4775),
    [anon_sym_BQUOTE] = ACTIONS(4775),
    [anon_sym_LT_LPAREN] = ACTIONS(4775),
    [anon_sym_GT_LPAREN] = ACTIONS(4775),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4777),
  },
  [2105] = {
    [aux_sym_concatenation_repeat1] = STATE(2107),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(53),
  },
  [2106] = {
    [aux_sym_concatenation_repeat1] = STATE(2107),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [2107] = {
    [aux_sym_concatenation_repeat1] = STATE(2329),
    [sym__concat] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [2108] = {
    [aux_sym_concatenation_repeat1] = STATE(2110),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(4799),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(53),
  },
  [2109] = {
    [aux_sym_concatenation_repeat1] = STATE(2110),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(4799),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [2110] = {
    [aux_sym_concatenation_repeat1] = STATE(2330),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(4799),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_LT] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [2111] = {
    [sym__heredoc_body_middle] = ACTIONS(3829),
    [sym__heredoc_body_end] = ACTIONS(3829),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3829),
    [sym_comment] = ACTIONS(53),
  },
  [2112] = {
    [sym__heredoc_body_middle] = ACTIONS(3835),
    [sym__heredoc_body_end] = ACTIONS(3835),
    [anon_sym_DOLLAR] = ACTIONS(3837),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3835),
    [sym_comment] = ACTIONS(53),
  },
  [2113] = {
    [sym__heredoc_body_middle] = ACTIONS(3920),
    [sym__heredoc_body_end] = ACTIONS(3920),
    [anon_sym_DOLLAR] = ACTIONS(3922),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3920),
    [sym_comment] = ACTIONS(53),
  },
  [2114] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2115] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5449),
    [sym_comment] = ACTIONS(53),
  },
  [2116] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [sym_comment] = ACTIONS(53),
  },
  [2117] = {
    [anon_sym_RBRACE] = ACTIONS(5451),
    [sym_comment] = ACTIONS(53),
  },
  [2118] = {
    [sym_concatenation] = STATE(2335),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2335),
    [anon_sym_RBRACE] = ACTIONS(5453),
    [anon_sym_EQ] = ACTIONS(5455),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5455),
    [anon_sym_COLON_QMARK] = ACTIONS(5455),
    [anon_sym_COLON_DASH] = ACTIONS(5455),
    [anon_sym_PERCENT] = ACTIONS(5455),
    [anon_sym_DASH] = ACTIONS(5455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2119] = {
    [sym__heredoc_body_middle] = ACTIONS(3936),
    [sym__heredoc_body_end] = ACTIONS(3936),
    [anon_sym_DOLLAR] = ACTIONS(3938),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3936),
    [sym_comment] = ACTIONS(53),
  },
  [2120] = {
    [sym_concatenation] = STATE(2337),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2337),
    [anon_sym_RBRACE] = ACTIONS(5459),
    [anon_sym_EQ] = ACTIONS(5461),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5461),
    [anon_sym_COLON_QMARK] = ACTIONS(5461),
    [anon_sym_COLON_DASH] = ACTIONS(5461),
    [anon_sym_PERCENT] = ACTIONS(5461),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2121] = {
    [sym__heredoc_body_middle] = ACTIONS(3946),
    [sym__heredoc_body_end] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [sym_comment] = ACTIONS(53),
  },
  [2122] = {
    [sym_concatenation] = STATE(2339),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2339),
    [anon_sym_RBRACE] = ACTIONS(5465),
    [anon_sym_EQ] = ACTIONS(5467),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5467),
    [anon_sym_COLON_QMARK] = ACTIONS(5467),
    [anon_sym_COLON_DASH] = ACTIONS(5467),
    [anon_sym_PERCENT] = ACTIONS(5467),
    [anon_sym_DASH] = ACTIONS(5467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2123] = {
    [sym__heredoc_body_middle] = ACTIONS(3956),
    [sym__heredoc_body_end] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3956),
    [sym_comment] = ACTIONS(53),
  },
  [2124] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5471),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2125] = {
    [sym__heredoc_body_middle] = ACTIONS(3962),
    [sym__heredoc_body_end] = ACTIONS(3962),
    [anon_sym_DOLLAR] = ACTIONS(3964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3962),
    [sym_comment] = ACTIONS(53),
  },
  [2126] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5473),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2127] = {
    [sym__concat] = ACTIONS(3829),
    [anon_sym_RPAREN] = ACTIONS(3829),
    [sym__special_characters] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [sym_raw_string] = ACTIONS(3829),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3829),
    [anon_sym_BQUOTE] = ACTIONS(3829),
    [anon_sym_LT_LPAREN] = ACTIONS(3829),
    [anon_sym_GT_LPAREN] = ACTIONS(3829),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3829),
  },
  [2128] = {
    [sym__concat] = ACTIONS(3835),
    [anon_sym_RPAREN] = ACTIONS(3835),
    [sym__special_characters] = ACTIONS(3835),
    [anon_sym_DQUOTE] = ACTIONS(3835),
    [anon_sym_DOLLAR] = ACTIONS(3837),
    [sym_raw_string] = ACTIONS(3835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3835),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3835),
    [anon_sym_BQUOTE] = ACTIONS(3835),
    [anon_sym_LT_LPAREN] = ACTIONS(3835),
    [anon_sym_GT_LPAREN] = ACTIONS(3835),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3835),
  },
  [2129] = {
    [sym__concat] = ACTIONS(3920),
    [anon_sym_RPAREN] = ACTIONS(3920),
    [sym__special_characters] = ACTIONS(3920),
    [anon_sym_DQUOTE] = ACTIONS(3920),
    [anon_sym_DOLLAR] = ACTIONS(3922),
    [sym_raw_string] = ACTIONS(3920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3920),
    [anon_sym_BQUOTE] = ACTIONS(3920),
    [anon_sym_LT_LPAREN] = ACTIONS(3920),
    [anon_sym_GT_LPAREN] = ACTIONS(3920),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3920),
  },
  [2130] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5475),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2131] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5477),
    [sym_comment] = ACTIONS(53),
  },
  [2132] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5479),
    [sym_comment] = ACTIONS(53),
  },
  [2133] = {
    [anon_sym_RBRACE] = ACTIONS(5479),
    [sym_comment] = ACTIONS(53),
  },
  [2134] = {
    [sym_concatenation] = STATE(2346),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2346),
    [anon_sym_RBRACE] = ACTIONS(5481),
    [anon_sym_EQ] = ACTIONS(5483),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5485),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5483),
    [anon_sym_COLON_QMARK] = ACTIONS(5483),
    [anon_sym_COLON_DASH] = ACTIONS(5483),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_DASH] = ACTIONS(5483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2135] = {
    [sym__concat] = ACTIONS(3936),
    [anon_sym_RPAREN] = ACTIONS(3936),
    [sym__special_characters] = ACTIONS(3936),
    [anon_sym_DQUOTE] = ACTIONS(3936),
    [anon_sym_DOLLAR] = ACTIONS(3938),
    [sym_raw_string] = ACTIONS(3936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3936),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3936),
    [anon_sym_BQUOTE] = ACTIONS(3936),
    [anon_sym_LT_LPAREN] = ACTIONS(3936),
    [anon_sym_GT_LPAREN] = ACTIONS(3936),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3936),
  },
  [2136] = {
    [sym_concatenation] = STATE(2348),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2348),
    [anon_sym_RBRACE] = ACTIONS(5487),
    [anon_sym_EQ] = ACTIONS(5489),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5491),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5489),
    [anon_sym_COLON_QMARK] = ACTIONS(5489),
    [anon_sym_COLON_DASH] = ACTIONS(5489),
    [anon_sym_PERCENT] = ACTIONS(5489),
    [anon_sym_DASH] = ACTIONS(5489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2137] = {
    [sym__concat] = ACTIONS(3946),
    [anon_sym_RPAREN] = ACTIONS(3946),
    [sym__special_characters] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3946),
  },
  [2138] = {
    [sym_concatenation] = STATE(2350),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2350),
    [anon_sym_RBRACE] = ACTIONS(5493),
    [anon_sym_EQ] = ACTIONS(5495),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5497),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5495),
    [anon_sym_COLON_QMARK] = ACTIONS(5495),
    [anon_sym_COLON_DASH] = ACTIONS(5495),
    [anon_sym_PERCENT] = ACTIONS(5495),
    [anon_sym_DASH] = ACTIONS(5495),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2139] = {
    [sym__concat] = ACTIONS(3956),
    [anon_sym_RPAREN] = ACTIONS(3956),
    [sym__special_characters] = ACTIONS(3956),
    [anon_sym_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [sym_raw_string] = ACTIONS(3956),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3956),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3956),
    [anon_sym_BQUOTE] = ACTIONS(3956),
    [anon_sym_LT_LPAREN] = ACTIONS(3956),
    [anon_sym_GT_LPAREN] = ACTIONS(3956),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3956),
  },
  [2140] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5499),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2141] = {
    [sym__concat] = ACTIONS(3962),
    [anon_sym_RPAREN] = ACTIONS(3962),
    [sym__special_characters] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_DOLLAR] = ACTIONS(3964),
    [sym_raw_string] = ACTIONS(3962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3962),
    [anon_sym_BQUOTE] = ACTIONS(3962),
    [anon_sym_LT_LPAREN] = ACTIONS(3962),
    [anon_sym_GT_LPAREN] = ACTIONS(3962),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3962),
  },
  [2142] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5501),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2143] = {
    [sym_file_descriptor] = ACTIONS(4741),
    [sym__concat] = ACTIONS(4741),
    [sym_variable_name] = ACTIONS(4741),
    [anon_sym_esac] = ACTIONS(4743),
    [anon_sym_PIPE] = ACTIONS(4743),
    [anon_sym_RPAREN] = ACTIONS(4743),
    [anon_sym_SEMI_SEMI] = ACTIONS(4743),
    [anon_sym_PIPE_AMP] = ACTIONS(4743),
    [anon_sym_AMP_AMP] = ACTIONS(4743),
    [anon_sym_PIPE_PIPE] = ACTIONS(4743),
    [anon_sym_LT] = ACTIONS(4743),
    [anon_sym_GT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_AMP_GT] = ACTIONS(4743),
    [anon_sym_AMP_GT_GT] = ACTIONS(4743),
    [anon_sym_LT_AMP] = ACTIONS(4743),
    [anon_sym_GT_AMP] = ACTIONS(4743),
    [sym__special_characters] = ACTIONS(4743),
    [anon_sym_DQUOTE] = ACTIONS(4743),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [sym_raw_string] = ACTIONS(4743),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4743),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [anon_sym_LT_LPAREN] = ACTIONS(4743),
    [anon_sym_GT_LPAREN] = ACTIONS(4743),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4743),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_LF] = ACTIONS(4741),
    [anon_sym_AMP] = ACTIONS(4743),
  },
  [2144] = {
    [sym_file_descriptor] = ACTIONS(4745),
    [sym__concat] = ACTIONS(4745),
    [sym_variable_name] = ACTIONS(4745),
    [anon_sym_esac] = ACTIONS(4747),
    [anon_sym_PIPE] = ACTIONS(4747),
    [anon_sym_RPAREN] = ACTIONS(4747),
    [anon_sym_SEMI_SEMI] = ACTIONS(4747),
    [anon_sym_PIPE_AMP] = ACTIONS(4747),
    [anon_sym_AMP_AMP] = ACTIONS(4747),
    [anon_sym_PIPE_PIPE] = ACTIONS(4747),
    [anon_sym_LT] = ACTIONS(4747),
    [anon_sym_GT] = ACTIONS(4747),
    [anon_sym_GT_GT] = ACTIONS(4747),
    [anon_sym_AMP_GT] = ACTIONS(4747),
    [anon_sym_AMP_GT_GT] = ACTIONS(4747),
    [anon_sym_LT_AMP] = ACTIONS(4747),
    [anon_sym_GT_AMP] = ACTIONS(4747),
    [sym__special_characters] = ACTIONS(4747),
    [anon_sym_DQUOTE] = ACTIONS(4747),
    [anon_sym_DOLLAR] = ACTIONS(4747),
    [sym_raw_string] = ACTIONS(4747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4747),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4747),
    [anon_sym_BQUOTE] = ACTIONS(4747),
    [anon_sym_LT_LPAREN] = ACTIONS(4747),
    [anon_sym_GT_LPAREN] = ACTIONS(4747),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4747),
    [anon_sym_SEMI] = ACTIONS(4747),
    [anon_sym_LF] = ACTIONS(4745),
    [anon_sym_AMP] = ACTIONS(4747),
  },
  [2145] = {
    [sym_file_descriptor] = ACTIONS(4749),
    [sym__concat] = ACTIONS(4749),
    [sym_variable_name] = ACTIONS(4749),
    [anon_sym_esac] = ACTIONS(4751),
    [anon_sym_PIPE] = ACTIONS(4751),
    [anon_sym_RPAREN] = ACTIONS(4751),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4751),
    [anon_sym_GT] = ACTIONS(4751),
    [anon_sym_GT_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT_GT] = ACTIONS(4751),
    [anon_sym_LT_AMP] = ACTIONS(4751),
    [anon_sym_GT_AMP] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4751),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4751),
    [anon_sym_LF] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(4751),
  },
  [2146] = {
    [sym_file_descriptor] = ACTIONS(4753),
    [sym__concat] = ACTIONS(4753),
    [sym_variable_name] = ACTIONS(4753),
    [anon_sym_esac] = ACTIONS(4755),
    [anon_sym_PIPE] = ACTIONS(4755),
    [anon_sym_RPAREN] = ACTIONS(4755),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4755),
    [anon_sym_GT] = ACTIONS(4755),
    [anon_sym_GT_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT_GT] = ACTIONS(4755),
    [anon_sym_LT_AMP] = ACTIONS(4755),
    [anon_sym_GT_AMP] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4755),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_LF] = ACTIONS(4753),
    [anon_sym_AMP] = ACTIONS(4755),
  },
  [2147] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5503),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2148] = {
    [sym_file_descriptor] = ACTIONS(4759),
    [sym__concat] = ACTIONS(4759),
    [sym_variable_name] = ACTIONS(4759),
    [anon_sym_esac] = ACTIONS(4761),
    [anon_sym_PIPE] = ACTIONS(4761),
    [anon_sym_RPAREN] = ACTIONS(4761),
    [anon_sym_SEMI_SEMI] = ACTIONS(4761),
    [anon_sym_PIPE_AMP] = ACTIONS(4761),
    [anon_sym_AMP_AMP] = ACTIONS(4761),
    [anon_sym_PIPE_PIPE] = ACTIONS(4761),
    [anon_sym_LT] = ACTIONS(4761),
    [anon_sym_GT] = ACTIONS(4761),
    [anon_sym_GT_GT] = ACTIONS(4761),
    [anon_sym_AMP_GT] = ACTIONS(4761),
    [anon_sym_AMP_GT_GT] = ACTIONS(4761),
    [anon_sym_LT_AMP] = ACTIONS(4761),
    [anon_sym_GT_AMP] = ACTIONS(4761),
    [sym__special_characters] = ACTIONS(4761),
    [anon_sym_DQUOTE] = ACTIONS(4761),
    [anon_sym_DOLLAR] = ACTIONS(4761),
    [sym_raw_string] = ACTIONS(4761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4761),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4761),
    [anon_sym_BQUOTE] = ACTIONS(4761),
    [anon_sym_LT_LPAREN] = ACTIONS(4761),
    [anon_sym_GT_LPAREN] = ACTIONS(4761),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4761),
    [anon_sym_SEMI] = ACTIONS(4761),
    [anon_sym_LF] = ACTIONS(4759),
    [anon_sym_AMP] = ACTIONS(4761),
  },
  [2149] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5505),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2150] = {
    [sym_file_descriptor] = ACTIONS(4765),
    [sym__concat] = ACTIONS(4765),
    [sym_variable_name] = ACTIONS(4765),
    [anon_sym_esac] = ACTIONS(4767),
    [anon_sym_PIPE] = ACTIONS(4767),
    [anon_sym_RPAREN] = ACTIONS(4767),
    [anon_sym_SEMI_SEMI] = ACTIONS(4767),
    [anon_sym_PIPE_AMP] = ACTIONS(4767),
    [anon_sym_AMP_AMP] = ACTIONS(4767),
    [anon_sym_PIPE_PIPE] = ACTIONS(4767),
    [anon_sym_LT] = ACTIONS(4767),
    [anon_sym_GT] = ACTIONS(4767),
    [anon_sym_GT_GT] = ACTIONS(4767),
    [anon_sym_AMP_GT] = ACTIONS(4767),
    [anon_sym_AMP_GT_GT] = ACTIONS(4767),
    [anon_sym_LT_AMP] = ACTIONS(4767),
    [anon_sym_GT_AMP] = ACTIONS(4767),
    [sym__special_characters] = ACTIONS(4767),
    [anon_sym_DQUOTE] = ACTIONS(4767),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [sym_raw_string] = ACTIONS(4767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4767),
    [anon_sym_BQUOTE] = ACTIONS(4767),
    [anon_sym_LT_LPAREN] = ACTIONS(4767),
    [anon_sym_GT_LPAREN] = ACTIONS(4767),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4767),
    [anon_sym_SEMI] = ACTIONS(4767),
    [anon_sym_LF] = ACTIONS(4765),
    [anon_sym_AMP] = ACTIONS(4767),
  },
  [2151] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5507),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2152] = {
    [sym_file_descriptor] = ACTIONS(4771),
    [sym__concat] = ACTIONS(4771),
    [sym_variable_name] = ACTIONS(4771),
    [anon_sym_esac] = ACTIONS(4773),
    [anon_sym_PIPE] = ACTIONS(4773),
    [anon_sym_RPAREN] = ACTIONS(4773),
    [anon_sym_SEMI_SEMI] = ACTIONS(4773),
    [anon_sym_PIPE_AMP] = ACTIONS(4773),
    [anon_sym_AMP_AMP] = ACTIONS(4773),
    [anon_sym_PIPE_PIPE] = ACTIONS(4773),
    [anon_sym_LT] = ACTIONS(4773),
    [anon_sym_GT] = ACTIONS(4773),
    [anon_sym_GT_GT] = ACTIONS(4773),
    [anon_sym_AMP_GT] = ACTIONS(4773),
    [anon_sym_AMP_GT_GT] = ACTIONS(4773),
    [anon_sym_LT_AMP] = ACTIONS(4773),
    [anon_sym_GT_AMP] = ACTIONS(4773),
    [sym__special_characters] = ACTIONS(4773),
    [anon_sym_DQUOTE] = ACTIONS(4773),
    [anon_sym_DOLLAR] = ACTIONS(4773),
    [sym_raw_string] = ACTIONS(4773),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4773),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4773),
    [anon_sym_BQUOTE] = ACTIONS(4773),
    [anon_sym_LT_LPAREN] = ACTIONS(4773),
    [anon_sym_GT_LPAREN] = ACTIONS(4773),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4773),
    [anon_sym_SEMI] = ACTIONS(4773),
    [anon_sym_LF] = ACTIONS(4771),
    [anon_sym_AMP] = ACTIONS(4773),
  },
  [2153] = {
    [sym_file_descriptor] = ACTIONS(4775),
    [sym__concat] = ACTIONS(4775),
    [sym_variable_name] = ACTIONS(4775),
    [anon_sym_esac] = ACTIONS(4777),
    [anon_sym_PIPE] = ACTIONS(4777),
    [anon_sym_RPAREN] = ACTIONS(4777),
    [anon_sym_SEMI_SEMI] = ACTIONS(4777),
    [anon_sym_PIPE_AMP] = ACTIONS(4777),
    [anon_sym_AMP_AMP] = ACTIONS(4777),
    [anon_sym_PIPE_PIPE] = ACTIONS(4777),
    [anon_sym_LT] = ACTIONS(4777),
    [anon_sym_GT] = ACTIONS(4777),
    [anon_sym_GT_GT] = ACTIONS(4777),
    [anon_sym_AMP_GT] = ACTIONS(4777),
    [anon_sym_AMP_GT_GT] = ACTIONS(4777),
    [anon_sym_LT_AMP] = ACTIONS(4777),
    [anon_sym_GT_AMP] = ACTIONS(4777),
    [sym__special_characters] = ACTIONS(4777),
    [anon_sym_DQUOTE] = ACTIONS(4777),
    [anon_sym_DOLLAR] = ACTIONS(4777),
    [sym_raw_string] = ACTIONS(4777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4777),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4777),
    [anon_sym_BQUOTE] = ACTIONS(4777),
    [anon_sym_LT_LPAREN] = ACTIONS(4777),
    [anon_sym_GT_LPAREN] = ACTIONS(4777),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4777),
    [anon_sym_SEMI] = ACTIONS(4777),
    [anon_sym_LF] = ACTIONS(4775),
    [anon_sym_AMP] = ACTIONS(4777),
  },
  [2154] = {
    [sym_concatenation] = STATE(212),
    [sym_string] = STATE(2357),
    [sym_array] = STATE(212),
    [sym_simple_expansion] = STATE(2357),
    [sym_string_expansion] = STATE(2357),
    [sym_expansion] = STATE(2357),
    [sym_command_substitution] = STATE(2357),
    [sym_process_substitution] = STATE(2357),
    [sym__empty_value] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(387),
    [sym__special_characters] = ACTIONS(5509),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [sym_raw_string] = ACTIONS(5511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(399),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(403),
    [anon_sym_GT_LPAREN] = ACTIONS(403),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5511),
  },
  [2155] = {
    [sym_do_group] = STATE(2358),
    [anon_sym_do] = ACTIONS(411),
    [sym_comment] = ACTIONS(53),
  },
  [2156] = {
    [sym_compound_statement] = STATE(2360),
    [anon_sym_LPAREN] = ACTIONS(5513),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [2157] = {
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_RBRACK] = ACTIONS(5515),
    [anon_sym_EQ_TILDE] = ACTIONS(547),
    [anon_sym_EQ_EQ] = ACTIONS(547),
    [anon_sym_EQ] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(543),
  },
  [2158] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5515),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [2159] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(5517),
    [anon_sym_PLUS_EQ] = ACTIONS(5517),
    [sym_comment] = ACTIONS(53),
  },
  [2160] = {
    [aux_sym_concatenation_repeat1] = STATE(2364),
    [sym__concat] = ACTIONS(5519),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_esac] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(585),
    [anon_sym_SEMI_SEMI] = ACTIONS(585),
    [anon_sym_PIPE_AMP] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [sym__special_characters] = ACTIONS(585),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(585),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(585),
    [anon_sym_LF] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(585),
  },
  [2161] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(2366),
    [anon_sym_DQUOTE] = ACTIONS(5521),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2162] = {
    [sym_string] = STATE(2368),
    [anon_sym_DQUOTE] = ACTIONS(5523),
    [anon_sym_DOLLAR] = ACTIONS(5525),
    [sym_raw_string] = ACTIONS(5527),
    [anon_sym_POUND] = ACTIONS(5525),
    [anon_sym_DASH] = ACTIONS(5525),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5529),
    [anon_sym_STAR] = ACTIONS(5525),
    [anon_sym_AT] = ACTIONS(5525),
    [anon_sym_QMARK] = ACTIONS(5525),
    [anon_sym_0] = ACTIONS(5531),
    [anon_sym__] = ACTIONS(5531),
  },
  [2163] = {
    [aux_sym_concatenation_repeat1] = STATE(2364),
    [sym__concat] = ACTIONS(5519),
    [sym_variable_name] = ACTIONS(599),
    [anon_sym_esac] = ACTIONS(601),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_SEMI_SEMI] = ACTIONS(601),
    [anon_sym_PIPE_AMP] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [anon_sym_DOLLAR] = ACTIONS(601),
    [sym_raw_string] = ACTIONS(601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(601),
    [anon_sym_BQUOTE] = ACTIONS(601),
    [anon_sym_LT_LPAREN] = ACTIONS(601),
    [anon_sym_GT_LPAREN] = ACTIONS(601),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(601),
    [sym_word] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(601),
  },
  [2164] = {
    [sym_subscript] = STATE(2374),
    [sym_variable_name] = ACTIONS(5533),
    [anon_sym_DOLLAR] = ACTIONS(5535),
    [anon_sym_POUND] = ACTIONS(5537),
    [anon_sym_DASH] = ACTIONS(5535),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5539),
    [anon_sym_STAR] = ACTIONS(5535),
    [anon_sym_AT] = ACTIONS(5535),
    [anon_sym_QMARK] = ACTIONS(5535),
    [anon_sym_0] = ACTIONS(5541),
    [anon_sym__] = ACTIONS(5541),
  },
  [2165] = {
    [sym_for_statement] = STATE(2375),
    [sym_while_statement] = STATE(2375),
    [sym_if_statement] = STATE(2375),
    [sym_case_statement] = STATE(2375),
    [sym_function_definition] = STATE(2375),
    [sym_subshell] = STATE(2375),
    [sym_pipeline] = STATE(2375),
    [sym_list] = STATE(2375),
    [sym_negated_command] = STATE(2375),
    [sym_test_command] = STATE(2375),
    [sym_declaration_command] = STATE(2375),
    [sym_unset_command] = STATE(2375),
    [sym_command] = STATE(2375),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2376),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2166] = {
    [sym_for_statement] = STATE(2377),
    [sym_while_statement] = STATE(2377),
    [sym_if_statement] = STATE(2377),
    [sym_case_statement] = STATE(2377),
    [sym_function_definition] = STATE(2377),
    [sym_subshell] = STATE(2377),
    [sym_pipeline] = STATE(2377),
    [sym_list] = STATE(2377),
    [sym_negated_command] = STATE(2377),
    [sym_test_command] = STATE(2377),
    [sym_declaration_command] = STATE(2377),
    [sym_unset_command] = STATE(2377),
    [sym_command] = STATE(2377),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(2378),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [2167] = {
    [sym_for_statement] = STATE(2379),
    [sym_while_statement] = STATE(2379),
    [sym_if_statement] = STATE(2379),
    [sym_case_statement] = STATE(2379),
    [sym_function_definition] = STATE(2379),
    [sym_subshell] = STATE(2379),
    [sym_pipeline] = STATE(2379),
    [sym_list] = STATE(2379),
    [sym_negated_command] = STATE(2379),
    [sym_test_command] = STATE(2379),
    [sym_declaration_command] = STATE(2379),
    [sym_unset_command] = STATE(2379),
    [sym_command] = STATE(2379),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2380),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2168] = {
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_esac] = ACTIONS(615),
    [anon_sym_PIPE] = ACTIONS(615),
    [anon_sym_SEMI_SEMI] = ACTIONS(615),
    [anon_sym_PIPE_AMP] = ACTIONS(615),
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [sym__special_characters] = ACTIONS(615),
    [anon_sym_DQUOTE] = ACTIONS(615),
    [anon_sym_DOLLAR] = ACTIONS(615),
    [sym_raw_string] = ACTIONS(615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(615),
    [anon_sym_BQUOTE] = ACTIONS(615),
    [anon_sym_LT_LPAREN] = ACTIONS(615),
    [anon_sym_GT_LPAREN] = ACTIONS(615),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(615),
    [sym_word] = ACTIONS(615),
    [anon_sym_SEMI] = ACTIONS(615),
    [anon_sym_LF] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(615),
  },
  [2169] = {
    [anon_sym_EQ] = ACTIONS(5517),
    [anon_sym_PLUS_EQ] = ACTIONS(5517),
    [sym_comment] = ACTIONS(53),
  },
  [2170] = {
    [sym_variable_assignment] = STATE(2381),
    [sym_subscript] = STATE(2169),
    [sym_concatenation] = STATE(2381),
    [sym_string] = STATE(2163),
    [sym_simple_expansion] = STATE(2163),
    [sym_string_expansion] = STATE(2163),
    [sym_expansion] = STATE(2163),
    [sym_command_substitution] = STATE(2163),
    [sym_process_substitution] = STATE(2163),
    [aux_sym_declaration_command_repeat1] = STATE(2381),
    [sym_variable_name] = ACTIONS(5081),
    [anon_sym_esac] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(617),
    [anon_sym_PIPE_AMP] = ACTIONS(617),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [sym__special_characters] = ACTIONS(5083),
    [anon_sym_DQUOTE] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [sym_raw_string] = ACTIONS(5089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5093),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5097),
    [anon_sym_GT_LPAREN] = ACTIONS(5097),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5099),
    [sym_word] = ACTIONS(5089),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LF] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(617),
  },
  [2171] = {
    [aux_sym_concatenation_repeat1] = STATE(2383),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_esac] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_SEMI_SEMI] = ACTIONS(623),
    [anon_sym_PIPE_AMP] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(623),
    [sym__special_characters] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [sym_raw_string] = ACTIONS(623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(623),
    [anon_sym_BQUOTE] = ACTIONS(623),
    [anon_sym_LT_LPAREN] = ACTIONS(623),
    [anon_sym_GT_LPAREN] = ACTIONS(623),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(623),
    [sym_word] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(623),
    [anon_sym_LF] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(623),
  },
  [2172] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(2385),
    [anon_sym_DQUOTE] = ACTIONS(5545),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2173] = {
    [sym_string] = STATE(2387),
    [anon_sym_DQUOTE] = ACTIONS(5547),
    [anon_sym_DOLLAR] = ACTIONS(5549),
    [sym_raw_string] = ACTIONS(5551),
    [anon_sym_POUND] = ACTIONS(5549),
    [anon_sym_DASH] = ACTIONS(5549),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5553),
    [anon_sym_STAR] = ACTIONS(5549),
    [anon_sym_AT] = ACTIONS(5549),
    [anon_sym_QMARK] = ACTIONS(5549),
    [anon_sym_0] = ACTIONS(5555),
    [anon_sym__] = ACTIONS(5555),
  },
  [2174] = {
    [aux_sym_concatenation_repeat1] = STATE(2383),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_esac] = ACTIONS(639),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_SEMI_SEMI] = ACTIONS(639),
    [anon_sym_PIPE_AMP] = ACTIONS(639),
    [anon_sym_AMP_AMP] = ACTIONS(639),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [sym__special_characters] = ACTIONS(639),
    [anon_sym_DQUOTE] = ACTIONS(639),
    [anon_sym_DOLLAR] = ACTIONS(639),
    [sym_raw_string] = ACTIONS(639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(639),
    [anon_sym_BQUOTE] = ACTIONS(639),
    [anon_sym_LT_LPAREN] = ACTIONS(639),
    [anon_sym_GT_LPAREN] = ACTIONS(639),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(639),
    [sym_word] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(639),
    [anon_sym_LF] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(639),
  },
  [2175] = {
    [sym_subscript] = STATE(2393),
    [sym_variable_name] = ACTIONS(5557),
    [anon_sym_DOLLAR] = ACTIONS(5559),
    [anon_sym_POUND] = ACTIONS(5561),
    [anon_sym_DASH] = ACTIONS(5559),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5563),
    [anon_sym_STAR] = ACTIONS(5559),
    [anon_sym_AT] = ACTIONS(5559),
    [anon_sym_QMARK] = ACTIONS(5559),
    [anon_sym_0] = ACTIONS(5565),
    [anon_sym__] = ACTIONS(5565),
  },
  [2176] = {
    [sym_for_statement] = STATE(2394),
    [sym_while_statement] = STATE(2394),
    [sym_if_statement] = STATE(2394),
    [sym_case_statement] = STATE(2394),
    [sym_function_definition] = STATE(2394),
    [sym_subshell] = STATE(2394),
    [sym_pipeline] = STATE(2394),
    [sym_list] = STATE(2394),
    [sym_negated_command] = STATE(2394),
    [sym_test_command] = STATE(2394),
    [sym_declaration_command] = STATE(2394),
    [sym_unset_command] = STATE(2394),
    [sym_command] = STATE(2394),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2395),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2177] = {
    [sym_for_statement] = STATE(2396),
    [sym_while_statement] = STATE(2396),
    [sym_if_statement] = STATE(2396),
    [sym_case_statement] = STATE(2396),
    [sym_function_definition] = STATE(2396),
    [sym_subshell] = STATE(2396),
    [sym_pipeline] = STATE(2396),
    [sym_list] = STATE(2396),
    [sym_negated_command] = STATE(2396),
    [sym_test_command] = STATE(2396),
    [sym_declaration_command] = STATE(2396),
    [sym_unset_command] = STATE(2396),
    [sym_command] = STATE(2396),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(2397),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [2178] = {
    [sym_for_statement] = STATE(2398),
    [sym_while_statement] = STATE(2398),
    [sym_if_statement] = STATE(2398),
    [sym_case_statement] = STATE(2398),
    [sym_function_definition] = STATE(2398),
    [sym_subshell] = STATE(2398),
    [sym_pipeline] = STATE(2398),
    [sym_list] = STATE(2398),
    [sym_negated_command] = STATE(2398),
    [sym_test_command] = STATE(2398),
    [sym_declaration_command] = STATE(2398),
    [sym_unset_command] = STATE(2398),
    [sym_command] = STATE(2398),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2399),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2179] = {
    [anon_sym_esac] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(653),
    [anon_sym_SEMI_SEMI] = ACTIONS(653),
    [anon_sym_PIPE_AMP] = ACTIONS(653),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [sym__special_characters] = ACTIONS(653),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_DOLLAR] = ACTIONS(653),
    [sym_raw_string] = ACTIONS(653),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(653),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(653),
    [anon_sym_LT_LPAREN] = ACTIONS(653),
    [anon_sym_GT_LPAREN] = ACTIONS(653),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(653),
    [sym_word] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_LF] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(653),
  },
  [2180] = {
    [sym_concatenation] = STATE(2400),
    [sym_string] = STATE(2174),
    [sym_simple_expansion] = STATE(2174),
    [sym_string_expansion] = STATE(2174),
    [sym_expansion] = STATE(2174),
    [sym_command_substitution] = STATE(2174),
    [sym_process_substitution] = STATE(2174),
    [aux_sym_unset_command_repeat1] = STATE(2400),
    [anon_sym_esac] = ACTIONS(657),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(657),
    [anon_sym_PIPE_AMP] = ACTIONS(657),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(657),
    [sym__special_characters] = ACTIONS(5101),
    [anon_sym_DQUOTE] = ACTIONS(5103),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [sym_raw_string] = ACTIONS(5107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5111),
    [anon_sym_BQUOTE] = ACTIONS(5113),
    [anon_sym_LT_LPAREN] = ACTIONS(5115),
    [anon_sym_GT_LPAREN] = ACTIONS(5115),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5117),
    [sym_word] = ACTIONS(5107),
    [anon_sym_SEMI] = ACTIONS(657),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(657),
  },
  [2181] = {
    [aux_sym_concatenation_repeat1] = STATE(2401),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(223),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [2182] = {
    [anon_sym_RPAREN] = ACTIONS(5567),
    [sym_comment] = ACTIONS(53),
  },
  [2183] = {
    [sym_for_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_function_definition] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_pipeline] = STATE(529),
    [sym_list] = STATE(529),
    [sym_negated_command] = STATE(529),
    [sym_test_command] = STATE(529),
    [sym_declaration_command] = STATE(529),
    [sym_unset_command] = STATE(529),
    [sym_command] = STATE(529),
    [sym_command_name] = STATE(1861),
    [sym_variable_assignment] = STATE(530),
    [sym_subscript] = STATE(1863),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(1858),
    [sym_simple_expansion] = STATE(1858),
    [sym_string_expansion] = STATE(1858),
    [sym_expansion] = STATE(1858),
    [sym_command_substitution] = STATE(1858),
    [sym_process_substitution] = STATE(1858),
    [aux_sym_command_repeat1] = STATE(1865),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4317),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4319),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(4325),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4327),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4331),
    [anon_sym_declare] = ACTIONS(4333),
    [anon_sym_typeset] = ACTIONS(4333),
    [anon_sym_export] = ACTIONS(4333),
    [anon_sym_readonly] = ACTIONS(4333),
    [anon_sym_local] = ACTIONS(4333),
    [anon_sym_unset] = ACTIONS(4335),
    [anon_sym_unsetenv] = ACTIONS(4335),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4337),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4341),
  },
  [2184] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_esac] = ACTIONS(5569),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(5571),
    [anon_sym_DQUOTE] = ACTIONS(5573),
    [anon_sym_DOLLAR] = ACTIONS(5571),
    [sym_raw_string] = ACTIONS(5573),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5573),
    [anon_sym_BQUOTE] = ACTIONS(5573),
    [anon_sym_LT_LPAREN] = ACTIONS(5573),
    [anon_sym_GT_LPAREN] = ACTIONS(5573),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5571),
  },
  [2185] = {
    [sym_for_statement] = STATE(2403),
    [sym_while_statement] = STATE(2403),
    [sym_if_statement] = STATE(2403),
    [sym_case_statement] = STATE(2403),
    [sym_function_definition] = STATE(2403),
    [sym_subshell] = STATE(2403),
    [sym_pipeline] = STATE(2403),
    [sym_list] = STATE(2403),
    [sym_negated_command] = STATE(2403),
    [sym_test_command] = STATE(2403),
    [sym_declaration_command] = STATE(2403),
    [sym_unset_command] = STATE(2403),
    [sym_command] = STATE(2403),
    [sym_command_name] = STATE(1861),
    [sym_variable_assignment] = STATE(2404),
    [sym_subscript] = STATE(1863),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(1858),
    [sym_simple_expansion] = STATE(1858),
    [sym_string_expansion] = STATE(1858),
    [sym_expansion] = STATE(1858),
    [sym_command_substitution] = STATE(1858),
    [sym_process_substitution] = STATE(1858),
    [aux_sym_command_repeat1] = STATE(1865),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4317),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4319),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(4325),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4327),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4331),
    [anon_sym_declare] = ACTIONS(4333),
    [anon_sym_typeset] = ACTIONS(4333),
    [anon_sym_export] = ACTIONS(4333),
    [anon_sym_readonly] = ACTIONS(4333),
    [anon_sym_local] = ACTIONS(4333),
    [anon_sym_unset] = ACTIONS(4335),
    [anon_sym_unsetenv] = ACTIONS(4335),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4337),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4341),
  },
  [2186] = {
    [anon_sym_LT] = ACTIONS(5575),
    [anon_sym_GT] = ACTIONS(5575),
    [anon_sym_GT_GT] = ACTIONS(5577),
    [anon_sym_AMP_GT] = ACTIONS(5575),
    [anon_sym_AMP_GT_GT] = ACTIONS(5577),
    [anon_sym_LT_AMP] = ACTIONS(5577),
    [anon_sym_GT_AMP] = ACTIONS(5577),
    [sym_comment] = ACTIONS(53),
  },
  [2187] = {
    [sym_concatenation] = STATE(540),
    [sym_string] = STATE(2407),
    [sym_simple_expansion] = STATE(2407),
    [sym_string_expansion] = STATE(2407),
    [sym_expansion] = STATE(2407),
    [sym_command_substitution] = STATE(2407),
    [sym_process_substitution] = STATE(2407),
    [sym__special_characters] = ACTIONS(5579),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(5581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5581),
    [sym_regex] = ACTIONS(975),
  },
  [2188] = {
    [sym_concatenation] = STATE(543),
    [sym_string] = STATE(2409),
    [sym_simple_expansion] = STATE(2409),
    [sym_string_expansion] = STATE(2409),
    [sym_expansion] = STATE(2409),
    [sym_command_substitution] = STATE(2409),
    [sym_process_substitution] = STATE(2409),
    [sym__special_characters] = ACTIONS(5583),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(5585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5585),
  },
  [2189] = {
    [sym_concatenation] = STATE(547),
    [sym_string] = STATE(2411),
    [sym_simple_expansion] = STATE(2411),
    [sym_string_expansion] = STATE(2411),
    [sym_expansion] = STATE(2411),
    [sym_command_substitution] = STATE(2411),
    [sym_process_substitution] = STATE(2411),
    [sym__special_characters] = ACTIONS(5587),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(5589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5589),
  },
  [2190] = {
    [aux_sym_concatenation_repeat1] = STATE(2181),
    [sym__simple_heredoc_body] = ACTIONS(987),
    [sym__heredoc_body_beginning] = ACTIONS(987),
    [sym_file_descriptor] = ACTIONS(987),
    [sym__concat] = ACTIONS(223),
    [anon_sym_esac] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_SEMI_SEMI] = ACTIONS(989),
    [anon_sym_PIPE_AMP] = ACTIONS(989),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE_PIPE] = ACTIONS(989),
    [anon_sym_EQ_TILDE] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_GT] = ACTIONS(989),
    [anon_sym_GT_GT] = ACTIONS(989),
    [anon_sym_AMP_GT] = ACTIONS(989),
    [anon_sym_AMP_GT_GT] = ACTIONS(989),
    [anon_sym_LT_AMP] = ACTIONS(989),
    [anon_sym_GT_AMP] = ACTIONS(989),
    [anon_sym_LT_LT] = ACTIONS(989),
    [anon_sym_LT_LT_DASH] = ACTIONS(989),
    [anon_sym_LT_LT_LT] = ACTIONS(989),
    [sym__special_characters] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(989),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [sym_raw_string] = ACTIONS(989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(989),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(989),
    [anon_sym_BQUOTE] = ACTIONS(989),
    [anon_sym_LT_LPAREN] = ACTIONS(989),
    [anon_sym_GT_LPAREN] = ACTIONS(989),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(989),
    [anon_sym_SEMI] = ACTIONS(989),
    [anon_sym_LF] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(989),
  },
  [2191] = {
    [aux_sym_concatenation_repeat1] = STATE(2181),
    [sym__simple_heredoc_body] = ACTIONS(991),
    [sym__heredoc_body_beginning] = ACTIONS(991),
    [sym_file_descriptor] = ACTIONS(991),
    [sym__concat] = ACTIONS(223),
    [anon_sym_esac] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_SEMI_SEMI] = ACTIONS(993),
    [anon_sym_PIPE_AMP] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT] = ACTIONS(993),
    [anon_sym_GT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_AMP_GT] = ACTIONS(993),
    [anon_sym_AMP_GT_GT] = ACTIONS(993),
    [anon_sym_LT_AMP] = ACTIONS(993),
    [anon_sym_GT_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_LT_LT_DASH] = ACTIONS(993),
    [anon_sym_LT_LT_LT] = ACTIONS(993),
    [sym__special_characters] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(993),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [sym_raw_string] = ACTIONS(993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(993),
    [anon_sym_LT_LPAREN] = ACTIONS(993),
    [anon_sym_GT_LPAREN] = ACTIONS(993),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(993),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_LF] = ACTIONS(991),
    [anon_sym_AMP] = ACTIONS(993),
  },
  [2192] = {
    [sym_file_redirect] = STATE(2412),
    [sym_heredoc_redirect] = STATE(2412),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(2412),
    [aux_sym_while_statement_repeat1] = STATE(2412),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5127),
    [anon_sym_esac] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5131),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT_GT] = ACTIONS(5131),
    [anon_sym_LT_AMP] = ACTIONS(5131),
    [anon_sym_GT_AMP] = ACTIONS(5131),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [2193] = {
    [sym_file_redirect] = STATE(2413),
    [sym_heredoc_redirect] = STATE(2413),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(2413),
    [sym_concatenation] = STATE(2414),
    [sym_string] = STATE(2191),
    [sym_simple_expansion] = STATE(2191),
    [sym_string_expansion] = STATE(2191),
    [sym_expansion] = STATE(2191),
    [sym_command_substitution] = STATE(2191),
    [sym_process_substitution] = STATE(2191),
    [aux_sym_while_statement_repeat1] = STATE(2413),
    [aux_sym_command_repeat2] = STATE(2414),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5127),
    [anon_sym_esac] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_EQ_TILDE] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5131),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT_GT] = ACTIONS(5131),
    [anon_sym_LT_AMP] = ACTIONS(5131),
    [anon_sym_GT_AMP] = ACTIONS(5131),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [sym__special_characters] = ACTIONS(5135),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(5137),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5137),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [2194] = {
    [anon_sym_esac] = ACTIONS(5569),
    [sym__special_characters] = ACTIONS(5573),
    [anon_sym_DQUOTE] = ACTIONS(5573),
    [anon_sym_DOLLAR] = ACTIONS(5571),
    [sym_raw_string] = ACTIONS(5573),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5573),
    [anon_sym_BQUOTE] = ACTIONS(5573),
    [anon_sym_LT_LPAREN] = ACTIONS(5573),
    [anon_sym_GT_LPAREN] = ACTIONS(5573),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5571),
  },
  [2195] = {
    [anon_sym_esac] = ACTIONS(5569),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI_SEMI] = ACTIONS(5591),
    [anon_sym_PIPE_AMP] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2196] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(5569),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI_SEMI] = ACTIONS(5591),
    [anon_sym_PIPE_AMP] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2197] = {
    [sym__terminated_statement] = STATE(2197),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2197),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_esac] = ACTIONS(3442),
    [anon_sym_SEMI_SEMI] = ACTIONS(1005),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [2198] = {
    [sym_file_redirect] = STATE(2413),
    [sym_heredoc_redirect] = STATE(2413),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(2413),
    [sym_concatenation] = STATE(2416),
    [sym_string] = STATE(2191),
    [sym_simple_expansion] = STATE(2191),
    [sym_string_expansion] = STATE(2191),
    [sym_expansion] = STATE(2191),
    [sym_command_substitution] = STATE(2191),
    [sym_process_substitution] = STATE(2191),
    [aux_sym_while_statement_repeat1] = STATE(2413),
    [aux_sym_command_repeat2] = STATE(2416),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5127),
    [anon_sym_esac] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_EQ_TILDE] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5131),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT_GT] = ACTIONS(5131),
    [anon_sym_LT_AMP] = ACTIONS(5131),
    [anon_sym_GT_AMP] = ACTIONS(5131),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [sym__special_characters] = ACTIONS(5135),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(5137),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5137),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [2199] = {
    [sym__terminated_statement] = STATE(2197),
    [sym_for_statement] = STATE(2418),
    [sym_while_statement] = STATE(2418),
    [sym_if_statement] = STATE(2418),
    [sym_case_statement] = STATE(2418),
    [sym_function_definition] = STATE(2418),
    [sym_subshell] = STATE(2418),
    [sym_pipeline] = STATE(2418),
    [sym_list] = STATE(2418),
    [sym_negated_command] = STATE(2418),
    [sym_test_command] = STATE(2418),
    [sym_declaration_command] = STATE(2418),
    [sym_unset_command] = STATE(2418),
    [sym_command] = STATE(2418),
    [sym_command_name] = STATE(1861),
    [sym_variable_assignment] = STATE(2419),
    [sym_subscript] = STATE(1863),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(1858),
    [sym_simple_expansion] = STATE(1858),
    [sym_string_expansion] = STATE(1858),
    [sym_expansion] = STATE(1858),
    [sym_command_substitution] = STATE(1858),
    [sym_process_substitution] = STATE(1858),
    [aux_sym_program_repeat1] = STATE(2197),
    [aux_sym_command_repeat1] = STATE(1865),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4317),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4319),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5569),
    [anon_sym_SEMI_SEMI] = ACTIONS(5593),
    [anon_sym_function] = ACTIONS(4325),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4327),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4331),
    [anon_sym_declare] = ACTIONS(4333),
    [anon_sym_typeset] = ACTIONS(4333),
    [anon_sym_export] = ACTIONS(4333),
    [anon_sym_readonly] = ACTIONS(4333),
    [anon_sym_local] = ACTIONS(4333),
    [anon_sym_unset] = ACTIONS(4335),
    [anon_sym_unsetenv] = ACTIONS(4335),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4337),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4341),
  },
  [2200] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_esac] = ACTIONS(5595),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(5597),
    [anon_sym_DQUOTE] = ACTIONS(5599),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5599),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5599),
    [anon_sym_BQUOTE] = ACTIONS(5599),
    [anon_sym_LT_LPAREN] = ACTIONS(5599),
    [anon_sym_GT_LPAREN] = ACTIONS(5599),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5597),
  },
  [2201] = {
    [anon_sym_esac] = ACTIONS(5595),
    [sym__special_characters] = ACTIONS(5599),
    [anon_sym_DQUOTE] = ACTIONS(5599),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5599),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5599),
    [anon_sym_BQUOTE] = ACTIONS(5599),
    [anon_sym_LT_LPAREN] = ACTIONS(5599),
    [anon_sym_GT_LPAREN] = ACTIONS(5599),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5597),
  },
  [2202] = {
    [anon_sym_esac] = ACTIONS(5595),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI_SEMI] = ACTIONS(5601),
    [anon_sym_PIPE_AMP] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2203] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(5595),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI_SEMI] = ACTIONS(5601),
    [anon_sym_PIPE_AMP] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2204] = {
    [sym__terminated_statement] = STATE(2197),
    [sym_for_statement] = STATE(2422),
    [sym_while_statement] = STATE(2422),
    [sym_if_statement] = STATE(2422),
    [sym_case_statement] = STATE(2422),
    [sym_function_definition] = STATE(2422),
    [sym_subshell] = STATE(2422),
    [sym_pipeline] = STATE(2422),
    [sym_list] = STATE(2422),
    [sym_negated_command] = STATE(2422),
    [sym_test_command] = STATE(2422),
    [sym_declaration_command] = STATE(2422),
    [sym_unset_command] = STATE(2422),
    [sym_command] = STATE(2422),
    [sym_command_name] = STATE(1861),
    [sym_variable_assignment] = STATE(2423),
    [sym_subscript] = STATE(1863),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(1858),
    [sym_simple_expansion] = STATE(1858),
    [sym_string_expansion] = STATE(1858),
    [sym_expansion] = STATE(1858),
    [sym_command_substitution] = STATE(1858),
    [sym_process_substitution] = STATE(1858),
    [aux_sym_program_repeat1] = STATE(2197),
    [aux_sym_command_repeat1] = STATE(1865),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4317),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4319),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5595),
    [anon_sym_SEMI_SEMI] = ACTIONS(5603),
    [anon_sym_function] = ACTIONS(4325),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4327),
    [anon_sym_LBRACK] = ACTIONS(4329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4331),
    [anon_sym_declare] = ACTIONS(4333),
    [anon_sym_typeset] = ACTIONS(4333),
    [anon_sym_export] = ACTIONS(4333),
    [anon_sym_readonly] = ACTIONS(4333),
    [anon_sym_local] = ACTIONS(4333),
    [anon_sym_unset] = ACTIONS(4335),
    [anon_sym_unsetenv] = ACTIONS(4335),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4337),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4341),
  },
  [2205] = {
    [sym__terminated_statement] = STATE(2427),
    [sym_for_statement] = STATE(2425),
    [sym_while_statement] = STATE(2425),
    [sym_if_statement] = STATE(2425),
    [sym_case_statement] = STATE(2425),
    [sym_function_definition] = STATE(2425),
    [sym_subshell] = STATE(2425),
    [sym_pipeline] = STATE(2425),
    [sym_list] = STATE(2425),
    [sym_negated_command] = STATE(2425),
    [sym_test_command] = STATE(2425),
    [sym_declaration_command] = STATE(2425),
    [sym_unset_command] = STATE(2425),
    [sym_command] = STATE(2425),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2426),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2427),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5605),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2206] = {
    [aux_sym_case_item_repeat1] = STATE(1867),
    [anon_sym_PIPE] = ACTIONS(3467),
    [anon_sym_RPAREN] = ACTIONS(5607),
    [sym_comment] = ACTIONS(53),
  },
  [2207] = {
    [sym__terminated_statement] = STATE(2432),
    [sym_for_statement] = STATE(2430),
    [sym_while_statement] = STATE(2430),
    [sym_if_statement] = STATE(2430),
    [sym_case_statement] = STATE(2430),
    [sym_function_definition] = STATE(2430),
    [sym_subshell] = STATE(2430),
    [sym_pipeline] = STATE(2430),
    [sym_list] = STATE(2430),
    [sym_negated_command] = STATE(2430),
    [sym_test_command] = STATE(2430),
    [sym_declaration_command] = STATE(2430),
    [sym_unset_command] = STATE(2430),
    [sym_command] = STATE(2430),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2431),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2432),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5609),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2208] = {
    [aux_sym_case_item_repeat1] = STATE(1867),
    [anon_sym_PIPE] = ACTIONS(3467),
    [anon_sym_RPAREN] = ACTIONS(5611),
    [sym_comment] = ACTIONS(53),
  },
  [2209] = {
    [anon_sym_esac] = ACTIONS(5613),
    [anon_sym_PIPE] = ACTIONS(5613),
    [anon_sym_RPAREN] = ACTIONS(5613),
    [anon_sym_SEMI_SEMI] = ACTIONS(5613),
    [anon_sym_PIPE_AMP] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_PIPE_PIPE] = ACTIONS(5613),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5613),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5613),
  },
  [2210] = {
    [anon_sym_esac] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_RPAREN] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5617),
    [anon_sym_PIPE_AMP] = ACTIONS(5617),
    [anon_sym_AMP_AMP] = ACTIONS(5617),
    [anon_sym_PIPE_PIPE] = ACTIONS(5617),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5619),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [2211] = {
    [sym__concat] = ACTIONS(5325),
    [anon_sym_in] = ACTIONS(5327),
    [anon_sym_SEMI_SEMI] = ACTIONS(5327),
    [sym__special_characters] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [sym_raw_string] = ACTIONS(5327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5327),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5327),
    [anon_sym_BQUOTE] = ACTIONS(5327),
    [anon_sym_LT_LPAREN] = ACTIONS(5327),
    [anon_sym_GT_LPAREN] = ACTIONS(5327),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5327),
    [anon_sym_SEMI] = ACTIONS(5327),
    [anon_sym_LF] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
  },
  [2212] = {
    [sym__concat] = ACTIONS(5329),
    [anon_sym_in] = ACTIONS(5331),
    [anon_sym_SEMI_SEMI] = ACTIONS(5331),
    [sym__special_characters] = ACTIONS(5331),
    [anon_sym_DQUOTE] = ACTIONS(5331),
    [anon_sym_DOLLAR] = ACTIONS(5331),
    [sym_raw_string] = ACTIONS(5331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5331),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5331),
    [anon_sym_BQUOTE] = ACTIONS(5331),
    [anon_sym_LT_LPAREN] = ACTIONS(5331),
    [anon_sym_GT_LPAREN] = ACTIONS(5331),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5331),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LF] = ACTIONS(5329),
    [anon_sym_AMP] = ACTIONS(5331),
  },
  [2213] = {
    [sym__concat] = ACTIONS(5333),
    [anon_sym_in] = ACTIONS(5335),
    [anon_sym_SEMI_SEMI] = ACTIONS(5335),
    [sym__special_characters] = ACTIONS(5335),
    [anon_sym_DQUOTE] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5335),
    [sym_raw_string] = ACTIONS(5335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5335),
    [anon_sym_BQUOTE] = ACTIONS(5335),
    [anon_sym_LT_LPAREN] = ACTIONS(5335),
    [anon_sym_GT_LPAREN] = ACTIONS(5335),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5335),
    [anon_sym_SEMI] = ACTIONS(5335),
    [anon_sym_LF] = ACTIONS(5333),
    [anon_sym_AMP] = ACTIONS(5335),
  },
  [2214] = {
    [aux_sym_concatenation_repeat1] = STATE(2214),
    [sym__concat] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [2215] = {
    [aux_sym_concatenation_repeat1] = STATE(2215),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [2216] = {
    [sym__concat] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_RBRACK] = ACTIONS(5325),
    [anon_sym_EQ_TILDE] = ACTIONS(5325),
    [anon_sym_EQ_EQ] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_BANG_EQ] = ACTIONS(5325),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5325),
  },
  [2217] = {
    [sym__concat] = ACTIONS(5329),
    [anon_sym_AMP_AMP] = ACTIONS(5329),
    [anon_sym_PIPE_PIPE] = ACTIONS(5329),
    [anon_sym_RBRACK] = ACTIONS(5329),
    [anon_sym_EQ_TILDE] = ACTIONS(5329),
    [anon_sym_EQ_EQ] = ACTIONS(5329),
    [anon_sym_EQ] = ACTIONS(5331),
    [anon_sym_LT] = ACTIONS(5329),
    [anon_sym_GT] = ACTIONS(5329),
    [anon_sym_BANG_EQ] = ACTIONS(5329),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5329),
  },
  [2218] = {
    [sym__concat] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_RBRACK] = ACTIONS(5333),
    [anon_sym_EQ_TILDE] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_LT] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5333),
  },
  [2219] = {
    [sym_file_descriptor] = ACTIONS(2710),
    [sym__concat] = ACTIONS(2710),
    [anon_sym_esac] = ACTIONS(2712),
    [anon_sym_PIPE] = ACTIONS(2712),
    [anon_sym_RPAREN] = ACTIONS(2712),
    [anon_sym_SEMI_SEMI] = ACTIONS(2712),
    [anon_sym_PIPE_AMP] = ACTIONS(2712),
    [anon_sym_AMP_AMP] = ACTIONS(2712),
    [anon_sym_PIPE_PIPE] = ACTIONS(2712),
    [anon_sym_LT] = ACTIONS(2712),
    [anon_sym_GT] = ACTIONS(2712),
    [anon_sym_GT_GT] = ACTIONS(2712),
    [anon_sym_AMP_GT] = ACTIONS(2712),
    [anon_sym_AMP_GT_GT] = ACTIONS(2712),
    [anon_sym_LT_AMP] = ACTIONS(2712),
    [anon_sym_GT_AMP] = ACTIONS(2712),
    [anon_sym_LT_LT] = ACTIONS(2712),
    [anon_sym_LT_LT_DASH] = ACTIONS(2712),
    [anon_sym_LT_LT_LT] = ACTIONS(2712),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_LF] = ACTIONS(2710),
    [anon_sym_AMP] = ACTIONS(2712),
  },
  [2220] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5621),
    [sym_comment] = ACTIONS(53),
  },
  [2221] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5623),
    [sym_comment] = ACTIONS(53),
  },
  [2222] = {
    [anon_sym_RBRACE] = ACTIONS(5623),
    [sym_comment] = ACTIONS(53),
  },
  [2223] = {
    [sym_concatenation] = STATE(2437),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2437),
    [anon_sym_RBRACE] = ACTIONS(5625),
    [anon_sym_EQ] = ACTIONS(5627),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5629),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5627),
    [anon_sym_COLON_QMARK] = ACTIONS(5627),
    [anon_sym_COLON_DASH] = ACTIONS(5627),
    [anon_sym_PERCENT] = ACTIONS(5627),
    [anon_sym_DASH] = ACTIONS(5627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2224] = {
    [sym_file_descriptor] = ACTIONS(2788),
    [sym__concat] = ACTIONS(2788),
    [anon_sym_esac] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_RPAREN] = ACTIONS(2790),
    [anon_sym_SEMI_SEMI] = ACTIONS(2790),
    [anon_sym_PIPE_AMP] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2790),
    [anon_sym_PIPE_PIPE] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_AMP_GT] = ACTIONS(2790),
    [anon_sym_AMP_GT_GT] = ACTIONS(2790),
    [anon_sym_LT_AMP] = ACTIONS(2790),
    [anon_sym_GT_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_LT_LT_DASH] = ACTIONS(2790),
    [anon_sym_LT_LT_LT] = ACTIONS(2790),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_LF] = ACTIONS(2788),
    [anon_sym_AMP] = ACTIONS(2790),
  },
  [2225] = {
    [sym_concatenation] = STATE(2440),
    [sym_string] = STATE(2439),
    [sym_simple_expansion] = STATE(2439),
    [sym_string_expansion] = STATE(2439),
    [sym_expansion] = STATE(2439),
    [sym_command_substitution] = STATE(2439),
    [sym_process_substitution] = STATE(2439),
    [anon_sym_RBRACE] = ACTIONS(5623),
    [sym__special_characters] = ACTIONS(5631),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(5633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5633),
  },
  [2226] = {
    [sym_file_descriptor] = ACTIONS(2831),
    [sym__concat] = ACTIONS(2831),
    [anon_sym_esac] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2833),
    [anon_sym_SEMI_SEMI] = ACTIONS(2833),
    [anon_sym_PIPE_AMP] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_AMP_GT] = ACTIONS(2833),
    [anon_sym_AMP_GT_GT] = ACTIONS(2833),
    [anon_sym_LT_AMP] = ACTIONS(2833),
    [anon_sym_GT_AMP] = ACTIONS(2833),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_DASH] = ACTIONS(2833),
    [anon_sym_LT_LT_LT] = ACTIONS(2833),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2831),
    [anon_sym_AMP] = ACTIONS(2833),
  },
  [2227] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5635),
  },
  [2228] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5637),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2229] = {
    [sym_file_descriptor] = ACTIONS(2839),
    [sym__concat] = ACTIONS(2839),
    [anon_sym_esac] = ACTIONS(2841),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_RPAREN] = ACTIONS(2841),
    [anon_sym_SEMI_SEMI] = ACTIONS(2841),
    [anon_sym_PIPE_AMP] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_GT] = ACTIONS(2841),
    [anon_sym_GT_GT] = ACTIONS(2841),
    [anon_sym_AMP_GT] = ACTIONS(2841),
    [anon_sym_AMP_GT_GT] = ACTIONS(2841),
    [anon_sym_LT_AMP] = ACTIONS(2841),
    [anon_sym_GT_AMP] = ACTIONS(2841),
    [anon_sym_LT_LT] = ACTIONS(2841),
    [anon_sym_LT_LT_DASH] = ACTIONS(2841),
    [anon_sym_LT_LT_LT] = ACTIONS(2841),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2839),
    [anon_sym_AMP] = ACTIONS(2841),
  },
  [2230] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5639),
  },
  [2231] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5641),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2232] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5643),
  },
  [2233] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5623),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2234] = {
    [sym_concatenation] = STATE(2447),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2447),
    [anon_sym_RBRACE] = ACTIONS(5645),
    [anon_sym_EQ] = ACTIONS(5647),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5649),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5647),
    [anon_sym_COLON_QMARK] = ACTIONS(5647),
    [anon_sym_COLON_DASH] = ACTIONS(5647),
    [anon_sym_PERCENT] = ACTIONS(5647),
    [anon_sym_DASH] = ACTIONS(5647),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2235] = {
    [sym_file_descriptor] = ACTIONS(2855),
    [sym__concat] = ACTIONS(2855),
    [anon_sym_esac] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2857),
    [anon_sym_SEMI_SEMI] = ACTIONS(2857),
    [anon_sym_PIPE_AMP] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT_GT] = ACTIONS(2857),
    [anon_sym_LT_AMP] = ACTIONS(2857),
    [anon_sym_GT_AMP] = ACTIONS(2857),
    [anon_sym_LT_LT] = ACTIONS(2857),
    [anon_sym_LT_LT_DASH] = ACTIONS(2857),
    [anon_sym_LT_LT_LT] = ACTIONS(2857),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [2236] = {
    [sym_concatenation] = STATE(2449),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2449),
    [anon_sym_RBRACE] = ACTIONS(5651),
    [anon_sym_EQ] = ACTIONS(5653),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5653),
    [anon_sym_COLON_QMARK] = ACTIONS(5653),
    [anon_sym_COLON_DASH] = ACTIONS(5653),
    [anon_sym_PERCENT] = ACTIONS(5653),
    [anon_sym_DASH] = ACTIONS(5653),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2237] = {
    [sym__concat] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5325),
    [anon_sym_EQ_TILDE] = ACTIONS(5325),
    [anon_sym_EQ_EQ] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_BANG_EQ] = ACTIONS(5325),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5325),
  },
  [2238] = {
    [sym__concat] = ACTIONS(5329),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5329),
    [anon_sym_AMP_AMP] = ACTIONS(5329),
    [anon_sym_PIPE_PIPE] = ACTIONS(5329),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5329),
    [anon_sym_EQ_TILDE] = ACTIONS(5329),
    [anon_sym_EQ_EQ] = ACTIONS(5329),
    [anon_sym_EQ] = ACTIONS(5331),
    [anon_sym_LT] = ACTIONS(5329),
    [anon_sym_GT] = ACTIONS(5329),
    [anon_sym_BANG_EQ] = ACTIONS(5329),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5329),
  },
  [2239] = {
    [sym__concat] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_RPAREN] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5333),
    [anon_sym_EQ_TILDE] = ACTIONS(5333),
    [anon_sym_EQ_EQ] = ACTIONS(5333),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_LT] = ACTIONS(5333),
    [anon_sym_GT] = ACTIONS(5333),
    [anon_sym_BANG_EQ] = ACTIONS(5333),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5333),
  },
  [2240] = {
    [sym__concat] = ACTIONS(5325),
    [sym_variable_name] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_RPAREN] = ACTIONS(5327),
    [anon_sym_SEMI_SEMI] = ACTIONS(5327),
    [anon_sym_PIPE_AMP] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [sym__special_characters] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [sym_raw_string] = ACTIONS(5327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5327),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5327),
    [anon_sym_BQUOTE] = ACTIONS(5327),
    [anon_sym_LT_LPAREN] = ACTIONS(5327),
    [anon_sym_GT_LPAREN] = ACTIONS(5327),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5327),
    [sym_word] = ACTIONS(5327),
    [anon_sym_SEMI] = ACTIONS(5327),
    [anon_sym_LF] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
  },
  [2241] = {
    [sym__concat] = ACTIONS(5329),
    [sym_variable_name] = ACTIONS(5329),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5331),
    [anon_sym_SEMI_SEMI] = ACTIONS(5331),
    [anon_sym_PIPE_AMP] = ACTIONS(5331),
    [anon_sym_AMP_AMP] = ACTIONS(5331),
    [anon_sym_PIPE_PIPE] = ACTIONS(5331),
    [sym__special_characters] = ACTIONS(5331),
    [anon_sym_DQUOTE] = ACTIONS(5331),
    [anon_sym_DOLLAR] = ACTIONS(5331),
    [sym_raw_string] = ACTIONS(5331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5331),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5331),
    [anon_sym_BQUOTE] = ACTIONS(5331),
    [anon_sym_LT_LPAREN] = ACTIONS(5331),
    [anon_sym_GT_LPAREN] = ACTIONS(5331),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5331),
    [sym_word] = ACTIONS(5331),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LF] = ACTIONS(5329),
    [anon_sym_AMP] = ACTIONS(5331),
  },
  [2242] = {
    [sym__concat] = ACTIONS(5333),
    [sym_variable_name] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_RPAREN] = ACTIONS(5335),
    [anon_sym_SEMI_SEMI] = ACTIONS(5335),
    [anon_sym_PIPE_AMP] = ACTIONS(5335),
    [anon_sym_AMP_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5335),
    [sym__special_characters] = ACTIONS(5335),
    [anon_sym_DQUOTE] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5335),
    [sym_raw_string] = ACTIONS(5335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5335),
    [anon_sym_BQUOTE] = ACTIONS(5335),
    [anon_sym_LT_LPAREN] = ACTIONS(5335),
    [anon_sym_GT_LPAREN] = ACTIONS(5335),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5335),
    [sym_word] = ACTIONS(5335),
    [anon_sym_SEMI] = ACTIONS(5335),
    [anon_sym_LF] = ACTIONS(5333),
    [anon_sym_AMP] = ACTIONS(5335),
  },
  [2243] = {
    [sym__concat] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_RPAREN] = ACTIONS(5327),
    [anon_sym_SEMI_SEMI] = ACTIONS(5327),
    [anon_sym_PIPE_AMP] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [sym__special_characters] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [sym_raw_string] = ACTIONS(5327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5327),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5327),
    [anon_sym_BQUOTE] = ACTIONS(5327),
    [anon_sym_LT_LPAREN] = ACTIONS(5327),
    [anon_sym_GT_LPAREN] = ACTIONS(5327),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5327),
    [sym_word] = ACTIONS(5327),
    [anon_sym_SEMI] = ACTIONS(5327),
    [anon_sym_LF] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
  },
  [2244] = {
    [sym__concat] = ACTIONS(5329),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5331),
    [anon_sym_SEMI_SEMI] = ACTIONS(5331),
    [anon_sym_PIPE_AMP] = ACTIONS(5331),
    [anon_sym_AMP_AMP] = ACTIONS(5331),
    [anon_sym_PIPE_PIPE] = ACTIONS(5331),
    [sym__special_characters] = ACTIONS(5331),
    [anon_sym_DQUOTE] = ACTIONS(5331),
    [anon_sym_DOLLAR] = ACTIONS(5331),
    [sym_raw_string] = ACTIONS(5331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5331),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5331),
    [anon_sym_BQUOTE] = ACTIONS(5331),
    [anon_sym_LT_LPAREN] = ACTIONS(5331),
    [anon_sym_GT_LPAREN] = ACTIONS(5331),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5331),
    [sym_word] = ACTIONS(5331),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LF] = ACTIONS(5329),
    [anon_sym_AMP] = ACTIONS(5331),
  },
  [2245] = {
    [sym__concat] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_RPAREN] = ACTIONS(5335),
    [anon_sym_SEMI_SEMI] = ACTIONS(5335),
    [anon_sym_PIPE_AMP] = ACTIONS(5335),
    [anon_sym_AMP_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5335),
    [sym__special_characters] = ACTIONS(5335),
    [anon_sym_DQUOTE] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5335),
    [sym_raw_string] = ACTIONS(5335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5335),
    [anon_sym_BQUOTE] = ACTIONS(5335),
    [anon_sym_LT_LPAREN] = ACTIONS(5335),
    [anon_sym_GT_LPAREN] = ACTIONS(5335),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5335),
    [sym_word] = ACTIONS(5335),
    [anon_sym_SEMI] = ACTIONS(5335),
    [anon_sym_LF] = ACTIONS(5333),
    [anon_sym_AMP] = ACTIONS(5335),
  },
  [2246] = {
    [sym_file_descriptor] = ACTIONS(5325),
    [sym__concat] = ACTIONS(5325),
    [sym_variable_name] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [anon_sym_PIPE_AMP] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_GT_GT] = ACTIONS(5325),
    [anon_sym_AMP_GT] = ACTIONS(5327),
    [anon_sym_AMP_GT_GT] = ACTIONS(5325),
    [anon_sym_LT_AMP] = ACTIONS(5325),
    [anon_sym_GT_AMP] = ACTIONS(5325),
    [sym__special_characters] = ACTIONS(5325),
    [anon_sym_DQUOTE] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [sym_raw_string] = ACTIONS(5325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5325),
    [anon_sym_BQUOTE] = ACTIONS(5325),
    [anon_sym_LT_LPAREN] = ACTIONS(5325),
    [anon_sym_GT_LPAREN] = ACTIONS(5325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5325),
  },
  [2247] = {
    [sym_file_descriptor] = ACTIONS(5329),
    [sym__concat] = ACTIONS(5329),
    [sym_variable_name] = ACTIONS(5329),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5329),
    [anon_sym_PIPE_AMP] = ACTIONS(5329),
    [anon_sym_AMP_AMP] = ACTIONS(5329),
    [anon_sym_PIPE_PIPE] = ACTIONS(5329),
    [anon_sym_LT] = ACTIONS(5331),
    [anon_sym_GT] = ACTIONS(5331),
    [anon_sym_GT_GT] = ACTIONS(5329),
    [anon_sym_AMP_GT] = ACTIONS(5331),
    [anon_sym_AMP_GT_GT] = ACTIONS(5329),
    [anon_sym_LT_AMP] = ACTIONS(5329),
    [anon_sym_GT_AMP] = ACTIONS(5329),
    [sym__special_characters] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [anon_sym_DOLLAR] = ACTIONS(5331),
    [sym_raw_string] = ACTIONS(5329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5329),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5329),
    [anon_sym_BQUOTE] = ACTIONS(5329),
    [anon_sym_LT_LPAREN] = ACTIONS(5329),
    [anon_sym_GT_LPAREN] = ACTIONS(5329),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5329),
  },
  [2248] = {
    [sym_file_descriptor] = ACTIONS(5333),
    [sym__concat] = ACTIONS(5333),
    [sym_variable_name] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_RPAREN] = ACTIONS(5333),
    [anon_sym_PIPE_AMP] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_GT] = ACTIONS(5333),
    [anon_sym_AMP_GT] = ACTIONS(5335),
    [anon_sym_AMP_GT_GT] = ACTIONS(5333),
    [anon_sym_LT_AMP] = ACTIONS(5333),
    [anon_sym_GT_AMP] = ACTIONS(5333),
    [sym__special_characters] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [anon_sym_DOLLAR] = ACTIONS(5335),
    [sym_raw_string] = ACTIONS(5333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5333),
    [anon_sym_BQUOTE] = ACTIONS(5333),
    [anon_sym_LT_LPAREN] = ACTIONS(5333),
    [anon_sym_GT_LPAREN] = ACTIONS(5333),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5333),
  },
  [2249] = {
    [sym__concat] = ACTIONS(5325),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [sym__string_content] = ACTIONS(5325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5327),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5327),
    [anon_sym_BQUOTE] = ACTIONS(5327),
    [sym_comment] = ACTIONS(177),
  },
  [2250] = {
    [sym__concat] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5331),
    [anon_sym_DOLLAR] = ACTIONS(5331),
    [sym__string_content] = ACTIONS(5329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5331),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5331),
    [anon_sym_BQUOTE] = ACTIONS(5331),
    [sym_comment] = ACTIONS(177),
  },
  [2251] = {
    [sym__concat] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5335),
    [sym__string_content] = ACTIONS(5333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5335),
    [anon_sym_BQUOTE] = ACTIONS(5335),
    [sym_comment] = ACTIONS(177),
  },
  [2252] = {
    [sym__concat] = ACTIONS(3829),
    [anon_sym_RBRACE] = ACTIONS(3829),
    [sym_comment] = ACTIONS(53),
  },
  [2253] = {
    [sym__concat] = ACTIONS(3835),
    [anon_sym_RBRACE] = ACTIONS(3835),
    [sym_comment] = ACTIONS(53),
  },
  [2254] = {
    [sym__concat] = ACTIONS(3920),
    [anon_sym_RBRACE] = ACTIONS(3920),
    [sym_comment] = ACTIONS(53),
  },
  [2255] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5657),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2256] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5659),
    [sym_comment] = ACTIONS(53),
  },
  [2257] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5661),
    [sym_comment] = ACTIONS(53),
  },
  [2258] = {
    [anon_sym_RBRACE] = ACTIONS(5661),
    [sym_comment] = ACTIONS(53),
  },
  [2259] = {
    [sym_concatenation] = STATE(2454),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2454),
    [anon_sym_RBRACE] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5665),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5665),
    [anon_sym_COLON_QMARK] = ACTIONS(5665),
    [anon_sym_COLON_DASH] = ACTIONS(5665),
    [anon_sym_PERCENT] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2260] = {
    [sym__concat] = ACTIONS(3936),
    [anon_sym_RBRACE] = ACTIONS(3936),
    [sym_comment] = ACTIONS(53),
  },
  [2261] = {
    [sym_concatenation] = STATE(2456),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2456),
    [anon_sym_RBRACE] = ACTIONS(5669),
    [anon_sym_EQ] = ACTIONS(5671),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5671),
    [anon_sym_COLON_QMARK] = ACTIONS(5671),
    [anon_sym_COLON_DASH] = ACTIONS(5671),
    [anon_sym_PERCENT] = ACTIONS(5671),
    [anon_sym_DASH] = ACTIONS(5671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2262] = {
    [sym__concat] = ACTIONS(3946),
    [anon_sym_RBRACE] = ACTIONS(3946),
    [sym_comment] = ACTIONS(53),
  },
  [2263] = {
    [sym_concatenation] = STATE(2458),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2458),
    [anon_sym_RBRACE] = ACTIONS(5675),
    [anon_sym_EQ] = ACTIONS(5677),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5677),
    [anon_sym_COLON_QMARK] = ACTIONS(5677),
    [anon_sym_COLON_DASH] = ACTIONS(5677),
    [anon_sym_PERCENT] = ACTIONS(5677),
    [anon_sym_DASH] = ACTIONS(5677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2264] = {
    [sym__concat] = ACTIONS(3956),
    [anon_sym_RBRACE] = ACTIONS(3956),
    [sym_comment] = ACTIONS(53),
  },
  [2265] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5681),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2266] = {
    [sym__concat] = ACTIONS(3962),
    [anon_sym_RBRACE] = ACTIONS(3962),
    [sym_comment] = ACTIONS(53),
  },
  [2267] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5683),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2268] = {
    [sym__concat] = ACTIONS(4741),
    [anon_sym_RBRACE] = ACTIONS(4741),
    [anon_sym_EQ] = ACTIONS(4743),
    [sym__special_characters] = ACTIONS(4743),
    [anon_sym_DQUOTE] = ACTIONS(4741),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [sym_raw_string] = ACTIONS(4741),
    [anon_sym_POUND] = ACTIONS(4741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4741),
    [anon_sym_COLON] = ACTIONS(4743),
    [anon_sym_COLON_QMARK] = ACTIONS(4743),
    [anon_sym_COLON_DASH] = ACTIONS(4743),
    [anon_sym_PERCENT] = ACTIONS(4743),
    [anon_sym_DASH] = ACTIONS(4743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4741),
    [anon_sym_BQUOTE] = ACTIONS(4741),
    [anon_sym_LT_LPAREN] = ACTIONS(4741),
    [anon_sym_GT_LPAREN] = ACTIONS(4741),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4743),
  },
  [2269] = {
    [sym__concat] = ACTIONS(4745),
    [anon_sym_RBRACE] = ACTIONS(4745),
    [anon_sym_EQ] = ACTIONS(4747),
    [sym__special_characters] = ACTIONS(4747),
    [anon_sym_DQUOTE] = ACTIONS(4745),
    [anon_sym_DOLLAR] = ACTIONS(4747),
    [sym_raw_string] = ACTIONS(4745),
    [anon_sym_POUND] = ACTIONS(4745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4745),
    [anon_sym_COLON] = ACTIONS(4747),
    [anon_sym_COLON_QMARK] = ACTIONS(4747),
    [anon_sym_COLON_DASH] = ACTIONS(4747),
    [anon_sym_PERCENT] = ACTIONS(4747),
    [anon_sym_DASH] = ACTIONS(4747),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4745),
    [anon_sym_BQUOTE] = ACTIONS(4745),
    [anon_sym_LT_LPAREN] = ACTIONS(4745),
    [anon_sym_GT_LPAREN] = ACTIONS(4745),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4747),
  },
  [2270] = {
    [sym__concat] = ACTIONS(4749),
    [anon_sym_RBRACE] = ACTIONS(4749),
    [anon_sym_EQ] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4749),
    [anon_sym_DOLLAR] = ACTIONS(4751),
    [sym_raw_string] = ACTIONS(4749),
    [anon_sym_POUND] = ACTIONS(4749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4749),
    [anon_sym_COLON] = ACTIONS(4751),
    [anon_sym_COLON_QMARK] = ACTIONS(4751),
    [anon_sym_COLON_DASH] = ACTIONS(4751),
    [anon_sym_PERCENT] = ACTIONS(4751),
    [anon_sym_DASH] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4749),
    [anon_sym_BQUOTE] = ACTIONS(4749),
    [anon_sym_LT_LPAREN] = ACTIONS(4749),
    [anon_sym_GT_LPAREN] = ACTIONS(4749),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4751),
  },
  [2271] = {
    [sym__concat] = ACTIONS(4753),
    [anon_sym_RBRACE] = ACTIONS(4753),
    [anon_sym_EQ] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4753),
    [anon_sym_DOLLAR] = ACTIONS(4755),
    [sym_raw_string] = ACTIONS(4753),
    [anon_sym_POUND] = ACTIONS(4753),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4753),
    [anon_sym_COLON] = ACTIONS(4755),
    [anon_sym_COLON_QMARK] = ACTIONS(4755),
    [anon_sym_COLON_DASH] = ACTIONS(4755),
    [anon_sym_PERCENT] = ACTIONS(4755),
    [anon_sym_DASH] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4753),
    [anon_sym_BQUOTE] = ACTIONS(4753),
    [anon_sym_LT_LPAREN] = ACTIONS(4753),
    [anon_sym_GT_LPAREN] = ACTIONS(4753),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4755),
  },
  [2272] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5685),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2273] = {
    [sym__concat] = ACTIONS(4759),
    [anon_sym_RBRACE] = ACTIONS(4759),
    [anon_sym_EQ] = ACTIONS(4761),
    [sym__special_characters] = ACTIONS(4761),
    [anon_sym_DQUOTE] = ACTIONS(4759),
    [anon_sym_DOLLAR] = ACTIONS(4761),
    [sym_raw_string] = ACTIONS(4759),
    [anon_sym_POUND] = ACTIONS(4759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4759),
    [anon_sym_COLON] = ACTIONS(4761),
    [anon_sym_COLON_QMARK] = ACTIONS(4761),
    [anon_sym_COLON_DASH] = ACTIONS(4761),
    [anon_sym_PERCENT] = ACTIONS(4761),
    [anon_sym_DASH] = ACTIONS(4761),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4759),
    [anon_sym_BQUOTE] = ACTIONS(4759),
    [anon_sym_LT_LPAREN] = ACTIONS(4759),
    [anon_sym_GT_LPAREN] = ACTIONS(4759),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4761),
  },
  [2274] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5687),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2275] = {
    [sym__concat] = ACTIONS(4765),
    [anon_sym_RBRACE] = ACTIONS(4765),
    [anon_sym_EQ] = ACTIONS(4767),
    [sym__special_characters] = ACTIONS(4767),
    [anon_sym_DQUOTE] = ACTIONS(4765),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [sym_raw_string] = ACTIONS(4765),
    [anon_sym_POUND] = ACTIONS(4765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4765),
    [anon_sym_COLON] = ACTIONS(4767),
    [anon_sym_COLON_QMARK] = ACTIONS(4767),
    [anon_sym_COLON_DASH] = ACTIONS(4767),
    [anon_sym_PERCENT] = ACTIONS(4767),
    [anon_sym_DASH] = ACTIONS(4767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4765),
    [anon_sym_BQUOTE] = ACTIONS(4765),
    [anon_sym_LT_LPAREN] = ACTIONS(4765),
    [anon_sym_GT_LPAREN] = ACTIONS(4765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4767),
  },
  [2276] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5689),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2277] = {
    [sym__concat] = ACTIONS(4771),
    [anon_sym_RBRACE] = ACTIONS(4771),
    [anon_sym_EQ] = ACTIONS(4773),
    [sym__special_characters] = ACTIONS(4773),
    [anon_sym_DQUOTE] = ACTIONS(4771),
    [anon_sym_DOLLAR] = ACTIONS(4773),
    [sym_raw_string] = ACTIONS(4771),
    [anon_sym_POUND] = ACTIONS(4771),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4771),
    [anon_sym_COLON] = ACTIONS(4773),
    [anon_sym_COLON_QMARK] = ACTIONS(4773),
    [anon_sym_COLON_DASH] = ACTIONS(4773),
    [anon_sym_PERCENT] = ACTIONS(4773),
    [anon_sym_DASH] = ACTIONS(4773),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4771),
    [anon_sym_BQUOTE] = ACTIONS(4771),
    [anon_sym_LT_LPAREN] = ACTIONS(4771),
    [anon_sym_GT_LPAREN] = ACTIONS(4771),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4773),
  },
  [2278] = {
    [sym__concat] = ACTIONS(4775),
    [anon_sym_RBRACE] = ACTIONS(4775),
    [anon_sym_EQ] = ACTIONS(4777),
    [sym__special_characters] = ACTIONS(4777),
    [anon_sym_DQUOTE] = ACTIONS(4775),
    [anon_sym_DOLLAR] = ACTIONS(4777),
    [sym_raw_string] = ACTIONS(4775),
    [anon_sym_POUND] = ACTIONS(4775),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4775),
    [anon_sym_COLON] = ACTIONS(4777),
    [anon_sym_COLON_QMARK] = ACTIONS(4777),
    [anon_sym_COLON_DASH] = ACTIONS(4777),
    [anon_sym_PERCENT] = ACTIONS(4777),
    [anon_sym_DASH] = ACTIONS(4777),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4775),
    [anon_sym_BQUOTE] = ACTIONS(4775),
    [anon_sym_LT_LPAREN] = ACTIONS(4775),
    [anon_sym_GT_LPAREN] = ACTIONS(4775),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4777),
  },
  [2279] = {
    [anon_sym_PIPE] = ACTIONS(5063),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_PIPE_AMP] = ACTIONS(5065),
    [anon_sym_AMP_AMP] = ACTIONS(5065),
    [anon_sym_PIPE_PIPE] = ACTIONS(5065),
    [anon_sym_BQUOTE] = ACTIONS(5065),
    [sym_comment] = ACTIONS(53),
  },
  [2280] = {
    [anon_sym_PIPE] = ACTIONS(5156),
    [anon_sym_RPAREN] = ACTIONS(5158),
    [anon_sym_PIPE_AMP] = ACTIONS(5158),
    [anon_sym_AMP_AMP] = ACTIONS(5158),
    [anon_sym_PIPE_PIPE] = ACTIONS(5158),
    [anon_sym_BQUOTE] = ACTIONS(5158),
    [sym_comment] = ACTIONS(53),
  },
  [2281] = {
    [anon_sym_esac] = ACTIONS(5691),
    [sym_comment] = ACTIONS(53),
  },
  [2282] = {
    [anon_sym_PIPE] = ACTIONS(5166),
    [anon_sym_RPAREN] = ACTIONS(5168),
    [anon_sym_PIPE_AMP] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_BQUOTE] = ACTIONS(5168),
    [sym_comment] = ACTIONS(53),
  },
  [2283] = {
    [anon_sym_esac] = ACTIONS(5693),
    [sym_comment] = ACTIONS(53),
  },
  [2284] = {
    [aux_sym_concatenation_repeat1] = STATE(2284),
    [sym__concat] = ACTIONS(4075),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
  },
  [2285] = {
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1642),
    [anon_sym_LT_LT_LT] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
  },
  [2286] = {
    [aux_sym_concatenation_repeat1] = STATE(2286),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(5695),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1642),
    [anon_sym_LT_LT_LT] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
  },
  [2287] = {
    [sym_file_descriptor] = ACTIONS(1691),
    [sym__concat] = ACTIONS(1691),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_RPAREN] = ACTIONS(1691),
    [anon_sym_PIPE_AMP] = ACTIONS(1691),
    [anon_sym_AMP_AMP] = ACTIONS(1691),
    [anon_sym_PIPE_PIPE] = ACTIONS(1691),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1691),
    [anon_sym_AMP_GT] = ACTIONS(1693),
    [anon_sym_AMP_GT_GT] = ACTIONS(1691),
    [anon_sym_LT_AMP] = ACTIONS(1691),
    [anon_sym_GT_AMP] = ACTIONS(1691),
    [anon_sym_LT_LT] = ACTIONS(1693),
    [anon_sym_LT_LT_DASH] = ACTIONS(1691),
    [anon_sym_LT_LT_LT] = ACTIONS(1691),
    [anon_sym_BQUOTE] = ACTIONS(1691),
    [sym_comment] = ACTIONS(53),
  },
  [2288] = {
    [sym_concatenation] = STATE(2469),
    [sym_string] = STATE(2468),
    [sym_simple_expansion] = STATE(2468),
    [sym_string_expansion] = STATE(2468),
    [sym_expansion] = STATE(2468),
    [sym_command_substitution] = STATE(2468),
    [sym_process_substitution] = STATE(2468),
    [anon_sym_RBRACE] = ACTIONS(5698),
    [sym__special_characters] = ACTIONS(5700),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(5702),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5702),
  },
  [2289] = {
    [sym_file_descriptor] = ACTIONS(1732),
    [sym__concat] = ACTIONS(1732),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [anon_sym_PIPE_AMP] = ACTIONS(1732),
    [anon_sym_AMP_AMP] = ACTIONS(1732),
    [anon_sym_PIPE_PIPE] = ACTIONS(1732),
    [anon_sym_LT] = ACTIONS(1734),
    [anon_sym_GT] = ACTIONS(1734),
    [anon_sym_GT_GT] = ACTIONS(1732),
    [anon_sym_AMP_GT] = ACTIONS(1734),
    [anon_sym_AMP_GT_GT] = ACTIONS(1732),
    [anon_sym_LT_AMP] = ACTIONS(1732),
    [anon_sym_GT_AMP] = ACTIONS(1732),
    [anon_sym_LT_LT] = ACTIONS(1734),
    [anon_sym_LT_LT_DASH] = ACTIONS(1732),
    [anon_sym_LT_LT_LT] = ACTIONS(1732),
    [anon_sym_BQUOTE] = ACTIONS(1732),
    [sym_comment] = ACTIONS(53),
  },
  [2290] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5704),
  },
  [2291] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2292] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(5708),
    [sym_comment] = ACTIONS(53),
  },
  [2293] = {
    [sym_concatenation] = STATE(2475),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2475),
    [anon_sym_RBRACE] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5712),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5716),
    [anon_sym_COLON] = ACTIONS(5712),
    [anon_sym_COLON_QMARK] = ACTIONS(5712),
    [anon_sym_COLON_DASH] = ACTIONS(5712),
    [anon_sym_PERCENT] = ACTIONS(5712),
    [anon_sym_DASH] = ACTIONS(5712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2294] = {
    [sym_concatenation] = STATE(2478),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2478),
    [anon_sym_RBRACE] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5720),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5724),
    [anon_sym_COLON] = ACTIONS(5720),
    [anon_sym_COLON_QMARK] = ACTIONS(5720),
    [anon_sym_COLON_DASH] = ACTIONS(5720),
    [anon_sym_PERCENT] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2295] = {
    [sym_concatenation] = STATE(2480),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2480),
    [anon_sym_RBRACE] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5726),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5730),
    [anon_sym_COLON] = ACTIONS(5726),
    [anon_sym_COLON_QMARK] = ACTIONS(5726),
    [anon_sym_COLON_DASH] = ACTIONS(5726),
    [anon_sym_PERCENT] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2296] = {
    [sym_file_descriptor] = ACTIONS(1798),
    [sym__concat] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1798),
    [anon_sym_PIPE_AMP] = ACTIONS(1798),
    [anon_sym_AMP_AMP] = ACTIONS(1798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1798),
    [anon_sym_LT] = ACTIONS(1800),
    [anon_sym_GT] = ACTIONS(1800),
    [anon_sym_GT_GT] = ACTIONS(1798),
    [anon_sym_AMP_GT] = ACTIONS(1800),
    [anon_sym_AMP_GT_GT] = ACTIONS(1798),
    [anon_sym_LT_AMP] = ACTIONS(1798),
    [anon_sym_GT_AMP] = ACTIONS(1798),
    [anon_sym_LT_LT] = ACTIONS(1800),
    [anon_sym_LT_LT_DASH] = ACTIONS(1798),
    [anon_sym_LT_LT_LT] = ACTIONS(1798),
    [anon_sym_BQUOTE] = ACTIONS(1798),
    [sym_comment] = ACTIONS(53),
  },
  [2297] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5732),
  },
  [2298] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2299] = {
    [sym_file_descriptor] = ACTIONS(1806),
    [sym__concat] = ACTIONS(1806),
    [anon_sym_PIPE] = ACTIONS(1808),
    [anon_sym_RPAREN] = ACTIONS(1806),
    [anon_sym_PIPE_AMP] = ACTIONS(1806),
    [anon_sym_AMP_AMP] = ACTIONS(1806),
    [anon_sym_PIPE_PIPE] = ACTIONS(1806),
    [anon_sym_LT] = ACTIONS(1808),
    [anon_sym_GT] = ACTIONS(1808),
    [anon_sym_GT_GT] = ACTIONS(1806),
    [anon_sym_AMP_GT] = ACTIONS(1808),
    [anon_sym_AMP_GT_GT] = ACTIONS(1806),
    [anon_sym_LT_AMP] = ACTIONS(1806),
    [anon_sym_GT_AMP] = ACTIONS(1806),
    [anon_sym_LT_LT] = ACTIONS(1808),
    [anon_sym_LT_LT_DASH] = ACTIONS(1806),
    [anon_sym_LT_LT_LT] = ACTIONS(1806),
    [anon_sym_BQUOTE] = ACTIONS(1806),
    [sym_comment] = ACTIONS(53),
  },
  [2300] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5736),
  },
  [2301] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2302] = {
    [sym_file_descriptor] = ACTIONS(1940),
    [sym__concat] = ACTIONS(1940),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_PIPE_PIPE] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1940),
    [anon_sym_AMP_GT] = ACTIONS(1942),
    [anon_sym_AMP_GT_GT] = ACTIONS(1940),
    [anon_sym_LT_AMP] = ACTIONS(1940),
    [anon_sym_GT_AMP] = ACTIONS(1940),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_LT_LT_DASH] = ACTIONS(1940),
    [anon_sym_LT_LT_LT] = ACTIONS(1940),
    [anon_sym_BQUOTE] = ACTIONS(1940),
    [sym_comment] = ACTIONS(53),
  },
  [2303] = {
    [sym_file_descriptor] = ACTIONS(2006),
    [sym__concat] = ACTIONS(2006),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_RPAREN] = ACTIONS(2006),
    [anon_sym_PIPE_AMP] = ACTIONS(2006),
    [anon_sym_AMP_AMP] = ACTIONS(2006),
    [anon_sym_PIPE_PIPE] = ACTIONS(2006),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2006),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2006),
    [anon_sym_LT_AMP] = ACTIONS(2006),
    [anon_sym_GT_AMP] = ACTIONS(2006),
    [anon_sym_LT_LT] = ACTIONS(2008),
    [anon_sym_LT_LT_DASH] = ACTIONS(2006),
    [anon_sym_LT_LT_LT] = ACTIONS(2006),
    [anon_sym_BQUOTE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(53),
  },
  [2304] = {
    [sym__concat] = ACTIONS(4741),
    [sym_variable_name] = ACTIONS(4741),
    [anon_sym_PIPE] = ACTIONS(4743),
    [anon_sym_RPAREN] = ACTIONS(4741),
    [anon_sym_PIPE_AMP] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [sym__special_characters] = ACTIONS(4741),
    [anon_sym_DQUOTE] = ACTIONS(4741),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [sym_raw_string] = ACTIONS(4741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4741),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4741),
    [anon_sym_BQUOTE] = ACTIONS(4741),
    [anon_sym_LT_LPAREN] = ACTIONS(4741),
    [anon_sym_GT_LPAREN] = ACTIONS(4741),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4743),
    [sym_word] = ACTIONS(4743),
  },
  [2305] = {
    [sym__concat] = ACTIONS(4745),
    [sym_variable_name] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(4747),
    [anon_sym_RPAREN] = ACTIONS(4745),
    [anon_sym_PIPE_AMP] = ACTIONS(4745),
    [anon_sym_AMP_AMP] = ACTIONS(4745),
    [anon_sym_PIPE_PIPE] = ACTIONS(4745),
    [sym__special_characters] = ACTIONS(4745),
    [anon_sym_DQUOTE] = ACTIONS(4745),
    [anon_sym_DOLLAR] = ACTIONS(4747),
    [sym_raw_string] = ACTIONS(4745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4745),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4745),
    [anon_sym_BQUOTE] = ACTIONS(4745),
    [anon_sym_LT_LPAREN] = ACTIONS(4745),
    [anon_sym_GT_LPAREN] = ACTIONS(4745),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4747),
    [sym_word] = ACTIONS(4747),
  },
  [2306] = {
    [sym__concat] = ACTIONS(4749),
    [sym_variable_name] = ACTIONS(4749),
    [anon_sym_PIPE] = ACTIONS(4751),
    [anon_sym_RPAREN] = ACTIONS(4749),
    [anon_sym_PIPE_AMP] = ACTIONS(4749),
    [anon_sym_AMP_AMP] = ACTIONS(4749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4749),
    [sym__special_characters] = ACTIONS(4749),
    [anon_sym_DQUOTE] = ACTIONS(4749),
    [anon_sym_DOLLAR] = ACTIONS(4751),
    [sym_raw_string] = ACTIONS(4749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4749),
    [anon_sym_BQUOTE] = ACTIONS(4749),
    [anon_sym_LT_LPAREN] = ACTIONS(4749),
    [anon_sym_GT_LPAREN] = ACTIONS(4749),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4751),
    [sym_word] = ACTIONS(4751),
  },
  [2307] = {
    [sym__concat] = ACTIONS(4753),
    [sym_variable_name] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4755),
    [anon_sym_RPAREN] = ACTIONS(4753),
    [anon_sym_PIPE_AMP] = ACTIONS(4753),
    [anon_sym_AMP_AMP] = ACTIONS(4753),
    [anon_sym_PIPE_PIPE] = ACTIONS(4753),
    [sym__special_characters] = ACTIONS(4753),
    [anon_sym_DQUOTE] = ACTIONS(4753),
    [anon_sym_DOLLAR] = ACTIONS(4755),
    [sym_raw_string] = ACTIONS(4753),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4753),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4753),
    [anon_sym_BQUOTE] = ACTIONS(4753),
    [anon_sym_LT_LPAREN] = ACTIONS(4753),
    [anon_sym_GT_LPAREN] = ACTIONS(4753),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4755),
    [sym_word] = ACTIONS(4755),
  },
  [2308] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2309] = {
    [sym__concat] = ACTIONS(4759),
    [sym_variable_name] = ACTIONS(4759),
    [anon_sym_PIPE] = ACTIONS(4761),
    [anon_sym_RPAREN] = ACTIONS(4759),
    [anon_sym_PIPE_AMP] = ACTIONS(4759),
    [anon_sym_AMP_AMP] = ACTIONS(4759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4759),
    [sym__special_characters] = ACTIONS(4759),
    [anon_sym_DQUOTE] = ACTIONS(4759),
    [anon_sym_DOLLAR] = ACTIONS(4761),
    [sym_raw_string] = ACTIONS(4759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4759),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4759),
    [anon_sym_BQUOTE] = ACTIONS(4759),
    [anon_sym_LT_LPAREN] = ACTIONS(4759),
    [anon_sym_GT_LPAREN] = ACTIONS(4759),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4761),
    [sym_word] = ACTIONS(4761),
  },
  [2310] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5740),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2311] = {
    [sym__concat] = ACTIONS(4765),
    [sym_variable_name] = ACTIONS(4765),
    [anon_sym_PIPE] = ACTIONS(4767),
    [anon_sym_RPAREN] = ACTIONS(4765),
    [anon_sym_PIPE_AMP] = ACTIONS(4765),
    [anon_sym_AMP_AMP] = ACTIONS(4765),
    [anon_sym_PIPE_PIPE] = ACTIONS(4765),
    [sym__special_characters] = ACTIONS(4765),
    [anon_sym_DQUOTE] = ACTIONS(4765),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [sym_raw_string] = ACTIONS(4765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4765),
    [anon_sym_BQUOTE] = ACTIONS(4765),
    [anon_sym_LT_LPAREN] = ACTIONS(4765),
    [anon_sym_GT_LPAREN] = ACTIONS(4765),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4767),
    [sym_word] = ACTIONS(4767),
  },
  [2312] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2313] = {
    [sym__concat] = ACTIONS(4771),
    [sym_variable_name] = ACTIONS(4771),
    [anon_sym_PIPE] = ACTIONS(4773),
    [anon_sym_RPAREN] = ACTIONS(4771),
    [anon_sym_PIPE_AMP] = ACTIONS(4771),
    [anon_sym_AMP_AMP] = ACTIONS(4771),
    [anon_sym_PIPE_PIPE] = ACTIONS(4771),
    [sym__special_characters] = ACTIONS(4771),
    [anon_sym_DQUOTE] = ACTIONS(4771),
    [anon_sym_DOLLAR] = ACTIONS(4773),
    [sym_raw_string] = ACTIONS(4771),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4771),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4771),
    [anon_sym_BQUOTE] = ACTIONS(4771),
    [anon_sym_LT_LPAREN] = ACTIONS(4771),
    [anon_sym_GT_LPAREN] = ACTIONS(4771),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4773),
    [sym_word] = ACTIONS(4773),
  },
  [2314] = {
    [sym__concat] = ACTIONS(4775),
    [sym_variable_name] = ACTIONS(4775),
    [anon_sym_PIPE] = ACTIONS(4777),
    [anon_sym_RPAREN] = ACTIONS(4775),
    [anon_sym_PIPE_AMP] = ACTIONS(4775),
    [anon_sym_AMP_AMP] = ACTIONS(4775),
    [anon_sym_PIPE_PIPE] = ACTIONS(4775),
    [sym__special_characters] = ACTIONS(4775),
    [anon_sym_DQUOTE] = ACTIONS(4775),
    [anon_sym_DOLLAR] = ACTIONS(4777),
    [sym_raw_string] = ACTIONS(4775),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4775),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4775),
    [anon_sym_BQUOTE] = ACTIONS(4775),
    [anon_sym_LT_LPAREN] = ACTIONS(4775),
    [anon_sym_GT_LPAREN] = ACTIONS(4775),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4777),
    [sym_word] = ACTIONS(4777),
  },
  [2315] = {
    [sym__concat] = ACTIONS(4741),
    [anon_sym_PIPE] = ACTIONS(4743),
    [anon_sym_RPAREN] = ACTIONS(4741),
    [anon_sym_PIPE_AMP] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [sym__special_characters] = ACTIONS(4741),
    [anon_sym_DQUOTE] = ACTIONS(4741),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [sym_raw_string] = ACTIONS(4741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4741),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4741),
    [anon_sym_BQUOTE] = ACTIONS(4741),
    [anon_sym_LT_LPAREN] = ACTIONS(4741),
    [anon_sym_GT_LPAREN] = ACTIONS(4741),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4743),
    [sym_word] = ACTIONS(4743),
  },
  [2316] = {
    [sym__concat] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(4747),
    [anon_sym_RPAREN] = ACTIONS(4745),
    [anon_sym_PIPE_AMP] = ACTIONS(4745),
    [anon_sym_AMP_AMP] = ACTIONS(4745),
    [anon_sym_PIPE_PIPE] = ACTIONS(4745),
    [sym__special_characters] = ACTIONS(4745),
    [anon_sym_DQUOTE] = ACTIONS(4745),
    [anon_sym_DOLLAR] = ACTIONS(4747),
    [sym_raw_string] = ACTIONS(4745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4745),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4745),
    [anon_sym_BQUOTE] = ACTIONS(4745),
    [anon_sym_LT_LPAREN] = ACTIONS(4745),
    [anon_sym_GT_LPAREN] = ACTIONS(4745),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4747),
    [sym_word] = ACTIONS(4747),
  },
  [2317] = {
    [sym__concat] = ACTIONS(4749),
    [anon_sym_PIPE] = ACTIONS(4751),
    [anon_sym_RPAREN] = ACTIONS(4749),
    [anon_sym_PIPE_AMP] = ACTIONS(4749),
    [anon_sym_AMP_AMP] = ACTIONS(4749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4749),
    [sym__special_characters] = ACTIONS(4749),
    [anon_sym_DQUOTE] = ACTIONS(4749),
    [anon_sym_DOLLAR] = ACTIONS(4751),
    [sym_raw_string] = ACTIONS(4749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4749),
    [anon_sym_BQUOTE] = ACTIONS(4749),
    [anon_sym_LT_LPAREN] = ACTIONS(4749),
    [anon_sym_GT_LPAREN] = ACTIONS(4749),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4751),
    [sym_word] = ACTIONS(4751),
  },
  [2318] = {
    [sym__concat] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4755),
    [anon_sym_RPAREN] = ACTIONS(4753),
    [anon_sym_PIPE_AMP] = ACTIONS(4753),
    [anon_sym_AMP_AMP] = ACTIONS(4753),
    [anon_sym_PIPE_PIPE] = ACTIONS(4753),
    [sym__special_characters] = ACTIONS(4753),
    [anon_sym_DQUOTE] = ACTIONS(4753),
    [anon_sym_DOLLAR] = ACTIONS(4755),
    [sym_raw_string] = ACTIONS(4753),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4753),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4753),
    [anon_sym_BQUOTE] = ACTIONS(4753),
    [anon_sym_LT_LPAREN] = ACTIONS(4753),
    [anon_sym_GT_LPAREN] = ACTIONS(4753),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4755),
    [sym_word] = ACTIONS(4755),
  },
  [2319] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5744),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2320] = {
    [sym__concat] = ACTIONS(4759),
    [anon_sym_PIPE] = ACTIONS(4761),
    [anon_sym_RPAREN] = ACTIONS(4759),
    [anon_sym_PIPE_AMP] = ACTIONS(4759),
    [anon_sym_AMP_AMP] = ACTIONS(4759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4759),
    [sym__special_characters] = ACTIONS(4759),
    [anon_sym_DQUOTE] = ACTIONS(4759),
    [anon_sym_DOLLAR] = ACTIONS(4761),
    [sym_raw_string] = ACTIONS(4759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4759),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4759),
    [anon_sym_BQUOTE] = ACTIONS(4759),
    [anon_sym_LT_LPAREN] = ACTIONS(4759),
    [anon_sym_GT_LPAREN] = ACTIONS(4759),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4761),
    [sym_word] = ACTIONS(4761),
  },
  [2321] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2322] = {
    [sym__concat] = ACTIONS(4765),
    [anon_sym_PIPE] = ACTIONS(4767),
    [anon_sym_RPAREN] = ACTIONS(4765),
    [anon_sym_PIPE_AMP] = ACTIONS(4765),
    [anon_sym_AMP_AMP] = ACTIONS(4765),
    [anon_sym_PIPE_PIPE] = ACTIONS(4765),
    [sym__special_characters] = ACTIONS(4765),
    [anon_sym_DQUOTE] = ACTIONS(4765),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [sym_raw_string] = ACTIONS(4765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4765),
    [anon_sym_BQUOTE] = ACTIONS(4765),
    [anon_sym_LT_LPAREN] = ACTIONS(4765),
    [anon_sym_GT_LPAREN] = ACTIONS(4765),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4767),
    [sym_word] = ACTIONS(4767),
  },
  [2323] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5748),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2324] = {
    [sym__concat] = ACTIONS(4771),
    [anon_sym_PIPE] = ACTIONS(4773),
    [anon_sym_RPAREN] = ACTIONS(4771),
    [anon_sym_PIPE_AMP] = ACTIONS(4771),
    [anon_sym_AMP_AMP] = ACTIONS(4771),
    [anon_sym_PIPE_PIPE] = ACTIONS(4771),
    [sym__special_characters] = ACTIONS(4771),
    [anon_sym_DQUOTE] = ACTIONS(4771),
    [anon_sym_DOLLAR] = ACTIONS(4773),
    [sym_raw_string] = ACTIONS(4771),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4771),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4771),
    [anon_sym_BQUOTE] = ACTIONS(4771),
    [anon_sym_LT_LPAREN] = ACTIONS(4771),
    [anon_sym_GT_LPAREN] = ACTIONS(4771),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4773),
    [sym_word] = ACTIONS(4773),
  },
  [2325] = {
    [sym__concat] = ACTIONS(4775),
    [anon_sym_PIPE] = ACTIONS(4777),
    [anon_sym_RPAREN] = ACTIONS(4775),
    [anon_sym_PIPE_AMP] = ACTIONS(4775),
    [anon_sym_AMP_AMP] = ACTIONS(4775),
    [anon_sym_PIPE_PIPE] = ACTIONS(4775),
    [sym__special_characters] = ACTIONS(4775),
    [anon_sym_DQUOTE] = ACTIONS(4775),
    [anon_sym_DOLLAR] = ACTIONS(4777),
    [sym_raw_string] = ACTIONS(4775),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4775),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4775),
    [anon_sym_BQUOTE] = ACTIONS(4775),
    [anon_sym_LT_LPAREN] = ACTIONS(4775),
    [anon_sym_GT_LPAREN] = ACTIONS(4775),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4777),
    [sym_word] = ACTIONS(4777),
  },
  [2326] = {
    [sym__simple_heredoc_body] = ACTIONS(5325),
    [sym__heredoc_body_beginning] = ACTIONS(5325),
    [sym_file_descriptor] = ACTIONS(5325),
    [sym__concat] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [anon_sym_PIPE_AMP] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_EQ_TILDE] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_GT_GT] = ACTIONS(5325),
    [anon_sym_AMP_GT] = ACTIONS(5327),
    [anon_sym_AMP_GT_GT] = ACTIONS(5325),
    [anon_sym_LT_AMP] = ACTIONS(5325),
    [anon_sym_GT_AMP] = ACTIONS(5325),
    [anon_sym_LT_LT] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5325),
    [anon_sym_LT_LT_LT] = ACTIONS(5325),
    [sym__special_characters] = ACTIONS(5325),
    [anon_sym_DQUOTE] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [sym_raw_string] = ACTIONS(5325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5325),
    [anon_sym_BQUOTE] = ACTIONS(5325),
    [anon_sym_LT_LPAREN] = ACTIONS(5325),
    [anon_sym_GT_LPAREN] = ACTIONS(5325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5327),
  },
  [2327] = {
    [sym__simple_heredoc_body] = ACTIONS(5329),
    [sym__heredoc_body_beginning] = ACTIONS(5329),
    [sym_file_descriptor] = ACTIONS(5329),
    [sym__concat] = ACTIONS(5329),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5329),
    [anon_sym_PIPE_AMP] = ACTIONS(5329),
    [anon_sym_AMP_AMP] = ACTIONS(5329),
    [anon_sym_PIPE_PIPE] = ACTIONS(5329),
    [anon_sym_EQ_TILDE] = ACTIONS(5331),
    [anon_sym_EQ_EQ] = ACTIONS(5331),
    [anon_sym_LT] = ACTIONS(5331),
    [anon_sym_GT] = ACTIONS(5331),
    [anon_sym_GT_GT] = ACTIONS(5329),
    [anon_sym_AMP_GT] = ACTIONS(5331),
    [anon_sym_AMP_GT_GT] = ACTIONS(5329),
    [anon_sym_LT_AMP] = ACTIONS(5329),
    [anon_sym_GT_AMP] = ACTIONS(5329),
    [anon_sym_LT_LT] = ACTIONS(5331),
    [anon_sym_LT_LT_DASH] = ACTIONS(5329),
    [anon_sym_LT_LT_LT] = ACTIONS(5329),
    [sym__special_characters] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [anon_sym_DOLLAR] = ACTIONS(5331),
    [sym_raw_string] = ACTIONS(5329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5329),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5329),
    [anon_sym_BQUOTE] = ACTIONS(5329),
    [anon_sym_LT_LPAREN] = ACTIONS(5329),
    [anon_sym_GT_LPAREN] = ACTIONS(5329),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5331),
  },
  [2328] = {
    [sym__simple_heredoc_body] = ACTIONS(5333),
    [sym__heredoc_body_beginning] = ACTIONS(5333),
    [sym_file_descriptor] = ACTIONS(5333),
    [sym__concat] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_RPAREN] = ACTIONS(5333),
    [anon_sym_PIPE_AMP] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_EQ_TILDE] = ACTIONS(5335),
    [anon_sym_EQ_EQ] = ACTIONS(5335),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_GT] = ACTIONS(5333),
    [anon_sym_AMP_GT] = ACTIONS(5335),
    [anon_sym_AMP_GT_GT] = ACTIONS(5333),
    [anon_sym_LT_AMP] = ACTIONS(5333),
    [anon_sym_GT_AMP] = ACTIONS(5333),
    [anon_sym_LT_LT] = ACTIONS(5335),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_LT] = ACTIONS(5333),
    [sym__special_characters] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [anon_sym_DOLLAR] = ACTIONS(5335),
    [sym_raw_string] = ACTIONS(5333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5333),
    [anon_sym_BQUOTE] = ACTIONS(5333),
    [anon_sym_LT_LPAREN] = ACTIONS(5333),
    [anon_sym_GT_LPAREN] = ACTIONS(5333),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5335),
  },
  [2329] = {
    [aux_sym_concatenation_repeat1] = STATE(2329),
    [sym__concat] = ACTIONS(4075),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
  },
  [2330] = {
    [aux_sym_concatenation_repeat1] = STATE(2330),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(5695),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1642),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_AMP] = ACTIONS(1642),
    [anon_sym_GT_AMP] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1642),
    [anon_sym_LT_LT_LT] = ACTIONS(1642),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(53),
  },
  [2331] = {
    [sym__heredoc_body_middle] = ACTIONS(4741),
    [sym__heredoc_body_end] = ACTIONS(4741),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4741),
    [sym_comment] = ACTIONS(53),
  },
  [2332] = {
    [sym__heredoc_body_middle] = ACTIONS(4745),
    [sym__heredoc_body_end] = ACTIONS(4745),
    [anon_sym_DOLLAR] = ACTIONS(4747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(53),
  },
  [2333] = {
    [sym__heredoc_body_middle] = ACTIONS(4749),
    [sym__heredoc_body_end] = ACTIONS(4749),
    [anon_sym_DOLLAR] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4749),
    [sym_comment] = ACTIONS(53),
  },
  [2334] = {
    [sym__heredoc_body_middle] = ACTIONS(4753),
    [sym__heredoc_body_end] = ACTIONS(4753),
    [anon_sym_DOLLAR] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4753),
    [sym_comment] = ACTIONS(53),
  },
  [2335] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2336] = {
    [sym__heredoc_body_middle] = ACTIONS(4759),
    [sym__heredoc_body_end] = ACTIONS(4759),
    [anon_sym_DOLLAR] = ACTIONS(4761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4759),
    [sym_comment] = ACTIONS(53),
  },
  [2337] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2338] = {
    [sym__heredoc_body_middle] = ACTIONS(4765),
    [sym__heredoc_body_end] = ACTIONS(4765),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4765),
    [sym_comment] = ACTIONS(53),
  },
  [2339] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2340] = {
    [sym__heredoc_body_middle] = ACTIONS(4771),
    [sym__heredoc_body_end] = ACTIONS(4771),
    [anon_sym_DOLLAR] = ACTIONS(4773),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4771),
    [sym_comment] = ACTIONS(53),
  },
  [2341] = {
    [sym__heredoc_body_middle] = ACTIONS(4775),
    [sym__heredoc_body_end] = ACTIONS(4775),
    [anon_sym_DOLLAR] = ACTIONS(4777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4775),
    [sym_comment] = ACTIONS(53),
  },
  [2342] = {
    [sym__concat] = ACTIONS(4741),
    [anon_sym_RPAREN] = ACTIONS(4741),
    [sym__special_characters] = ACTIONS(4741),
    [anon_sym_DQUOTE] = ACTIONS(4741),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [sym_raw_string] = ACTIONS(4741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4741),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4741),
    [anon_sym_BQUOTE] = ACTIONS(4741),
    [anon_sym_LT_LPAREN] = ACTIONS(4741),
    [anon_sym_GT_LPAREN] = ACTIONS(4741),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4741),
  },
  [2343] = {
    [sym__concat] = ACTIONS(4745),
    [anon_sym_RPAREN] = ACTIONS(4745),
    [sym__special_characters] = ACTIONS(4745),
    [anon_sym_DQUOTE] = ACTIONS(4745),
    [anon_sym_DOLLAR] = ACTIONS(4747),
    [sym_raw_string] = ACTIONS(4745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4745),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4745),
    [anon_sym_BQUOTE] = ACTIONS(4745),
    [anon_sym_LT_LPAREN] = ACTIONS(4745),
    [anon_sym_GT_LPAREN] = ACTIONS(4745),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4745),
  },
  [2344] = {
    [sym__concat] = ACTIONS(4749),
    [anon_sym_RPAREN] = ACTIONS(4749),
    [sym__special_characters] = ACTIONS(4749),
    [anon_sym_DQUOTE] = ACTIONS(4749),
    [anon_sym_DOLLAR] = ACTIONS(4751),
    [sym_raw_string] = ACTIONS(4749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4749),
    [anon_sym_BQUOTE] = ACTIONS(4749),
    [anon_sym_LT_LPAREN] = ACTIONS(4749),
    [anon_sym_GT_LPAREN] = ACTIONS(4749),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4749),
  },
  [2345] = {
    [sym__concat] = ACTIONS(4753),
    [anon_sym_RPAREN] = ACTIONS(4753),
    [sym__special_characters] = ACTIONS(4753),
    [anon_sym_DQUOTE] = ACTIONS(4753),
    [anon_sym_DOLLAR] = ACTIONS(4755),
    [sym_raw_string] = ACTIONS(4753),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4753),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4753),
    [anon_sym_BQUOTE] = ACTIONS(4753),
    [anon_sym_LT_LPAREN] = ACTIONS(4753),
    [anon_sym_GT_LPAREN] = ACTIONS(4753),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4753),
  },
  [2346] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5756),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2347] = {
    [sym__concat] = ACTIONS(4759),
    [anon_sym_RPAREN] = ACTIONS(4759),
    [sym__special_characters] = ACTIONS(4759),
    [anon_sym_DQUOTE] = ACTIONS(4759),
    [anon_sym_DOLLAR] = ACTIONS(4761),
    [sym_raw_string] = ACTIONS(4759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4759),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4759),
    [anon_sym_BQUOTE] = ACTIONS(4759),
    [anon_sym_LT_LPAREN] = ACTIONS(4759),
    [anon_sym_GT_LPAREN] = ACTIONS(4759),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4759),
  },
  [2348] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2349] = {
    [sym__concat] = ACTIONS(4765),
    [anon_sym_RPAREN] = ACTIONS(4765),
    [sym__special_characters] = ACTIONS(4765),
    [anon_sym_DQUOTE] = ACTIONS(4765),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [sym_raw_string] = ACTIONS(4765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4765),
    [anon_sym_BQUOTE] = ACTIONS(4765),
    [anon_sym_LT_LPAREN] = ACTIONS(4765),
    [anon_sym_GT_LPAREN] = ACTIONS(4765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4765),
  },
  [2350] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5760),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2351] = {
    [sym__concat] = ACTIONS(4771),
    [anon_sym_RPAREN] = ACTIONS(4771),
    [sym__special_characters] = ACTIONS(4771),
    [anon_sym_DQUOTE] = ACTIONS(4771),
    [anon_sym_DOLLAR] = ACTIONS(4773),
    [sym_raw_string] = ACTIONS(4771),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4771),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4771),
    [anon_sym_BQUOTE] = ACTIONS(4771),
    [anon_sym_LT_LPAREN] = ACTIONS(4771),
    [anon_sym_GT_LPAREN] = ACTIONS(4771),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4771),
  },
  [2352] = {
    [sym__concat] = ACTIONS(4775),
    [anon_sym_RPAREN] = ACTIONS(4775),
    [sym__special_characters] = ACTIONS(4775),
    [anon_sym_DQUOTE] = ACTIONS(4775),
    [anon_sym_DOLLAR] = ACTIONS(4777),
    [sym_raw_string] = ACTIONS(4775),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4775),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4775),
    [anon_sym_BQUOTE] = ACTIONS(4775),
    [anon_sym_LT_LPAREN] = ACTIONS(4775),
    [anon_sym_GT_LPAREN] = ACTIONS(4775),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4775),
  },
  [2353] = {
    [sym_file_descriptor] = ACTIONS(5325),
    [sym__concat] = ACTIONS(5325),
    [sym_variable_name] = ACTIONS(5325),
    [anon_sym_esac] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_RPAREN] = ACTIONS(5327),
    [anon_sym_SEMI_SEMI] = ACTIONS(5327),
    [anon_sym_PIPE_AMP] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_GT_GT] = ACTIONS(5327),
    [anon_sym_AMP_GT] = ACTIONS(5327),
    [anon_sym_AMP_GT_GT] = ACTIONS(5327),
    [anon_sym_LT_AMP] = ACTIONS(5327),
    [anon_sym_GT_AMP] = ACTIONS(5327),
    [sym__special_characters] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [sym_raw_string] = ACTIONS(5327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5327),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5327),
    [anon_sym_BQUOTE] = ACTIONS(5327),
    [anon_sym_LT_LPAREN] = ACTIONS(5327),
    [anon_sym_GT_LPAREN] = ACTIONS(5327),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5327),
    [anon_sym_SEMI] = ACTIONS(5327),
    [anon_sym_LF] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
  },
  [2354] = {
    [sym_file_descriptor] = ACTIONS(5329),
    [sym__concat] = ACTIONS(5329),
    [sym_variable_name] = ACTIONS(5329),
    [anon_sym_esac] = ACTIONS(5331),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5331),
    [anon_sym_SEMI_SEMI] = ACTIONS(5331),
    [anon_sym_PIPE_AMP] = ACTIONS(5331),
    [anon_sym_AMP_AMP] = ACTIONS(5331),
    [anon_sym_PIPE_PIPE] = ACTIONS(5331),
    [anon_sym_LT] = ACTIONS(5331),
    [anon_sym_GT] = ACTIONS(5331),
    [anon_sym_GT_GT] = ACTIONS(5331),
    [anon_sym_AMP_GT] = ACTIONS(5331),
    [anon_sym_AMP_GT_GT] = ACTIONS(5331),
    [anon_sym_LT_AMP] = ACTIONS(5331),
    [anon_sym_GT_AMP] = ACTIONS(5331),
    [sym__special_characters] = ACTIONS(5331),
    [anon_sym_DQUOTE] = ACTIONS(5331),
    [anon_sym_DOLLAR] = ACTIONS(5331),
    [sym_raw_string] = ACTIONS(5331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5331),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5331),
    [anon_sym_BQUOTE] = ACTIONS(5331),
    [anon_sym_LT_LPAREN] = ACTIONS(5331),
    [anon_sym_GT_LPAREN] = ACTIONS(5331),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5331),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LF] = ACTIONS(5329),
    [anon_sym_AMP] = ACTIONS(5331),
  },
  [2355] = {
    [sym_file_descriptor] = ACTIONS(5333),
    [sym__concat] = ACTIONS(5333),
    [sym_variable_name] = ACTIONS(5333),
    [anon_sym_esac] = ACTIONS(5335),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_RPAREN] = ACTIONS(5335),
    [anon_sym_SEMI_SEMI] = ACTIONS(5335),
    [anon_sym_PIPE_AMP] = ACTIONS(5335),
    [anon_sym_AMP_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5335),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_GT] = ACTIONS(5335),
    [anon_sym_AMP_GT] = ACTIONS(5335),
    [anon_sym_AMP_GT_GT] = ACTIONS(5335),
    [anon_sym_LT_AMP] = ACTIONS(5335),
    [anon_sym_GT_AMP] = ACTIONS(5335),
    [sym__special_characters] = ACTIONS(5335),
    [anon_sym_DQUOTE] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5335),
    [sym_raw_string] = ACTIONS(5335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5335),
    [anon_sym_BQUOTE] = ACTIONS(5335),
    [anon_sym_LT_LPAREN] = ACTIONS(5335),
    [anon_sym_GT_LPAREN] = ACTIONS(5335),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5335),
    [anon_sym_SEMI] = ACTIONS(5335),
    [anon_sym_LF] = ACTIONS(5333),
    [anon_sym_AMP] = ACTIONS(5335),
  },
  [2356] = {
    [aux_sym_concatenation_repeat1] = STATE(2496),
    [sym_file_descriptor] = ACTIONS(1129),
    [sym__concat] = ACTIONS(1131),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_esac] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_AMP] = ACTIONS(1133),
    [anon_sym_GT_AMP] = ACTIONS(1133),
    [sym__special_characters] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1133),
  },
  [2357] = {
    [aux_sym_concatenation_repeat1] = STATE(2496),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(1131),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_esac] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_AMP] = ACTIONS(1109),
    [anon_sym_GT_AMP] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [2358] = {
    [sym_file_redirect] = STATE(2497),
    [sym_heredoc_redirect] = STATE(2497),
    [sym_heredoc_body] = STATE(594),
    [sym_herestring_redirect] = STATE(2497),
    [aux_sym_while_statement_repeat1] = STATE(2497),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5127),
    [anon_sym_esac] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1163),
    [anon_sym_SEMI_SEMI] = ACTIONS(1163),
    [anon_sym_PIPE_AMP] = ACTIONS(1163),
    [anon_sym_AMP_AMP] = ACTIONS(1163),
    [anon_sym_PIPE_PIPE] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5131),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT_GT] = ACTIONS(5131),
    [anon_sym_LT_AMP] = ACTIONS(5131),
    [anon_sym_GT_AMP] = ACTIONS(5131),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_LF] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1163),
  },
  [2359] = {
    [anon_sym_RPAREN] = ACTIONS(5762),
    [sym_comment] = ACTIONS(53),
  },
  [2360] = {
    [sym_file_redirect] = STATE(633),
    [sym_file_descriptor] = ACTIONS(5764),
    [anon_sym_esac] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1233),
    [anon_sym_SEMI_SEMI] = ACTIONS(1233),
    [anon_sym_PIPE_AMP] = ACTIONS(1233),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(5766),
    [anon_sym_GT] = ACTIONS(5766),
    [anon_sym_GT_GT] = ACTIONS(5766),
    [anon_sym_AMP_GT] = ACTIONS(5766),
    [anon_sym_AMP_GT_GT] = ACTIONS(5766),
    [anon_sym_LT_AMP] = ACTIONS(5766),
    [anon_sym_GT_AMP] = ACTIONS(5766),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_LF] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1233),
  },
  [2361] = {
    [sym_file_redirect] = STATE(2504),
    [sym_heredoc_redirect] = STATE(2504),
    [sym_herestring_redirect] = STATE(2504),
    [aux_sym_while_statement_repeat1] = STATE(2504),
    [sym_file_descriptor] = ACTIONS(5768),
    [anon_sym_esac] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_SEMI_SEMI] = ACTIONS(1341),
    [anon_sym_PIPE_AMP] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(5770),
    [anon_sym_GT] = ACTIONS(5770),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(1345),
    [anon_sym_LT_LT_DASH] = ACTIONS(1345),
    [anon_sym_LT_LT_LT] = ACTIONS(5772),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1341),
    [anon_sym_LF] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1341),
  },
  [2362] = {
    [sym_concatenation] = STATE(2505),
    [sym_string] = STATE(2508),
    [sym_array] = STATE(2505),
    [sym_simple_expansion] = STATE(2508),
    [sym_string_expansion] = STATE(2508),
    [sym_expansion] = STATE(2508),
    [sym_command_substitution] = STATE(2508),
    [sym_process_substitution] = STATE(2508),
    [sym__empty_value] = ACTIONS(5774),
    [anon_sym_LPAREN] = ACTIONS(5776),
    [sym__special_characters] = ACTIONS(5778),
    [anon_sym_DQUOTE] = ACTIONS(5523),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [sym_raw_string] = ACTIONS(5780),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5784),
    [anon_sym_BQUOTE] = ACTIONS(5786),
    [anon_sym_LT_LPAREN] = ACTIONS(5788),
    [anon_sym_GT_LPAREN] = ACTIONS(5788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5780),
  },
  [2363] = {
    [sym_string] = STATE(2509),
    [sym_simple_expansion] = STATE(2509),
    [sym_string_expansion] = STATE(2509),
    [sym_expansion] = STATE(2509),
    [sym_command_substitution] = STATE(2509),
    [sym_process_substitution] = STATE(2509),
    [sym__special_characters] = ACTIONS(5790),
    [anon_sym_DQUOTE] = ACTIONS(5523),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [sym_raw_string] = ACTIONS(5790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5784),
    [anon_sym_BQUOTE] = ACTIONS(5786),
    [anon_sym_LT_LPAREN] = ACTIONS(5788),
    [anon_sym_GT_LPAREN] = ACTIONS(5788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5790),
  },
  [2364] = {
    [aux_sym_concatenation_repeat1] = STATE(2510),
    [sym__concat] = ACTIONS(5519),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [2365] = {
    [sym__concat] = ACTIONS(697),
    [sym_variable_name] = ACTIONS(697),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(699),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [2366] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(5792),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2367] = {
    [sym__concat] = ACTIONS(727),
    [sym_variable_name] = ACTIONS(727),
    [anon_sym_esac] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(729),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [2368] = {
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [2369] = {
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [2370] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(5794),
    [sym_comment] = ACTIONS(53),
  },
  [2371] = {
    [sym_concatenation] = STATE(2515),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2515),
    [anon_sym_RBRACE] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5798),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5802),
    [anon_sym_COLON] = ACTIONS(5798),
    [anon_sym_COLON_QMARK] = ACTIONS(5798),
    [anon_sym_COLON_DASH] = ACTIONS(5798),
    [anon_sym_PERCENT] = ACTIONS(5798),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2372] = {
    [sym_subscript] = STATE(2519),
    [sym_variable_name] = ACTIONS(5804),
    [anon_sym_DOLLAR] = ACTIONS(5806),
    [anon_sym_DASH] = ACTIONS(5806),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5808),
    [anon_sym_STAR] = ACTIONS(5806),
    [anon_sym_AT] = ACTIONS(5806),
    [anon_sym_QMARK] = ACTIONS(5806),
    [anon_sym_0] = ACTIONS(5810),
    [anon_sym__] = ACTIONS(5810),
  },
  [2373] = {
    [sym_concatenation] = STATE(2522),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2522),
    [anon_sym_RBRACE] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5814),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5818),
    [anon_sym_COLON] = ACTIONS(5814),
    [anon_sym_COLON_QMARK] = ACTIONS(5814),
    [anon_sym_COLON_DASH] = ACTIONS(5814),
    [anon_sym_PERCENT] = ACTIONS(5814),
    [anon_sym_DASH] = ACTIONS(5814),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2374] = {
    [sym_concatenation] = STATE(2525),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2525),
    [anon_sym_RBRACE] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5822),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5826),
    [anon_sym_COLON] = ACTIONS(5822),
    [anon_sym_COLON_QMARK] = ACTIONS(5822),
    [anon_sym_COLON_DASH] = ACTIONS(5822),
    [anon_sym_PERCENT] = ACTIONS(5822),
    [anon_sym_DASH] = ACTIONS(5822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2375] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5828),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2376] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5828),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2377] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(5828),
    [sym_comment] = ACTIONS(53),
  },
  [2378] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(5828),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2379] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5830),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2380] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5830),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2381] = {
    [sym_variable_assignment] = STATE(2381),
    [sym_subscript] = STATE(2169),
    [sym_concatenation] = STATE(2381),
    [sym_string] = STATE(2163),
    [sym_simple_expansion] = STATE(2163),
    [sym_string_expansion] = STATE(2163),
    [sym_expansion] = STATE(2163),
    [sym_command_substitution] = STATE(2163),
    [sym_process_substitution] = STATE(2163),
    [aux_sym_declaration_command_repeat1] = STATE(2381),
    [sym_variable_name] = ACTIONS(5832),
    [anon_sym_esac] = ACTIONS(1488),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_SEMI_SEMI] = ACTIONS(1488),
    [anon_sym_PIPE_AMP] = ACTIONS(1488),
    [anon_sym_AMP_AMP] = ACTIONS(1488),
    [anon_sym_PIPE_PIPE] = ACTIONS(1488),
    [sym__special_characters] = ACTIONS(5835),
    [anon_sym_DQUOTE] = ACTIONS(5838),
    [anon_sym_DOLLAR] = ACTIONS(5841),
    [sym_raw_string] = ACTIONS(5844),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5850),
    [anon_sym_BQUOTE] = ACTIONS(5853),
    [anon_sym_LT_LPAREN] = ACTIONS(5856),
    [anon_sym_GT_LPAREN] = ACTIONS(5856),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5859),
    [sym_word] = ACTIONS(5844),
    [anon_sym_SEMI] = ACTIONS(1488),
    [anon_sym_LF] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1488),
  },
  [2382] = {
    [sym_string] = STATE(2528),
    [sym_simple_expansion] = STATE(2528),
    [sym_string_expansion] = STATE(2528),
    [sym_expansion] = STATE(2528),
    [sym_command_substitution] = STATE(2528),
    [sym_process_substitution] = STATE(2528),
    [sym__special_characters] = ACTIONS(5862),
    [anon_sym_DQUOTE] = ACTIONS(5547),
    [anon_sym_DOLLAR] = ACTIONS(5105),
    [sym_raw_string] = ACTIONS(5862),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5864),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5866),
    [anon_sym_BQUOTE] = ACTIONS(5868),
    [anon_sym_LT_LPAREN] = ACTIONS(5870),
    [anon_sym_GT_LPAREN] = ACTIONS(5870),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5862),
  },
  [2383] = {
    [aux_sym_concatenation_repeat1] = STATE(2529),
    [sym__concat] = ACTIONS(5543),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [2384] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(699),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [2385] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(5872),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2386] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_esac] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(729),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [2387] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [2388] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [2389] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(5874),
    [sym_comment] = ACTIONS(53),
  },
  [2390] = {
    [sym_concatenation] = STATE(2534),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2534),
    [anon_sym_RBRACE] = ACTIONS(5876),
    [anon_sym_EQ] = ACTIONS(5878),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5882),
    [anon_sym_COLON] = ACTIONS(5878),
    [anon_sym_COLON_QMARK] = ACTIONS(5878),
    [anon_sym_COLON_DASH] = ACTIONS(5878),
    [anon_sym_PERCENT] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2391] = {
    [sym_subscript] = STATE(2538),
    [sym_variable_name] = ACTIONS(5884),
    [anon_sym_DOLLAR] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5886),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5888),
    [anon_sym_STAR] = ACTIONS(5886),
    [anon_sym_AT] = ACTIONS(5886),
    [anon_sym_QMARK] = ACTIONS(5886),
    [anon_sym_0] = ACTIONS(5890),
    [anon_sym__] = ACTIONS(5890),
  },
  [2392] = {
    [sym_concatenation] = STATE(2541),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2541),
    [anon_sym_RBRACE] = ACTIONS(5892),
    [anon_sym_EQ] = ACTIONS(5894),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5898),
    [anon_sym_COLON] = ACTIONS(5894),
    [anon_sym_COLON_QMARK] = ACTIONS(5894),
    [anon_sym_COLON_DASH] = ACTIONS(5894),
    [anon_sym_PERCENT] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2393] = {
    [sym_concatenation] = STATE(2544),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2544),
    [anon_sym_RBRACE] = ACTIONS(5900),
    [anon_sym_EQ] = ACTIONS(5902),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5906),
    [anon_sym_COLON] = ACTIONS(5902),
    [anon_sym_COLON_QMARK] = ACTIONS(5902),
    [anon_sym_COLON_DASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2394] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5908),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2395] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5908),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2396] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(5908),
    [sym_comment] = ACTIONS(53),
  },
  [2397] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(5908),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2398] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5910),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2399] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5910),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2400] = {
    [sym_concatenation] = STATE(2400),
    [sym_string] = STATE(2174),
    [sym_simple_expansion] = STATE(2174),
    [sym_string_expansion] = STATE(2174),
    [sym_expansion] = STATE(2174),
    [sym_command_substitution] = STATE(2174),
    [sym_process_substitution] = STATE(2174),
    [aux_sym_unset_command_repeat1] = STATE(2400),
    [anon_sym_esac] = ACTIONS(1569),
    [anon_sym_PIPE] = ACTIONS(1569),
    [anon_sym_SEMI_SEMI] = ACTIONS(1569),
    [anon_sym_PIPE_AMP] = ACTIONS(1569),
    [anon_sym_AMP_AMP] = ACTIONS(1569),
    [anon_sym_PIPE_PIPE] = ACTIONS(1569),
    [sym__special_characters] = ACTIONS(5912),
    [anon_sym_DQUOTE] = ACTIONS(5915),
    [anon_sym_DOLLAR] = ACTIONS(5918),
    [sym_raw_string] = ACTIONS(5921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5927),
    [anon_sym_BQUOTE] = ACTIONS(5930),
    [anon_sym_LT_LPAREN] = ACTIONS(5933),
    [anon_sym_GT_LPAREN] = ACTIONS(5933),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5936),
    [sym_word] = ACTIONS(5921),
    [anon_sym_SEMI] = ACTIONS(1569),
    [anon_sym_LF] = ACTIONS(1598),
    [anon_sym_AMP] = ACTIONS(1569),
  },
  [2401] = {
    [aux_sym_concatenation_repeat1] = STATE(2401),
    [sym__simple_heredoc_body] = ACTIONS(1642),
    [sym__heredoc_body_beginning] = ACTIONS(1642),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1646),
    [anon_sym_esac] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_EQ_TILDE] = ACTIONS(1644),
    [anon_sym_EQ_EQ] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [2402] = {
    [sym_compound_statement] = STATE(2547),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [2403] = {
    [anon_sym_esac] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE_AMP] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(2014),
    [anon_sym_PIPE_PIPE] = ACTIONS(2014),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_LF] = ACTIONS(2016),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [2404] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI_SEMI] = ACTIONS(2014),
    [anon_sym_PIPE_AMP] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(2014),
    [anon_sym_PIPE_PIPE] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_LF] = ACTIONS(2016),
    [anon_sym_AMP] = ACTIONS(2014),
  },
  [2405] = {
    [sym_concatenation] = STATE(981),
    [sym_string] = STATE(2549),
    [sym_simple_expansion] = STATE(2549),
    [sym_string_expansion] = STATE(2549),
    [sym_expansion] = STATE(2549),
    [sym_command_substitution] = STATE(2549),
    [sym_process_substitution] = STATE(2549),
    [sym__special_characters] = ACTIONS(5939),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(5941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5941),
  },
  [2406] = {
    [aux_sym_concatenation_repeat1] = STATE(2181),
    [sym__simple_heredoc_body] = ACTIONS(2046),
    [sym__heredoc_body_beginning] = ACTIONS(2046),
    [sym_file_descriptor] = ACTIONS(2046),
    [sym__concat] = ACTIONS(223),
    [anon_sym_esac] = ACTIONS(2048),
    [anon_sym_PIPE] = ACTIONS(2048),
    [anon_sym_SEMI_SEMI] = ACTIONS(2048),
    [anon_sym_PIPE_AMP] = ACTIONS(2048),
    [anon_sym_AMP_AMP] = ACTIONS(2048),
    [anon_sym_PIPE_PIPE] = ACTIONS(2048),
    [anon_sym_EQ_TILDE] = ACTIONS(2048),
    [anon_sym_EQ_EQ] = ACTIONS(2048),
    [anon_sym_LT] = ACTIONS(2048),
    [anon_sym_GT] = ACTIONS(2048),
    [anon_sym_GT_GT] = ACTIONS(2048),
    [anon_sym_AMP_GT] = ACTIONS(2048),
    [anon_sym_AMP_GT_GT] = ACTIONS(2048),
    [anon_sym_LT_AMP] = ACTIONS(2048),
    [anon_sym_GT_AMP] = ACTIONS(2048),
    [anon_sym_LT_LT] = ACTIONS(2048),
    [anon_sym_LT_LT_DASH] = ACTIONS(2048),
    [anon_sym_LT_LT_LT] = ACTIONS(2048),
    [sym__special_characters] = ACTIONS(2048),
    [anon_sym_DQUOTE] = ACTIONS(2048),
    [anon_sym_DOLLAR] = ACTIONS(2048),
    [sym_raw_string] = ACTIONS(2048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2048),
    [anon_sym_BQUOTE] = ACTIONS(2048),
    [anon_sym_LT_LPAREN] = ACTIONS(2048),
    [anon_sym_GT_LPAREN] = ACTIONS(2048),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2048),
    [anon_sym_SEMI] = ACTIONS(2048),
    [anon_sym_LF] = ACTIONS(2046),
    [anon_sym_AMP] = ACTIONS(2048),
  },
  [2407] = {
    [aux_sym_concatenation_repeat1] = STATE(2181),
    [sym__simple_heredoc_body] = ACTIONS(2050),
    [sym__heredoc_body_beginning] = ACTIONS(2050),
    [sym_file_descriptor] = ACTIONS(2050),
    [sym__concat] = ACTIONS(223),
    [anon_sym_esac] = ACTIONS(2052),
    [anon_sym_PIPE] = ACTIONS(2052),
    [anon_sym_SEMI_SEMI] = ACTIONS(2052),
    [anon_sym_PIPE_AMP] = ACTIONS(2052),
    [anon_sym_AMP_AMP] = ACTIONS(2052),
    [anon_sym_PIPE_PIPE] = ACTIONS(2052),
    [anon_sym_EQ_TILDE] = ACTIONS(2052),
    [anon_sym_EQ_EQ] = ACTIONS(2052),
    [anon_sym_LT] = ACTIONS(2052),
    [anon_sym_GT] = ACTIONS(2052),
    [anon_sym_GT_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT_GT] = ACTIONS(2052),
    [anon_sym_LT_AMP] = ACTIONS(2052),
    [anon_sym_GT_AMP] = ACTIONS(2052),
    [anon_sym_LT_LT] = ACTIONS(2052),
    [anon_sym_LT_LT_DASH] = ACTIONS(2052),
    [anon_sym_LT_LT_LT] = ACTIONS(2052),
    [sym__special_characters] = ACTIONS(2052),
    [anon_sym_DQUOTE] = ACTIONS(2052),
    [anon_sym_DOLLAR] = ACTIONS(2052),
    [sym_raw_string] = ACTIONS(2052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2052),
    [anon_sym_BQUOTE] = ACTIONS(2052),
    [anon_sym_LT_LPAREN] = ACTIONS(2052),
    [anon_sym_GT_LPAREN] = ACTIONS(2052),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2052),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym_LF] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2052),
  },
  [2408] = {
    [aux_sym_concatenation_repeat1] = STATE(2550),
    [sym__simple_heredoc_body] = ACTIONS(661),
    [sym__heredoc_body_beginning] = ACTIONS(661),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(223),
    [anon_sym_esac] = ACTIONS(665),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(665),
    [anon_sym_LT_LT_LT] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [2409] = {
    [aux_sym_concatenation_repeat1] = STATE(2550),
    [sym__simple_heredoc_body] = ACTIONS(677),
    [sym__heredoc_body_beginning] = ACTIONS(677),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(223),
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [2410] = {
    [aux_sym_concatenation_repeat1] = STATE(2550),
    [sym__simple_heredoc_body] = ACTIONS(2058),
    [sym__heredoc_body_beginning] = ACTIONS(2058),
    [sym_file_descriptor] = ACTIONS(2058),
    [sym__concat] = ACTIONS(223),
    [anon_sym_esac] = ACTIONS(2060),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_SEMI_SEMI] = ACTIONS(2060),
    [anon_sym_PIPE_AMP] = ACTIONS(2060),
    [anon_sym_AMP_AMP] = ACTIONS(2060),
    [anon_sym_PIPE_PIPE] = ACTIONS(2060),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2060),
    [anon_sym_LT_AMP] = ACTIONS(2060),
    [anon_sym_GT_AMP] = ACTIONS(2060),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2060),
    [anon_sym_LT_LT_LT] = ACTIONS(2060),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2060),
  },
  [2411] = {
    [aux_sym_concatenation_repeat1] = STATE(2550),
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [sym__concat] = ACTIONS(223),
    [anon_sym_esac] = ACTIONS(2064),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [2412] = {
    [sym_file_redirect] = STATE(2412),
    [sym_heredoc_redirect] = STATE(2412),
    [sym_herestring_redirect] = STATE(2412),
    [aux_sym_while_statement_repeat1] = STATE(2412),
    [sym__simple_heredoc_body] = ACTIONS(2070),
    [sym__heredoc_body_beginning] = ACTIONS(2070),
    [sym_file_descriptor] = ACTIONS(5943),
    [anon_sym_esac] = ACTIONS(2075),
    [anon_sym_PIPE] = ACTIONS(2075),
    [anon_sym_SEMI_SEMI] = ACTIONS(2075),
    [anon_sym_PIPE_AMP] = ACTIONS(2075),
    [anon_sym_AMP_AMP] = ACTIONS(2075),
    [anon_sym_PIPE_PIPE] = ACTIONS(2075),
    [anon_sym_LT] = ACTIONS(5946),
    [anon_sym_GT] = ACTIONS(5946),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_AMP_GT] = ACTIONS(5946),
    [anon_sym_AMP_GT_GT] = ACTIONS(5946),
    [anon_sym_LT_AMP] = ACTIONS(5946),
    [anon_sym_GT_AMP] = ACTIONS(5946),
    [anon_sym_LT_LT] = ACTIONS(2080),
    [anon_sym_LT_LT_DASH] = ACTIONS(2080),
    [anon_sym_LT_LT_LT] = ACTIONS(5949),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_LF] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2075),
  },
  [2413] = {
    [sym_file_redirect] = STATE(2412),
    [sym_heredoc_redirect] = STATE(2412),
    [sym_heredoc_body] = STATE(983),
    [sym_herestring_redirect] = STATE(2412),
    [aux_sym_while_statement_repeat1] = STATE(2412),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5127),
    [anon_sym_esac] = ACTIONS(2066),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_SEMI_SEMI] = ACTIONS(2066),
    [anon_sym_PIPE_AMP] = ACTIONS(2066),
    [anon_sym_AMP_AMP] = ACTIONS(2066),
    [anon_sym_PIPE_PIPE] = ACTIONS(2066),
    [anon_sym_LT] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5131),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT_GT] = ACTIONS(5131),
    [anon_sym_LT_AMP] = ACTIONS(5131),
    [anon_sym_GT_AMP] = ACTIONS(5131),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym_LF] = ACTIONS(2068),
    [anon_sym_AMP] = ACTIONS(2066),
  },
  [2414] = {
    [sym_concatenation] = STATE(2414),
    [sym_string] = STATE(2191),
    [sym_simple_expansion] = STATE(2191),
    [sym_string_expansion] = STATE(2191),
    [sym_expansion] = STATE(2191),
    [sym_command_substitution] = STATE(2191),
    [sym_process_substitution] = STATE(2191),
    [aux_sym_command_repeat2] = STATE(2414),
    [sym__simple_heredoc_body] = ACTIONS(2050),
    [sym__heredoc_body_beginning] = ACTIONS(2050),
    [sym_file_descriptor] = ACTIONS(2050),
    [anon_sym_esac] = ACTIONS(2052),
    [anon_sym_PIPE] = ACTIONS(2052),
    [anon_sym_SEMI_SEMI] = ACTIONS(2052),
    [anon_sym_PIPE_AMP] = ACTIONS(2052),
    [anon_sym_AMP_AMP] = ACTIONS(2052),
    [anon_sym_PIPE_PIPE] = ACTIONS(2052),
    [anon_sym_EQ_TILDE] = ACTIONS(5952),
    [anon_sym_EQ_EQ] = ACTIONS(5952),
    [anon_sym_LT] = ACTIONS(2052),
    [anon_sym_GT] = ACTIONS(2052),
    [anon_sym_GT_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT] = ACTIONS(2052),
    [anon_sym_AMP_GT_GT] = ACTIONS(2052),
    [anon_sym_LT_AMP] = ACTIONS(2052),
    [anon_sym_GT_AMP] = ACTIONS(2052),
    [anon_sym_LT_LT] = ACTIONS(2052),
    [anon_sym_LT_LT_DASH] = ACTIONS(2052),
    [anon_sym_LT_LT_LT] = ACTIONS(2052),
    [sym__special_characters] = ACTIONS(5955),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [anon_sym_DOLLAR] = ACTIONS(2095),
    [sym_raw_string] = ACTIONS(5958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2104),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [anon_sym_LT_LPAREN] = ACTIONS(2110),
    [anon_sym_GT_LPAREN] = ACTIONS(2110),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5958),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym_LF] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2052),
  },
  [2415] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_esac] = ACTIONS(5961),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(5963),
    [anon_sym_DQUOTE] = ACTIONS(5965),
    [anon_sym_DOLLAR] = ACTIONS(5963),
    [sym_raw_string] = ACTIONS(5965),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5965),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5965),
    [anon_sym_BQUOTE] = ACTIONS(5965),
    [anon_sym_LT_LPAREN] = ACTIONS(5965),
    [anon_sym_GT_LPAREN] = ACTIONS(5965),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5963),
  },
  [2416] = {
    [sym_file_redirect] = STATE(2551),
    [sym_heredoc_redirect] = STATE(2551),
    [sym_heredoc_body] = STATE(983),
    [sym_herestring_redirect] = STATE(2551),
    [sym_concatenation] = STATE(2414),
    [sym_string] = STATE(2191),
    [sym_simple_expansion] = STATE(2191),
    [sym_string_expansion] = STATE(2191),
    [sym_expansion] = STATE(2191),
    [sym_command_substitution] = STATE(2191),
    [sym_process_substitution] = STATE(2191),
    [aux_sym_while_statement_repeat1] = STATE(2551),
    [aux_sym_command_repeat2] = STATE(2414),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5127),
    [anon_sym_esac] = ACTIONS(2066),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_SEMI_SEMI] = ACTIONS(2066),
    [anon_sym_PIPE_AMP] = ACTIONS(2066),
    [anon_sym_AMP_AMP] = ACTIONS(2066),
    [anon_sym_PIPE_PIPE] = ACTIONS(2066),
    [anon_sym_EQ_TILDE] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5131),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT_GT] = ACTIONS(5131),
    [anon_sym_LT_AMP] = ACTIONS(5131),
    [anon_sym_GT_AMP] = ACTIONS(5131),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [sym__special_characters] = ACTIONS(5135),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(5137),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5137),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym_LF] = ACTIONS(2068),
    [anon_sym_AMP] = ACTIONS(2066),
  },
  [2417] = {
    [anon_sym_esac] = ACTIONS(5961),
    [sym__special_characters] = ACTIONS(5965),
    [anon_sym_DQUOTE] = ACTIONS(5965),
    [anon_sym_DOLLAR] = ACTIONS(5963),
    [sym_raw_string] = ACTIONS(5965),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5965),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5965),
    [anon_sym_BQUOTE] = ACTIONS(5965),
    [anon_sym_LT_LPAREN] = ACTIONS(5965),
    [anon_sym_GT_LPAREN] = ACTIONS(5965),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5963),
  },
  [2418] = {
    [anon_sym_esac] = ACTIONS(5961),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI_SEMI] = ACTIONS(5967),
    [anon_sym_PIPE_AMP] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2419] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(5961),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI_SEMI] = ACTIONS(5967),
    [anon_sym_PIPE_AMP] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2420] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_esac] = ACTIONS(5969),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(5971),
    [anon_sym_DQUOTE] = ACTIONS(5973),
    [anon_sym_DOLLAR] = ACTIONS(5971),
    [sym_raw_string] = ACTIONS(5973),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5973),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5973),
    [anon_sym_BQUOTE] = ACTIONS(5973),
    [anon_sym_LT_LPAREN] = ACTIONS(5973),
    [anon_sym_GT_LPAREN] = ACTIONS(5973),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5971),
  },
  [2421] = {
    [anon_sym_esac] = ACTIONS(5969),
    [sym__special_characters] = ACTIONS(5973),
    [anon_sym_DQUOTE] = ACTIONS(5973),
    [anon_sym_DOLLAR] = ACTIONS(5971),
    [sym_raw_string] = ACTIONS(5973),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5973),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5973),
    [anon_sym_BQUOTE] = ACTIONS(5973),
    [anon_sym_LT_LPAREN] = ACTIONS(5973),
    [anon_sym_GT_LPAREN] = ACTIONS(5973),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5971),
  },
  [2422] = {
    [anon_sym_esac] = ACTIONS(5969),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI_SEMI] = ACTIONS(5975),
    [anon_sym_PIPE_AMP] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2423] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(5969),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_SEMI_SEMI] = ACTIONS(5975),
    [anon_sym_PIPE_AMP] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2424] = {
    [sym__special_characters] = ACTIONS(5075),
    [anon_sym_DQUOTE] = ACTIONS(5075),
    [anon_sym_DOLLAR] = ACTIONS(5077),
    [sym_raw_string] = ACTIONS(5075),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5075),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5075),
    [anon_sym_BQUOTE] = ACTIONS(5075),
    [anon_sym_LT_LPAREN] = ACTIONS(5075),
    [anon_sym_GT_LPAREN] = ACTIONS(5075),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5075),
  },
  [2425] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(5977),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2426] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(5977),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2427] = {
    [sym__terminated_statement] = STATE(2558),
    [sym_for_statement] = STATE(2556),
    [sym_while_statement] = STATE(2556),
    [sym_if_statement] = STATE(2556),
    [sym_case_statement] = STATE(2556),
    [sym_function_definition] = STATE(2556),
    [sym_subshell] = STATE(2556),
    [sym_pipeline] = STATE(2556),
    [sym_list] = STATE(2556),
    [sym_negated_command] = STATE(2556),
    [sym_test_command] = STATE(2556),
    [sym_declaration_command] = STATE(2556),
    [sym_unset_command] = STATE(2556),
    [sym_command] = STATE(2556),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2557),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2558),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5979),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2428] = {
    [sym__terminated_statement] = STATE(2559),
    [sym_for_statement] = STATE(2556),
    [sym_while_statement] = STATE(2556),
    [sym_if_statement] = STATE(2556),
    [sym_case_statement] = STATE(2556),
    [sym_function_definition] = STATE(2556),
    [sym_subshell] = STATE(2556),
    [sym_pipeline] = STATE(2556),
    [sym_list] = STATE(2556),
    [sym_negated_command] = STATE(2556),
    [sym_test_command] = STATE(2556),
    [sym_declaration_command] = STATE(2556),
    [sym_unset_command] = STATE(2556),
    [sym_command] = STATE(2556),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2557),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2559),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5979),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2429] = {
    [sym__special_characters] = ACTIONS(5148),
    [anon_sym_DQUOTE] = ACTIONS(5148),
    [anon_sym_DOLLAR] = ACTIONS(5150),
    [sym_raw_string] = ACTIONS(5148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5148),
    [anon_sym_BQUOTE] = ACTIONS(5148),
    [anon_sym_LT_LPAREN] = ACTIONS(5148),
    [anon_sym_GT_LPAREN] = ACTIONS(5148),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5148),
  },
  [2430] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(5981),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2431] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(5981),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2432] = {
    [sym__terminated_statement] = STATE(2558),
    [sym_for_statement] = STATE(2562),
    [sym_while_statement] = STATE(2562),
    [sym_if_statement] = STATE(2562),
    [sym_case_statement] = STATE(2562),
    [sym_function_definition] = STATE(2562),
    [sym_subshell] = STATE(2562),
    [sym_pipeline] = STATE(2562),
    [sym_list] = STATE(2562),
    [sym_negated_command] = STATE(2562),
    [sym_test_command] = STATE(2562),
    [sym_declaration_command] = STATE(2562),
    [sym_unset_command] = STATE(2562),
    [sym_command] = STATE(2562),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2563),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2558),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5983),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2433] = {
    [sym__terminated_statement] = STATE(2564),
    [sym_for_statement] = STATE(2562),
    [sym_while_statement] = STATE(2562),
    [sym_if_statement] = STATE(2562),
    [sym_case_statement] = STATE(2562),
    [sym_function_definition] = STATE(2562),
    [sym_subshell] = STATE(2562),
    [sym_pipeline] = STATE(2562),
    [sym_list] = STATE(2562),
    [sym_negated_command] = STATE(2562),
    [sym_test_command] = STATE(2562),
    [sym_declaration_command] = STATE(2562),
    [sym_unset_command] = STATE(2562),
    [sym_command] = STATE(2562),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2563),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2564),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5983),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2434] = {
    [sym_file_descriptor] = ACTIONS(3829),
    [sym__concat] = ACTIONS(3829),
    [anon_sym_esac] = ACTIONS(3831),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_RPAREN] = ACTIONS(3831),
    [anon_sym_SEMI_SEMI] = ACTIONS(3831),
    [anon_sym_PIPE_AMP] = ACTIONS(3831),
    [anon_sym_AMP_AMP] = ACTIONS(3831),
    [anon_sym_PIPE_PIPE] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_GT] = ACTIONS(3831),
    [anon_sym_GT_GT] = ACTIONS(3831),
    [anon_sym_AMP_GT] = ACTIONS(3831),
    [anon_sym_AMP_GT_GT] = ACTIONS(3831),
    [anon_sym_LT_AMP] = ACTIONS(3831),
    [anon_sym_GT_AMP] = ACTIONS(3831),
    [anon_sym_LT_LT] = ACTIONS(3831),
    [anon_sym_LT_LT_DASH] = ACTIONS(3831),
    [anon_sym_LT_LT_LT] = ACTIONS(3831),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_LF] = ACTIONS(3829),
    [anon_sym_AMP] = ACTIONS(3831),
  },
  [2435] = {
    [sym_file_descriptor] = ACTIONS(3835),
    [sym__concat] = ACTIONS(3835),
    [anon_sym_esac] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3837),
    [anon_sym_RPAREN] = ACTIONS(3837),
    [anon_sym_SEMI_SEMI] = ACTIONS(3837),
    [anon_sym_PIPE_AMP] = ACTIONS(3837),
    [anon_sym_AMP_AMP] = ACTIONS(3837),
    [anon_sym_PIPE_PIPE] = ACTIONS(3837),
    [anon_sym_LT] = ACTIONS(3837),
    [anon_sym_GT] = ACTIONS(3837),
    [anon_sym_GT_GT] = ACTIONS(3837),
    [anon_sym_AMP_GT] = ACTIONS(3837),
    [anon_sym_AMP_GT_GT] = ACTIONS(3837),
    [anon_sym_LT_AMP] = ACTIONS(3837),
    [anon_sym_GT_AMP] = ACTIONS(3837),
    [anon_sym_LT_LT] = ACTIONS(3837),
    [anon_sym_LT_LT_DASH] = ACTIONS(3837),
    [anon_sym_LT_LT_LT] = ACTIONS(3837),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3837),
    [anon_sym_LF] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
  },
  [2436] = {
    [sym_file_descriptor] = ACTIONS(3920),
    [sym__concat] = ACTIONS(3920),
    [anon_sym_esac] = ACTIONS(3922),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_RPAREN] = ACTIONS(3922),
    [anon_sym_SEMI_SEMI] = ACTIONS(3922),
    [anon_sym_PIPE_AMP] = ACTIONS(3922),
    [anon_sym_AMP_AMP] = ACTIONS(3922),
    [anon_sym_PIPE_PIPE] = ACTIONS(3922),
    [anon_sym_LT] = ACTIONS(3922),
    [anon_sym_GT] = ACTIONS(3922),
    [anon_sym_GT_GT] = ACTIONS(3922),
    [anon_sym_AMP_GT] = ACTIONS(3922),
    [anon_sym_AMP_GT_GT] = ACTIONS(3922),
    [anon_sym_LT_AMP] = ACTIONS(3922),
    [anon_sym_GT_AMP] = ACTIONS(3922),
    [anon_sym_LT_LT] = ACTIONS(3922),
    [anon_sym_LT_LT_DASH] = ACTIONS(3922),
    [anon_sym_LT_LT_LT] = ACTIONS(3922),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3922),
    [anon_sym_LF] = ACTIONS(3920),
    [anon_sym_AMP] = ACTIONS(3922),
  },
  [2437] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(5985),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2438] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5987),
    [sym_comment] = ACTIONS(53),
  },
  [2439] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(5989),
    [sym_comment] = ACTIONS(53),
  },
  [2440] = {
    [anon_sym_RBRACE] = ACTIONS(5989),
    [sym_comment] = ACTIONS(53),
  },
  [2441] = {
    [sym_concatenation] = STATE(2569),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2569),
    [anon_sym_RBRACE] = ACTIONS(5991),
    [anon_sym_EQ] = ACTIONS(5993),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5993),
    [anon_sym_COLON_QMARK] = ACTIONS(5993),
    [anon_sym_COLON_DASH] = ACTIONS(5993),
    [anon_sym_PERCENT] = ACTIONS(5993),
    [anon_sym_DASH] = ACTIONS(5993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2442] = {
    [sym_file_descriptor] = ACTIONS(3936),
    [sym__concat] = ACTIONS(3936),
    [anon_sym_esac] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3938),
    [anon_sym_RPAREN] = ACTIONS(3938),
    [anon_sym_SEMI_SEMI] = ACTIONS(3938),
    [anon_sym_PIPE_AMP] = ACTIONS(3938),
    [anon_sym_AMP_AMP] = ACTIONS(3938),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [anon_sym_LT] = ACTIONS(3938),
    [anon_sym_GT] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3938),
    [anon_sym_AMP_GT] = ACTIONS(3938),
    [anon_sym_AMP_GT_GT] = ACTIONS(3938),
    [anon_sym_LT_AMP] = ACTIONS(3938),
    [anon_sym_GT_AMP] = ACTIONS(3938),
    [anon_sym_LT_LT] = ACTIONS(3938),
    [anon_sym_LT_LT_DASH] = ACTIONS(3938),
    [anon_sym_LT_LT_LT] = ACTIONS(3938),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_LF] = ACTIONS(3936),
    [anon_sym_AMP] = ACTIONS(3938),
  },
  [2443] = {
    [sym_concatenation] = STATE(2571),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2571),
    [anon_sym_RBRACE] = ACTIONS(5997),
    [anon_sym_EQ] = ACTIONS(5999),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6001),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5999),
    [anon_sym_COLON_QMARK] = ACTIONS(5999),
    [anon_sym_COLON_DASH] = ACTIONS(5999),
    [anon_sym_PERCENT] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(5999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2444] = {
    [sym_file_descriptor] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3946),
    [anon_sym_esac] = ACTIONS(3948),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3948),
    [anon_sym_SEMI_SEMI] = ACTIONS(3948),
    [anon_sym_PIPE_AMP] = ACTIONS(3948),
    [anon_sym_AMP_AMP] = ACTIONS(3948),
    [anon_sym_PIPE_PIPE] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3948),
    [anon_sym_GT_GT] = ACTIONS(3948),
    [anon_sym_AMP_GT] = ACTIONS(3948),
    [anon_sym_AMP_GT_GT] = ACTIONS(3948),
    [anon_sym_LT_AMP] = ACTIONS(3948),
    [anon_sym_GT_AMP] = ACTIONS(3948),
    [anon_sym_LT_LT] = ACTIONS(3948),
    [anon_sym_LT_LT_DASH] = ACTIONS(3948),
    [anon_sym_LT_LT_LT] = ACTIONS(3948),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3948),
    [anon_sym_LF] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3948),
  },
  [2445] = {
    [sym_concatenation] = STATE(2573),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2573),
    [anon_sym_RBRACE] = ACTIONS(6003),
    [anon_sym_EQ] = ACTIONS(6005),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6007),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6005),
    [anon_sym_COLON_QMARK] = ACTIONS(6005),
    [anon_sym_COLON_DASH] = ACTIONS(6005),
    [anon_sym_PERCENT] = ACTIONS(6005),
    [anon_sym_DASH] = ACTIONS(6005),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2446] = {
    [sym_file_descriptor] = ACTIONS(3956),
    [sym__concat] = ACTIONS(3956),
    [anon_sym_esac] = ACTIONS(3958),
    [anon_sym_PIPE] = ACTIONS(3958),
    [anon_sym_RPAREN] = ACTIONS(3958),
    [anon_sym_SEMI_SEMI] = ACTIONS(3958),
    [anon_sym_PIPE_AMP] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_GT] = ACTIONS(3958),
    [anon_sym_AMP_GT] = ACTIONS(3958),
    [anon_sym_AMP_GT_GT] = ACTIONS(3958),
    [anon_sym_LT_AMP] = ACTIONS(3958),
    [anon_sym_GT_AMP] = ACTIONS(3958),
    [anon_sym_LT_LT] = ACTIONS(3958),
    [anon_sym_LT_LT_DASH] = ACTIONS(3958),
    [anon_sym_LT_LT_LT] = ACTIONS(3958),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_LF] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
  },
  [2447] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6009),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2448] = {
    [sym_file_descriptor] = ACTIONS(3962),
    [sym__concat] = ACTIONS(3962),
    [anon_sym_esac] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_RPAREN] = ACTIONS(3964),
    [anon_sym_SEMI_SEMI] = ACTIONS(3964),
    [anon_sym_PIPE_AMP] = ACTIONS(3964),
    [anon_sym_AMP_AMP] = ACTIONS(3964),
    [anon_sym_PIPE_PIPE] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_GT] = ACTIONS(3964),
    [anon_sym_GT_GT] = ACTIONS(3964),
    [anon_sym_AMP_GT] = ACTIONS(3964),
    [anon_sym_AMP_GT_GT] = ACTIONS(3964),
    [anon_sym_LT_AMP] = ACTIONS(3964),
    [anon_sym_GT_AMP] = ACTIONS(3964),
    [anon_sym_LT_LT] = ACTIONS(3964),
    [anon_sym_LT_LT_DASH] = ACTIONS(3964),
    [anon_sym_LT_LT_LT] = ACTIONS(3964),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3964),
    [anon_sym_LF] = ACTIONS(3962),
    [anon_sym_AMP] = ACTIONS(3964),
  },
  [2449] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6011),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2450] = {
    [sym__concat] = ACTIONS(4741),
    [anon_sym_RBRACE] = ACTIONS(4741),
    [sym_comment] = ACTIONS(53),
  },
  [2451] = {
    [sym__concat] = ACTIONS(4745),
    [anon_sym_RBRACE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(53),
  },
  [2452] = {
    [sym__concat] = ACTIONS(4749),
    [anon_sym_RBRACE] = ACTIONS(4749),
    [sym_comment] = ACTIONS(53),
  },
  [2453] = {
    [sym__concat] = ACTIONS(4753),
    [anon_sym_RBRACE] = ACTIONS(4753),
    [sym_comment] = ACTIONS(53),
  },
  [2454] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6013),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2455] = {
    [sym__concat] = ACTIONS(4759),
    [anon_sym_RBRACE] = ACTIONS(4759),
    [sym_comment] = ACTIONS(53),
  },
  [2456] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6015),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2457] = {
    [sym__concat] = ACTIONS(4765),
    [anon_sym_RBRACE] = ACTIONS(4765),
    [sym_comment] = ACTIONS(53),
  },
  [2458] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6017),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2459] = {
    [sym__concat] = ACTIONS(4771),
    [anon_sym_RBRACE] = ACTIONS(4771),
    [sym_comment] = ACTIONS(53),
  },
  [2460] = {
    [sym__concat] = ACTIONS(4775),
    [anon_sym_RBRACE] = ACTIONS(4775),
    [sym_comment] = ACTIONS(53),
  },
  [2461] = {
    [sym__concat] = ACTIONS(5325),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5327),
    [sym__special_characters] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [sym_raw_string] = ACTIONS(5325),
    [anon_sym_POUND] = ACTIONS(5325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5325),
    [anon_sym_COLON] = ACTIONS(5327),
    [anon_sym_COLON_QMARK] = ACTIONS(5327),
    [anon_sym_COLON_DASH] = ACTIONS(5327),
    [anon_sym_PERCENT] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(5327),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5325),
    [anon_sym_BQUOTE] = ACTIONS(5325),
    [anon_sym_LT_LPAREN] = ACTIONS(5325),
    [anon_sym_GT_LPAREN] = ACTIONS(5325),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5327),
  },
  [2462] = {
    [sym__concat] = ACTIONS(5329),
    [anon_sym_RBRACE] = ACTIONS(5329),
    [anon_sym_EQ] = ACTIONS(5331),
    [sym__special_characters] = ACTIONS(5331),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [anon_sym_DOLLAR] = ACTIONS(5331),
    [sym_raw_string] = ACTIONS(5329),
    [anon_sym_POUND] = ACTIONS(5329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5329),
    [anon_sym_COLON] = ACTIONS(5331),
    [anon_sym_COLON_QMARK] = ACTIONS(5331),
    [anon_sym_COLON_DASH] = ACTIONS(5331),
    [anon_sym_PERCENT] = ACTIONS(5331),
    [anon_sym_DASH] = ACTIONS(5331),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5329),
    [anon_sym_BQUOTE] = ACTIONS(5329),
    [anon_sym_LT_LPAREN] = ACTIONS(5329),
    [anon_sym_GT_LPAREN] = ACTIONS(5329),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5331),
  },
  [2463] = {
    [sym__concat] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5333),
    [anon_sym_EQ] = ACTIONS(5335),
    [sym__special_characters] = ACTIONS(5335),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [anon_sym_DOLLAR] = ACTIONS(5335),
    [sym_raw_string] = ACTIONS(5333),
    [anon_sym_POUND] = ACTIONS(5333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_COLON_QMARK] = ACTIONS(5335),
    [anon_sym_COLON_DASH] = ACTIONS(5335),
    [anon_sym_PERCENT] = ACTIONS(5335),
    [anon_sym_DASH] = ACTIONS(5335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5333),
    [anon_sym_BQUOTE] = ACTIONS(5333),
    [anon_sym_LT_LPAREN] = ACTIONS(5333),
    [anon_sym_GT_LPAREN] = ACTIONS(5333),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5335),
  },
  [2464] = {
    [anon_sym_PIPE] = ACTIONS(5613),
    [anon_sym_RPAREN] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [sym_comment] = ACTIONS(53),
  },
  [2465] = {
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_RPAREN] = ACTIONS(5619),
    [anon_sym_PIPE_AMP] = ACTIONS(5619),
    [anon_sym_AMP_AMP] = ACTIONS(5619),
    [anon_sym_PIPE_PIPE] = ACTIONS(5619),
    [anon_sym_BQUOTE] = ACTIONS(5619),
    [sym_comment] = ACTIONS(53),
  },
  [2466] = {
    [sym_file_descriptor] = ACTIONS(2710),
    [sym__concat] = ACTIONS(2710),
    [anon_sym_PIPE] = ACTIONS(2712),
    [anon_sym_RPAREN] = ACTIONS(2710),
    [anon_sym_PIPE_AMP] = ACTIONS(2710),
    [anon_sym_AMP_AMP] = ACTIONS(2710),
    [anon_sym_PIPE_PIPE] = ACTIONS(2710),
    [anon_sym_LT] = ACTIONS(2712),
    [anon_sym_GT] = ACTIONS(2712),
    [anon_sym_GT_GT] = ACTIONS(2710),
    [anon_sym_AMP_GT] = ACTIONS(2712),
    [anon_sym_AMP_GT_GT] = ACTIONS(2710),
    [anon_sym_LT_AMP] = ACTIONS(2710),
    [anon_sym_GT_AMP] = ACTIONS(2710),
    [anon_sym_LT_LT] = ACTIONS(2712),
    [anon_sym_LT_LT_DASH] = ACTIONS(2710),
    [anon_sym_LT_LT_LT] = ACTIONS(2710),
    [anon_sym_BQUOTE] = ACTIONS(2710),
    [sym_comment] = ACTIONS(53),
  },
  [2467] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6019),
    [sym_comment] = ACTIONS(53),
  },
  [2468] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6021),
    [sym_comment] = ACTIONS(53),
  },
  [2469] = {
    [anon_sym_RBRACE] = ACTIONS(6021),
    [sym_comment] = ACTIONS(53),
  },
  [2470] = {
    [sym_concatenation] = STATE(2582),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2582),
    [anon_sym_RBRACE] = ACTIONS(6023),
    [anon_sym_EQ] = ACTIONS(6025),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6027),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6025),
    [anon_sym_COLON_QMARK] = ACTIONS(6025),
    [anon_sym_COLON_DASH] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [anon_sym_DASH] = ACTIONS(6025),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2471] = {
    [sym_file_descriptor] = ACTIONS(2788),
    [sym__concat] = ACTIONS(2788),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_RPAREN] = ACTIONS(2788),
    [anon_sym_PIPE_AMP] = ACTIONS(2788),
    [anon_sym_AMP_AMP] = ACTIONS(2788),
    [anon_sym_PIPE_PIPE] = ACTIONS(2788),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2788),
    [anon_sym_AMP_GT] = ACTIONS(2790),
    [anon_sym_AMP_GT_GT] = ACTIONS(2788),
    [anon_sym_LT_AMP] = ACTIONS(2788),
    [anon_sym_GT_AMP] = ACTIONS(2788),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_LT_LT_DASH] = ACTIONS(2788),
    [anon_sym_LT_LT_LT] = ACTIONS(2788),
    [anon_sym_BQUOTE] = ACTIONS(2788),
    [sym_comment] = ACTIONS(53),
  },
  [2472] = {
    [sym_concatenation] = STATE(2585),
    [sym_string] = STATE(2584),
    [sym_simple_expansion] = STATE(2584),
    [sym_string_expansion] = STATE(2584),
    [sym_expansion] = STATE(2584),
    [sym_command_substitution] = STATE(2584),
    [sym_process_substitution] = STATE(2584),
    [anon_sym_RBRACE] = ACTIONS(6021),
    [sym__special_characters] = ACTIONS(6029),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(6031),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6031),
  },
  [2473] = {
    [sym_file_descriptor] = ACTIONS(2831),
    [sym__concat] = ACTIONS(2831),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2831),
    [anon_sym_PIPE_AMP] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2831),
    [anon_sym_AMP_GT] = ACTIONS(2833),
    [anon_sym_AMP_GT_GT] = ACTIONS(2831),
    [anon_sym_LT_AMP] = ACTIONS(2831),
    [anon_sym_GT_AMP] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_DASH] = ACTIONS(2831),
    [anon_sym_LT_LT_LT] = ACTIONS(2831),
    [anon_sym_BQUOTE] = ACTIONS(2831),
    [sym_comment] = ACTIONS(53),
  },
  [2474] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6033),
  },
  [2475] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6035),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2476] = {
    [sym_file_descriptor] = ACTIONS(2839),
    [sym__concat] = ACTIONS(2839),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_RPAREN] = ACTIONS(2839),
    [anon_sym_PIPE_AMP] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_GT] = ACTIONS(2841),
    [anon_sym_GT_GT] = ACTIONS(2839),
    [anon_sym_AMP_GT] = ACTIONS(2841),
    [anon_sym_AMP_GT_GT] = ACTIONS(2839),
    [anon_sym_LT_AMP] = ACTIONS(2839),
    [anon_sym_GT_AMP] = ACTIONS(2839),
    [anon_sym_LT_LT] = ACTIONS(2841),
    [anon_sym_LT_LT_DASH] = ACTIONS(2839),
    [anon_sym_LT_LT_LT] = ACTIONS(2839),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_comment] = ACTIONS(53),
  },
  [2477] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6037),
  },
  [2478] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6039),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2479] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6041),
  },
  [2480] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6021),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2481] = {
    [sym_concatenation] = STATE(2592),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2592),
    [anon_sym_RBRACE] = ACTIONS(6043),
    [anon_sym_EQ] = ACTIONS(6045),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6045),
    [anon_sym_COLON_QMARK] = ACTIONS(6045),
    [anon_sym_COLON_DASH] = ACTIONS(6045),
    [anon_sym_PERCENT] = ACTIONS(6045),
    [anon_sym_DASH] = ACTIONS(6045),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2482] = {
    [sym_file_descriptor] = ACTIONS(2855),
    [sym__concat] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [anon_sym_PIPE_AMP] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_AMP_GT] = ACTIONS(2857),
    [anon_sym_AMP_GT_GT] = ACTIONS(2855),
    [anon_sym_LT_AMP] = ACTIONS(2855),
    [anon_sym_GT_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2857),
    [anon_sym_LT_LT_DASH] = ACTIONS(2855),
    [anon_sym_LT_LT_LT] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [sym_comment] = ACTIONS(53),
  },
  [2483] = {
    [sym_concatenation] = STATE(2594),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2594),
    [anon_sym_RBRACE] = ACTIONS(6049),
    [anon_sym_EQ] = ACTIONS(6051),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6051),
    [anon_sym_COLON_QMARK] = ACTIONS(6051),
    [anon_sym_COLON_DASH] = ACTIONS(6051),
    [anon_sym_PERCENT] = ACTIONS(6051),
    [anon_sym_DASH] = ACTIONS(6051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2484] = {
    [sym__concat] = ACTIONS(5325),
    [sym_variable_name] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [anon_sym_PIPE_AMP] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [sym__special_characters] = ACTIONS(5325),
    [anon_sym_DQUOTE] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [sym_raw_string] = ACTIONS(5325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5325),
    [anon_sym_BQUOTE] = ACTIONS(5325),
    [anon_sym_LT_LPAREN] = ACTIONS(5325),
    [anon_sym_GT_LPAREN] = ACTIONS(5325),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5327),
    [sym_word] = ACTIONS(5327),
  },
  [2485] = {
    [sym__concat] = ACTIONS(5329),
    [sym_variable_name] = ACTIONS(5329),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5329),
    [anon_sym_PIPE_AMP] = ACTIONS(5329),
    [anon_sym_AMP_AMP] = ACTIONS(5329),
    [anon_sym_PIPE_PIPE] = ACTIONS(5329),
    [sym__special_characters] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [anon_sym_DOLLAR] = ACTIONS(5331),
    [sym_raw_string] = ACTIONS(5329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5329),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5329),
    [anon_sym_BQUOTE] = ACTIONS(5329),
    [anon_sym_LT_LPAREN] = ACTIONS(5329),
    [anon_sym_GT_LPAREN] = ACTIONS(5329),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5331),
    [sym_word] = ACTIONS(5331),
  },
  [2486] = {
    [sym__concat] = ACTIONS(5333),
    [sym_variable_name] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_RPAREN] = ACTIONS(5333),
    [anon_sym_PIPE_AMP] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [sym__special_characters] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [anon_sym_DOLLAR] = ACTIONS(5335),
    [sym_raw_string] = ACTIONS(5333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5333),
    [anon_sym_BQUOTE] = ACTIONS(5333),
    [anon_sym_LT_LPAREN] = ACTIONS(5333),
    [anon_sym_GT_LPAREN] = ACTIONS(5333),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5335),
    [sym_word] = ACTIONS(5335),
  },
  [2487] = {
    [sym__concat] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [anon_sym_PIPE_AMP] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [sym__special_characters] = ACTIONS(5325),
    [anon_sym_DQUOTE] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [sym_raw_string] = ACTIONS(5325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5325),
    [anon_sym_BQUOTE] = ACTIONS(5325),
    [anon_sym_LT_LPAREN] = ACTIONS(5325),
    [anon_sym_GT_LPAREN] = ACTIONS(5325),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5327),
    [sym_word] = ACTIONS(5327),
  },
  [2488] = {
    [sym__concat] = ACTIONS(5329),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5329),
    [anon_sym_PIPE_AMP] = ACTIONS(5329),
    [anon_sym_AMP_AMP] = ACTIONS(5329),
    [anon_sym_PIPE_PIPE] = ACTIONS(5329),
    [sym__special_characters] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [anon_sym_DOLLAR] = ACTIONS(5331),
    [sym_raw_string] = ACTIONS(5329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5329),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5329),
    [anon_sym_BQUOTE] = ACTIONS(5329),
    [anon_sym_LT_LPAREN] = ACTIONS(5329),
    [anon_sym_GT_LPAREN] = ACTIONS(5329),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5331),
    [sym_word] = ACTIONS(5331),
  },
  [2489] = {
    [sym__concat] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_RPAREN] = ACTIONS(5333),
    [anon_sym_PIPE_AMP] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [sym__special_characters] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [anon_sym_DOLLAR] = ACTIONS(5335),
    [sym_raw_string] = ACTIONS(5333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5333),
    [anon_sym_BQUOTE] = ACTIONS(5333),
    [anon_sym_LT_LPAREN] = ACTIONS(5333),
    [anon_sym_GT_LPAREN] = ACTIONS(5333),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5335),
    [sym_word] = ACTIONS(5335),
  },
  [2490] = {
    [sym__heredoc_body_middle] = ACTIONS(5325),
    [sym__heredoc_body_end] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5325),
    [sym_comment] = ACTIONS(53),
  },
  [2491] = {
    [sym__heredoc_body_middle] = ACTIONS(5329),
    [sym__heredoc_body_end] = ACTIONS(5329),
    [anon_sym_DOLLAR] = ACTIONS(5331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5329),
    [sym_comment] = ACTIONS(53),
  },
  [2492] = {
    [sym__heredoc_body_middle] = ACTIONS(5333),
    [sym__heredoc_body_end] = ACTIONS(5333),
    [anon_sym_DOLLAR] = ACTIONS(5335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5333),
    [sym_comment] = ACTIONS(53),
  },
  [2493] = {
    [sym__concat] = ACTIONS(5325),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [sym__special_characters] = ACTIONS(5325),
    [anon_sym_DQUOTE] = ACTIONS(5325),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [sym_raw_string] = ACTIONS(5325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5325),
    [anon_sym_BQUOTE] = ACTIONS(5325),
    [anon_sym_LT_LPAREN] = ACTIONS(5325),
    [anon_sym_GT_LPAREN] = ACTIONS(5325),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5325),
  },
  [2494] = {
    [sym__concat] = ACTIONS(5329),
    [anon_sym_RPAREN] = ACTIONS(5329),
    [sym__special_characters] = ACTIONS(5329),
    [anon_sym_DQUOTE] = ACTIONS(5329),
    [anon_sym_DOLLAR] = ACTIONS(5331),
    [sym_raw_string] = ACTIONS(5329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5329),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5329),
    [anon_sym_BQUOTE] = ACTIONS(5329),
    [anon_sym_LT_LPAREN] = ACTIONS(5329),
    [anon_sym_GT_LPAREN] = ACTIONS(5329),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5329),
  },
  [2495] = {
    [sym__concat] = ACTIONS(5333),
    [anon_sym_RPAREN] = ACTIONS(5333),
    [sym__special_characters] = ACTIONS(5333),
    [anon_sym_DQUOTE] = ACTIONS(5333),
    [anon_sym_DOLLAR] = ACTIONS(5335),
    [sym_raw_string] = ACTIONS(5333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5333),
    [anon_sym_BQUOTE] = ACTIONS(5333),
    [anon_sym_LT_LPAREN] = ACTIONS(5333),
    [anon_sym_GT_LPAREN] = ACTIONS(5333),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5333),
  },
  [2496] = {
    [aux_sym_concatenation_repeat1] = STATE(2595),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(1131),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [2497] = {
    [sym_file_redirect] = STATE(2412),
    [sym_heredoc_redirect] = STATE(2412),
    [sym_heredoc_body] = STATE(1036),
    [sym_herestring_redirect] = STATE(2412),
    [aux_sym_while_statement_repeat1] = STATE(2412),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5127),
    [anon_sym_esac] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2235),
    [anon_sym_SEMI_SEMI] = ACTIONS(2235),
    [anon_sym_PIPE_AMP] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_LT] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5131),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT_GT] = ACTIONS(5131),
    [anon_sym_LT_AMP] = ACTIONS(5131),
    [anon_sym_GT_AMP] = ACTIONS(5131),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_LF] = ACTIONS(2237),
    [anon_sym_AMP] = ACTIONS(2235),
  },
  [2498] = {
    [sym_compound_statement] = STATE(2596),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [2499] = {
    [anon_sym_LT] = ACTIONS(6055),
    [anon_sym_GT] = ACTIONS(6055),
    [anon_sym_GT_GT] = ACTIONS(6057),
    [anon_sym_AMP_GT] = ACTIONS(6055),
    [anon_sym_AMP_GT_GT] = ACTIONS(6057),
    [anon_sym_LT_AMP] = ACTIONS(6057),
    [anon_sym_GT_AMP] = ACTIONS(6057),
    [sym_comment] = ACTIONS(53),
  },
  [2500] = {
    [sym_concatenation] = STATE(1080),
    [sym_string] = STATE(2601),
    [sym_simple_expansion] = STATE(2601),
    [sym_string_expansion] = STATE(2601),
    [sym_expansion] = STATE(2601),
    [sym_command_substitution] = STATE(2601),
    [sym_process_substitution] = STATE(2601),
    [sym__special_characters] = ACTIONS(6059),
    [anon_sym_DQUOTE] = ACTIONS(6061),
    [anon_sym_DOLLAR] = ACTIONS(6063),
    [sym_raw_string] = ACTIONS(6065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6069),
    [anon_sym_BQUOTE] = ACTIONS(6071),
    [anon_sym_LT_LPAREN] = ACTIONS(6073),
    [anon_sym_GT_LPAREN] = ACTIONS(6073),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6065),
  },
  [2501] = {
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_AMP_GT] = ACTIONS(6075),
    [anon_sym_AMP_GT_GT] = ACTIONS(6077),
    [anon_sym_LT_AMP] = ACTIONS(6077),
    [anon_sym_GT_AMP] = ACTIONS(6077),
    [sym_comment] = ACTIONS(53),
  },
  [2502] = {
    [sym_concatenation] = STATE(1130),
    [sym_string] = STATE(2608),
    [sym_simple_expansion] = STATE(2608),
    [sym_string_expansion] = STATE(2608),
    [sym_expansion] = STATE(2608),
    [sym_command_substitution] = STATE(2608),
    [sym_process_substitution] = STATE(2608),
    [sym__special_characters] = ACTIONS(6079),
    [anon_sym_DQUOTE] = ACTIONS(2458),
    [anon_sym_DOLLAR] = ACTIONS(2460),
    [sym_raw_string] = ACTIONS(6081),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2466),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [anon_sym_LT_LPAREN] = ACTIONS(2470),
    [anon_sym_GT_LPAREN] = ACTIONS(2470),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6081),
  },
  [2503] = {
    [sym_concatenation] = STATE(1134),
    [sym_string] = STATE(2610),
    [sym_simple_expansion] = STATE(2610),
    [sym_string_expansion] = STATE(2610),
    [sym_expansion] = STATE(2610),
    [sym_command_substitution] = STATE(2610),
    [sym_process_substitution] = STATE(2610),
    [sym__special_characters] = ACTIONS(6083),
    [anon_sym_DQUOTE] = ACTIONS(2458),
    [anon_sym_DOLLAR] = ACTIONS(2460),
    [sym_raw_string] = ACTIONS(6085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2466),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [anon_sym_LT_LPAREN] = ACTIONS(2470),
    [anon_sym_GT_LPAREN] = ACTIONS(2470),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6085),
  },
  [2504] = {
    [sym_file_redirect] = STATE(2611),
    [sym_heredoc_redirect] = STATE(2611),
    [sym_herestring_redirect] = STATE(2611),
    [aux_sym_while_statement_repeat1] = STATE(2611),
    [sym_file_descriptor] = ACTIONS(5768),
    [anon_sym_esac] = ACTIONS(2478),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_SEMI_SEMI] = ACTIONS(2478),
    [anon_sym_PIPE_AMP] = ACTIONS(2478),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_LT] = ACTIONS(5770),
    [anon_sym_GT] = ACTIONS(5770),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(1345),
    [anon_sym_LT_LT_DASH] = ACTIONS(1345),
    [anon_sym_LT_LT_LT] = ACTIONS(5772),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_LF] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2478),
  },
  [2505] = {
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_esac] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [2506] = {
    [sym_concatenation] = STATE(2613),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(2613),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [2507] = {
    [aux_sym_concatenation_repeat1] = STATE(2364),
    [sym__concat] = ACTIONS(5519),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_esac] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [sym__special_characters] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1133),
    [sym_word] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1133),
  },
  [2508] = {
    [aux_sym_concatenation_repeat1] = STATE(2364),
    [sym__concat] = ACTIONS(5519),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_esac] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [2509] = {
    [sym__concat] = ACTIONS(1642),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_esac] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [2510] = {
    [aux_sym_concatenation_repeat1] = STATE(2510),
    [sym__concat] = ACTIONS(6089),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_esac] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [2511] = {
    [sym__concat] = ACTIONS(1691),
    [sym_variable_name] = ACTIONS(1691),
    [anon_sym_esac] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_SEMI_SEMI] = ACTIONS(1693),
    [anon_sym_PIPE_AMP] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [sym__special_characters] = ACTIONS(1693),
    [anon_sym_DQUOTE] = ACTIONS(1693),
    [anon_sym_DOLLAR] = ACTIONS(1693),
    [sym_raw_string] = ACTIONS(1693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1693),
    [anon_sym_BQUOTE] = ACTIONS(1693),
    [anon_sym_LT_LPAREN] = ACTIONS(1693),
    [anon_sym_GT_LPAREN] = ACTIONS(1693),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1693),
    [sym_word] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1693),
    [anon_sym_LF] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1693),
  },
  [2512] = {
    [sym_concatenation] = STATE(2617),
    [sym_string] = STATE(2616),
    [sym_simple_expansion] = STATE(2616),
    [sym_string_expansion] = STATE(2616),
    [sym_expansion] = STATE(2616),
    [sym_command_substitution] = STATE(2616),
    [sym_process_substitution] = STATE(2616),
    [anon_sym_RBRACE] = ACTIONS(6092),
    [sym__special_characters] = ACTIONS(6094),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(6096),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6096),
  },
  [2513] = {
    [sym__concat] = ACTIONS(1732),
    [sym_variable_name] = ACTIONS(1732),
    [anon_sym_esac] = ACTIONS(1734),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_SEMI_SEMI] = ACTIONS(1734),
    [anon_sym_PIPE_AMP] = ACTIONS(1734),
    [anon_sym_AMP_AMP] = ACTIONS(1734),
    [anon_sym_PIPE_PIPE] = ACTIONS(1734),
    [sym__special_characters] = ACTIONS(1734),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [sym_raw_string] = ACTIONS(1734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1734),
    [anon_sym_BQUOTE] = ACTIONS(1734),
    [anon_sym_LT_LPAREN] = ACTIONS(1734),
    [anon_sym_GT_LPAREN] = ACTIONS(1734),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1734),
    [sym_word] = ACTIONS(1734),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_LF] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1734),
  },
  [2514] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6098),
  },
  [2515] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6100),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2516] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(6102),
    [sym_comment] = ACTIONS(53),
  },
  [2517] = {
    [sym_concatenation] = STATE(2623),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2623),
    [anon_sym_RBRACE] = ACTIONS(6104),
    [anon_sym_EQ] = ACTIONS(6106),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6110),
    [anon_sym_COLON] = ACTIONS(6106),
    [anon_sym_COLON_QMARK] = ACTIONS(6106),
    [anon_sym_COLON_DASH] = ACTIONS(6106),
    [anon_sym_PERCENT] = ACTIONS(6106),
    [anon_sym_DASH] = ACTIONS(6106),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2518] = {
    [sym_concatenation] = STATE(2626),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2626),
    [anon_sym_RBRACE] = ACTIONS(6112),
    [anon_sym_EQ] = ACTIONS(6114),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6116),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6118),
    [anon_sym_COLON] = ACTIONS(6114),
    [anon_sym_COLON_QMARK] = ACTIONS(6114),
    [anon_sym_COLON_DASH] = ACTIONS(6114),
    [anon_sym_PERCENT] = ACTIONS(6114),
    [anon_sym_DASH] = ACTIONS(6114),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2519] = {
    [sym_concatenation] = STATE(2628),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2628),
    [anon_sym_RBRACE] = ACTIONS(6092),
    [anon_sym_EQ] = ACTIONS(6120),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6122),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6124),
    [anon_sym_COLON] = ACTIONS(6120),
    [anon_sym_COLON_QMARK] = ACTIONS(6120),
    [anon_sym_COLON_DASH] = ACTIONS(6120),
    [anon_sym_PERCENT] = ACTIONS(6120),
    [anon_sym_DASH] = ACTIONS(6120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2520] = {
    [sym__concat] = ACTIONS(1798),
    [sym_variable_name] = ACTIONS(1798),
    [anon_sym_esac] = ACTIONS(1800),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_SEMI_SEMI] = ACTIONS(1800),
    [anon_sym_PIPE_AMP] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(1800),
    [anon_sym_PIPE_PIPE] = ACTIONS(1800),
    [sym__special_characters] = ACTIONS(1800),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [sym_raw_string] = ACTIONS(1800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1800),
    [anon_sym_BQUOTE] = ACTIONS(1800),
    [anon_sym_LT_LPAREN] = ACTIONS(1800),
    [anon_sym_GT_LPAREN] = ACTIONS(1800),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1800),
    [sym_word] = ACTIONS(1800),
    [anon_sym_SEMI] = ACTIONS(1800),
    [anon_sym_LF] = ACTIONS(1798),
    [anon_sym_AMP] = ACTIONS(1800),
  },
  [2521] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6126),
  },
  [2522] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6128),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2523] = {
    [sym__concat] = ACTIONS(1806),
    [sym_variable_name] = ACTIONS(1806),
    [anon_sym_esac] = ACTIONS(1808),
    [anon_sym_PIPE] = ACTIONS(1808),
    [anon_sym_SEMI_SEMI] = ACTIONS(1808),
    [anon_sym_PIPE_AMP] = ACTIONS(1808),
    [anon_sym_AMP_AMP] = ACTIONS(1808),
    [anon_sym_PIPE_PIPE] = ACTIONS(1808),
    [sym__special_characters] = ACTIONS(1808),
    [anon_sym_DQUOTE] = ACTIONS(1808),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [sym_raw_string] = ACTIONS(1808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1808),
    [anon_sym_BQUOTE] = ACTIONS(1808),
    [anon_sym_LT_LPAREN] = ACTIONS(1808),
    [anon_sym_GT_LPAREN] = ACTIONS(1808),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1808),
    [sym_word] = ACTIONS(1808),
    [anon_sym_SEMI] = ACTIONS(1808),
    [anon_sym_LF] = ACTIONS(1806),
    [anon_sym_AMP] = ACTIONS(1808),
  },
  [2524] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6130),
  },
  [2525] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6092),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2526] = {
    [sym__concat] = ACTIONS(1940),
    [sym_variable_name] = ACTIONS(1940),
    [anon_sym_esac] = ACTIONS(1942),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1942),
    [anon_sym_PIPE_AMP] = ACTIONS(1942),
    [anon_sym_AMP_AMP] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1942),
    [sym__special_characters] = ACTIONS(1942),
    [anon_sym_DQUOTE] = ACTIONS(1942),
    [anon_sym_DOLLAR] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1942),
    [anon_sym_BQUOTE] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1942),
    [anon_sym_GT_LPAREN] = ACTIONS(1942),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1942),
    [sym_word] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [2527] = {
    [sym__concat] = ACTIONS(2006),
    [sym_variable_name] = ACTIONS(2006),
    [anon_sym_esac] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [sym__special_characters] = ACTIONS(2008),
    [anon_sym_DQUOTE] = ACTIONS(2008),
    [anon_sym_DOLLAR] = ACTIONS(2008),
    [sym_raw_string] = ACTIONS(2008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2008),
    [anon_sym_BQUOTE] = ACTIONS(2008),
    [anon_sym_LT_LPAREN] = ACTIONS(2008),
    [anon_sym_GT_LPAREN] = ACTIONS(2008),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2008),
    [sym_word] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2008),
  },
  [2528] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_esac] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [2529] = {
    [aux_sym_concatenation_repeat1] = STATE(2529),
    [sym__concat] = ACTIONS(6132),
    [anon_sym_esac] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1644),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [2530] = {
    [sym__concat] = ACTIONS(1691),
    [anon_sym_esac] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_SEMI_SEMI] = ACTIONS(1693),
    [anon_sym_PIPE_AMP] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [sym__special_characters] = ACTIONS(1693),
    [anon_sym_DQUOTE] = ACTIONS(1693),
    [anon_sym_DOLLAR] = ACTIONS(1693),
    [sym_raw_string] = ACTIONS(1693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1693),
    [anon_sym_BQUOTE] = ACTIONS(1693),
    [anon_sym_LT_LPAREN] = ACTIONS(1693),
    [anon_sym_GT_LPAREN] = ACTIONS(1693),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1693),
    [sym_word] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1693),
    [anon_sym_LF] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1693),
  },
  [2531] = {
    [sym_concatenation] = STATE(2635),
    [sym_string] = STATE(2634),
    [sym_simple_expansion] = STATE(2634),
    [sym_string_expansion] = STATE(2634),
    [sym_expansion] = STATE(2634),
    [sym_command_substitution] = STATE(2634),
    [sym_process_substitution] = STATE(2634),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [sym__special_characters] = ACTIONS(6137),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(6139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6139),
  },
  [2532] = {
    [sym__concat] = ACTIONS(1732),
    [anon_sym_esac] = ACTIONS(1734),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_SEMI_SEMI] = ACTIONS(1734),
    [anon_sym_PIPE_AMP] = ACTIONS(1734),
    [anon_sym_AMP_AMP] = ACTIONS(1734),
    [anon_sym_PIPE_PIPE] = ACTIONS(1734),
    [sym__special_characters] = ACTIONS(1734),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [sym_raw_string] = ACTIONS(1734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1734),
    [anon_sym_BQUOTE] = ACTIONS(1734),
    [anon_sym_LT_LPAREN] = ACTIONS(1734),
    [anon_sym_GT_LPAREN] = ACTIONS(1734),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1734),
    [sym_word] = ACTIONS(1734),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_LF] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1734),
  },
  [2533] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6141),
  },
  [2534] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6143),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2535] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(6145),
    [sym_comment] = ACTIONS(53),
  },
  [2536] = {
    [sym_concatenation] = STATE(2641),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2641),
    [anon_sym_RBRACE] = ACTIONS(6147),
    [anon_sym_EQ] = ACTIONS(6149),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6153),
    [anon_sym_COLON] = ACTIONS(6149),
    [anon_sym_COLON_QMARK] = ACTIONS(6149),
    [anon_sym_COLON_DASH] = ACTIONS(6149),
    [anon_sym_PERCENT] = ACTIONS(6149),
    [anon_sym_DASH] = ACTIONS(6149),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2537] = {
    [sym_concatenation] = STATE(2644),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2644),
    [anon_sym_RBRACE] = ACTIONS(6155),
    [anon_sym_EQ] = ACTIONS(6157),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6161),
    [anon_sym_COLON] = ACTIONS(6157),
    [anon_sym_COLON_QMARK] = ACTIONS(6157),
    [anon_sym_COLON_DASH] = ACTIONS(6157),
    [anon_sym_PERCENT] = ACTIONS(6157),
    [anon_sym_DASH] = ACTIONS(6157),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2538] = {
    [sym_concatenation] = STATE(2646),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2646),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_EQ] = ACTIONS(6163),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6167),
    [anon_sym_COLON] = ACTIONS(6163),
    [anon_sym_COLON_QMARK] = ACTIONS(6163),
    [anon_sym_COLON_DASH] = ACTIONS(6163),
    [anon_sym_PERCENT] = ACTIONS(6163),
    [anon_sym_DASH] = ACTIONS(6163),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2539] = {
    [sym__concat] = ACTIONS(1798),
    [anon_sym_esac] = ACTIONS(1800),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_SEMI_SEMI] = ACTIONS(1800),
    [anon_sym_PIPE_AMP] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(1800),
    [anon_sym_PIPE_PIPE] = ACTIONS(1800),
    [sym__special_characters] = ACTIONS(1800),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [anon_sym_DOLLAR] = ACTIONS(1800),
    [sym_raw_string] = ACTIONS(1800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1800),
    [anon_sym_BQUOTE] = ACTIONS(1800),
    [anon_sym_LT_LPAREN] = ACTIONS(1800),
    [anon_sym_GT_LPAREN] = ACTIONS(1800),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1800),
    [sym_word] = ACTIONS(1800),
    [anon_sym_SEMI] = ACTIONS(1800),
    [anon_sym_LF] = ACTIONS(1798),
    [anon_sym_AMP] = ACTIONS(1800),
  },
  [2540] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6169),
  },
  [2541] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6171),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2542] = {
    [sym__concat] = ACTIONS(1806),
    [anon_sym_esac] = ACTIONS(1808),
    [anon_sym_PIPE] = ACTIONS(1808),
    [anon_sym_SEMI_SEMI] = ACTIONS(1808),
    [anon_sym_PIPE_AMP] = ACTIONS(1808),
    [anon_sym_AMP_AMP] = ACTIONS(1808),
    [anon_sym_PIPE_PIPE] = ACTIONS(1808),
    [sym__special_characters] = ACTIONS(1808),
    [anon_sym_DQUOTE] = ACTIONS(1808),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [sym_raw_string] = ACTIONS(1808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1808),
    [anon_sym_BQUOTE] = ACTIONS(1808),
    [anon_sym_LT_LPAREN] = ACTIONS(1808),
    [anon_sym_GT_LPAREN] = ACTIONS(1808),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1808),
    [sym_word] = ACTIONS(1808),
    [anon_sym_SEMI] = ACTIONS(1808),
    [anon_sym_LF] = ACTIONS(1806),
    [anon_sym_AMP] = ACTIONS(1808),
  },
  [2543] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6173),
  },
  [2544] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2545] = {
    [sym__concat] = ACTIONS(1940),
    [anon_sym_esac] = ACTIONS(1942),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1942),
    [anon_sym_PIPE_AMP] = ACTIONS(1942),
    [anon_sym_AMP_AMP] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1942),
    [sym__special_characters] = ACTIONS(1942),
    [anon_sym_DQUOTE] = ACTIONS(1942),
    [anon_sym_DOLLAR] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1942),
    [anon_sym_BQUOTE] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1942),
    [anon_sym_GT_LPAREN] = ACTIONS(1942),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1942),
    [sym_word] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [2546] = {
    [sym__concat] = ACTIONS(2006),
    [anon_sym_esac] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [sym__special_characters] = ACTIONS(2008),
    [anon_sym_DQUOTE] = ACTIONS(2008),
    [anon_sym_DOLLAR] = ACTIONS(2008),
    [sym_raw_string] = ACTIONS(2008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2008),
    [anon_sym_BQUOTE] = ACTIONS(2008),
    [anon_sym_LT_LPAREN] = ACTIONS(2008),
    [anon_sym_GT_LPAREN] = ACTIONS(2008),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2008),
    [sym_word] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2008),
  },
  [2547] = {
    [sym_file_redirect] = STATE(1401),
    [sym_file_descriptor] = ACTIONS(5764),
    [anon_sym_esac] = ACTIONS(2334),
    [anon_sym_PIPE] = ACTIONS(2334),
    [anon_sym_SEMI_SEMI] = ACTIONS(2334),
    [anon_sym_PIPE_AMP] = ACTIONS(2334),
    [anon_sym_AMP_AMP] = ACTIONS(2334),
    [anon_sym_PIPE_PIPE] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(5766),
    [anon_sym_GT] = ACTIONS(5766),
    [anon_sym_GT_GT] = ACTIONS(5766),
    [anon_sym_AMP_GT] = ACTIONS(5766),
    [anon_sym_AMP_GT_GT] = ACTIONS(5766),
    [anon_sym_LT_AMP] = ACTIONS(5766),
    [anon_sym_GT_AMP] = ACTIONS(5766),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_LF] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2334),
  },
  [2548] = {
    [aux_sym_concatenation_repeat1] = STATE(2550),
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(223),
    [anon_sym_esac] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2549] = {
    [aux_sym_concatenation_repeat1] = STATE(2550),
    [sym__simple_heredoc_body] = ACTIONS(1093),
    [sym__heredoc_body_beginning] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(223),
    [anon_sym_esac] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [2550] = {
    [aux_sym_concatenation_repeat1] = STATE(2650),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(223),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [2551] = {
    [sym_file_redirect] = STATE(2412),
    [sym_heredoc_redirect] = STATE(2412),
    [sym_heredoc_body] = STATE(1417),
    [sym_herestring_redirect] = STATE(2412),
    [aux_sym_while_statement_repeat1] = STATE(2412),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5127),
    [anon_sym_esac] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3283),
    [anon_sym_SEMI_SEMI] = ACTIONS(3283),
    [anon_sym_PIPE_AMP] = ACTIONS(3283),
    [anon_sym_AMP_AMP] = ACTIONS(3283),
    [anon_sym_PIPE_PIPE] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5131),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT] = ACTIONS(5131),
    [anon_sym_AMP_GT_GT] = ACTIONS(5131),
    [anon_sym_LT_AMP] = ACTIONS(5131),
    [anon_sym_GT_AMP] = ACTIONS(5131),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_LF] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3283),
  },
  [2552] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_esac] = ACTIONS(6175),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(6177),
    [anon_sym_DQUOTE] = ACTIONS(6179),
    [anon_sym_DOLLAR] = ACTIONS(6177),
    [sym_raw_string] = ACTIONS(6179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6179),
    [anon_sym_BQUOTE] = ACTIONS(6179),
    [anon_sym_LT_LPAREN] = ACTIONS(6179),
    [anon_sym_GT_LPAREN] = ACTIONS(6179),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6177),
  },
  [2553] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_esac] = ACTIONS(6181),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(6183),
    [anon_sym_DQUOTE] = ACTIONS(6185),
    [anon_sym_DOLLAR] = ACTIONS(6183),
    [sym_raw_string] = ACTIONS(6185),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6185),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6185),
    [anon_sym_BQUOTE] = ACTIONS(6185),
    [anon_sym_LT_LPAREN] = ACTIONS(6185),
    [anon_sym_GT_LPAREN] = ACTIONS(6185),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6183),
  },
  [2554] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(5571),
    [anon_sym_DQUOTE] = ACTIONS(5573),
    [anon_sym_DOLLAR] = ACTIONS(5571),
    [sym_raw_string] = ACTIONS(5573),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5573),
    [anon_sym_BQUOTE] = ACTIONS(5573),
    [anon_sym_LT_LPAREN] = ACTIONS(5573),
    [anon_sym_GT_LPAREN] = ACTIONS(5573),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5571),
  },
  [2555] = {
    [sym__special_characters] = ACTIONS(5573),
    [anon_sym_DQUOTE] = ACTIONS(5573),
    [anon_sym_DOLLAR] = ACTIONS(5571),
    [sym_raw_string] = ACTIONS(5573),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5573),
    [anon_sym_BQUOTE] = ACTIONS(5573),
    [anon_sym_LT_LPAREN] = ACTIONS(5573),
    [anon_sym_GT_LPAREN] = ACTIONS(5573),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5573),
  },
  [2556] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6187),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2557] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6187),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2558] = {
    [sym__terminated_statement] = STATE(2558),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2558),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_SEMI_SEMI] = ACTIONS(1005),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [2559] = {
    [sym__terminated_statement] = STATE(2558),
    [sym_for_statement] = STATE(2653),
    [sym_while_statement] = STATE(2653),
    [sym_if_statement] = STATE(2653),
    [sym_case_statement] = STATE(2653),
    [sym_function_definition] = STATE(2653),
    [sym_subshell] = STATE(2653),
    [sym_pipeline] = STATE(2653),
    [sym_list] = STATE(2653),
    [sym_negated_command] = STATE(2653),
    [sym_test_command] = STATE(2653),
    [sym_declaration_command] = STATE(2653),
    [sym_unset_command] = STATE(2653),
    [sym_command] = STATE(2653),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2654),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2558),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6189),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2560] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(5597),
    [anon_sym_DQUOTE] = ACTIONS(5599),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5599),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5599),
    [anon_sym_BQUOTE] = ACTIONS(5599),
    [anon_sym_LT_LPAREN] = ACTIONS(5599),
    [anon_sym_GT_LPAREN] = ACTIONS(5599),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5597),
  },
  [2561] = {
    [sym__special_characters] = ACTIONS(5599),
    [anon_sym_DQUOTE] = ACTIONS(5599),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [sym_raw_string] = ACTIONS(5599),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5599),
    [anon_sym_BQUOTE] = ACTIONS(5599),
    [anon_sym_LT_LPAREN] = ACTIONS(5599),
    [anon_sym_GT_LPAREN] = ACTIONS(5599),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5599),
  },
  [2562] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6191),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2563] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6191),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2564] = {
    [sym__terminated_statement] = STATE(2558),
    [sym_for_statement] = STATE(2657),
    [sym_while_statement] = STATE(2657),
    [sym_if_statement] = STATE(2657),
    [sym_case_statement] = STATE(2657),
    [sym_function_definition] = STATE(2657),
    [sym_subshell] = STATE(2657),
    [sym_pipeline] = STATE(2657),
    [sym_list] = STATE(2657),
    [sym_negated_command] = STATE(2657),
    [sym_test_command] = STATE(2657),
    [sym_declaration_command] = STATE(2657),
    [sym_unset_command] = STATE(2657),
    [sym_command] = STATE(2657),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2658),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2558),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6193),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2565] = {
    [sym_file_descriptor] = ACTIONS(4741),
    [sym__concat] = ACTIONS(4741),
    [anon_sym_esac] = ACTIONS(4743),
    [anon_sym_PIPE] = ACTIONS(4743),
    [anon_sym_RPAREN] = ACTIONS(4743),
    [anon_sym_SEMI_SEMI] = ACTIONS(4743),
    [anon_sym_PIPE_AMP] = ACTIONS(4743),
    [anon_sym_AMP_AMP] = ACTIONS(4743),
    [anon_sym_PIPE_PIPE] = ACTIONS(4743),
    [anon_sym_LT] = ACTIONS(4743),
    [anon_sym_GT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4743),
    [anon_sym_AMP_GT] = ACTIONS(4743),
    [anon_sym_AMP_GT_GT] = ACTIONS(4743),
    [anon_sym_LT_AMP] = ACTIONS(4743),
    [anon_sym_GT_AMP] = ACTIONS(4743),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_LT_LT_DASH] = ACTIONS(4743),
    [anon_sym_LT_LT_LT] = ACTIONS(4743),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_LF] = ACTIONS(4741),
    [anon_sym_AMP] = ACTIONS(4743),
  },
  [2566] = {
    [sym_file_descriptor] = ACTIONS(4745),
    [sym__concat] = ACTIONS(4745),
    [anon_sym_esac] = ACTIONS(4747),
    [anon_sym_PIPE] = ACTIONS(4747),
    [anon_sym_RPAREN] = ACTIONS(4747),
    [anon_sym_SEMI_SEMI] = ACTIONS(4747),
    [anon_sym_PIPE_AMP] = ACTIONS(4747),
    [anon_sym_AMP_AMP] = ACTIONS(4747),
    [anon_sym_PIPE_PIPE] = ACTIONS(4747),
    [anon_sym_LT] = ACTIONS(4747),
    [anon_sym_GT] = ACTIONS(4747),
    [anon_sym_GT_GT] = ACTIONS(4747),
    [anon_sym_AMP_GT] = ACTIONS(4747),
    [anon_sym_AMP_GT_GT] = ACTIONS(4747),
    [anon_sym_LT_AMP] = ACTIONS(4747),
    [anon_sym_GT_AMP] = ACTIONS(4747),
    [anon_sym_LT_LT] = ACTIONS(4747),
    [anon_sym_LT_LT_DASH] = ACTIONS(4747),
    [anon_sym_LT_LT_LT] = ACTIONS(4747),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4747),
    [anon_sym_LF] = ACTIONS(4745),
    [anon_sym_AMP] = ACTIONS(4747),
  },
  [2567] = {
    [sym_file_descriptor] = ACTIONS(4749),
    [sym__concat] = ACTIONS(4749),
    [anon_sym_esac] = ACTIONS(4751),
    [anon_sym_PIPE] = ACTIONS(4751),
    [anon_sym_RPAREN] = ACTIONS(4751),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [anon_sym_LT] = ACTIONS(4751),
    [anon_sym_GT] = ACTIONS(4751),
    [anon_sym_GT_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT_GT] = ACTIONS(4751),
    [anon_sym_LT_AMP] = ACTIONS(4751),
    [anon_sym_GT_AMP] = ACTIONS(4751),
    [anon_sym_LT_LT] = ACTIONS(4751),
    [anon_sym_LT_LT_DASH] = ACTIONS(4751),
    [anon_sym_LT_LT_LT] = ACTIONS(4751),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4751),
    [anon_sym_LF] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(4751),
  },
  [2568] = {
    [sym_file_descriptor] = ACTIONS(4753),
    [sym__concat] = ACTIONS(4753),
    [anon_sym_esac] = ACTIONS(4755),
    [anon_sym_PIPE] = ACTIONS(4755),
    [anon_sym_RPAREN] = ACTIONS(4755),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4755),
    [anon_sym_GT] = ACTIONS(4755),
    [anon_sym_GT_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT_GT] = ACTIONS(4755),
    [anon_sym_LT_AMP] = ACTIONS(4755),
    [anon_sym_GT_AMP] = ACTIONS(4755),
    [anon_sym_LT_LT] = ACTIONS(4755),
    [anon_sym_LT_LT_DASH] = ACTIONS(4755),
    [anon_sym_LT_LT_LT] = ACTIONS(4755),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_LF] = ACTIONS(4753),
    [anon_sym_AMP] = ACTIONS(4755),
  },
  [2569] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6195),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2570] = {
    [sym_file_descriptor] = ACTIONS(4759),
    [sym__concat] = ACTIONS(4759),
    [anon_sym_esac] = ACTIONS(4761),
    [anon_sym_PIPE] = ACTIONS(4761),
    [anon_sym_RPAREN] = ACTIONS(4761),
    [anon_sym_SEMI_SEMI] = ACTIONS(4761),
    [anon_sym_PIPE_AMP] = ACTIONS(4761),
    [anon_sym_AMP_AMP] = ACTIONS(4761),
    [anon_sym_PIPE_PIPE] = ACTIONS(4761),
    [anon_sym_LT] = ACTIONS(4761),
    [anon_sym_GT] = ACTIONS(4761),
    [anon_sym_GT_GT] = ACTIONS(4761),
    [anon_sym_AMP_GT] = ACTIONS(4761),
    [anon_sym_AMP_GT_GT] = ACTIONS(4761),
    [anon_sym_LT_AMP] = ACTIONS(4761),
    [anon_sym_GT_AMP] = ACTIONS(4761),
    [anon_sym_LT_LT] = ACTIONS(4761),
    [anon_sym_LT_LT_DASH] = ACTIONS(4761),
    [anon_sym_LT_LT_LT] = ACTIONS(4761),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4761),
    [anon_sym_LF] = ACTIONS(4759),
    [anon_sym_AMP] = ACTIONS(4761),
  },
  [2571] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6197),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2572] = {
    [sym_file_descriptor] = ACTIONS(4765),
    [sym__concat] = ACTIONS(4765),
    [anon_sym_esac] = ACTIONS(4767),
    [anon_sym_PIPE] = ACTIONS(4767),
    [anon_sym_RPAREN] = ACTIONS(4767),
    [anon_sym_SEMI_SEMI] = ACTIONS(4767),
    [anon_sym_PIPE_AMP] = ACTIONS(4767),
    [anon_sym_AMP_AMP] = ACTIONS(4767),
    [anon_sym_PIPE_PIPE] = ACTIONS(4767),
    [anon_sym_LT] = ACTIONS(4767),
    [anon_sym_GT] = ACTIONS(4767),
    [anon_sym_GT_GT] = ACTIONS(4767),
    [anon_sym_AMP_GT] = ACTIONS(4767),
    [anon_sym_AMP_GT_GT] = ACTIONS(4767),
    [anon_sym_LT_AMP] = ACTIONS(4767),
    [anon_sym_GT_AMP] = ACTIONS(4767),
    [anon_sym_LT_LT] = ACTIONS(4767),
    [anon_sym_LT_LT_DASH] = ACTIONS(4767),
    [anon_sym_LT_LT_LT] = ACTIONS(4767),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4767),
    [anon_sym_LF] = ACTIONS(4765),
    [anon_sym_AMP] = ACTIONS(4767),
  },
  [2573] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6199),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2574] = {
    [sym_file_descriptor] = ACTIONS(4771),
    [sym__concat] = ACTIONS(4771),
    [anon_sym_esac] = ACTIONS(4773),
    [anon_sym_PIPE] = ACTIONS(4773),
    [anon_sym_RPAREN] = ACTIONS(4773),
    [anon_sym_SEMI_SEMI] = ACTIONS(4773),
    [anon_sym_PIPE_AMP] = ACTIONS(4773),
    [anon_sym_AMP_AMP] = ACTIONS(4773),
    [anon_sym_PIPE_PIPE] = ACTIONS(4773),
    [anon_sym_LT] = ACTIONS(4773),
    [anon_sym_GT] = ACTIONS(4773),
    [anon_sym_GT_GT] = ACTIONS(4773),
    [anon_sym_AMP_GT] = ACTIONS(4773),
    [anon_sym_AMP_GT_GT] = ACTIONS(4773),
    [anon_sym_LT_AMP] = ACTIONS(4773),
    [anon_sym_GT_AMP] = ACTIONS(4773),
    [anon_sym_LT_LT] = ACTIONS(4773),
    [anon_sym_LT_LT_DASH] = ACTIONS(4773),
    [anon_sym_LT_LT_LT] = ACTIONS(4773),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4773),
    [anon_sym_LF] = ACTIONS(4771),
    [anon_sym_AMP] = ACTIONS(4773),
  },
  [2575] = {
    [sym_file_descriptor] = ACTIONS(4775),
    [sym__concat] = ACTIONS(4775),
    [anon_sym_esac] = ACTIONS(4777),
    [anon_sym_PIPE] = ACTIONS(4777),
    [anon_sym_RPAREN] = ACTIONS(4777),
    [anon_sym_SEMI_SEMI] = ACTIONS(4777),
    [anon_sym_PIPE_AMP] = ACTIONS(4777),
    [anon_sym_AMP_AMP] = ACTIONS(4777),
    [anon_sym_PIPE_PIPE] = ACTIONS(4777),
    [anon_sym_LT] = ACTIONS(4777),
    [anon_sym_GT] = ACTIONS(4777),
    [anon_sym_GT_GT] = ACTIONS(4777),
    [anon_sym_AMP_GT] = ACTIONS(4777),
    [anon_sym_AMP_GT_GT] = ACTIONS(4777),
    [anon_sym_LT_AMP] = ACTIONS(4777),
    [anon_sym_GT_AMP] = ACTIONS(4777),
    [anon_sym_LT_LT] = ACTIONS(4777),
    [anon_sym_LT_LT_DASH] = ACTIONS(4777),
    [anon_sym_LT_LT_LT] = ACTIONS(4777),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4777),
    [anon_sym_LF] = ACTIONS(4775),
    [anon_sym_AMP] = ACTIONS(4777),
  },
  [2576] = {
    [sym__concat] = ACTIONS(5325),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [sym_comment] = ACTIONS(53),
  },
  [2577] = {
    [sym__concat] = ACTIONS(5329),
    [anon_sym_RBRACE] = ACTIONS(5329),
    [sym_comment] = ACTIONS(53),
  },
  [2578] = {
    [sym__concat] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5333),
    [sym_comment] = ACTIONS(53),
  },
  [2579] = {
    [sym_file_descriptor] = ACTIONS(3829),
    [sym__concat] = ACTIONS(3829),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_RPAREN] = ACTIONS(3829),
    [anon_sym_PIPE_AMP] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_GT] = ACTIONS(3831),
    [anon_sym_GT_GT] = ACTIONS(3829),
    [anon_sym_AMP_GT] = ACTIONS(3831),
    [anon_sym_AMP_GT_GT] = ACTIONS(3829),
    [anon_sym_LT_AMP] = ACTIONS(3829),
    [anon_sym_GT_AMP] = ACTIONS(3829),
    [anon_sym_LT_LT] = ACTIONS(3831),
    [anon_sym_LT_LT_DASH] = ACTIONS(3829),
    [anon_sym_LT_LT_LT] = ACTIONS(3829),
    [anon_sym_BQUOTE] = ACTIONS(3829),
    [sym_comment] = ACTIONS(53),
  },
  [2580] = {
    [sym_file_descriptor] = ACTIONS(3835),
    [sym__concat] = ACTIONS(3835),
    [anon_sym_PIPE] = ACTIONS(3837),
    [anon_sym_RPAREN] = ACTIONS(3835),
    [anon_sym_PIPE_AMP] = ACTIONS(3835),
    [anon_sym_AMP_AMP] = ACTIONS(3835),
    [anon_sym_PIPE_PIPE] = ACTIONS(3835),
    [anon_sym_LT] = ACTIONS(3837),
    [anon_sym_GT] = ACTIONS(3837),
    [anon_sym_GT_GT] = ACTIONS(3835),
    [anon_sym_AMP_GT] = ACTIONS(3837),
    [anon_sym_AMP_GT_GT] = ACTIONS(3835),
    [anon_sym_LT_AMP] = ACTIONS(3835),
    [anon_sym_GT_AMP] = ACTIONS(3835),
    [anon_sym_LT_LT] = ACTIONS(3837),
    [anon_sym_LT_LT_DASH] = ACTIONS(3835),
    [anon_sym_LT_LT_LT] = ACTIONS(3835),
    [anon_sym_BQUOTE] = ACTIONS(3835),
    [sym_comment] = ACTIONS(53),
  },
  [2581] = {
    [sym_file_descriptor] = ACTIONS(3920),
    [sym__concat] = ACTIONS(3920),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_RPAREN] = ACTIONS(3920),
    [anon_sym_PIPE_AMP] = ACTIONS(3920),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3920),
    [anon_sym_LT] = ACTIONS(3922),
    [anon_sym_GT] = ACTIONS(3922),
    [anon_sym_GT_GT] = ACTIONS(3920),
    [anon_sym_AMP_GT] = ACTIONS(3922),
    [anon_sym_AMP_GT_GT] = ACTIONS(3920),
    [anon_sym_LT_AMP] = ACTIONS(3920),
    [anon_sym_GT_AMP] = ACTIONS(3920),
    [anon_sym_LT_LT] = ACTIONS(3922),
    [anon_sym_LT_LT_DASH] = ACTIONS(3920),
    [anon_sym_LT_LT_LT] = ACTIONS(3920),
    [anon_sym_BQUOTE] = ACTIONS(3920),
    [sym_comment] = ACTIONS(53),
  },
  [2582] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6201),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2583] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6203),
    [sym_comment] = ACTIONS(53),
  },
  [2584] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6205),
    [sym_comment] = ACTIONS(53),
  },
  [2585] = {
    [anon_sym_RBRACE] = ACTIONS(6205),
    [sym_comment] = ACTIONS(53),
  },
  [2586] = {
    [sym_concatenation] = STATE(2666),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2666),
    [anon_sym_RBRACE] = ACTIONS(6207),
    [anon_sym_EQ] = ACTIONS(6209),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6209),
    [anon_sym_COLON_QMARK] = ACTIONS(6209),
    [anon_sym_COLON_DASH] = ACTIONS(6209),
    [anon_sym_PERCENT] = ACTIONS(6209),
    [anon_sym_DASH] = ACTIONS(6209),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2587] = {
    [sym_file_descriptor] = ACTIONS(3936),
    [sym__concat] = ACTIONS(3936),
    [anon_sym_PIPE] = ACTIONS(3938),
    [anon_sym_RPAREN] = ACTIONS(3936),
    [anon_sym_PIPE_AMP] = ACTIONS(3936),
    [anon_sym_AMP_AMP] = ACTIONS(3936),
    [anon_sym_PIPE_PIPE] = ACTIONS(3936),
    [anon_sym_LT] = ACTIONS(3938),
    [anon_sym_GT] = ACTIONS(3938),
    [anon_sym_GT_GT] = ACTIONS(3936),
    [anon_sym_AMP_GT] = ACTIONS(3938),
    [anon_sym_AMP_GT_GT] = ACTIONS(3936),
    [anon_sym_LT_AMP] = ACTIONS(3936),
    [anon_sym_GT_AMP] = ACTIONS(3936),
    [anon_sym_LT_LT] = ACTIONS(3938),
    [anon_sym_LT_LT_DASH] = ACTIONS(3936),
    [anon_sym_LT_LT_LT] = ACTIONS(3936),
    [anon_sym_BQUOTE] = ACTIONS(3936),
    [sym_comment] = ACTIONS(53),
  },
  [2588] = {
    [sym_concatenation] = STATE(2668),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2668),
    [anon_sym_RBRACE] = ACTIONS(6213),
    [anon_sym_EQ] = ACTIONS(6215),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_COLON_QMARK] = ACTIONS(6215),
    [anon_sym_COLON_DASH] = ACTIONS(6215),
    [anon_sym_PERCENT] = ACTIONS(6215),
    [anon_sym_DASH] = ACTIONS(6215),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2589] = {
    [sym_file_descriptor] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3948),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3948),
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3948),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [sym_comment] = ACTIONS(53),
  },
  [2590] = {
    [sym_concatenation] = STATE(2670),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2670),
    [anon_sym_RBRACE] = ACTIONS(6219),
    [anon_sym_EQ] = ACTIONS(6221),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6223),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6221),
    [anon_sym_COLON_QMARK] = ACTIONS(6221),
    [anon_sym_COLON_DASH] = ACTIONS(6221),
    [anon_sym_PERCENT] = ACTIONS(6221),
    [anon_sym_DASH] = ACTIONS(6221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2591] = {
    [sym_file_descriptor] = ACTIONS(3956),
    [sym__concat] = ACTIONS(3956),
    [anon_sym_PIPE] = ACTIONS(3958),
    [anon_sym_RPAREN] = ACTIONS(3956),
    [anon_sym_PIPE_AMP] = ACTIONS(3956),
    [anon_sym_AMP_AMP] = ACTIONS(3956),
    [anon_sym_PIPE_PIPE] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_GT] = ACTIONS(3956),
    [anon_sym_AMP_GT] = ACTIONS(3958),
    [anon_sym_AMP_GT_GT] = ACTIONS(3956),
    [anon_sym_LT_AMP] = ACTIONS(3956),
    [anon_sym_GT_AMP] = ACTIONS(3956),
    [anon_sym_LT_LT] = ACTIONS(3958),
    [anon_sym_LT_LT_DASH] = ACTIONS(3956),
    [anon_sym_LT_LT_LT] = ACTIONS(3956),
    [anon_sym_BQUOTE] = ACTIONS(3956),
    [sym_comment] = ACTIONS(53),
  },
  [2592] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6225),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2593] = {
    [sym_file_descriptor] = ACTIONS(3962),
    [sym__concat] = ACTIONS(3962),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_RPAREN] = ACTIONS(3962),
    [anon_sym_PIPE_AMP] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_GT] = ACTIONS(3964),
    [anon_sym_GT_GT] = ACTIONS(3962),
    [anon_sym_AMP_GT] = ACTIONS(3964),
    [anon_sym_AMP_GT_GT] = ACTIONS(3962),
    [anon_sym_LT_AMP] = ACTIONS(3962),
    [anon_sym_GT_AMP] = ACTIONS(3962),
    [anon_sym_LT_LT] = ACTIONS(3964),
    [anon_sym_LT_LT_DASH] = ACTIONS(3962),
    [anon_sym_LT_LT_LT] = ACTIONS(3962),
    [anon_sym_BQUOTE] = ACTIONS(3962),
    [sym_comment] = ACTIONS(53),
  },
  [2594] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6227),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2595] = {
    [aux_sym_concatenation_repeat1] = STATE(2595),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(3367),
    [sym_variable_name] = ACTIONS(1642),
    [anon_sym_esac] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [sym_raw_string] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LT_LPAREN] = ACTIONS(1644),
    [anon_sym_GT_LPAREN] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [2596] = {
    [sym_file_redirect] = STATE(1495),
    [sym_file_descriptor] = ACTIONS(5764),
    [anon_sym_esac] = ACTIONS(3521),
    [anon_sym_PIPE] = ACTIONS(3521),
    [anon_sym_SEMI_SEMI] = ACTIONS(3521),
    [anon_sym_PIPE_AMP] = ACTIONS(3521),
    [anon_sym_AMP_AMP] = ACTIONS(3521),
    [anon_sym_PIPE_PIPE] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(5766),
    [anon_sym_GT] = ACTIONS(5766),
    [anon_sym_GT_GT] = ACTIONS(5766),
    [anon_sym_AMP_GT] = ACTIONS(5766),
    [anon_sym_AMP_GT_GT] = ACTIONS(5766),
    [anon_sym_LT_AMP] = ACTIONS(5766),
    [anon_sym_GT_AMP] = ACTIONS(5766),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3521),
    [anon_sym_LF] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
  },
  [2597] = {
    [sym_concatenation] = STATE(1498),
    [sym_string] = STATE(2674),
    [sym_simple_expansion] = STATE(2674),
    [sym_string_expansion] = STATE(2674),
    [sym_expansion] = STATE(2674),
    [sym_command_substitution] = STATE(2674),
    [sym_process_substitution] = STATE(2674),
    [sym__special_characters] = ACTIONS(6229),
    [anon_sym_DQUOTE] = ACTIONS(6061),
    [anon_sym_DOLLAR] = ACTIONS(6063),
    [sym_raw_string] = ACTIONS(6231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6069),
    [anon_sym_BQUOTE] = ACTIONS(6071),
    [anon_sym_LT_LPAREN] = ACTIONS(6073),
    [anon_sym_GT_LPAREN] = ACTIONS(6073),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6231),
  },
  [2598] = {
    [aux_sym_concatenation_repeat1] = STATE(2676),
    [sym__concat] = ACTIONS(6233),
    [anon_sym_esac] = ACTIONS(665),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [2599] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(2678),
    [anon_sym_DQUOTE] = ACTIONS(6235),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2600] = {
    [sym_string] = STATE(2680),
    [anon_sym_DQUOTE] = ACTIONS(6061),
    [anon_sym_DOLLAR] = ACTIONS(6237),
    [sym_raw_string] = ACTIONS(6239),
    [anon_sym_POUND] = ACTIONS(6237),
    [anon_sym_DASH] = ACTIONS(6237),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6241),
    [anon_sym_STAR] = ACTIONS(6237),
    [anon_sym_AT] = ACTIONS(6237),
    [anon_sym_QMARK] = ACTIONS(6237),
    [anon_sym_0] = ACTIONS(6243),
    [anon_sym__] = ACTIONS(6243),
  },
  [2601] = {
    [aux_sym_concatenation_repeat1] = STATE(2676),
    [sym__concat] = ACTIONS(6233),
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [2602] = {
    [sym_subscript] = STATE(2686),
    [sym_variable_name] = ACTIONS(6245),
    [anon_sym_DOLLAR] = ACTIONS(6247),
    [anon_sym_POUND] = ACTIONS(6249),
    [anon_sym_DASH] = ACTIONS(6247),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6251),
    [anon_sym_STAR] = ACTIONS(6247),
    [anon_sym_AT] = ACTIONS(6247),
    [anon_sym_QMARK] = ACTIONS(6247),
    [anon_sym_0] = ACTIONS(6253),
    [anon_sym__] = ACTIONS(6253),
  },
  [2603] = {
    [sym_for_statement] = STATE(2687),
    [sym_while_statement] = STATE(2687),
    [sym_if_statement] = STATE(2687),
    [sym_case_statement] = STATE(2687),
    [sym_function_definition] = STATE(2687),
    [sym_subshell] = STATE(2687),
    [sym_pipeline] = STATE(2687),
    [sym_list] = STATE(2687),
    [sym_negated_command] = STATE(2687),
    [sym_test_command] = STATE(2687),
    [sym_declaration_command] = STATE(2687),
    [sym_unset_command] = STATE(2687),
    [sym_command] = STATE(2687),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2688),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2604] = {
    [sym_for_statement] = STATE(2689),
    [sym_while_statement] = STATE(2689),
    [sym_if_statement] = STATE(2689),
    [sym_case_statement] = STATE(2689),
    [sym_function_definition] = STATE(2689),
    [sym_subshell] = STATE(2689),
    [sym_pipeline] = STATE(2689),
    [sym_list] = STATE(2689),
    [sym_negated_command] = STATE(2689),
    [sym_test_command] = STATE(2689),
    [sym_declaration_command] = STATE(2689),
    [sym_unset_command] = STATE(2689),
    [sym_command] = STATE(2689),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(2690),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [2605] = {
    [sym_for_statement] = STATE(2691),
    [sym_while_statement] = STATE(2691),
    [sym_if_statement] = STATE(2691),
    [sym_case_statement] = STATE(2691),
    [sym_function_definition] = STATE(2691),
    [sym_subshell] = STATE(2691),
    [sym_pipeline] = STATE(2691),
    [sym_list] = STATE(2691),
    [sym_negated_command] = STATE(2691),
    [sym_test_command] = STATE(2691),
    [sym_declaration_command] = STATE(2691),
    [sym_unset_command] = STATE(2691),
    [sym_command] = STATE(2691),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2692),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2606] = {
    [sym_concatenation] = STATE(1531),
    [sym_string] = STATE(2694),
    [sym_simple_expansion] = STATE(2694),
    [sym_string_expansion] = STATE(2694),
    [sym_expansion] = STATE(2694),
    [sym_command_substitution] = STATE(2694),
    [sym_process_substitution] = STATE(2694),
    [sym__special_characters] = ACTIONS(6255),
    [anon_sym_DQUOTE] = ACTIONS(2458),
    [anon_sym_DOLLAR] = ACTIONS(2460),
    [sym_raw_string] = ACTIONS(6257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2466),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [anon_sym_LT_LPAREN] = ACTIONS(2470),
    [anon_sym_GT_LPAREN] = ACTIONS(2470),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6257),
  },
  [2607] = {
    [aux_sym_concatenation_repeat1] = STATE(2695),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_esac] = ACTIONS(665),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(665),
    [anon_sym_LT_LT_LT] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [2608] = {
    [aux_sym_concatenation_repeat1] = STATE(2695),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [2609] = {
    [aux_sym_concatenation_repeat1] = STATE(2695),
    [sym_file_descriptor] = ACTIONS(2058),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_esac] = ACTIONS(2060),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_SEMI_SEMI] = ACTIONS(2060),
    [anon_sym_PIPE_AMP] = ACTIONS(2060),
    [anon_sym_AMP_AMP] = ACTIONS(2060),
    [anon_sym_PIPE_PIPE] = ACTIONS(2060),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2060),
    [anon_sym_LT_AMP] = ACTIONS(2060),
    [anon_sym_GT_AMP] = ACTIONS(2060),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2060),
    [anon_sym_LT_LT_LT] = ACTIONS(2060),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2060),
  },
  [2610] = {
    [aux_sym_concatenation_repeat1] = STATE(2695),
    [sym_file_descriptor] = ACTIONS(2062),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_esac] = ACTIONS(2064),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [2611] = {
    [sym_file_redirect] = STATE(2611),
    [sym_heredoc_redirect] = STATE(2611),
    [sym_herestring_redirect] = STATE(2611),
    [aux_sym_while_statement_repeat1] = STATE(2611),
    [sym_file_descriptor] = ACTIONS(6259),
    [anon_sym_esac] = ACTIONS(2075),
    [anon_sym_PIPE] = ACTIONS(2075),
    [anon_sym_SEMI_SEMI] = ACTIONS(2075),
    [anon_sym_PIPE_AMP] = ACTIONS(2075),
    [anon_sym_AMP_AMP] = ACTIONS(2075),
    [anon_sym_PIPE_PIPE] = ACTIONS(2075),
    [anon_sym_LT] = ACTIONS(6262),
    [anon_sym_GT] = ACTIONS(6262),
    [anon_sym_GT_GT] = ACTIONS(6262),
    [anon_sym_AMP_GT] = ACTIONS(6262),
    [anon_sym_AMP_GT_GT] = ACTIONS(6262),
    [anon_sym_LT_AMP] = ACTIONS(6262),
    [anon_sym_GT_AMP] = ACTIONS(6262),
    [anon_sym_LT_LT] = ACTIONS(3627),
    [anon_sym_LT_LT_DASH] = ACTIONS(3627),
    [anon_sym_LT_LT_LT] = ACTIONS(6265),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_LF] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2075),
  },
  [2612] = {
    [sym_variable_name] = ACTIONS(2127),
    [anon_sym_esac] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(2129),
    [anon_sym_SEMI_SEMI] = ACTIONS(2129),
    [anon_sym_PIPE_AMP] = ACTIONS(2129),
    [anon_sym_AMP_AMP] = ACTIONS(2129),
    [anon_sym_PIPE_PIPE] = ACTIONS(2129),
    [sym__special_characters] = ACTIONS(2129),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_DOLLAR] = ACTIONS(2129),
    [sym_raw_string] = ACTIONS(2129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2129),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [anon_sym_LT_LPAREN] = ACTIONS(2129),
    [anon_sym_GT_LPAREN] = ACTIONS(2129),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2129),
    [sym_word] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_LF] = ACTIONS(2127),
    [anon_sym_AMP] = ACTIONS(2129),
  },
  [2613] = {
    [sym_concatenation] = STATE(1009),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1009),
    [anon_sym_RPAREN] = ACTIONS(6268),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [2614] = {
    [sym__concat] = ACTIONS(2710),
    [sym_variable_name] = ACTIONS(2710),
    [anon_sym_esac] = ACTIONS(2712),
    [anon_sym_PIPE] = ACTIONS(2712),
    [anon_sym_SEMI_SEMI] = ACTIONS(2712),
    [anon_sym_PIPE_AMP] = ACTIONS(2712),
    [anon_sym_AMP_AMP] = ACTIONS(2712),
    [anon_sym_PIPE_PIPE] = ACTIONS(2712),
    [sym__special_characters] = ACTIONS(2712),
    [anon_sym_DQUOTE] = ACTIONS(2712),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [sym_raw_string] = ACTIONS(2712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2712),
    [anon_sym_BQUOTE] = ACTIONS(2712),
    [anon_sym_LT_LPAREN] = ACTIONS(2712),
    [anon_sym_GT_LPAREN] = ACTIONS(2712),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2712),
    [sym_word] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_LF] = ACTIONS(2710),
    [anon_sym_AMP] = ACTIONS(2712),
  },
  [2615] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6270),
    [sym_comment] = ACTIONS(53),
  },
  [2616] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6272),
    [sym_comment] = ACTIONS(53),
  },
  [2617] = {
    [anon_sym_RBRACE] = ACTIONS(6272),
    [sym_comment] = ACTIONS(53),
  },
  [2618] = {
    [sym_concatenation] = STATE(2700),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2700),
    [anon_sym_RBRACE] = ACTIONS(6274),
    [anon_sym_EQ] = ACTIONS(6276),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6276),
    [anon_sym_COLON_QMARK] = ACTIONS(6276),
    [anon_sym_COLON_DASH] = ACTIONS(6276),
    [anon_sym_PERCENT] = ACTIONS(6276),
    [anon_sym_DASH] = ACTIONS(6276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2619] = {
    [sym__concat] = ACTIONS(2788),
    [sym_variable_name] = ACTIONS(2788),
    [anon_sym_esac] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_SEMI_SEMI] = ACTIONS(2790),
    [anon_sym_PIPE_AMP] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2790),
    [anon_sym_PIPE_PIPE] = ACTIONS(2790),
    [sym__special_characters] = ACTIONS(2790),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym_raw_string] = ACTIONS(2790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2790),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [anon_sym_LT_LPAREN] = ACTIONS(2790),
    [anon_sym_GT_LPAREN] = ACTIONS(2790),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2790),
    [sym_word] = ACTIONS(2790),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_LF] = ACTIONS(2788),
    [anon_sym_AMP] = ACTIONS(2790),
  },
  [2620] = {
    [sym_concatenation] = STATE(2703),
    [sym_string] = STATE(2702),
    [sym_simple_expansion] = STATE(2702),
    [sym_string_expansion] = STATE(2702),
    [sym_expansion] = STATE(2702),
    [sym_command_substitution] = STATE(2702),
    [sym_process_substitution] = STATE(2702),
    [anon_sym_RBRACE] = ACTIONS(6272),
    [sym__special_characters] = ACTIONS(6280),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(6282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6282),
  },
  [2621] = {
    [sym__concat] = ACTIONS(2831),
    [sym_variable_name] = ACTIONS(2831),
    [anon_sym_esac] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_SEMI_SEMI] = ACTIONS(2833),
    [anon_sym_PIPE_AMP] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [sym__special_characters] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [sym_raw_string] = ACTIONS(2833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2833),
    [anon_sym_BQUOTE] = ACTIONS(2833),
    [anon_sym_LT_LPAREN] = ACTIONS(2833),
    [anon_sym_GT_LPAREN] = ACTIONS(2833),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2833),
    [sym_word] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2831),
    [anon_sym_AMP] = ACTIONS(2833),
  },
  [2622] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6284),
  },
  [2623] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6286),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2624] = {
    [sym__concat] = ACTIONS(2839),
    [sym_variable_name] = ACTIONS(2839),
    [anon_sym_esac] = ACTIONS(2841),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_SEMI_SEMI] = ACTIONS(2841),
    [anon_sym_PIPE_AMP] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [sym__special_characters] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2841),
    [sym_raw_string] = ACTIONS(2841),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2841),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2841),
    [anon_sym_BQUOTE] = ACTIONS(2841),
    [anon_sym_LT_LPAREN] = ACTIONS(2841),
    [anon_sym_GT_LPAREN] = ACTIONS(2841),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2841),
    [sym_word] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2839),
    [anon_sym_AMP] = ACTIONS(2841),
  },
  [2625] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6288),
  },
  [2626] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6290),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2627] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6292),
  },
  [2628] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6272),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2629] = {
    [sym_concatenation] = STATE(2710),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2710),
    [anon_sym_RBRACE] = ACTIONS(6294),
    [anon_sym_EQ] = ACTIONS(6296),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6298),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6296),
    [anon_sym_COLON_QMARK] = ACTIONS(6296),
    [anon_sym_COLON_DASH] = ACTIONS(6296),
    [anon_sym_PERCENT] = ACTIONS(6296),
    [anon_sym_DASH] = ACTIONS(6296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2630] = {
    [sym__concat] = ACTIONS(2855),
    [sym_variable_name] = ACTIONS(2855),
    [anon_sym_esac] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_SEMI_SEMI] = ACTIONS(2857),
    [anon_sym_PIPE_AMP] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2857),
    [sym__special_characters] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2857),
    [anon_sym_BQUOTE] = ACTIONS(2857),
    [anon_sym_LT_LPAREN] = ACTIONS(2857),
    [anon_sym_GT_LPAREN] = ACTIONS(2857),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2857),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [2631] = {
    [sym_concatenation] = STATE(2712),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2712),
    [anon_sym_RBRACE] = ACTIONS(6300),
    [anon_sym_EQ] = ACTIONS(6302),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6302),
    [anon_sym_COLON_QMARK] = ACTIONS(6302),
    [anon_sym_COLON_DASH] = ACTIONS(6302),
    [anon_sym_PERCENT] = ACTIONS(6302),
    [anon_sym_DASH] = ACTIONS(6302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2632] = {
    [sym__concat] = ACTIONS(2710),
    [anon_sym_esac] = ACTIONS(2712),
    [anon_sym_PIPE] = ACTIONS(2712),
    [anon_sym_SEMI_SEMI] = ACTIONS(2712),
    [anon_sym_PIPE_AMP] = ACTIONS(2712),
    [anon_sym_AMP_AMP] = ACTIONS(2712),
    [anon_sym_PIPE_PIPE] = ACTIONS(2712),
    [sym__special_characters] = ACTIONS(2712),
    [anon_sym_DQUOTE] = ACTIONS(2712),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [sym_raw_string] = ACTIONS(2712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2712),
    [anon_sym_BQUOTE] = ACTIONS(2712),
    [anon_sym_LT_LPAREN] = ACTIONS(2712),
    [anon_sym_GT_LPAREN] = ACTIONS(2712),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2712),
    [sym_word] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_LF] = ACTIONS(2710),
    [anon_sym_AMP] = ACTIONS(2712),
  },
  [2633] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6306),
    [sym_comment] = ACTIONS(53),
  },
  [2634] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6308),
    [sym_comment] = ACTIONS(53),
  },
  [2635] = {
    [anon_sym_RBRACE] = ACTIONS(6308),
    [sym_comment] = ACTIONS(53),
  },
  [2636] = {
    [sym_concatenation] = STATE(2716),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2716),
    [anon_sym_RBRACE] = ACTIONS(6310),
    [anon_sym_EQ] = ACTIONS(6312),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6314),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6312),
    [anon_sym_COLON_QMARK] = ACTIONS(6312),
    [anon_sym_COLON_DASH] = ACTIONS(6312),
    [anon_sym_PERCENT] = ACTIONS(6312),
    [anon_sym_DASH] = ACTIONS(6312),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2637] = {
    [sym__concat] = ACTIONS(2788),
    [anon_sym_esac] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_SEMI_SEMI] = ACTIONS(2790),
    [anon_sym_PIPE_AMP] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2790),
    [anon_sym_PIPE_PIPE] = ACTIONS(2790),
    [sym__special_characters] = ACTIONS(2790),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym_raw_string] = ACTIONS(2790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2790),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [anon_sym_LT_LPAREN] = ACTIONS(2790),
    [anon_sym_GT_LPAREN] = ACTIONS(2790),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2790),
    [sym_word] = ACTIONS(2790),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_LF] = ACTIONS(2788),
    [anon_sym_AMP] = ACTIONS(2790),
  },
  [2638] = {
    [sym_concatenation] = STATE(2719),
    [sym_string] = STATE(2718),
    [sym_simple_expansion] = STATE(2718),
    [sym_string_expansion] = STATE(2718),
    [sym_expansion] = STATE(2718),
    [sym_command_substitution] = STATE(2718),
    [sym_process_substitution] = STATE(2718),
    [anon_sym_RBRACE] = ACTIONS(6308),
    [sym__special_characters] = ACTIONS(6316),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(6318),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6318),
  },
  [2639] = {
    [sym__concat] = ACTIONS(2831),
    [anon_sym_esac] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_SEMI_SEMI] = ACTIONS(2833),
    [anon_sym_PIPE_AMP] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [sym__special_characters] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [sym_raw_string] = ACTIONS(2833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2833),
    [anon_sym_BQUOTE] = ACTIONS(2833),
    [anon_sym_LT_LPAREN] = ACTIONS(2833),
    [anon_sym_GT_LPAREN] = ACTIONS(2833),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2833),
    [sym_word] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2831),
    [anon_sym_AMP] = ACTIONS(2833),
  },
  [2640] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6320),
  },
  [2641] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6322),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2642] = {
    [sym__concat] = ACTIONS(2839),
    [anon_sym_esac] = ACTIONS(2841),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_SEMI_SEMI] = ACTIONS(2841),
    [anon_sym_PIPE_AMP] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [sym__special_characters] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2841),
    [sym_raw_string] = ACTIONS(2841),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2841),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2841),
    [anon_sym_BQUOTE] = ACTIONS(2841),
    [anon_sym_LT_LPAREN] = ACTIONS(2841),
    [anon_sym_GT_LPAREN] = ACTIONS(2841),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2841),
    [sym_word] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2839),
    [anon_sym_AMP] = ACTIONS(2841),
  },
  [2643] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6324),
  },
  [2644] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6326),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2645] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6328),
  },
  [2646] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6308),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2647] = {
    [sym_concatenation] = STATE(2726),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2726),
    [anon_sym_RBRACE] = ACTIONS(6330),
    [anon_sym_EQ] = ACTIONS(6332),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6334),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6332),
    [anon_sym_COLON_QMARK] = ACTIONS(6332),
    [anon_sym_COLON_DASH] = ACTIONS(6332),
    [anon_sym_PERCENT] = ACTIONS(6332),
    [anon_sym_DASH] = ACTIONS(6332),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2648] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_esac] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_SEMI_SEMI] = ACTIONS(2857),
    [anon_sym_PIPE_AMP] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2857),
    [sym__special_characters] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2857),
    [sym_raw_string] = ACTIONS(2857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2857),
    [anon_sym_BQUOTE] = ACTIONS(2857),
    [anon_sym_LT_LPAREN] = ACTIONS(2857),
    [anon_sym_GT_LPAREN] = ACTIONS(2857),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2857),
    [sym_word] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [2649] = {
    [sym_concatenation] = STATE(2728),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2728),
    [anon_sym_RBRACE] = ACTIONS(6336),
    [anon_sym_EQ] = ACTIONS(6338),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6338),
    [anon_sym_COLON_QMARK] = ACTIONS(6338),
    [anon_sym_COLON_DASH] = ACTIONS(6338),
    [anon_sym_PERCENT] = ACTIONS(6338),
    [anon_sym_DASH] = ACTIONS(6338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2650] = {
    [aux_sym_concatenation_repeat1] = STATE(2650),
    [sym__simple_heredoc_body] = ACTIONS(1642),
    [sym__heredoc_body_beginning] = ACTIONS(1642),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(1646),
    [anon_sym_esac] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [2651] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(5963),
    [anon_sym_DQUOTE] = ACTIONS(5965),
    [anon_sym_DOLLAR] = ACTIONS(5963),
    [sym_raw_string] = ACTIONS(5965),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5965),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5965),
    [anon_sym_BQUOTE] = ACTIONS(5965),
    [anon_sym_LT_LPAREN] = ACTIONS(5965),
    [anon_sym_GT_LPAREN] = ACTIONS(5965),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5963),
  },
  [2652] = {
    [sym__special_characters] = ACTIONS(5965),
    [anon_sym_DQUOTE] = ACTIONS(5965),
    [anon_sym_DOLLAR] = ACTIONS(5963),
    [sym_raw_string] = ACTIONS(5965),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5965),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5965),
    [anon_sym_BQUOTE] = ACTIONS(5965),
    [anon_sym_LT_LPAREN] = ACTIONS(5965),
    [anon_sym_GT_LPAREN] = ACTIONS(5965),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5965),
  },
  [2653] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6342),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2654] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6342),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2655] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(5971),
    [anon_sym_DQUOTE] = ACTIONS(5973),
    [anon_sym_DOLLAR] = ACTIONS(5971),
    [sym_raw_string] = ACTIONS(5973),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5973),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5973),
    [anon_sym_BQUOTE] = ACTIONS(5973),
    [anon_sym_LT_LPAREN] = ACTIONS(5973),
    [anon_sym_GT_LPAREN] = ACTIONS(5973),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5971),
  },
  [2656] = {
    [sym__special_characters] = ACTIONS(5973),
    [anon_sym_DQUOTE] = ACTIONS(5973),
    [anon_sym_DOLLAR] = ACTIONS(5971),
    [sym_raw_string] = ACTIONS(5973),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5973),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5973),
    [anon_sym_BQUOTE] = ACTIONS(5973),
    [anon_sym_LT_LPAREN] = ACTIONS(5973),
    [anon_sym_GT_LPAREN] = ACTIONS(5973),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5973),
  },
  [2657] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6344),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2658] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6344),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2659] = {
    [sym_file_descriptor] = ACTIONS(5325),
    [sym__concat] = ACTIONS(5325),
    [anon_sym_esac] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_RPAREN] = ACTIONS(5327),
    [anon_sym_SEMI_SEMI] = ACTIONS(5327),
    [anon_sym_PIPE_AMP] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_GT_GT] = ACTIONS(5327),
    [anon_sym_AMP_GT] = ACTIONS(5327),
    [anon_sym_AMP_GT_GT] = ACTIONS(5327),
    [anon_sym_LT_AMP] = ACTIONS(5327),
    [anon_sym_GT_AMP] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5327),
    [anon_sym_LT_LT_LT] = ACTIONS(5327),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5327),
    [anon_sym_LF] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
  },
  [2660] = {
    [sym_file_descriptor] = ACTIONS(5329),
    [sym__concat] = ACTIONS(5329),
    [anon_sym_esac] = ACTIONS(5331),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5331),
    [anon_sym_SEMI_SEMI] = ACTIONS(5331),
    [anon_sym_PIPE_AMP] = ACTIONS(5331),
    [anon_sym_AMP_AMP] = ACTIONS(5331),
    [anon_sym_PIPE_PIPE] = ACTIONS(5331),
    [anon_sym_LT] = ACTIONS(5331),
    [anon_sym_GT] = ACTIONS(5331),
    [anon_sym_GT_GT] = ACTIONS(5331),
    [anon_sym_AMP_GT] = ACTIONS(5331),
    [anon_sym_AMP_GT_GT] = ACTIONS(5331),
    [anon_sym_LT_AMP] = ACTIONS(5331),
    [anon_sym_GT_AMP] = ACTIONS(5331),
    [anon_sym_LT_LT] = ACTIONS(5331),
    [anon_sym_LT_LT_DASH] = ACTIONS(5331),
    [anon_sym_LT_LT_LT] = ACTIONS(5331),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LF] = ACTIONS(5329),
    [anon_sym_AMP] = ACTIONS(5331),
  },
  [2661] = {
    [sym_file_descriptor] = ACTIONS(5333),
    [sym__concat] = ACTIONS(5333),
    [anon_sym_esac] = ACTIONS(5335),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_RPAREN] = ACTIONS(5335),
    [anon_sym_SEMI_SEMI] = ACTIONS(5335),
    [anon_sym_PIPE_AMP] = ACTIONS(5335),
    [anon_sym_AMP_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5335),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_GT] = ACTIONS(5335),
    [anon_sym_AMP_GT] = ACTIONS(5335),
    [anon_sym_AMP_GT_GT] = ACTIONS(5335),
    [anon_sym_LT_AMP] = ACTIONS(5335),
    [anon_sym_GT_AMP] = ACTIONS(5335),
    [anon_sym_LT_LT] = ACTIONS(5335),
    [anon_sym_LT_LT_DASH] = ACTIONS(5335),
    [anon_sym_LT_LT_LT] = ACTIONS(5335),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5335),
    [anon_sym_LF] = ACTIONS(5333),
    [anon_sym_AMP] = ACTIONS(5335),
  },
  [2662] = {
    [sym_file_descriptor] = ACTIONS(4741),
    [sym__concat] = ACTIONS(4741),
    [anon_sym_PIPE] = ACTIONS(4743),
    [anon_sym_RPAREN] = ACTIONS(4741),
    [anon_sym_PIPE_AMP] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_LT] = ACTIONS(4743),
    [anon_sym_GT] = ACTIONS(4743),
    [anon_sym_GT_GT] = ACTIONS(4741),
    [anon_sym_AMP_GT] = ACTIONS(4743),
    [anon_sym_AMP_GT_GT] = ACTIONS(4741),
    [anon_sym_LT_AMP] = ACTIONS(4741),
    [anon_sym_GT_AMP] = ACTIONS(4741),
    [anon_sym_LT_LT] = ACTIONS(4743),
    [anon_sym_LT_LT_DASH] = ACTIONS(4741),
    [anon_sym_LT_LT_LT] = ACTIONS(4741),
    [anon_sym_BQUOTE] = ACTIONS(4741),
    [sym_comment] = ACTIONS(53),
  },
  [2663] = {
    [sym_file_descriptor] = ACTIONS(4745),
    [sym__concat] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(4747),
    [anon_sym_RPAREN] = ACTIONS(4745),
    [anon_sym_PIPE_AMP] = ACTIONS(4745),
    [anon_sym_AMP_AMP] = ACTIONS(4745),
    [anon_sym_PIPE_PIPE] = ACTIONS(4745),
    [anon_sym_LT] = ACTIONS(4747),
    [anon_sym_GT] = ACTIONS(4747),
    [anon_sym_GT_GT] = ACTIONS(4745),
    [anon_sym_AMP_GT] = ACTIONS(4747),
    [anon_sym_AMP_GT_GT] = ACTIONS(4745),
    [anon_sym_LT_AMP] = ACTIONS(4745),
    [anon_sym_GT_AMP] = ACTIONS(4745),
    [anon_sym_LT_LT] = ACTIONS(4747),
    [anon_sym_LT_LT_DASH] = ACTIONS(4745),
    [anon_sym_LT_LT_LT] = ACTIONS(4745),
    [anon_sym_BQUOTE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(53),
  },
  [2664] = {
    [sym_file_descriptor] = ACTIONS(4749),
    [sym__concat] = ACTIONS(4749),
    [anon_sym_PIPE] = ACTIONS(4751),
    [anon_sym_RPAREN] = ACTIONS(4749),
    [anon_sym_PIPE_AMP] = ACTIONS(4749),
    [anon_sym_AMP_AMP] = ACTIONS(4749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4749),
    [anon_sym_LT] = ACTIONS(4751),
    [anon_sym_GT] = ACTIONS(4751),
    [anon_sym_GT_GT] = ACTIONS(4749),
    [anon_sym_AMP_GT] = ACTIONS(4751),
    [anon_sym_AMP_GT_GT] = ACTIONS(4749),
    [anon_sym_LT_AMP] = ACTIONS(4749),
    [anon_sym_GT_AMP] = ACTIONS(4749),
    [anon_sym_LT_LT] = ACTIONS(4751),
    [anon_sym_LT_LT_DASH] = ACTIONS(4749),
    [anon_sym_LT_LT_LT] = ACTIONS(4749),
    [anon_sym_BQUOTE] = ACTIONS(4749),
    [sym_comment] = ACTIONS(53),
  },
  [2665] = {
    [sym_file_descriptor] = ACTIONS(4753),
    [sym__concat] = ACTIONS(4753),
    [anon_sym_PIPE] = ACTIONS(4755),
    [anon_sym_RPAREN] = ACTIONS(4753),
    [anon_sym_PIPE_AMP] = ACTIONS(4753),
    [anon_sym_AMP_AMP] = ACTIONS(4753),
    [anon_sym_PIPE_PIPE] = ACTIONS(4753),
    [anon_sym_LT] = ACTIONS(4755),
    [anon_sym_GT] = ACTIONS(4755),
    [anon_sym_GT_GT] = ACTIONS(4753),
    [anon_sym_AMP_GT] = ACTIONS(4755),
    [anon_sym_AMP_GT_GT] = ACTIONS(4753),
    [anon_sym_LT_AMP] = ACTIONS(4753),
    [anon_sym_GT_AMP] = ACTIONS(4753),
    [anon_sym_LT_LT] = ACTIONS(4755),
    [anon_sym_LT_LT_DASH] = ACTIONS(4753),
    [anon_sym_LT_LT_LT] = ACTIONS(4753),
    [anon_sym_BQUOTE] = ACTIONS(4753),
    [sym_comment] = ACTIONS(53),
  },
  [2666] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6346),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2667] = {
    [sym_file_descriptor] = ACTIONS(4759),
    [sym__concat] = ACTIONS(4759),
    [anon_sym_PIPE] = ACTIONS(4761),
    [anon_sym_RPAREN] = ACTIONS(4759),
    [anon_sym_PIPE_AMP] = ACTIONS(4759),
    [anon_sym_AMP_AMP] = ACTIONS(4759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4759),
    [anon_sym_LT] = ACTIONS(4761),
    [anon_sym_GT] = ACTIONS(4761),
    [anon_sym_GT_GT] = ACTIONS(4759),
    [anon_sym_AMP_GT] = ACTIONS(4761),
    [anon_sym_AMP_GT_GT] = ACTIONS(4759),
    [anon_sym_LT_AMP] = ACTIONS(4759),
    [anon_sym_GT_AMP] = ACTIONS(4759),
    [anon_sym_LT_LT] = ACTIONS(4761),
    [anon_sym_LT_LT_DASH] = ACTIONS(4759),
    [anon_sym_LT_LT_LT] = ACTIONS(4759),
    [anon_sym_BQUOTE] = ACTIONS(4759),
    [sym_comment] = ACTIONS(53),
  },
  [2668] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6348),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2669] = {
    [sym_file_descriptor] = ACTIONS(4765),
    [sym__concat] = ACTIONS(4765),
    [anon_sym_PIPE] = ACTIONS(4767),
    [anon_sym_RPAREN] = ACTIONS(4765),
    [anon_sym_PIPE_AMP] = ACTIONS(4765),
    [anon_sym_AMP_AMP] = ACTIONS(4765),
    [anon_sym_PIPE_PIPE] = ACTIONS(4765),
    [anon_sym_LT] = ACTIONS(4767),
    [anon_sym_GT] = ACTIONS(4767),
    [anon_sym_GT_GT] = ACTIONS(4765),
    [anon_sym_AMP_GT] = ACTIONS(4767),
    [anon_sym_AMP_GT_GT] = ACTIONS(4765),
    [anon_sym_LT_AMP] = ACTIONS(4765),
    [anon_sym_GT_AMP] = ACTIONS(4765),
    [anon_sym_LT_LT] = ACTIONS(4767),
    [anon_sym_LT_LT_DASH] = ACTIONS(4765),
    [anon_sym_LT_LT_LT] = ACTIONS(4765),
    [anon_sym_BQUOTE] = ACTIONS(4765),
    [sym_comment] = ACTIONS(53),
  },
  [2670] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6350),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2671] = {
    [sym_file_descriptor] = ACTIONS(4771),
    [sym__concat] = ACTIONS(4771),
    [anon_sym_PIPE] = ACTIONS(4773),
    [anon_sym_RPAREN] = ACTIONS(4771),
    [anon_sym_PIPE_AMP] = ACTIONS(4771),
    [anon_sym_AMP_AMP] = ACTIONS(4771),
    [anon_sym_PIPE_PIPE] = ACTIONS(4771),
    [anon_sym_LT] = ACTIONS(4773),
    [anon_sym_GT] = ACTIONS(4773),
    [anon_sym_GT_GT] = ACTIONS(4771),
    [anon_sym_AMP_GT] = ACTIONS(4773),
    [anon_sym_AMP_GT_GT] = ACTIONS(4771),
    [anon_sym_LT_AMP] = ACTIONS(4771),
    [anon_sym_GT_AMP] = ACTIONS(4771),
    [anon_sym_LT_LT] = ACTIONS(4773),
    [anon_sym_LT_LT_DASH] = ACTIONS(4771),
    [anon_sym_LT_LT_LT] = ACTIONS(4771),
    [anon_sym_BQUOTE] = ACTIONS(4771),
    [sym_comment] = ACTIONS(53),
  },
  [2672] = {
    [sym_file_descriptor] = ACTIONS(4775),
    [sym__concat] = ACTIONS(4775),
    [anon_sym_PIPE] = ACTIONS(4777),
    [anon_sym_RPAREN] = ACTIONS(4775),
    [anon_sym_PIPE_AMP] = ACTIONS(4775),
    [anon_sym_AMP_AMP] = ACTIONS(4775),
    [anon_sym_PIPE_PIPE] = ACTIONS(4775),
    [anon_sym_LT] = ACTIONS(4777),
    [anon_sym_GT] = ACTIONS(4777),
    [anon_sym_GT_GT] = ACTIONS(4775),
    [anon_sym_AMP_GT] = ACTIONS(4777),
    [anon_sym_AMP_GT_GT] = ACTIONS(4775),
    [anon_sym_LT_AMP] = ACTIONS(4775),
    [anon_sym_GT_AMP] = ACTIONS(4775),
    [anon_sym_LT_LT] = ACTIONS(4777),
    [anon_sym_LT_LT_DASH] = ACTIONS(4775),
    [anon_sym_LT_LT_LT] = ACTIONS(4775),
    [anon_sym_BQUOTE] = ACTIONS(4775),
    [sym_comment] = ACTIONS(53),
  },
  [2673] = {
    [aux_sym_concatenation_repeat1] = STATE(2676),
    [sym__concat] = ACTIONS(6233),
    [anon_sym_esac] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2674] = {
    [aux_sym_concatenation_repeat1] = STATE(2676),
    [sym__concat] = ACTIONS(6233),
    [anon_sym_esac] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [2675] = {
    [sym_string] = STATE(2734),
    [sym_simple_expansion] = STATE(2734),
    [sym_string_expansion] = STATE(2734),
    [sym_expansion] = STATE(2734),
    [sym_command_substitution] = STATE(2734),
    [sym_process_substitution] = STATE(2734),
    [sym__special_characters] = ACTIONS(6352),
    [anon_sym_DQUOTE] = ACTIONS(6061),
    [anon_sym_DOLLAR] = ACTIONS(6063),
    [sym_raw_string] = ACTIONS(6352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6069),
    [anon_sym_BQUOTE] = ACTIONS(6071),
    [anon_sym_LT_LPAREN] = ACTIONS(6073),
    [anon_sym_GT_LPAREN] = ACTIONS(6073),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6352),
  },
  [2676] = {
    [aux_sym_concatenation_repeat1] = STATE(2735),
    [sym__concat] = ACTIONS(6233),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [2677] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [2678] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(6354),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2679] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_esac] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [2680] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [2681] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [2682] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(6356),
    [sym_comment] = ACTIONS(53),
  },
  [2683] = {
    [sym_concatenation] = STATE(2740),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2740),
    [anon_sym_RBRACE] = ACTIONS(6358),
    [anon_sym_EQ] = ACTIONS(6360),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6364),
    [anon_sym_COLON] = ACTIONS(6360),
    [anon_sym_COLON_QMARK] = ACTIONS(6360),
    [anon_sym_COLON_DASH] = ACTIONS(6360),
    [anon_sym_PERCENT] = ACTIONS(6360),
    [anon_sym_DASH] = ACTIONS(6360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2684] = {
    [sym_subscript] = STATE(2744),
    [sym_variable_name] = ACTIONS(6366),
    [anon_sym_DOLLAR] = ACTIONS(6368),
    [anon_sym_DASH] = ACTIONS(6368),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6370),
    [anon_sym_STAR] = ACTIONS(6368),
    [anon_sym_AT] = ACTIONS(6368),
    [anon_sym_QMARK] = ACTIONS(6368),
    [anon_sym_0] = ACTIONS(6372),
    [anon_sym__] = ACTIONS(6372),
  },
  [2685] = {
    [sym_concatenation] = STATE(2747),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2747),
    [anon_sym_RBRACE] = ACTIONS(6374),
    [anon_sym_EQ] = ACTIONS(6376),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6380),
    [anon_sym_COLON] = ACTIONS(6376),
    [anon_sym_COLON_QMARK] = ACTIONS(6376),
    [anon_sym_COLON_DASH] = ACTIONS(6376),
    [anon_sym_PERCENT] = ACTIONS(6376),
    [anon_sym_DASH] = ACTIONS(6376),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2686] = {
    [sym_concatenation] = STATE(2750),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2750),
    [anon_sym_RBRACE] = ACTIONS(6382),
    [anon_sym_EQ] = ACTIONS(6384),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6386),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6388),
    [anon_sym_COLON] = ACTIONS(6384),
    [anon_sym_COLON_QMARK] = ACTIONS(6384),
    [anon_sym_COLON_DASH] = ACTIONS(6384),
    [anon_sym_PERCENT] = ACTIONS(6384),
    [anon_sym_DASH] = ACTIONS(6384),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2687] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6390),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2688] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6390),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2689] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(6390),
    [sym_comment] = ACTIONS(53),
  },
  [2690] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(6390),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2691] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6392),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2692] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6392),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2693] = {
    [aux_sym_concatenation_repeat1] = STATE(2695),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_esac] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2694] = {
    [aux_sym_concatenation_repeat1] = STATE(2695),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_esac] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [2695] = {
    [aux_sym_concatenation_repeat1] = STATE(2753),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(3599),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [2696] = {
    [sym_variable_name] = ACTIONS(3337),
    [anon_sym_esac] = ACTIONS(3339),
    [anon_sym_PIPE] = ACTIONS(3339),
    [anon_sym_SEMI_SEMI] = ACTIONS(3339),
    [anon_sym_PIPE_AMP] = ACTIONS(3339),
    [anon_sym_AMP_AMP] = ACTIONS(3339),
    [anon_sym_PIPE_PIPE] = ACTIONS(3339),
    [sym__special_characters] = ACTIONS(3339),
    [anon_sym_DQUOTE] = ACTIONS(3339),
    [anon_sym_DOLLAR] = ACTIONS(3339),
    [sym_raw_string] = ACTIONS(3339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3339),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [anon_sym_LT_LPAREN] = ACTIONS(3339),
    [anon_sym_GT_LPAREN] = ACTIONS(3339),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3339),
    [sym_word] = ACTIONS(3339),
    [anon_sym_SEMI] = ACTIONS(3339),
    [anon_sym_LF] = ACTIONS(3337),
    [anon_sym_AMP] = ACTIONS(3339),
  },
  [2697] = {
    [sym__concat] = ACTIONS(3829),
    [sym_variable_name] = ACTIONS(3829),
    [anon_sym_esac] = ACTIONS(3831),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_SEMI_SEMI] = ACTIONS(3831),
    [anon_sym_PIPE_AMP] = ACTIONS(3831),
    [anon_sym_AMP_AMP] = ACTIONS(3831),
    [anon_sym_PIPE_PIPE] = ACTIONS(3831),
    [sym__special_characters] = ACTIONS(3831),
    [anon_sym_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [sym_raw_string] = ACTIONS(3831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3831),
    [anon_sym_BQUOTE] = ACTIONS(3831),
    [anon_sym_LT_LPAREN] = ACTIONS(3831),
    [anon_sym_GT_LPAREN] = ACTIONS(3831),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3831),
    [sym_word] = ACTIONS(3831),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_LF] = ACTIONS(3829),
    [anon_sym_AMP] = ACTIONS(3831),
  },
  [2698] = {
    [sym__concat] = ACTIONS(3835),
    [sym_variable_name] = ACTIONS(3835),
    [anon_sym_esac] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3837),
    [anon_sym_SEMI_SEMI] = ACTIONS(3837),
    [anon_sym_PIPE_AMP] = ACTIONS(3837),
    [anon_sym_AMP_AMP] = ACTIONS(3837),
    [anon_sym_PIPE_PIPE] = ACTIONS(3837),
    [sym__special_characters] = ACTIONS(3837),
    [anon_sym_DQUOTE] = ACTIONS(3837),
    [anon_sym_DOLLAR] = ACTIONS(3837),
    [sym_raw_string] = ACTIONS(3837),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3837),
    [anon_sym_BQUOTE] = ACTIONS(3837),
    [anon_sym_LT_LPAREN] = ACTIONS(3837),
    [anon_sym_GT_LPAREN] = ACTIONS(3837),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3837),
    [sym_word] = ACTIONS(3837),
    [anon_sym_SEMI] = ACTIONS(3837),
    [anon_sym_LF] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
  },
  [2699] = {
    [sym__concat] = ACTIONS(3920),
    [sym_variable_name] = ACTIONS(3920),
    [anon_sym_esac] = ACTIONS(3922),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_SEMI_SEMI] = ACTIONS(3922),
    [anon_sym_PIPE_AMP] = ACTIONS(3922),
    [anon_sym_AMP_AMP] = ACTIONS(3922),
    [anon_sym_PIPE_PIPE] = ACTIONS(3922),
    [sym__special_characters] = ACTIONS(3922),
    [anon_sym_DQUOTE] = ACTIONS(3922),
    [anon_sym_DOLLAR] = ACTIONS(3922),
    [sym_raw_string] = ACTIONS(3922),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3922),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3922),
    [anon_sym_BQUOTE] = ACTIONS(3922),
    [anon_sym_LT_LPAREN] = ACTIONS(3922),
    [anon_sym_GT_LPAREN] = ACTIONS(3922),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3922),
    [sym_word] = ACTIONS(3922),
    [anon_sym_SEMI] = ACTIONS(3922),
    [anon_sym_LF] = ACTIONS(3920),
    [anon_sym_AMP] = ACTIONS(3922),
  },
  [2700] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6394),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2701] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6396),
    [sym_comment] = ACTIONS(53),
  },
  [2702] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6398),
    [sym_comment] = ACTIONS(53),
  },
  [2703] = {
    [anon_sym_RBRACE] = ACTIONS(6398),
    [sym_comment] = ACTIONS(53),
  },
  [2704] = {
    [sym_concatenation] = STATE(2758),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2758),
    [anon_sym_RBRACE] = ACTIONS(6400),
    [anon_sym_EQ] = ACTIONS(6402),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6404),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6402),
    [anon_sym_COLON_QMARK] = ACTIONS(6402),
    [anon_sym_COLON_DASH] = ACTIONS(6402),
    [anon_sym_PERCENT] = ACTIONS(6402),
    [anon_sym_DASH] = ACTIONS(6402),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2705] = {
    [sym__concat] = ACTIONS(3936),
    [sym_variable_name] = ACTIONS(3936),
    [anon_sym_esac] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3938),
    [anon_sym_SEMI_SEMI] = ACTIONS(3938),
    [anon_sym_PIPE_AMP] = ACTIONS(3938),
    [anon_sym_AMP_AMP] = ACTIONS(3938),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [sym__special_characters] = ACTIONS(3938),
    [anon_sym_DQUOTE] = ACTIONS(3938),
    [anon_sym_DOLLAR] = ACTIONS(3938),
    [sym_raw_string] = ACTIONS(3938),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3938),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3938),
    [anon_sym_BQUOTE] = ACTIONS(3938),
    [anon_sym_LT_LPAREN] = ACTIONS(3938),
    [anon_sym_GT_LPAREN] = ACTIONS(3938),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3938),
    [sym_word] = ACTIONS(3938),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_LF] = ACTIONS(3936),
    [anon_sym_AMP] = ACTIONS(3938),
  },
  [2706] = {
    [sym_concatenation] = STATE(2760),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2760),
    [anon_sym_RBRACE] = ACTIONS(6406),
    [anon_sym_EQ] = ACTIONS(6408),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6408),
    [anon_sym_COLON_QMARK] = ACTIONS(6408),
    [anon_sym_COLON_DASH] = ACTIONS(6408),
    [anon_sym_PERCENT] = ACTIONS(6408),
    [anon_sym_DASH] = ACTIONS(6408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2707] = {
    [sym__concat] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3946),
    [anon_sym_esac] = ACTIONS(3948),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_SEMI_SEMI] = ACTIONS(3948),
    [anon_sym_PIPE_AMP] = ACTIONS(3948),
    [anon_sym_AMP_AMP] = ACTIONS(3948),
    [anon_sym_PIPE_PIPE] = ACTIONS(3948),
    [sym__special_characters] = ACTIONS(3948),
    [anon_sym_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3948),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3948),
    [anon_sym_BQUOTE] = ACTIONS(3948),
    [anon_sym_LT_LPAREN] = ACTIONS(3948),
    [anon_sym_GT_LPAREN] = ACTIONS(3948),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3948),
    [sym_word] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3948),
    [anon_sym_LF] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3948),
  },
  [2708] = {
    [sym_concatenation] = STATE(2762),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2762),
    [anon_sym_RBRACE] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(6414),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6416),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6414),
    [anon_sym_COLON_QMARK] = ACTIONS(6414),
    [anon_sym_COLON_DASH] = ACTIONS(6414),
    [anon_sym_PERCENT] = ACTIONS(6414),
    [anon_sym_DASH] = ACTIONS(6414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2709] = {
    [sym__concat] = ACTIONS(3956),
    [sym_variable_name] = ACTIONS(3956),
    [anon_sym_esac] = ACTIONS(3958),
    [anon_sym_PIPE] = ACTIONS(3958),
    [anon_sym_SEMI_SEMI] = ACTIONS(3958),
    [anon_sym_PIPE_AMP] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [sym__special_characters] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [sym_raw_string] = ACTIONS(3958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3958),
    [anon_sym_BQUOTE] = ACTIONS(3958),
    [anon_sym_LT_LPAREN] = ACTIONS(3958),
    [anon_sym_GT_LPAREN] = ACTIONS(3958),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3958),
    [sym_word] = ACTIONS(3958),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_LF] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
  },
  [2710] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6418),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2711] = {
    [sym__concat] = ACTIONS(3962),
    [sym_variable_name] = ACTIONS(3962),
    [anon_sym_esac] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_SEMI_SEMI] = ACTIONS(3964),
    [anon_sym_PIPE_AMP] = ACTIONS(3964),
    [anon_sym_AMP_AMP] = ACTIONS(3964),
    [anon_sym_PIPE_PIPE] = ACTIONS(3964),
    [sym__special_characters] = ACTIONS(3964),
    [anon_sym_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3964),
    [sym_raw_string] = ACTIONS(3964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3964),
    [anon_sym_BQUOTE] = ACTIONS(3964),
    [anon_sym_LT_LPAREN] = ACTIONS(3964),
    [anon_sym_GT_LPAREN] = ACTIONS(3964),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3964),
    [sym_word] = ACTIONS(3964),
    [anon_sym_SEMI] = ACTIONS(3964),
    [anon_sym_LF] = ACTIONS(3962),
    [anon_sym_AMP] = ACTIONS(3964),
  },
  [2712] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6420),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2713] = {
    [sym__concat] = ACTIONS(3829),
    [anon_sym_esac] = ACTIONS(3831),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_SEMI_SEMI] = ACTIONS(3831),
    [anon_sym_PIPE_AMP] = ACTIONS(3831),
    [anon_sym_AMP_AMP] = ACTIONS(3831),
    [anon_sym_PIPE_PIPE] = ACTIONS(3831),
    [sym__special_characters] = ACTIONS(3831),
    [anon_sym_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [sym_raw_string] = ACTIONS(3831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3831),
    [anon_sym_BQUOTE] = ACTIONS(3831),
    [anon_sym_LT_LPAREN] = ACTIONS(3831),
    [anon_sym_GT_LPAREN] = ACTIONS(3831),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3831),
    [sym_word] = ACTIONS(3831),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_LF] = ACTIONS(3829),
    [anon_sym_AMP] = ACTIONS(3831),
  },
  [2714] = {
    [sym__concat] = ACTIONS(3835),
    [anon_sym_esac] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3837),
    [anon_sym_SEMI_SEMI] = ACTIONS(3837),
    [anon_sym_PIPE_AMP] = ACTIONS(3837),
    [anon_sym_AMP_AMP] = ACTIONS(3837),
    [anon_sym_PIPE_PIPE] = ACTIONS(3837),
    [sym__special_characters] = ACTIONS(3837),
    [anon_sym_DQUOTE] = ACTIONS(3837),
    [anon_sym_DOLLAR] = ACTIONS(3837),
    [sym_raw_string] = ACTIONS(3837),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3837),
    [anon_sym_BQUOTE] = ACTIONS(3837),
    [anon_sym_LT_LPAREN] = ACTIONS(3837),
    [anon_sym_GT_LPAREN] = ACTIONS(3837),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3837),
    [sym_word] = ACTIONS(3837),
    [anon_sym_SEMI] = ACTIONS(3837),
    [anon_sym_LF] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
  },
  [2715] = {
    [sym__concat] = ACTIONS(3920),
    [anon_sym_esac] = ACTIONS(3922),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_SEMI_SEMI] = ACTIONS(3922),
    [anon_sym_PIPE_AMP] = ACTIONS(3922),
    [anon_sym_AMP_AMP] = ACTIONS(3922),
    [anon_sym_PIPE_PIPE] = ACTIONS(3922),
    [sym__special_characters] = ACTIONS(3922),
    [anon_sym_DQUOTE] = ACTIONS(3922),
    [anon_sym_DOLLAR] = ACTIONS(3922),
    [sym_raw_string] = ACTIONS(3922),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3922),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3922),
    [anon_sym_BQUOTE] = ACTIONS(3922),
    [anon_sym_LT_LPAREN] = ACTIONS(3922),
    [anon_sym_GT_LPAREN] = ACTIONS(3922),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3922),
    [sym_word] = ACTIONS(3922),
    [anon_sym_SEMI] = ACTIONS(3922),
    [anon_sym_LF] = ACTIONS(3920),
    [anon_sym_AMP] = ACTIONS(3922),
  },
  [2716] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6422),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2717] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6424),
    [sym_comment] = ACTIONS(53),
  },
  [2718] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6426),
    [sym_comment] = ACTIONS(53),
  },
  [2719] = {
    [anon_sym_RBRACE] = ACTIONS(6426),
    [sym_comment] = ACTIONS(53),
  },
  [2720] = {
    [sym_concatenation] = STATE(2769),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2769),
    [anon_sym_RBRACE] = ACTIONS(6428),
    [anon_sym_EQ] = ACTIONS(6430),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6432),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_COLON_QMARK] = ACTIONS(6430),
    [anon_sym_COLON_DASH] = ACTIONS(6430),
    [anon_sym_PERCENT] = ACTIONS(6430),
    [anon_sym_DASH] = ACTIONS(6430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2721] = {
    [sym__concat] = ACTIONS(3936),
    [anon_sym_esac] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3938),
    [anon_sym_SEMI_SEMI] = ACTIONS(3938),
    [anon_sym_PIPE_AMP] = ACTIONS(3938),
    [anon_sym_AMP_AMP] = ACTIONS(3938),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [sym__special_characters] = ACTIONS(3938),
    [anon_sym_DQUOTE] = ACTIONS(3938),
    [anon_sym_DOLLAR] = ACTIONS(3938),
    [sym_raw_string] = ACTIONS(3938),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3938),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3938),
    [anon_sym_BQUOTE] = ACTIONS(3938),
    [anon_sym_LT_LPAREN] = ACTIONS(3938),
    [anon_sym_GT_LPAREN] = ACTIONS(3938),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3938),
    [sym_word] = ACTIONS(3938),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_LF] = ACTIONS(3936),
    [anon_sym_AMP] = ACTIONS(3938),
  },
  [2722] = {
    [sym_concatenation] = STATE(2771),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2771),
    [anon_sym_RBRACE] = ACTIONS(6434),
    [anon_sym_EQ] = ACTIONS(6436),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6438),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6436),
    [anon_sym_COLON_QMARK] = ACTIONS(6436),
    [anon_sym_COLON_DASH] = ACTIONS(6436),
    [anon_sym_PERCENT] = ACTIONS(6436),
    [anon_sym_DASH] = ACTIONS(6436),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2723] = {
    [sym__concat] = ACTIONS(3946),
    [anon_sym_esac] = ACTIONS(3948),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_SEMI_SEMI] = ACTIONS(3948),
    [anon_sym_PIPE_AMP] = ACTIONS(3948),
    [anon_sym_AMP_AMP] = ACTIONS(3948),
    [anon_sym_PIPE_PIPE] = ACTIONS(3948),
    [sym__special_characters] = ACTIONS(3948),
    [anon_sym_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3948),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3948),
    [anon_sym_BQUOTE] = ACTIONS(3948),
    [anon_sym_LT_LPAREN] = ACTIONS(3948),
    [anon_sym_GT_LPAREN] = ACTIONS(3948),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3948),
    [sym_word] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3948),
    [anon_sym_LF] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3948),
  },
  [2724] = {
    [sym_concatenation] = STATE(2773),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2773),
    [anon_sym_RBRACE] = ACTIONS(6440),
    [anon_sym_EQ] = ACTIONS(6442),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6442),
    [anon_sym_COLON_QMARK] = ACTIONS(6442),
    [anon_sym_COLON_DASH] = ACTIONS(6442),
    [anon_sym_PERCENT] = ACTIONS(6442),
    [anon_sym_DASH] = ACTIONS(6442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2725] = {
    [sym__concat] = ACTIONS(3956),
    [anon_sym_esac] = ACTIONS(3958),
    [anon_sym_PIPE] = ACTIONS(3958),
    [anon_sym_SEMI_SEMI] = ACTIONS(3958),
    [anon_sym_PIPE_AMP] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [sym__special_characters] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [sym_raw_string] = ACTIONS(3958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3958),
    [anon_sym_BQUOTE] = ACTIONS(3958),
    [anon_sym_LT_LPAREN] = ACTIONS(3958),
    [anon_sym_GT_LPAREN] = ACTIONS(3958),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3958),
    [sym_word] = ACTIONS(3958),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_LF] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
  },
  [2726] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6446),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2727] = {
    [sym__concat] = ACTIONS(3962),
    [anon_sym_esac] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_SEMI_SEMI] = ACTIONS(3964),
    [anon_sym_PIPE_AMP] = ACTIONS(3964),
    [anon_sym_AMP_AMP] = ACTIONS(3964),
    [anon_sym_PIPE_PIPE] = ACTIONS(3964),
    [sym__special_characters] = ACTIONS(3964),
    [anon_sym_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3964),
    [sym_raw_string] = ACTIONS(3964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3964),
    [anon_sym_BQUOTE] = ACTIONS(3964),
    [anon_sym_LT_LPAREN] = ACTIONS(3964),
    [anon_sym_GT_LPAREN] = ACTIONS(3964),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3964),
    [sym_word] = ACTIONS(3964),
    [anon_sym_SEMI] = ACTIONS(3964),
    [anon_sym_LF] = ACTIONS(3962),
    [anon_sym_AMP] = ACTIONS(3964),
  },
  [2728] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6448),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2729] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(6177),
    [anon_sym_DQUOTE] = ACTIONS(6179),
    [anon_sym_DOLLAR] = ACTIONS(6177),
    [sym_raw_string] = ACTIONS(6179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6179),
    [anon_sym_BQUOTE] = ACTIONS(6179),
    [anon_sym_LT_LPAREN] = ACTIONS(6179),
    [anon_sym_GT_LPAREN] = ACTIONS(6179),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6177),
  },
  [2730] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(6183),
    [anon_sym_DQUOTE] = ACTIONS(6185),
    [anon_sym_DOLLAR] = ACTIONS(6183),
    [sym_raw_string] = ACTIONS(6185),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6185),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6185),
    [anon_sym_BQUOTE] = ACTIONS(6185),
    [anon_sym_LT_LPAREN] = ACTIONS(6185),
    [anon_sym_GT_LPAREN] = ACTIONS(6185),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6183),
  },
  [2731] = {
    [sym_file_descriptor] = ACTIONS(5325),
    [sym__concat] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [anon_sym_PIPE_AMP] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_GT_GT] = ACTIONS(5325),
    [anon_sym_AMP_GT] = ACTIONS(5327),
    [anon_sym_AMP_GT_GT] = ACTIONS(5325),
    [anon_sym_LT_AMP] = ACTIONS(5325),
    [anon_sym_GT_AMP] = ACTIONS(5325),
    [anon_sym_LT_LT] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5325),
    [anon_sym_LT_LT_LT] = ACTIONS(5325),
    [anon_sym_BQUOTE] = ACTIONS(5325),
    [sym_comment] = ACTIONS(53),
  },
  [2732] = {
    [sym_file_descriptor] = ACTIONS(5329),
    [sym__concat] = ACTIONS(5329),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5329),
    [anon_sym_PIPE_AMP] = ACTIONS(5329),
    [anon_sym_AMP_AMP] = ACTIONS(5329),
    [anon_sym_PIPE_PIPE] = ACTIONS(5329),
    [anon_sym_LT] = ACTIONS(5331),
    [anon_sym_GT] = ACTIONS(5331),
    [anon_sym_GT_GT] = ACTIONS(5329),
    [anon_sym_AMP_GT] = ACTIONS(5331),
    [anon_sym_AMP_GT_GT] = ACTIONS(5329),
    [anon_sym_LT_AMP] = ACTIONS(5329),
    [anon_sym_GT_AMP] = ACTIONS(5329),
    [anon_sym_LT_LT] = ACTIONS(5331),
    [anon_sym_LT_LT_DASH] = ACTIONS(5329),
    [anon_sym_LT_LT_LT] = ACTIONS(5329),
    [anon_sym_BQUOTE] = ACTIONS(5329),
    [sym_comment] = ACTIONS(53),
  },
  [2733] = {
    [sym_file_descriptor] = ACTIONS(5333),
    [sym__concat] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_RPAREN] = ACTIONS(5333),
    [anon_sym_PIPE_AMP] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_GT] = ACTIONS(5333),
    [anon_sym_AMP_GT] = ACTIONS(5335),
    [anon_sym_AMP_GT_GT] = ACTIONS(5333),
    [anon_sym_LT_AMP] = ACTIONS(5333),
    [anon_sym_GT_AMP] = ACTIONS(5333),
    [anon_sym_LT_LT] = ACTIONS(5335),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_LT] = ACTIONS(5333),
    [anon_sym_BQUOTE] = ACTIONS(5333),
    [sym_comment] = ACTIONS(53),
  },
  [2734] = {
    [sym__concat] = ACTIONS(1642),
    [anon_sym_esac] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [2735] = {
    [aux_sym_concatenation_repeat1] = STATE(2735),
    [sym__concat] = ACTIONS(6450),
    [anon_sym_esac] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [2736] = {
    [sym__concat] = ACTIONS(1691),
    [anon_sym_esac] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_SEMI_SEMI] = ACTIONS(1693),
    [anon_sym_PIPE_AMP] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1693),
    [anon_sym_LF] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1693),
  },
  [2737] = {
    [sym_concatenation] = STATE(2779),
    [sym_string] = STATE(2778),
    [sym_simple_expansion] = STATE(2778),
    [sym_string_expansion] = STATE(2778),
    [sym_expansion] = STATE(2778),
    [sym_command_substitution] = STATE(2778),
    [sym_process_substitution] = STATE(2778),
    [anon_sym_RBRACE] = ACTIONS(6453),
    [sym__special_characters] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(6457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6457),
  },
  [2738] = {
    [sym__concat] = ACTIONS(1732),
    [anon_sym_esac] = ACTIONS(1734),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_SEMI_SEMI] = ACTIONS(1734),
    [anon_sym_PIPE_AMP] = ACTIONS(1734),
    [anon_sym_AMP_AMP] = ACTIONS(1734),
    [anon_sym_PIPE_PIPE] = ACTIONS(1734),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_LF] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1734),
  },
  [2739] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6459),
  },
  [2740] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6461),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2741] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(6463),
    [sym_comment] = ACTIONS(53),
  },
  [2742] = {
    [sym_concatenation] = STATE(2785),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2785),
    [anon_sym_RBRACE] = ACTIONS(6465),
    [anon_sym_EQ] = ACTIONS(6467),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6471),
    [anon_sym_COLON] = ACTIONS(6467),
    [anon_sym_COLON_QMARK] = ACTIONS(6467),
    [anon_sym_COLON_DASH] = ACTIONS(6467),
    [anon_sym_PERCENT] = ACTIONS(6467),
    [anon_sym_DASH] = ACTIONS(6467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2743] = {
    [sym_concatenation] = STATE(2788),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2788),
    [anon_sym_RBRACE] = ACTIONS(6473),
    [anon_sym_EQ] = ACTIONS(6475),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6477),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6479),
    [anon_sym_COLON] = ACTIONS(6475),
    [anon_sym_COLON_QMARK] = ACTIONS(6475),
    [anon_sym_COLON_DASH] = ACTIONS(6475),
    [anon_sym_PERCENT] = ACTIONS(6475),
    [anon_sym_DASH] = ACTIONS(6475),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2744] = {
    [sym_concatenation] = STATE(2790),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2790),
    [anon_sym_RBRACE] = ACTIONS(6453),
    [anon_sym_EQ] = ACTIONS(6481),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6485),
    [anon_sym_COLON] = ACTIONS(6481),
    [anon_sym_COLON_QMARK] = ACTIONS(6481),
    [anon_sym_COLON_DASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [anon_sym_DASH] = ACTIONS(6481),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2745] = {
    [sym__concat] = ACTIONS(1798),
    [anon_sym_esac] = ACTIONS(1800),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_SEMI_SEMI] = ACTIONS(1800),
    [anon_sym_PIPE_AMP] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(1800),
    [anon_sym_PIPE_PIPE] = ACTIONS(1800),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1800),
    [anon_sym_LF] = ACTIONS(1798),
    [anon_sym_AMP] = ACTIONS(1800),
  },
  [2746] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6487),
  },
  [2747] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6489),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2748] = {
    [sym__concat] = ACTIONS(1806),
    [anon_sym_esac] = ACTIONS(1808),
    [anon_sym_PIPE] = ACTIONS(1808),
    [anon_sym_SEMI_SEMI] = ACTIONS(1808),
    [anon_sym_PIPE_AMP] = ACTIONS(1808),
    [anon_sym_AMP_AMP] = ACTIONS(1808),
    [anon_sym_PIPE_PIPE] = ACTIONS(1808),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1808),
    [anon_sym_LF] = ACTIONS(1806),
    [anon_sym_AMP] = ACTIONS(1808),
  },
  [2749] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6491),
  },
  [2750] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6453),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2751] = {
    [sym__concat] = ACTIONS(1940),
    [anon_sym_esac] = ACTIONS(1942),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_SEMI_SEMI] = ACTIONS(1942),
    [anon_sym_PIPE_AMP] = ACTIONS(1942),
    [anon_sym_AMP_AMP] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1942),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1942),
  },
  [2752] = {
    [sym__concat] = ACTIONS(2006),
    [anon_sym_esac] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2008),
  },
  [2753] = {
    [aux_sym_concatenation_repeat1] = STATE(2753),
    [sym_file_descriptor] = ACTIONS(1642),
    [sym__concat] = ACTIONS(5184),
    [anon_sym_esac] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE_AMP] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1644),
    [anon_sym_PIPE_PIPE] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1644),
    [anon_sym_LT_LT_DASH] = ACTIONS(1644),
    [anon_sym_LT_LT_LT] = ACTIONS(1644),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [2754] = {
    [sym__concat] = ACTIONS(4741),
    [sym_variable_name] = ACTIONS(4741),
    [anon_sym_esac] = ACTIONS(4743),
    [anon_sym_PIPE] = ACTIONS(4743),
    [anon_sym_SEMI_SEMI] = ACTIONS(4743),
    [anon_sym_PIPE_AMP] = ACTIONS(4743),
    [anon_sym_AMP_AMP] = ACTIONS(4743),
    [anon_sym_PIPE_PIPE] = ACTIONS(4743),
    [sym__special_characters] = ACTIONS(4743),
    [anon_sym_DQUOTE] = ACTIONS(4743),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [sym_raw_string] = ACTIONS(4743),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4743),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [anon_sym_LT_LPAREN] = ACTIONS(4743),
    [anon_sym_GT_LPAREN] = ACTIONS(4743),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4743),
    [sym_word] = ACTIONS(4743),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_LF] = ACTIONS(4741),
    [anon_sym_AMP] = ACTIONS(4743),
  },
  [2755] = {
    [sym__concat] = ACTIONS(4745),
    [sym_variable_name] = ACTIONS(4745),
    [anon_sym_esac] = ACTIONS(4747),
    [anon_sym_PIPE] = ACTIONS(4747),
    [anon_sym_SEMI_SEMI] = ACTIONS(4747),
    [anon_sym_PIPE_AMP] = ACTIONS(4747),
    [anon_sym_AMP_AMP] = ACTIONS(4747),
    [anon_sym_PIPE_PIPE] = ACTIONS(4747),
    [sym__special_characters] = ACTIONS(4747),
    [anon_sym_DQUOTE] = ACTIONS(4747),
    [anon_sym_DOLLAR] = ACTIONS(4747),
    [sym_raw_string] = ACTIONS(4747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4747),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4747),
    [anon_sym_BQUOTE] = ACTIONS(4747),
    [anon_sym_LT_LPAREN] = ACTIONS(4747),
    [anon_sym_GT_LPAREN] = ACTIONS(4747),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4747),
    [sym_word] = ACTIONS(4747),
    [anon_sym_SEMI] = ACTIONS(4747),
    [anon_sym_LF] = ACTIONS(4745),
    [anon_sym_AMP] = ACTIONS(4747),
  },
  [2756] = {
    [sym__concat] = ACTIONS(4749),
    [sym_variable_name] = ACTIONS(4749),
    [anon_sym_esac] = ACTIONS(4751),
    [anon_sym_PIPE] = ACTIONS(4751),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4751),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4751),
    [sym_word] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4751),
    [anon_sym_LF] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(4751),
  },
  [2757] = {
    [sym__concat] = ACTIONS(4753),
    [sym_variable_name] = ACTIONS(4753),
    [anon_sym_esac] = ACTIONS(4755),
    [anon_sym_PIPE] = ACTIONS(4755),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4755),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4755),
    [sym_word] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_LF] = ACTIONS(4753),
    [anon_sym_AMP] = ACTIONS(4755),
  },
  [2758] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6493),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2759] = {
    [sym__concat] = ACTIONS(4759),
    [sym_variable_name] = ACTIONS(4759),
    [anon_sym_esac] = ACTIONS(4761),
    [anon_sym_PIPE] = ACTIONS(4761),
    [anon_sym_SEMI_SEMI] = ACTIONS(4761),
    [anon_sym_PIPE_AMP] = ACTIONS(4761),
    [anon_sym_AMP_AMP] = ACTIONS(4761),
    [anon_sym_PIPE_PIPE] = ACTIONS(4761),
    [sym__special_characters] = ACTIONS(4761),
    [anon_sym_DQUOTE] = ACTIONS(4761),
    [anon_sym_DOLLAR] = ACTIONS(4761),
    [sym_raw_string] = ACTIONS(4761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4761),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4761),
    [anon_sym_BQUOTE] = ACTIONS(4761),
    [anon_sym_LT_LPAREN] = ACTIONS(4761),
    [anon_sym_GT_LPAREN] = ACTIONS(4761),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4761),
    [sym_word] = ACTIONS(4761),
    [anon_sym_SEMI] = ACTIONS(4761),
    [anon_sym_LF] = ACTIONS(4759),
    [anon_sym_AMP] = ACTIONS(4761),
  },
  [2760] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6495),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2761] = {
    [sym__concat] = ACTIONS(4765),
    [sym_variable_name] = ACTIONS(4765),
    [anon_sym_esac] = ACTIONS(4767),
    [anon_sym_PIPE] = ACTIONS(4767),
    [anon_sym_SEMI_SEMI] = ACTIONS(4767),
    [anon_sym_PIPE_AMP] = ACTIONS(4767),
    [anon_sym_AMP_AMP] = ACTIONS(4767),
    [anon_sym_PIPE_PIPE] = ACTIONS(4767),
    [sym__special_characters] = ACTIONS(4767),
    [anon_sym_DQUOTE] = ACTIONS(4767),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [sym_raw_string] = ACTIONS(4767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4767),
    [anon_sym_BQUOTE] = ACTIONS(4767),
    [anon_sym_LT_LPAREN] = ACTIONS(4767),
    [anon_sym_GT_LPAREN] = ACTIONS(4767),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4767),
    [sym_word] = ACTIONS(4767),
    [anon_sym_SEMI] = ACTIONS(4767),
    [anon_sym_LF] = ACTIONS(4765),
    [anon_sym_AMP] = ACTIONS(4767),
  },
  [2762] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6497),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2763] = {
    [sym__concat] = ACTIONS(4771),
    [sym_variable_name] = ACTIONS(4771),
    [anon_sym_esac] = ACTIONS(4773),
    [anon_sym_PIPE] = ACTIONS(4773),
    [anon_sym_SEMI_SEMI] = ACTIONS(4773),
    [anon_sym_PIPE_AMP] = ACTIONS(4773),
    [anon_sym_AMP_AMP] = ACTIONS(4773),
    [anon_sym_PIPE_PIPE] = ACTIONS(4773),
    [sym__special_characters] = ACTIONS(4773),
    [anon_sym_DQUOTE] = ACTIONS(4773),
    [anon_sym_DOLLAR] = ACTIONS(4773),
    [sym_raw_string] = ACTIONS(4773),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4773),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4773),
    [anon_sym_BQUOTE] = ACTIONS(4773),
    [anon_sym_LT_LPAREN] = ACTIONS(4773),
    [anon_sym_GT_LPAREN] = ACTIONS(4773),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4773),
    [sym_word] = ACTIONS(4773),
    [anon_sym_SEMI] = ACTIONS(4773),
    [anon_sym_LF] = ACTIONS(4771),
    [anon_sym_AMP] = ACTIONS(4773),
  },
  [2764] = {
    [sym__concat] = ACTIONS(4775),
    [sym_variable_name] = ACTIONS(4775),
    [anon_sym_esac] = ACTIONS(4777),
    [anon_sym_PIPE] = ACTIONS(4777),
    [anon_sym_SEMI_SEMI] = ACTIONS(4777),
    [anon_sym_PIPE_AMP] = ACTIONS(4777),
    [anon_sym_AMP_AMP] = ACTIONS(4777),
    [anon_sym_PIPE_PIPE] = ACTIONS(4777),
    [sym__special_characters] = ACTIONS(4777),
    [anon_sym_DQUOTE] = ACTIONS(4777),
    [anon_sym_DOLLAR] = ACTIONS(4777),
    [sym_raw_string] = ACTIONS(4777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4777),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4777),
    [anon_sym_BQUOTE] = ACTIONS(4777),
    [anon_sym_LT_LPAREN] = ACTIONS(4777),
    [anon_sym_GT_LPAREN] = ACTIONS(4777),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4777),
    [sym_word] = ACTIONS(4777),
    [anon_sym_SEMI] = ACTIONS(4777),
    [anon_sym_LF] = ACTIONS(4775),
    [anon_sym_AMP] = ACTIONS(4777),
  },
  [2765] = {
    [sym__concat] = ACTIONS(4741),
    [anon_sym_esac] = ACTIONS(4743),
    [anon_sym_PIPE] = ACTIONS(4743),
    [anon_sym_SEMI_SEMI] = ACTIONS(4743),
    [anon_sym_PIPE_AMP] = ACTIONS(4743),
    [anon_sym_AMP_AMP] = ACTIONS(4743),
    [anon_sym_PIPE_PIPE] = ACTIONS(4743),
    [sym__special_characters] = ACTIONS(4743),
    [anon_sym_DQUOTE] = ACTIONS(4743),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [sym_raw_string] = ACTIONS(4743),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4743),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [anon_sym_LT_LPAREN] = ACTIONS(4743),
    [anon_sym_GT_LPAREN] = ACTIONS(4743),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4743),
    [sym_word] = ACTIONS(4743),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_LF] = ACTIONS(4741),
    [anon_sym_AMP] = ACTIONS(4743),
  },
  [2766] = {
    [sym__concat] = ACTIONS(4745),
    [anon_sym_esac] = ACTIONS(4747),
    [anon_sym_PIPE] = ACTIONS(4747),
    [anon_sym_SEMI_SEMI] = ACTIONS(4747),
    [anon_sym_PIPE_AMP] = ACTIONS(4747),
    [anon_sym_AMP_AMP] = ACTIONS(4747),
    [anon_sym_PIPE_PIPE] = ACTIONS(4747),
    [sym__special_characters] = ACTIONS(4747),
    [anon_sym_DQUOTE] = ACTIONS(4747),
    [anon_sym_DOLLAR] = ACTIONS(4747),
    [sym_raw_string] = ACTIONS(4747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4747),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4747),
    [anon_sym_BQUOTE] = ACTIONS(4747),
    [anon_sym_LT_LPAREN] = ACTIONS(4747),
    [anon_sym_GT_LPAREN] = ACTIONS(4747),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4747),
    [sym_word] = ACTIONS(4747),
    [anon_sym_SEMI] = ACTIONS(4747),
    [anon_sym_LF] = ACTIONS(4745),
    [anon_sym_AMP] = ACTIONS(4747),
  },
  [2767] = {
    [sym__concat] = ACTIONS(4749),
    [anon_sym_esac] = ACTIONS(4751),
    [anon_sym_PIPE] = ACTIONS(4751),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [sym__special_characters] = ACTIONS(4751),
    [anon_sym_DQUOTE] = ACTIONS(4751),
    [anon_sym_DOLLAR] = ACTIONS(4751),
    [sym_raw_string] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_LT_LPAREN] = ACTIONS(4751),
    [anon_sym_GT_LPAREN] = ACTIONS(4751),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4751),
    [sym_word] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(4751),
    [anon_sym_LF] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(4751),
  },
  [2768] = {
    [sym__concat] = ACTIONS(4753),
    [anon_sym_esac] = ACTIONS(4755),
    [anon_sym_PIPE] = ACTIONS(4755),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_DOLLAR] = ACTIONS(4755),
    [sym_raw_string] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_LT_LPAREN] = ACTIONS(4755),
    [anon_sym_GT_LPAREN] = ACTIONS(4755),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4755),
    [sym_word] = ACTIONS(4755),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_LF] = ACTIONS(4753),
    [anon_sym_AMP] = ACTIONS(4755),
  },
  [2769] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6499),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2770] = {
    [sym__concat] = ACTIONS(4759),
    [anon_sym_esac] = ACTIONS(4761),
    [anon_sym_PIPE] = ACTIONS(4761),
    [anon_sym_SEMI_SEMI] = ACTIONS(4761),
    [anon_sym_PIPE_AMP] = ACTIONS(4761),
    [anon_sym_AMP_AMP] = ACTIONS(4761),
    [anon_sym_PIPE_PIPE] = ACTIONS(4761),
    [sym__special_characters] = ACTIONS(4761),
    [anon_sym_DQUOTE] = ACTIONS(4761),
    [anon_sym_DOLLAR] = ACTIONS(4761),
    [sym_raw_string] = ACTIONS(4761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4761),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4761),
    [anon_sym_BQUOTE] = ACTIONS(4761),
    [anon_sym_LT_LPAREN] = ACTIONS(4761),
    [anon_sym_GT_LPAREN] = ACTIONS(4761),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4761),
    [sym_word] = ACTIONS(4761),
    [anon_sym_SEMI] = ACTIONS(4761),
    [anon_sym_LF] = ACTIONS(4759),
    [anon_sym_AMP] = ACTIONS(4761),
  },
  [2771] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6501),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2772] = {
    [sym__concat] = ACTIONS(4765),
    [anon_sym_esac] = ACTIONS(4767),
    [anon_sym_PIPE] = ACTIONS(4767),
    [anon_sym_SEMI_SEMI] = ACTIONS(4767),
    [anon_sym_PIPE_AMP] = ACTIONS(4767),
    [anon_sym_AMP_AMP] = ACTIONS(4767),
    [anon_sym_PIPE_PIPE] = ACTIONS(4767),
    [sym__special_characters] = ACTIONS(4767),
    [anon_sym_DQUOTE] = ACTIONS(4767),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [sym_raw_string] = ACTIONS(4767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4767),
    [anon_sym_BQUOTE] = ACTIONS(4767),
    [anon_sym_LT_LPAREN] = ACTIONS(4767),
    [anon_sym_GT_LPAREN] = ACTIONS(4767),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4767),
    [sym_word] = ACTIONS(4767),
    [anon_sym_SEMI] = ACTIONS(4767),
    [anon_sym_LF] = ACTIONS(4765),
    [anon_sym_AMP] = ACTIONS(4767),
  },
  [2773] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6503),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2774] = {
    [sym__concat] = ACTIONS(4771),
    [anon_sym_esac] = ACTIONS(4773),
    [anon_sym_PIPE] = ACTIONS(4773),
    [anon_sym_SEMI_SEMI] = ACTIONS(4773),
    [anon_sym_PIPE_AMP] = ACTIONS(4773),
    [anon_sym_AMP_AMP] = ACTIONS(4773),
    [anon_sym_PIPE_PIPE] = ACTIONS(4773),
    [sym__special_characters] = ACTIONS(4773),
    [anon_sym_DQUOTE] = ACTIONS(4773),
    [anon_sym_DOLLAR] = ACTIONS(4773),
    [sym_raw_string] = ACTIONS(4773),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4773),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4773),
    [anon_sym_BQUOTE] = ACTIONS(4773),
    [anon_sym_LT_LPAREN] = ACTIONS(4773),
    [anon_sym_GT_LPAREN] = ACTIONS(4773),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4773),
    [sym_word] = ACTIONS(4773),
    [anon_sym_SEMI] = ACTIONS(4773),
    [anon_sym_LF] = ACTIONS(4771),
    [anon_sym_AMP] = ACTIONS(4773),
  },
  [2775] = {
    [sym__concat] = ACTIONS(4775),
    [anon_sym_esac] = ACTIONS(4777),
    [anon_sym_PIPE] = ACTIONS(4777),
    [anon_sym_SEMI_SEMI] = ACTIONS(4777),
    [anon_sym_PIPE_AMP] = ACTIONS(4777),
    [anon_sym_AMP_AMP] = ACTIONS(4777),
    [anon_sym_PIPE_PIPE] = ACTIONS(4777),
    [sym__special_characters] = ACTIONS(4777),
    [anon_sym_DQUOTE] = ACTIONS(4777),
    [anon_sym_DOLLAR] = ACTIONS(4777),
    [sym_raw_string] = ACTIONS(4777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4777),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4777),
    [anon_sym_BQUOTE] = ACTIONS(4777),
    [anon_sym_LT_LPAREN] = ACTIONS(4777),
    [anon_sym_GT_LPAREN] = ACTIONS(4777),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4777),
    [sym_word] = ACTIONS(4777),
    [anon_sym_SEMI] = ACTIONS(4777),
    [anon_sym_LF] = ACTIONS(4775),
    [anon_sym_AMP] = ACTIONS(4777),
  },
  [2776] = {
    [sym__concat] = ACTIONS(2710),
    [anon_sym_esac] = ACTIONS(2712),
    [anon_sym_PIPE] = ACTIONS(2712),
    [anon_sym_SEMI_SEMI] = ACTIONS(2712),
    [anon_sym_PIPE_AMP] = ACTIONS(2712),
    [anon_sym_AMP_AMP] = ACTIONS(2712),
    [anon_sym_PIPE_PIPE] = ACTIONS(2712),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_LF] = ACTIONS(2710),
    [anon_sym_AMP] = ACTIONS(2712),
  },
  [2777] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6505),
    [sym_comment] = ACTIONS(53),
  },
  [2778] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6507),
    [sym_comment] = ACTIONS(53),
  },
  [2779] = {
    [anon_sym_RBRACE] = ACTIONS(6507),
    [sym_comment] = ACTIONS(53),
  },
  [2780] = {
    [sym_concatenation] = STATE(2803),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2803),
    [anon_sym_RBRACE] = ACTIONS(6509),
    [anon_sym_EQ] = ACTIONS(6511),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6511),
    [anon_sym_COLON_QMARK] = ACTIONS(6511),
    [anon_sym_COLON_DASH] = ACTIONS(6511),
    [anon_sym_PERCENT] = ACTIONS(6511),
    [anon_sym_DASH] = ACTIONS(6511),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2781] = {
    [sym__concat] = ACTIONS(2788),
    [anon_sym_esac] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_SEMI_SEMI] = ACTIONS(2790),
    [anon_sym_PIPE_AMP] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2790),
    [anon_sym_PIPE_PIPE] = ACTIONS(2790),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_LF] = ACTIONS(2788),
    [anon_sym_AMP] = ACTIONS(2790),
  },
  [2782] = {
    [sym_concatenation] = STATE(2806),
    [sym_string] = STATE(2805),
    [sym_simple_expansion] = STATE(2805),
    [sym_string_expansion] = STATE(2805),
    [sym_expansion] = STATE(2805),
    [sym_command_substitution] = STATE(2805),
    [sym_process_substitution] = STATE(2805),
    [anon_sym_RBRACE] = ACTIONS(6507),
    [sym__special_characters] = ACTIONS(6515),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1720),
    [sym_raw_string] = ACTIONS(6517),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(1730),
    [anon_sym_GT_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6517),
  },
  [2783] = {
    [sym__concat] = ACTIONS(2831),
    [anon_sym_esac] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_SEMI_SEMI] = ACTIONS(2833),
    [anon_sym_PIPE_AMP] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2831),
    [anon_sym_AMP] = ACTIONS(2833),
  },
  [2784] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6519),
  },
  [2785] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6521),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2786] = {
    [sym__concat] = ACTIONS(2839),
    [anon_sym_esac] = ACTIONS(2841),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_SEMI_SEMI] = ACTIONS(2841),
    [anon_sym_PIPE_AMP] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_PIPE_PIPE] = ACTIONS(2841),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym_LF] = ACTIONS(2839),
    [anon_sym_AMP] = ACTIONS(2841),
  },
  [2787] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6523),
  },
  [2788] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6525),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2789] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6527),
  },
  [2790] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6507),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2791] = {
    [sym_concatenation] = STATE(2813),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2813),
    [anon_sym_RBRACE] = ACTIONS(6529),
    [anon_sym_EQ] = ACTIONS(6531),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6533),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6531),
    [anon_sym_COLON_QMARK] = ACTIONS(6531),
    [anon_sym_COLON_DASH] = ACTIONS(6531),
    [anon_sym_PERCENT] = ACTIONS(6531),
    [anon_sym_DASH] = ACTIONS(6531),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2792] = {
    [sym__concat] = ACTIONS(2855),
    [anon_sym_esac] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_SEMI_SEMI] = ACTIONS(2857),
    [anon_sym_PIPE_AMP] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2857),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_LF] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2857),
  },
  [2793] = {
    [sym_concatenation] = STATE(2815),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2815),
    [anon_sym_RBRACE] = ACTIONS(6535),
    [anon_sym_EQ] = ACTIONS(6537),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6539),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6537),
    [anon_sym_COLON_QMARK] = ACTIONS(6537),
    [anon_sym_COLON_DASH] = ACTIONS(6537),
    [anon_sym_PERCENT] = ACTIONS(6537),
    [anon_sym_DASH] = ACTIONS(6537),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2794] = {
    [sym__concat] = ACTIONS(5325),
    [sym_variable_name] = ACTIONS(5325),
    [anon_sym_esac] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_SEMI_SEMI] = ACTIONS(5327),
    [anon_sym_PIPE_AMP] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [sym__special_characters] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [sym_raw_string] = ACTIONS(5327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5327),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5327),
    [anon_sym_BQUOTE] = ACTIONS(5327),
    [anon_sym_LT_LPAREN] = ACTIONS(5327),
    [anon_sym_GT_LPAREN] = ACTIONS(5327),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5327),
    [sym_word] = ACTIONS(5327),
    [anon_sym_SEMI] = ACTIONS(5327),
    [anon_sym_LF] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
  },
  [2795] = {
    [sym__concat] = ACTIONS(5329),
    [sym_variable_name] = ACTIONS(5329),
    [anon_sym_esac] = ACTIONS(5331),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_SEMI_SEMI] = ACTIONS(5331),
    [anon_sym_PIPE_AMP] = ACTIONS(5331),
    [anon_sym_AMP_AMP] = ACTIONS(5331),
    [anon_sym_PIPE_PIPE] = ACTIONS(5331),
    [sym__special_characters] = ACTIONS(5331),
    [anon_sym_DQUOTE] = ACTIONS(5331),
    [anon_sym_DOLLAR] = ACTIONS(5331),
    [sym_raw_string] = ACTIONS(5331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5331),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5331),
    [anon_sym_BQUOTE] = ACTIONS(5331),
    [anon_sym_LT_LPAREN] = ACTIONS(5331),
    [anon_sym_GT_LPAREN] = ACTIONS(5331),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5331),
    [sym_word] = ACTIONS(5331),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LF] = ACTIONS(5329),
    [anon_sym_AMP] = ACTIONS(5331),
  },
  [2796] = {
    [sym__concat] = ACTIONS(5333),
    [sym_variable_name] = ACTIONS(5333),
    [anon_sym_esac] = ACTIONS(5335),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_SEMI_SEMI] = ACTIONS(5335),
    [anon_sym_PIPE_AMP] = ACTIONS(5335),
    [anon_sym_AMP_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5335),
    [sym__special_characters] = ACTIONS(5335),
    [anon_sym_DQUOTE] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5335),
    [sym_raw_string] = ACTIONS(5335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5335),
    [anon_sym_BQUOTE] = ACTIONS(5335),
    [anon_sym_LT_LPAREN] = ACTIONS(5335),
    [anon_sym_GT_LPAREN] = ACTIONS(5335),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5335),
    [sym_word] = ACTIONS(5335),
    [anon_sym_SEMI] = ACTIONS(5335),
    [anon_sym_LF] = ACTIONS(5333),
    [anon_sym_AMP] = ACTIONS(5335),
  },
  [2797] = {
    [sym__concat] = ACTIONS(5325),
    [anon_sym_esac] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_SEMI_SEMI] = ACTIONS(5327),
    [anon_sym_PIPE_AMP] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [sym__special_characters] = ACTIONS(5327),
    [anon_sym_DQUOTE] = ACTIONS(5327),
    [anon_sym_DOLLAR] = ACTIONS(5327),
    [sym_raw_string] = ACTIONS(5327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5327),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5327),
    [anon_sym_BQUOTE] = ACTIONS(5327),
    [anon_sym_LT_LPAREN] = ACTIONS(5327),
    [anon_sym_GT_LPAREN] = ACTIONS(5327),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5327),
    [sym_word] = ACTIONS(5327),
    [anon_sym_SEMI] = ACTIONS(5327),
    [anon_sym_LF] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
  },
  [2798] = {
    [sym__concat] = ACTIONS(5329),
    [anon_sym_esac] = ACTIONS(5331),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_SEMI_SEMI] = ACTIONS(5331),
    [anon_sym_PIPE_AMP] = ACTIONS(5331),
    [anon_sym_AMP_AMP] = ACTIONS(5331),
    [anon_sym_PIPE_PIPE] = ACTIONS(5331),
    [sym__special_characters] = ACTIONS(5331),
    [anon_sym_DQUOTE] = ACTIONS(5331),
    [anon_sym_DOLLAR] = ACTIONS(5331),
    [sym_raw_string] = ACTIONS(5331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5331),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5331),
    [anon_sym_BQUOTE] = ACTIONS(5331),
    [anon_sym_LT_LPAREN] = ACTIONS(5331),
    [anon_sym_GT_LPAREN] = ACTIONS(5331),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5331),
    [sym_word] = ACTIONS(5331),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LF] = ACTIONS(5329),
    [anon_sym_AMP] = ACTIONS(5331),
  },
  [2799] = {
    [sym__concat] = ACTIONS(5333),
    [anon_sym_esac] = ACTIONS(5335),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_SEMI_SEMI] = ACTIONS(5335),
    [anon_sym_PIPE_AMP] = ACTIONS(5335),
    [anon_sym_AMP_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5335),
    [sym__special_characters] = ACTIONS(5335),
    [anon_sym_DQUOTE] = ACTIONS(5335),
    [anon_sym_DOLLAR] = ACTIONS(5335),
    [sym_raw_string] = ACTIONS(5335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5335),
    [anon_sym_BQUOTE] = ACTIONS(5335),
    [anon_sym_LT_LPAREN] = ACTIONS(5335),
    [anon_sym_GT_LPAREN] = ACTIONS(5335),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5335),
    [sym_word] = ACTIONS(5335),
    [anon_sym_SEMI] = ACTIONS(5335),
    [anon_sym_LF] = ACTIONS(5333),
    [anon_sym_AMP] = ACTIONS(5335),
  },
  [2800] = {
    [sym__concat] = ACTIONS(3829),
    [anon_sym_esac] = ACTIONS(3831),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_SEMI_SEMI] = ACTIONS(3831),
    [anon_sym_PIPE_AMP] = ACTIONS(3831),
    [anon_sym_AMP_AMP] = ACTIONS(3831),
    [anon_sym_PIPE_PIPE] = ACTIONS(3831),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_LF] = ACTIONS(3829),
    [anon_sym_AMP] = ACTIONS(3831),
  },
  [2801] = {
    [sym__concat] = ACTIONS(3835),
    [anon_sym_esac] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3837),
    [anon_sym_SEMI_SEMI] = ACTIONS(3837),
    [anon_sym_PIPE_AMP] = ACTIONS(3837),
    [anon_sym_AMP_AMP] = ACTIONS(3837),
    [anon_sym_PIPE_PIPE] = ACTIONS(3837),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3837),
    [anon_sym_LF] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
  },
  [2802] = {
    [sym__concat] = ACTIONS(3920),
    [anon_sym_esac] = ACTIONS(3922),
    [anon_sym_PIPE] = ACTIONS(3922),
    [anon_sym_SEMI_SEMI] = ACTIONS(3922),
    [anon_sym_PIPE_AMP] = ACTIONS(3922),
    [anon_sym_AMP_AMP] = ACTIONS(3922),
    [anon_sym_PIPE_PIPE] = ACTIONS(3922),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3922),
    [anon_sym_LF] = ACTIONS(3920),
    [anon_sym_AMP] = ACTIONS(3922),
  },
  [2803] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6541),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2804] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6543),
    [sym_comment] = ACTIONS(53),
  },
  [2805] = {
    [aux_sym_concatenation_repeat1] = STATE(1235),
    [sym__concat] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(6545),
    [sym_comment] = ACTIONS(53),
  },
  [2806] = {
    [anon_sym_RBRACE] = ACTIONS(6545),
    [sym_comment] = ACTIONS(53),
  },
  [2807] = {
    [sym_concatenation] = STATE(2820),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2820),
    [anon_sym_RBRACE] = ACTIONS(6547),
    [anon_sym_EQ] = ACTIONS(6549),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6549),
    [anon_sym_COLON_QMARK] = ACTIONS(6549),
    [anon_sym_COLON_DASH] = ACTIONS(6549),
    [anon_sym_PERCENT] = ACTIONS(6549),
    [anon_sym_DASH] = ACTIONS(6549),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2808] = {
    [sym__concat] = ACTIONS(3936),
    [anon_sym_esac] = ACTIONS(3938),
    [anon_sym_PIPE] = ACTIONS(3938),
    [anon_sym_SEMI_SEMI] = ACTIONS(3938),
    [anon_sym_PIPE_AMP] = ACTIONS(3938),
    [anon_sym_AMP_AMP] = ACTIONS(3938),
    [anon_sym_PIPE_PIPE] = ACTIONS(3938),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_LF] = ACTIONS(3936),
    [anon_sym_AMP] = ACTIONS(3938),
  },
  [2809] = {
    [sym_concatenation] = STATE(2822),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2822),
    [anon_sym_RBRACE] = ACTIONS(6553),
    [anon_sym_EQ] = ACTIONS(6555),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6555),
    [anon_sym_COLON_QMARK] = ACTIONS(6555),
    [anon_sym_COLON_DASH] = ACTIONS(6555),
    [anon_sym_PERCENT] = ACTIONS(6555),
    [anon_sym_DASH] = ACTIONS(6555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2810] = {
    [sym__concat] = ACTIONS(3946),
    [anon_sym_esac] = ACTIONS(3948),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_SEMI_SEMI] = ACTIONS(3948),
    [anon_sym_PIPE_AMP] = ACTIONS(3948),
    [anon_sym_AMP_AMP] = ACTIONS(3948),
    [anon_sym_PIPE_PIPE] = ACTIONS(3948),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3948),
    [anon_sym_LF] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3948),
  },
  [2811] = {
    [sym_concatenation] = STATE(2824),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2824),
    [anon_sym_RBRACE] = ACTIONS(6559),
    [anon_sym_EQ] = ACTIONS(6561),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6563),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6561),
    [anon_sym_COLON_QMARK] = ACTIONS(6561),
    [anon_sym_COLON_DASH] = ACTIONS(6561),
    [anon_sym_PERCENT] = ACTIONS(6561),
    [anon_sym_DASH] = ACTIONS(6561),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2812] = {
    [sym__concat] = ACTIONS(3956),
    [anon_sym_esac] = ACTIONS(3958),
    [anon_sym_PIPE] = ACTIONS(3958),
    [anon_sym_SEMI_SEMI] = ACTIONS(3958),
    [anon_sym_PIPE_AMP] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_LF] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
  },
  [2813] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6565),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2814] = {
    [sym__concat] = ACTIONS(3962),
    [anon_sym_esac] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_SEMI_SEMI] = ACTIONS(3964),
    [anon_sym_PIPE_AMP] = ACTIONS(3964),
    [anon_sym_AMP_AMP] = ACTIONS(3964),
    [anon_sym_PIPE_PIPE] = ACTIONS(3964),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3964),
    [anon_sym_LF] = ACTIONS(3962),
    [anon_sym_AMP] = ACTIONS(3964),
  },
  [2815] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6567),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2816] = {
    [sym__concat] = ACTIONS(4741),
    [anon_sym_esac] = ACTIONS(4743),
    [anon_sym_PIPE] = ACTIONS(4743),
    [anon_sym_SEMI_SEMI] = ACTIONS(4743),
    [anon_sym_PIPE_AMP] = ACTIONS(4743),
    [anon_sym_AMP_AMP] = ACTIONS(4743),
    [anon_sym_PIPE_PIPE] = ACTIONS(4743),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_LF] = ACTIONS(4741),
    [anon_sym_AMP] = ACTIONS(4743),
  },
  [2817] = {
    [sym__concat] = ACTIONS(4745),
    [anon_sym_esac] = ACTIONS(4747),
    [anon_sym_PIPE] = ACTIONS(4747),
    [anon_sym_SEMI_SEMI] = ACTIONS(4747),
    [anon_sym_PIPE_AMP] = ACTIONS(4747),
    [anon_sym_AMP_AMP] = ACTIONS(4747),
    [anon_sym_PIPE_PIPE] = ACTIONS(4747),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4747),
    [anon_sym_LF] = ACTIONS(4745),
    [anon_sym_AMP] = ACTIONS(4747),
  },
  [2818] = {
    [sym__concat] = ACTIONS(4749),
    [anon_sym_esac] = ACTIONS(4751),
    [anon_sym_PIPE] = ACTIONS(4751),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(4751),
    [anon_sym_AMP_AMP] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE] = ACTIONS(4751),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4751),
    [anon_sym_LF] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(4751),
  },
  [2819] = {
    [sym__concat] = ACTIONS(4753),
    [anon_sym_esac] = ACTIONS(4755),
    [anon_sym_PIPE] = ACTIONS(4755),
    [anon_sym_SEMI_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE_AMP] = ACTIONS(4755),
    [anon_sym_AMP_AMP] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE] = ACTIONS(4755),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_LF] = ACTIONS(4753),
    [anon_sym_AMP] = ACTIONS(4755),
  },
  [2820] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6569),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2821] = {
    [sym__concat] = ACTIONS(4759),
    [anon_sym_esac] = ACTIONS(4761),
    [anon_sym_PIPE] = ACTIONS(4761),
    [anon_sym_SEMI_SEMI] = ACTIONS(4761),
    [anon_sym_PIPE_AMP] = ACTIONS(4761),
    [anon_sym_AMP_AMP] = ACTIONS(4761),
    [anon_sym_PIPE_PIPE] = ACTIONS(4761),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4761),
    [anon_sym_LF] = ACTIONS(4759),
    [anon_sym_AMP] = ACTIONS(4761),
  },
  [2822] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6571),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2823] = {
    [sym__concat] = ACTIONS(4765),
    [anon_sym_esac] = ACTIONS(4767),
    [anon_sym_PIPE] = ACTIONS(4767),
    [anon_sym_SEMI_SEMI] = ACTIONS(4767),
    [anon_sym_PIPE_AMP] = ACTIONS(4767),
    [anon_sym_AMP_AMP] = ACTIONS(4767),
    [anon_sym_PIPE_PIPE] = ACTIONS(4767),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4767),
    [anon_sym_LF] = ACTIONS(4765),
    [anon_sym_AMP] = ACTIONS(4767),
  },
  [2824] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(6573),
    [anon_sym_EQ] = ACTIONS(1770),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1770),
    [anon_sym_COLON_QMARK] = ACTIONS(1770),
    [anon_sym_COLON_DASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2825] = {
    [sym__concat] = ACTIONS(4771),
    [anon_sym_esac] = ACTIONS(4773),
    [anon_sym_PIPE] = ACTIONS(4773),
    [anon_sym_SEMI_SEMI] = ACTIONS(4773),
    [anon_sym_PIPE_AMP] = ACTIONS(4773),
    [anon_sym_AMP_AMP] = ACTIONS(4773),
    [anon_sym_PIPE_PIPE] = ACTIONS(4773),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4773),
    [anon_sym_LF] = ACTIONS(4771),
    [anon_sym_AMP] = ACTIONS(4773),
  },
  [2826] = {
    [sym__concat] = ACTIONS(4775),
    [anon_sym_esac] = ACTIONS(4777),
    [anon_sym_PIPE] = ACTIONS(4777),
    [anon_sym_SEMI_SEMI] = ACTIONS(4777),
    [anon_sym_PIPE_AMP] = ACTIONS(4777),
    [anon_sym_AMP_AMP] = ACTIONS(4777),
    [anon_sym_PIPE_PIPE] = ACTIONS(4777),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4777),
    [anon_sym_LF] = ACTIONS(4775),
    [anon_sym_AMP] = ACTIONS(4777),
  },
  [2827] = {
    [sym__concat] = ACTIONS(5325),
    [anon_sym_esac] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_SEMI_SEMI] = ACTIONS(5327),
    [anon_sym_PIPE_AMP] = ACTIONS(5327),
    [anon_sym_AMP_AMP] = ACTIONS(5327),
    [anon_sym_PIPE_PIPE] = ACTIONS(5327),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5327),
    [anon_sym_LF] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
  },
  [2828] = {
    [sym__concat] = ACTIONS(5329),
    [anon_sym_esac] = ACTIONS(5331),
    [anon_sym_PIPE] = ACTIONS(5331),
    [anon_sym_SEMI_SEMI] = ACTIONS(5331),
    [anon_sym_PIPE_AMP] = ACTIONS(5331),
    [anon_sym_AMP_AMP] = ACTIONS(5331),
    [anon_sym_PIPE_PIPE] = ACTIONS(5331),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LF] = ACTIONS(5329),
    [anon_sym_AMP] = ACTIONS(5331),
  },
  [2829] = {
    [sym__concat] = ACTIONS(5333),
    [anon_sym_esac] = ACTIONS(5335),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_SEMI_SEMI] = ACTIONS(5335),
    [anon_sym_PIPE_AMP] = ACTIONS(5335),
    [anon_sym_AMP_AMP] = ACTIONS(5335),
    [anon_sym_PIPE_PIPE] = ACTIONS(5335),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5335),
    [anon_sym_LF] = ACTIONS(5333),
    [anon_sym_AMP] = ACTIONS(5335),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [11] = {.count = 1, .reusable = false}, SHIFT(4),
  [13] = {.count = 1, .reusable = false}, SHIFT(5),
  [15] = {.count = 1, .reusable = false}, SHIFT(6),
  [17] = {.count = 1, .reusable = false}, SHIFT(7),
  [19] = {.count = 1, .reusable = false}, SHIFT(8),
  [21] = {.count = 1, .reusable = true}, SHIFT(9),
  [23] = {.count = 1, .reusable = false}, SHIFT(10),
  [25] = {.count = 1, .reusable = false}, SHIFT(11),
  [27] = {.count = 1, .reusable = true}, SHIFT(12),
  [29] = {.count = 1, .reusable = false}, SHIFT(13),
  [31] = {.count = 1, .reusable = false}, SHIFT(14),
  [33] = {.count = 1, .reusable = false}, SHIFT(15),
  [35] = {.count = 1, .reusable = true}, SHIFT(15),
  [37] = {.count = 1, .reusable = false}, SHIFT(16),
  [39] = {.count = 1, .reusable = true}, SHIFT(17),
  [41] = {.count = 1, .reusable = false}, SHIFT(18),
  [43] = {.count = 1, .reusable = true}, SHIFT(19),
  [45] = {.count = 1, .reusable = true}, SHIFT(20),
  [47] = {.count = 1, .reusable = true}, SHIFT(21),
  [49] = {.count = 1, .reusable = true}, SHIFT(22),
  [51] = {.count = 1, .reusable = true}, SHIFT(23),
  [53] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [55] = {.count = 1, .reusable = false}, SHIFT(24),
  [57] = {.count = 1, .reusable = false}, SHIFT(34),
  [59] = {.count = 1, .reusable = true}, SHIFT(34),
  [61] = {.count = 1, .reusable = true}, SHIFT(35),
  [63] = {.count = 1, .reusable = true}, SHIFT(36),
  [65] = {.count = 1, .reusable = true}, SHIFT(37),
  [67] = {.count = 1, .reusable = true}, SHIFT(42),
  [69] = {.count = 1, .reusable = true}, SHIFT(43),
  [71] = {.count = 1, .reusable = false}, SHIFT(44),
  [73] = {.count = 1, .reusable = true}, SHIFT(45),
  [75] = {.count = 1, .reusable = true}, SHIFT(46),
  [77] = {.count = 1, .reusable = true}, SHIFT(47),
  [79] = {.count = 1, .reusable = true}, SHIFT(48),
  [81] = {.count = 1, .reusable = true}, SHIFT(49),
  [83] = {.count = 1, .reusable = true}, SHIFT(51),
  [85] = {.count = 1, .reusable = true}, SHIFT(52),
  [87] = {.count = 1, .reusable = false}, SHIFT(53),
  [89] = {.count = 1, .reusable = false}, SHIFT(54),
  [91] = {.count = 1, .reusable = false}, SHIFT(55),
  [93] = {.count = 1, .reusable = false}, SHIFT(56),
  [95] = {.count = 1, .reusable = true}, SHIFT(57),
  [97] = {.count = 1, .reusable = false}, SHIFT(58),
  [99] = {.count = 1, .reusable = false}, SHIFT(59),
  [101] = {.count = 1, .reusable = false}, SHIFT(60),
  [103] = {.count = 1, .reusable = true}, SHIFT(61),
  [105] = {.count = 1, .reusable = false}, SHIFT(62),
  [107] = {.count = 1, .reusable = true}, SHIFT(69),
  [109] = {.count = 1, .reusable = true}, SHIFT(72),
  [111] = {.count = 1, .reusable = false}, SHIFT(73),
  [113] = {.count = 1, .reusable = true}, SHIFT(74),
  [115] = {.count = 1, .reusable = true}, SHIFT(75),
  [117] = {.count = 1, .reusable = false}, SHIFT(76),
  [119] = {.count = 1, .reusable = true}, SHIFT(77),
  [121] = {.count = 1, .reusable = true}, SHIFT(78),
  [123] = {.count = 1, .reusable = true}, SHIFT(79),
  [125] = {.count = 1, .reusable = true}, SHIFT(80),
  [127] = {.count = 1, .reusable = true}, SHIFT(81),
  [129] = {.count = 1, .reusable = false}, SHIFT(77),
  [131] = {.count = 1, .reusable = true}, SHIFT(73),
  [133] = {.count = 1, .reusable = true}, SHIFT(83),
  [135] = {.count = 1, .reusable = false}, SHIFT(84),
  [137] = {.count = 1, .reusable = true}, SHIFT(85),
  [139] = {.count = 1, .reusable = true}, SHIFT(86),
  [141] = {.count = 1, .reusable = false}, SHIFT(87),
  [143] = {.count = 1, .reusable = true}, SHIFT(88),
  [145] = {.count = 1, .reusable = true}, SHIFT(89),
  [147] = {.count = 1, .reusable = true}, SHIFT(90),
  [149] = {.count = 1, .reusable = true}, SHIFT(91),
  [151] = {.count = 1, .reusable = true}, SHIFT(92),
  [153] = {.count = 1, .reusable = false}, SHIFT(88),
  [155] = {.count = 1, .reusable = true}, SHIFT(84),
  [157] = {.count = 1, .reusable = true}, SHIFT(94),
  [159] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 1),
  [161] = {.count = 1, .reusable = false}, SHIFT(95),
  [163] = {.count = 1, .reusable = false}, SHIFT(96),
  [165] = {.count = 1, .reusable = false}, SHIFT(97),
  [167] = {.count = 1, .reusable = false}, SHIFT(98),
  [169] = {.count = 1, .reusable = false}, SHIFT(99),
  [171] = {.count = 1, .reusable = false}, SHIFT(100),
  [173] = {.count = 1, .reusable = false}, SHIFT(101),
  [175] = {.count = 1, .reusable = false}, SHIFT(102),
  [177] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [179] = {.count = 1, .reusable = false}, SHIFT(103),
  [181] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 1),
  [183] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 1),
  [185] = {.count = 1, .reusable = false}, SHIFT(106),
  [187] = {.count = 1, .reusable = false}, SHIFT(107),
  [189] = {.count = 1, .reusable = false}, SHIFT(108),
  [191] = {.count = 1, .reusable = false}, SHIFT(109),
  [193] = {.count = 1, .reusable = false}, SHIFT(110),
  [195] = {.count = 1, .reusable = false}, SHIFT(111),
  [197] = {.count = 1, .reusable = false}, SHIFT(112),
  [199] = {.count = 1, .reusable = false}, SHIFT(113),
  [201] = {.count = 1, .reusable = false}, SHIFT(114),
  [203] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 1),
  [205] = {.count = 1, .reusable = true}, SHIFT(116),
  [207] = {.count = 1, .reusable = true}, SHIFT(117),
  [209] = {.count = 1, .reusable = false}, SHIFT(118),
  [211] = {.count = 1, .reusable = true}, SHIFT(119),
  [213] = {.count = 1, .reusable = true}, SHIFT(120),
  [215] = {.count = 1, .reusable = true}, SHIFT(121),
  [217] = {.count = 1, .reusable = true}, SHIFT(122),
  [219] = {.count = 1, .reusable = true}, SHIFT(123),
  [221] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [223] = {.count = 1, .reusable = true}, SHIFT(125),
  [225] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [227] = {.count = 1, .reusable = false}, SHIFT(127),
  [229] = {.count = 1, .reusable = false}, SHIFT(128),
  [231] = {.count = 1, .reusable = true}, SHIFT(129),
  [233] = {.count = 1, .reusable = false}, SHIFT(130),
  [235] = {.count = 1, .reusable = false}, SHIFT(131),
  [237] = {.count = 1, .reusable = false}, SHIFT(132),
  [239] = {.count = 1, .reusable = true}, SHIFT(134),
  [241] = {.count = 1, .reusable = true}, SHIFT(135),
  [243] = {.count = 1, .reusable = false}, SHIFT(136),
  [245] = {.count = 1, .reusable = false}, SHIFT(134),
  [247] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1),
  [249] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1),
  [251] = {.count = 1, .reusable = true}, SHIFT(137),
  [253] = {.count = 1, .reusable = true}, SHIFT(138),
  [255] = {.count = 1, .reusable = true}, SHIFT(139),
  [257] = {.count = 1, .reusable = false}, SHIFT(140),
  [259] = {.count = 1, .reusable = false}, SHIFT(138),
  [261] = {.count = 1, .reusable = true}, SHIFT(142),
  [263] = {.count = 1, .reusable = false}, SHIFT(143),
  [265] = {.count = 1, .reusable = false}, SHIFT(144),
  [267] = {.count = 1, .reusable = false}, SHIFT(145),
  [269] = {.count = 1, .reusable = false}, SHIFT(146),
  [271] = {.count = 1, .reusable = false}, SHIFT(147),
  [273] = {.count = 1, .reusable = true}, SHIFT(148),
  [275] = {.count = 1, .reusable = false}, SHIFT(149),
  [277] = {.count = 1, .reusable = false}, SHIFT(150),
  [279] = {.count = 1, .reusable = true}, SHIFT(151),
  [281] = {.count = 1, .reusable = false}, SHIFT(152),
  [283] = {.count = 1, .reusable = false}, SHIFT(153),
  [285] = {.count = 1, .reusable = false}, SHIFT(154),
  [287] = {.count = 1, .reusable = true}, SHIFT(155),
  [289] = {.count = 1, .reusable = false}, SHIFT(156),
  [291] = {.count = 1, .reusable = true}, SHIFT(157),
  [293] = {.count = 1, .reusable = true}, SHIFT(158),
  [295] = {.count = 1, .reusable = true}, SHIFT(159),
  [297] = {.count = 1, .reusable = true}, SHIFT(160),
  [299] = {.count = 1, .reusable = true}, SHIFT(161),
  [301] = {.count = 1, .reusable = false}, SHIFT(162),
  [303] = {.count = 1, .reusable = true}, SHIFT(169),
  [305] = {.count = 1, .reusable = false}, SHIFT(170),
  [307] = {.count = 1, .reusable = false}, SHIFT(171),
  [309] = {.count = 1, .reusable = false}, SHIFT(172),
  [311] = {.count = 1, .reusable = false}, SHIFT(173),
  [313] = {.count = 1, .reusable = true}, SHIFT(174),
  [315] = {.count = 1, .reusable = false}, SHIFT(175),
  [317] = {.count = 1, .reusable = false}, SHIFT(176),
  [319] = {.count = 1, .reusable = false}, SHIFT(177),
  [321] = {.count = 1, .reusable = true}, SHIFT(178),
  [323] = {.count = 1, .reusable = false}, SHIFT(179),
  [325] = {.count = 1, .reusable = false}, SHIFT(187),
  [327] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [329] = {.count = 1, .reusable = false}, SHIFT(188),
  [331] = {.count = 1, .reusable = false}, SHIFT(189),
  [333] = {.count = 1, .reusable = false}, SHIFT(190),
  [335] = {.count = 1, .reusable = true}, SHIFT(189),
  [337] = {.count = 1, .reusable = true}, SHIFT(191),
  [339] = {.count = 1, .reusable = true}, SHIFT(192),
  [341] = {.count = 1, .reusable = true}, SHIFT(193),
  [343] = {.count = 1, .reusable = false}, REDUCE(sym_command, 1),
  [345] = {.count = 1, .reusable = false}, SHIFT(194),
  [347] = {.count = 1, .reusable = false}, SHIFT(195),
  [349] = {.count = 1, .reusable = false}, SHIFT(196),
  [351] = {.count = 1, .reusable = false}, SHIFT(197),
  [353] = {.count = 1, .reusable = false}, SHIFT(198),
  [355] = {.count = 1, .reusable = false}, SHIFT(17),
  [357] = {.count = 1, .reusable = false}, SHIFT(199),
  [359] = {.count = 1, .reusable = false}, SHIFT(20),
  [361] = {.count = 1, .reusable = false}, SHIFT(21),
  [363] = {.count = 1, .reusable = false}, SHIFT(22),
  [365] = {.count = 1, .reusable = false}, SHIFT(23),
  [367] = {.count = 1, .reusable = true}, REDUCE(sym_command, 1),
  [369] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 1),
  [371] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 1),
  [373] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [375] = {.count = 1, .reusable = true}, SHIFT(16),
  [377] = {.count = 1, .reusable = true}, SHIFT(206),
  [379] = {.count = 1, .reusable = true}, SHIFT(207),
  [381] = {.count = 1, .reusable = true}, SHIFT(209),
  [383] = {.count = 1, .reusable = true}, SHIFT(210),
  [385] = {.count = 1, .reusable = true}, SHIFT(212),
  [387] = {.count = 1, .reusable = true}, SHIFT(213),
  [389] = {.count = 1, .reusable = true}, SHIFT(214),
  [391] = {.count = 1, .reusable = true}, SHIFT(215),
  [393] = {.count = 1, .reusable = false}, SHIFT(216),
  [395] = {.count = 1, .reusable = true}, SHIFT(217),
  [397] = {.count = 1, .reusable = true}, SHIFT(218),
  [399] = {.count = 1, .reusable = true}, SHIFT(219),
  [401] = {.count = 1, .reusable = true}, SHIFT(220),
  [403] = {.count = 1, .reusable = true}, SHIFT(221),
  [405] = {.count = 1, .reusable = false}, SHIFT(222),
  [407] = {.count = 1, .reusable = false}, SHIFT(223),
  [409] = {.count = 1, .reusable = true}, SHIFT(223),
  [411] = {.count = 1, .reusable = true}, SHIFT(224),
  [413] = {.count = 1, .reusable = false}, SHIFT(226),
  [415] = {.count = 1, .reusable = true}, SHIFT(226),
  [417] = {.count = 1, .reusable = true}, SHIFT(227),
  [419] = {.count = 1, .reusable = true}, SHIFT(228),
  [421] = {.count = 1, .reusable = false}, SHIFT(229),
  [423] = {.count = 1, .reusable = false}, SHIFT(230),
  [425] = {.count = 1, .reusable = true}, SHIFT(230),
  [427] = {.count = 1, .reusable = false}, SHIFT(232),
  [429] = {.count = 1, .reusable = true}, SHIFT(234),
  [431] = {.count = 1, .reusable = true}, SHIFT(235),
  [433] = {.count = 1, .reusable = false}, SHIFT(236),
  [435] = {.count = 1, .reusable = false}, SHIFT(234),
  [437] = {.count = 1, .reusable = false}, SHIFT(237),
  [439] = {.count = 1, .reusable = false}, SHIFT(238),
  [441] = {.count = 1, .reusable = true}, SHIFT(238),
  [443] = {.count = 1, .reusable = true}, SHIFT(239),
  [445] = {.count = 1, .reusable = true}, SHIFT(240),
  [447] = {.count = 1, .reusable = true}, SHIFT(241),
  [449] = {.count = 1, .reusable = false}, SHIFT(242),
  [451] = {.count = 1, .reusable = false}, SHIFT(240),
  [453] = {.count = 1, .reusable = true}, SHIFT(250),
  [455] = {.count = 1, .reusable = true}, SHIFT(251),
  [457] = {.count = 1, .reusable = true}, SHIFT(253),
  [459] = {.count = 1, .reusable = true}, SHIFT(255),
  [461] = {.count = 1, .reusable = true}, SHIFT(258),
  [463] = {.count = 1, .reusable = false}, SHIFT(259),
  [465] = {.count = 1, .reusable = false}, SHIFT(260),
  [467] = {.count = 1, .reusable = false}, SHIFT(263),
  [469] = {.count = 1, .reusable = false}, SHIFT(264),
  [471] = {.count = 1, .reusable = false}, SHIFT(267),
  [473] = {.count = 1, .reusable = false}, SHIFT(268),
  [475] = {.count = 1, .reusable = false}, SHIFT(269),
  [477] = {.count = 1, .reusable = false}, SHIFT(270),
  [479] = {.count = 1, .reusable = false}, SHIFT(271),
  [481] = {.count = 1, .reusable = true}, SHIFT(270),
  [483] = {.count = 1, .reusable = true}, SHIFT(272),
  [485] = {.count = 1, .reusable = false}, SHIFT(273),
  [487] = {.count = 1, .reusable = false}, SHIFT(274),
  [489] = {.count = 1, .reusable = false}, SHIFT(275),
  [491] = {.count = 1, .reusable = false}, SHIFT(276),
  [493] = {.count = 1, .reusable = false}, SHIFT(277),
  [495] = {.count = 1, .reusable = true}, SHIFT(60),
  [497] = {.count = 1, .reusable = true}, SHIFT(284),
  [499] = {.count = 1, .reusable = false}, REDUCE(sym_negated_command, 2),
  [501] = {.count = 1, .reusable = true}, REDUCE(sym_negated_command, 2),
  [503] = {.count = 1, .reusable = false}, SHIFT(285),
  [505] = {.count = 1, .reusable = true}, SHIFT(286),
  [507] = {.count = 1, .reusable = true}, SHIFT(287),
  [509] = {.count = 1, .reusable = false}, SHIFT(287),
  [511] = {.count = 1, .reusable = true}, SHIFT(285),
  [513] = {.count = 1, .reusable = true}, SHIFT(290),
  [515] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [517] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [519] = {.count = 1, .reusable = false}, SHIFT(292),
  [521] = {.count = 1, .reusable = true}, SHIFT(294),
  [523] = {.count = 1, .reusable = true}, SHIFT(295),
  [525] = {.count = 1, .reusable = false}, SHIFT(296),
  [527] = {.count = 1, .reusable = false}, SHIFT(294),
  [529] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [531] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [533] = {.count = 1, .reusable = true}, SHIFT(297),
  [535] = {.count = 1, .reusable = true}, SHIFT(298),
  [537] = {.count = 1, .reusable = true}, SHIFT(299),
  [539] = {.count = 1, .reusable = false}, SHIFT(300),
  [541] = {.count = 1, .reusable = false}, SHIFT(298),
  [543] = {.count = 1, .reusable = true}, SHIFT(308),
  [545] = {.count = 1, .reusable = true}, SHIFT(309),
  [547] = {.count = 1, .reusable = true}, SHIFT(310),
  [549] = {.count = 1, .reusable = false}, SHIFT(308),
  [551] = {.count = 1, .reusable = true}, SHIFT(313),
  [553] = {.count = 1, .reusable = false}, SHIFT(315),
  [555] = {.count = 1, .reusable = true}, SHIFT(317),
  [557] = {.count = 1, .reusable = true}, SHIFT(318),
  [559] = {.count = 1, .reusable = false}, SHIFT(319),
  [561] = {.count = 1, .reusable = false}, SHIFT(317),
  [563] = {.count = 1, .reusable = true}, SHIFT(320),
  [565] = {.count = 1, .reusable = true}, SHIFT(321),
  [567] = {.count = 1, .reusable = true}, SHIFT(322),
  [569] = {.count = 1, .reusable = false}, SHIFT(323),
  [571] = {.count = 1, .reusable = false}, SHIFT(321),
  [573] = {.count = 1, .reusable = true}, SHIFT(331),
  [575] = {.count = 1, .reusable = true}, SHIFT(332),
  [577] = {.count = 1, .reusable = false}, SHIFT(331),
  [579] = {.count = 1, .reusable = true}, SHIFT(333),
  [581] = {.count = 1, .reusable = true}, SHIFT(334),
  [583] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [585] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [587] = {.count = 1, .reusable = false}, SHIFT(336),
  [589] = {.count = 1, .reusable = true}, SHIFT(96),
  [591] = {.count = 1, .reusable = true}, SHIFT(338),
  [593] = {.count = 1, .reusable = true}, SHIFT(339),
  [595] = {.count = 1, .reusable = false}, SHIFT(340),
  [597] = {.count = 1, .reusable = false}, SHIFT(338),
  [599] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [601] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [603] = {.count = 1, .reusable = true}, SHIFT(341),
  [605] = {.count = 1, .reusable = true}, SHIFT(342),
  [607] = {.count = 1, .reusable = true}, SHIFT(343),
  [609] = {.count = 1, .reusable = false}, SHIFT(344),
  [611] = {.count = 1, .reusable = false}, SHIFT(342),
  [613] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [615] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [617] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 2),
  [619] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 2),
  [621] = {.count = 1, .reusable = true}, SHIFT(353),
  [623] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [625] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [627] = {.count = 1, .reusable = false}, SHIFT(355),
  [629] = {.count = 1, .reusable = true}, SHIFT(107),
  [631] = {.count = 1, .reusable = true}, SHIFT(357),
  [633] = {.count = 1, .reusable = true}, SHIFT(358),
  [635] = {.count = 1, .reusable = false}, SHIFT(359),
  [637] = {.count = 1, .reusable = false}, SHIFT(357),
  [639] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [641] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [643] = {.count = 1, .reusable = true}, SHIFT(360),
  [645] = {.count = 1, .reusable = true}, SHIFT(361),
  [647] = {.count = 1, .reusable = true}, SHIFT(362),
  [649] = {.count = 1, .reusable = false}, SHIFT(363),
  [651] = {.count = 1, .reusable = false}, SHIFT(361),
  [653] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 2),
  [655] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 2),
  [657] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 2),
  [659] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 2),
  [661] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [663] = {.count = 1, .reusable = true}, SHIFT(372),
  [665] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [667] = {.count = 1, .reusable = false}, SHIFT(374),
  [669] = {.count = 1, .reusable = true}, SHIFT(376),
  [671] = {.count = 1, .reusable = true}, SHIFT(377),
  [673] = {.count = 1, .reusable = false}, SHIFT(378),
  [675] = {.count = 1, .reusable = false}, SHIFT(376),
  [677] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2),
  [679] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2),
  [681] = {.count = 1, .reusable = true}, SHIFT(379),
  [683] = {.count = 1, .reusable = true}, SHIFT(380),
  [685] = {.count = 1, .reusable = true}, SHIFT(381),
  [687] = {.count = 1, .reusable = false}, SHIFT(382),
  [689] = {.count = 1, .reusable = false}, SHIFT(380),
  [691] = {.count = 1, .reusable = true}, SHIFT(390),
  [693] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 2),
  [695] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 2),
  [697] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [699] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [701] = {.count = 1, .reusable = false}, SHIFT(392),
  [703] = {.count = 1, .reusable = false}, SHIFT(393),
  [705] = {.count = 1, .reusable = true}, SHIFT(392),
  [707] = {.count = 1, .reusable = false}, SHIFT(394),
  [709] = {.count = 1, .reusable = true}, SHIFT(395),
  [711] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 1),
  [713] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 1),
  [715] = {.count = 1, .reusable = true}, SHIFT(396),
  [717] = {.count = 1, .reusable = true}, SHIFT(397),
  [719] = {.count = 1, .reusable = true}, SHIFT(398),
  [721] = {.count = 1, .reusable = false}, SHIFT(399),
  [723] = {.count = 1, .reusable = false}, SHIFT(397),
  [725] = {.count = 1, .reusable = false}, SHIFT(405),
  [727] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [729] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [731] = {.count = 1, .reusable = true}, REDUCE(sym_string_expansion, 2),
  [733] = {.count = 1, .reusable = false}, REDUCE(sym_string_expansion, 2),
  [735] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 5),
  [737] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 5),
  [739] = {.count = 1, .reusable = true}, SHIFT(407),
  [741] = {.count = 1, .reusable = true}, SHIFT(408),
  [743] = {.count = 1, .reusable = true}, SHIFT(409),
  [745] = {.count = 1, .reusable = false}, SHIFT(419),
  [747] = {.count = 1, .reusable = false}, SHIFT(410),
  [749] = {.count = 1, .reusable = true}, SHIFT(411),
  [751] = {.count = 1, .reusable = false}, SHIFT(412),
  [753] = {.count = 1, .reusable = true}, SHIFT(413),
  [755] = {.count = 1, .reusable = true}, SHIFT(419),
  [757] = {.count = 1, .reusable = true}, SHIFT(414),
  [759] = {.count = 1, .reusable = true}, SHIFT(415),
  [761] = {.count = 1, .reusable = true}, SHIFT(416),
  [763] = {.count = 1, .reusable = true}, SHIFT(417),
  [765] = {.count = 1, .reusable = true}, SHIFT(418),
  [767] = {.count = 1, .reusable = false}, SHIFT(413),
  [769] = {.count = 1, .reusable = true}, SHIFT(420),
  [771] = {.count = 1, .reusable = true}, SHIFT(421),
  [773] = {.count = 1, .reusable = false}, SHIFT(422),
  [775] = {.count = 1, .reusable = false}, SHIFT(421),
  [777] = {.count = 1, .reusable = true}, SHIFT(424),
  [779] = {.count = 1, .reusable = false}, SHIFT(426),
  [781] = {.count = 1, .reusable = true}, SHIFT(426),
  [783] = {.count = 1, .reusable = true}, SHIFT(425),
  [785] = {.count = 1, .reusable = true}, SHIFT(427),
  [787] = {.count = 1, .reusable = false}, SHIFT(429),
  [789] = {.count = 1, .reusable = true}, SHIFT(429),
  [791] = {.count = 1, .reusable = true}, SHIFT(428),
  [793] = {.count = 1, .reusable = true}, SHIFT(430),
  [795] = {.count = 1, .reusable = true}, SHIFT(431),
  [797] = {.count = 1, .reusable = true}, SHIFT(434),
  [799] = {.count = 1, .reusable = true}, SHIFT(435),
  [801] = {.count = 1, .reusable = true}, SHIFT(437),
  [803] = {.count = 1, .reusable = true}, SHIFT(444),
  [805] = {.count = 1, .reusable = true}, SHIFT(445),
  [807] = {.count = 1, .reusable = true}, SHIFT(446),
  [809] = {.count = 1, .reusable = false}, SHIFT(447),
  [811] = {.count = 1, .reusable = true}, SHIFT(448),
  [813] = {.count = 1, .reusable = true}, SHIFT(449),
  [815] = {.count = 1, .reusable = true}, SHIFT(450),
  [817] = {.count = 1, .reusable = true}, SHIFT(451),
  [819] = {.count = 1, .reusable = true}, SHIFT(452),
  [821] = {.count = 1, .reusable = false}, SHIFT(453),
  [823] = {.count = 1, .reusable = false}, SHIFT(448),
  [825] = {.count = 1, .reusable = true}, SHIFT(456),
  [827] = {.count = 1, .reusable = true}, SHIFT(457),
  [829] = {.count = 1, .reusable = false}, SHIFT(458),
  [831] = {.count = 1, .reusable = true}, SHIFT(459),
  [833] = {.count = 1, .reusable = true}, SHIFT(460),
  [835] = {.count = 1, .reusable = true}, SHIFT(461),
  [837] = {.count = 1, .reusable = true}, SHIFT(462),
  [839] = {.count = 1, .reusable = true}, SHIFT(463),
  [841] = {.count = 1, .reusable = false}, SHIFT(464),
  [843] = {.count = 1, .reusable = false}, SHIFT(459),
  [845] = {.count = 1, .reusable = true}, SHIFT(466),
  [847] = {.count = 1, .reusable = false}, SHIFT(468),
  [849] = {.count = 1, .reusable = true}, SHIFT(470),
  [851] = {.count = 1, .reusable = true}, SHIFT(471),
  [853] = {.count = 1, .reusable = false}, SHIFT(472),
  [855] = {.count = 1, .reusable = false}, SHIFT(470),
  [857] = {.count = 1, .reusable = true}, SHIFT(473),
  [859] = {.count = 1, .reusable = true}, SHIFT(474),
  [861] = {.count = 1, .reusable = true}, SHIFT(475),
  [863] = {.count = 1, .reusable = false}, SHIFT(476),
  [865] = {.count = 1, .reusable = false}, SHIFT(474),
  [867] = {.count = 1, .reusable = true}, SHIFT(484),
  [869] = {.count = 1, .reusable = false}, SHIFT(485),
  [871] = {.count = 1, .reusable = true}, SHIFT(486),
  [873] = {.count = 1, .reusable = true}, SHIFT(485),
  [875] = {.count = 1, .reusable = true}, SHIFT(487),
  [877] = {.count = 1, .reusable = true}, SHIFT(488),
  [879] = {.count = 1, .reusable = true}, SHIFT(489),
  [881] = {.count = 1, .reusable = true}, SHIFT(490),
  [883] = {.count = 1, .reusable = false}, SHIFT(491),
  [885] = {.count = 1, .reusable = false}, SHIFT(492),
  [887] = {.count = 1, .reusable = true}, SHIFT(492),
  [889] = {.count = 1, .reusable = false}, SHIFT(493),
  [891] = {.count = 1, .reusable = true}, SHIFT(493),
  [893] = {.count = 1, .reusable = true}, SHIFT(494),
  [895] = {.count = 1, .reusable = true}, SHIFT(495),
  [897] = {.count = 1, .reusable = true}, SHIFT(496),
  [899] = {.count = 1, .reusable = false}, SHIFT(496),
  [901] = {.count = 1, .reusable = true}, SHIFT(154),
  [903] = {.count = 1, .reusable = true}, SHIFT(501),
  [905] = {.count = 1, .reusable = true}, SHIFT(503),
  [907] = {.count = 1, .reusable = true}, SHIFT(506),
  [909] = {.count = 1, .reusable = true}, SHIFT(507),
  [911] = {.count = 1, .reusable = true}, SHIFT(508),
  [913] = {.count = 1, .reusable = false}, SHIFT(508),
  [915] = {.count = 1, .reusable = true}, SHIFT(511),
  [917] = {.count = 1, .reusable = true}, SHIFT(512),
  [919] = {.count = 1, .reusable = false}, SHIFT(512),
  [921] = {.count = 1, .reusable = true}, SHIFT(515),
  [923] = {.count = 1, .reusable = false}, SHIFT(516),
  [925] = {.count = 1, .reusable = true}, SHIFT(516),
  [927] = {.count = 1, .reusable = true}, SHIFT(517),
  [929] = {.count = 1, .reusable = true}, SHIFT(518),
  [931] = {.count = 1, .reusable = false}, SHIFT(519),
  [933] = {.count = 1, .reusable = false}, SHIFT(520),
  [935] = {.count = 1, .reusable = true}, SHIFT(520),
  [937] = {.count = 1, .reusable = true}, SHIFT(521),
  [939] = {.count = 1, .reusable = true}, SHIFT(522),
  [941] = {.count = 1, .reusable = true}, SHIFT(523),
  [943] = {.count = 1, .reusable = false}, SHIFT(523),
  [945] = {.count = 1, .reusable = true}, SHIFT(177),
  [947] = {.count = 1, .reusable = true}, SHIFT(527),
  [949] = {.count = 1, .reusable = true}, SHIFT(528),
  [951] = {.count = 1, .reusable = true}, REDUCE(sym__terminated_statement, 2),
  [953] = {.count = 1, .reusable = false}, REDUCE(sym__terminated_statement, 2),
  [955] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 1),
  [957] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 1),
  [959] = {.count = 1, .reusable = true}, SHIFT(536),
  [961] = {.count = 1, .reusable = true}, SHIFT(533),
  [963] = {.count = 1, .reusable = false}, SHIFT(534),
  [965] = {.count = 1, .reusable = true}, SHIFT(535),
  [967] = {.count = 1, .reusable = false}, SHIFT(537),
  [969] = {.count = 1, .reusable = true}, SHIFT(537),
  [971] = {.count = 1, .reusable = false}, SHIFT(538),
  [973] = {.count = 1, .reusable = false}, SHIFT(539),
  [975] = {.count = 1, .reusable = false}, SHIFT(540),
  [977] = {.count = 1, .reusable = true}, SHIFT(541),
  [979] = {.count = 1, .reusable = true}, SHIFT(542),
  [981] = {.count = 1, .reusable = true}, SHIFT(544),
  [983] = {.count = 1, .reusable = true}, SHIFT(545),
  [985] = {.count = 1, .reusable = true}, SHIFT(546),
  [987] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [989] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [991] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1),
  [993] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1),
  [995] = {.count = 1, .reusable = false}, REDUCE(sym_command, 2),
  [997] = {.count = 1, .reusable = true}, REDUCE(sym_command, 2),
  [999] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2),
  [1002] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [1005] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [1007] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [1010] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [1013] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [1016] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [1019] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [1022] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(9),
  [1025] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [1028] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [1031] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [1034] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [1037] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [1040] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [1043] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [1046] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [1049] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [1052] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(18),
  [1055] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(19),
  [1058] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(20),
  [1061] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(21),
  [1064] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(22),
  [1067] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(23),
  [1070] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(24),
  [1073] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(2),
  [1076] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(69),
  [1079] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(15),
  [1082] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(15),
  [1085] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2),
  [1087] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2),
  [1089] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 6),
  [1091] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 6),
  [1093] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3),
  [1095] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3),
  [1097] = {.count = 1, .reusable = true}, SHIFT(553),
  [1099] = {.count = 1, .reusable = true}, SHIFT(554),
  [1101] = {.count = 1, .reusable = true}, SHIFT(556),
  [1103] = {.count = 1, .reusable = true}, SHIFT(557),
  [1105] = {.count = 1, .reusable = true}, SHIFT(558),
  [1107] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3),
  [1109] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3),
  [1111] = {.count = 1, .reusable = true}, SHIFT(559),
  [1113] = {.count = 1, .reusable = true}, SHIFT(560),
  [1115] = {.count = 1, .reusable = true}, SHIFT(561),
  [1117] = {.count = 1, .reusable = false}, SHIFT(562),
  [1119] = {.count = 1, .reusable = true}, SHIFT(563),
  [1121] = {.count = 1, .reusable = true}, SHIFT(564),
  [1123] = {.count = 1, .reusable = true}, SHIFT(565),
  [1125] = {.count = 1, .reusable = true}, SHIFT(566),
  [1127] = {.count = 1, .reusable = true}, SHIFT(567),
  [1129] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 6),
  [1131] = {.count = 1, .reusable = true}, SHIFT(569),
  [1133] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 6),
  [1135] = {.count = 1, .reusable = false}, SHIFT(571),
  [1137] = {.count = 1, .reusable = true}, SHIFT(573),
  [1139] = {.count = 1, .reusable = true}, SHIFT(574),
  [1141] = {.count = 1, .reusable = false}, SHIFT(575),
  [1143] = {.count = 1, .reusable = false}, SHIFT(573),
  [1145] = {.count = 1, .reusable = true}, SHIFT(576),
  [1147] = {.count = 1, .reusable = true}, SHIFT(577),
  [1149] = {.count = 1, .reusable = true}, SHIFT(578),
  [1151] = {.count = 1, .reusable = false}, SHIFT(579),
  [1153] = {.count = 1, .reusable = false}, SHIFT(577),
  [1155] = {.count = 1, .reusable = true}, SHIFT(587),
  [1157] = {.count = 1, .reusable = true}, SHIFT(588),
  [1159] = {.count = 1, .reusable = true}, SHIFT(590),
  [1161] = {.count = 1, .reusable = false}, SHIFT(592),
  [1163] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [1165] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [1167] = {.count = 1, .reusable = false}, SHIFT(596),
  [1169] = {.count = 1, .reusable = false}, SHIFT(597),
  [1171] = {.count = 1, .reusable = false}, SHIFT(598),
  [1173] = {.count = 1, .reusable = true}, SHIFT(603),
  [1175] = {.count = 1, .reusable = false}, SHIFT(604),
  [1177] = {.count = 1, .reusable = true}, SHIFT(604),
  [1179] = {.count = 1, .reusable = true}, SHIFT(605),
  [1181] = {.count = 1, .reusable = false}, SHIFT(607),
  [1183] = {.count = 1, .reusable = false}, SHIFT(608),
  [1185] = {.count = 1, .reusable = true}, SHIFT(608),
  [1187] = {.count = 1, .reusable = true}, SHIFT(609),
  [1189] = {.count = 1, .reusable = true}, SHIFT(610),
  [1191] = {.count = 1, .reusable = true}, SHIFT(611),
  [1193] = {.count = 1, .reusable = false}, SHIFT(613),
  [1195] = {.count = 1, .reusable = true}, SHIFT(613),
  [1197] = {.count = 1, .reusable = true}, SHIFT(612),
  [1199] = {.count = 1, .reusable = true}, SHIFT(614),
  [1201] = {.count = 1, .reusable = true}, SHIFT(615),
  [1203] = {.count = 1, .reusable = false}, SHIFT(616),
  [1205] = {.count = 1, .reusable = false}, SHIFT(615),
  [1207] = {.count = 1, .reusable = true}, SHIFT(618),
  [1209] = {.count = 1, .reusable = false}, SHIFT(620),
  [1211] = {.count = 1, .reusable = true}, SHIFT(620),
  [1213] = {.count = 1, .reusable = true}, SHIFT(619),
  [1215] = {.count = 1, .reusable = true}, SHIFT(621),
  [1217] = {.count = 1, .reusable = false}, SHIFT(623),
  [1219] = {.count = 1, .reusable = true}, SHIFT(623),
  [1221] = {.count = 1, .reusable = true}, SHIFT(622),
  [1223] = {.count = 1, .reusable = true}, SHIFT(624),
  [1225] = {.count = 1, .reusable = true}, SHIFT(625),
  [1227] = {.count = 1, .reusable = true}, SHIFT(626),
  [1229] = {.count = 1, .reusable = true}, SHIFT(627),
  [1231] = {.count = 1, .reusable = true}, SHIFT(631),
  [1233] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [1235] = {.count = 1, .reusable = false}, SHIFT(632),
  [1237] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [1239] = {.count = 1, .reusable = true}, SHIFT(634),
  [1241] = {.count = 1, .reusable = true}, SHIFT(635),
  [1243] = {.count = 1, .reusable = true}, SHIFT(637),
  [1245] = {.count = 1, .reusable = true}, SHIFT(639),
  [1247] = {.count = 1, .reusable = true}, SHIFT(640),
  [1249] = {.count = 1, .reusable = true}, SHIFT(646),
  [1251] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3),
  [1253] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3),
  [1255] = {.count = 1, .reusable = true}, SHIFT(647),
  [1257] = {.count = 1, .reusable = false}, SHIFT(650),
  [1259] = {.count = 1, .reusable = true}, SHIFT(650),
  [1261] = {.count = 1, .reusable = false}, SHIFT(651),
  [1263] = {.count = 1, .reusable = false}, SHIFT(652),
  [1265] = {.count = 1, .reusable = true}, SHIFT(653),
  [1267] = {.count = 1, .reusable = true}, SHIFT(654),
  [1269] = {.count = 1, .reusable = true}, SHIFT(655),
  [1271] = {.count = 1, .reusable = true}, SHIFT(656),
  [1273] = {.count = 1, .reusable = false}, SHIFT(647),
  [1275] = {.count = 1, .reusable = false}, SHIFT(660),
  [1277] = {.count = 1, .reusable = true}, SHIFT(660),
  [1279] = {.count = 1, .reusable = true}, SHIFT(662),
  [1281] = {.count = 1, .reusable = true}, SHIFT(663),
  [1283] = {.count = 1, .reusable = true}, SHIFT(664),
  [1285] = {.count = 1, .reusable = true}, SHIFT(665),
  [1287] = {.count = 1, .reusable = true}, SHIFT(668),
  [1289] = {.count = 1, .reusable = true}, SHIFT(669),
  [1291] = {.count = 1, .reusable = true}, SHIFT(670),
  [1293] = {.count = 1, .reusable = false}, SHIFT(669),
  [1295] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [1297] = {.count = 1, .reusable = true}, SHIFT(671),
  [1299] = {.count = 1, .reusable = false}, SHIFT(673),
  [1301] = {.count = 1, .reusable = true}, SHIFT(674),
  [1303] = {.count = 1, .reusable = true}, SHIFT(675),
  [1305] = {.count = 1, .reusable = false}, SHIFT(677),
  [1307] = {.count = 1, .reusable = true}, SHIFT(677),
  [1309] = {.count = 1, .reusable = true}, SHIFT(676),
  [1311] = {.count = 1, .reusable = true}, SHIFT(678),
  [1313] = {.count = 1, .reusable = true}, SHIFT(679),
  [1315] = {.count = 1, .reusable = false}, SHIFT(680),
  [1317] = {.count = 1, .reusable = false}, SHIFT(679),
  [1319] = {.count = 1, .reusable = true}, SHIFT(682),
  [1321] = {.count = 1, .reusable = false}, SHIFT(684),
  [1323] = {.count = 1, .reusable = true}, SHIFT(684),
  [1325] = {.count = 1, .reusable = true}, SHIFT(683),
  [1327] = {.count = 1, .reusable = true}, SHIFT(685),
  [1329] = {.count = 1, .reusable = false}, SHIFT(687),
  [1331] = {.count = 1, .reusable = true}, SHIFT(687),
  [1333] = {.count = 1, .reusable = true}, SHIFT(686),
  [1335] = {.count = 1, .reusable = true}, SHIFT(688),
  [1337] = {.count = 1, .reusable = true}, SHIFT(689),
  [1339] = {.count = 1, .reusable = true}, SHIFT(691),
  [1341] = {.count = 1, .reusable = false}, REDUCE(sym_test_command, 3),
  [1343] = {.count = 1, .reusable = false}, SHIFT(692),
  [1345] = {.count = 1, .reusable = false}, SHIFT(693),
  [1347] = {.count = 1, .reusable = false}, SHIFT(694),
  [1349] = {.count = 1, .reusable = true}, REDUCE(sym_test_command, 3),
  [1351] = {.count = 1, .reusable = false}, SHIFT(72),
  [1353] = {.count = 1, .reusable = false}, SHIFT(74),
  [1355] = {.count = 1, .reusable = false}, SHIFT(75),
  [1357] = {.count = 1, .reusable = false}, SHIFT(78),
  [1359] = {.count = 1, .reusable = false}, SHIFT(79),
  [1361] = {.count = 1, .reusable = false}, SHIFT(80),
  [1363] = {.count = 1, .reusable = false}, SHIFT(81),
  [1365] = {.count = 1, .reusable = false}, SHIFT(696),
  [1367] = {.count = 1, .reusable = true}, SHIFT(697),
  [1369] = {.count = 1, .reusable = true}, SHIFT(698),
  [1371] = {.count = 1, .reusable = false}, SHIFT(700),
  [1373] = {.count = 1, .reusable = true}, SHIFT(701),
  [1375] = {.count = 1, .reusable = true}, SHIFT(702),
  [1377] = {.count = 1, .reusable = false}, SHIFT(704),
  [1379] = {.count = 1, .reusable = true}, SHIFT(704),
  [1381] = {.count = 1, .reusable = true}, SHIFT(703),
  [1383] = {.count = 1, .reusable = true}, SHIFT(705),
  [1385] = {.count = 1, .reusable = true}, SHIFT(706),
  [1387] = {.count = 1, .reusable = false}, SHIFT(707),
  [1389] = {.count = 1, .reusable = false}, SHIFT(706),
  [1391] = {.count = 1, .reusable = true}, SHIFT(709),
  [1393] = {.count = 1, .reusable = false}, SHIFT(711),
  [1395] = {.count = 1, .reusable = true}, SHIFT(711),
  [1397] = {.count = 1, .reusable = true}, SHIFT(710),
  [1399] = {.count = 1, .reusable = true}, SHIFT(712),
  [1401] = {.count = 1, .reusable = false}, SHIFT(714),
  [1403] = {.count = 1, .reusable = true}, SHIFT(714),
  [1405] = {.count = 1, .reusable = true}, SHIFT(713),
  [1407] = {.count = 1, .reusable = true}, SHIFT(715),
  [1409] = {.count = 1, .reusable = true}, SHIFT(716),
  [1411] = {.count = 1, .reusable = false}, SHIFT(83),
  [1413] = {.count = 1, .reusable = false}, SHIFT(85),
  [1415] = {.count = 1, .reusable = false}, SHIFT(86),
  [1417] = {.count = 1, .reusable = false}, SHIFT(89),
  [1419] = {.count = 1, .reusable = false}, SHIFT(90),
  [1421] = {.count = 1, .reusable = false}, SHIFT(91),
  [1423] = {.count = 1, .reusable = false}, SHIFT(92),
  [1425] = {.count = 1, .reusable = false}, SHIFT(718),
  [1427] = {.count = 1, .reusable = true}, SHIFT(719),
  [1429] = {.count = 1, .reusable = true}, SHIFT(720),
  [1431] = {.count = 1, .reusable = true}, SHIFT(721),
  [1433] = {.count = 1, .reusable = true}, SHIFT(722),
  [1435] = {.count = 1, .reusable = true}, SHIFT(99),
  [1437] = {.count = 1, .reusable = true}, SHIFT(100),
  [1439] = {.count = 1, .reusable = true}, SHIFT(101),
  [1441] = {.count = 1, .reusable = true}, SHIFT(102),
  [1443] = {.count = 1, .reusable = true}, SHIFT(723),
  [1445] = {.count = 1, .reusable = false}, SHIFT(725),
  [1447] = {.count = 1, .reusable = true}, SHIFT(726),
  [1449] = {.count = 1, .reusable = true}, SHIFT(727),
  [1451] = {.count = 1, .reusable = false}, SHIFT(729),
  [1453] = {.count = 1, .reusable = true}, SHIFT(729),
  [1455] = {.count = 1, .reusable = true}, SHIFT(728),
  [1457] = {.count = 1, .reusable = true}, SHIFT(730),
  [1459] = {.count = 1, .reusable = true}, SHIFT(731),
  [1461] = {.count = 1, .reusable = false}, SHIFT(732),
  [1463] = {.count = 1, .reusable = false}, SHIFT(731),
  [1465] = {.count = 1, .reusable = true}, SHIFT(734),
  [1467] = {.count = 1, .reusable = false}, SHIFT(736),
  [1469] = {.count = 1, .reusable = true}, SHIFT(736),
  [1471] = {.count = 1, .reusable = true}, SHIFT(735),
  [1473] = {.count = 1, .reusable = true}, SHIFT(737),
  [1475] = {.count = 1, .reusable = false}, SHIFT(739),
  [1477] = {.count = 1, .reusable = true}, SHIFT(739),
  [1479] = {.count = 1, .reusable = true}, SHIFT(738),
  [1481] = {.count = 1, .reusable = true}, SHIFT(740),
  [1483] = {.count = 1, .reusable = true}, SHIFT(741),
  [1485] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(94),
  [1488] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1490] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(95),
  [1493] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(96),
  [1496] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(97),
  [1499] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(98),
  [1502] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(99),
  [1505] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(100),
  [1508] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(101),
  [1511] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(102),
  [1514] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(103),
  [1517] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1519] = {.count = 1, .reusable = true}, SHIFT(742),
  [1521] = {.count = 1, .reusable = true}, SHIFT(110),
  [1523] = {.count = 1, .reusable = true}, SHIFT(111),
  [1525] = {.count = 1, .reusable = true}, SHIFT(112),
  [1527] = {.count = 1, .reusable = true}, SHIFT(113),
  [1529] = {.count = 1, .reusable = false}, SHIFT(744),
  [1531] = {.count = 1, .reusable = true}, SHIFT(745),
  [1533] = {.count = 1, .reusable = true}, SHIFT(746),
  [1535] = {.count = 1, .reusable = false}, SHIFT(748),
  [1537] = {.count = 1, .reusable = true}, SHIFT(748),
  [1539] = {.count = 1, .reusable = true}, SHIFT(747),
  [1541] = {.count = 1, .reusable = true}, SHIFT(749),
  [1543] = {.count = 1, .reusable = true}, SHIFT(750),
  [1545] = {.count = 1, .reusable = false}, SHIFT(751),
  [1547] = {.count = 1, .reusable = false}, SHIFT(750),
  [1549] = {.count = 1, .reusable = true}, SHIFT(753),
  [1551] = {.count = 1, .reusable = false}, SHIFT(755),
  [1553] = {.count = 1, .reusable = true}, SHIFT(755),
  [1555] = {.count = 1, .reusable = true}, SHIFT(754),
  [1557] = {.count = 1, .reusable = true}, SHIFT(756),
  [1559] = {.count = 1, .reusable = false}, SHIFT(758),
  [1561] = {.count = 1, .reusable = true}, SHIFT(758),
  [1563] = {.count = 1, .reusable = true}, SHIFT(757),
  [1565] = {.count = 1, .reusable = true}, SHIFT(759),
  [1567] = {.count = 1, .reusable = true}, SHIFT(760),
  [1569] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1571] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(106),
  [1574] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(107),
  [1577] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(108),
  [1580] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(109),
  [1583] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(110),
  [1586] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(111),
  [1589] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(112),
  [1592] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(113),
  [1595] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(114),
  [1598] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1600] = {.count = 1, .reusable = true}, SHIFT(761),
  [1602] = {.count = 1, .reusable = false}, SHIFT(763),
  [1604] = {.count = 1, .reusable = true}, SHIFT(764),
  [1606] = {.count = 1, .reusable = true}, SHIFT(765),
  [1608] = {.count = 1, .reusable = false}, SHIFT(767),
  [1610] = {.count = 1, .reusable = true}, SHIFT(767),
  [1612] = {.count = 1, .reusable = true}, SHIFT(766),
  [1614] = {.count = 1, .reusable = true}, SHIFT(768),
  [1616] = {.count = 1, .reusable = true}, SHIFT(769),
  [1618] = {.count = 1, .reusable = false}, SHIFT(770),
  [1620] = {.count = 1, .reusable = false}, SHIFT(769),
  [1622] = {.count = 1, .reusable = true}, SHIFT(772),
  [1624] = {.count = 1, .reusable = false}, SHIFT(774),
  [1626] = {.count = 1, .reusable = true}, SHIFT(774),
  [1628] = {.count = 1, .reusable = true}, SHIFT(773),
  [1630] = {.count = 1, .reusable = true}, SHIFT(775),
  [1632] = {.count = 1, .reusable = false}, SHIFT(777),
  [1634] = {.count = 1, .reusable = true}, SHIFT(777),
  [1636] = {.count = 1, .reusable = true}, SHIFT(776),
  [1638] = {.count = 1, .reusable = true}, SHIFT(778),
  [1640] = {.count = 1, .reusable = true}, SHIFT(779),
  [1642] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1644] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1646] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(125),
  [1649] = {.count = 1, .reusable = true}, SHIFT(780),
  [1651] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [1653] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [1655] = {.count = 1, .reusable = true}, SHIFT(781),
  [1657] = {.count = 1, .reusable = true}, SHIFT(782),
  [1659] = {.count = 1, .reusable = false}, SHIFT(784),
  [1661] = {.count = 1, .reusable = true}, SHIFT(784),
  [1663] = {.count = 1, .reusable = true}, SHIFT(783),
  [1665] = {.count = 1, .reusable = true}, SHIFT(785),
  [1667] = {.count = 1, .reusable = true}, SHIFT(786),
  [1669] = {.count = 1, .reusable = false}, SHIFT(787),
  [1671] = {.count = 1, .reusable = false}, SHIFT(786),
  [1673] = {.count = 1, .reusable = true}, SHIFT(789),
  [1675] = {.count = 1, .reusable = false}, SHIFT(791),
  [1677] = {.count = 1, .reusable = true}, SHIFT(791),
  [1679] = {.count = 1, .reusable = true}, SHIFT(790),
  [1681] = {.count = 1, .reusable = true}, SHIFT(792),
  [1683] = {.count = 1, .reusable = false}, SHIFT(794),
  [1685] = {.count = 1, .reusable = true}, SHIFT(794),
  [1687] = {.count = 1, .reusable = true}, SHIFT(793),
  [1689] = {.count = 1, .reusable = true}, SHIFT(795),
  [1691] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1693] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1695] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(128),
  [1698] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(129),
  [1701] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(130),
  [1704] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(131),
  [1707] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(132),
  [1710] = {.count = 1, .reusable = true}, SHIFT(796),
  [1712] = {.count = 1, .reusable = true}, SHIFT(797),
  [1714] = {.count = 1, .reusable = true}, SHIFT(799),
  [1716] = {.count = 1, .reusable = false}, SHIFT(800),
  [1718] = {.count = 1, .reusable = true}, SHIFT(801),
  [1720] = {.count = 1, .reusable = false}, SHIFT(802),
  [1722] = {.count = 1, .reusable = true}, SHIFT(803),
  [1724] = {.count = 1, .reusable = true}, SHIFT(804),
  [1726] = {.count = 1, .reusable = true}, SHIFT(805),
  [1728] = {.count = 1, .reusable = true}, SHIFT(806),
  [1730] = {.count = 1, .reusable = true}, SHIFT(807),
  [1732] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [1734] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [1736] = {.count = 1, .reusable = true}, SHIFT(809),
  [1738] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1740] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1742] = {.count = 1, .reusable = false}, SHIFT(811),
  [1744] = {.count = 1, .reusable = true}, SHIFT(813),
  [1746] = {.count = 1, .reusable = true}, SHIFT(814),
  [1748] = {.count = 1, .reusable = false}, SHIFT(815),
  [1750] = {.count = 1, .reusable = false}, SHIFT(813),
  [1752] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1754] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1756] = {.count = 1, .reusable = true}, SHIFT(816),
  [1758] = {.count = 1, .reusable = true}, SHIFT(817),
  [1760] = {.count = 1, .reusable = true}, SHIFT(818),
  [1762] = {.count = 1, .reusable = false}, SHIFT(819),
  [1764] = {.count = 1, .reusable = false}, SHIFT(817),
  [1766] = {.count = 1, .reusable = true}, SHIFT(821),
  [1768] = {.count = 1, .reusable = true}, SHIFT(828),
  [1770] = {.count = 1, .reusable = false}, SHIFT(829),
  [1772] = {.count = 1, .reusable = true}, SHIFT(829),
  [1774] = {.count = 1, .reusable = true}, SHIFT(830),
  [1776] = {.count = 1, .reusable = true}, SHIFT(831),
  [1778] = {.count = 1, .reusable = false}, SHIFT(833),
  [1780] = {.count = 1, .reusable = true}, SHIFT(833),
  [1782] = {.count = 1, .reusable = true}, SHIFT(832),
  [1784] = {.count = 1, .reusable = true}, SHIFT(834),
  [1786] = {.count = 1, .reusable = false}, SHIFT(836),
  [1788] = {.count = 1, .reusable = true}, SHIFT(836),
  [1790] = {.count = 1, .reusable = true}, SHIFT(835),
  [1792] = {.count = 1, .reusable = false}, SHIFT(838),
  [1794] = {.count = 1, .reusable = true}, SHIFT(838),
  [1796] = {.count = 1, .reusable = true}, SHIFT(837),
  [1798] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 5),
  [1800] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 5),
  [1802] = {.count = 1, .reusable = true}, SHIFT(839),
  [1804] = {.count = 1, .reusable = true}, SHIFT(840),
  [1806] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3),
  [1808] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3),
  [1810] = {.count = 1, .reusable = true}, SHIFT(841),
  [1812] = {.count = 1, .reusable = true}, SHIFT(842),
  [1814] = {.count = 1, .reusable = true}, SHIFT(843),
  [1816] = {.count = 1, .reusable = false}, SHIFT(844),
  [1818] = {.count = 1, .reusable = false}, SHIFT(845),
  [1820] = {.count = 1, .reusable = true}, SHIFT(845),
  [1822] = {.count = 1, .reusable = true}, SHIFT(846),
  [1824] = {.count = 1, .reusable = true}, SHIFT(848),
  [1826] = {.count = 1, .reusable = false}, SHIFT(849),
  [1828] = {.count = 1, .reusable = false}, SHIFT(850),
  [1830] = {.count = 1, .reusable = true}, SHIFT(850),
  [1832] = {.count = 1, .reusable = false}, SHIFT(851),
  [1834] = {.count = 1, .reusable = false}, SHIFT(852),
  [1836] = {.count = 1, .reusable = true}, SHIFT(852),
  [1838] = {.count = 1, .reusable = true}, SHIFT(853),
  [1840] = {.count = 1, .reusable = true}, SHIFT(854),
  [1842] = {.count = 1, .reusable = false}, SHIFT(856),
  [1844] = {.count = 1, .reusable = false}, SHIFT(857),
  [1846] = {.count = 1, .reusable = true}, SHIFT(857),
  [1848] = {.count = 1, .reusable = true}, SHIFT(860),
  [1850] = {.count = 1, .reusable = true}, SHIFT(861),
  [1852] = {.count = 1, .reusable = true}, SHIFT(862),
  [1854] = {.count = 1, .reusable = false}, SHIFT(864),
  [1856] = {.count = 1, .reusable = true}, SHIFT(866),
  [1858] = {.count = 1, .reusable = true}, SHIFT(867),
  [1860] = {.count = 1, .reusable = false}, SHIFT(868),
  [1862] = {.count = 1, .reusable = false}, SHIFT(866),
  [1864] = {.count = 1, .reusable = true}, SHIFT(869),
  [1866] = {.count = 1, .reusable = true}, SHIFT(870),
  [1868] = {.count = 1, .reusable = true}, SHIFT(871),
  [1870] = {.count = 1, .reusable = false}, SHIFT(872),
  [1872] = {.count = 1, .reusable = false}, SHIFT(870),
  [1874] = {.count = 1, .reusable = true}, SHIFT(881),
  [1876] = {.count = 1, .reusable = false}, SHIFT(883),
  [1878] = {.count = 1, .reusable = true}, SHIFT(885),
  [1880] = {.count = 1, .reusable = true}, SHIFT(886),
  [1882] = {.count = 1, .reusable = false}, SHIFT(887),
  [1884] = {.count = 1, .reusable = false}, SHIFT(885),
  [1886] = {.count = 1, .reusable = true}, SHIFT(888),
  [1888] = {.count = 1, .reusable = true}, SHIFT(889),
  [1890] = {.count = 1, .reusable = true}, SHIFT(890),
  [1892] = {.count = 1, .reusable = false}, SHIFT(891),
  [1894] = {.count = 1, .reusable = false}, SHIFT(889),
  [1896] = {.count = 1, .reusable = true}, SHIFT(900),
  [1898] = {.count = 1, .reusable = false}, SHIFT(902),
  [1900] = {.count = 1, .reusable = true}, SHIFT(903),
  [1902] = {.count = 1, .reusable = true}, SHIFT(904),
  [1904] = {.count = 1, .reusable = false}, SHIFT(906),
  [1906] = {.count = 1, .reusable = true}, SHIFT(906),
  [1908] = {.count = 1, .reusable = true}, SHIFT(905),
  [1910] = {.count = 1, .reusable = true}, SHIFT(907),
  [1912] = {.count = 1, .reusable = true}, SHIFT(908),
  [1914] = {.count = 1, .reusable = false}, SHIFT(909),
  [1916] = {.count = 1, .reusable = false}, SHIFT(908),
  [1918] = {.count = 1, .reusable = true}, SHIFT(911),
  [1920] = {.count = 1, .reusable = false}, SHIFT(913),
  [1922] = {.count = 1, .reusable = true}, SHIFT(913),
  [1924] = {.count = 1, .reusable = true}, SHIFT(912),
  [1926] = {.count = 1, .reusable = true}, SHIFT(914),
  [1928] = {.count = 1, .reusable = false}, SHIFT(916),
  [1930] = {.count = 1, .reusable = true}, SHIFT(916),
  [1932] = {.count = 1, .reusable = true}, SHIFT(915),
  [1934] = {.count = 1, .reusable = true}, SHIFT(917),
  [1936] = {.count = 1, .reusable = true}, SHIFT(918),
  [1938] = {.count = 1, .reusable = true}, SHIFT(919),
  [1940] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 3),
  [1942] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 3),
  [1944] = {.count = 1, .reusable = true}, SHIFT(925),
  [1946] = {.count = 1, .reusable = true}, SHIFT(924),
  [1948] = {.count = 1, .reusable = false}, SHIFT(926),
  [1950] = {.count = 1, .reusable = true}, SHIFT(926),
  [1952] = {.count = 1, .reusable = false}, SHIFT(927),
  [1954] = {.count = 1, .reusable = false}, SHIFT(155),
  [1956] = {.count = 1, .reusable = false}, SHIFT(928),
  [1958] = {.count = 1, .reusable = false}, SHIFT(158),
  [1960] = {.count = 1, .reusable = false}, SHIFT(159),
  [1962] = {.count = 1, .reusable = false}, SHIFT(160),
  [1964] = {.count = 1, .reusable = false}, SHIFT(161),
  [1966] = {.count = 1, .reusable = false}, SHIFT(929),
  [1968] = {.count = 1, .reusable = true}, SHIFT(930),
  [1970] = {.count = 1, .reusable = true}, SHIFT(931),
  [1972] = {.count = 1, .reusable = true}, SHIFT(933),
  [1974] = {.count = 1, .reusable = true}, SHIFT(934),
  [1976] = {.count = 1, .reusable = true}, SHIFT(935),
  [1978] = {.count = 1, .reusable = true}, SHIFT(942),
  [1980] = {.count = 1, .reusable = true}, SHIFT(943),
  [1982] = {.count = 1, .reusable = true}, SHIFT(945),
  [1984] = {.count = 1, .reusable = true}, SHIFT(947),
  [1986] = {.count = 1, .reusable = true}, SHIFT(948),
  [1988] = {.count = 1, .reusable = true}, SHIFT(954),
  [1990] = {.count = 1, .reusable = false}, SHIFT(958),
  [1992] = {.count = 1, .reusable = true}, SHIFT(958),
  [1994] = {.count = 1, .reusable = false}, SHIFT(959),
  [1996] = {.count = 1, .reusable = false}, SHIFT(960),
  [1998] = {.count = 1, .reusable = true}, SHIFT(961),
  [2000] = {.count = 1, .reusable = true}, SHIFT(962),
  [2002] = {.count = 1, .reusable = true}, SHIFT(963),
  [2004] = {.count = 1, .reusable = true}, SHIFT(964),
  [2006] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 3),
  [2008] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 3),
  [2010] = {.count = 1, .reusable = false}, REDUCE(sym_pipeline, 3),
  [2012] = {.count = 1, .reusable = true}, REDUCE(sym_pipeline, 3),
  [2014] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [2016] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [2018] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [2020] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [2022] = {.count = 1, .reusable = true}, SHIFT(970),
  [2024] = {.count = 1, .reusable = false}, SHIFT(971),
  [2026] = {.count = 1, .reusable = false}, SHIFT(970),
  [2028] = {.count = 1, .reusable = true}, SHIFT(972),
  [2030] = {.count = 1, .reusable = true}, SHIFT(973),
  [2032] = {.count = 1, .reusable = true}, SHIFT(974),
  [2034] = {.count = 1, .reusable = false}, SHIFT(975),
  [2036] = {.count = 1, .reusable = false}, SHIFT(973),
  [2038] = {.count = 1, .reusable = true}, SHIFT(978),
  [2040] = {.count = 1, .reusable = true}, SHIFT(977),
  [2042] = {.count = 1, .reusable = true}, SHIFT(979),
  [2044] = {.count = 1, .reusable = true}, SHIFT(980),
  [2046] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 3),
  [2048] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 3),
  [2050] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2),
  [2052] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2),
  [2054] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_redirect, 2),
  [2056] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_redirect, 2),
  [2058] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 3),
  [2060] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 3),
  [2062] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2),
  [2064] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2),
  [2066] = {.count = 1, .reusable = false}, REDUCE(sym_command, 3),
  [2068] = {.count = 1, .reusable = true}, REDUCE(sym_command, 3),
  [2070] = {.count = 1, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [2072] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(193),
  [2075] = {.count = 1, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [2077] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(195),
  [2080] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(196),
  [2083] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(197),
  [2086] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(194),
  [2089] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(198),
  [2092] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(17),
  [2095] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(18),
  [2098] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(199),
  [2101] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(20),
  [2104] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(21),
  [2107] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(22),
  [2110] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(23),
  [2113] = {.count = 1, .reusable = true}, SHIFT(985),
  [2115] = {.count = 1, .reusable = false}, SHIFT(671),
  [2117] = {.count = 1, .reusable = true}, SHIFT(986),
  [2119] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4, .alias_sequence_id = 6),
  [2121] = {.count = 1, .reusable = true}, SHIFT(988),
  [2123] = {.count = 1, .reusable = true}, SHIFT(989),
  [2125] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4),
  [2127] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [2129] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [2131] = {.count = 1, .reusable = true}, SHIFT(990),
  [2133] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2135] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2137] = {.count = 1, .reusable = false}, SHIFT(992),
  [2139] = {.count = 1, .reusable = true}, SHIFT(994),
  [2141] = {.count = 1, .reusable = true}, SHIFT(995),
  [2143] = {.count = 1, .reusable = false}, SHIFT(996),
  [2145] = {.count = 1, .reusable = false}, SHIFT(994),
  [2147] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2149] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2151] = {.count = 1, .reusable = true}, SHIFT(997),
  [2153] = {.count = 1, .reusable = true}, SHIFT(998),
  [2155] = {.count = 1, .reusable = true}, SHIFT(999),
  [2157] = {.count = 1, .reusable = false}, SHIFT(1000),
  [2159] = {.count = 1, .reusable = false}, SHIFT(998),
  [2161] = {.count = 1, .reusable = true}, SHIFT(1008),
  [2163] = {.count = 1, .reusable = true}, SHIFT(1010),
  [2165] = {.count = 1, .reusable = false}, SHIFT(1012),
  [2167] = {.count = 1, .reusable = true}, SHIFT(1013),
  [2169] = {.count = 1, .reusable = true}, SHIFT(1014),
  [2171] = {.count = 1, .reusable = false}, SHIFT(1016),
  [2173] = {.count = 1, .reusable = true}, SHIFT(1016),
  [2175] = {.count = 1, .reusable = true}, SHIFT(1015),
  [2177] = {.count = 1, .reusable = true}, SHIFT(1017),
  [2179] = {.count = 1, .reusable = true}, SHIFT(1018),
  [2181] = {.count = 1, .reusable = false}, SHIFT(1019),
  [2183] = {.count = 1, .reusable = false}, SHIFT(1018),
  [2185] = {.count = 1, .reusable = true}, SHIFT(1021),
  [2187] = {.count = 1, .reusable = false}, SHIFT(1023),
  [2189] = {.count = 1, .reusable = true}, SHIFT(1023),
  [2191] = {.count = 1, .reusable = true}, SHIFT(1022),
  [2193] = {.count = 1, .reusable = true}, SHIFT(1024),
  [2195] = {.count = 1, .reusable = false}, SHIFT(1026),
  [2197] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2199] = {.count = 1, .reusable = true}, SHIFT(1025),
  [2201] = {.count = 1, .reusable = true}, SHIFT(1027),
  [2203] = {.count = 1, .reusable = true}, SHIFT(1028),
  [2205] = {.count = 1, .reusable = false}, SHIFT(1030),
  [2207] = {.count = 1, .reusable = false}, SHIFT(587),
  [2209] = {.count = 1, .reusable = false}, SHIFT(43),
  [2211] = {.count = 1, .reusable = false}, SHIFT(588),
  [2213] = {.count = 1, .reusable = false}, SHIFT(46),
  [2215] = {.count = 1, .reusable = false}, SHIFT(47),
  [2217] = {.count = 1, .reusable = false}, SHIFT(48),
  [2219] = {.count = 1, .reusable = false}, SHIFT(49),
  [2221] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2223] = {.count = 1, .reusable = false}, SHIFT(1032),
  [2225] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 4, .alias_sequence_id = 5),
  [2227] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 4, .alias_sequence_id = 5),
  [2229] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 2),
  [2231] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 2),
  [2233] = {.count = 1, .reusable = false}, SHIFT(1034),
  [2235] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 4),
  [2237] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 4),
  [2239] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4),
  [2241] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4),
  [2243] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 1),
  [2245] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 1),
  [2247] = {.count = 1, .reusable = true}, SHIFT(1039),
  [2249] = {.count = 1, .reusable = false}, SHIFT(1039),
  [2251] = {.count = 1, .reusable = true}, SHIFT(597),
  [2253] = {.count = 1, .reusable = true}, SHIFT(598),
  [2255] = {.count = 1, .reusable = false}, SHIFT(1044),
  [2257] = {.count = 1, .reusable = true}, SHIFT(1045),
  [2259] = {.count = 1, .reusable = true}, SHIFT(1046),
  [2261] = {.count = 1, .reusable = false}, SHIFT(1046),
  [2263] = {.count = 1, .reusable = false}, SHIFT(1050),
  [2265] = {.count = 1, .reusable = true}, SHIFT(1050),
  [2267] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(228),
  [2270] = {.count = 1, .reusable = false}, SHIFT(1051),
  [2272] = {.count = 1, .reusable = false}, SHIFT(1054),
  [2274] = {.count = 1, .reusable = true}, SHIFT(1054),
  [2276] = {.count = 1, .reusable = true}, SHIFT(1055),
  [2278] = {.count = 1, .reusable = false}, SHIFT(1056),
  [2280] = {.count = 1, .reusable = true}, SHIFT(1057),
  [2282] = {.count = 1, .reusable = true}, SHIFT(1059),
  [2284] = {.count = 1, .reusable = true}, SHIFT(1060),
  [2286] = {.count = 1, .reusable = true}, SHIFT(1061),
  [2288] = {.count = 1, .reusable = true}, SHIFT(1062),
  [2290] = {.count = 1, .reusable = false}, SHIFT(1064),
  [2292] = {.count = 1, .reusable = true}, SHIFT(1064),
  [2294] = {.count = 1, .reusable = true}, SHIFT(1063),
  [2296] = {.count = 1, .reusable = true}, SHIFT(1065),
  [2298] = {.count = 1, .reusable = false}, SHIFT(1067),
  [2300] = {.count = 1, .reusable = true}, SHIFT(1067),
  [2302] = {.count = 1, .reusable = true}, SHIFT(1066),
  [2304] = {.count = 1, .reusable = false}, SHIFT(1069),
  [2306] = {.count = 1, .reusable = true}, SHIFT(1069),
  [2308] = {.count = 1, .reusable = true}, SHIFT(1068),
  [2310] = {.count = 1, .reusable = true}, SHIFT(1070),
  [2312] = {.count = 1, .reusable = true}, SHIFT(1071),
  [2314] = {.count = 1, .reusable = true}, SHIFT(1072),
  [2316] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [2318] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [2320] = {.count = 1, .reusable = false}, SHIFT(1074),
  [2322] = {.count = 1, .reusable = true}, SHIFT(1074),
  [2324] = {.count = 1, .reusable = true}, SHIFT(1075),
  [2326] = {.count = 1, .reusable = false}, SHIFT(1077),
  [2328] = {.count = 1, .reusable = true}, SHIFT(1077),
  [2330] = {.count = 1, .reusable = true}, SHIFT(1078),
  [2332] = {.count = 1, .reusable = true}, SHIFT(1079),
  [2334] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 4),
  [2336] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 4),
  [2338] = {.count = 1, .reusable = true}, SHIFT(1083),
  [2340] = {.count = 1, .reusable = true}, SHIFT(1084),
  [2342] = {.count = 1, .reusable = false}, SHIFT(1085),
  [2344] = {.count = 1, .reusable = true}, SHIFT(1086),
  [2346] = {.count = 1, .reusable = false}, SHIFT(1087),
  [2348] = {.count = 1, .reusable = false}, SHIFT(1088),
  [2350] = {.count = 1, .reusable = true}, SHIFT(1090),
  [2352] = {.count = 1, .reusable = true}, SHIFT(1091),
  [2354] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(258),
  [2357] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(259),
  [2360] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(260),
  [2363] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(263),
  [2366] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(264),
  [2369] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 4),
  [2371] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 4),
  [2373] = {.count = 1, .reusable = true}, SHIFT(1095),
  [2375] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2377] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(272),
  [2380] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(274),
  [2383] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(275),
  [2386] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(273),
  [2389] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(276),
  [2392] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(277),
  [2395] = {.count = 1, .reusable = true}, SHIFT(1098),
  [2397] = {.count = 1, .reusable = true}, SHIFT(1100),
  [2399] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2401] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2403] = {.count = 1, .reusable = false}, SHIFT(286),
  [2405] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(290),
  [2408] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2410] = {.count = 1, .reusable = false}, SHIFT(1104),
  [2412] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2414] = {.count = 1, .reusable = true}, SHIFT(1107),
  [2416] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2418] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2420] = {.count = 1, .reusable = true}, SHIFT(1110),
  [2422] = {.count = 1, .reusable = false}, SHIFT(1112),
  [2424] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2426] = {.count = 1, .reusable = true}, SHIFT(1111),
  [2428] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2430] = {.count = 1, .reusable = false}, SHIFT(1115),
  [2432] = {.count = 1, .reusable = true}, SHIFT(1115),
  [2434] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2436] = {.count = 1, .reusable = false}, SHIFT(1117),
  [2438] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2440] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2442] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2444] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2446] = {.count = 1, .reusable = true}, SHIFT(1120),
  [2448] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [2450] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [2452] = {.count = 1, .reusable = false}, SHIFT(1121),
  [2454] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2456] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2458] = {.count = 1, .reusable = true}, SHIFT(1123),
  [2460] = {.count = 1, .reusable = false}, SHIFT(1124),
  [2462] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2464] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2466] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2468] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2470] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2472] = {.count = 1, .reusable = true}, SHIFT(1131),
  [2474] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2476] = {.count = 1, .reusable = true}, SHIFT(1133),
  [2478] = {.count = 1, .reusable = false}, REDUCE(sym_test_command, 4),
  [2480] = {.count = 1, .reusable = true}, REDUCE(sym_test_command, 4),
  [2482] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(313),
  [2485] = {.count = 1, .reusable = true}, SHIFT(1136),
  [2487] = {.count = 1, .reusable = false}, SHIFT(1137),
  [2489] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2491] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2493] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2495] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2497] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2499] = {.count = 1, .reusable = false}, SHIFT(1145),
  [2501] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2503] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2505] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2507] = {.count = 1, .reusable = false}, SHIFT(1148),
  [2509] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2511] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2513] = {.count = 1, .reusable = false}, SHIFT(1150),
  [2515] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2517] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2519] = {.count = 1, .reusable = true}, SHIFT(1151),
  [2521] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2523] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2525] = {.count = 1, .reusable = true}, SHIFT(1154),
  [2527] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(334),
  [2530] = {.count = 1, .reusable = true}, SHIFT(1156),
  [2532] = {.count = 1, .reusable = false}, SHIFT(1157),
  [2534] = {.count = 1, .reusable = true}, SHIFT(1158),
  [2536] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2538] = {.count = 1, .reusable = true}, SHIFT(1161),
  [2540] = {.count = 1, .reusable = true}, SHIFT(1162),
  [2542] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2544] = {.count = 1, .reusable = false}, SHIFT(1165),
  [2546] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2548] = {.count = 1, .reusable = true}, SHIFT(1164),
  [2550] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2552] = {.count = 1, .reusable = false}, SHIFT(1168),
  [2554] = {.count = 1, .reusable = true}, SHIFT(1168),
  [2556] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2558] = {.count = 1, .reusable = false}, SHIFT(1170),
  [2560] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2562] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2564] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2566] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2568] = {.count = 1, .reusable = true}, SHIFT(1173),
  [2570] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(353),
  [2573] = {.count = 1, .reusable = true}, SHIFT(1174),
  [2575] = {.count = 1, .reusable = false}, SHIFT(1175),
  [2577] = {.count = 1, .reusable = true}, SHIFT(1176),
  [2579] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2581] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2583] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2585] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2587] = {.count = 1, .reusable = false}, SHIFT(1183),
  [2589] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2591] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2593] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2595] = {.count = 1, .reusable = false}, SHIFT(1186),
  [2597] = {.count = 1, .reusable = true}, SHIFT(1186),
  [2599] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2601] = {.count = 1, .reusable = false}, SHIFT(1188),
  [2603] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2605] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2607] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2609] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2611] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2613] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(372),
  [2616] = {.count = 1, .reusable = true}, SHIFT(1192),
  [2618] = {.count = 1, .reusable = false}, SHIFT(1193),
  [2620] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2622] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2624] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2626] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2628] = {.count = 1, .reusable = true}, SHIFT(1199),
  [2630] = {.count = 1, .reusable = false}, SHIFT(1201),
  [2632] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2634] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2636] = {.count = 1, .reusable = true}, SHIFT(1202),
  [2638] = {.count = 1, .reusable = false}, SHIFT(1204),
  [2640] = {.count = 1, .reusable = true}, SHIFT(1204),
  [2642] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2644] = {.count = 1, .reusable = false}, SHIFT(1206),
  [2646] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2648] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2650] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2652] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2654] = {.count = 1, .reusable = true}, SHIFT(1209),
  [2656] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 3),
  [2658] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 3),
  [2660] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2662] = {.count = 1, .reusable = false}, SHIFT(1211),
  [2664] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2666] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2668] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2670] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2672] = {.count = 1, .reusable = true}, SHIFT(1217),
  [2674] = {.count = 1, .reusable = false}, SHIFT(1219),
  [2676] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2678] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2680] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2682] = {.count = 1, .reusable = false}, SHIFT(1222),
  [2684] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2686] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2688] = {.count = 1, .reusable = false}, SHIFT(1224),
  [2690] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2692] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2694] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2696] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2698] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2700] = {.count = 1, .reusable = true}, SHIFT(1228),
  [2702] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2704] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2706] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2708] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2710] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4),
  [2712] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4),
  [2714] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2716] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2718] = {.count = 1, .reusable = false}, SHIFT(1236),
  [2720] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2722] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2724] = {.count = 1, .reusable = false}, SHIFT(1240),
  [2726] = {.count = 1, .reusable = false}, SHIFT(1238),
  [2728] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2730] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2732] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2734] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2736] = {.count = 1, .reusable = false}, SHIFT(1245),
  [2738] = {.count = 1, .reusable = false}, SHIFT(1243),
  [2740] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2742] = {.count = 1, .reusable = false}, SHIFT(1255),
  [2744] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2746] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2748] = {.count = 1, .reusable = false}, SHIFT(1259),
  [2750] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2752] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2754] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2756] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2758] = {.count = 1, .reusable = false}, SHIFT(1262),
  [2760] = {.count = 1, .reusable = false}, SHIFT(1261),
  [2762] = {.count = 1, .reusable = true}, SHIFT(1264),
  [2764] = {.count = 1, .reusable = false}, SHIFT(1266),
  [2766] = {.count = 1, .reusable = true}, SHIFT(1266),
  [2768] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2770] = {.count = 1, .reusable = true}, SHIFT(1267),
  [2772] = {.count = 1, .reusable = false}, SHIFT(1269),
  [2774] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2776] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2778] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2780] = {.count = 1, .reusable = false}, SHIFT(1271),
  [2782] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2784] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2786] = {.count = 1, .reusable = true}, SHIFT(1273),
  [2788] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [2790] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [2792] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2),
  [2794] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(829),
  [2797] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(410),
  [2800] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(411),
  [2803] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(412),
  [2806] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(413),
  [2809] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(829),
  [2812] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(414),
  [2815] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(416),
  [2818] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(417),
  [2821] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(418),
  [2824] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(413),
  [2827] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2829] = {.count = 1, .reusable = true}, SHIFT(1275),
  [2831] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 7),
  [2833] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 7),
  [2835] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2837] = {.count = 1, .reusable = true}, SHIFT(1278),
  [2839] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 8),
  [2841] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 8),
  [2843] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2845] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2847] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2849] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2851] = {.count = 1, .reusable = false}, SHIFT(1283),
  [2853] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2855] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2857] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2859] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2861] = {.count = 1, .reusable = false}, SHIFT(1285),
  [2863] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2865] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2867] = {.count = 1, .reusable = false}, SHIFT(1290),
  [2869] = {.count = 1, .reusable = false}, SHIFT(1294),
  [2871] = {.count = 1, .reusable = false}, SHIFT(1298),
  [2873] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2875] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2877] = {.count = 1, .reusable = false}, SHIFT(1300),
  [2879] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2881] = {.count = 1, .reusable = true}, SHIFT(1301),
  [2883] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2885] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2887] = {.count = 1, .reusable = true}, SHIFT(1305),
  [2889] = {.count = 1, .reusable = false}, SHIFT(1306),
  [2891] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2893] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2895] = {.count = 1, .reusable = false}, SHIFT(1308),
  [2897] = {.count = 1, .reusable = false}, SHIFT(1309),
  [2899] = {.count = 1, .reusable = true}, SHIFT(1309),
  [2901] = {.count = 1, .reusable = true}, SHIFT(1310),
  [2903] = {.count = 1, .reusable = false}, SHIFT(1311),
  [2905] = {.count = 1, .reusable = true}, SHIFT(1311),
  [2907] = {.count = 1, .reusable = false}, SHIFT(1312),
  [2909] = {.count = 1, .reusable = true}, SHIFT(1312),
  [2911] = {.count = 1, .reusable = true}, SHIFT(1313),
  [2913] = {.count = 1, .reusable = true}, SHIFT(1315),
  [2915] = {.count = 1, .reusable = true}, SHIFT(1316),
  [2917] = {.count = 1, .reusable = true}, SHIFT(1317),
  [2919] = {.count = 1, .reusable = true}, SHIFT(1318),
  [2921] = {.count = 1, .reusable = true}, SHIFT(1319),
  [2923] = {.count = 1, .reusable = false}, SHIFT(1321),
  [2925] = {.count = 1, .reusable = true}, SHIFT(1322),
  [2927] = {.count = 1, .reusable = true}, SHIFT(1323),
  [2929] = {.count = 1, .reusable = false}, SHIFT(1325),
  [2931] = {.count = 1, .reusable = true}, SHIFT(1325),
  [2933] = {.count = 1, .reusable = true}, SHIFT(1324),
  [2935] = {.count = 1, .reusable = true}, SHIFT(1326),
  [2937] = {.count = 1, .reusable = true}, SHIFT(1327),
  [2939] = {.count = 1, .reusable = false}, SHIFT(1328),
  [2941] = {.count = 1, .reusable = false}, SHIFT(1327),
  [2943] = {.count = 1, .reusable = true}, SHIFT(1330),
  [2945] = {.count = 1, .reusable = false}, SHIFT(1332),
  [2947] = {.count = 1, .reusable = true}, SHIFT(1332),
  [2949] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2951] = {.count = 1, .reusable = true}, SHIFT(1333),
  [2953] = {.count = 1, .reusable = false}, SHIFT(1335),
  [2955] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2957] = {.count = 1, .reusable = true}, SHIFT(1334),
  [2959] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2961] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2963] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(444),
  [2966] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(445),
  [2969] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(446),
  [2972] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(447),
  [2975] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(448),
  [2978] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(449),
  [2981] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(450),
  [2984] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(451),
  [2987] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(452),
  [2990] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(453),
  [2993] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(448),
  [2996] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2998] = {.count = 1, .reusable = false}, SHIFT(1340),
  [3000] = {.count = 1, .reusable = true}, SHIFT(1341),
  [3002] = {.count = 1, .reusable = true}, SHIFT(1342),
  [3004] = {.count = 1, .reusable = false}, SHIFT(1344),
  [3006] = {.count = 1, .reusable = true}, SHIFT(1344),
  [3008] = {.count = 1, .reusable = true}, SHIFT(1343),
  [3010] = {.count = 1, .reusable = true}, SHIFT(1345),
  [3012] = {.count = 1, .reusable = true}, SHIFT(1346),
  [3014] = {.count = 1, .reusable = false}, SHIFT(1347),
  [3016] = {.count = 1, .reusable = false}, SHIFT(1346),
  [3018] = {.count = 1, .reusable = true}, SHIFT(1349),
  [3020] = {.count = 1, .reusable = false}, SHIFT(1351),
  [3022] = {.count = 1, .reusable = true}, SHIFT(1351),
  [3024] = {.count = 1, .reusable = true}, SHIFT(1350),
  [3026] = {.count = 1, .reusable = true}, SHIFT(1352),
  [3028] = {.count = 1, .reusable = false}, SHIFT(1354),
  [3030] = {.count = 1, .reusable = true}, SHIFT(1354),
  [3032] = {.count = 1, .reusable = true}, SHIFT(1353),
  [3034] = {.count = 1, .reusable = true}, SHIFT(1355),
  [3036] = {.count = 1, .reusable = true}, SHIFT(1356),
  [3038] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(456),
  [3041] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(457),
  [3044] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(458),
  [3047] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(459),
  [3050] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(460),
  [3053] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(461),
  [3056] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(462),
  [3059] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(463),
  [3062] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(464),
  [3065] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(459),
  [3068] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(466),
  [3071] = {.count = 1, .reusable = true}, SHIFT(1357),
  [3073] = {.count = 1, .reusable = false}, SHIFT(1358),
  [3075] = {.count = 1, .reusable = true}, SHIFT(1359),
  [3077] = {.count = 1, .reusable = true}, SHIFT(1361),
  [3079] = {.count = 1, .reusable = true}, SHIFT(1362),
  [3081] = {.count = 1, .reusable = true}, SHIFT(1363),
  [3083] = {.count = 1, .reusable = true}, SHIFT(1364),
  [3085] = {.count = 1, .reusable = false}, SHIFT(1366),
  [3087] = {.count = 1, .reusable = true}, SHIFT(1366),
  [3089] = {.count = 1, .reusable = true}, SHIFT(1365),
  [3091] = {.count = 1, .reusable = true}, SHIFT(1367),
  [3093] = {.count = 1, .reusable = false}, SHIFT(1369),
  [3095] = {.count = 1, .reusable = true}, SHIFT(1369),
  [3097] = {.count = 1, .reusable = true}, SHIFT(1368),
  [3099] = {.count = 1, .reusable = false}, SHIFT(1371),
  [3101] = {.count = 1, .reusable = true}, SHIFT(1371),
  [3103] = {.count = 1, .reusable = true}, SHIFT(1370),
  [3105] = {.count = 1, .reusable = true}, SHIFT(1372),
  [3107] = {.count = 1, .reusable = true}, SHIFT(1373),
  [3109] = {.count = 1, .reusable = true}, SHIFT(1374),
  [3111] = {.count = 1, .reusable = true}, SHIFT(1376),
  [3113] = {.count = 1, .reusable = true}, SHIFT(1377),
  [3115] = {.count = 1, .reusable = true}, SHIFT(1378),
  [3117] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(490),
  [3120] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(492),
  [3123] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(492),
  [3126] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(493),
  [3129] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(493),
  [3132] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(494),
  [3135] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(491),
  [3138] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(495),
  [3141] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(155),
  [3144] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(156),
  [3147] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(496),
  [3150] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(158),
  [3153] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(159),
  [3156] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(160),
  [3159] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(161),
  [3162] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(496),
  [3165] = {.count = 1, .reusable = true}, SHIFT(1385),
  [3167] = {.count = 1, .reusable = true}, SHIFT(1386),
  [3169] = {.count = 1, .reusable = false}, SHIFT(1387),
  [3171] = {.count = 1, .reusable = true}, SHIFT(1387),
  [3173] = {.count = 1, .reusable = true}, SHIFT(1388),
  [3175] = {.count = 1, .reusable = false}, SHIFT(1389),
  [3177] = {.count = 1, .reusable = true}, SHIFT(1389),
  [3179] = {.count = 1, .reusable = true}, SHIFT(1390),
  [3181] = {.count = 1, .reusable = true}, SHIFT(1392),
  [3183] = {.count = 1, .reusable = true}, SHIFT(1393),
  [3185] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(506),
  [3188] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(507),
  [3191] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(508),
  [3194] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(508),
  [3197] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(511),
  [3200] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(512),
  [3203] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(512),
  [3206] = {.count = 1, .reusable = true}, SHIFT(1397),
  [3208] = {.count = 1, .reusable = true}, SHIFT(1398),
  [3210] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(518),
  [3213] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(520),
  [3216] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(520),
  [3219] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(521),
  [3222] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(519),
  [3225] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(522),
  [3228] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(523),
  [3231] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(523),
  [3234] = {.count = 1, .reusable = true}, SHIFT(1402),
  [3236] = {.count = 1, .reusable = true}, SHIFT(1403),
  [3238] = {.count = 1, .reusable = false}, SHIFT(1405),
  [3240] = {.count = 1, .reusable = true}, SHIFT(1405),
  [3242] = {.count = 1, .reusable = true}, SHIFT(1404),
  [3244] = {.count = 1, .reusable = true}, SHIFT(1406),
  [3246] = {.count = 1, .reusable = true}, SHIFT(1407),
  [3248] = {.count = 1, .reusable = false}, SHIFT(1408),
  [3250] = {.count = 1, .reusable = false}, SHIFT(1407),
  [3252] = {.count = 1, .reusable = true}, SHIFT(1410),
  [3254] = {.count = 1, .reusable = false}, SHIFT(1412),
  [3256] = {.count = 1, .reusable = true}, SHIFT(1412),
  [3258] = {.count = 1, .reusable = true}, SHIFT(1411),
  [3260] = {.count = 1, .reusable = true}, SHIFT(1413),
  [3262] = {.count = 1, .reusable = false}, SHIFT(1415),
  [3264] = {.count = 1, .reusable = true}, SHIFT(1415),
  [3266] = {.count = 1, .reusable = true}, SHIFT(1414),
  [3268] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [3270] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [3272] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(978),
  [3275] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [3277] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(534),
  [3280] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(535),
  [3283] = {.count = 1, .reusable = false}, REDUCE(sym_command, 4),
  [3285] = {.count = 1, .reusable = true}, REDUCE(sym_command, 4),
  [3287] = {.count = 1, .reusable = true}, SHIFT(1418),
  [3289] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .alias_sequence_id = 6),
  [3291] = {.count = 1, .reusable = true}, SHIFT(1419),
  [3293] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5),
  [3295] = {.count = 1, .reusable = true}, SHIFT(1420),
  [3297] = {.count = 1, .reusable = false}, SHIFT(1422),
  [3299] = {.count = 1, .reusable = true}, SHIFT(1423),
  [3301] = {.count = 1, .reusable = true}, SHIFT(1424),
  [3303] = {.count = 1, .reusable = false}, SHIFT(1426),
  [3305] = {.count = 1, .reusable = true}, SHIFT(1426),
  [3307] = {.count = 1, .reusable = true}, SHIFT(1425),
  [3309] = {.count = 1, .reusable = true}, SHIFT(1427),
  [3311] = {.count = 1, .reusable = true}, SHIFT(1428),
  [3313] = {.count = 1, .reusable = false}, SHIFT(1429),
  [3315] = {.count = 1, .reusable = false}, SHIFT(1428),
  [3317] = {.count = 1, .reusable = true}, SHIFT(1431),
  [3319] = {.count = 1, .reusable = false}, SHIFT(1433),
  [3321] = {.count = 1, .reusable = true}, SHIFT(1433),
  [3323] = {.count = 1, .reusable = true}, SHIFT(1432),
  [3325] = {.count = 1, .reusable = true}, SHIFT(1434),
  [3327] = {.count = 1, .reusable = false}, SHIFT(1436),
  [3329] = {.count = 1, .reusable = true}, SHIFT(1436),
  [3331] = {.count = 1, .reusable = true}, SHIFT(1435),
  [3333] = {.count = 1, .reusable = true}, SHIFT(1437),
  [3335] = {.count = 1, .reusable = true}, SHIFT(1438),
  [3337] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [3339] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [3341] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3343] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(560),
  [3346] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(561),
  [3349] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(562),
  [3352] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(563),
  [3355] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(564),
  [3358] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(565),
  [3361] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(566),
  [3364] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(567),
  [3367] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(569),
  [3370] = {.count = 1, .reusable = true}, SHIFT(1439),
  [3372] = {.count = 1, .reusable = false}, SHIFT(1440),
  [3374] = {.count = 1, .reusable = true}, SHIFT(1441),
  [3376] = {.count = 1, .reusable = true}, SHIFT(1443),
  [3378] = {.count = 1, .reusable = true}, SHIFT(1444),
  [3380] = {.count = 1, .reusable = true}, SHIFT(1445),
  [3382] = {.count = 1, .reusable = true}, SHIFT(1446),
  [3384] = {.count = 1, .reusable = false}, SHIFT(1448),
  [3386] = {.count = 1, .reusable = true}, SHIFT(1448),
  [3388] = {.count = 1, .reusable = true}, SHIFT(1447),
  [3390] = {.count = 1, .reusable = true}, SHIFT(1449),
  [3392] = {.count = 1, .reusable = false}, SHIFT(1451),
  [3394] = {.count = 1, .reusable = true}, SHIFT(1451),
  [3396] = {.count = 1, .reusable = true}, SHIFT(1450),
  [3398] = {.count = 1, .reusable = false}, SHIFT(1453),
  [3400] = {.count = 1, .reusable = true}, SHIFT(1453),
  [3402] = {.count = 1, .reusable = true}, SHIFT(1452),
  [3404] = {.count = 1, .reusable = true}, SHIFT(1454),
  [3406] = {.count = 1, .reusable = true}, SHIFT(1455),
  [3408] = {.count = 1, .reusable = true}, SHIFT(1456),
  [3410] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3412] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(587),
  [3415] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(43),
  [3418] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(44),
  [3421] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(588),
  [3424] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(46),
  [3427] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(47),
  [3430] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(48),
  [3433] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(49),
  [3436] = {.count = 1, .reusable = false}, SHIFT(1459),
  [3438] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 3),
  [3440] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 3),
  [3442] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [3444] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5),
  [3446] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5),
  [3448] = {.count = 1, .reusable = true}, SHIFT(1460),
  [3450] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 2),
  [3452] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [3454] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [3456] = {.count = 1, .reusable = true}, SHIFT(1462),
  [3458] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [3460] = {.count = 2, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(597),
  [3463] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [3465] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [3467] = {.count = 1, .reusable = true}, SHIFT(1464),
  [3469] = {.count = 1, .reusable = true}, SHIFT(1465),
  [3471] = {.count = 1, .reusable = true}, SHIFT(1468),
  [3473] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3475] = {.count = 1, .reusable = false}, SHIFT(1473),
  [3477] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5),
  [3479] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5),
  [3481] = {.count = 1, .reusable = true}, SHIFT(1475),
  [3483] = {.count = 1, .reusable = false}, SHIFT(1477),
  [3485] = {.count = 1, .reusable = true}, SHIFT(1479),
  [3487] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3489] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3491] = {.count = 1, .reusable = false}, SHIFT(1482),
  [3493] = {.count = 1, .reusable = true}, SHIFT(1482),
  [3495] = {.count = 1, .reusable = false}, SHIFT(1483),
  [3497] = {.count = 1, .reusable = true}, SHIFT(1484),
  [3499] = {.count = 1, .reusable = true}, SHIFT(1486),
  [3501] = {.count = 1, .reusable = true}, SHIFT(1487),
  [3503] = {.count = 1, .reusable = true}, SHIFT(1488),
  [3505] = {.count = 1, .reusable = true}, SHIFT(1489),
  [3507] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3509] = {.count = 1, .reusable = true}, SHIFT(1491),
  [3511] = {.count = 1, .reusable = false}, SHIFT(1492),
  [3513] = {.count = 1, .reusable = true}, SHIFT(1492),
  [3515] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3517] = {.count = 1, .reusable = false}, SHIFT(1494),
  [3519] = {.count = 1, .reusable = true}, SHIFT(1494),
  [3521] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5),
  [3523] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5),
  [3525] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [3527] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [3529] = {.count = 1, .reusable = true}, SHIFT(1496),
  [3531] = {.count = 1, .reusable = true}, SHIFT(1497),
  [3533] = {.count = 1, .reusable = false}, SHIFT(1502),
  [3535] = {.count = 1, .reusable = true}, SHIFT(1502),
  [3537] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3539] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3541] = {.count = 1, .reusable = false}, SHIFT(1505),
  [3543] = {.count = 1, .reusable = true}, SHIFT(1505),
  [3545] = {.count = 1, .reusable = true}, SHIFT(1506),
  [3547] = {.count = 1, .reusable = true}, SHIFT(1507),
  [3549] = {.count = 1, .reusable = true}, SHIFT(1508),
  [3551] = {.count = 1, .reusable = true}, SHIFT(1509),
  [3553] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 5),
  [3555] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 5),
  [3557] = {.count = 1, .reusable = true}, SHIFT(1512),
  [3559] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3561] = {.count = 1, .reusable = true}, SHIFT(1514),
  [3563] = {.count = 1, .reusable = true}, SHIFT(1515),
  [3565] = {.count = 1, .reusable = false}, SHIFT(1516),
  [3567] = {.count = 1, .reusable = true}, SHIFT(1516),
  [3569] = {.count = 1, .reusable = false}, SHIFT(1517),
  [3571] = {.count = 1, .reusable = true}, SHIFT(1518),
  [3573] = {.count = 1, .reusable = true}, SHIFT(1520),
  [3575] = {.count = 1, .reusable = true}, SHIFT(1521),
  [3577] = {.count = 1, .reusable = true}, SHIFT(1522),
  [3579] = {.count = 1, .reusable = true}, SHIFT(1523),
  [3581] = {.count = 1, .reusable = true}, SHIFT(1524),
  [3583] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3585] = {.count = 1, .reusable = false}, SHIFT(1526),
  [3587] = {.count = 1, .reusable = true}, SHIFT(1526),
  [3589] = {.count = 1, .reusable = true}, SHIFT(1527),
  [3591] = {.count = 1, .reusable = false}, SHIFT(1528),
  [3593] = {.count = 1, .reusable = true}, SHIFT(1528),
  [3595] = {.count = 1, .reusable = true}, SHIFT(1529),
  [3597] = {.count = 1, .reusable = true}, SHIFT(1530),
  [3599] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3601] = {.count = 1, .reusable = false}, SHIFT(1534),
  [3603] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3605] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3607] = {.count = 1, .reusable = false}, SHIFT(1538),
  [3609] = {.count = 1, .reusable = false}, SHIFT(1536),
  [3611] = {.count = 1, .reusable = true}, SHIFT(1539),
  [3613] = {.count = 1, .reusable = true}, SHIFT(1540),
  [3615] = {.count = 1, .reusable = true}, SHIFT(1541),
  [3617] = {.count = 1, .reusable = false}, SHIFT(1542),
  [3619] = {.count = 1, .reusable = false}, SHIFT(1540),
  [3621] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(691),
  [3624] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(692),
  [3627] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(693),
  [3630] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(694),
  [3633] = {.count = 1, .reusable = true}, SHIFT(1550),
  [3635] = {.count = 1, .reusable = true}, SHIFT(1551),
  [3637] = {.count = 1, .reusable = true}, SHIFT(1552),
  [3639] = {.count = 1, .reusable = false}, SHIFT(1553),
  [3641] = {.count = 1, .reusable = true}, SHIFT(1553),
  [3643] = {.count = 1, .reusable = false}, SHIFT(1554),
  [3645] = {.count = 1, .reusable = true}, SHIFT(1555),
  [3647] = {.count = 1, .reusable = true}, SHIFT(1557),
  [3649] = {.count = 1, .reusable = true}, SHIFT(1558),
  [3651] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3653] = {.count = 1, .reusable = true}, SHIFT(1560),
  [3655] = {.count = 1, .reusable = true}, SHIFT(1561),
  [3657] = {.count = 1, .reusable = true}, SHIFT(1562),
  [3659] = {.count = 1, .reusable = false}, SHIFT(1563),
  [3661] = {.count = 1, .reusable = true}, SHIFT(1563),
  [3663] = {.count = 1, .reusable = true}, SHIFT(1564),
  [3665] = {.count = 1, .reusable = false}, SHIFT(1565),
  [3667] = {.count = 1, .reusable = true}, SHIFT(1565),
  [3669] = {.count = 1, .reusable = true}, SHIFT(1566),
  [3671] = {.count = 1, .reusable = true}, SHIFT(1567),
  [3673] = {.count = 1, .reusable = true}, SHIFT(1568),
  [3675] = {.count = 1, .reusable = true}, SHIFT(1569),
  [3677] = {.count = 1, .reusable = false}, SHIFT(1570),
  [3679] = {.count = 1, .reusable = true}, SHIFT(1570),
  [3681] = {.count = 1, .reusable = false}, SHIFT(1571),
  [3683] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3685] = {.count = 1, .reusable = true}, SHIFT(1574),
  [3687] = {.count = 1, .reusable = true}, SHIFT(1575),
  [3689] = {.count = 1, .reusable = true}, SHIFT(1576),
  [3691] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3693] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3695] = {.count = 1, .reusable = true}, SHIFT(1579),
  [3697] = {.count = 1, .reusable = false}, SHIFT(1580),
  [3699] = {.count = 1, .reusable = true}, SHIFT(1580),
  [3701] = {.count = 1, .reusable = true}, SHIFT(1581),
  [3703] = {.count = 1, .reusable = false}, SHIFT(1582),
  [3705] = {.count = 1, .reusable = true}, SHIFT(1582),
  [3707] = {.count = 1, .reusable = true}, SHIFT(1583),
  [3709] = {.count = 1, .reusable = true}, SHIFT(1584),
  [3711] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3713] = {.count = 1, .reusable = false}, SHIFT(1586),
  [3715] = {.count = 1, .reusable = true}, SHIFT(1586),
  [3717] = {.count = 1, .reusable = false}, SHIFT(1587),
  [3719] = {.count = 1, .reusable = true}, SHIFT(1588),
  [3721] = {.count = 1, .reusable = true}, SHIFT(1590),
  [3723] = {.count = 1, .reusable = true}, SHIFT(1591),
  [3725] = {.count = 1, .reusable = true}, SHIFT(1592),
  [3727] = {.count = 1, .reusable = true}, SHIFT(1593),
  [3729] = {.count = 1, .reusable = true}, SHIFT(1594),
  [3731] = {.count = 1, .reusable = true}, SHIFT(1595),
  [3733] = {.count = 1, .reusable = false}, SHIFT(1596),
  [3735] = {.count = 1, .reusable = true}, SHIFT(1596),
  [3737] = {.count = 1, .reusable = true}, SHIFT(1597),
  [3739] = {.count = 1, .reusable = false}, SHIFT(1598),
  [3741] = {.count = 1, .reusable = true}, SHIFT(1598),
  [3743] = {.count = 1, .reusable = true}, SHIFT(1599),
  [3745] = {.count = 1, .reusable = true}, SHIFT(1600),
  [3747] = {.count = 1, .reusable = true}, SHIFT(1601),
  [3749] = {.count = 1, .reusable = false}, SHIFT(1602),
  [3751] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3753] = {.count = 1, .reusable = false}, SHIFT(1603),
  [3755] = {.count = 1, .reusable = true}, SHIFT(1604),
  [3757] = {.count = 1, .reusable = true}, SHIFT(1606),
  [3759] = {.count = 1, .reusable = true}, SHIFT(1607),
  [3761] = {.count = 1, .reusable = true}, SHIFT(1608),
  [3763] = {.count = 1, .reusable = true}, SHIFT(1609),
  [3765] = {.count = 1, .reusable = true}, SHIFT(1610),
  [3767] = {.count = 1, .reusable = true}, SHIFT(1611),
  [3769] = {.count = 1, .reusable = false}, SHIFT(1612),
  [3771] = {.count = 1, .reusable = true}, SHIFT(1612),
  [3773] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3775] = {.count = 1, .reusable = false}, SHIFT(1614),
  [3777] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3779] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3781] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3783] = {.count = 1, .reusable = true}, SHIFT(1617),
  [3785] = {.count = 1, .reusable = false}, SHIFT(1618),
  [3787] = {.count = 1, .reusable = true}, SHIFT(1618),
  [3789] = {.count = 1, .reusable = false}, SHIFT(1619),
  [3791] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3793] = {.count = 1, .reusable = true}, SHIFT(1622),
  [3795] = {.count = 1, .reusable = true}, SHIFT(1623),
  [3797] = {.count = 1, .reusable = true}, SHIFT(1624),
  [3799] = {.count = 1, .reusable = true}, SHIFT(1625),
  [3801] = {.count = 1, .reusable = true}, SHIFT(1626),
  [3803] = {.count = 1, .reusable = true}, SHIFT(1627),
  [3805] = {.count = 1, .reusable = false}, SHIFT(1628),
  [3807] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3809] = {.count = 1, .reusable = true}, SHIFT(1629),
  [3811] = {.count = 1, .reusable = false}, SHIFT(1630),
  [3813] = {.count = 1, .reusable = true}, SHIFT(1630),
  [3815] = {.count = 1, .reusable = true}, SHIFT(1631),
  [3817] = {.count = 1, .reusable = true}, SHIFT(1632),
  [3819] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 6),
  [3821] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3823] = {.count = 1, .reusable = true}, SHIFT(1634),
  [3825] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4),
  [3827] = {.count = 1, .reusable = true}, SHIFT(1635),
  [3829] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 9),
  [3831] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 9),
  [3833] = {.count = 1, .reusable = false}, SHIFT(1637),
  [3835] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5),
  [3837] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5),
  [3839] = {.count = 1, .reusable = true}, SHIFT(1638),
  [3841] = {.count = 1, .reusable = true}, SHIFT(1639),
  [3843] = {.count = 1, .reusable = false}, SHIFT(1641),
  [3845] = {.count = 1, .reusable = true}, SHIFT(1641),
  [3847] = {.count = 1, .reusable = true}, SHIFT(1640),
  [3849] = {.count = 1, .reusable = true}, SHIFT(1642),
  [3851] = {.count = 1, .reusable = true}, SHIFT(1643),
  [3853] = {.count = 1, .reusable = false}, SHIFT(1644),
  [3855] = {.count = 1, .reusable = false}, SHIFT(1643),
  [3857] = {.count = 1, .reusable = true}, SHIFT(1646),
  [3859] = {.count = 1, .reusable = false}, SHIFT(1648),
  [3861] = {.count = 1, .reusable = true}, SHIFT(1648),
  [3863] = {.count = 1, .reusable = true}, SHIFT(1647),
  [3865] = {.count = 1, .reusable = true}, SHIFT(1649),
  [3867] = {.count = 1, .reusable = false}, SHIFT(1651),
  [3869] = {.count = 1, .reusable = true}, SHIFT(1651),
  [3871] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3873] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3875] = {.count = 1, .reusable = true}, SHIFT(1653),
  [3877] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(809),
  [3880] = {.count = 1, .reusable = true}, SHIFT(1654),
  [3882] = {.count = 1, .reusable = false}, SHIFT(1655),
  [3884] = {.count = 1, .reusable = true}, SHIFT(1656),
  [3886] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3888] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3890] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3892] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3894] = {.count = 1, .reusable = false}, SHIFT(1663),
  [3896] = {.count = 1, .reusable = true}, SHIFT(1663),
  [3898] = {.count = 1, .reusable = true}, SHIFT(1662),
  [3900] = {.count = 1, .reusable = true}, SHIFT(1664),
  [3902] = {.count = 1, .reusable = false}, SHIFT(1666),
  [3904] = {.count = 1, .reusable = true}, SHIFT(1666),
  [3906] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3908] = {.count = 1, .reusable = false}, SHIFT(1668),
  [3910] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3912] = {.count = 1, .reusable = true}, SHIFT(1667),
  [3914] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3916] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3918] = {.count = 1, .reusable = true}, SHIFT(1671),
  [3920] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 10),
  [3922] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 10),
  [3924] = {.count = 1, .reusable = true}, SHIFT(1672),
  [3926] = {.count = 1, .reusable = true}, SHIFT(1673),
  [3928] = {.count = 1, .reusable = true}, SHIFT(1674),
  [3930] = {.count = 1, .reusable = true}, SHIFT(1675),
  [3932] = {.count = 1, .reusable = false}, SHIFT(1676),
  [3934] = {.count = 1, .reusable = true}, SHIFT(1676),
  [3936] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [3938] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [3940] = {.count = 1, .reusable = true}, SHIFT(1677),
  [3942] = {.count = 1, .reusable = false}, SHIFT(1678),
  [3944] = {.count = 1, .reusable = true}, SHIFT(1678),
  [3946] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [3948] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [3950] = {.count = 1, .reusable = true}, SHIFT(1679),
  [3952] = {.count = 1, .reusable = false}, SHIFT(1680),
  [3954] = {.count = 1, .reusable = true}, SHIFT(1680),
  [3956] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 11),
  [3958] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 11),
  [3960] = {.count = 1, .reusable = true}, SHIFT(1681),
  [3962] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 12),
  [3964] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 12),
  [3966] = {.count = 1, .reusable = true}, SHIFT(1682),
  [3968] = {.count = 1, .reusable = false}, SHIFT(1684),
  [3970] = {.count = 1, .reusable = true}, SHIFT(1684),
  [3972] = {.count = 1, .reusable = false}, SHIFT(1685),
  [3974] = {.count = 1, .reusable = false}, SHIFT(1687),
  [3976] = {.count = 1, .reusable = true}, SHIFT(1689),
  [3978] = {.count = 1, .reusable = false}, SHIFT(1689),
  [3980] = {.count = 1, .reusable = false}, SHIFT(1692),
  [3982] = {.count = 1, .reusable = false}, SHIFT(1695),
  [3984] = {.count = 1, .reusable = true}, SHIFT(1695),
  [3986] = {.count = 1, .reusable = false}, SHIFT(1696),
  [3988] = {.count = 1, .reusable = false}, SHIFT(1699),
  [3990] = {.count = 1, .reusable = true}, SHIFT(1699),
  [3992] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3994] = {.count = 1, .reusable = false}, SHIFT(1702),
  [3996] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3998] = {.count = 1, .reusable = true}, SHIFT(1703),
  [4000] = {.count = 1, .reusable = true}, SHIFT(1704),
  [4002] = {.count = 1, .reusable = true}, SHIFT(1706),
  [4004] = {.count = 1, .reusable = false}, SHIFT(1707),
  [4006] = {.count = 1, .reusable = true}, SHIFT(1707),
  [4008] = {.count = 1, .reusable = true}, SHIFT(1708),
  [4010] = {.count = 1, .reusable = true}, SHIFT(1709),
  [4012] = {.count = 1, .reusable = false}, SHIFT(1710),
  [4014] = {.count = 1, .reusable = true}, SHIFT(1711),
  [4016] = {.count = 1, .reusable = true}, SHIFT(1712),
  [4018] = {.count = 1, .reusable = true}, SHIFT(1713),
  [4020] = {.count = 1, .reusable = true}, SHIFT(1714),
  [4022] = {.count = 1, .reusable = true}, SHIFT(1715),
  [4024] = {.count = 1, .reusable = true}, SHIFT(1717),
  [4026] = {.count = 1, .reusable = true}, SHIFT(1718),
  [4028] = {.count = 1, .reusable = true}, SHIFT(1719),
  [4030] = {.count = 1, .reusable = true}, SHIFT(1722),
  [4032] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(862),
  [4035] = {.count = 1, .reusable = true}, SHIFT(1724),
  [4037] = {.count = 1, .reusable = false}, SHIFT(1725),
  [4039] = {.count = 1, .reusable = true}, SHIFT(1726),
  [4041] = {.count = 1, .reusable = true}, SHIFT(1728),
  [4043] = {.count = 1, .reusable = true}, SHIFT(1729),
  [4045] = {.count = 1, .reusable = true}, SHIFT(1730),
  [4047] = {.count = 1, .reusable = true}, SHIFT(1731),
  [4049] = {.count = 1, .reusable = false}, SHIFT(1733),
  [4051] = {.count = 1, .reusable = true}, SHIFT(1733),
  [4053] = {.count = 1, .reusable = true}, SHIFT(1732),
  [4055] = {.count = 1, .reusable = true}, SHIFT(1734),
  [4057] = {.count = 1, .reusable = false}, SHIFT(1736),
  [4059] = {.count = 1, .reusable = true}, SHIFT(1736),
  [4061] = {.count = 1, .reusable = true}, SHIFT(1735),
  [4063] = {.count = 1, .reusable = false}, SHIFT(1738),
  [4065] = {.count = 1, .reusable = true}, SHIFT(1738),
  [4067] = {.count = 1, .reusable = true}, SHIFT(1737),
  [4069] = {.count = 1, .reusable = true}, SHIFT(1739),
  [4071] = {.count = 1, .reusable = true}, SHIFT(1740),
  [4073] = {.count = 1, .reusable = true}, SHIFT(1741),
  [4075] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(881),
  [4078] = {.count = 1, .reusable = true}, SHIFT(1742),
  [4080] = {.count = 1, .reusable = false}, SHIFT(1743),
  [4082] = {.count = 1, .reusable = true}, SHIFT(1744),
  [4084] = {.count = 1, .reusable = true}, SHIFT(1746),
  [4086] = {.count = 1, .reusable = true}, SHIFT(1747),
  [4088] = {.count = 1, .reusable = true}, SHIFT(1748),
  [4090] = {.count = 1, .reusable = true}, SHIFT(1749),
  [4092] = {.count = 1, .reusable = false}, SHIFT(1751),
  [4094] = {.count = 1, .reusable = true}, SHIFT(1751),
  [4096] = {.count = 1, .reusable = true}, SHIFT(1750),
  [4098] = {.count = 1, .reusable = true}, SHIFT(1752),
  [4100] = {.count = 1, .reusable = false}, SHIFT(1754),
  [4102] = {.count = 1, .reusable = true}, SHIFT(1754),
  [4104] = {.count = 1, .reusable = true}, SHIFT(1753),
  [4106] = {.count = 1, .reusable = false}, SHIFT(1756),
  [4108] = {.count = 1, .reusable = true}, SHIFT(1756),
  [4110] = {.count = 1, .reusable = true}, SHIFT(1755),
  [4112] = {.count = 1, .reusable = true}, SHIFT(1757),
  [4114] = {.count = 1, .reusable = true}, SHIFT(1758),
  [4116] = {.count = 1, .reusable = true}, SHIFT(1759),
  [4118] = {.count = 1, .reusable = true}, SHIFT(1760),
  [4120] = {.count = 1, .reusable = true}, SHIFT(1761),
  [4122] = {.count = 1, .reusable = true}, SHIFT(1762),
  [4124] = {.count = 1, .reusable = false}, SHIFT(1763),
  [4126] = {.count = 1, .reusable = true}, SHIFT(1763),
  [4128] = {.count = 1, .reusable = false}, SHIFT(1764),
  [4130] = {.count = 1, .reusable = true}, SHIFT(1765),
  [4132] = {.count = 1, .reusable = true}, SHIFT(1767),
  [4134] = {.count = 1, .reusable = true}, SHIFT(1768),
  [4136] = {.count = 1, .reusable = true}, SHIFT(1769),
  [4138] = {.count = 1, .reusable = true}, SHIFT(1770),
  [4140] = {.count = 1, .reusable = true}, SHIFT(1771),
  [4142] = {.count = 1, .reusable = true}, SHIFT(1772),
  [4144] = {.count = 1, .reusable = false}, SHIFT(1773),
  [4146] = {.count = 1, .reusable = true}, SHIFT(1773),
  [4148] = {.count = 1, .reusable = true}, SHIFT(1774),
  [4150] = {.count = 1, .reusable = false}, SHIFT(1775),
  [4152] = {.count = 1, .reusable = true}, SHIFT(1775),
  [4154] = {.count = 1, .reusable = false}, SHIFT(1781),
  [4156] = {.count = 1, .reusable = true}, SHIFT(1781),
  [4158] = {.count = 1, .reusable = true}, SHIFT(1782),
  [4160] = {.count = 1, .reusable = true}, SHIFT(1783),
  [4162] = {.count = 1, .reusable = false}, SHIFT(1784),
  [4164] = {.count = 1, .reusable = true}, SHIFT(1784),
  [4166] = {.count = 1, .reusable = true}, SHIFT(1785),
  [4168] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4170] = {.count = 1, .reusable = true}, SHIFT(1787),
  [4172] = {.count = 1, .reusable = true}, SHIFT(1788),
  [4174] = {.count = 1, .reusable = true}, SHIFT(1791),
  [4176] = {.count = 1, .reusable = false}, SHIFT(1792),
  [4178] = {.count = 1, .reusable = true}, SHIFT(1793),
  [4180] = {.count = 1, .reusable = true}, SHIFT(1795),
  [4182] = {.count = 1, .reusable = true}, SHIFT(1796),
  [4184] = {.count = 1, .reusable = true}, SHIFT(1797),
  [4186] = {.count = 1, .reusable = true}, SHIFT(1798),
  [4188] = {.count = 1, .reusable = false}, SHIFT(1800),
  [4190] = {.count = 1, .reusable = true}, SHIFT(1800),
  [4192] = {.count = 1, .reusable = true}, SHIFT(1799),
  [4194] = {.count = 1, .reusable = true}, SHIFT(1801),
  [4196] = {.count = 1, .reusable = false}, SHIFT(1803),
  [4198] = {.count = 1, .reusable = true}, SHIFT(1803),
  [4200] = {.count = 1, .reusable = true}, SHIFT(1802),
  [4202] = {.count = 1, .reusable = false}, SHIFT(1805),
  [4204] = {.count = 1, .reusable = true}, SHIFT(1805),
  [4206] = {.count = 1, .reusable = true}, SHIFT(1804),
  [4208] = {.count = 1, .reusable = true}, SHIFT(1806),
  [4210] = {.count = 1, .reusable = true}, SHIFT(1807),
  [4212] = {.count = 1, .reusable = true}, SHIFT(1808),
  [4214] = {.count = 1, .reusable = false}, REDUCE(sym_command, 5),
  [4216] = {.count = 1, .reusable = true}, REDUCE(sym_command, 5),
  [4218] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6, .alias_sequence_id = 6),
  [4220] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6),
  [4222] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(990),
  [4225] = {.count = 1, .reusable = true}, SHIFT(1809),
  [4227] = {.count = 1, .reusable = false}, SHIFT(1810),
  [4229] = {.count = 1, .reusable = true}, SHIFT(1811),
  [4231] = {.count = 1, .reusable = true}, SHIFT(1813),
  [4233] = {.count = 1, .reusable = true}, SHIFT(1814),
  [4235] = {.count = 1, .reusable = true}, SHIFT(1815),
  [4237] = {.count = 1, .reusable = true}, SHIFT(1816),
  [4239] = {.count = 1, .reusable = false}, SHIFT(1818),
  [4241] = {.count = 1, .reusable = true}, SHIFT(1818),
  [4243] = {.count = 1, .reusable = true}, SHIFT(1817),
  [4245] = {.count = 1, .reusable = true}, SHIFT(1819),
  [4247] = {.count = 1, .reusable = false}, SHIFT(1821),
  [4249] = {.count = 1, .reusable = true}, SHIFT(1821),
  [4251] = {.count = 1, .reusable = true}, SHIFT(1820),
  [4253] = {.count = 1, .reusable = false}, SHIFT(1823),
  [4255] = {.count = 1, .reusable = true}, SHIFT(1823),
  [4257] = {.count = 1, .reusable = true}, SHIFT(1822),
  [4259] = {.count = 1, .reusable = true}, SHIFT(1824),
  [4261] = {.count = 1, .reusable = true}, SHIFT(1825),
  [4263] = {.count = 1, .reusable = true}, SHIFT(1826),
  [4265] = {.count = 1, .reusable = true}, SHIFT(1827),
  [4267] = {.count = 1, .reusable = true}, SHIFT(1828),
  [4269] = {.count = 1, .reusable = true}, SHIFT(1829),
  [4271] = {.count = 1, .reusable = false}, SHIFT(1830),
  [4273] = {.count = 1, .reusable = true}, SHIFT(1830),
  [4275] = {.count = 1, .reusable = false}, SHIFT(1831),
  [4277] = {.count = 1, .reusable = true}, SHIFT(1832),
  [4279] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4281] = {.count = 1, .reusable = true}, SHIFT(1835),
  [4283] = {.count = 1, .reusable = true}, SHIFT(1836),
  [4285] = {.count = 1, .reusable = true}, SHIFT(1837),
  [4287] = {.count = 1, .reusable = true}, SHIFT(1838),
  [4289] = {.count = 1, .reusable = true}, SHIFT(1839),
  [4291] = {.count = 1, .reusable = false}, SHIFT(1840),
  [4293] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4295] = {.count = 1, .reusable = true}, SHIFT(1841),
  [4297] = {.count = 1, .reusable = false}, SHIFT(1842),
  [4299] = {.count = 1, .reusable = true}, SHIFT(1842),
  [4301] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 5),
  [4303] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 5),
  [4305] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 3),
  [4307] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [4309] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [4311] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4313] = {.count = 1, .reusable = true}, SHIFT(1845),
  [4315] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4317] = {.count = 1, .reusable = true}, SHIFT(1848),
  [4319] = {.count = 1, .reusable = false}, SHIFT(1849),
  [4321] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2, .alias_sequence_id = 1),
  [4323] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4325] = {.count = 1, .reusable = false}, SHIFT(1851),
  [4327] = {.count = 1, .reusable = false}, SHIFT(1852),
  [4329] = {.count = 1, .reusable = false}, SHIFT(1853),
  [4331] = {.count = 1, .reusable = true}, SHIFT(1854),
  [4333] = {.count = 1, .reusable = false}, SHIFT(1855),
  [4335] = {.count = 1, .reusable = false}, SHIFT(1856),
  [4337] = {.count = 1, .reusable = false}, SHIFT(1857),
  [4339] = {.count = 1, .reusable = true}, SHIFT(1858),
  [4341] = {.count = 1, .reusable = false}, SHIFT(1859),
  [4343] = {.count = 1, .reusable = true}, SHIFT(1866),
  [4345] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2),
  [4347] = {.count = 1, .reusable = true}, SHIFT(1869),
  [4349] = {.count = 1, .reusable = true}, SHIFT(1873),
  [4351] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 13),
  [4353] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 13),
  [4355] = {.count = 1, .reusable = true}, SHIFT(1874),
  [4357] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1875),
  [4360] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(86),
  [4363] = {.count = 2, .reusable = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(87),
  [4366] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1876),
  [4369] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(89),
  [4372] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(90),
  [4375] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(91),
  [4378] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(92),
  [4381] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [4383] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [4385] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 14),
  [4387] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 14),
  [4389] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4391] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6),
  [4393] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6),
  [4395] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4397] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4399] = {.count = 1, .reusable = true}, SHIFT(1883),
  [4401] = {.count = 1, .reusable = true}, SHIFT(1884),
  [4403] = {.count = 1, .reusable = false}, SHIFT(1885),
  [4405] = {.count = 1, .reusable = true}, SHIFT(1885),
  [4407] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4409] = {.count = 1, .reusable = false}, SHIFT(1887),
  [4411] = {.count = 1, .reusable = true}, SHIFT(1887),
  [4413] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4415] = {.count = 1, .reusable = false}, SHIFT(1889),
  [4417] = {.count = 1, .reusable = true}, SHIFT(1889),
  [4419] = {.count = 1, .reusable = true}, SHIFT(1890),
  [4421] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4423] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 6),
  [4425] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 6),
  [4427] = {.count = 1, .reusable = true}, SHIFT(1893),
  [4429] = {.count = 1, .reusable = true}, SHIFT(1894),
  [4431] = {.count = 1, .reusable = true}, SHIFT(1896),
  [4433] = {.count = 1, .reusable = true}, SHIFT(1897),
  [4435] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1086),
  [4438] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1087),
  [4441] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1088),
  [4444] = {.count = 1, .reusable = true}, SHIFT(1899),
  [4446] = {.count = 1, .reusable = true}, SHIFT(1900),
  [4448] = {.count = 1, .reusable = true}, SHIFT(1901),
  [4450] = {.count = 1, .reusable = true}, SHIFT(1902),
  [4452] = {.count = 1, .reusable = false}, SHIFT(1903),
  [4454] = {.count = 1, .reusable = true}, SHIFT(1903),
  [4456] = {.count = 1, .reusable = true}, SHIFT(1904),
  [4458] = {.count = 1, .reusable = false}, SHIFT(1905),
  [4460] = {.count = 1, .reusable = true}, SHIFT(1905),
  [4462] = {.count = 1, .reusable = true}, SHIFT(1906),
  [4464] = {.count = 1, .reusable = false}, SHIFT(1907),
  [4466] = {.count = 1, .reusable = true}, SHIFT(1907),
  [4468] = {.count = 1, .reusable = true}, SHIFT(1908),
  [4470] = {.count = 1, .reusable = true}, SHIFT(1909),
  [4472] = {.count = 1, .reusable = true}, SHIFT(1910),
  [4474] = {.count = 1, .reusable = false}, SHIFT(1912),
  [4476] = {.count = 1, .reusable = true}, SHIFT(1913),
  [4478] = {.count = 1, .reusable = true}, SHIFT(1914),
  [4480] = {.count = 1, .reusable = false}, SHIFT(1916),
  [4482] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4484] = {.count = 1, .reusable = true}, SHIFT(1915),
  [4486] = {.count = 1, .reusable = true}, SHIFT(1917),
  [4488] = {.count = 1, .reusable = true}, SHIFT(1918),
  [4490] = {.count = 1, .reusable = false}, SHIFT(1919),
  [4492] = {.count = 1, .reusable = false}, SHIFT(1918),
  [4494] = {.count = 1, .reusable = true}, SHIFT(1921),
  [4496] = {.count = 1, .reusable = false}, SHIFT(1923),
  [4498] = {.count = 1, .reusable = true}, SHIFT(1923),
  [4500] = {.count = 1, .reusable = true}, SHIFT(1922),
  [4502] = {.count = 1, .reusable = true}, SHIFT(1924),
  [4504] = {.count = 1, .reusable = false}, SHIFT(1926),
  [4506] = {.count = 1, .reusable = true}, SHIFT(1926),
  [4508] = {.count = 1, .reusable = true}, SHIFT(1925),
  [4510] = {.count = 1, .reusable = true}, SHIFT(1927),
  [4512] = {.count = 1, .reusable = true}, SHIFT(1928),
  [4514] = {.count = 1, .reusable = true}, SHIFT(1929),
  [4516] = {.count = 1, .reusable = true}, SHIFT(1930),
  [4518] = {.count = 1, .reusable = true}, SHIFT(1931),
  [4520] = {.count = 1, .reusable = true}, SHIFT(1932),
  [4522] = {.count = 1, .reusable = false}, SHIFT(1933),
  [4524] = {.count = 1, .reusable = true}, SHIFT(1933),
  [4526] = {.count = 1, .reusable = true}, SHIFT(1934),
  [4528] = {.count = 1, .reusable = false}, SHIFT(1935),
  [4530] = {.count = 1, .reusable = true}, SHIFT(1935),
  [4532] = {.count = 1, .reusable = true}, SHIFT(1936),
  [4534] = {.count = 1, .reusable = false}, SHIFT(1937),
  [4536] = {.count = 1, .reusable = true}, SHIFT(1937),
  [4538] = {.count = 1, .reusable = true}, SHIFT(1938),
  [4540] = {.count = 1, .reusable = true}, SHIFT(1939),
  [4542] = {.count = 1, .reusable = true}, SHIFT(1940),
  [4544] = {.count = 1, .reusable = true}, SHIFT(1941),
  [4546] = {.count = 1, .reusable = true}, SHIFT(1942),
  [4548] = {.count = 1, .reusable = true}, SHIFT(1943),
  [4550] = {.count = 1, .reusable = false}, SHIFT(1944),
  [4552] = {.count = 1, .reusable = true}, SHIFT(1944),
  [4554] = {.count = 1, .reusable = true}, SHIFT(1945),
  [4556] = {.count = 1, .reusable = false}, SHIFT(1946),
  [4558] = {.count = 1, .reusable = true}, SHIFT(1946),
  [4560] = {.count = 1, .reusable = true}, SHIFT(1947),
  [4562] = {.count = 1, .reusable = false}, SHIFT(1948),
  [4564] = {.count = 1, .reusable = true}, SHIFT(1948),
  [4566] = {.count = 1, .reusable = true}, SHIFT(1949),
  [4568] = {.count = 1, .reusable = true}, SHIFT(1950),
  [4570] = {.count = 1, .reusable = true}, SHIFT(1951),
  [4572] = {.count = 1, .reusable = true}, SHIFT(1952),
  [4574] = {.count = 1, .reusable = true}, SHIFT(1953),
  [4576] = {.count = 1, .reusable = true}, SHIFT(1954),
  [4578] = {.count = 1, .reusable = false}, SHIFT(1955),
  [4580] = {.count = 1, .reusable = true}, SHIFT(1955),
  [4582] = {.count = 1, .reusable = true}, SHIFT(1956),
  [4584] = {.count = 1, .reusable = false}, SHIFT(1957),
  [4586] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4588] = {.count = 1, .reusable = true}, SHIFT(1958),
  [4590] = {.count = 1, .reusable = false}, SHIFT(1959),
  [4592] = {.count = 1, .reusable = true}, SHIFT(1959),
  [4594] = {.count = 1, .reusable = true}, SHIFT(1960),
  [4596] = {.count = 1, .reusable = true}, SHIFT(1961),
  [4598] = {.count = 1, .reusable = true}, SHIFT(1962),
  [4600] = {.count = 1, .reusable = true}, SHIFT(1963),
  [4602] = {.count = 1, .reusable = true}, SHIFT(1964),
  [4604] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4606] = {.count = 1, .reusable = false}, SHIFT(1966),
  [4608] = {.count = 1, .reusable = true}, SHIFT(1966),
  [4610] = {.count = 1, .reusable = true}, SHIFT(1967),
  [4612] = {.count = 1, .reusable = false}, SHIFT(1968),
  [4614] = {.count = 1, .reusable = true}, SHIFT(1968),
  [4616] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4618] = {.count = 1, .reusable = false}, SHIFT(1970),
  [4620] = {.count = 1, .reusable = true}, SHIFT(1970),
  [4622] = {.count = 1, .reusable = true}, SHIFT(1971),
  [4624] = {.count = 1, .reusable = true}, SHIFT(1972),
  [4626] = {.count = 1, .reusable = true}, SHIFT(1973),
  [4628] = {.count = 1, .reusable = true}, SHIFT(1974),
  [4630] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4632] = {.count = 1, .reusable = true}, SHIFT(1976),
  [4634] = {.count = 1, .reusable = false}, SHIFT(1977),
  [4636] = {.count = 1, .reusable = true}, SHIFT(1977),
  [4638] = {.count = 1, .reusable = true}, SHIFT(1978),
  [4640] = {.count = 1, .reusable = false}, SHIFT(1979),
  [4642] = {.count = 1, .reusable = true}, SHIFT(1979),
  [4644] = {.count = 1, .reusable = true}, SHIFT(1980),
  [4646] = {.count = 1, .reusable = false}, SHIFT(1981),
  [4648] = {.count = 1, .reusable = true}, SHIFT(1981),
  [4650] = {.count = 1, .reusable = true}, SHIFT(1982),
  [4652] = {.count = 1, .reusable = true}, SHIFT(1983),
  [4654] = {.count = 1, .reusable = true}, SHIFT(1984),
  [4656] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .alias_sequence_id = 6),
  [4658] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4660] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5),
  [4662] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1233),
  [4665] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4667] = {.count = 1, .reusable = false}, SHIFT(1987),
  [4669] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4671] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4673] = {.count = 1, .reusable = true}, SHIFT(1991),
  [4675] = {.count = 1, .reusable = true}, SHIFT(1992),
  [4677] = {.count = 1, .reusable = true}, SHIFT(1993),
  [4679] = {.count = 1, .reusable = false}, SHIFT(1995),
  [4681] = {.count = 1, .reusable = true}, SHIFT(1995),
  [4683] = {.count = 1, .reusable = true}, SHIFT(1994),
  [4685] = {.count = 1, .reusable = true}, SHIFT(1996),
  [4687] = {.count = 1, .reusable = false}, SHIFT(1998),
  [4689] = {.count = 1, .reusable = true}, SHIFT(1998),
  [4691] = {.count = 1, .reusable = true}, SHIFT(1997),
  [4693] = {.count = 1, .reusable = false}, SHIFT(2000),
  [4695] = {.count = 1, .reusable = true}, SHIFT(2000),
  [4697] = {.count = 1, .reusable = true}, SHIFT(1999),
  [4699] = {.count = 1, .reusable = true}, SHIFT(2001),
  [4701] = {.count = 1, .reusable = true}, SHIFT(2002),
  [4703] = {.count = 1, .reusable = true}, SHIFT(2003),
  [4705] = {.count = 1, .reusable = true}, SHIFT(2004),
  [4707] = {.count = 1, .reusable = true}, SHIFT(2005),
  [4709] = {.count = 1, .reusable = true}, SHIFT(2006),
  [4711] = {.count = 1, .reusable = false}, SHIFT(2007),
  [4713] = {.count = 1, .reusable = true}, SHIFT(2007),
  [4715] = {.count = 1, .reusable = false}, SHIFT(2008),
  [4717] = {.count = 1, .reusable = true}, SHIFT(2009),
  [4719] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4721] = {.count = 1, .reusable = true}, SHIFT(2012),
  [4723] = {.count = 1, .reusable = true}, SHIFT(2013),
  [4725] = {.count = 1, .reusable = true}, SHIFT(2014),
  [4727] = {.count = 1, .reusable = true}, SHIFT(2015),
  [4729] = {.count = 1, .reusable = true}, SHIFT(2016),
  [4731] = {.count = 1, .reusable = false}, SHIFT(2017),
  [4733] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4735] = {.count = 1, .reusable = true}, SHIFT(2018),
  [4737] = {.count = 1, .reusable = false}, SHIFT(2019),
  [4739] = {.count = 1, .reusable = true}, SHIFT(2019),
  [4741] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 10),
  [4743] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 10),
  [4745] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 15),
  [4747] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 15),
  [4749] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6),
  [4751] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6),
  [4753] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 16),
  [4755] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 16),
  [4757] = {.count = 1, .reusable = true}, SHIFT(2020),
  [4759] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 17),
  [4761] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 17),
  [4763] = {.count = 1, .reusable = true}, SHIFT(2021),
  [4765] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 18),
  [4767] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 18),
  [4769] = {.count = 1, .reusable = true}, SHIFT(2022),
  [4771] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 11),
  [4773] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 11),
  [4775] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 12),
  [4777] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 12),
  [4779] = {.count = 1, .reusable = false}, SHIFT(2024),
  [4781] = {.count = 1, .reusable = true}, SHIFT(2025),
  [4783] = {.count = 1, .reusable = true}, SHIFT(2027),
  [4785] = {.count = 1, .reusable = false}, SHIFT(2029),
  [4787] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4789] = {.count = 1, .reusable = false}, SHIFT(2033),
  [4791] = {.count = 1, .reusable = true}, SHIFT(2036),
  [4793] = {.count = 1, .reusable = true}, SHIFT(2037),
  [4795] = {.count = 1, .reusable = true}, SHIFT(2040),
  [4797] = {.count = 1, .reusable = true}, SHIFT(2041),
  [4799] = {.count = 1, .reusable = true}, SHIFT(2043),
  [4801] = {.count = 1, .reusable = false}, SHIFT(2045),
  [4803] = {.count = 1, .reusable = true}, SHIFT(2047),
  [4805] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4807] = {.count = 1, .reusable = false}, SHIFT(2049),
  [4809] = {.count = 1, .reusable = false}, SHIFT(2047),
  [4811] = {.count = 1, .reusable = true}, SHIFT(2050),
  [4813] = {.count = 1, .reusable = true}, SHIFT(2051),
  [4815] = {.count = 1, .reusable = true}, SHIFT(2052),
  [4817] = {.count = 1, .reusable = false}, SHIFT(2053),
  [4819] = {.count = 1, .reusable = false}, SHIFT(2051),
  [4821] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1310),
  [4824] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1311),
  [4827] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1311),
  [4830] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1312),
  [4833] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1312),
  [4836] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1313),
  [4839] = {.count = 1, .reusable = true}, SHIFT(2061),
  [4841] = {.count = 1, .reusable = true}, SHIFT(2062),
  [4843] = {.count = 1, .reusable = true}, SHIFT(2063),
  [4845] = {.count = 1, .reusable = true}, SHIFT(2064),
  [4847] = {.count = 1, .reusable = false}, SHIFT(2065),
  [4849] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4851] = {.count = 1, .reusable = false}, SHIFT(2066),
  [4853] = {.count = 1, .reusable = true}, SHIFT(2067),
  [4855] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4857] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4859] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4861] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4863] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4865] = {.count = 1, .reusable = true}, SHIFT(2074),
  [4867] = {.count = 1, .reusable = false}, SHIFT(2075),
  [4869] = {.count = 1, .reusable = true}, SHIFT(2075),
  [4871] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4873] = {.count = 1, .reusable = false}, SHIFT(2077),
  [4875] = {.count = 1, .reusable = true}, SHIFT(2077),
  [4877] = {.count = 1, .reusable = true}, SHIFT(2078),
  [4879] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4881] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4883] = {.count = 1, .reusable = false}, SHIFT(2081),
  [4885] = {.count = 1, .reusable = true}, SHIFT(2081),
  [4887] = {.count = 1, .reusable = false}, SHIFT(2082),
  [4889] = {.count = 1, .reusable = true}, SHIFT(2083),
  [4891] = {.count = 1, .reusable = true}, SHIFT(2085),
  [4893] = {.count = 1, .reusable = true}, SHIFT(2086),
  [4895] = {.count = 1, .reusable = true}, SHIFT(2087),
  [4897] = {.count = 1, .reusable = true}, SHIFT(2088),
  [4899] = {.count = 1, .reusable = true}, SHIFT(2089),
  [4901] = {.count = 1, .reusable = true}, SHIFT(2090),
  [4903] = {.count = 1, .reusable = false}, SHIFT(2091),
  [4905] = {.count = 1, .reusable = true}, SHIFT(2091),
  [4907] = {.count = 1, .reusable = true}, SHIFT(2092),
  [4909] = {.count = 1, .reusable = false}, SHIFT(2093),
  [4911] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4913] = {.count = 1, .reusable = true}, SHIFT(2094),
  [4915] = {.count = 1, .reusable = true}, SHIFT(2095),
  [4917] = {.count = 1, .reusable = true}, SHIFT(2096),
  [4919] = {.count = 1, .reusable = true}, SHIFT(2097),
  [4921] = {.count = 1, .reusable = false}, SHIFT(2098),
  [4923] = {.count = 1, .reusable = true}, SHIFT(2098),
  [4925] = {.count = 1, .reusable = true}, SHIFT(2099),
  [4927] = {.count = 1, .reusable = false}, SHIFT(2100),
  [4929] = {.count = 1, .reusable = true}, SHIFT(2100),
  [4931] = {.count = 1, .reusable = true}, SHIFT(2101),
  [4933] = {.count = 1, .reusable = false}, SHIFT(2102),
  [4935] = {.count = 1, .reusable = true}, SHIFT(2102),
  [4937] = {.count = 1, .reusable = true}, SHIFT(2103),
  [4939] = {.count = 1, .reusable = true}, SHIFT(2104),
  [4941] = {.count = 1, .reusable = true}, SHIFT(2105),
  [4943] = {.count = 1, .reusable = true}, SHIFT(2106),
  [4945] = {.count = 1, .reusable = true}, SHIFT(2108),
  [4947] = {.count = 1, .reusable = true}, SHIFT(2109),
  [4949] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1388),
  [4952] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1389),
  [4955] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1389),
  [4958] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1390),
  [4961] = {.count = 1, .reusable = true}, SHIFT(2111),
  [4963] = {.count = 1, .reusable = true}, SHIFT(2112),
  [4965] = {.count = 1, .reusable = true}, SHIFT(2113),
  [4967] = {.count = 1, .reusable = false}, SHIFT(2114),
  [4969] = {.count = 1, .reusable = true}, SHIFT(2114),
  [4971] = {.count = 1, .reusable = false}, SHIFT(2115),
  [4973] = {.count = 1, .reusable = true}, SHIFT(2116),
  [4975] = {.count = 1, .reusable = true}, SHIFT(2118),
  [4977] = {.count = 1, .reusable = true}, SHIFT(2119),
  [4979] = {.count = 1, .reusable = true}, SHIFT(2120),
  [4981] = {.count = 1, .reusable = true}, SHIFT(2121),
  [4983] = {.count = 1, .reusable = true}, SHIFT(2122),
  [4985] = {.count = 1, .reusable = true}, SHIFT(2123),
  [4987] = {.count = 1, .reusable = false}, SHIFT(2124),
  [4989] = {.count = 1, .reusable = true}, SHIFT(2124),
  [4991] = {.count = 1, .reusable = true}, SHIFT(2125),
  [4993] = {.count = 1, .reusable = false}, SHIFT(2126),
  [4995] = {.count = 1, .reusable = true}, SHIFT(2126),
  [4997] = {.count = 1, .reusable = true}, SHIFT(2127),
  [4999] = {.count = 1, .reusable = true}, SHIFT(2128),
  [5001] = {.count = 1, .reusable = true}, SHIFT(2129),
  [5003] = {.count = 1, .reusable = false}, SHIFT(2130),
  [5005] = {.count = 1, .reusable = true}, SHIFT(2130),
  [5007] = {.count = 1, .reusable = false}, SHIFT(2131),
  [5009] = {.count = 1, .reusable = true}, SHIFT(2132),
  [5011] = {.count = 1, .reusable = true}, SHIFT(2134),
  [5013] = {.count = 1, .reusable = true}, SHIFT(2135),
  [5015] = {.count = 1, .reusable = true}, SHIFT(2136),
  [5017] = {.count = 1, .reusable = true}, SHIFT(2137),
  [5019] = {.count = 1, .reusable = true}, SHIFT(2138),
  [5021] = {.count = 1, .reusable = true}, SHIFT(2139),
  [5023] = {.count = 1, .reusable = false}, SHIFT(2140),
  [5025] = {.count = 1, .reusable = true}, SHIFT(2140),
  [5027] = {.count = 1, .reusable = true}, SHIFT(2141),
  [5029] = {.count = 1, .reusable = false}, SHIFT(2142),
  [5031] = {.count = 1, .reusable = true}, SHIFT(2142),
  [5033] = {.count = 1, .reusable = true}, SHIFT(2143),
  [5035] = {.count = 1, .reusable = true}, SHIFT(2144),
  [5037] = {.count = 1, .reusable = true}, SHIFT(2145),
  [5039] = {.count = 1, .reusable = true}, SHIFT(2146),
  [5041] = {.count = 1, .reusable = false}, SHIFT(2147),
  [5043] = {.count = 1, .reusable = true}, SHIFT(2147),
  [5045] = {.count = 1, .reusable = true}, SHIFT(2148),
  [5047] = {.count = 1, .reusable = false}, SHIFT(2149),
  [5049] = {.count = 1, .reusable = true}, SHIFT(2149),
  [5051] = {.count = 1, .reusable = true}, SHIFT(2150),
  [5053] = {.count = 1, .reusable = false}, SHIFT(2151),
  [5055] = {.count = 1, .reusable = true}, SHIFT(2151),
  [5057] = {.count = 1, .reusable = true}, SHIFT(2152),
  [5059] = {.count = 1, .reusable = true}, SHIFT(2153),
  [5061] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 4),
  [5063] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [5065] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [5067] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2, .alias_sequence_id = 3),
  [5069] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2),
  [5071] = {.count = 1, .reusable = true}, SHIFT(2154),
  [5073] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [5075] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [5077] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [5079] = {.count = 1, .reusable = true}, SHIFT(2156),
  [5081] = {.count = 1, .reusable = true}, SHIFT(2159),
  [5083] = {.count = 1, .reusable = false}, SHIFT(2160),
  [5085] = {.count = 1, .reusable = false}, SHIFT(2161),
  [5087] = {.count = 1, .reusable = false}, SHIFT(2162),
  [5089] = {.count = 1, .reusable = false}, SHIFT(2163),
  [5091] = {.count = 1, .reusable = false}, SHIFT(2164),
  [5093] = {.count = 1, .reusable = false}, SHIFT(2165),
  [5095] = {.count = 1, .reusable = false}, SHIFT(2166),
  [5097] = {.count = 1, .reusable = false}, SHIFT(2167),
  [5099] = {.count = 1, .reusable = false}, SHIFT(2168),
  [5101] = {.count = 1, .reusable = false}, SHIFT(2171),
  [5103] = {.count = 1, .reusable = false}, SHIFT(2172),
  [5105] = {.count = 1, .reusable = false}, SHIFT(2173),
  [5107] = {.count = 1, .reusable = false}, SHIFT(2174),
  [5109] = {.count = 1, .reusable = false}, SHIFT(2175),
  [5111] = {.count = 1, .reusable = false}, SHIFT(2176),
  [5113] = {.count = 1, .reusable = false}, SHIFT(2177),
  [5115] = {.count = 1, .reusable = false}, SHIFT(2178),
  [5117] = {.count = 1, .reusable = false}, SHIFT(2179),
  [5119] = {.count = 1, .reusable = false}, SHIFT(2182),
  [5121] = {.count = 1, .reusable = false}, SHIFT(2183),
  [5123] = {.count = 1, .reusable = false}, SHIFT(2184),
  [5125] = {.count = 1, .reusable = false}, SHIFT(2185),
  [5127] = {.count = 1, .reusable = true}, SHIFT(2186),
  [5129] = {.count = 1, .reusable = false}, SHIFT(2187),
  [5131] = {.count = 1, .reusable = false}, SHIFT(2188),
  [5133] = {.count = 1, .reusable = false}, SHIFT(2189),
  [5135] = {.count = 1, .reusable = false}, SHIFT(2190),
  [5137] = {.count = 1, .reusable = false}, SHIFT(2191),
  [5139] = {.count = 1, .reusable = true}, SHIFT(2194),
  [5141] = {.count = 1, .reusable = true}, SHIFT(1857),
  [5143] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(1464),
  [5146] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3),
  [5148] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3),
  [5150] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3),
  [5152] = {.count = 1, .reusable = false}, SHIFT(2200),
  [5154] = {.count = 1, .reusable = true}, SHIFT(2201),
  [5156] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 19),
  [5158] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 19),
  [5160] = {.count = 1, .reusable = true}, SHIFT(2205),
  [5162] = {.count = 1, .reusable = true}, SHIFT(2207),
  [5164] = {.count = 1, .reusable = true}, SHIFT(2209),
  [5166] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 20),
  [5168] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 20),
  [5170] = {.count = 1, .reusable = true}, SHIFT(2210),
  [5172] = {.count = 1, .reusable = true}, SHIFT(2211),
  [5174] = {.count = 1, .reusable = true}, SHIFT(2212),
  [5176] = {.count = 1, .reusable = true}, SHIFT(2213),
  [5178] = {.count = 1, .reusable = true}, SHIFT(2216),
  [5180] = {.count = 1, .reusable = true}, SHIFT(2217),
  [5182] = {.count = 1, .reusable = true}, SHIFT(2218),
  [5184] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1532),
  [5187] = {.count = 1, .reusable = true}, SHIFT(2219),
  [5189] = {.count = 1, .reusable = false}, SHIFT(2220),
  [5191] = {.count = 1, .reusable = true}, SHIFT(2221),
  [5193] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5195] = {.count = 1, .reusable = true}, SHIFT(2224),
  [5197] = {.count = 1, .reusable = true}, SHIFT(2225),
  [5199] = {.count = 1, .reusable = true}, SHIFT(2226),
  [5201] = {.count = 1, .reusable = false}, SHIFT(2228),
  [5203] = {.count = 1, .reusable = true}, SHIFT(2228),
  [5205] = {.count = 1, .reusable = true}, SHIFT(2227),
  [5207] = {.count = 1, .reusable = true}, SHIFT(2229),
  [5209] = {.count = 1, .reusable = false}, SHIFT(2231),
  [5211] = {.count = 1, .reusable = true}, SHIFT(2231),
  [5213] = {.count = 1, .reusable = true}, SHIFT(2230),
  [5215] = {.count = 1, .reusable = false}, SHIFT(2233),
  [5217] = {.count = 1, .reusable = true}, SHIFT(2233),
  [5219] = {.count = 1, .reusable = true}, SHIFT(2232),
  [5221] = {.count = 1, .reusable = true}, SHIFT(2234),
  [5223] = {.count = 1, .reusable = true}, SHIFT(2235),
  [5225] = {.count = 1, .reusable = true}, SHIFT(2236),
  [5227] = {.count = 1, .reusable = true}, SHIFT(2237),
  [5229] = {.count = 1, .reusable = true}, SHIFT(2238),
  [5231] = {.count = 1, .reusable = true}, SHIFT(2239),
  [5233] = {.count = 1, .reusable = true}, SHIFT(2240),
  [5235] = {.count = 1, .reusable = true}, SHIFT(2241),
  [5237] = {.count = 1, .reusable = true}, SHIFT(2242),
  [5239] = {.count = 1, .reusable = true}, SHIFT(2243),
  [5241] = {.count = 1, .reusable = true}, SHIFT(2244),
  [5243] = {.count = 1, .reusable = true}, SHIFT(2245),
  [5245] = {.count = 1, .reusable = true}, SHIFT(2246),
  [5247] = {.count = 1, .reusable = true}, SHIFT(2247),
  [5249] = {.count = 1, .reusable = true}, SHIFT(2248),
  [5251] = {.count = 1, .reusable = true}, SHIFT(2249),
  [5253] = {.count = 1, .reusable = true}, SHIFT(2250),
  [5255] = {.count = 1, .reusable = true}, SHIFT(2251),
  [5257] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6, .alias_sequence_id = 6),
  [5259] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6),
  [5261] = {.count = 1, .reusable = true}, SHIFT(2252),
  [5263] = {.count = 1, .reusable = true}, SHIFT(2253),
  [5265] = {.count = 1, .reusable = true}, SHIFT(2254),
  [5267] = {.count = 1, .reusable = false}, SHIFT(2255),
  [5269] = {.count = 1, .reusable = true}, SHIFT(2255),
  [5271] = {.count = 1, .reusable = false}, SHIFT(2256),
  [5273] = {.count = 1, .reusable = true}, SHIFT(2257),
  [5275] = {.count = 1, .reusable = true}, SHIFT(2259),
  [5277] = {.count = 1, .reusable = true}, SHIFT(2260),
  [5279] = {.count = 1, .reusable = true}, SHIFT(2261),
  [5281] = {.count = 1, .reusable = true}, SHIFT(2262),
  [5283] = {.count = 1, .reusable = true}, SHIFT(2263),
  [5285] = {.count = 1, .reusable = true}, SHIFT(2264),
  [5287] = {.count = 1, .reusable = false}, SHIFT(2265),
  [5289] = {.count = 1, .reusable = true}, SHIFT(2265),
  [5291] = {.count = 1, .reusable = true}, SHIFT(2266),
  [5293] = {.count = 1, .reusable = false}, SHIFT(2267),
  [5295] = {.count = 1, .reusable = true}, SHIFT(2267),
  [5297] = {.count = 1, .reusable = true}, SHIFT(2268),
  [5299] = {.count = 1, .reusable = true}, SHIFT(2269),
  [5301] = {.count = 1, .reusable = true}, SHIFT(2270),
  [5303] = {.count = 1, .reusable = true}, SHIFT(2271),
  [5305] = {.count = 1, .reusable = false}, SHIFT(2272),
  [5307] = {.count = 1, .reusable = true}, SHIFT(2272),
  [5309] = {.count = 1, .reusable = true}, SHIFT(2273),
  [5311] = {.count = 1, .reusable = false}, SHIFT(2274),
  [5313] = {.count = 1, .reusable = true}, SHIFT(2274),
  [5315] = {.count = 1, .reusable = true}, SHIFT(2275),
  [5317] = {.count = 1, .reusable = false}, SHIFT(2276),
  [5319] = {.count = 1, .reusable = true}, SHIFT(2276),
  [5321] = {.count = 1, .reusable = true}, SHIFT(2277),
  [5323] = {.count = 1, .reusable = true}, SHIFT(2278),
  [5325] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 16),
  [5327] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 16),
  [5329] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 17),
  [5331] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 17),
  [5333] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 18),
  [5335] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 18),
  [5337] = {.count = 1, .reusable = true}, SHIFT(2279),
  [5339] = {.count = 1, .reusable = true}, SHIFT(2280),
  [5341] = {.count = 1, .reusable = true}, SHIFT(2282),
  [5343] = {.count = 1, .reusable = true}, SHIFT(2285),
  [5345] = {.count = 1, .reusable = false}, SHIFT(2287),
  [5347] = {.count = 1, .reusable = true}, SHIFT(2288),
  [5349] = {.count = 1, .reusable = true}, SHIFT(2289),
  [5351] = {.count = 1, .reusable = false}, SHIFT(2291),
  [5353] = {.count = 1, .reusable = true}, SHIFT(2291),
  [5355] = {.count = 1, .reusable = true}, SHIFT(2290),
  [5357] = {.count = 1, .reusable = true}, SHIFT(2292),
  [5359] = {.count = 1, .reusable = true}, SHIFT(2293),
  [5361] = {.count = 1, .reusable = false}, SHIFT(2294),
  [5363] = {.count = 1, .reusable = false}, SHIFT(2293),
  [5365] = {.count = 1, .reusable = true}, SHIFT(2296),
  [5367] = {.count = 1, .reusable = false}, SHIFT(2298),
  [5369] = {.count = 1, .reusable = true}, SHIFT(2298),
  [5371] = {.count = 1, .reusable = true}, SHIFT(2297),
  [5373] = {.count = 1, .reusable = true}, SHIFT(2299),
  [5375] = {.count = 1, .reusable = false}, SHIFT(2301),
  [5377] = {.count = 1, .reusable = true}, SHIFT(2301),
  [5379] = {.count = 1, .reusable = true}, SHIFT(2300),
  [5381] = {.count = 1, .reusable = true}, SHIFT(2302),
  [5383] = {.count = 1, .reusable = true}, SHIFT(2303),
  [5385] = {.count = 1, .reusable = true}, SHIFT(2304),
  [5387] = {.count = 1, .reusable = true}, SHIFT(2305),
  [5389] = {.count = 1, .reusable = true}, SHIFT(2306),
  [5391] = {.count = 1, .reusable = true}, SHIFT(2307),
  [5393] = {.count = 1, .reusable = false}, SHIFT(2308),
  [5395] = {.count = 1, .reusable = true}, SHIFT(2308),
  [5397] = {.count = 1, .reusable = true}, SHIFT(2309),
  [5399] = {.count = 1, .reusable = false}, SHIFT(2310),
  [5401] = {.count = 1, .reusable = true}, SHIFT(2310),
  [5403] = {.count = 1, .reusable = true}, SHIFT(2311),
  [5405] = {.count = 1, .reusable = false}, SHIFT(2312),
  [5407] = {.count = 1, .reusable = true}, SHIFT(2312),
  [5409] = {.count = 1, .reusable = true}, SHIFT(2313),
  [5411] = {.count = 1, .reusable = true}, SHIFT(2314),
  [5413] = {.count = 1, .reusable = true}, SHIFT(2315),
  [5415] = {.count = 1, .reusable = true}, SHIFT(2316),
  [5417] = {.count = 1, .reusable = true}, SHIFT(2317),
  [5419] = {.count = 1, .reusable = true}, SHIFT(2318),
  [5421] = {.count = 1, .reusable = false}, SHIFT(2319),
  [5423] = {.count = 1, .reusable = true}, SHIFT(2319),
  [5425] = {.count = 1, .reusable = true}, SHIFT(2320),
  [5427] = {.count = 1, .reusable = false}, SHIFT(2321),
  [5429] = {.count = 1, .reusable = true}, SHIFT(2321),
  [5431] = {.count = 1, .reusable = true}, SHIFT(2322),
  [5433] = {.count = 1, .reusable = false}, SHIFT(2323),
  [5435] = {.count = 1, .reusable = true}, SHIFT(2323),
  [5437] = {.count = 1, .reusable = true}, SHIFT(2324),
  [5439] = {.count = 1, .reusable = true}, SHIFT(2325),
  [5441] = {.count = 1, .reusable = true}, SHIFT(2326),
  [5443] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5445] = {.count = 1, .reusable = true}, SHIFT(2328),
  [5447] = {.count = 1, .reusable = true}, SHIFT(2331),
  [5449] = {.count = 1, .reusable = true}, SHIFT(2332),
  [5451] = {.count = 1, .reusable = true}, SHIFT(2333),
  [5453] = {.count = 1, .reusable = true}, SHIFT(2334),
  [5455] = {.count = 1, .reusable = false}, SHIFT(2335),
  [5457] = {.count = 1, .reusable = true}, SHIFT(2335),
  [5459] = {.count = 1, .reusable = true}, SHIFT(2336),
  [5461] = {.count = 1, .reusable = false}, SHIFT(2337),
  [5463] = {.count = 1, .reusable = true}, SHIFT(2337),
  [5465] = {.count = 1, .reusable = true}, SHIFT(2338),
  [5467] = {.count = 1, .reusable = false}, SHIFT(2339),
  [5469] = {.count = 1, .reusable = true}, SHIFT(2339),
  [5471] = {.count = 1, .reusable = true}, SHIFT(2340),
  [5473] = {.count = 1, .reusable = true}, SHIFT(2341),
  [5475] = {.count = 1, .reusable = true}, SHIFT(2342),
  [5477] = {.count = 1, .reusable = true}, SHIFT(2343),
  [5479] = {.count = 1, .reusable = true}, SHIFT(2344),
  [5481] = {.count = 1, .reusable = true}, SHIFT(2345),
  [5483] = {.count = 1, .reusable = false}, SHIFT(2346),
  [5485] = {.count = 1, .reusable = true}, SHIFT(2346),
  [5487] = {.count = 1, .reusable = true}, SHIFT(2347),
  [5489] = {.count = 1, .reusable = false}, SHIFT(2348),
  [5491] = {.count = 1, .reusable = true}, SHIFT(2348),
  [5493] = {.count = 1, .reusable = true}, SHIFT(2349),
  [5495] = {.count = 1, .reusable = false}, SHIFT(2350),
  [5497] = {.count = 1, .reusable = true}, SHIFT(2350),
  [5499] = {.count = 1, .reusable = true}, SHIFT(2351),
  [5501] = {.count = 1, .reusable = true}, SHIFT(2352),
  [5503] = {.count = 1, .reusable = true}, SHIFT(2353),
  [5505] = {.count = 1, .reusable = true}, SHIFT(2354),
  [5507] = {.count = 1, .reusable = true}, SHIFT(2355),
  [5509] = {.count = 1, .reusable = true}, SHIFT(2356),
  [5511] = {.count = 1, .reusable = true}, SHIFT(2357),
  [5513] = {.count = 1, .reusable = true}, SHIFT(2359),
  [5515] = {.count = 1, .reusable = true}, SHIFT(2361),
  [5517] = {.count = 1, .reusable = true}, SHIFT(2362),
  [5519] = {.count = 1, .reusable = true}, SHIFT(2363),
  [5521] = {.count = 1, .reusable = false}, SHIFT(2365),
  [5523] = {.count = 1, .reusable = true}, SHIFT(2161),
  [5525] = {.count = 1, .reusable = true}, SHIFT(2367),
  [5527] = {.count = 1, .reusable = true}, SHIFT(2368),
  [5529] = {.count = 1, .reusable = false}, SHIFT(2369),
  [5531] = {.count = 1, .reusable = false}, SHIFT(2367),
  [5533] = {.count = 1, .reusable = true}, SHIFT(2370),
  [5535] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5537] = {.count = 1, .reusable = true}, SHIFT(2372),
  [5539] = {.count = 1, .reusable = false}, SHIFT(2373),
  [5541] = {.count = 1, .reusable = false}, SHIFT(2371),
  [5543] = {.count = 1, .reusable = true}, SHIFT(2382),
  [5545] = {.count = 1, .reusable = false}, SHIFT(2384),
  [5547] = {.count = 1, .reusable = true}, SHIFT(2172),
  [5549] = {.count = 1, .reusable = true}, SHIFT(2386),
  [5551] = {.count = 1, .reusable = true}, SHIFT(2387),
  [5553] = {.count = 1, .reusable = false}, SHIFT(2388),
  [5555] = {.count = 1, .reusable = false}, SHIFT(2386),
  [5557] = {.count = 1, .reusable = true}, SHIFT(2389),
  [5559] = {.count = 1, .reusable = true}, SHIFT(2390),
  [5561] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5563] = {.count = 1, .reusable = false}, SHIFT(2392),
  [5565] = {.count = 1, .reusable = false}, SHIFT(2390),
  [5567] = {.count = 1, .reusable = true}, SHIFT(2402),
  [5569] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [5571] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [5573] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [5575] = {.count = 1, .reusable = false}, SHIFT(2405),
  [5577] = {.count = 1, .reusable = true}, SHIFT(2405),
  [5579] = {.count = 1, .reusable = false}, SHIFT(2406),
  [5581] = {.count = 1, .reusable = false}, SHIFT(2407),
  [5583] = {.count = 1, .reusable = true}, SHIFT(2408),
  [5585] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5587] = {.count = 1, .reusable = true}, SHIFT(2410),
  [5589] = {.count = 1, .reusable = true}, SHIFT(2411),
  [5591] = {.count = 1, .reusable = false}, SHIFT(2415),
  [5593] = {.count = 1, .reusable = true}, SHIFT(2417),
  [5595] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4),
  [5597] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4),
  [5599] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4),
  [5601] = {.count = 1, .reusable = false}, SHIFT(2420),
  [5603] = {.count = 1, .reusable = true}, SHIFT(2421),
  [5605] = {.count = 1, .reusable = true}, SHIFT(2424),
  [5607] = {.count = 1, .reusable = true}, SHIFT(2428),
  [5609] = {.count = 1, .reusable = true}, SHIFT(2429),
  [5611] = {.count = 1, .reusable = true}, SHIFT(2433),
  [5613] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 21),
  [5615] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 21),
  [5617] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 22),
  [5619] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 22),
  [5621] = {.count = 1, .reusable = true}, SHIFT(2434),
  [5623] = {.count = 1, .reusable = true}, SHIFT(2435),
  [5625] = {.count = 1, .reusable = true}, SHIFT(2436),
  [5627] = {.count = 1, .reusable = false}, SHIFT(2437),
  [5629] = {.count = 1, .reusable = true}, SHIFT(2437),
  [5631] = {.count = 1, .reusable = false}, SHIFT(2438),
  [5633] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5635] = {.count = 1, .reusable = true}, SHIFT(2441),
  [5637] = {.count = 1, .reusable = true}, SHIFT(2442),
  [5639] = {.count = 1, .reusable = true}, SHIFT(2443),
  [5641] = {.count = 1, .reusable = true}, SHIFT(2444),
  [5643] = {.count = 1, .reusable = true}, SHIFT(2445),
  [5645] = {.count = 1, .reusable = true}, SHIFT(2446),
  [5647] = {.count = 1, .reusable = false}, SHIFT(2447),
  [5649] = {.count = 1, .reusable = true}, SHIFT(2447),
  [5651] = {.count = 1, .reusable = true}, SHIFT(2448),
  [5653] = {.count = 1, .reusable = false}, SHIFT(2449),
  [5655] = {.count = 1, .reusable = true}, SHIFT(2449),
  [5657] = {.count = 1, .reusable = true}, SHIFT(2450),
  [5659] = {.count = 1, .reusable = true}, SHIFT(2451),
  [5661] = {.count = 1, .reusable = true}, SHIFT(2452),
  [5663] = {.count = 1, .reusable = true}, SHIFT(2453),
  [5665] = {.count = 1, .reusable = false}, SHIFT(2454),
  [5667] = {.count = 1, .reusable = true}, SHIFT(2454),
  [5669] = {.count = 1, .reusable = true}, SHIFT(2455),
  [5671] = {.count = 1, .reusable = false}, SHIFT(2456),
  [5673] = {.count = 1, .reusable = true}, SHIFT(2456),
  [5675] = {.count = 1, .reusable = true}, SHIFT(2457),
  [5677] = {.count = 1, .reusable = false}, SHIFT(2458),
  [5679] = {.count = 1, .reusable = true}, SHIFT(2458),
  [5681] = {.count = 1, .reusable = true}, SHIFT(2459),
  [5683] = {.count = 1, .reusable = true}, SHIFT(2460),
  [5685] = {.count = 1, .reusable = true}, SHIFT(2461),
  [5687] = {.count = 1, .reusable = true}, SHIFT(2462),
  [5689] = {.count = 1, .reusable = true}, SHIFT(2463),
  [5691] = {.count = 1, .reusable = true}, SHIFT(2464),
  [5693] = {.count = 1, .reusable = true}, SHIFT(2465),
  [5695] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2043),
  [5698] = {.count = 1, .reusable = true}, SHIFT(2466),
  [5700] = {.count = 1, .reusable = false}, SHIFT(2467),
  [5702] = {.count = 1, .reusable = true}, SHIFT(2468),
  [5704] = {.count = 1, .reusable = true}, SHIFT(2470),
  [5706] = {.count = 1, .reusable = true}, SHIFT(2471),
  [5708] = {.count = 1, .reusable = true}, SHIFT(2472),
  [5710] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5712] = {.count = 1, .reusable = false}, SHIFT(2475),
  [5714] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5716] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5718] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5720] = {.count = 1, .reusable = false}, SHIFT(2478),
  [5722] = {.count = 1, .reusable = true}, SHIFT(2478),
  [5724] = {.count = 1, .reusable = true}, SHIFT(2477),
  [5726] = {.count = 1, .reusable = false}, SHIFT(2480),
  [5728] = {.count = 1, .reusable = true}, SHIFT(2480),
  [5730] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5732] = {.count = 1, .reusable = true}, SHIFT(2481),
  [5734] = {.count = 1, .reusable = true}, SHIFT(2482),
  [5736] = {.count = 1, .reusable = true}, SHIFT(2483),
  [5738] = {.count = 1, .reusable = true}, SHIFT(2484),
  [5740] = {.count = 1, .reusable = true}, SHIFT(2485),
  [5742] = {.count = 1, .reusable = true}, SHIFT(2486),
  [5744] = {.count = 1, .reusable = true}, SHIFT(2487),
  [5746] = {.count = 1, .reusable = true}, SHIFT(2488),
  [5748] = {.count = 1, .reusable = true}, SHIFT(2489),
  [5750] = {.count = 1, .reusable = true}, SHIFT(2490),
  [5752] = {.count = 1, .reusable = true}, SHIFT(2491),
  [5754] = {.count = 1, .reusable = true}, SHIFT(2492),
  [5756] = {.count = 1, .reusable = true}, SHIFT(2493),
  [5758] = {.count = 1, .reusable = true}, SHIFT(2494),
  [5760] = {.count = 1, .reusable = true}, SHIFT(2495),
  [5762] = {.count = 1, .reusable = true}, SHIFT(2498),
  [5764] = {.count = 1, .reusable = true}, SHIFT(2499),
  [5766] = {.count = 1, .reusable = false}, SHIFT(2500),
  [5768] = {.count = 1, .reusable = true}, SHIFT(2501),
  [5770] = {.count = 1, .reusable = false}, SHIFT(2502),
  [5772] = {.count = 1, .reusable = false}, SHIFT(2503),
  [5774] = {.count = 1, .reusable = true}, SHIFT(2505),
  [5776] = {.count = 1, .reusable = true}, SHIFT(2506),
  [5778] = {.count = 1, .reusable = true}, SHIFT(2507),
  [5780] = {.count = 1, .reusable = true}, SHIFT(2508),
  [5782] = {.count = 1, .reusable = true}, SHIFT(2164),
  [5784] = {.count = 1, .reusable = true}, SHIFT(2165),
  [5786] = {.count = 1, .reusable = true}, SHIFT(2166),
  [5788] = {.count = 1, .reusable = true}, SHIFT(2167),
  [5790] = {.count = 1, .reusable = true}, SHIFT(2509),
  [5792] = {.count = 1, .reusable = false}, SHIFT(2511),
  [5794] = {.count = 1, .reusable = true}, SHIFT(2512),
  [5796] = {.count = 1, .reusable = true}, SHIFT(2513),
  [5798] = {.count = 1, .reusable = false}, SHIFT(2515),
  [5800] = {.count = 1, .reusable = true}, SHIFT(2515),
  [5802] = {.count = 1, .reusable = true}, SHIFT(2514),
  [5804] = {.count = 1, .reusable = true}, SHIFT(2516),
  [5806] = {.count = 1, .reusable = true}, SHIFT(2517),
  [5808] = {.count = 1, .reusable = false}, SHIFT(2518),
  [5810] = {.count = 1, .reusable = false}, SHIFT(2517),
  [5812] = {.count = 1, .reusable = true}, SHIFT(2520),
  [5814] = {.count = 1, .reusable = false}, SHIFT(2522),
  [5816] = {.count = 1, .reusable = true}, SHIFT(2522),
  [5818] = {.count = 1, .reusable = true}, SHIFT(2521),
  [5820] = {.count = 1, .reusable = true}, SHIFT(2523),
  [5822] = {.count = 1, .reusable = false}, SHIFT(2525),
  [5824] = {.count = 1, .reusable = true}, SHIFT(2525),
  [5826] = {.count = 1, .reusable = true}, SHIFT(2524),
  [5828] = {.count = 1, .reusable = true}, SHIFT(2526),
  [5830] = {.count = 1, .reusable = true}, SHIFT(2527),
  [5832] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2159),
  [5835] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2160),
  [5838] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2161),
  [5841] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2162),
  [5844] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2163),
  [5847] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2164),
  [5850] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2165),
  [5853] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2166),
  [5856] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2167),
  [5859] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2168),
  [5862] = {.count = 1, .reusable = true}, SHIFT(2528),
  [5864] = {.count = 1, .reusable = true}, SHIFT(2175),
  [5866] = {.count = 1, .reusable = true}, SHIFT(2176),
  [5868] = {.count = 1, .reusable = true}, SHIFT(2177),
  [5870] = {.count = 1, .reusable = true}, SHIFT(2178),
  [5872] = {.count = 1, .reusable = false}, SHIFT(2530),
  [5874] = {.count = 1, .reusable = true}, SHIFT(2531),
  [5876] = {.count = 1, .reusable = true}, SHIFT(2532),
  [5878] = {.count = 1, .reusable = false}, SHIFT(2534),
  [5880] = {.count = 1, .reusable = true}, SHIFT(2534),
  [5882] = {.count = 1, .reusable = true}, SHIFT(2533),
  [5884] = {.count = 1, .reusable = true}, SHIFT(2535),
  [5886] = {.count = 1, .reusable = true}, SHIFT(2536),
  [5888] = {.count = 1, .reusable = false}, SHIFT(2537),
  [5890] = {.count = 1, .reusable = false}, SHIFT(2536),
  [5892] = {.count = 1, .reusable = true}, SHIFT(2539),
  [5894] = {.count = 1, .reusable = false}, SHIFT(2541),
  [5896] = {.count = 1, .reusable = true}, SHIFT(2541),
  [5898] = {.count = 1, .reusable = true}, SHIFT(2540),
  [5900] = {.count = 1, .reusable = true}, SHIFT(2542),
  [5902] = {.count = 1, .reusable = false}, SHIFT(2544),
  [5904] = {.count = 1, .reusable = true}, SHIFT(2544),
  [5906] = {.count = 1, .reusable = true}, SHIFT(2543),
  [5908] = {.count = 1, .reusable = true}, SHIFT(2545),
  [5910] = {.count = 1, .reusable = true}, SHIFT(2546),
  [5912] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2171),
  [5915] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2172),
  [5918] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2173),
  [5921] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2174),
  [5924] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2175),
  [5927] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2176),
  [5930] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2177),
  [5933] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2178),
  [5936] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2179),
  [5939] = {.count = 1, .reusable = true}, SHIFT(2548),
  [5941] = {.count = 1, .reusable = true}, SHIFT(2549),
  [5943] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2186),
  [5946] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2188),
  [5949] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2189),
  [5952] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2187),
  [5955] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2190),
  [5958] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2191),
  [5961] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [5963] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [5965] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [5967] = {.count = 1, .reusable = false}, SHIFT(2552),
  [5969] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5),
  [5971] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5),
  [5973] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5),
  [5975] = {.count = 1, .reusable = false}, SHIFT(2553),
  [5977] = {.count = 1, .reusable = false}, SHIFT(2554),
  [5979] = {.count = 1, .reusable = true}, SHIFT(2555),
  [5981] = {.count = 1, .reusable = false}, SHIFT(2560),
  [5983] = {.count = 1, .reusable = true}, SHIFT(2561),
  [5985] = {.count = 1, .reusable = true}, SHIFT(2565),
  [5987] = {.count = 1, .reusable = true}, SHIFT(2566),
  [5989] = {.count = 1, .reusable = true}, SHIFT(2567),
  [5991] = {.count = 1, .reusable = true}, SHIFT(2568),
  [5993] = {.count = 1, .reusable = false}, SHIFT(2569),
  [5995] = {.count = 1, .reusable = true}, SHIFT(2569),
  [5997] = {.count = 1, .reusable = true}, SHIFT(2570),
  [5999] = {.count = 1, .reusable = false}, SHIFT(2571),
  [6001] = {.count = 1, .reusable = true}, SHIFT(2571),
  [6003] = {.count = 1, .reusable = true}, SHIFT(2572),
  [6005] = {.count = 1, .reusable = false}, SHIFT(2573),
  [6007] = {.count = 1, .reusable = true}, SHIFT(2573),
  [6009] = {.count = 1, .reusable = true}, SHIFT(2574),
  [6011] = {.count = 1, .reusable = true}, SHIFT(2575),
  [6013] = {.count = 1, .reusable = true}, SHIFT(2576),
  [6015] = {.count = 1, .reusable = true}, SHIFT(2577),
  [6017] = {.count = 1, .reusable = true}, SHIFT(2578),
  [6019] = {.count = 1, .reusable = true}, SHIFT(2579),
  [6021] = {.count = 1, .reusable = true}, SHIFT(2580),
  [6023] = {.count = 1, .reusable = true}, SHIFT(2581),
  [6025] = {.count = 1, .reusable = false}, SHIFT(2582),
  [6027] = {.count = 1, .reusable = true}, SHIFT(2582),
  [6029] = {.count = 1, .reusable = false}, SHIFT(2583),
  [6031] = {.count = 1, .reusable = true}, SHIFT(2584),
  [6033] = {.count = 1, .reusable = true}, SHIFT(2586),
  [6035] = {.count = 1, .reusable = true}, SHIFT(2587),
  [6037] = {.count = 1, .reusable = true}, SHIFT(2588),
  [6039] = {.count = 1, .reusable = true}, SHIFT(2589),
  [6041] = {.count = 1, .reusable = true}, SHIFT(2590),
  [6043] = {.count = 1, .reusable = true}, SHIFT(2591),
  [6045] = {.count = 1, .reusable = false}, SHIFT(2592),
  [6047] = {.count = 1, .reusable = true}, SHIFT(2592),
  [6049] = {.count = 1, .reusable = true}, SHIFT(2593),
  [6051] = {.count = 1, .reusable = false}, SHIFT(2594),
  [6053] = {.count = 1, .reusable = true}, SHIFT(2594),
  [6055] = {.count = 1, .reusable = false}, SHIFT(2597),
  [6057] = {.count = 1, .reusable = true}, SHIFT(2597),
  [6059] = {.count = 1, .reusable = true}, SHIFT(2598),
  [6061] = {.count = 1, .reusable = true}, SHIFT(2599),
  [6063] = {.count = 1, .reusable = false}, SHIFT(2600),
  [6065] = {.count = 1, .reusable = true}, SHIFT(2601),
  [6067] = {.count = 1, .reusable = true}, SHIFT(2602),
  [6069] = {.count = 1, .reusable = true}, SHIFT(2603),
  [6071] = {.count = 1, .reusable = true}, SHIFT(2604),
  [6073] = {.count = 1, .reusable = true}, SHIFT(2605),
  [6075] = {.count = 1, .reusable = false}, SHIFT(2606),
  [6077] = {.count = 1, .reusable = true}, SHIFT(2606),
  [6079] = {.count = 1, .reusable = true}, SHIFT(2607),
  [6081] = {.count = 1, .reusable = true}, SHIFT(2608),
  [6083] = {.count = 1, .reusable = true}, SHIFT(2609),
  [6085] = {.count = 1, .reusable = true}, SHIFT(2610),
  [6087] = {.count = 1, .reusable = true}, SHIFT(2612),
  [6089] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2363),
  [6092] = {.count = 1, .reusable = true}, SHIFT(2614),
  [6094] = {.count = 1, .reusable = false}, SHIFT(2615),
  [6096] = {.count = 1, .reusable = true}, SHIFT(2616),
  [6098] = {.count = 1, .reusable = true}, SHIFT(2618),
  [6100] = {.count = 1, .reusable = true}, SHIFT(2619),
  [6102] = {.count = 1, .reusable = true}, SHIFT(2620),
  [6104] = {.count = 1, .reusable = true}, SHIFT(2621),
  [6106] = {.count = 1, .reusable = false}, SHIFT(2623),
  [6108] = {.count = 1, .reusable = true}, SHIFT(2623),
  [6110] = {.count = 1, .reusable = true}, SHIFT(2622),
  [6112] = {.count = 1, .reusable = true}, SHIFT(2624),
  [6114] = {.count = 1, .reusable = false}, SHIFT(2626),
  [6116] = {.count = 1, .reusable = true}, SHIFT(2626),
  [6118] = {.count = 1, .reusable = true}, SHIFT(2625),
  [6120] = {.count = 1, .reusable = false}, SHIFT(2628),
  [6122] = {.count = 1, .reusable = true}, SHIFT(2628),
  [6124] = {.count = 1, .reusable = true}, SHIFT(2627),
  [6126] = {.count = 1, .reusable = true}, SHIFT(2629),
  [6128] = {.count = 1, .reusable = true}, SHIFT(2630),
  [6130] = {.count = 1, .reusable = true}, SHIFT(2631),
  [6132] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2382),
  [6135] = {.count = 1, .reusable = true}, SHIFT(2632),
  [6137] = {.count = 1, .reusable = false}, SHIFT(2633),
  [6139] = {.count = 1, .reusable = true}, SHIFT(2634),
  [6141] = {.count = 1, .reusable = true}, SHIFT(2636),
  [6143] = {.count = 1, .reusable = true}, SHIFT(2637),
  [6145] = {.count = 1, .reusable = true}, SHIFT(2638),
  [6147] = {.count = 1, .reusable = true}, SHIFT(2639),
  [6149] = {.count = 1, .reusable = false}, SHIFT(2641),
  [6151] = {.count = 1, .reusable = true}, SHIFT(2641),
  [6153] = {.count = 1, .reusable = true}, SHIFT(2640),
  [6155] = {.count = 1, .reusable = true}, SHIFT(2642),
  [6157] = {.count = 1, .reusable = false}, SHIFT(2644),
  [6159] = {.count = 1, .reusable = true}, SHIFT(2644),
  [6161] = {.count = 1, .reusable = true}, SHIFT(2643),
  [6163] = {.count = 1, .reusable = false}, SHIFT(2646),
  [6165] = {.count = 1, .reusable = true}, SHIFT(2646),
  [6167] = {.count = 1, .reusable = true}, SHIFT(2645),
  [6169] = {.count = 1, .reusable = true}, SHIFT(2647),
  [6171] = {.count = 1, .reusable = true}, SHIFT(2648),
  [6173] = {.count = 1, .reusable = true}, SHIFT(2649),
  [6175] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 6, .alias_sequence_id = 1),
  [6177] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 6, .alias_sequence_id = 1),
  [6179] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 6, .alias_sequence_id = 1),
  [6181] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 6),
  [6183] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 6),
  [6185] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 6),
  [6187] = {.count = 1, .reusable = false}, SHIFT(2651),
  [6189] = {.count = 1, .reusable = true}, SHIFT(2652),
  [6191] = {.count = 1, .reusable = false}, SHIFT(2655),
  [6193] = {.count = 1, .reusable = true}, SHIFT(2656),
  [6195] = {.count = 1, .reusable = true}, SHIFT(2659),
  [6197] = {.count = 1, .reusable = true}, SHIFT(2660),
  [6199] = {.count = 1, .reusable = true}, SHIFT(2661),
  [6201] = {.count = 1, .reusable = true}, SHIFT(2662),
  [6203] = {.count = 1, .reusable = true}, SHIFT(2663),
  [6205] = {.count = 1, .reusable = true}, SHIFT(2664),
  [6207] = {.count = 1, .reusable = true}, SHIFT(2665),
  [6209] = {.count = 1, .reusable = false}, SHIFT(2666),
  [6211] = {.count = 1, .reusable = true}, SHIFT(2666),
  [6213] = {.count = 1, .reusable = true}, SHIFT(2667),
  [6215] = {.count = 1, .reusable = false}, SHIFT(2668),
  [6217] = {.count = 1, .reusable = true}, SHIFT(2668),
  [6219] = {.count = 1, .reusable = true}, SHIFT(2669),
  [6221] = {.count = 1, .reusable = false}, SHIFT(2670),
  [6223] = {.count = 1, .reusable = true}, SHIFT(2670),
  [6225] = {.count = 1, .reusable = true}, SHIFT(2671),
  [6227] = {.count = 1, .reusable = true}, SHIFT(2672),
  [6229] = {.count = 1, .reusable = true}, SHIFT(2673),
  [6231] = {.count = 1, .reusable = true}, SHIFT(2674),
  [6233] = {.count = 1, .reusable = true}, SHIFT(2675),
  [6235] = {.count = 1, .reusable = false}, SHIFT(2677),
  [6237] = {.count = 1, .reusable = true}, SHIFT(2679),
  [6239] = {.count = 1, .reusable = true}, SHIFT(2680),
  [6241] = {.count = 1, .reusable = false}, SHIFT(2681),
  [6243] = {.count = 1, .reusable = false}, SHIFT(2679),
  [6245] = {.count = 1, .reusable = true}, SHIFT(2682),
  [6247] = {.count = 1, .reusable = true}, SHIFT(2683),
  [6249] = {.count = 1, .reusable = true}, SHIFT(2684),
  [6251] = {.count = 1, .reusable = false}, SHIFT(2685),
  [6253] = {.count = 1, .reusable = false}, SHIFT(2683),
  [6255] = {.count = 1, .reusable = true}, SHIFT(2693),
  [6257] = {.count = 1, .reusable = true}, SHIFT(2694),
  [6259] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2501),
  [6262] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2502),
  [6265] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2503),
  [6268] = {.count = 1, .reusable = true}, SHIFT(2696),
  [6270] = {.count = 1, .reusable = true}, SHIFT(2697),
  [6272] = {.count = 1, .reusable = true}, SHIFT(2698),
  [6274] = {.count = 1, .reusable = true}, SHIFT(2699),
  [6276] = {.count = 1, .reusable = false}, SHIFT(2700),
  [6278] = {.count = 1, .reusable = true}, SHIFT(2700),
  [6280] = {.count = 1, .reusable = false}, SHIFT(2701),
  [6282] = {.count = 1, .reusable = true}, SHIFT(2702),
  [6284] = {.count = 1, .reusable = true}, SHIFT(2704),
  [6286] = {.count = 1, .reusable = true}, SHIFT(2705),
  [6288] = {.count = 1, .reusable = true}, SHIFT(2706),
  [6290] = {.count = 1, .reusable = true}, SHIFT(2707),
  [6292] = {.count = 1, .reusable = true}, SHIFT(2708),
  [6294] = {.count = 1, .reusable = true}, SHIFT(2709),
  [6296] = {.count = 1, .reusable = false}, SHIFT(2710),
  [6298] = {.count = 1, .reusable = true}, SHIFT(2710),
  [6300] = {.count = 1, .reusable = true}, SHIFT(2711),
  [6302] = {.count = 1, .reusable = false}, SHIFT(2712),
  [6304] = {.count = 1, .reusable = true}, SHIFT(2712),
  [6306] = {.count = 1, .reusable = true}, SHIFT(2713),
  [6308] = {.count = 1, .reusable = true}, SHIFT(2714),
  [6310] = {.count = 1, .reusable = true}, SHIFT(2715),
  [6312] = {.count = 1, .reusable = false}, SHIFT(2716),
  [6314] = {.count = 1, .reusable = true}, SHIFT(2716),
  [6316] = {.count = 1, .reusable = false}, SHIFT(2717),
  [6318] = {.count = 1, .reusable = true}, SHIFT(2718),
  [6320] = {.count = 1, .reusable = true}, SHIFT(2720),
  [6322] = {.count = 1, .reusable = true}, SHIFT(2721),
  [6324] = {.count = 1, .reusable = true}, SHIFT(2722),
  [6326] = {.count = 1, .reusable = true}, SHIFT(2723),
  [6328] = {.count = 1, .reusable = true}, SHIFT(2724),
  [6330] = {.count = 1, .reusable = true}, SHIFT(2725),
  [6332] = {.count = 1, .reusable = false}, SHIFT(2726),
  [6334] = {.count = 1, .reusable = true}, SHIFT(2726),
  [6336] = {.count = 1, .reusable = true}, SHIFT(2727),
  [6338] = {.count = 1, .reusable = false}, SHIFT(2728),
  [6340] = {.count = 1, .reusable = true}, SHIFT(2728),
  [6342] = {.count = 1, .reusable = false}, SHIFT(2729),
  [6344] = {.count = 1, .reusable = false}, SHIFT(2730),
  [6346] = {.count = 1, .reusable = true}, SHIFT(2731),
  [6348] = {.count = 1, .reusable = true}, SHIFT(2732),
  [6350] = {.count = 1, .reusable = true}, SHIFT(2733),
  [6352] = {.count = 1, .reusable = true}, SHIFT(2734),
  [6354] = {.count = 1, .reusable = false}, SHIFT(2736),
  [6356] = {.count = 1, .reusable = true}, SHIFT(2737),
  [6358] = {.count = 1, .reusable = true}, SHIFT(2738),
  [6360] = {.count = 1, .reusable = false}, SHIFT(2740),
  [6362] = {.count = 1, .reusable = true}, SHIFT(2740),
  [6364] = {.count = 1, .reusable = true}, SHIFT(2739),
  [6366] = {.count = 1, .reusable = true}, SHIFT(2741),
  [6368] = {.count = 1, .reusable = true}, SHIFT(2742),
  [6370] = {.count = 1, .reusable = false}, SHIFT(2743),
  [6372] = {.count = 1, .reusable = false}, SHIFT(2742),
  [6374] = {.count = 1, .reusable = true}, SHIFT(2745),
  [6376] = {.count = 1, .reusable = false}, SHIFT(2747),
  [6378] = {.count = 1, .reusable = true}, SHIFT(2747),
  [6380] = {.count = 1, .reusable = true}, SHIFT(2746),
  [6382] = {.count = 1, .reusable = true}, SHIFT(2748),
  [6384] = {.count = 1, .reusable = false}, SHIFT(2750),
  [6386] = {.count = 1, .reusable = true}, SHIFT(2750),
  [6388] = {.count = 1, .reusable = true}, SHIFT(2749),
  [6390] = {.count = 1, .reusable = true}, SHIFT(2751),
  [6392] = {.count = 1, .reusable = true}, SHIFT(2752),
  [6394] = {.count = 1, .reusable = true}, SHIFT(2754),
  [6396] = {.count = 1, .reusable = true}, SHIFT(2755),
  [6398] = {.count = 1, .reusable = true}, SHIFT(2756),
  [6400] = {.count = 1, .reusable = true}, SHIFT(2757),
  [6402] = {.count = 1, .reusable = false}, SHIFT(2758),
  [6404] = {.count = 1, .reusable = true}, SHIFT(2758),
  [6406] = {.count = 1, .reusable = true}, SHIFT(2759),
  [6408] = {.count = 1, .reusable = false}, SHIFT(2760),
  [6410] = {.count = 1, .reusable = true}, SHIFT(2760),
  [6412] = {.count = 1, .reusable = true}, SHIFT(2761),
  [6414] = {.count = 1, .reusable = false}, SHIFT(2762),
  [6416] = {.count = 1, .reusable = true}, SHIFT(2762),
  [6418] = {.count = 1, .reusable = true}, SHIFT(2763),
  [6420] = {.count = 1, .reusable = true}, SHIFT(2764),
  [6422] = {.count = 1, .reusable = true}, SHIFT(2765),
  [6424] = {.count = 1, .reusable = true}, SHIFT(2766),
  [6426] = {.count = 1, .reusable = true}, SHIFT(2767),
  [6428] = {.count = 1, .reusable = true}, SHIFT(2768),
  [6430] = {.count = 1, .reusable = false}, SHIFT(2769),
  [6432] = {.count = 1, .reusable = true}, SHIFT(2769),
  [6434] = {.count = 1, .reusable = true}, SHIFT(2770),
  [6436] = {.count = 1, .reusable = false}, SHIFT(2771),
  [6438] = {.count = 1, .reusable = true}, SHIFT(2771),
  [6440] = {.count = 1, .reusable = true}, SHIFT(2772),
  [6442] = {.count = 1, .reusable = false}, SHIFT(2773),
  [6444] = {.count = 1, .reusable = true}, SHIFT(2773),
  [6446] = {.count = 1, .reusable = true}, SHIFT(2774),
  [6448] = {.count = 1, .reusable = true}, SHIFT(2775),
  [6450] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2675),
  [6453] = {.count = 1, .reusable = true}, SHIFT(2776),
  [6455] = {.count = 1, .reusable = false}, SHIFT(2777),
  [6457] = {.count = 1, .reusable = true}, SHIFT(2778),
  [6459] = {.count = 1, .reusable = true}, SHIFT(2780),
  [6461] = {.count = 1, .reusable = true}, SHIFT(2781),
  [6463] = {.count = 1, .reusable = true}, SHIFT(2782),
  [6465] = {.count = 1, .reusable = true}, SHIFT(2783),
  [6467] = {.count = 1, .reusable = false}, SHIFT(2785),
  [6469] = {.count = 1, .reusable = true}, SHIFT(2785),
  [6471] = {.count = 1, .reusable = true}, SHIFT(2784),
  [6473] = {.count = 1, .reusable = true}, SHIFT(2786),
  [6475] = {.count = 1, .reusable = false}, SHIFT(2788),
  [6477] = {.count = 1, .reusable = true}, SHIFT(2788),
  [6479] = {.count = 1, .reusable = true}, SHIFT(2787),
  [6481] = {.count = 1, .reusable = false}, SHIFT(2790),
  [6483] = {.count = 1, .reusable = true}, SHIFT(2790),
  [6485] = {.count = 1, .reusable = true}, SHIFT(2789),
  [6487] = {.count = 1, .reusable = true}, SHIFT(2791),
  [6489] = {.count = 1, .reusable = true}, SHIFT(2792),
  [6491] = {.count = 1, .reusable = true}, SHIFT(2793),
  [6493] = {.count = 1, .reusable = true}, SHIFT(2794),
  [6495] = {.count = 1, .reusable = true}, SHIFT(2795),
  [6497] = {.count = 1, .reusable = true}, SHIFT(2796),
  [6499] = {.count = 1, .reusable = true}, SHIFT(2797),
  [6501] = {.count = 1, .reusable = true}, SHIFT(2798),
  [6503] = {.count = 1, .reusable = true}, SHIFT(2799),
  [6505] = {.count = 1, .reusable = true}, SHIFT(2800),
  [6507] = {.count = 1, .reusable = true}, SHIFT(2801),
  [6509] = {.count = 1, .reusable = true}, SHIFT(2802),
  [6511] = {.count = 1, .reusable = false}, SHIFT(2803),
  [6513] = {.count = 1, .reusable = true}, SHIFT(2803),
  [6515] = {.count = 1, .reusable = false}, SHIFT(2804),
  [6517] = {.count = 1, .reusable = true}, SHIFT(2805),
  [6519] = {.count = 1, .reusable = true}, SHIFT(2807),
  [6521] = {.count = 1, .reusable = true}, SHIFT(2808),
  [6523] = {.count = 1, .reusable = true}, SHIFT(2809),
  [6525] = {.count = 1, .reusable = true}, SHIFT(2810),
  [6527] = {.count = 1, .reusable = true}, SHIFT(2811),
  [6529] = {.count = 1, .reusable = true}, SHIFT(2812),
  [6531] = {.count = 1, .reusable = false}, SHIFT(2813),
  [6533] = {.count = 1, .reusable = true}, SHIFT(2813),
  [6535] = {.count = 1, .reusable = true}, SHIFT(2814),
  [6537] = {.count = 1, .reusable = false}, SHIFT(2815),
  [6539] = {.count = 1, .reusable = true}, SHIFT(2815),
  [6541] = {.count = 1, .reusable = true}, SHIFT(2816),
  [6543] = {.count = 1, .reusable = true}, SHIFT(2817),
  [6545] = {.count = 1, .reusable = true}, SHIFT(2818),
  [6547] = {.count = 1, .reusable = true}, SHIFT(2819),
  [6549] = {.count = 1, .reusable = false}, SHIFT(2820),
  [6551] = {.count = 1, .reusable = true}, SHIFT(2820),
  [6553] = {.count = 1, .reusable = true}, SHIFT(2821),
  [6555] = {.count = 1, .reusable = false}, SHIFT(2822),
  [6557] = {.count = 1, .reusable = true}, SHIFT(2822),
  [6559] = {.count = 1, .reusable = true}, SHIFT(2823),
  [6561] = {.count = 1, .reusable = false}, SHIFT(2824),
  [6563] = {.count = 1, .reusable = true}, SHIFT(2824),
  [6565] = {.count = 1, .reusable = true}, SHIFT(2825),
  [6567] = {.count = 1, .reusable = true}, SHIFT(2826),
  [6569] = {.count = 1, .reusable = true}, SHIFT(2827),
  [6571] = {.count = 1, .reusable = true}, SHIFT(2828),
  [6573] = {.count = 1, .reusable = true}, SHIFT(2829),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_word,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
